/*
 Navicat Premium Data Transfer

 Source Server         : local
 Source Server Type    : MySQL
 Source Server Version : 80027
 Source Host           : localhost:3306
 Source Schema         : drug_0

 Target Server Type    : MySQL
 Target Server Version : 80027
 File Encoding         : 65001

 Date: 07/05/2022 23:50:25
*/


DROP DATABASE IF EXISTS drug;
CREATE DATABASE IF NOT EXISTS drug;
USE drug;

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for drug_resource_0
-- ----------------------------
DROP TABLE IF EXISTS `drug_resource_0`;
CREATE TABLE `drug_resource_0` (
  `id` bigint unsigned NOT NULL DEFAULT '0' COMMENT '主键',
  `drug_res_type_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT ' 药品和物资类型ID(dw_drug_res_type.id)',
  `base_type` tinyint NOT NULL DEFAULT '0' COMMENT '物品类型：1-药品, 2-耗材, 3-办公用品',
  `status` int DEFAULT '1' COMMENT '药品状态: 0 - 停用, 1 - 使用',
  `type_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药品或者耗材类别的字典ID(dw_dictionary.id AND dw_dictionary.type_id=[yplb OR hclb])',
  `dict_dosage_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药品剂型的字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypjx)',
  `code` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '集团编码',
  `pym` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '拼音简码',
  `name` varchar(64) CHARACTER SET utf8 DEFAULT '' COMMENT '药品或者耗材的名称',
  `manufacturer_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '生产厂家的字典ID(dw_dictionary.id AND dw_dictionary.type_id=sccj)',
  `approval_no` varchar(100) CHARACTER SET utf8 DEFAULT NULL COMMENT '批准文号',
  `med_type` int DEFAULT '3' COMMENT '医保分类： 1 - 无自付, 2 - 部分自付, 3 - 全自付',
  `admin_code` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药监编码',
  `pack_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '包装单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypdw)',
  `min_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '最小单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypdw)',
  `pack_quantity` int DEFAULT '1' COMMENT '包装含量',
  `dosage_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '剂量单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=jldw)',
  `dosage_quantity` decimal(10,2) DEFAULT '0.00' COMMENT '剂量含量',
  `pack_spec` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '包装规格，生成规则：[剂量含量] [剂量单位] * [包装含量] [最小单位] / [包装单位]',
  `take_method_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '用法(默认用法)(dw_dictionary.id AND dw_dictionary.type_id=ypyf)',
  `take_quantity` decimal(36,4) DEFAULT '0.0000' COMMENT '用量(默认用量)',
  `take_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '用量单位字典ID - 暂留字典',
  `take_unit_name` varchar(36) CHARACTER SET utf8 DEFAULT 'ml' COMMENT '用量单位名称，默认ml',
  `take_frequency` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '频率(默认频率)(dw_dictionary.id AND dw_dictionary.type_id=yppl)',
  `common_unit_type` int DEFAULT '1' COMMENT '常规单位类型: 1 - 包装单位(packUnit), 2 - 最小单位(minUnit)',
  `purchase_price` decimal(8,4) DEFAULT '0.0000' COMMENT '进货价: 单位 元',
  `sale_price` decimal(8,4) DEFAULT '0.0000' COMMENT '基准价: 单位 元',
  `cost_category_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '费用类别字典ID(dw_dictionary.id AND dw_dicitionary.type_id=fylb)',
  `invoice_item_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '发票项目字典ID - 暂留',
  `expensive_flag` int DEFAULT '1' COMMENT '贵重物品标识： 0 - 非贵重物品， 1 - 贵重物品',
  `psy_flag_i` int DEFAULT '0' COMMENT ' 精神I类药品标识：0 - 非选中， 1 - 选中',
  `psy_flag_ii` int DEFAULT '0' COMMENT '精神II类药品标识：0 - 非选中，1 - 选中',
  `otc_flag` int DEFAULT '0' COMMENT 'OTC标识：0 - 非选中， 1 - 选中',
  `nar_flag` int DEFAULT '0' COMMENT '麻醉药品标识：0 - 非选中， 1 - 选中',
  `inventory_upper` int DEFAULT '0' COMMENT '库存上限',
  `inventory_lower` int DEFAULT '0' COMMENT '库存下限',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  `modify_time` datetime DEFAULT NULL COMMENT '修改时间',
  `del_flag` int DEFAULT '0' COMMENT '删除标志:  0 - 未删除, 1 - 已删除',
  `consumable_type` int NOT NULL DEFAULT '0' COMMENT '耗材类型:1-国产,2-进口',
  `tips` varchar(1024) CHARACTER SET utf8 DEFAULT NULL COMMENT '药品使用注意事项',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

-- ----------------------------
-- Records of drug_resource_0
-- ----------------------------
BEGIN;
INSERT INTO `drug_resource_0` VALUES (10, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001167', 'qxy', '清洗液', 'sccj_glyltyldzyxgs', '桂桂械备20140004号', 3, '', 'jjdw_h', '', 1, '', 0.00, '500mlURIT-DC1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (20, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000898', 'xczj', '吸潮纸尖', 'sccj_tjjfylqxyxgs', '天津械备20160055号', 3, '', 'jjdw_h', '', 1, '', 0.00, '15#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 09:53:10', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (30, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001057', '60yzlcA4', '60页资料册A4', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 12.0000, 12.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (40, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001064', 'fbhj', '氟保护剂', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '0.5ml/袋', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (50, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000589', 'Kc', 'K锉', 'sccj_xnddsb', '国械备20170214号', 3, '', 'jjdw_t', '', 1, '', 0.00, '21mm-30', '', 0.0000, '', 'ml', '', 1, 0.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (60, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dyj', 'ZKM00000117', 'lmsdyy', '氯霉素滴眼液', 'sccj_sdbslfrdzyyxgs', '国药准字', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 5.00, '5.00ml*1支/支', '', 0.0000, '', '', '', 1, 7.9000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 13:28:22', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (70, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000940', 'mkdh', '蜜款冬花', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.7840, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (80, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_cj', 'ZKM00000087', 'hgp（bmy）', '护肝片（薄膜衣）', 'sccj_adyy(bj)yxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 12, 'jldw_g', 4.00, '4.00g*12袋/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (90, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rgj', 'ZKM00001796', 'pxlwrg（ky）', '喷昔洛韦乳膏（可由）', 'sccj_shchyyyxgs', 'H20000168', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 10.00, '10.00g*1支/支', '', 0.0000, '', '', '', 1, 0.0000, 7.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-06-08 14:32:54', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (100, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000051', 'ncgsz', '尿常规试纸', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (110, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000196', '3Mqngxdmqxy', '3M全能高效多酶清洗液', 'sccj_mnsdkyzz（sh）gjmyyxgs', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '瓶', '', 0.0000, '', 'ml', '', 1, 119.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-08-08 18:15:20', 0, 1, NULL);
INSERT INTO `drug_resource_0` VALUES (120, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000561', 'edfgj', '额戴反光镜', 'sccj_yy_11134', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '1只装', '', 0.0000, '', 'ml', '', 1, 59.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-03-13 16:50:14', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (130, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000981', 'jwss', '酒乌梢蛇', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/支', '', 10.0000, '', '', '', 1, 2.5200, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (140, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001348', 'pjq', '帕巾钳', 'sccj_shjz', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '14cm尖头无镀层', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (150, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001026', 'yyflq', '牙用分离器', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '杆类型式E6', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (160, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pbj', 'ZKM00000420', 'bdndpbj', '布地奈德喷鼻剂', 'sccj_aslkzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_q', 64, 'jldw_ug', 1.00, '1.00ug*64揿/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 1, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (170, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000734', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'TR-SS21(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (180, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000835', 'ysb（TX）', '压舌板（TX）', 'sccj_w', '无', 3, '', 'jjdw_ge', '', 1, '', 0.00, '200片/包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (190, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001134', 'ccez', '炒苍耳子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0390, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (200, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001268', 'cpt', '椿皮炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0450, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (210, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000402', 'hlcz', '华林床罩', 'sccj_xxshlylqxyxgs', '', 3, '', 'jjdw_t_7475', '', 1, '', 0.00, '120*230', '', 0.0000, '', 'ml', '', 1, 3.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (220, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000302', 'ycxzsqdz', '一次性注射器带针', 'sccj_shkdlqyfzjtgfyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '10ml', '', 0.0000, '', 'ml', '', 1, 0.4000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (230, 'bgyplb_ycxcl', 3, 1, 'bgyplb_ycxcl', '', 'ZKM00001843', 'hccb2g', '红茶茶包2g', 'sccj_amzyc', NULL, 3, '', 'bzdw_b', 'zxdw_b', 1, '', 0.00, '1包/包', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (240, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001333', 'ddxyq', '电动吸引器', 'sccj_shxyqc', '-', 3, '', 'jjdw_t_148', '', 1, '', 0.00, '上海吸引器厂YX-932D', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (250, 'hclb_ryplcl', 2, 1, 'hclb_ryplcl', '', 'ZKW00000014', 'snx', '收纳箱', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (260, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rg', 'ZKM00000298', 'dsqhkdsrg', '丁酸氢化可的松乳膏', 'sccj_hbhaflyygfyxgs(yhbhayyyxgs)', '国药准字H20083906', 3, '', 'bzdw_h', 'zxdw_h', 1, 'jldw_g', 20.00, '20.00g*1盒/盒', '', 0.0000, '', '', '', 1, 13.4000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 13:50:28', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (270, 'bgyplb_yyzflcl', 3, 1, 'bgyplb_yyzflcl', '', 'ZKM00001505', 'nysbdy（Sm）', '女医生白大衣（S码）', 'sccj_amzyc', NULL, 3, '', 'bzdw_j_4203', 'zxdw_j_2903', 1, '', 0.00, '1件/件', '', 0.0000, '', 'ml', '', 2, 130.0000, 130.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (280, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000587', 'hz', '红枣', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0670, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:34:19', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (290, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_jnj', 'ZKM00000072', 'gmljn', '感冒灵胶囊', 'sccj_gxcztzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_l', 12, 'jldw_g', 0.50, '0.5g*12粒/盒', '', 0.0000, '', '', '', 1, 3.1000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 11:50:54', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (300, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001336', 'yqd', '氧气袋', 'sccj_jnyq', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '42L/个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (310, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001306', 'lxg', '离心管', 'sccj_jskjylqxyxgs		', '-', 3, '', 'jjdw_b', '', 1, '', 0.00, '1.5ml无抗凝，500支/包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (320, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000218', 'tbkljn（xkl）', '头孢克洛胶囊（希刻劳）', 'sccj_llszzyyxgs', 'H10983030', 3, '', 'bzdw_h', 'zxdw_l', 6, 'jldw_g', 0.25, '0.25g*6粒/盒', 'PO', 0.2500, '', '', 'TID', 1, 27.6700, 38.7400, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 2, NULL, '2018-04-03 17:13:20', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (330, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001106', 'czq', '持针钳', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '粗针直型140mm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (340, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000444', 'ycxsywjzjz', '一次性使用无菌针灸针', 'sccj_bjkydylypc', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '0.25*40单支', '', 0.0000, '', 'ml', '', 1, 0.1000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-10 21:52:37', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (350, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001512', 'mfdg', '妙芙蛋糕', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 2.1740, 2.1740, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (360, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000099', 'wssErjn', '维生素E软胶囊', 'sccj_hnhstzzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_l', 60, 'jldw_mg', 100.00, '100mg*60粒/盒', '', 0.0000, '', '', '', 1, 5.5500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 11:32:02', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (370, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000169', 'yspnlep', '盐酸普萘洛尔片', 'sccj_jsybapsyyyxgs', '国药准字h32020133', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 10.00, '10.00mg*100片/瓶', '', 0.0000, '', '', '', 1, 28.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 13:56:42', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (380, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001112', 'mzw', '蜜紫菀', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.1680, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (390, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000229', 'yywjycxmq', '医用无菌一次性棉球', 'sccj_bjzbbjkmyxgs', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '0.2g*10个/包', '', 0.0000, '', 'ml', '', 1, 55.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (400, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_fzj', 'ZKM00000242', 'zsyqhkdshpsn', '注射用氢化可的松琥珀酸钠', 'sccj_tjswhxzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 5, 'jldw_mg', 50.00, '50.00mg*5支/盒', '', 0.0000, '', '', '', 1, 18.3500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-18 16:06:38', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (410, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000204', '3Mznbd', '3M自粘绷带', 'sccj_3Mzg', '', 3, '', 'jjdw_j', '', 1, '', 0.00, '50mm*4.5m', '', 0.0000, '', 'ml', '', 1, 17.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-12 13:47:09', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (420, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_klj', 'ZKM00000216', 'xxkdqkl', '消旋卡多曲颗粒', 'sccj_scblyyyxzrgs', '国药准字h20050411', 3, '', 'bzdw_h', 'zxdw_d', 8, 'jldw_mg', 10.00, '10.00mg*8袋/盒', '', 0.0000, '', '', '', 1, 17.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 13:57:09', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (430, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001369', 'dbb', '大便杯', 'sccj_hmynt', '-', 3, '', 'jjdw_x', '', 1, '', 0.00, '60ml，带小勺，PP，420支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (440, 'yplb_xy', 1, 1, 'yplb_zcy', 'ypjx_wj', 'ZKM00000076', 'mrrcw', '麻仁润肠丸', 'sccj_adyy(bj)yxgs', '国药准字z14020117', 3, '', 'bzdw_h', 'zxdw_w', 10, 'jldw_g', 6.00, '6.00g*10丸/盒', '', 0.0000, '', '', '', 1, 4.7500, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:00:44', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (450, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rgj', 'ZKM00001814', 'wAsrg（0.1%）', '维A酸乳膏（0.1%）', 'sccj_cqbhzyyxgs', 'H50021816', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 15.00, '15.00g*1支/支', '', 0.0000, '', '', '', 1, 0.0000, 13.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (460, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000465', 'wssCzsy', '维生素C注射液', 'sccj_rs', 'H410023393', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 2.00, '2.00ml*1支/支', '', 0.0000, '', '', '', 2, 0.4770, 2.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 3, NULL, '2018-05-11 16:05:13', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (470, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001289', 'ssjm', '生石决明', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0580, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (480, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000349', '0.9%lhnzsy', '0.9%氯化钠注射液', 'sccj_scklyygfyxgs', '国药准字h51021157', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 250.00, '250.00ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 1.0800, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:01:34', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (490, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000233', 'ysssxszsy(xnyy)', '盐酸肾上腺素注射液(西南药业)', 'sccj_xnyygfyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_ml', 1.00, '1ml*10支/盒', '', 0.0000, '', '', '', 1, 25.5000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 14:53:49', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (500, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001109', 'kb', '昆布', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0840, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (510, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001028', 'ygc', '牙刮匙', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '普通型E2', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (520, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001281', 'jb', '卷柏', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0410, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (530, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001362', 'yklsjh', '亚克力手机盒', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 35.0000, 35.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (540, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00001404', 'B3', 'B3', 'sccj_shxyswyyyxzrgs', 'WSS001', 3, '', 'bzdw_x', 'zxdw_h', 5, 'jldw_p', 3.00, '3.00片*5盒/箱', 'ad us.int', 3.0000, '', '', 'bid', 1, 0.0000, 50.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (550, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000881', 'yyc（C+c）', '牙用锉（C+锉）', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm10##6*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (560, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000062', 'pgb', '抛光杯', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (570, 'yplb_zcy', 1, 0, 'yplb_zcy', 'ypjx_cj', 'ZKM00000040', '1', '1', 'sccj_adyy(bj)yxgs', '1', 3, '1', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 50.00, '50.00ml*1瓶/瓶', 'ad us.int', 5.0000, '', '', 'bid', 1, 10.0000, 20.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 1, 0, 111, 11, NULL, '2017-12-28 23:14:21', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (580, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001358', 'sddtdktwlyyq', '手动单通道可调微量移液器', 'sccj_dlxcsyyq（bj）yxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '200-1000μl', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (590, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001191', 'qyhj', '氢氧化钾', 'sccj_w', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, 'KOH500g', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (600, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001850', 'wjbhdA4', '文件保护袋A4', 'sccj_amzyc', NULL, 3, '', 'bzdw_b', 'zxdw_b', 1, '', 0.00, '1包/包', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (610, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000040', 'fskwxhjkyq', '放射科无线呼叫扩音器', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (620, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001315', 'wcnz', '无齿镊子', 'sccj_shjz', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '无钩,总长16cm,不锈钢', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (630, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000551', 'sbs', '生白术', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.2240, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:30:20', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (640, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000182', 'kytqd', '口咽通气道', 'sccj_kdyckjyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '90mm黄色', '', 0.0000, '', 'ml', '', 1, 4.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (650, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00001357', 'amxljn（amx）', '阿莫西林胶囊（阿莫仙）', 'sccj_zhlbzygfyxgszsfgs', 'H20003263', 3, '', 'bzdw_h', 'zxdw_l', 24, 'jldw_g', 0.50, '0.50g*24粒/盒', 'ad us.int', 0.5000, '', '', 'TID', 1, 18.1400, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 3, NULL, '2018-04-02 10:43:21', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (660, 'hclb_ptcl', 2, 0, 'hclb_ptcl', '', 'ZKW00000002', 'sb', '纱布', 'sccj_bjbkjjykjyxgs', '12', 3, '123', 'jjdw_d', '', 1, '', 0.00, '1包/袋', '', 0.0000, '', 'ml', '', 1, 20.0000, 40.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 1, 0, 0, 0, NULL, '2017-08-25 09:21:52', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (670, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_klj', 'ZKM00000500', 'cszcykl', '测试中成药颗粒', 'sccj_gdyhylqxcyxgs', '123', 3, '321', 'bzdw_h', 'zxdw_b', 15, 'jldw_mg', 10.00, '10.00mg*15包/盒', 'ad us.ext', 10.0000, '', '', 'bid', 1, 20.0000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (680, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001528', 'xtsz', '血糖试纸', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (690, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000322', 'xpczq', '镶片持针钳', 'sccj_shylqx（jt）yxgsssqxc', '', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'JCA46016CM直细针0.3', '', 0.0000, '', 'ml', '', 1, 456.2400, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (700, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001286', 'sz', '桑枝', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0290, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (710, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001451', 'zbp（msb）	', '载玻片（磨砂边）	', 'sccj_ycsjhybypc		', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (720, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000515', 'sgltp（alz）', '沙格列汀片（安立泽）', 'sccj_aslkzyyxgs', 'J20160069', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_mg', 5.00, '5.00mg*7片/盒', '', 0.0000, '', '', '', 1, 59.3600, 83.1000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 4, 1, NULL, '2018-04-09 10:27:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (730, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001039', 'crbyq', '成人拔牙钳', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '48#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (740, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000482', 'jpajh', '极品艾灸盒', 'sccj_bjkydylypc', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '单孔', '', 0.0000, '', 'ml', '', 1, 24.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (750, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rg', 'ZKM00001619', 'jwhrg', '京万红软膏', 'sccj_tjlszyyxgs', '215014', 3, '', 'bzdw_z', 'zxdw_kg_g', 30, 'jldw_dw', 1.00, '1.00单位*30g/支', '', 0.0000, '', '', '', 1, 0.0000, 29.8000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (760, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000805', 'bw', '白薇', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.2910, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (770, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000053', 'gcseacrjn', '甘草酸二铵肠溶胶囊', 'sccj_zdtqyyjtgfyxgs', '国药准字H20040628', 3, '', 'bzdw_h', 'zxdw_l', 63, 'jldw_mg', 50.00, '50.00mg*63粒/盒', '', 0.0000, '', '', '', 1, 60.8200, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:24:59', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (780, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000843', 'xjp', '香加皮', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0650, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (790, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001398', 'fkwjdmq', '妇科无菌大棉签', 'sccj_jxym		', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '20cm20支\\包20包/中包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (800, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000126', 'yhz', '咬合纸', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (810, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001570', 'mscxg', '末梢采血管', 'sccj_w', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (820, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_wj', 'ZKM00000052', 'lbszdw', '联苯双酯滴丸', 'sccj_wbdzyjtgfyxgs', '国药准字h33021305', 3, '', 'bzdw_p', 'zxdw_p', 250, 'jldw_mg', 1.50, '1.50mg*250片/瓶', '', 0.0000, '', '', '', 1, 22.5000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:26:59', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (830, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000226', 'lzz', '留置针', 'sccj_szxdylqxyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '18G', '', 0.0000, '', 'ml', '', 1, 11.3600, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 17:12:02', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (840, 'bgyplb_yyzflcl', 3, 1, 'bgyplb_yyzflcl', '', 'ZKM00001507', 'nysbdy（Mm）', '男医生白大衣（M码）', 'sccj_amzyc', NULL, 3, '', 'bzdw_j_4203', 'zxdw_j_2903', 1, '', 0.00, '1件/件', '', 0.0000, '', 'ml', '', 2, 130.0000, 130.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (850, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_fzj', 'ZKM00000254', 'zsyamlzn', '注射用奥美拉唑钠', 'sccj_cdttszyyxgs', '', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_mg', 40.00, '40mg*1瓶/瓶', '', 0.0000, '', '', '', 1, 1.2000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 15:01:04', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (860, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000671', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'TC-21(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (870, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_njj', 'ZKM00000036', 'zmdy', '中模单一', 'sccj_hrsj', '131242154', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', '', '', 1, 0.0000, 10.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (880, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tj', 'ZKM00001616', 'ssztg', '伤湿止痛膏', 'sccj_hnsabwcyxgs', '170714', 3, '', 'bzdw_h', 'zxdw_t', 10, 'jldw_cm', 10.00, '10.00cm*10贴/盒', '', 0.0000, '', '', '', 1, 0.0000, 28.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (890, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001586', 'jsq', '计时器', 'sccj_bx', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (900, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001285', 'ydz', '鸦胆子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1700, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (910, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000712', 'lzh', '荔枝核', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0390, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (920, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000946', 'nh', '牛黄', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 46.0000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (930, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsp', 'ZKM00000046', 'wssCzsy', '维生素C注射液', 'sccj_bjsykyy', '', 3, '', 'bzdw_g_cldw', 'zxdw_wu_cldw', 1, 'jldw_g', 1.00, '1.00g/g', '', 0.0000, '', '', '', 1, 0.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (940, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00001326', 'nfsxjn', '诺氟沙星胶囊', 'sccj_schys', 'H51023512', 3, '', 'bzdw_h', 'zxdw_l', 24, 'jldw_g', 0.10, '0.10g*24粒/盒', '', 0.0000, '', '', '', 1, 4.5000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:42:04', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (950, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000298', 'ycxzsqdz', '一次性注射器带针', 'sccj_shkdlqyfzjtgfyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '1ml', '', 0.0000, '', 'ml', '', 1, 0.3000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (960, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rj', 'ZKM00001854', 'lhjp', '氯化钾片', 'sccj_tjlszyyxgs', 'H2020167', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_g', 0.25, '0.25g*100片/瓶', '', 0.0000, '', '', '', 1, 0.0000, 3.3000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (970, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000278', 'lgxwwhjp', '冷光纤维弯喉镜片', 'sccj_TruphatekInternationalLtd', '', 3, '', 'jjdw_z', '', 1, '', 0.00, 'shucman2系列52444号弯片', '', 0.0000, '', 'ml', '', 1, 900.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (980, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000553', 'xeq', '吸耳球', 'sccj_dd', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '60ml', '', 0.0000, '', 'ml', '', 1, 5.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (990, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001116', 'zl', '猪苓', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 1.9040, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1000, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000168', 'gxjmt', '硅橡胶磨头', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1010, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000309', 'mlslbnmp', '马来酸氯苯那敏片', 'sccj_sxypzyyxgs', 'h34022323', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 4.00, '4.00mg*100片/瓶', '', 0.0000, '', '', '', 1, 1.0500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:46:17', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1020, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00001407', 'dyybgjhjjn（zcs）', '地衣芽孢杆菌活菌胶囊（整肠生）', 'sccj_dbzyjtsydyzyyxgs', 'S10950019', 3, '', 'bzdw_h', 'zxdw_l', 36, 'jldw_g', 0.25, '0.25g*36粒/盒', 'ad us.int', 0.5000, '', '', 'TID', 1, 43.9000, 52.6800, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-04-03 10:36:48', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1030, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000374', 'txzp', '替硝唑片', 'sccj_sdfmyyjtgfyxgs', 'H20033666', 3, '', 'bzdw_h', 'zxdw_p', 8, 'jldw_g', 0.50, '0.50g*8片/盒', 'ad us.int', 0.5000, '', '', 'bid', 1, 0.0000, 7.1400, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 20, 5, NULL, '2018-05-16 14:57:46', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1040, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000831', 'jjs', '荆芥穗', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1120, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1050, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000325', 'lhjcsdj', '铝合金铲式担架', 'sccj_dd', '', 3, '', 'jjdw_t_148', '', 1, '', 0.00, 'YHX-4A铲式担架', '', 0.0000, '', 'ml', '', 1, 1100.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1060, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000870', 'bsz', '拔髓针', 'sccj_mnzshs', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, '000#12*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 12:44:43', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1070, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001395', 'bxgwp', '不锈钢弯盘', 'sccj_gdscaxczysylqxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '大号', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1080, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_pj', 'ZKM00001783', 'jfzp（hjq-G）', '吉法酯片（惠加强-G）', 'sccj_shryypzshs', 'H20160240', 3, '', 'bzdw_h', 'zxdw_p', 40, 'jldw_mg', 50.00, '50.00mg*40片/盒', '', 0.0000, '', '', '', 1, 0.0000, 36.8000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-07-05 09:56:11', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1090, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000232', 'yslblzsy', '盐酸洛贝林注射液', 'sccj_shhfzyyxgs', '国药准字H3102134', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 1.00, '1.00ml*1支/支', '', 0.0000, '', '', '', 1, 9.2200, 12.9000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 3, NULL, '2018-04-08 16:10:06', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1100, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_hsp', 'ZKM00000025', 'ze1', '周二1', 'sccj_hrsj', '12', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', '', '', 1, 0.0000, 10.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-07-31 13:55:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1110, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000661', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'TF-14(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-04-08 10:43:55', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1120, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001794', 'tsqnp', '碳酸氢钠片', 'sccj_tjlszyyxgs', 'H12020220', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_g', 0.50, '0.50g*100片/瓶', '', 0.0000, '', '', '', 1, 0.0000, 10.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1130, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001293', 'zsy', '紫苏叶', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0670, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1140, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001282', 'kkq', '开口器', 'sccj_zjgsy		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '丁字,130MM', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1150, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000613', 'swblx', '生王不留行', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0300, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1160, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001831', 'hpxg', '惠普硒鼓', 'sccj_amzyc', NULL, 3, '', 'bzdw_h', 'zxdw_g', 1, '', 0.00, '1个/盒', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1170, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000817', 'jy', '橘叶', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0500, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1180, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001872', 'wssB2p', '维生素B2片', 'sccj_bjzxyyyxgs', 'H13020593', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 5.00, '5mg*100片/瓶', '', 0.0000, '', '', '', 1, 0.0000, 2.9000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1190, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hjp', 'ZKM00001779', 'tkmsrg（ptb）0.03%', '他克莫司软膏（普特彼）0.03%', 'sccj_asktlzyyxgs', 'J20140147', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 10.00, '10.00g*1支/支', '', 0.0000, '', '', '', 1, 0.0000, 119.1000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1200, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001135', 'dymydgwdzsjmgA', '第一磨牙单管网底直丝颊面管A', 'sccj_hzxyckclyxgs', '浙食药监械（准）字2014第2630177号', 3, '', 'jjdw_d', '', 1, '', 0.00, '62BK-20J-16(20*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-04 16:52:23', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1210, 'bgyplb_ycxcl', 3, 1, 'bgyplb_ycxcl', '', 'ZKM00001732', 'apsmh', '爱普生墨盒', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1220, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000605', 'qg', '青果', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0930, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1230, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000248', 'ycxsywjdnb（bzx）', '一次性使用无菌导尿包（标准型）', 'sccj_zjssdsyyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '16Fr', '', 0.0000, '', 'ml', '', 1, 22.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1240, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_hsp', 'ZKM00000033', 'ceshi123', 'ceshi123', 'sccj_bjsykyy', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', '', '', 1, 0.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1250, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001367', 'fhz', '缝合针', 'sccj_hzhw		', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '角头带针不可吸收缝合针4.040包/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1260, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_kfy', 'ZKM00001593', 'kbdkfy', '抗病毒口服液', 'sccj_gzdzzyyxgs', '201708012', 3, '', 'bzdw_h', 'zxdw_z', 18, 'jldw_ml', 10.00, '10.00ml*18支/盒', 'kf', 10.0000, '', '', 'mr3c', 2, 35.0000, 1.7000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-05-24 10:13:23', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1270, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000253', 'yywhq(mzs）', '医用雾化器(面罩式）', 'sccj_hzjlylqxyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, 'YZ.W02', '', 0.0000, '', 'ml', '', 1, 14.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-24 09:17:37', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1280, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001534', 'mgd', '美工刀', 'sccj_amzyc', NULL, 3, '', 'bzdw_b_9933', 'zxdw_b_1129', 1, '', 0.00, '1把/把', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1290, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000677', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'BR-S41(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1300, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000274', 'ycxyyxjjcst（wf）', '一次性医用橡胶检查手套（无粉）', 'sccj_dd', '', 3, '', 'jjdw_h', '', 1, '', 0.00, 'TLFCMD44100无粉中号（6,.0）乳白色100只/盒10盒/箱', '', 0.0000, '', 'ml', '', 1, 36.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 15:38:30', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1310, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001143', 'dymywdzsgtcA', '第一磨牙网底直丝弓托槽A', 'sccj_hzxyckclyxgs', '浙械注准20172631235', 3, '', 'jjdw_d', '', 1, '', 0.00, '8253-20B-16(20*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-04 17:04:14', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1320, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000393', 'bxghyw', '不锈钢换药碗', 'sccj_czscaqctxxqylqxc', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '14CM', '', 0.0000, '', 'ml', '', 1, 6.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1330, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000964', 'aedpfxdy', '安尔碘皮肤消毒液', 'sccj_shlkxdgkjyxgs', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '60ml', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-28 09:32:48', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1340, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001535', 'yy', '印油', 'sccj_amzyc', NULL, 3, '', 'bzdw_p', 'zxdw_p_1', 1, '', 0.00, '1瓶/瓶', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-07 10:00:32', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1350, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000780', 'ptyykz', '普通医用口罩', 'sccj_mdkylypmy（sh）yxgs', '沪食药监械（准）字2013第2640789', 3, '', 'jjdw_h', '', 1, '', 0.00, '粉色50*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1360, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001648', 'axlwrg（TX）', '阿昔洛韦乳膏（TX）', 'sccj_fjtpyzyyxgs', '170801', 3, '', 'bzdw_z', 'zxdw_kg_g', 10, 'jldw_％', 3.00, '3.00％*10g/支', '', 0.0000, '', '', '', 1, 0.0000, 2.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1370, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_jnj', 'ZKM00001585', 'gzfljn', '桂枝茯苓胶囊', 'sccj_jskyyygfyxgs', '国药准字Z10950005', 3, '', 'bzdw_h', 'zxdw_l', 100, 'jldw_g', 0.31, '0.31g*100粒/盒', '', 0.0000, '', '', '', 1, 51.8000, 51.8000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1380, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00001163', 'omldzxyj', '欧姆龙电子血压计', 'sccj_oml', '-', 3, '', 'jjdw_t_148', '', 1, '', 0.00, 'HEM-7206上臂式', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1390, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000862', 'gzjyggqx（jyGz-32h）', '钢质机用根管器械（机用G钻-32混）', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '32mm1-6#6*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:29:05', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1400, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000838', 'ggtcq(cyz-S21h)', '根管填充器(侧压针-S21混)', 'sccj_mnzshs', 'R18A232800', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm15-40#6*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 35.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1410, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_klj', 'ZKM00001627', 'ymckl（TX）', '益母草颗粒（TX）', 'sccj_zzqjyygfyxgs', '20171106', 3, '', 'bzdw_h', 'zxdw_d', 10, 'jldw_g', 14.00, '14.00g*10袋/盒', '', 0.0000, '', '', '', 1, 0.0000, 29.8000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1420, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001021', 'M277DWdyjmh', 'M277DW打印机墨盒', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 559.0000, 559.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1430, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000984', 'zwzy', '制吴茱萸', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 1.3440, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1440, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001181', 'bhn', '薄荷脑', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.5250, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1450, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000544', 'dmdzdbdgccdsjh（zjf-bmhxjqcf）', '低密度脂蛋白胆固醇测定试剂盒（直接法-表面活性剂清除法）', 'sccj_glyltyldzyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '45ml*3；15ml*3；校准品1ml', '', 0.0000, '', 'ml', '', 1, 1708.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1460, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000724', 'kdd', '苦地丁', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0560, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1470, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001126', 'ghx', '广藿香', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1120, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1480, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_cj', 'ZKM00000046', '6', '6', 'sccj_adyy(bj)yxgs', '123', 3, '123', 'bzdw_b', 'zxdw_b', 1, 'jldw_l', 25.00, '25.00粒*1包/包', 'ad us.ext', 5.0000, '', '', 'Am', 1, 10.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1490, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001645', 'fhwssBp（TX）', '复合维生素B片（TX）', 'sccj_fzhwfyzyyxgs', '1709200', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_p', 1.00, '1.00片*100片/瓶', '', 0.0000, '', '', '', 1, 0.0000, 5.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 5, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1500, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000604', 'Hc', 'H锉', 'sccj_xnddsb', '国械备20170214号', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm-30（蓝）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1510, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_hsp', 'ZKM00000024', '1', '1', 'sccj_hrsj', '1', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', '', '', 1, 0.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1520, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_hsp', 'ZKM00000043', 'cs123', '测试123', 'sccj_bjsykyy', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', '', '', 1, 0.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1530, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000368', 'yycymz', '医用储氧面罩', 'sccj_bjsdeylqxzzyxzrgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '无', '', 0.0000, '', 'ml', '', 1, 11.2000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 15:58:08', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1540, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001698', '5％pttzsy', '5％葡萄糖注射液', 'sccj_sdqdyyyxgs', 'H37020773', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_ml', 250.00, '250.00ml*1袋/袋', 'jmdz', 0.0000, '', '', '', 1, 0.0000, 5.1000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 20, 5, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1550, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001098', 'cgj', '醋龟甲', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 1.2320, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1560, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001113', 'ycxsywjydkzq', '一次性使用无菌阴道扩张器', 'sccj_czxc', '苏械注准20163400540', 3, '', 'jjdw_z', '', 1, '', 0.00, '中号', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-30 14:48:33', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1570, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000940', 'yggsj（6%dzdyjj）', '牙根管塞尖（6%大锥度牙胶尖）', 'sccj_dsbyk（tj）yxgs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '06锥度20#黄120*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 16:22:51', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1580, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000887', 'qyhghj（qyhgggxdhj）', '氢氧化钙糊剂（氢氧化钙根管消毒糊剂）', 'sccj_w', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '#595915/598607,2.5g/支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 16:14:54', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1590, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000726', 'dkr', '豆蔻仁', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.3750, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1600, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000926', 'ggc（Hc-21h)', '根管锉（H锉-21混)', 'sccj_mnzshs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm15-40#6*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 17:40:28', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1610, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001444', 'UQnzky', 'UQ尿质控液', 'sccj_glyltyldzyxgs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1620, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qwj', 'ZKM00001426', 'smtltksfxrj（sld）', '沙美特罗替卡松粉吸入剂（舒利迭）', 'sccj_GlaxoWellcomeOperations', 'h20150324', 3, '', 'bzdw_h', 'zxdw_p_4005', 60, 'jldw_μg', 50.00, '50.00μg*60泡/盒', '', 0.0000, '', '', '', 1, 195.5700, 1.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-04 16:16:05', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1630, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000389', 'yzpklp', '右佐匹克隆片', 'sccj_jstsldyyy', 'H20090209', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_mg', 2.00, '2.00mg*20片/盒', 'ad us.int', 2.0000, '', '', 'qd', 1, 61.6400, 86.3000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 1, 0, 0, 5, 2, NULL, '2018-05-11 16:43:44', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1640, 'hclb_qxlcl', 2, 1, 'hclb_qxlcl', '', 'ZKW00000005', 'zjbcq', '正畸保持器', 'sccj_adyy(bj)yxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '1盒', '', 0.0000, '', 'ml', '', 1, 600.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2017-09-05 09:57:44', 1, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1650, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000590', 'Kc', 'K锉', 'sccj_xnddsb', '国械备20170214号', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm-40', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1660, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001255', 'dec', '地耳草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1200, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-03-07 14:00:27', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1670, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000357', 'axzp（kl）', '奥硝唑片（科伦）', 'sccj_scklyygfyxgs', '国药准字H20030148', 3, '', 'bzdw_h', 'zxdw_p', 12, 'jldw_g', 0.25, '0.25g*12片/盒', '', 0.0000, '', '', '', 1, 4.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 13:26:57', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1680, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000070', 'gscz', '高速车针', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1690, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000920', 'clz', '川楝子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0390, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1700, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000019', 'zgt', '紫管头', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_z', '', 1, '', 0.00, 'EDTA-K2', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1710, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dsy', 'ZKM00001696', '0.9lhnzsy', '0.9氯化钠注射液', 'sccj_zgdzzyyxgs', 'H20200024', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_ml', 100.00, '100.00ml*1袋/袋', 'jmdz', 0.0000, '', '', '', 1, 0.0000, 7.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 20, 5, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1720, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001152', 'ycxyyzd', '一次性医用中单', 'sccj_hnytylypyxgs', '豫械注准20152640571', 3, '', 'jjdw_zhang', '', 1, '', 0.00, '500mm*700mm（独立装）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1730, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000256', 'yqmz（ktd2stjg）', '氧气面罩（可调带2色调节管）', 'sccj_dd', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, 'HX.002', '', 0.0000, '', 'ml', '', 1, 10.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1740, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000947', 'snjs', '水牛角丝', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1700, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1750, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001511', 'tpsdbg', '太平梳打饼干', 'sccj_amzyc', NULL, 3, '', 'bzdw_b', 'zxdw_b', 1, '', 0.00, '1包/包', '', 0.0000, '', 'ml', '', 2, 3.0830, 3.0830, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1760, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000394', 'dztwj', '电子体温计', 'sccj_bjkdwzylqxzx', '', 3, '', 'jjdw_z', '', 1, '', 0.00, 'KD3311', '', 0.0000, '', 'ml', '', 1, 14.5000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1770, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001067', 'gghfhsz', '光固化复合树脂', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '7018A3.5B', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1780, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001191', 'czzm', '炒栀子面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1200, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1790, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001552', 'byt', '避孕套', 'sccj_ssdt', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1800, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000495', 'wztlwm', '网状弹力网帽', 'sccj_zd', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '8#成人', '', 0.0000, '', 'ml', '', 1, 2.9000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1810, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001290', 'crx', '醋乳香', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.3360, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1820, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000830', 'dht', '大黄炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1900, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1830, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001636', 'ntfsgly16*22L', '镍钛方丝弓卵圆16*22L', 'sccj_shamdclljgfyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1840, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001387', 'syh', '输液盒', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '40*10*8cm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1850, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001079', 'mydzynsb', '灭蝇灯专用粘鼠板', 'sccj_amzyc', '', 3, '', 'bzdw_h', 'zxdw_h', 1, '', 0.00, '1盒/盒', '', 0.0000, '', 'ml', '', 2, 290.0000, 290.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1860, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000930', 'mh', '梅花', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 1.1200, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1870, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001303', 'dzy', '淡竹叶', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0500, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1880, 'hclb_gzyhp', 2, 1, 'hclb_gzyhp', '', 'ZKW00001435', 'tzq', '听诊器', 'sccj_3M', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1890, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001059', 'czq', '持针器', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '细针直型140mm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-29 16:40:42', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1900, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000235', 'lsatpzsy', '硫酸阿托品注射液', 'sccj_tjjyyyyxgs', 'H12020382', 3, '', 'bzdw_z', 'zxdw_ml', 1, 'jldw_mg', 0.50, '0.50mg*1ml/支', 'Iv', 0.5000, '', '', 'Prn', 1, 5.8000, 8.1200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 2, NULL, '2018-04-19 13:27:24', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1910, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001797', 'lblzncrp', '雷贝拉唑钠肠溶片', 'sccj_cddkyyyxgs', 'H20040715', 3, '', 'bzdw_h', 'zxdw_p', 5, 'jldw_mg', 20.00, '20.00mg*5片/盒', '', 0.0000, '', '', '', 1, 0.0000, 17.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1920, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_sj_1', 'ZKM00001867', 'zgs', '正骨水', 'sccj_gxnnbhyy', 'Z45021659', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 12.00, '12ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 0.0000, 8.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1930, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000501', 'fmmmp', '酚麻美敏片', 'sccj_shqsyxgs', 'H20010115', 3, '', 'bzdw_h', 'zxdw_p', 1, 'jldw_p', 20.00, '20.00片*1片/盒', 'ad us.int', 1.0000, '', '', 'Qid', 1, 7.4200, 8.9000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 10, 3, NULL, '2018-05-15 17:27:02', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1940, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001066', 'hjl', '呼叫铃', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 59.0000, 59.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1950, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000073', '3Mnjj', '3M粘结剂', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '七代', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2017-09-12 16:28:49', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1960, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000990', 'jgscz', '金钢砂车针', 'sccj_w', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'TF-SS31', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1970, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001510', 'yksj-gsqwlsj', '牙科手机-高速气涡轮手机', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '把', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1980, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000061', 'fnxap（qnl）', '非那雄胺片（千诺林）', 'sccj_hnqjxjyygfyxgs', 'h20040333', 3, '', 'bzdw_h', 'zxdw_p', 10, 'jldw_mg', 5.00, '5.00mg*10片/盒', '', 0.0000, '', '', '', 1, 14.2000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 16:48:17', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (1990, 'bgyplb_dzl', 3, 1, 'bgyplb_dzl', '', 'ZKM00001735', 'wsdj', '温湿度计', 'sccj_amzyc', NULL, 3, '', 'bzdw_t_9258', 'zxdw_t_6854', 1, '', 0.00, '1台/台', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2000, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000924', 'ggc（Kc-21h）', '根管锉（K锉-21混）', 'sccj_mnzshs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm15-40#6*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2010, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_cj_1', 'ZKM00001809', 'lgsxj', '炉甘石洗剂', 'sccj_shyjhpzyyxgs', 'H31022790', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 100.00, '100.00ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 0.0000, 11.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2020, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001395', 'szj', '湿纸巾', 'sccj_amzyc', '', 3, '', 'bzdw_b', 'zxdw_xb', 10, '', 0.00, '10小包/包', '', 0.0000, '', 'ml', '', 2, 2.9900, 2.9900, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2030, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001208', '60mlzsq	', '60ml注射器	', 'sccj_jxhd		', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '50支/包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-07 14:16:33', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2040, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000722', 'Z350XTgghnmsz', 'Z350XT光固化纳米树脂', 'sccj_3MESPE DENTAL PRODUCT', '--', 3, '', 'jjdw_z', '', 1, '', 0.00, '7018(A2)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2050, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000822', 'htp', '海桐皮', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0560, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2060, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000202', '3Mtxmrkjd', '3M弹性棉柔宽胶带', 'sccj_3M  Japan Limited Health', '', 3, '', 'jjdw_j', '', 1, '', 0.00, '12卷/盒', '', 0.0000, '', 'ml', '', 1, 75.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2070, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_pj', 'ZKM00000267', 'sjp(bmyp)', '三金片(薄膜衣片)', 'sccj_glsjyygfyxgs', 'z45021645', 3, '', 'bzdw_h', 'zxdw_p', 72, 'jldw_g', 0.29, '0.29g*72片/盒', '', 0.0000, '', '', '', 1, 30.2000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 16:49:59', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2080, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001361', 'qjs', '清洁刷', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 10.0000, 10.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2090, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00001784', 'xstjn（dw）', '缬沙坦胶囊（代文）', 'sccj_bjnhzyyxgs', 'H20040217', 3, '', 'bzdw_h', 'zxdw_l', 7, 'jldw_mg', 80.00, '80.00mg*7粒/盒', '', 0.0000, '', '', '', 1, 0.0000, 35.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2100, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000754', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '国械注进20152552079', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'EX-21EF(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2110, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001704', 'qxsymsfp', '氢溴酸右美沙芬片', 'sccj_gzbystxzygfyxgs', 'H10900005', 3, '', 'bzdw_h', 'zxdw_p', 12, 'jldw_mg', 15.00, '15.00mg*12片/盒', 'kf', 30.0000, '', '', 'mr3c', 1, 0.0000, 4.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 09:50:16', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2120, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001163', 'wrdk', '煨肉豆蔻', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.3640, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2130, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_klj', 'ZKM00000315', 'tbklghxj（xkl））', '头孢克洛干混悬剂（希刻劳））', 'sccj_llszzyyxgs', '国药准字h10983028', 3, '', 'bzdw_h', 'zxdw_d', 6, 'jldw_g', 0.12, '0.12g*6袋/盒', '', 0.0000, '', '', '', 1, 21.6300, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-08 08:45:29', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2140, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001320', 'ysxxsldjzsy', '盐酸消旋山莨菪碱注射液', 'sccj_scyy', 'h41021055', 3, '', 'bzdw_z', 'zxdw_ml', 1, 'jldw_mg', 10.00, '10.00mg*1ml/支', '', 0.0000, '', '', '', 1, 2.3650, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 17:01:43', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2150, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000656', 'ssz', '生山楂', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0450, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 17:46:48', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2160, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_gj', 'ZKM00000276', 'sxzgg', '麝香壮骨膏', 'sccj_jzgtryyjtyxzrgs', '', 3, '', 'bzdw_h', 'zxdw_t', 10, 'jldw_cm', 10.00, '10cm*10贴/盒', '', 0.0000, '', '', '', 1, 3.2000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 14:20:44', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2170, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001258', 'ldqy', '蓼大青叶', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0650, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2180, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_wy', 'ZKM00000229', 'cszyxy', '除湿止痒洗液', 'sccj_scstyzyyxgs', '国药准字b20020447', 3, '', 'bzdw_h', 'zxdw_p_1', 1, 'jldw_ml', 150.00, '150.00ml*1瓶/盒', '', 0.0000, '', '', '', 1, 20.7000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 17:04:18', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2190, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001319', 'ccddg', '除颤导电膏', 'sccj_gg ', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '250g/瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2200, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001508', 'VITAbsb', 'VITA比色板', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_k_7001', '', 1, '', 0.00, '块', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2210, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000959', 'ct', '蝉蜕', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 1.4560, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2220, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000238', 'fsmzsy(sn)', '呋塞米注射液(速尿)', 'sccj_gdghyyyxgs', 'H44022506', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_ml', 2.00, '2.00ml*10支/盒', '', 0.0000, '', '', '', 2, 8.3000, 2.8000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-22 10:29:33', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2230, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000199', 'lqh', '利器盒', 'sccj_bjjrkkjyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '8L', '', 0.0000, '', 'ml', '', 1, 9.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 16:36:33', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2240, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000495', 'mlxkp', '美洛昔康片', 'sccj_shbl', '国药准字h20020217', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_mg', 7.50, '7.50mg*7片/盒', '', 0.0000, '', '', '', 1, 17.6200, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-25 13:42:03', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2250, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000534', 'tmdasajzymcdsjh（tmddasdwf）', '天门东氨酸氨基转移酶测定试剂盒（天门冬冬氨酸底物法）', 'sccj_glyltyldzyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '40ml*320ml*3', '', 0.0000, '', 'ml', '', 1, 122.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 16:44:14', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2260, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001277', 'sqk', '三七块', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 1.5480, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2270, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001607', 'ysxbjp', '盐酸小檗碱片', 'sccj_njhrylsbzzyxgs', '170502', 3, '', 'bzdw_h', 'zxdw_p', 48, 'jldw_g', 0.10, '0.10g*48片/盒', '', 0.0000, '', '', '', 1, 0.0000, 6.3000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2280, 'yplb_zcy', 1, 0, 'yplb_zcy', 'ypjx_cj', 'ZKM00000041', '2', '2', 'sccj_adyy(bj)yxgs', '2', 3, '2', 'bzdw_b', 'zxdw_b', 2, 'jldw_l', 50.00, '50.00粒*2包/包', 'ad us.int', 5.0000, '', '', 'bid', 1, 20.0000, 20.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 1, 0, 123, 23, NULL, '2017-12-28 23:14:26', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2290, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_gj', 'ZKM00001902', 'yyqfg', '养阴清肺膏', 'sccj_bjtrtkjfzgfyxgszyc', 'Z11020376', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_g', 50.00, '50g*1瓶/瓶', '', 0.0000, '', '', '', 1, 0.0000, 25.4400, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2300, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000811', 'amkzstc', '奥美科自锁托槽', 'sccj_mg Ormco Corporation', '国械注进20162631328', 3, '', 'jjdw_f_3720', '', 1, '', 0.00, '标准Q740-1503', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2310, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000142', 'ysbbkyzsy', '盐酸布比卡因注射液', 'sccj_shchyyyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 5, 'jldw_mg', 37.50, '37.5mg*5支/盒', '', 0.0000, '', '', '', 1, 11.7000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 10:51:37', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2320, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000475', 'pttzsy（50%）', '葡萄糖注射液（50%）', 'sccj_gyjtrszyyxgs', 'H41020039', 3, '', 'bzdw_z', 'zxdw_ml', 20, 'jldw_g', 10.00, '10.00g*20ml/支', 'Iv', 10.0000, '', '', 'St', 2, 1.0000, 0.4200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 3, NULL, '2018-05-22 10:26:57', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2330, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000080', 'akbtp', '阿卡波糖片', 'sccj_hzzmhdzyyxgs', '国药准字h20020202', 3, '', 'bzdw_h', 'zxdw_p', 30, 'jldw_mg', 50.00, '50.00mg*30片/盒', '', 0.0000, '', '', '', 1, 42.6000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:15:46', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2340, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000375', 'fxlwp', '泛昔洛韦片', 'sccj_sdlxyyjtgfyxgs', 'H20093927', 3, '', 'bzdw_h', 'zxdw_p', 6, 'jldw_g', 0.25, '0.25g*6片/盒', 'ad us.int', 0.2500, '', '', 'Q8h', 1, 8.7000, 12.1800, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, NULL, '2018-04-19 11:45:07', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2350, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001781', 'slfsnhsp（ftl）', '双氯芬酸钠缓释片（扶他林）', 'sccj_bjnhzyyxgs', 'H10980297', 3, '', 'bzdw_h', 'zxdw_p', 10, 'jldw_mg', 75.00, '75.00mg*10片/盒', '', 0.0000, '', '', '', 1, 0.0000, 22.9000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2360, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000961', 'mppy', '蜜枇杷叶', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0560, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2370, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_wj', 'ZKM00001453', 'sxjxw', '速效救心丸', 'sccj_tjzxyyjtgfyxgsdlzyc', 'Z12020025', 3, '', 'bzdw_h', 'zxdw_p_1', 3, 'jldw_w', 50.00, '50.00丸*3瓶/盒', '', 0.0000, '', '', '', 1, 49.8000, 60.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-25 12:00:57', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2380, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000246', 'lxydz', '量血压垫枕', 'sccj_hbll', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '大号23*14*45cm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2390, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001267', 'jyht', '金银花炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.5400, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2400, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_klj', 'ZKM00001889', 'qhlykl（mysn）', '清喉利咽颗粒（慢严舒柠）', 'sccj_glyy（ah）yxgs', '', 3, '', 'bzdw_h', 'zxdw_b', 8, 'jldw_g', 5.00, '5.00g*8包/盒', '', 0.0000, '', '', '', 1, 0.0000, 27.5000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-07-03 17:16:10', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2410, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001362', 'yyqxz', '移液器吸嘴', 'sccj_dlxcsyyq（bj）yxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '1000μl（100支/盒）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2420, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000385', 'llxpp(ll)', '劳拉西泮片(罗拉)', 'sccj_tgdxyzycyxgs', 'H20130909', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_mg', 0.50, '0.50mg*20片/盒', 'ad us.int', 0.5000, '', '', 'TID', 1, 13.0000, 18.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 1, 0, 0, 5, 2, NULL, '2018-05-04 17:44:21', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2430, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001350', 'gj', '蛤蚧', 'sccj_trt', '', 3, '', 'bzdw_d_d', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 1.0000, '', '', '', 1, 61.0000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-03-08 15:08:19', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2440, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000790', 'sdh', '熟地黄', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.1000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2450, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000197', 'xxsldjp', '消旋山莨菪碱片', 'sccj_hzmsyyyxgs', 'h33021568', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 10.00, '10.00mg*100片/瓶', '', 0.0000, '', '', '', 1, 16.8000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:19:45', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2460, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000336', 'yyzd（yyjcd-zdx）', '医用中单（医用检查垫-中单型）', 'sccj_sdnyylkjyxgs', '', 3, '', 'jjdw_p_10962', '', 1, '', 0.00, '40x50cm', '', 0.0000, '', 'ml', '', 1, 0.2000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2470, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001034', '60ybjb', '60页笔记本', 'sccj_amzyc', '', 3, '', 'bzdw_b_9413', 'zxdw_b_2375', 1, '', 0.00, '1本/本', '', 0.0000, '', 'ml', '', 2, 2.5000, 2.5000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2480, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000194', 'qjb（nb）', '取精杯（尿杯）', 'sccj_hmsyntsyqcfzyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '40ml/(40只/包）', '', 0.0000, '', 'ml', '', 1, 0.4000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2490, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001167', 'sdy', '生地榆', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.0840, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2500, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000648', 'Kc', 'K锉', 'sccj_xnddsb', '--', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm-15', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2510, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001582', 'fzcp fsb', '纺织产品 访视包', 'sccj_w', '-', 3, '', 'jjdw_t', '', 1, '', 0.00, '套', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2520, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001817', 'wCyqp（wt）', '维C银翘片（无糖）', 'sccj_gzblqyjtgfyxgs', 'Z20083499', 3, '', 'bzdw_h', 'zxdw_l', 24, 'jldw_g', 0.50, '0.50g*24粒/盒', '', 0.0000, '', '', '', 1, 0.0000, 9.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2530, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_fzj', 'ZKM00001777', 'zsyamlzn（lsk）', '注射用奥美拉唑钠（洛赛克）', 'sccj_aslkzyyxgs', 'H20033394', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_mg', 40.00, '40.00mg*1支/支', 'jmdz', 0.0000, '', '', '', 1, 0.0000, 86.9600, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2540, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001579', 'wjsb 10*10', '无菌纱布 10*10', 'sccj_w', '-', 3, '', 'jjdw_p_10962', '', 1, '', 0.00, '片', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2550, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000972', 'shh', '生槐花', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.0990, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 16:37:47', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2560, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000850', 'cwblx', '炒王不留行', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.0330, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-24 17:50:24', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2570, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000108', 'yztz', '牙周探针', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '双头', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2580, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001435', 'lstqlsqp', '氯沙坦氢氯噻嗪片', 'sccj_hzmsdzyyxgs', '国药准字J20140008', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_mg', 0.10, '0.10mg*7片/盒', '', 0.0000, '', '', '', 1, 52.7300, 73.8200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2590, 'bgyplb_dzl', 3, 1, 'bgyplb_dzl', '', 'ZKM00001821', 'a', '啊', 'sccj_amzyc', NULL, 3, '', 'bzdw_sj', 'zxdw_t_6854', 1, '', 0.00, '1台/散剂', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2600, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001376', 'csjf', '醋山甲粉', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 3, 'jldw_g', 3.00, '3g/对', '', 3.0000, '', '', '', 1, 40.0000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2610, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000581', 'fyc', '凤眼草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.0680, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2620, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000463', 'wssB12zsy', '维生素B12注射液', 'sccj_shxyjzyyyxgs_6161', '', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_mg', 0.05, '0.05mg*10支/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 2, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2630, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000488', 'swxwjzypjgbp', '生物显微镜专用配件盖玻片', 'sccj_ycwyyqyxgs', '', 3, '', 'jjdw_p_10962', '', 1, '', 0.00, '22*22mm', '', 0.0000, '', 'ml', '', 1, 0.0600, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-11 16:44:37', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2640, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001223', '50p/bshlt', '50片/包上海励图', 'sccj_shjk', '-', 3, '', 'jjdw_p_10962', '', 1, '', 0.00, '50片/包上海励图', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2650, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000769', 'jdc', '酒丹参', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.1040, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2660, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000774', 'syyr', '生薏苡仁', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.0730, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2670, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000574', 'gjqc', '广金钱草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0410, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:13:01', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2680, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001492', 'stjy', '身体精油', 'sccj_amzyc', NULL, 3, '', 'bzdw_h', 'zxdw_h', 1, '', 0.00, '1盒/盒', '', 0.0000, '', 'ml', '', 2, 98.0000, 98.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2690, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000941', 'yggsj（6%dzdyjj）', '牙根管塞尖（6%大锥度牙胶尖）', 'sccj_dsbyk（tj）yxgs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '06锥度30#蓝120*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 16:23:02', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2700, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000971', 'yjh', '野菊花', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.2520, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2710, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001488', 'lqjksjcsj', '淋球菌快速检测试剂', 'sccj_bs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2720, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001477', 'xcj	', '血沉架	', 'sccj_jsckylypyxgs		', '-', 3, '', 'jjdw_t_148', '', 1, '', 0.00, '台', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-15 12:51:20', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2730, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000858', 'gxjymcl', '硅橡胶印模材料', 'sccj_w', '-', 3, '', 'jjdw_t', '', 1, '', 0.00, '305ml', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2740, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001386', 'pvckc', 'pvc卡槽', 'sccj_amzyc', '', 3, '', 'bzdw_m_1821', 'zxdw_m_4363', 1, '', 0.00, '1米/米', '', 0.0000, '', 'ml', '', 2, 4.5000, 4.5000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2750, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000497', 'yyfsdj', '医用防水垫巾', 'sccj_cf', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '45*50cm', '', 0.0000, '', 'ml', '', 1, 19.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2760, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001563', 'nz', '镊子', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2770, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001144', 'ylqygty', '游离牵引钩通用', 'sccj_hzxyckclyxgs', '浙械注准20172631227', 3, '', 'jjdw_d', '', 1, '', 0.00, '9121-021-10（2.1mm）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2780, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001299', 'lhc', '老鹤草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0340, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2790, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001259', 'hyt', '荷叶炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0570, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2800, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tptj', 'ZKM00000409', 'lnzp', '螺内酯片', 'sccj_Abbott Biologicals B.V.', '', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 20.00, '20.00mg*100片/瓶', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2810, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001588', 'qxs', '器械刷', 'sccj_bx', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2820, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000954', 'yzz', '预知子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1120, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2830, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001147', 'hyzxmjhm', '含银止血明胶海绵', 'sccj_Coltene/whaledertGmbH.Co.KG', '国食药监械（进）字2013第3643967', 3, '', 'jjdw_h', '', 1, '', 0.00, '无', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 08:48:02', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2840, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00001760', 'nfsxjn', '诺氟沙星胶囊', 'sccj_lntczyyxgs', '国药准字h21023141', 3, '', 'bzdw_h', 'zxdw_l', 30, 'jldw_g', 0.10, '0.10g*30粒/盒', '', 0.0000, '', '', '', 1, 0.0000, 3.6000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2850, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000492', 'ysnltzsy', '盐酸纳洛酮注射液', 'sccj_jsehyygfyxgs', 'H20057857', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 1.00, '1.00ml*1支/支', '', 0.0000, '', '', '', 1, 4.6100, 6.4500, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 3, NULL, '2018-04-08 17:24:02', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2860, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000816', 'bjhx', '八角茴香', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1460, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2870, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000096', 'wssB1p', '维生素B1片', 'sccj_hzyygfyxgs', 'h42020611', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 10.00, '10.00mg*100片/瓶', '', 0.0000, '', '', '', 1, 3.6000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:55:20', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2880, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000272', 'lgxwwhjp', '冷光纤维弯喉镜片', 'sccj_TruphatekInternationalLtd', '', 3, '', 'jjdw_z', '', 1, '', 0.00, 'shucman系列52422号弯', '', 0.0000, '', 'ml', '', 1, 900.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2890, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001443', 'nszt（kVC）	', '尿试纸条（抗VC）	', 'sccj_glyltyldzyxgs', '-', 3, '', 'jjdw_t_5432', '', 1, '', 0.00, '桶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2900, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_klj', 'ZKM00001613', 'wskl', '胃苏颗粒', 'sccj_yzjyyjtjszygfyxgs', '17072024', 3, '', 'bzdw_h', 'zxdw_d', 9, 'jldw_g', 5.00, '5.00g*9袋/盒', 'kf', 5.0000, '', '', 'mr3c', 1, 0.0000, 29.9000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-05-24 10:59:48', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2910, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_sj_1', 'ZKM00001811', 'mjzsys', '灭菌注射用水', 'sccj_gyjtrszyyxgs', 'H41024923', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 2.00, '2.00ml*1支/支', '', 0.0000, '', '', '', 1, 0.0000, 0.1400, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2920, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_kfy', 'ZKM00001717', 'kbdkfy', '抗病毒口服液', 'sccj_gzxxzyyxgs', 'Z10890017', 3, '', 'bzdw_h', 'zxdw_z', 12, 'jldw_ml', 10.00, '10.00ml*12支/盒', 'kf', 10.0000, '', '', 'mr3c', 1, 0.0000, 19.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 10:13:09', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2930, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001050', 'wjj（hs）', '文件架（灰色）', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 18.8000, 18.8000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2940, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000241', 'yyjjmp', '医用酒精棉片', 'sccj_qdhnyxzrgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '6*6cm50片/盒', '', 0.0000, '', 'ml', '', 1, 5.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2950, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000977', 'nsc', '南沙参', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2020, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2960, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001174', 'fbjyyclzz（cwn）', '粪便检验预处理装置（常卫宁）', 'sccj_hznhjkkjyxgs', '浙杭械备20170145号', 3, '', 'jjdw_h', '', 1, '', 0.00, '1人份/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2970, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000852', 'sw', '石韦', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0670, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2980, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000789', 'lbmy', '罗布麻叶', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0560, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (2990, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000123', 'cysg', '超硬石膏', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_d', '', 1, '', 0.00, '1.5kg', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3000, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000486', 'btynzsy', '苯妥英钠注射液', 'sccj_dd', '', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_mg', 100.00, '100.00mg*10支/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3010, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001566', 'qlpmj', '强力泡沫胶', 'sccj_amzyc', NULL, 3, '', 'bzdw_j', 'zxdw_j', 1, '', 0.00, '1卷/卷', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3020, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000395', 'zlp', '治疗盘', 'sccj_gdscaxctqsylqxc', '', 3, '', 'jjdw_t', '', 1, '', 0.00, '11.5#配4杯', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3030, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001014', 'A4', 'A4', 'sccj_amzyc', '', 3, '', 'bzdw_h', 'zxdw_b', 5, '', 0.00, '5包/盒', '', 0.0000, '', 'ml', '', 2, 10.0000, 10.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3040, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qwj', 'ZKM00000426', 'ynbyqwj', '云南白药气雾剂', 'sccj_ynbyjtgfyxgs', 'Z53021107', 3, '', 'bzdw_h', 'zxdw_h', 1, 'jldw_g', 115.00, '115.00g*1盒/盒', 'ad us.ext', 0.0000, '', '', 'TID', 1, 29.7000, 35.6400, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 5, 2, NULL, '2018-05-23 15:57:49', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3050, 'bgyplb_qxlcl', 3, 1, 'bgyplb_qxlcl', '', 'ZKM00001654', 'blhg', '玻璃火罐', 'sccj_amzyc', NULL, 3, '', 'bzdw_t_2940', 'zxdw_t_9446', 1, '', 0.00, '1套/套', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-14 11:59:19', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3060, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001425', 'ycxsywjykzsz', '一次性使用无菌牙科注射针', 'sccj_C-K DENTAL IND.CO.,LTD		', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '30G*21mm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3070, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001527', 'yygdd dh', '医用固定带 大号', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3080, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001696', 'wwysjd 24j/h', '网纹易撕胶带 24卷/盒', 'sccj_mnsdkyzzyyqc', '-', 3, '', 'jjdw_j', '', 1, '', 0.00, '卷', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3090, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001235', 'blewqzyet	', '博朗耳温枪专用耳套	', 'sccj_dgbl		', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '20个/盒*10盒/大盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3100, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000404', 'tqjd（wfb）', '透气胶带（无纺布）', 'sccj_jzxzlmwsclyxgs', '', 3, '', 'jjdw_j', '', 1, '', 0.00, '2.5*91012卷/盒', '', 0.0000, '', 'ml', '', 1, 2.0800, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 15:38:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3110, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001278', 'wjft', '无菌敷贴', 'sccj_zjyd ', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '10*10cm,25片/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3120, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rg', 'ZKM00000107', 'axlwrg', '阿昔洛韦乳膏', 'sccj_fjtpyzyyxgs', '国药准字h20063676', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 10.00, '10.00g*1支/支', '', 0.0000, '', '', '', 1, 1.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 08:40:56', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3130, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000986', 'xtg', '吸唾管', 'sccj_w', '无', 3, '', 'jjdw_b', '', 1, '', 0.00, 'HS15SALIVAEJ', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3140, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00001864', 'adf -0.5%PVP-Ixdy', '安多福 -0.5%PVP-I消毒液', 'sccj_sznyyyyxgs', '18041007', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 60.00, '60ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 0.0000, 4.1500, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3150, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000610', 'pyg', '排龈膏', 'sccj_tjzdswyxkjyxgs', '津械注准20162630171', 3, '', 'jjdw_z', '', 1, '', 0.00, '1g*2支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3160, 'hclb_fskcl', 2, 1, 'hclb_fskcl', '', 'ZKW00000435', 'Xsxjpgpd', 'X射线胶片观片灯', 'sccj_rbgdgyzshs_6795', '', 3, '', 'jjdw_z_4769', '', 1, '', 0.00, '三联', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3170, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000448', 'dxfhz（yysx）', '带线缝合针（医用丝线）', 'sccj_shpdjhylypgfyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '1/2角针4*1016cm', '', 0.0000, '', 'ml', '', 1, 22.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3180, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000542', 'dgccdsjh（zm-gyhwmf）', '胆固醇测定试剂盒（酯酶-过氧化物酶法）', 'sccj_glyltyldzyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '50ml*6校准品1ml', '', 0.0000, '', 'ml', '', 1, 292.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3190, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000816', 'dtSuperlinezzt', '登腾Superline种植体', 'sccj_EA', '--', 3, '', 'jjdw_h', '', 1, '', 0.00, 'FX5008SW', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3200, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000693', 'sbbdr', '生白扁豆仁', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0780, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3210, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000900', 'csjyjgzj（ggdxz）', '超声洁牙机工作尖（根管荡洗针）', 'sccj_w', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '15#白6*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3220, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000293', 'fflxpabddp', '复方利血平氨苯蝶啶片', 'sccj_hrshyygfyxgs', 'h11022335', 3, '', 'bzdw_h', 'zxdw_h', 1, 'jldw_p', 30.00, '30.00片*1盒/盒', '', 0.0000, '', '', '', 1, 39.1200, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:26:37', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3230, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000546', 'tsz', '菟丝子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2520, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3240, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000452', 'ttqxy', '探头清洗液', 'sccj_glyltyldzyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, 'D43100ml', '', 0.0000, '', 'ml', '', 1, 130.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3250, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001110', 'yyjp', '医用胶片', 'sccj_hnhq', '-', 3, '', 'jjdw_zhang', '', 1, '', 0.00, '10*12', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-30 14:29:13', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3260, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001342', 'jyhxq', '简易呼吸器', 'sccj_txmn', '-', 3, '', 'jjdw_t', '', 1, '', 0.00, 'MN001-B/PVC小儿型', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3270, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000907', 'cjqkq（kjlg）', '唇颊牵开器（口角拉钩）', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '518-202儿童', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3280, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tj', 'ZKM00001665', 'ssztg1', '伤湿止痛膏1', 'sccj_hnsabwcyxgs', '170714', 3, '', 'bzdw_h', 'zxdw_t', 10, 'jldw_cm', 10.00, '10.00cm*10贴/盒', '', 0.0000, '', '', '', 2, 0.0000, 2.4400, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3290, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tptj', 'ZKM00000430', 'jfzp', '吉法酯片', 'sccj_rbSeiko Eiyo Yakunin', 'H20160240', 3, '', 'bzdw_h', 'zxdw_p', 30, 'jldw_mg', 50.00, '50.00mg*30片/盒', '', 0.0000, '', '', '', 1, 31.4000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-24 09:27:13', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3300, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001055', 'lbgA4wjj', '拉边杆A4文件夹', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 3.0000, 3.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3310, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tj', 'ZKM00001641', 'tqbt cr（TX）', '通气鼻贴 成人（TX）', 'sccj_sjzsyyxgs', '1710001', 3, '', 'bzdw_h', 'zxdw_h', 1, 'jldw_mm', 55.00, '55.00mm*1盒/盒', '', 0.0000, '', '', '', 1, 0.0000, 16.9000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3320, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_wj', 'ZKM00000149', 'bhw', '保和丸', 'sccj_zjwxzygfyxgs', '国药准字z41021818', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_w', 200.00, '200.00丸*1瓶/瓶', '', 0.0000, '', '', '', 1, 10.3000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 09:01:07', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3330, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000267', 'shpdfxdy', '四环牌碘伏消毒液', 'sccj_bjshwsyxcyxgs', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '500ml', '', 0.0000, '', 'ml', '', 1, 15.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3340, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001368', 'fhz', '缝合针', 'sccj_hzhw		', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '角头带针不可吸收缝合针5.040包/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3350, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001033', 'yt', '牙挺', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '空心六角柄SC4', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3360, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001088', 'MP C2503Cxmf（ls）', 'MP C2503C型墨粉（蓝色）', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 580.0000, 580.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3370, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000361', 'csx（bzx）dz', '蚕丝线（编织型）带针', 'sccj_hzhwylypyxgs', '20170420420170412', 3, '', 'jjdw_b', '', 1, '', 0.00, '070cm。1/2,9x24单针', '', 0.0000, '', 'ml', '', 1, 4.4000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-15 14:40:55', 1, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3380, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001244', 'sbj', '水杯架', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 46.8000, 46.8000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3390, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001345', 'zxq（z）', '止血钳（直）', 'sccj_shjz', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '16cm,普通直全齿WD', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3400, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000084', 'lgltp', '罗格列酮片', 'sccj_cdhrzyyxgs', '国药准字h20030569', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_mg', 4.00, '4.00mg*7片/盒', '', 0.0000, '', '', '', 1, 33.0500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 09:02:16', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3410, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000979', 'ycxsyjmcxz', '一次性使用静脉采血针', 'sccj_jxfeksyjtyxgs', '国械注准20153152149', 3, '', 'jjdw_z', '', 1, '', 0.00, '100支/袋0.7*25', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3420, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_crp', 'ZKM00001434', 'amxlklwsjp', '阿莫西林克拉维酸钾片', 'sccj_zhlbzygfyxgszsfgs', '国药准字H20010772', 3, '', 'bzdw_h', 'zxdw_p', 12, 'jldw_g', 0.45, '0.45g*12片/盒', 'kf', 0.9000, '', '', 'm12xsyc', 1, 18.0000, 25.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 14:36:46', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3430, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001613', 'zjz 0.3*60mm', '针灸针 0.3*60mm', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3440, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000891', 'rdt', '忍冬藤', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0290, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3450, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001629', 'clsnry3%250ml', '次氯酸钠溶液3%250ml', 'sccj_dsbyk（tj）yxgs', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3460, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000579', 'Hc', 'H锉', 'sccj_xnddsb', '国器备20170214', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm-8', '', 0.0000, '', 'ml', '', 1, 0.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3470, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001428', 'jssmtlep（btlk）', '酒石酸美托洛尔片（倍他洛克）', 'sccj_aslkzy', '国药准字H32025391', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_hk', 25.00, '25.00毫克*20片/盒', '', 0.0000, '', '', '', 1, 0.0000, 11.5600, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 3, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3480, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001432', 'yt', '牙挺', 'sccj_hfdzzyxzrgs		', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, 'EL2C微创-弯头2mm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3490, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_kfy', 'ZKM00000312', 'fffekdkfry', '复方福尔可定口服溶液', 'sccj_amzyc', 'HC20150057', 3, '', 'bzdw_h', 'zxdw_p_1', 1, 'jldw_ml', 150.00, '150.00ml*1瓶/盒', '', 0.0000, '', '', '', 1, 20.9000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-08 08:42:48', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3500, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000329', 'yyxdmb（dfmq）', '医用消毒棉棒（碘伏棉签）', 'sccj_qdhnswgcyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '24支/盒', '', 0.0000, '', 'ml', '', 1, 5.5000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3510, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001598', 'zjz 0.25*40mm', '针灸针 0.25*40mm', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3520, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000026', 'whq', '雾化器', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3530, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000060', 'pgg', '抛光膏', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3540, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000783', 'tsy', '铁树叶', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0450, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3550, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000730', 'ndg', '糯稻根', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0300, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3560, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000722', 'dh', '地黄', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1010, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 17:42:09', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3570, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000084', 'K3 jyc 30mm', 'K3 机用锉 30mm', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3580, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001600', 'zjz 0.25*50mm', '针灸针 0.25*50mm', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3590, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000453', 'xxbfxyrxj', '血细胞分析用溶血剂', 'sccj_glyltyldzyxgs', '', 3, '', 'jjdw_t_5432', '', 1, '', 0.00, '5L11/1L', '', 0.0000, '', 'ml', '', 1, 780.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3600, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001217', 'ycxzjz', '一次性针灸针', 'sccj_szhq', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '0.18*25mm*10支/10片/盒华佗牌', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3610, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000009', 'xeafhnmkl', '小儿氨酚黄那敏颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3620, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000019', 'zphzs', '珠珀猴枣散', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3630, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000029', 'pttsgxkfry', '葡萄糖酸钙锌口服溶液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3640, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_qt', 'ZDS90000039', 'yfsxdey', '氧氟沙星滴耳液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-02-06 17:17:19', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3650, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000049', 'tqbyp', '通窍鼻炎片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3660, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000059', 'afghcrjn（fn）', '阿法骨化醇软胶囊（法能）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3670, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000069', 'ysajpttjn（weg）', '盐酸氨基葡萄糖胶囊（维尔固）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3680, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000079', 'jtp', '颈痛片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3690, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000089', 'kfyjn', '康妇炎胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3700, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000099', 'jeyxy', '洁尔阴洗液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3710, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000109', 'lfmp', '莉芙敏片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3720, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000119', '*cscrg(owt)', '*雌三醇乳膏(欧维婷)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3730, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000129', 'gzfljn', '桂枝茯苓胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3740, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000139', 'ldpsp', '利胆排石片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3750, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000149', 'ydpgjn', '茵胆平肝胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3760, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000159', 'dxypfkl', '丹溪玉屏风颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3770, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000169', '*hxbhy', '*和兴白花油', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3780, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000179', 'mlstnjjp(sen)', '孟鲁司特钠咀嚼片(顺尔宁)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3790, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000189', '@lssdacqwj(wtl)', '@硫酸沙丁胺醇气雾剂(万托林)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3800, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000199', 'mlstnp(sen)', '孟鲁司特钠片(顺尔宁)', 'sccj_hzmsdzyyxgs', 'J20130047', 3, '', 'bzdw_h', 'zxdw_p', 5, 'jldw_mg', 10.00, '10.00mg*5片/盒', 'ad us.int', 10.0000, '', 'ml', 'qd', 1, 37.2000, 52.0800, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 10, 3, '2017-07-13 00:00:00', '2018-04-19 13:40:11', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3810, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000209', 'qtp', '去痛片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3820, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000219', 'jasblfkl', '精氨酸布洛芬颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3830, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rg', 'ZDS90000229', 'ztxyrg(hj)', '止痛消炎软膏(恒健)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-09-11 14:23:46', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3840, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000239', 'lsqdmszsy', '硫酸庆大霉素注射液', 'sccj_xnyygfyxgs', 'h50021451', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 2.00, '2ml*1支/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 0.3400, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-07-03 15:06:57', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3850, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000249', 'lfpjn', '利福平胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3860, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000259', 'ysyadcp', '盐酸乙胺丁醇片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3870, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000269', 'lgtdgp', '雷公藤多苷片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3880, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZDS90000279', 'zyyzjn', '转移因子胶囊', 'sccj_bjhlzyyxgs', 'H20046007', 3, '', 'bzdw_h', 'zxdw_l', 24, 'jldw_mg', 6.00, '6.00mg*24粒/盒', 'kf', 12.0000, '', 'ml', 'mr3c', 1, 36.1000, 2.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-24 15:17:38', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3890, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000289', 'qrtlp', '清热通淋片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3900, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000299', 'sstkl', '肾石通颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3910, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000309', 'ssnjn', '肾衰宁胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3920, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000319', 'ysejsgp(ghz)', '盐酸二甲双胍片(格华止)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3930, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000329', 'axlwnj', '阿昔洛韦凝胶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3940, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000339', 'ffzcy', '复方紫草油', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3950, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_gj', 'ZDS90000349', 'tkzrg', '酮康唑乳膏', 'sccj_xayszyyxgs', '170723907', 3, '', 'bzdw_z', 'zxdw_kg_g', 15, 'jldw_%', 2.00, '2.00%*15g/支', '', 0.0000, '', 'ml', '', 1, 23.0000, 23.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 1, 0, 0, 1, '2017-07-13 00:00:00', '2018-05-10 14:38:52', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3960, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000359', 'sdqjn', '湿毒清胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3970, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000369', 'zcg', '紫草膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3980, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000379', 'sdqp', '湿毒清片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (3990, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000389', 'wyzjd', '外用紫金锭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4000, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000399', 'hxzqkfy', '藿香正气口服液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4010, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000409', 'hxzqs', '藿香正气水', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4020, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000419', 'eswwshw', '二十五味珊瑚丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4030, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000429', 'fpsdmlqxp(dlx)', '氟哌噻吨美利曲辛片(黛力新)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4040, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000439', 'pbdehsp', '吡贝地尔缓释片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4050, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000449', 'jwxsp', '健胃消食片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4060, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000459', 'kfxy', '康复新液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4070, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000469', 'gpw', '归脾丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4080, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000479', 'ffmxxbjp', '复方木香小檗碱片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4090, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000489', 'kfxy', '康复新液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4100, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000499', 'nxtjn', '脑心通胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4110, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000509', 'atfttgp', '阿托伐他汀钙片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4120, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000519', 'xstp', '血塞通片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4130, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000529', 'fmq10jn', '辅酶q10胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4140, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000539', 'ysplptp', '盐酸普罗帕酮片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4150, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000549', 'lhzzjn', '裸花紫珠胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4160, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000559', 'nmwdyy', '萘敏维滴眼液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4170, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000569', 'fflsrgsdyy', '复方硫酸软骨素滴眼液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4180, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000579', 'ysnjzldyy', '盐酸萘甲唑啉滴眼液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4190, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000589', 'yymq', '医用棉签', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/袋', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4200, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_sj_2', 'ZDS90000599', 'pttfj', '葡萄糖粉剂', 'sccj_fzhwfyzyyxgs', 'H35021006', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 75.00, '75.00g*1袋/袋', '', 0.0000, '', 'ml', '', 2, 5.4000, 2.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 2, '2017-07-13 00:00:00', '2018-05-03 16:13:32', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4210, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000609', 'tsgd3p（cr）', '碳酸钙d3片（成人）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4220, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000619', 'bsysjn', '补肾益寿胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4230, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000629', 'agyxtj', '阿归养血糖浆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4240, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000639', 'yanw', '益安宁丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4250, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000007', 'ycswhzz（et）', '一次生雾化装置（儿童）', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '单个装', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4260, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000017', 'ycxyywfbzjd', '一次性医用无纺布纸胶带', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '直径2.5cm 12卷一盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4270, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000027', 'ycxkz', '一次性口罩', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '独立包装3000个每件', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4280, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000037', 'ycxskfl', '一次性伤口敷料', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '20个/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4290, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000047', 'xdtz', '心电图纸', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4300, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000057', 'flj：hm', '分离胶：黄帽', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '100支每盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4310, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000067', 'xbtkqsky', '洗必泰口腔漱口液', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4320, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000077', 'kqdxfhz', '口腔带线缝合针', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '12包/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4330, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000087', 'yx', '牙线', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4340, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000097', 'zlp', '治疗盘', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 1, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4350, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000107', 'dmq（fky）', '大棉签（妇科用）', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '50包/袋（20cm/根）', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4360, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000008', 'hq', '黄芪', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4370, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000018', 'sdh', '生地黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4380, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000028', 'cjnj', '炒鸡内金', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4390, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000038', 'bs', '白芍', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4400, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000048', 'sr', '砂仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4410, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000058', 'wg', '蜈蚣', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4420, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000068', 'hx', '藿香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4430, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000078', 'ml', '牡蛎', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4440, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000088', 'fccs', '麸炒苍术', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4450, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000098', 'jj', '荆芥', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4460, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000108', 'ff', '防风', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4470, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000118', 'my', '麦芽', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4480, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000128', 'hhp', '合欢皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4490, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000138', 'sy', '山药', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4500, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000148', 'cdy', '炒稻芽', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4510, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000158', 'pgy', '蒲公英', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4520, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000168', 'qh', '前胡', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4530, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000178', 'zm', '知母', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4540, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000188', 'dgp', '地骨皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4550, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000198', 'zhsw', '制何首乌', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4560, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000208', 'zjc', '皂角刺', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4570, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000218', 'xx', '细辛', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4580, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000228', 'jxd', '酒续断', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4590, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000238', 'lz', '莲子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4600, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000248', 'bmg', '白茅根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4610, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000258', 'ccp', '炒陈皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4620, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000268', 'bh', '薄荷', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4630, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000278', 'ybgz', '盐补骨脂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4640, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000288', 'zgc', '炙甘草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4650, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000298', 'fs', '佛手', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4660, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000308', 'bjc', '败酱草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4670, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000318', 'yzm', '盐知母', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4680, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000328', 'ct', '蝉蜕', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4690, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000338', 'sy', '桑叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4700, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000348', 'cjz', '炒芥子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4710, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000358', 'sgl', '丝瓜络', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4720, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000368', 'hhp', '合欢皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4730, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000378', 'mbq', '蜜白前', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4740, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000388', 'cmc', '川明参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4750, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000398', 'dg', '当归', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4760, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000408', 'gg', '葛根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4770, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000418', 'jqbhs', '金钱白花蛇', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4780, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000428', 'lq', '连翘', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4790, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000438', 'yjh', '盐橘核', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4800, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000448', 'dgt', '当归头', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4810, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000458', 'hhh', '合欢花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4820, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000468', 'ydz', '盐杜仲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4830, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000478', 'cqc', '车前草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4840, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000488', 'czych', '醋竹叶柴胡', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4850, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000498', 'dh', '独活', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4860, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000508', 'qlg', '千里光', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4870, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000518', 'sm', '苏木', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4880, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000528', 'jhq', '酒黄芩', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4890, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000538', 'thf', '天花粉', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4900, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000548', 'yxhx', '盐小茴香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4910, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000558', 'dx', '丁香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4920, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000568', 'tbc', '土鳖虫', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4930, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000578', 'ymc', '益母草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4940, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000588', 'pl', '佩兰', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4950, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000598', 'es', '莪术', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4960, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000608', 'zgc', '炙甘草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4970, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000618', 'sl', '三棱', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4980, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000628', 'htp', '海桐皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (4990, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000638', 'sz', '桑枝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5000, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000648', 'yfpz', '盐覆盆子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5010, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000658', 'mmh', '蜜麻黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5020, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000668', 'adc', '矮地茶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5030, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000678', 'dml', '煅牡蛎', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5040, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000688', 'jgh', '鸡冠花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5050, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000698', 'ssg', '生石膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5060, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000708', 'mz', '木贼', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5070, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000718', 'jdh', '酒大黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5080, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000728', 'lbmy', '罗布麻叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5090, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000738', 'xkqc', '夏枯全草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5100, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000748', 'rcrp', '肉苁蓉片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5110, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000758', 'pdh', '胖大海', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5120, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000768', 'xqg', '西青果', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5130, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000778', 'yfpz', '盐覆盆子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5140, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000788', 'ddc', '淡豆豉', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5150, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000798', 'cx', '川芎', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5160, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000808', 'bb', '百部', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5170, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000818', 'qh', '前胡', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5180, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000828', 'dk', '豆蔻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5190, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000838', 'cgj', '醋龟甲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5200, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000848', 'lzx', '莲子心', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5210, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000858', 'jhp', '姜厚朴', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5220, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000868', 'fj', '防己', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5230, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000878', 'dgz', '冬瓜子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5240, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000888', 'fsm', '茯神木', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5250, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000898', 'djt', '大蓟炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5260, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000908', 'xb', '薤白', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5270, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000918', 'mb（b）', '马勃（白）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5280, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000928', 'jqm', '金荞麦', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5290, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000938', 'mx(ymx)', '木香(云木香)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5300, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000948', 'dy', '地榆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5310, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000958', 'll', '漏芦', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5320, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000968', 'lg', '芦根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5330, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000978', 'dqy', '大青叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5340, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000988', 'cqc', '炒蛴螬', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5350, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000998', 'hz', '诃子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5360, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001008', 'zjp', '紫荆皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5370, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001018', 'dzzm', '煅珍珠母', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5380, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001028', 'mmh', '蜜麻黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5390, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001038', 'jxd', '酒续断', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5400, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001048', 'sz', '水蛭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5410, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001058', 'ych', '银柴胡', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5420, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001068', 'bx', '萆薢', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5430, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001078', 'cjc', '炒僵蚕', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5440, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001088', 'cbj', '醋鳖甲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5450, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001098', 'chh', '炒槐花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5460, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001108', 'qh(xqh)', '前胡(信前胡)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5470, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001118', 'tcwp', '烫刺猬皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5480, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001128', 'gzt', '贯众炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5490, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001138', 'hzm', '黑芝麻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5500, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001148', 'zsy', '紫苏叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5510, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001158', 'pdh', '胖大海', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5520, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001168', 'cht', '草红藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5530, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001178', 'yhlb', '盐胡芦巴', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5540, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001188', 'mcx', '马齿苋', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5550, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001198', 'ysj', '油松节', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5560, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001208', 'ojt', '藕节炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5570, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001218', 'blg', '板蓝根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5580, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001228', 'jgh', '鸡冠花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5590, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001238', 'mmdl', '蜜马兜铃', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5600, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001248', 'jsz', '净山楂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5610, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001258', 'jbx.', '姜半夏.', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5620, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001268', 'mgh', '玫瑰花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5630, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001278', 'pgy', '蒲公英', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5640, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001288', 'cqh', '长前胡', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5650, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001298', 'tl', '天龙', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5660, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001308', 'pdh', '胖大海', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5670, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001318', 'lg', '龙骨', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5680, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001328', 'ckxr', '燀苦杏仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5690, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001338', 'sdh', '熟大黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5700, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001348', 'qp', '秦皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5710, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001358', 'sd', '柿蒂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5720, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001368', 'xd', '续断', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5730, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001378', 'cjxc', '炒九香虫', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5740, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001388', 'jqc', '金钱草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5750, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001398', 'whg', '无花果', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5760, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001408', 'ckxr', '燀苦杏仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5770, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001418', 'ct', '蝉蜕', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5780, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001428', 'dml', '煅牡蛎', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5790, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001438', 'lg', '龙骨', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5800, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001448', 'dh', '大黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5810, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001458', 'nmtg', '糯米藤根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5820, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001468', 'dj', '大蓟', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5830, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001478', 'tkz', '天葵子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5840, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001488', 'xy', '辛夷', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5850, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001498', 'wrdk', '煨肉豆蔻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5860, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001508', 'ccwz', '炒茺蔚子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5870, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001518', 'dkg', '冬葵果', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5880, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001528', 'sz', '水蛭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5890, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001538', 'cpc', '垂盆草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5900, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001548', 'xy', '香橼', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5910, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001558', 'cjxz', '炒急性子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5920, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001568', 'pj', '炮姜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5930, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001578', 'nx', '牛膝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5940, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001588', 'jcx', '酒川芎', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5950, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001598', 'sg', '守宫', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5960, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001608', 'sjm', '石决明', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5970, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001618', 'hmwjp', '红毛五加皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5980, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001628', 'jj', '荆芥', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (5990, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001638', 'dz', '大枣', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6000, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001648', 'mhg', '麻黄根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6010, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001658', 'bq', '白前', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6020, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001668', 'xtd', '小天冬', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6030, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001678', 'hph', '厚朴花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6040, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001688', 'bs', '白芍', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6050, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001698', 'yjh', '月季花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6060, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001708', 'snj', '水牛角', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6070, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001718', 'cjc', '炒僵蚕', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6080, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001728', 'zcw', '制草乌', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6090, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001738', 'zhsw', '制何首乌', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6100, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001748', 'bsc', '北沙参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6110, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001758', 'czych', '醋竹叶柴胡', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6120, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001768', 'sjc', '石见穿', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6130, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001778', 'zjp', '紫荆皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6140, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001788', 'ybgz', '盐补骨脂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6150, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001798', 'bh', '薄荷', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6160, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001808', 'zych', '竹叶柴胡', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6170, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001818', 'zsy', '紫苏叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6180, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001828', 'sg', '石膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6190, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001838', 'rdt', '忍冬藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6200, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001848', 'jyh', '金银花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6210, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001858', 'ghx', '广藿香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6220, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001868', 'mdp', '牡丹皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6230, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001878', 'cyhs', '醋延胡索', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6240, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001888', 'jbx', '京半夏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6250, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001898', 'lxt', '灵仙藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6260, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001908', 'cbm', '川贝母', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6270, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001918', 'xkc', '夏枯草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6280, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001928', 'hsp', '黑顺片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6290, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001938', 'pc', '排草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6300, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001948', 'yms', '夜明砂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6310, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001958', 'bl', '槟榔', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6320, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001968', 'kc', '苦参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6330, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001978', 'hq', '黄芩', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6340, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001988', 'dz', '大枣', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6350, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001998', 'hc', '红参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6360, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002008', 'zhq', '炙黄芪', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6370, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002018', 'msz', '没食子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6380, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002028', 'xtd', '小天冬', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6390, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002038', 'mtx', '满天星', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6400, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002048', 'mgh', '玫瑰花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6410, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002058', 'dnx', '胆南星', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6420, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002068', 'md', '麦冬', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6430, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002078', 'mppy', '蜜枇杷叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6440, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002088', 'chdj', '醋红大戟', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6450, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002098', 'scz', '蛇床子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6460, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002108', 'dh', '独活', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6470, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002118', 'jst', '鸡矢藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6480, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002128', 'nx', '牛膝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6490, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002138', 'jcs', '酒常山', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6500, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002148', 'hsp', '黑顺片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6510, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002158', 'xcq', '徐长卿', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6520, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002168', 'tkz', '天葵子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6530, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002178', 'sdh', '熟地黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6540, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002188', 'sz', '水蛭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6550, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002198', 'ct', '蝉蜕', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_0` VALUES (6560, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002208', 'cyh', '川银花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
COMMIT;

-- ----------------------------
-- Table structure for drug_resource_1
-- ----------------------------
DROP TABLE IF EXISTS `drug_resource_1`;
CREATE TABLE `drug_resource_1` (
  `id` bigint unsigned NOT NULL DEFAULT '0' COMMENT '主键',
  `drug_res_type_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT ' 药品和物资类型ID(dw_drug_res_type.id)',
  `base_type` tinyint NOT NULL DEFAULT '0' COMMENT '物品类型：1-药品, 2-耗材, 3-办公用品',
  `status` int DEFAULT '1' COMMENT '药品状态: 0 - 停用, 1 - 使用',
  `type_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药品或者耗材类别的字典ID(dw_dictionary.id AND dw_dictionary.type_id=[yplb OR hclb])',
  `dict_dosage_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药品剂型的字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypjx)',
  `code` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '集团编码',
  `pym` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '拼音简码',
  `name` varchar(64) CHARACTER SET utf8 DEFAULT '' COMMENT '药品或者耗材的名称',
  `manufacturer_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '生产厂家的字典ID(dw_dictionary.id AND dw_dictionary.type_id=sccj)',
  `approval_no` varchar(100) CHARACTER SET utf8 DEFAULT NULL COMMENT '批准文号',
  `med_type` int DEFAULT '3' COMMENT '医保分类： 1 - 无自付, 2 - 部分自付, 3 - 全自付',
  `admin_code` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药监编码',
  `pack_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '包装单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypdw)',
  `min_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '最小单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypdw)',
  `pack_quantity` int DEFAULT '1' COMMENT '包装含量',
  `dosage_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '剂量单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=jldw)',
  `dosage_quantity` decimal(10,2) DEFAULT '0.00' COMMENT '剂量含量',
  `pack_spec` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '包装规格，生成规则：[剂量含量] [剂量单位] * [包装含量] [最小单位] / [包装单位]',
  `take_method_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '用法(默认用法)(dw_dictionary.id AND dw_dictionary.type_id=ypyf)',
  `take_quantity` decimal(36,4) DEFAULT '0.0000' COMMENT '用量(默认用量)',
  `take_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '用量单位字典ID - 暂留字典',
  `take_unit_name` varchar(36) CHARACTER SET utf8 DEFAULT 'ml' COMMENT '用量单位名称，默认ml',
  `take_frequency` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '频率(默认频率)(dw_dictionary.id AND dw_dictionary.type_id=yppl)',
  `common_unit_type` int DEFAULT '1' COMMENT '常规单位类型: 1 - 包装单位(packUnit), 2 - 最小单位(minUnit)',
  `purchase_price` decimal(8,4) DEFAULT '0.0000' COMMENT '进货价: 单位 元',
  `sale_price` decimal(8,4) DEFAULT '0.0000' COMMENT '基准价: 单位 元',
  `cost_category_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '费用类别字典ID(dw_dictionary.id AND dw_dicitionary.type_id=fylb)',
  `invoice_item_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '发票项目字典ID - 暂留',
  `expensive_flag` int DEFAULT '1' COMMENT '贵重物品标识： 0 - 非贵重物品， 1 - 贵重物品',
  `psy_flag_i` int DEFAULT '0' COMMENT ' 精神I类药品标识：0 - 非选中， 1 - 选中',
  `psy_flag_ii` int DEFAULT '0' COMMENT '精神II类药品标识：0 - 非选中，1 - 选中',
  `otc_flag` int DEFAULT '0' COMMENT 'OTC标识：0 - 非选中， 1 - 选中',
  `nar_flag` int DEFAULT '0' COMMENT '麻醉药品标识：0 - 非选中， 1 - 选中',
  `inventory_upper` int DEFAULT '0' COMMENT '库存上限',
  `inventory_lower` int DEFAULT '0' COMMENT '库存下限',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  `modify_time` datetime DEFAULT NULL COMMENT '修改时间',
  `del_flag` int DEFAULT '0' COMMENT '删除标志:  0 - 未删除, 1 - 已删除',
  `consumable_type` int NOT NULL DEFAULT '0' COMMENT '耗材类型:1-国产,2-进口',
  `tips` varchar(1024) CHARACTER SET utf8 DEFAULT NULL COMMENT '药品使用注意事项',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

-- ----------------------------
-- Records of drug_resource_1
-- ----------------------------
BEGIN;
INSERT INTO `drug_resource_1` VALUES (1, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000082', 'K3 jyc 21mm', 'K3 机用锉 21mm', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (11, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001328', 'ycxwg', '一次性胃管', 'sccj_cqdkcjzy', '-qweqr', 3, '', 'jjdw_z', '', 1, '', 0.00, '支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-08-13 18:00:54', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (21, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001420', 'yyzzx', '医用周转箱', 'sccj_bjkylsmyxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '60L黄色', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (31, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001447', 'rrmcxxjs（HCG）jcsz	', '人绒毛促性腺激素（HCG）检测试纸	', 'sccj_rhswyykj（st）yxgs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (41, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000771', 'cqp', '醋青皮', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1.00g*1g/克', '', 10.0000, '', '', '', 1, 0.0670, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (51, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_xrj', 'ZKM00001775', 'lstbtlwhy（blkn）', '硫酸特布他林雾化液（博利康尼）', 'sccj_AstraZenecaAB', 'H20140108', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 2.00, '2.00ml*1支/支', '', 0.0000, '', '', '', 1, 0.0000, 4.9300, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (61, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000846', 'cmdp', '炒牡丹皮', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1.00g*1g/克', '', 10.0000, '', '', '', 1, 0.2000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (71, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000066', 'asplcrp', '阿司匹林肠溶片', 'sccj_beyybjyxgsfz', 'J20171021', 3, '', 'bzdw_h', 'zxdw_p', 30, 'jldw_mg', 100.00, '100.00mg*30片/盒', '', 0.0000, '', '', '', 1, 15.5000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 13:30:12', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (81, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001705', 'yysbp 50d/h 2p/d', '医用纱布片 50袋/盒 2片/袋', 'sccj_wjyl（hg）yxgs		', '-', 3, '', 'jjdw_p_10962', '', 1, '', 0.00, '片', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (91, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000382', 'yyjd', '医用胶带', 'sccj_lcshcylqxyxgs', '', 3, '', 'jjdw_j', '', 1, '', 0.00, '1.5X500X10', '', 0.0000, '', 'ml', '', 1, 1.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (101, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00001786', 'ystslxhsjn（hl）', '盐酸坦索罗辛缓释胶囊（哈乐）', 'sccj_asktlzyyxgs', 'H20000681', 3, '', 'bzdw_h', 'zxdw_l', 10, 'jldw_mg', 0.20, '0.20mg*10粒/盒', 'chkf', 0.2000, '', '', 'mr1c', 1, 0.0000, 49.5100, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (111, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001159', 'yysyt', '医用输液贴', 'sccj_ncsyekylqxyxgs', '赣械注准20172640010', 3, '', 'jjdw_h', '', 1, '', 0.00, '100片/盒70mm*35', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 11:34:39', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (121, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001020', '1020PLUSdyjmh', '1020PLUS打印机墨盒', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 59.0000, 59.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (131, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000156', 'nmdpp', '尼莫地平片', 'sccj_ybyyjtgfyxgs', '国药准字H14022821', 3, '', 'bzdw_p', 'zxdw_p', 50, 'jldw_mg', 20.00, '20.00mg*50片/瓶', '', 0.0000, '', '', '', 1, 1.9000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 13:36:43', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (141, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000069', '3Mwgfbj', '3M窝沟封闭剂', 'sccj_Boryung Pharmaceutical ', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '袋', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-22 16:41:15', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (151, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001525', 'A5bjb', 'A5笔记本', 'sccj_amzyc', NULL, 3, '', 'bzdw_b_9413', 'zxdw_b_2375', 1, '', 0.00, '1本/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-02 13:49:27', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (161, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rj', 'ZKM00001863', 'adf -0.5%PVP-Ixdy', '安多福 -0.5%PVP-I消毒液', 'sccj_szlbkjgfyxgs', '18041007', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 60.00, '60ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 0.0000, 4.1500, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (171, 'bgyplb_dzl', 3, 1, 'bgyplb_dzl', '', 'ZKM00001487', 'haptimejsq', 'haptime计时器', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 35.9000, 35.9000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-04-20 18:25:37', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (181, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000788', 'cszr', '炒酸枣仁', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.8960, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (191, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000758', 'yzx', '盐泽泻', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0750, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (201, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsp', 'ZKM00000032', '123cs', '123测试', 'sccj_cqdkcjzy', '', 3, '', 'bzdw_g_cldw', 'zxdw_h', 123, 'jldw_g', 1.00, '1.00g*123盒/g', '', 0.0000, '', '', '', 1, 0.0000, 12.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (211, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001550', 'kgyfsp', '抗宫炎分散片', 'sccj_htjtgxskzy', 'Z20090163', 3, '', 'bzdw_h', 'zxdw_p', 36, 'jldw_g', 0.50, '0.50g*36片/盒', 'kf', 3.0000, '', '', 'mr3c', 1, 22.0000, 2.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 2, NULL, '2018-05-24 14:06:36', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (221, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001131', 'dgp', '地骨皮', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.5040, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (231, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00000454', 'nxmsj（TT）cdsjh（dgx）（ngf）', '凝血酶时间（TT）测定试剂盒（冻干型）（凝固法）', 'sccj_shtyswjsyxgs', '', 3, '', 'jjdw_f_9562', '', 1, '', 0.00, '10*2.5', '', 0.0000, '', 'ml', '', 1, 10.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-10 21:36:40', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (241, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_dej', 'ZKM00000406', 'yfsxdey', '氧氟沙星滴耳液', 'sccj_rbdyzyzshs', '', 3, '', 'bzdw_z', 'zxdw_ml', 5, 'jldw_mg', 3.00, '3.00mg*5ml/支', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 1, NULL, '2018-02-06 17:17:09', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (251, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000156', 'wgmt', '钨钢磨头', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (261, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000685', 'dnx', '胆南星', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.2500, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (271, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001534', 'xzn', '膝状镊', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '把', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (281, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000732', 'jhq', '酒黄芩', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.3140, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (291, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000286', 'bxgsbg', '不锈钢纱布罐', 'sccj_hzjlylqxyxgs', '', 3, '', 'jjdw_z_5693', '', 1, '', 0.00, '141X130', '', 0.0000, '', 'ml', '', 1, 67.2000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (301, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000608', 'Hc', 'H锉', 'sccj_xnddsb', '国械备20170214号', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm-10', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (311, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001622', 'ymcl（glz）', '研磨材料（矽粒子）', 'sccj_rb', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (321, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001581', 'fzcp fsb', '纺织产品 访视包', 'sccj_lxThinkPad', '-', 3, '', 'jjdw_t', '', 1, '', 0.00, '套', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (331, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001125', 'cxd', '赤小豆', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0500, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (341, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000290', 'ycxsywg（gjwg）', '一次性使用胃管（硅胶胃管）', 'sccj_yzysyykjyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '14#', '', 0.0000, '', 'ml', '', 1, 2.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-15 11:00:03', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (351, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000184', 'fmtdp', '法莫替丁片', 'sccj_hndnzyyxgs', '国药准字h43020667', 3, '', 'bzdw_h', 'zxdw_p', 24, 'jldw_mg', 20.00, '20.00mg*24片/盒', '', 0.0000, '', '', '', 1, 4.5000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 13:56:04', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (361, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_hsp', 'ZKM00000041', 'csadg', '测试啊当归', 'sccj_hrsj', '123413241', 3, '', 'bzdw_b', 'zxdw_kg_g', 1, 'jldw_g', 8.00, '8.00g/包', '', 0.0000, '', '', '', 1, 0.0000, 12.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (371, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001633', 'zjzth 0.3*25mm', '针灸针套盒 0.3*25mm', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (381, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001474', 'rxj	', '溶血剂	', 'sccj_szmr', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (391, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000598', 'Kc', 'K锉', 'sccj_xnddsb', '国食药监械进字2013第1062073', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm-15-40混', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (401, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001639', 'fmsttfp（TX）', '富马酸酮替芬片（TX）', 'sccj_jspyyyyxgs', '1705172', 3, '', 'bzdw_p', 'zxdw_p', 60, 'jldw_mg', 1.38, '1.38mg*60片/瓶', '', 0.0000, '', '', '', 2, 0.0000, 0.0900, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-05-17 17:32:15', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (411, 'bgyplb_qxlcl', 3, 1, 'bgyplb_qxlcl', '', 'ZKM00001767', 'jnnkj', '胶囊内窥镜', 'sccj_amzyc', NULL, 3, '', 'bzdw_h', 'zxdw_l', 1, '', 0.00, '1粒/盒', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (421, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001646', 'gsy', '刮痧油', 'sccj_w', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (431, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001130', 'ces', '醋莪术', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0840, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (441, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000427', 'ycxsywjzsq', '一次性使用无菌注射器', 'sccj_shkdlqyfzjtgfyxgs', '', 3, '', 'jjdw_z_5693', '', 1, '', 0.00, '20ml', '', 0.0000, '', 'ml', '', 1, 0.5300, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (451, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000566', 'tljcyc', '听力检查音叉', 'sccj_Carent ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '512Hz银', '', 0.0000, '', 'ml', '', 1, 52.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (461, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001459', 'bdb（ALB）cdsjh	', '白蛋白（ALB）测定试剂盒	', 'sccj_szmr', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (471, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000727', 'mg', '木瓜', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.1120, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (481, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsjn', 'ZKM00001516', 'blfhsjn', '布洛芬缓释胶囊', 'sccj_zmtjskzyyxgs', 'H1000089', 3, '', 'bzdw_h', 'zxdw_l', 20, 'jldw_g', 0.30, '0.30g*20粒/盒', 'Pc', 0.3000, '', '', 'Q12h', 1, 14.8400, 17.8100, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 10, 5, NULL, '2018-04-27 15:15:59', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (491, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsp', 'ZKM00000038', 'xmdy', '西模单一', 'sccj_hrsj', '', 3, '', 'bzdw_b', 'zxdw_wu_cldw', 1, 'jldw_g', 10.00, '10.00g/包', '', 0.0000, '', '', '', 1, 0.0000, 10.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-08-14 16:51:12', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (501, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001419', 'ryljt', '日用垃圾桶', 'sccj_bjkylsmyxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '30L脚踏式', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (511, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001605', 'ffcshhp', '复方草珊瑚含片', 'sccj_jsst', '17090007', 3, '', 'bzdw_h', 'zxdw_p', 24, 'jldw_g', 1.00, '1.00g*24片/盒', '', 0.0000, '', '', '', 1, 0.0000, 12.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (521, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001597', 'zjzth 0.25*40mm', '针灸针套盒 0.25*40mm', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (531, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001258', 'ycxsycxz', '一次性使用采血针', 'sccj_zjkdlylqxgfyxgs', 'C20170105', 3, '', 'jjdw_z', '', 1, '', 0.00, '0.7x20双翼XYII12', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.6000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (541, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000744', 'jjt', '荆芥碳', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0480, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (551, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001344', 'zxq（w）', '止血钳（弯）', 'sccj_shjz', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '16cm普通弯全齿WD', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (561, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001274', 'ytjs', '液体胶水', 'sccj_amzyc', '', 3, '', 'bzdw_h', 'zxdw_z', 15, '', 0.00, '15支/盒', '', 0.0000, '', 'ml', '', 2, 4.5000, 4.5000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (571, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000236', 'dsmslsnzsy', '地塞米松磷酸钠注射液', 'sccj_tjjyjthbtyyygfyxgs', 'H42020019', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 1.00, '1.00ml*1支/支', '', 0.0000, '', '', '', 1, 0.5500, 0.7700, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 3, NULL, '2018-04-08 17:11:55', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (581, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rgj', 'ZKM00001589', 'lkmsldkyrg', '林可霉素利多卡因乳膏', 'sccj_hbrzzyyxgs', '170406', 3, '', 'bzdw_z', 'zxdw_kg_g', 10, 'jldw_hk', 50.00, '50.00毫克*10g/支', '', 0.0000, '', '', '', 1, 3.5000, 3.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (591, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000139', 'abdzp', '阿苯达唑片', 'sccj_hzyygfyxgs', 'h40021405', 3, '', 'bzdw_h', 'zxdw_p', 10, 'jldw_g', 0.20, '0.20g*10片/盒', '', 0.0000, '', '', '', 1, 6.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:06:02', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (601, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00000532', 'ysssxszsj', '盐酸肾上腺素注射剂', 'sccj_jnkfszyyxgs_2176', 'H12020526', 3, '', 'bzdw_z', 'zxdw_ml', 1, 'jldw_mg', 1.00, '1.00mg*1ml/支', '', 0.0000, '', '', '', 1, 4.8000, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 0, 0, 100, 10, NULL, '2018-02-07 15:46:18', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (611, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000687', 'mb', '马勃', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.3670, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (621, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rgj', 'ZKM00000431', 'slfsrjj', '双氯芬酸乳胶剂', 'sccj_bjnhzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 1, 'jldw_g', 20.00, '20.00g*1支/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 1, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (631, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000617', 'mslb', '毛刷连棒', 'sccj_dgslgylqxyxgs', '粤东械备20160012', 3, '', 'jjdw_h', '', 1, '', 0.00, '中（黄色+蓝色）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (641, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000538', 'zjzxjsnp', '左甲状腺激素纳片', 'sccj_dgMorok KGaA ', 'H20140052', 3, '', 'bzdw_h', 'zxdw_p', 100, 'jldw_ug', 50.00, '50.00ug*100片/盒', 'ad us.int', 50.0000, '', '', 'om', 1, 25.6500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 1, NULL, '2018-03-02 17:12:49', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (651, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001528', 'cgj', '抽杆夹', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (661, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000176', 'gmflq', '骨膜分离器', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (671, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000576', 'Hc', 'H锉', 'sccj_xnddsb', '国器备20170214', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm-35', '', 0.0000, '', 'ml', '', 1, 0.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (681, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001260', 'ryljt	', '日用垃圾桶	', 'sccj_bjkylsmyxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '30L脚踏式', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (691, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000653', 'mfry', '木芙蓉叶', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0330, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (701, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000951', 'mx', '芒硝', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.1800, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (711, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001049', 'kjd', '宽胶带', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 5.5000, 5.5000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (721, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00001130', 'hc（cs）', '耗材（测试）', 'sccj_cdjdsjmyyxgs', 'GB004', 3, 'YJ004', 'jjdw_p', '', 1, '', 0.00, '50g/瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (731, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001354', 'bbzyx', '标本转运箱', 'sccj_cdtk		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '46L带温显', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (741, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001288', 'dgp', '冬瓜皮', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.1120, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (751, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001484', 'yyj', '移液架', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (761, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001530', 'dyzA4', '打印纸A4', 'sccj_amzyc', NULL, 3, '', 'bzdw_j_4203', 'zxdw_b', 8, '', 0.00, '1包/件', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-02 14:12:35', 1, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (771, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000927', 'dml', '煅牡蛎', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0220, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (781, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000538', 'bdbcdsjh（xjflf）', '白蛋白测定试剂盒（溴甲酚绿法）', 'sccj_glyltyldzyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '45ml*6校准品1ml', '', 0.0000, '', 'ml', '', 1, 78.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (791, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001026', 'hsqzbx', '黑色签字笔芯', 'sccj_amzyc', '', 3, '', 'bzdw_h', 'zxdw_z', 20, '', 0.00, '20支/盒', '', 0.0000, '', 'ml', '', 2, 0.6000, 0.6000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (801, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000970', 'jfrmxsxdnj', '洁肤柔免洗手消毒凝胶', 'sccj_cdwjlkylypyxgs', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '500ml/瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (811, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_hsp', 'ZKM00000037', 'zmde', '中模单二', 'sccj_hrsj', '1211', 3, '', 'bzdw_b', 'zxdw_kg_g', 20, 'jldw_g', 20.00, '20.00g/包', '', 0.0000, '', '', '', 1, 0.0000, 20.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (821, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000417', 'dtxycly', '动态血压测量仪', 'sccj_yghmgjyxgsbjdbc', '', 3, '', 'jjdw_t_148', '', 1, '', 0.00, 'ri-cardio（1760）', '', 0.0000, '', 'ml', '', 1, 9000.0000, 0.0000, 'fylb_zcf', 'fpxm_zcf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (831, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000702', 'bxgfs', '不锈钢方丝', 'sccj_shamdclljgfyxgs', '沪械注准20152630530', 3, '', 'jjdw_d', '', 1, '', 0.00, '卵圆18*22下', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 08:48:53', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (841, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001594', 'wCyqp', '维C银翘片', 'sccj_gzjxyyyxgs', '20170709', 3, '', 'bzdw_h', 'zxdw_b_7638', 2, 'jldw_p', 12.00, '12.00片*2板/盒', '', 0.0000, '', '', '', 1, 9.8000, 8.5600, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-05-21 14:44:23', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (851, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001533', 'tmj（x）', '透明胶（小）', 'sccj_amzyc', NULL, 3, '', 'bzdw_j', 'zxdw_j', 1, '', 0.00, '1卷/卷', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (861, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_ryj', 'ZKM00000536', 'pdlkfy', '蒲地蓝口服液', 'sccj_UCB PARCHIM SA rs bj', 'Z20030095', 3, '', 'bzdw_h', 'zxdw_z', 12, 'jldw_ml', 10.00, '10.00ml*12支/盒', '', 0.0000, '', '', '', 1, 37.9660, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 0, 0, 10, 3, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (871, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001899', 'fmsbslep（kx）', '富马酸比索洛尔片（康忻）', 'sccj_mkzy（js）yxgs', 'J20170042', 3, '', 'bzdw_h', 'zxdw_p', 10, 'jldw_hk', 5.00, '5毫克*10片/盒', '', 0.0000, '', '', '', 1, 0.0000, 40.3200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (881, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001033', '30ybjb', '30页笔记本', 'sccj_amzyc', '', 3, '', 'bzdw_b_9413', 'zxdw_b_2375', 1, '', 0.00, '1本/本', '', 0.0000, '', 'ml', '', 2, 1.5000, 1.5000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (891, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001101', 'jsz', '焦山楂', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0560, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (901, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001542', 'ylljd20L', '医疗垃圾袋20L', 'sccj_amzyc', NULL, 3, '', 'bzdw_b_9933', 'zxdw_b_1129', 1, '', 0.00, '1把/把', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-07 10:00:21', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (911, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000923', 'yyc（protaper ntgk-sy25h）', '牙用锉（protaper 镍钛根扩-手用25混）', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mmSX-F36*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (921, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001193', 'ldm', '龙胆面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1440, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (931, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001462', 'ns（UA）cdsjh	', '尿酸（UA）测定试剂盒	', 'sccj_szmr', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (941, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000850', 'ggkdz', '根管扩大针', 'sccj_mnzshs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm 08H 6*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-22 17:43:30', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (951, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001386', 'tzq', '听诊器', 'sccj_3M', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '2298', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (961, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001585', 'amkzzzkd', '奥美科种植支抗钉', 'sccj_mg Ormco Corporation', '国械注进20173631800', 3, '', 'jjdw_l', '', 1, '', 0.00, '粒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (971, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001041', 'dsq+dsd+qdq', '订书器+订书钉+起钉器', 'sccj_amzyc', '', 3, '', 'bzdw_t_2940', 'zxdw_t_9446', 1, '', 0.00, '1套/套', '', 0.0000, '', 'ml', '', 2, 12.0000, 12.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (981, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001052', 'etbyq', '儿童拔牙钳', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '8#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (991, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001900', 'bhsaldpp（lhx）', '苯磺酸氨氯地平片（络活喜）', 'sccj_hrzyyxgs', 'H10950224', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_hk', 5.00, '5毫克*7片/盒', '', 0.0000, '', '', '', 1, 0.0000, 46.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1001, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001314', 'ycnz', '有齿镊子', 'sccj_shjz', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '总长16cm,有钩', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1011, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hj', 'ZKM00000473', 'smtkfy', '四磨汤口服液', 'sccj_dd', '', 3, '', 'bzdw_h', 'zxdw_z', 8, 'jldw_ml', 10.00, '10.00ml*8支/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 2, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1021, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000177', '11', '11', 'sccj_gdhnyyjtyxgs', '11', 3, '11', 'jjdw_d', '', 1, '', 0.00, '11', '', 0.0000, '', 'ml', '', 1, 10.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1031, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000583', 'rjst', '乳胶手套', 'sccj_gzsjmxszpyxgs', '粤械注准20152660723', 3, '', 'jjdw_s', '', 1, '', 0.00, '小（6.5）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1041, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000399', '10xlgdkssd（wyd））', '10型冷光单孔手术灯（无影灯））', 'sccj_jsjggdkjyxgs', '', 3, '', 'jjdw_t_148', '', 1, '', 0.00, '无', '', 0.0000, '', 'ml', '', 1, 450.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1051, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_dyj', 'ZKM00000178', 'zzmmdyy', '珍珠明目滴眼液', 'sccj_szgyyqtlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 1, 'jldw_ml', 15.00, '15.00ml*1支/盒', '', 0.0000, '', '', '', 1, 8.5000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-18 16:21:31', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1061, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001042', 'crbyq', '成人拔牙钳', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '69#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1071, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000725', 'wgf', '蜈蚣粉', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 9.3100, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1081, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_hjp', 'ZKM00001771', 'cy（cs）', '草药（测试）', 'sccj_cdjdsjmyyxgs', 'GB001', 3, 'YJ001', 'bzdw_h', 'zxdw_kg_g', 10, 'jldw_g', 50.00, '50g/盒', 'phc', 2.0000, '', '', 'm12xsyc', 1, 0.0000, 50.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1091, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000379', 'tngmp', '泰诺感冒片', 'sccj_w', '', 3, '', 'bzdw_h', 'zxdw_p', 10, 'jldw_mg', 325.00, '325.00mg*10片/盒', 'ad us.int', 325.0000, '', '', 'Qid', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 3, NULL, '2018-02-09 16:56:40', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1101, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000224', 'ycxsywjzsz（kdlzsz）', '一次性使用无菌注射针（康德莱注射针）', 'sccj_zjkdlylqxgfyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '0.7*32', '', 0.0000, '', 'ml', '', 1, 0.1700, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 13:52:37', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1111, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000089', 'kdz Rc 21mm', '扩大针 R锉 21mm', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1121, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001127', 'flp', '茯苓皮', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0390, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1131, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000630', 'dzdyjj', '大锥度牙胶尖', 'sccj_dsbyk（tj）yxgs', '国械注准20163631121', 3, '', 'jjdw_h', '', 1, '', 0.00, '04（混）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-04-03 15:42:36', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1141, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_pj', 'ZKM00000362', 'shp（1）', '三黄片（1）', 'sccj_hbryyygfyxgs(yhbryyyyxgs)', '', 3, '', 'bzdw_h', 'zxdw_p', 54, 'jldw_g', 0.26, '0.26g*54片/盒', '', 0.0000, '', '', '', 1, 2.8500, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1151, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001002', 'jgscz', '金刚砂车针', 'sccj_w', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'BR-46', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-29 12:37:53', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1161, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_rj', 'ZKM00001853', '1111', '1111', 'sccj_lxThinkPad', '1111', 3, '', 'bzdw_k_10382', 'zxdw_k_6141', 1, 'jldw_IU', 1.00, '1.00IU*1颗/颗', '', 0.0000, '', '', '', 1, 0.0000, 111.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1171, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dej', 'ZKM00001658', 'yszyfsxdey', '盐酸左氧氟沙星滴耳液', 'sccj_szwhzyyxgs', 'H20090024', 3, '', 'bzdw_z', 'zxdw_ml', 5, 'jldw_％', 0.50, '0.50％*5ml/支', '', 0.0000, '', '', '', 1, 0.0000, 22.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1181, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000951', 'ggctcl（AH Plus）', '根管充填材料（AH Plus）', 'sccj_xnddsb', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, 'A糊剂3ml/管+B糊剂3ml/管', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1191, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001497', 'hzMh', '护肘M号', 'sccj_3M', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1201, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001292', 'ycxwhxrmz', '一次性雾化吸入面罩', 'sccj_gzwl', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '维力6cm/个A型成人型', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1211, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000956', 'jmxsy', '洁灭洗手液', 'sccj_cdswsclc', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '500ml', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1221, 'hclb_gzyhp', 2, 1, 'hclb_gzyhp', '', 'ZKW00000206', 'ajxs,xdyzdfpq', '安捷洗手,消毒液自动分配器', 'sccj_sdajgkxdkjyxgs', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '2型', '', 0.0000, '', 'ml', '', 1, 380.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-12 13:49:12', 1, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1231, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001249', 'yysbp（mjj）	', '医用纱布片（灭菌级）	', 'sccj_wjyl（hg）yxgs		', '-', 3, '', 'jjdw_p_10962', '', 1, '', 0.00, '7.5*7.5cm-8P*2片/袋30袋/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1241, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000676', 'zyz', '朱远志', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.3740, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1251, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000145', 'byq', '拔牙钳', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '各型', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1261, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tptj', 'ZKM00000417', 'sdacqwj', '沙丁胺醇气雾剂', 'sccj_Abbott Biologicals B.V.', '', 3, '', 'bzdw_z', 'zxdw_q', 200, 'jldw_ug', 100.00, '100.00ug*200揿/支', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1271, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hj', 'ZKM00000472', 'shlkfy', '双黄连口服液', 'sccj_hysj', '17092037', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_ml', 10.00, '10.00ml*10支/盒', '', 0.0000, '', '', '', 1, 16.0000, 13.9700, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 10, 2, NULL, '2018-06-28 17:40:33', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1281, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000556', 'mdksxjfyszdsj', '梅毒快速血浆反应素诊断试剂', 'sccj_shkh', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '120人份', '', 0.0000, '', 'ml', '', 1, 120.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1291, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000273', 'ysb', '压舌板', 'sccj_yzysyykjyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '150mm', '', 0.0000, '', 'ml', '', 1, 0.1000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 13:55:18', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1301, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001146', 'yhlb', '盐葫芦巴', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0670, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1311, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rgj', 'ZKM00001682', 'ystbnfrg(1%)', '盐酸特比萘芬乳膏(1%)', 'sccj_UCB PARCHIM SA rs bj', 'H20150190', 3, '', 'bzdw_z', 'zxdw_kg_g', 10, 'jldw_%', 1.00, '1.00%*10g/支', '', 0.0000, '', '', '', 1, 0.0000, 19.4100, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1321, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000880', 'yyc（C+c）', '牙用锉（C+锉）', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm8##6*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1331, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001245', 'ebsc', '鹅不食草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1150, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1341, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000466', 'bhlmzsy', '苯海拉明注射液', 'sccj_tjjyyyyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_mg', 20.00, '20.00mg*10支/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 2, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1351, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001030', 'csjhb', '彩色记号笔', 'sccj_amzyc', '', 3, '', 'bzdw_h', 'zxdw_z', 6, '', 0.00, '6支/盒', '', 0.0000, '', 'ml', '', 2, 1.7700, 1.7700, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1361, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000637', 'hcsh', '黄草石斛', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.5940, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1371, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000911', 'jgcxdkd', '技工醋型雕刻刀', 'sccj_shkqylqxyxgs', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '#E48 10支/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 16:58:43', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1381, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00001703', 'ffjynmjn（asm）', '复方甲氧那明胶囊（阿斯美）', 'sccj_dysgzy（bj）yxgs', 'H20033669', 3, '', 'bzdw_h', 'zxdw_l', 60, 'jldw_l', 1.00, '1.00粒*60粒/盒', 'kf', 2.0000, '', '', 'mr3c', 1, 0.0000, 37.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 09:58:32', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1391, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000928', ' ydz', ' 盐杜仲', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0990, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1401, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001571', 'mjzsys', '灭菌注射用水', 'sccj_dzzy', 'H20044102', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 10.00, '10.00ml*1支/支', 'Iv', 10.0000, '', '', 'qd', 1, 1.1900, 1.6700, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 20, 5, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1411, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001030', 'yt', '牙挺', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '空心六角柄SS3', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1421, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001611', 'zjzth 0.3*60mm', '针灸针套盒 0.3*60mm', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1431, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000860', 'gghddcl', '光固化垫底材料', 'sccj_w', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '0.33g/支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1441, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001537', 'zyb', '遮眼板', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1451, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001300', 'ych', '银柴胡', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.3360, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1461, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000615', 'yhz', '咬合纸', 'sccj_syxkmxclyxgs', '辽沈食药监械生产备20150024号', 3, '', 'jjdw_h', '', 1, '', 0.00, '红色', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1471, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001223', 'cjsq', '炒建神曲', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1120, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1481, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000638', 'ggywsszjy', '根管药物输送针机用', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, '21mm混', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1491, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000028', 'bdgjmzxyzz', '鼻导管及面罩吸氧装置', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1501, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000632', 'Hc', 'H锉', 'sccj_xnddsb', '国器备20170214', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm-20(黄)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1511, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000611', 'smjz', '生蔓荆子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.4300, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1521, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001805', 'tbkwfsp', '头孢克肟分散片', 'sccj_zjspasyyyxgs', 'H20060655', 3, '', 'bzdw_h', 'zxdw_l', 8, 'jldw_g', 0.10, '0.10g*8粒/盒', '', 0.0000, '', '', '', 1, 0.0000, 6.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-06-14 16:45:31', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1531, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_kfy', 'ZKM00000313', 'xewmmfdj', '小儿伪麻美芬滴剂', 'sccj_shqszyyxgs', 'H20010605', 3, '', 'bzdw_h', 'zxdw_p_1', 1, 'jldw_ml', 15.00, '15.00ml*1瓶/盒', '', 0.0000, '', '', '', 1, 12.6900, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:11:25', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1541, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001558', 'zd', '扎带', 'sccj_amzyc', NULL, 3, '', 'bzdw_d', 'zxdw_d', 1, '', 0.00, '1袋/袋', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1551, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001351', '3Mzsjd', '3M指示胶带', 'sccj_3M', '-', 3, '', 'jjdw_j', '', 1, '', 0.00, '3M,1322', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1561, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001663', 'ycmbj4751（2*1）', '牙齿美白胶4751（2*1）', 'sccj_mgWelch Allyyn.Incgs', '', 3, '', 'jjdw_t', '', 1, '', 0.00, '套', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1571, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001308', 'ycxyd', '一次性牙垫', 'sccj_dgblgfhxyxgs', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '中号,长方形,100个/包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1581, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_klj', 'ZKM00000067', 'gmqrkl', '感冒清热颗粒', 'sccj_bjtrtkjfzgfyxgszyc', 'Z11020361', 3, '', 'bzdw_h', 'zxdw_d', 10, 'jldw_g', 12.00, '12.00g*10袋/盒', 'ad us.int', 12.0000, '', '', 'bid', 1, 12.4000, 14.8800, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 1, 0, 10, 4, NULL, '2018-04-19 13:47:16', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1591, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001524', '40yzlcA4', '40页资料册A4', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1601, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000584', 'chqnz', '炒黑牵牛子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0270, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1611, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000083', 'K3 jyc 25mm', 'K3 机用锉 25mm', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1621, 'hclb_fskcl', 2, 1, 'hclb_fskcl', '', 'ZKW00000434', 'Xsxjpgpd', 'X射线胶片观片灯', 'sccj_hspskfqxc', '', 3, '', 'jjdw_z_4769', '', 1, '', 0.00, '双联', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-17 16:34:35', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1631, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001231', 'spby', '生批把叶', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0440, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1641, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000217', 'yysyt', '医用输液贴', 'sccj_bjygykkjfzyxgs', '', 3, '', 'jjdw_p_10962', '', 1, '', 0.00, '5片/盒', '', 0.0000, '', 'ml', '', 1, 6.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-24 10:02:53', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1651, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001056', 'bqt', '标签贴', 'sccj_amzyc', '', 3, '', 'bzdw_b', 'zxdw_b', 1, '', 0.00, '1包/包', '', 0.0000, '', 'ml', '', 2, 1.8000, 1.8000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1661, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001179', 'kf', '枯矾', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0330, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1671, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000875', 'fp', '浮萍', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 0.0000, '', '', '', 1, 0.0560, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1681, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_hsp', 'ZKM00000030', 'ze2', '周二2', 'sccj_hrsj', '12', 3, '', 'bzdw_z', 'zxdw_wu_cldw', 1, 'jldw_mm', 500.00, '500.00mm/支', '', 0.0000, '', '', '', 1, 0.0000, 3990.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1691, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001379', 'zhsw', '制何首乌', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1460, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1701, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsp', 'ZKM00001485', 'slfsnhsp（xxd）', '双氯芬酸钠缓释片（仙喜得）', 'sccj_shsyxyycyxgs', 'H20010604', 3, '', 'bzdw_h', 'zxdw_p', 12, 'jldw_g', 0.10, '0.10g*12片/盒', 'PO', 0.1000, '', '', 'Qn', 1, 19.8000, 27.7200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1711, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000034', 'wssgtzcly', '卧式身高体重测量仪', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1721, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000661', 'fcyyr', '麸炒薏苡仁', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0840, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 17:47:25', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1731, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000385', 'jjb', '急救包', 'sccj_zkkj', '', 3, '', 'jjdw_t', '', 1, '', 0.00, 'ZK-D52cm*35cm*28cm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1741, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_rg', 'ZKM00000230', 'mplxrg(bdbrg)', '莫匹罗星软膏(百多邦软膏)', 'sccj_zmtjskzyyxgs', 'H10930064', 3, '', 'bzdw_h', 'zxdw_kg_g', 5, 'jldw_%', 2.00, '2.00%*5g/盒', 'ad us.ext', 0.0000, '', '', 'TID', 1, 11.8500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-03-09 16:41:26', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1751, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000676', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'TF-S41(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1761, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001146', 'nkpgb', '内口抛光杯', 'sccj_dgslgylqxyxgs', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '无', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1771, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001122', 'nwlbdbcdsjh（ghxwlmybzf）', '尿微量白蛋白测定试剂盒（干化学微粒免疫比浊法）', 'sccj_flOriongs', '国械注进20172400740', 3, '', 'jjdw_h', '', 1, '', 0.00, '50T', '', 0.0000, '', 'ml', '', 1, 0.0000, 1000.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-31 13:39:02', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1781, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001279', 'tmskfsflt', '透明伤口防水敷料贴', 'sccj_3M', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '6*7cm,100个/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1791, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001644', 'wssB2p（TX）', '维生素B2片（TX）', 'sccj_hzyygfyxgs', '20170606', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 5.00, '5.00mg*100片/瓶', '', 0.0000, '', '', '', 1, 0.0000, 3.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1801, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001203', 'ecm', '儿茶面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1980, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1811, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_pj', 'ZKM00001430', 'ysmxsp（bfl）', '盐酸莫西沙片（拜复乐）', 'sccj_beyybjyxgsfz', '国药准字J20150015', 3, '', 'bzdw_h', 'zxdw_p', 3, 'jldw_g', 0.40, '0.40g*3片/盒', 'kf', 0.4000, '', '', 'mr1c', 1, 69.8300, 97.7600, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 1, NULL, '2018-05-24 14:54:09', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1821, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000768', 'dps', '煅硼砂', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0540, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1831, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000010', 'jjd', '酒精灯', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1841, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000023', 'zbp', '载玻片', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1851, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000338', 'yyfl（skft）', '医用敷料（伤口敷贴）', 'sccj_qdhnswgcyxgs', '', 3, '', 'jjdw_p_10962', '', 1, '', 0.00, '6x7cm', '', 0.0000, '', 'ml', '', 1, 0.5500, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1861, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000339', 'yyfl（skft）', '医用敷料（伤口敷贴）', 'sccj_qdhnswgcyxgs', '', 3, '', 'jjdw_p_10962', '', 1, '', 0.00, '10x10cm', '', 0.0000, '', 'ml', '', 1, 0.8000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1871, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001373', 'ccsjf', '醋穿山甲粉', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 3, 'jldw_g', 3.00, '3g/包', '', 3.0000, '', '', '', 1, 45.0000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1881, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000716', 'bs', '白芍', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1400, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1891, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000291', 'ycxsywg（gjwg）', '一次性使用胃管（硅胶胃管）', 'sccj_yzysyykjyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '16#', '', 0.0000, '', 'ml', '', 1, 2.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1901, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000980', 'ycxsyzkcxg', '一次性使用真空采血管', 'sccj_jskjylypyxgs', '苏械注准20152411361', 3, '', 'jjdw_z', '', 1, '', 0.00, '5ml肝素钠绿色', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-29 11:48:34', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1911, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000635', 'mdq', '毛冬青', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0480, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1921, 'hclb_ycxcl', 2, 0, 'hclb_ycxcl', '', 'ZKW00001234', 'ycxsyyywkkz	', '一次性使用医用外科口罩	', 'sccj_gzslhylqxsyyxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '耳挂式/单个装100个/包3000个/件', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-22 15:55:03', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1931, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001098', 'gzq', '刮治器', 'sccj_w', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, 'SG7/89E2', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1941, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000500', 'wpt', '网瓶套', 'sccj_zd', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '500ml', '', 0.0000, '', 'ml', '', 1, 0.5500, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1951, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000237', 'mz', '脉诊', 'sccj_hbllpgzpyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '大号', '', 0.0000, '', 'ml', '', 1, 25.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 16:01:16', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1961, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000895', 'ffqjytmcl（yx）', '氟防龋健龈脱敏材料（牙线）', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '50m', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 14:24:49', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1971, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001008', 'jgscz', '金刚砂车针', 'sccj_w', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'F0-54C', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1981, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000794', 'md', '麦冬', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 0.0000, '', '', '', 1, 0.5320, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (1991, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001449', 'ycxsywlcxxg	', '一次性使用微量采血吸管	', 'sccj_zblxyyqcyxgs		', '-', 3, '', 'jjdw_t_5432', '', 1, '', 0.00, '桶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2001, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tptj', 'ZKM00000422', 'mlstjjp', '孟鲁司特咀嚼片', 'sccj_Abbott Biologicals B.V.', '', 3, '', 'bzdw_h', 'zxdw_p', 5, 'jldw_mg', 10.00, '10.00mg*5片/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2011, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001457', 'glqtp（dmk）', '格列齐特片（达美康）', 'sccj_tjhjzygs', 'H10910053', 3, '', 'bzdw_h', 'zxdw_p', 60, 'jldw_mg', 80.00, '80.00mg*60片/盒', '', 0.0000, '', '', '', 1, 71.0500, 99.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2021, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000386', 'sladp', '舒乐安定片', 'sccj_w', '', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_mg', 1.00, '1.00mg*20片/盒', 'ad us.int', 2.0000, '', '', 'qd', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 1, 0, 0, 5, 2, NULL, '2018-01-12 11:19:27', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2031, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000506', 'fnbtjn', '非诺贝特胶囊', 'sccj_recipharm fontaine', 'H20160155', 3, '', 'bzdw_h', 'zxdw_l', 10, 'jldw_mg', 200.00, '200.00mg*10粒/盒', 'ad us.int', 200.0000, '', '', 'qd', 1, 36.8000, 51.5200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 5, NULL, '2018-04-27 15:44:36', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2041, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hjp', 'ZKM00001713', 'sqgjslhjp（jsq）', '双歧杆菌三联活菌片（金双歧）', 'sccj_nmgsqyygfyxgs', 'S19980004', 3, '', 'bzdw_h', 'zxdw_p', 24, 'jldw_g', 0.50, '0.50g*24片/盒', 'kf', 0.5000, '', '', 'mr3c', 1, 0.0000, 20.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2051, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000313', 'fln', '敷料镊', 'sccj_shylqx（jt）yxgsssqxc', '', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'J4205020CM无钩', '', 0.0000, '', 'ml', '', 1, 15.2800, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2061, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_pj', 'ZKM00001431', 'aqmsp（xsm）', '阿奇霉素片（希舒美）', 'sccj_hrzyyxgs', '国药准字H10960167', 3, '', 'bzdw_h', 'zxdw_p', 6, 'jldw_g', 0.25, '0.25g*6片/盒', '', 0.0000, '', '', '', 1, 61.8200, 86.5500, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-08 11:08:09', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2071, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001255', 'etfhwq1712322	', '儿童防护围裙1712322	', 'sccj_szhkylqxyxgs		', '-', 3, '', 'jjdw_t_7475', '', 1, '', 0.00, '0.50铅当量', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2081, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000833', 'kjt', '口镜头', 'sccj_shylqx（jt）yxgsssqxc', '沪虹械备20150219号', 3, '', 'jjdw_z_5693', '', 1, '', 0.00, '头平光', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2091, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000147', 'ryq', '日月钳', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2101, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001205', '2.5mlzsq	', '2.5ml注射器	', 'sccj_jxhd		', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '100支/包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2111, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001356', 'sddtdktwlyyq', '手动单通道可调微量移液器', 'sccj_dlxcsyyq（bj）yxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '2-20μl', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2121, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000579', 'jt', '姜炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.1100, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:45:27', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2131, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00000530', 'wss B12zsy', '维生素 B12注射液', 'sccj_tjjyyyyxgs', 'H12020387', 3, '', 'bzdw_z', 'zxdw_ml', 1, 'jldw_mg', 0.50, '0.50mg*1ml/支', '', 0.0000, '', '', '', 1, 0.1900, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 100, 2, NULL, '2018-02-08 11:29:30', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2141, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001241', 'gkp	', '广口瓶	', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '30ml白色', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2151, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001123', 'wlbdbzkp', '微量白蛋白质控品', 'sccj_flOriongs', '国械注进20162400917', 3, '', 'jjdw_h', '', 1, '', 0.00, '2ml', '', 0.0000, '', 'ml', '', 1, 0.0000, 318.4000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-31 13:39:47', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2161, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001339', 'hmr', '火麻仁', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.1120, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2171, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000794', '75%jj（TX）', '75%酒精（TX）', 'sccj_w', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '500ml*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2181, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000116', 'zxhm', '止血海绵', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_d', '', 1, '', 0.00, '袋', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2191, 'yplb_zcy', 1, 0, 'yplb_zcy', 'ypjx_cj', 'ZKM00000042', '3', '3', 'sccj_adyy(bj)yxgs', '3', 3, '3', 'bzdw_d', 'zxdw_b', 3, 'jldw_g', 50.00, '50.00g*3包/袋', 'ad us.ext', 1.0000, '', '', 'bid', 2, 30.0000, 450.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 1, 0, 12, 1, NULL, '2017-12-28 23:15:04', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2201, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000868', 'gjy', '鬼箭羽', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.3140, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 10:55:37', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2211, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000843', 'kqzjyfgj', '口腔正畸用反光镜', 'sccj_w', '-', 3, '', 'jjdw_k_7001', '', 1, '', 0.00, '505-103A1宽#3A颌向大号', '', 0.0000, '', 'ml', '', 1, 0.0000, 120.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2221, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001154', 'ymjd', '亚敏胶带', 'sccj_shsf', '沪嘉械备20140058号', 3, '', 'jjdw_h', '', 1, '', 0.00, '910*1.25nm*24卷', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 11:23:12', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2231, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001557', 'sjbd', '三角绷带', 'sccj_ssdt', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2241, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000440', 'ycxsyypb', '一次性使用样品杯', 'sccj_jskdylypyxgs', '', 3, '', 'jjdw_z_5693', '', 1, '', 0.00, '16*38mm', '', 0.0000, '', 'ml', '', 1, 5.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-24 10:15:30', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2251, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000426', '3Mtxmrkjd', '3M弹性绵柔宽胶带', 'sccj_3Mzg', '', 3, '', 'jjdw_j', '', 1, '', 0.00, '2733-25', '', 0.0000, '', 'ml', '', 1, 36.5000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2261, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000503', 'yyjjd', '医用酒精灯', 'sccj_relAB', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '304不锈钢', '', 0.0000, '', 'ml', '', 1, 66.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2271, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_cj', 'ZKM00000071', 'jfkl（dq）', '荆防颗粒（大千）', 'sccj_scdqyyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 20, 'jldw_g', 15.00, '15g*20袋/袋', '', 0.0000, '', '', '', 1, 8.9300, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-08 13:38:50', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2281, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000704', 'amk ycbxgfs', '奥美科 预成不锈钢方丝', 'sccj_mg Ormco Corporation', '--', 3, '', 'jjdw_g', '', 1, '', 0.00, '19*25', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2291, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000649', 'yjc', '月见草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0450, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2301, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001390', 'sgzdq', '石膏振荡器', 'sccj_w', '-', 3, '', 'jjdw_t_148', '', 1, '', 0.00, '瑞安PV-1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2311, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001177', 'dp', '滴瓶', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '30ml白色', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2321, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000330', 'hmq', '海绵钳', 'sccj_shylqx（jt）yxgsssqxc', '', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'J3409025CM弯有槽10CM', '', 0.0000, '', 'ml', '', 1, 71.6800, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2331, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000515', 'ysp', '油纱片', 'sccj_sxfke', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '5*5cm', '', 0.0000, '', 'ml', '', 1, 20.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-11 17:44:39', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2341, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsjn', 'ZKM00001666', 'blfhsjn（fbd）*', '布洛芬缓释胶囊（芬必得）*', 'sccj_zmtjskzyyxgs', '17070530', 3, '', 'bzdw_h', 'zxdw_l', 24, 'jldw_g', 0.40, '0.40g*24粒/盒', '', 0.0000, '', '', '', 2, 0.0000, 1.1000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2351, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000119', 'zsyymc', '藻酸盐印膜材', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_d', '', 1, '', 0.00, '袋', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2361, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000093', 'wssB6p', '维生素B6片', 'sccj_cddyzyyxgs(ycddyyyyxgs)', '', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 10.00, '10mg*100片/瓶', '', 0.0000, '', '', '', 1, 1.7000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 11:30:29', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2371, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000197', 'lqh', '利器盒', 'sccj_bjjrkkjyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '1L', '', 0.0000, '', 'ml', '', 1, 2.6000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2381, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_klj', 'ZKM00001715', 'amxlklwsjkl（aq）', '阿莫西林克拉维酸钾颗粒（安奇）', 'sccj_xsyyyxgs', 'H20163326', 3, '', 'bzdw_h', 'zxdw_d', 6, 'jldw_g', 0.15, '0.15g*6袋/盒', 'kf', 0.3000, '', '', 'mr3c', 1, 0.0000, 16.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 10:23:28', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2391, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000312', 'ycxsytwyld', '一次性使用体外引流袋', 'sccj_nbgr', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '1000ml', '', 0.0000, '', 'ml', '', 1, 1.3200, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2401, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_kfy', 'ZKM00000271', 'axtlkfry(ytj)', '氨溴特罗口服溶液(易坦静)', 'sccj_bjhmypyxgs', 'h20040317', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 100.00, '100.00ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 22.3800, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-19 12:45:01', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2411, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000536', 'zdbcsdsjh', '总蛋白测试定试剂盒', 'sccj_glyltyldzyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '45ml*6', '', 0.0000, '', 'ml', '', 1, 78.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2421, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001684', 'ysaxszsy（mst）', '盐酸氨溴索注射液（沐舒坦）', 'sccj_shbl', 'J20140032', 3, '', 'bzdw_h', 'zxdw_z', 5, 'jldw_ml', 2.00, '2.00ml*5支/盒', '', 0.0000, '', '', '', 2, 0.0000, 5.5700, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2431, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_sj_2', 'ZKM00001681', 'sqgjslhjs（xpfk）', '双歧杆菌三联活菌散（小培菲康）', 'sccj_shsyxyycyxgs(yshxyycyxgs)', 'S10970105', 3, '', 'bzdw_h', 'zxdw_b', 6, 'jldw_g', 1.00, '1.00g*6包/盒', 'kf', 1.0000, '', '', 'mr3c', 1, 0.0000, 14.7900, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 14:14:21', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2441, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000652', 'zgc', '炙甘草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.1460, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 17:46:25', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2451, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000733', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'TR-13(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2461, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000981', 'ycxsyzkcxg', '一次性使用真空采血管', 'sccj_jskjylypyxgs', '苏械注准20152411361', 3, '', 'jjdw_z', '', 1, '', 0.00, '2ml血常规紫色', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-29 11:48:21', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2471, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000732', 'yjjyz', '牙胶尖压针', 'sccj_xnddsb', '国食药监械（进）字2013第1551335', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm混', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 10:03:35', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2481, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001405', 'yyfsl', '医用凡士林', 'sccj_sdaj', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '400g*40瓶/件', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2491, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_fzj', 'ZKM00000294', 'zsynjm', '注射用尿激酶', 'sccj_whrfyyyxzrgs', '', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_wdw', 10.00, '10万单位*1支/支', '', 0.0000, '', '', '', 1, 23.8000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 11:25:16', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2501, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001429', 'fxlwp（lzf）', '泛昔洛韦片（丽珠风）', 'sccj_lzjtlzzyc', '国药准字H19991075', 3, '', 'bzdw_h', 'zxdw_p', 6, 'jldw_g', 0.25, '0.25g*6片/盒', 'kf', 0.2500, '', '', 'mr3c', 1, 0.0000, 35.7000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 5, NULL, '2018-05-24 15:18:28', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2511, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00001603', 'qxsymsfkfy', '氢溴酸右美沙芬口服液', 'sccj_zhlbzy', '61104429', 3, '', 'bzdw_p', 'zxdw_ml', 120, 'jldw_mg', 180.00, '180.00mg*120ml/瓶', '', 0.0000, '', '', '', 1, 0.0000, 29.8000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2521, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001701', '50％  pttzsy', '50％  葡萄糖注射液', 'sccj_rs', 'H41020039', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 20.00, '20.00ml*1支/支', 'jmdz', 0.0000, '', '', '', 1, 0.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 2, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2531, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000601', 'cjjs', '炒荆芥穗', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.1090, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-24 11:39:19', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2541, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000581', 'qtbytz', '嵌体备牙套装', 'sccj_shdb', '无', 3, '', 'jjdw_t', '', 1, '', 0.00, 'FG1112D', '', 0.0000, '', 'ml', '', 1, 0.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2551, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001753', 'axzp', '奥硝唑片', 'sccj_zjasyyyxgs', '国药准字h20051077', 3, '', 'bzdw_h', 'zxdw_p', 12, 'jldw_g', 0.25, '0.25g*12片/盒', '', 0.0000, '', '', '', 1, 0.0000, 12.0800, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2561, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000663', 'jdl', '锦灯笼', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.5610, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2571, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001239', 'xtcsy	', '血糖测试仪	', 'sccj_akswjs（hz）yxgs		', '-', 3, '', 'jjdw_t_148', '', 1, '', 0.00, '艾科灵睿2', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2581, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_wj', 'ZKM00000185', 'lsw', '六神丸', 'sccj_lysyyjtyxgs(ylysyyyxgs)', 'z32020481', 3, '', 'bzdw_h', 'zxdw_z', 12, 'jldw_l', 10.00, '10.00粒*12支/盒', '', 0.0000, '', '', '', 1, 29.0000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:24:16', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2591, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000082', 'glktp（tsp）', '格列喹酮片（糖适片）', 'sccj_bjwhshyyyxzrgs', '', 3, '', 'bzdw_p', 'zxdw_p', 60, 'jldw_mg', 30.00, '30mg*60片/瓶', '', 0.0000, '', '', '', 1, 65.0400, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 11:27:52', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2601, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001815', 'mlstnp（sen）', '孟鲁司特钠片（顺尔宁）', 'sccj_hzmsdzyyxgs', 'J20130047', 3, '', 'bzdw_h', 'zxdw_p', 5, 'jldw_mg', 10.00, '10.00mg*5片/盒', 'kf', 10.0000, '', '', 'mr1c', 1, 0.0000, 36.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2611, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000251', 'fhyazsy', '酚磺乙胺注射液', 'sccj_tjjyjthbtyyygfyxgs', 'H42020039', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_ml', 2.00, '2.00ml*10支/盒', '', 0.0000, '', '', '', 2, 15.0000, 1.3000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-22 17:07:59', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2621, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00000456', 'nxmfdzzkp（zc）', '凝血酶非定值质控品（正常）', 'sccj_shtyswjsyxgs', '', 3, '', 'jjdw_f_9562', '', 1, '', 0.00, '10*10ml', '', 0.0000, '', 'ml', '', 1, 39.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-10 21:34:58', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2631, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001846', 'sxckb', '手写触控笔', 'sccj_amzyc', NULL, 3, '', 'bzdw_z', 'zxdw_z', 1, '', 0.00, '1支/支', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2641, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001676', 'kxsxwkfx', '可吸收性外科缝线', 'sccj_sdrhtyyyxgs', '-', 3, '', 'jjdw_b', '', 1, '', 0.00, '包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2651, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000828', 'ycxsyssb', '一次性使用手术包', 'sccj_EA', '-', 3, '', 'jjdw_t', '', 1, '', 0.00, '无', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2661, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001371', 'lzf', '灵芝粉', 'sccj_trt', '', 3, '', 'bzdw_d', 'zxdw_kg_g', 3, 'jldw_g', 3.00, '3g/袋', '', 3.0000, '', '', '', 1, 9.0000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2671, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00001498', 'gysmsbljn', '枸橼酸莫沙必利胶囊', 'sccj_shsyxyycyxgs(yshxyycyxgs)', '国药准字H20051719', 3, '', 'bzdw_h', 'zxdw_l', 28, 'jldw_mg', 5.00, '5.00mg*28粒/盒', '', 0.0000, '', '', '', 1, 25.5000, 25.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-25 14:17:21', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2681, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001084', 'ggc', '根管锉', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, 'MANIK-FILES8#-25mm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-29 16:53:14', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2691, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rgj', 'ZKM00001686', 'ffldkyrg', '复方利多卡因乳膏', 'sccj_tfyyjt', 'H9990265', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 10.00, '10.00g*1支/支', '', 0.0000, '', '', '', 1, 0.0000, 49.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2701, 'bgyplb_ycxcl', 3, 1, 'bgyplb_ycxcl', '', 'ZKM00001736', 'ylljd70L', '医疗垃圾袋70L', 'sccj_amzyc', NULL, 3, '', 'bzdw_b_9933', 'zxdw_b_1129', 1, '', 0.00, '1把/把', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2711, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000340', '（jz）zxq', '（金钟）止血钳', 'sccj_shylqx（jt）yxgsssqxc', '', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'J3102012.5CM蚊式弯全齿', '', 0.0000, '', 'ml', '', 1, 55.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2721, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001077', 'qxxwpfhdmqjj', '全效型无泡复合多酶清洁剂', 'sccj_w', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '988-0436,5L', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2731, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001453', 'sb	', '烧杯	', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2741, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_klj', 'ZKM00001592', 'gmqrkl', '感冒清热颗粒', 'sccj_trt', '17110565', 3, '', 'bzdw_h', 'zxdw_d', 12, 'jldw_g', 12.00, '12.00g*12袋/盒', '', 0.0000, '', '', '', 1, 13.8000, 12.0500, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-05-21 14:30:10', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2751, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000907', 'csq', '炒神曲', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0500, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2761, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001080', 'myd', '灭蝇灯', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 550.0000, 550.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2771, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rgj', 'ZKM00001621', 'slfseyarg', '双氯芬酸二乙胺乳膏', 'sccj_bjnhzyyxgs', 'VP1173', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 20.00, '20.00g*1支/支', '', 0.0000, '', '', '', 1, 0.0000, 20.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2781, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000184', 'yyljt', '医用垃圾桶', 'sccj_bjjrkkjyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '30L', '', 0.0000, '', 'ml', '', 1, 58.0000, 0.0000, 'fylb_qt', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-12 13:14:46', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2791, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001520', 'xtycxz', '血糖仪采血针', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_t_7475', '', 1, '', 0.00, '条', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2801, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001325', 'yszyfsxp', '盐酸左氧氟沙星片', 'sccj_hndnzy', 'h20057425', 3, '', 'bzdw_h', 'zxdw_p', 24, 'jldw_g', 0.10, '0.10g*24片/盒', '', 0.0000, '', '', '', 1, 9.5000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:31:39', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2811, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000617', 'sjz', '使君子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0330, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2821, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001601', 'zjz 0.25*60mm', '针灸针 0.25*60mm', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2831, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000988', 'ebkpmjzsbz', '恩柏克牌灭菌指示包装', 'sccj_w', '-', 3, '', 'jjdw_j', '', 1, '', 0.00, '75mm*200m', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-29 17:08:18', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2841, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001604', 'zjzth 0.25*75mm', '针灸针套盒 0.25*75mm', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2851, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000691', 'hjh', '化橘红', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0300, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2861, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001232', 'xdjp	', '心电极片	', 'sccj_shjk', '-', 3, '', 'jjdw_p_10962', '', 1, '', 0.00, '50片/包上海励图', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2871, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000803', 'jmy', '焦麦芽', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0450, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2881, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000340', 'fmQ10jn', '辅酶Q10胶囊', 'sccj_gdhnyyjtyxgs', '', 3, '', 'bzdw_h', 'zxdw_l', 30, 'jldw_mg', 10.00, '10.00mg*30粒/盒', '', 0.0000, '', '', '', 1, 7.2900, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2891, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000518', 'jhsbtstp（msl）', '甲磺酸倍他司汀片（敏使朗）', 'sccj_wc（zg）yyyxgs', 'H20040130', 3, '', 'bzdw_h', 'zxdw_p', 30, 'jldw_mg', 6.00, '6.00mg*30片/盒', 'ad us.int', 12.0000, '', '', 'TID', 1, 12.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 2, NULL, '2018-03-02 16:52:09', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2901, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000867', 'hft', '海风藤', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0780, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 10:55:16', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2911, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001679', 'BC EDzkp', 'BC ED质控品', 'sccj_szmr', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2921, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000244', 'pttzsy', '葡萄糖注射液', 'sccj_hnskhyygfyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 5, 'jldw_ml', 20.00, '20ml*5支/盒', '', 0.0000, '', '', '', 1, 1.7000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 14:58:19', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2931, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000766', 'qkwktp', '全口无孔托盘', 'sccj_rxckclyxgs', '沪食药监械生产许可20000061号', 3, '', 'jjdw_ge', '', 1, '', 0.00, '3#下', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2941, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001307', 'ycxslsg', '一次性塑料试管', 'sccj_jskjylqxyxgs		', '-', 3, '', 'jjdw_b', '', 1, '', 0.00, '12*100mmPE，500支/包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2951, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000663', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'SR-13(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-04-08 10:44:01', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2961, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000371', 'rtc', '人体秤', 'sccj_shyl', '', 3, '', 'jjdw_t_148', '', 1, '', 0.00, 'RGZ-120', '', 0.0000, '', 'ml', '', 1, 230.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2971, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001433', 'fhz', '缝合针', 'sccj_hzhw		', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '角头带针不可吸收缝合针5.0，40包/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2981, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000410', 'ycxsyjmglsyq  dz', '一次性使用精密过滤输液器  带针', 'sccj_tjhnhycyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, 'YQ-512-06APD0.6*20(双翼）', '', 0.0000, '', 'ml', '', 1, 4.5000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (2991, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000703', 'tmjzq', '透明结扎圈', 'sccj_xnddsb', '--', 3, '', 'jjdw_d', '', 1, '', 0.00, 'S型', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3001, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000719', 'jykkz', '机用扩孔钻', 'sccj_MANI', '--', 3, '', 'jjdw_h', '', 1, '', 0.00, 'P28mm-4', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3011, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000262', 'pttlhnzsy(5%)', '葡萄糖氯化钠注射液(5%)', 'sccj_scklyygfyxgs', '', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 500.00, '500ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 1.3000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 15:03:41', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3021, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000257', 'dxsyslzp', '单硝酸异山梨酯片', 'sccj_cxyygfyxgs', 'h2006014', 3, '', 'bzdw_h', 'zxdw_p', 48, 'jldw_mg', 20.00, '20.00mg*48片/盒', '', 0.0000, '', '', '', 1, 9.2700, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 08:35:13', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3031, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000311', 'ycxsyssy', '一次性使用手术衣', 'sccj_ksjsyyzpyxgs', '', 3, '', 'jjdw_j_8137', '', 1, '', 0.00, 'L码（120*185cm）30件/箱无纺布SMMS', '', 0.0000, '', 'ml', '', 1, 12.5000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 15:39:48', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3041, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsp', 'ZKM00000034', 'ceshi123', 'ceshi123', 'sccj_bjsykyy', '', 3, '', 'bzdw_p_1730', 'zxdw_p', 1, 'jldw_g', 1.00, '1.00g*1片/片', '', 0.0000, '', '', '', 1, 0.0000, 12.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3051, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rj', 'ZKM00001882', 'ysjpky/ssxszsy', '盐酸甲哌卡因/肾上腺素注射液', 'sccj_fgBeaufour Ipsen Industrie', 'h20171134', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 1.80, '1.8ml*1支/支', '', 0.0000, '', '', '', 1, 0.0000, 7.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3061, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000294', 'ycxsywjm（kmmz）ztmz', '一次性使用无菌帽（康民帽子）直筒帽子', 'sccj_xxskmylqxyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '30克直筒手工净边', '', 0.0000, '', 'ml', '', 1, 0.2500, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-13 09:24:48', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3071, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000946', 'NTIkcdbl', 'NTI烤瓷刀边轮', 'sccj_w', '-', 3, '', 'jjdw_z_5693', '', 1, '', 0.00, '银灰色', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3081, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000985', 'ycxsykqqxh', '一次性使用口腔器械盒', 'sccj_w', '-', 3, '', 'jjdw_x', '', 1, '', 0.00, 'KQH-III', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3091, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000912', 'bxgytp（jb）', '不锈钢牙托盘（局部）', 'sccj_w', '-', 3, '', 'jjdw_f', '', 1, '', 0.00, '边口', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3101, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001421', 'yyljd', '医用垃圾袋', 'sccj_bjkylsmyxgs		', '-', 3, '', 'jjdw_k', '', 1, '', 0.00, '30L58*70*2.5S', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3111, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000786', 'xtsz（ptttqmf）', '血糖试纸（葡萄糖脱氢酶法）', 'sccj_Roche Diabetes Care GmbH', '20162402313', 3, '', 'jjdw_h', '', 1, '', 0.00, '50人份/盒', '', 0.0000, '', 'ml', '', 1, 185.0000, 185.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 14:04:18', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3121, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001265', 'hm', '槐米', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0680, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3131, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000346', 'xg', '吸管', 'sccj_jskdylypyxgs', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '160mm500ui滴量PE，500支', '', 0.0000, '', 'ml', '', 1, 15.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3141, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_klj', 'ZKM00000069', 'yqjdkl', '银翘解毒颗粒', 'sccj_scfczyyxgs', '国药准字Z51020135', 3, '', 'bzdw_d', 'zxdw_d', 20, 'jldw_g', 15.00, '15.00g*20袋/袋', '', 0.0000, '', '', '', 1, 10.3000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 08:42:22', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3151, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001650', 'ggctq（czjyq-st）', '根管充填器（垂直加压器-双头）', 'sccj_w', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '把', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3161, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001350', 'gymjhxzsk', '高压灭菌化学指示卡', 'sccj_3M', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '3M', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3171, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001384', 'xpczq', '镶片持针器', 'sccj_shylqx（jt）yxgsssqxc		', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '12.5cm直细针0.3（圆腮）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3181, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000728', 'pht', '普黄碳', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 0.0000, '', '', '', 1, 0.4830, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3191, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001320', 'ycxxcb', '一次性胸穿包', 'sccj_fstz', '-', 3, '', 'jjdw_b', '', 1, '', 0.00, '佛山特种,16*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3201, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001090', 'hsstjhb', '红色双头记号笔', 'sccj_amzyc', '', 3, '', 'bzdw_h', 'zxdw_z', 12, '', 0.00, '12支/盒', '', 0.0000, '', 'ml', '', 2, 1.1500, 1.1500, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-03-01 15:53:48', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3211, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001092', 'twq', '剔挖器', 'sccj_w', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '八角柄整体型式E6', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3221, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000236', 'ycxsygzq', '一次性使用灌注器', 'sccj_szwkylqxyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '80ML', '', 0.0000, '', 'ml', '', 1, 6.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3231, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000161', 'bxgfp', '不锈钢方盘', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '11寸', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3241, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001338', 'lj', '鹿角', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 1.2320, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3251, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000305', 'ycxzsqdz', '一次性注射器带针', 'sccj_shkdlqyfzjtgfyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '50ml', '', 0.0000, '', 'ml', '', 1, 1.1000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3261, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000724', 'Z350XTgghnmsz', 'Z350XT光固化纳米树脂', 'sccj_3MESPE DENTAL PRODUCT', '--', 3, '', 'jjdw_z', '', 1, '', 0.00, '7018(A3)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3271, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001560', 'tb', '台笔', 'sccj_amzyc', NULL, 3, '', 'bzdw_z', 'zxdw_z', 1, '', 0.00, '1支/支', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3281, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000873', 'bdg', '北豆根', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1010, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 10:57:26', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3291, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_hsp', 'ZKM00000042', 'cs123', '测试123', 'sccj_hrsj', '123', 3, '', 'bzdw_g_cldw', 'zxdw_h', 1, 'jldw_g', 1.00, '1.00g*1盒/g', '', 0.0000, '', '', '', 1, 0.0000, 1.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3301, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000966', 'yxy', '银杏叶', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0500, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3311, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_hsp', 'ZKM00000040', 'pcx', '平常心', 'sccj_hrsj', '111111', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', '', '', 1, 0.0000, 111.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3321, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001107', 'ycxsywjzsqdz', '一次性使用无菌注射器带针', 'sccj_scslylqxyxgs', '国械注准20143152281', 3, '', 'jjdw_h', '', 1, '', 0.00, '30ml1.2*30', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-06 10:07:52', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3331, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000140', 'fhz', '缝合针', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_d', '', 1, '', 0.00, '0型6*14', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3341, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00001561', 'zjexmx', '针灸耳穴模型', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3351, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000986', 'hj', '花椒', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.3360, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3361, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001474', 'sgwjk', '四格文件筐', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3371, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001318', 'ycxyqmz', '一次性氧气面罩', 'sccj_wl', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '可调带2色调节管M（儿童）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3381, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000517', 'allsnp（fsm）', '阿仑膦酸钠片（福善美）', 'sccj_hzmsdzyyxgs', 'J20130085', 3, '', 'bzdw_h', 'zxdw_p', 1, 'jldw_mg', 70.00, '70.00mg*1片/盒', 'ad us.int', 0.0000, '', '', '', 1, 58.4900, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 2, 1, NULL, '2018-03-01 17:12:30', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3391, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001193', 'mxsxy（nj）', '免洗手消液（凝胶）', 'sccj_shjzylqxbzgfyxgs		', '-', 3, '', 'jjdw_p_10962', '', 1, '', 0.00, '100片/瓶杭州朗索', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3401, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000239', 'yytxbd', '医用弹性绷带', 'sccj_ajhjylqxyxgs', '', 3, '', 'jjdw_k_7001', '', 1, '', 0.00, '10*450CM', '', 0.0000, '', 'ml', '', 1, 2.5000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3411, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000987', 'ebkpmjzsbz', '恩柏克牌灭菌指示包装', 'sccj_w', '-', 3, '', 'jjdw_j', '', 1, '', 0.00, '55mm*200m', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3421, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001349', 'zwxjczsk', '紫外线监测指示卡', 'sccj_bjsh', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '北京四环,100片/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3431, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001211', 'sbj', '生鳖甲', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.4260, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3441, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000637', 'yjj', '牙胶尖', 'sccj_dsbyk（tj）yxgs', '--', 3, '', 'jjdw_h', '', 1, '', 0.00, '120*1（混）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3451, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001476', 'gysz（TG）cdsjh	', '甘油三酯（TG）测定试剂盒	', 'sccj_szmr', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3461, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000634', 'xcg', '萱草根', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0340, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3471, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000493', 'zszkcxg', '紫色真空采血管', 'sccj_jskjylqxyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '13*75mm2ml', '', 0.0000, '', 'ml', '', 1, 0.5000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3481, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000962', 'scz', '蛇床子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2020, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3491, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00001697', 'mlcbppg（jdnca）', '蜜炼川贝枇杷膏（京都念慈庵）', 'sccj_jdncazc', 'ZC20160005', 3, '', 'bzdw_p', 'zxdw_ml', 150, 'jldw_mg', 1.00, '1.00mg*150ml/瓶', 'kf', 10.0000, '', '', 'mr3c', 1, 0.0000, 21.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 10:14:50', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3501, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsp', 'ZKM00000049', 'kcxy1', '库存西药1', 'sccj_hs/zyyxgs', '232', 3, '', 'bzdw_h', 'zxdw_p_1', 3, 'jldw_mm', 188.00, '188.00mm*3瓶/盒', '', 0.0000, '', '', '', 1, 0.0000, 10.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3511, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000862', 'jbs', '酒白芍', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1570, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3521, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rj', 'ZKM00001878', 'kcgjelhjcrjn（mca）', '枯草杆菌二联活菌肠溶胶囊（美常安）', 'sccj_bjhmypyxgs', '国药准字s20030087', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_mg', 250.00, '250mg*20片/盒', '', 0.0000, '', '', '', 1, 0.0000, 22.4300, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3531, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000859', 'kc', '苦参', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1120, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3541, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000596', 'Kc', 'K锉', 'sccj_xnddsb', '国械备20170214号', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm-40', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3551, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_xry', 'ZKM00001500', 'jqmz（sz）', '甲巯咪唑（赛治）', 'sccj_mkzy（js）yxgs', 'J20160064', 3, '', 'bzdw_h', 'zxdw_p', 50, 'jldw_hk', 10.00, '10.00毫克*50片/盒', 'ad us.int', 10.0000, '', '', 'TID', 1, 33.1000, 46.3400, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3561, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_hsp', 'ZKM00000050', 'kczcy1', '库存中成药1', 'sccj_nmgsqyygfyxgs', '1111', 3, '', 'bzdw_d', 'zxdw_l', 3, 'jldw_g', 122.00, '122.00g*3粒/袋', '', 0.0000, '', '', '', 1, 0.0000, 10.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3571, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000808', 'ycxsywjyycxq', '一次性使用无菌牙龈冲洗器', 'sccj_sdxhylqxgfyxgs', '鲁械注准20172660144', 3, '', 'jjdw_g', '', 1, '', 0.00, 'CXQ-1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3581, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000509', 'yxzyt', '圆形针眼贴', 'sccj_ntyj', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '2*2cm', '', 0.0000, '', 'ml', '', 1, 0.7000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3591, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000609', 'Hc', 'H锉', 'sccj_xnddsb', '国械备20170214号', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm-15', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3601, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000995', 'ar', '艾绒', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/支', '', 10.0000, '', '', '', 1, 0.0340, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3611, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000010', 'xeqfhtkfy', '小儿清肺化痰口服液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3621, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000020', 'zcyerg', '紫草婴儿软膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3631, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000030', 'xeqfhtkfy', '小儿清肺化痰口服液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3641, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZDS90000040', 'jszhp', '金嗓子喉片', 'sccj_gxjszyxgs', 'B20020993', 3, '', 'bzdw_h', 'zxdw_p', 12, 'jldw_g', 2.00, '2.00g*12片/盒', '', 0.0000, '', 'ml', '', 1, 6.2850, 2.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, '2017-07-13 00:00:00', '2018-04-24 17:18:26', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3651, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_qt', 'ZDS90000050', 'yfsxdey（tlbt)', '氧氟沙星滴耳液（泰利必妥)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-02-06 17:16:29', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3661, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000060', 'gjwjn', '骨筋丸胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3671, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000070', 'allsnp(fsm)', '阿仑膦酸钠片(福善美)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3681, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000080', 'scryjn(abd)', '双醋瑞因胶囊(安必丁)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3691, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000090', 'rpxjn', '乳癖消胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3701, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000100', 'jwymcg', '加味益母草膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3711, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000110', 'gxnjn', '宫血宁胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3721, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000120', 'fkbdg', '妇科白带膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3731, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000130', '@xqydsjn(ysf)', '@熊去氧胆酸胶囊(优思弗)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3741, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000140', 'dsjn', '胆舒胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3751, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000150', 'etkwfsp', '恩替卡韦分散片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3761, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_w', 'ZDS90000160', 'txlfw', '通宣理肺丸', 'sccj_bjtrtkjfzgfyxgszyc', '17015241', 3, '', 'bzdw_h', 'zxdw_w', 10, 'jldw_g', 6.00, '6.00g*10丸/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 11.8000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-11 09:43:56', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3771, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000170', 'ffafwap(gk)', '复方氨酚烷胺片(感康)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3781, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000180', 'ffzlp', '复方紫龙片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3791, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000190', 'ktljn', '咳特灵胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3801, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000200', 'fnp', '肺宁片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3811, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000210', 'blfhsjn', '布洛芬缓释胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1.00g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-02-09 17:01:17', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3821, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000220', 'slfsnhsjn(ytq)', '双氯芬酸钠缓释胶囊(英太青)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3831, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000230', 'bnzp', '贝诺酯片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3841, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_qt', 'ZDS90000240', 'aqmsp', '阿奇霉素片', 'sccj_hrzy', 'H10960167', 3, '', 'bzdw_h', 'zxdw_p', 6, 'jldw_g', 0.25, '0.25g*6片/盒', 'ad us.int', 0.2500, '', 'ml', 'qd', 1, 41.7300, 1.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 4, '2017-07-13 00:00:00', '2018-04-08 11:22:42', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3851, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000250', 'amxljn（lbamx）', '阿莫西林胶囊（联邦阿莫仙）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3861, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_qt', 'ZDS90000260', 'amxljn(lbamx)', '阿莫西林胶囊(联邦阿莫仙)', 'sccj_zhlbzy', 'H20003263', 3, '', 'bzdw_h', 'zxdw_l', 24, 'jldw_g', 0.25, '0.25g*24粒/盒', 'ad us.int', 0.5000, '', 'ml', 'TID', 1, 18.1400, 1.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 3, '2017-07-13 00:00:00', '2018-03-09 16:30:43', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3871, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000270', 'lzbzfjn', '灵芝孢子粉胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3881, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000280', 'csdsmsztp(ykt*)', '醋酸地塞米松粘贴片(意可贴*)', 'sccj_bjhlzyyxgs', 'H19991372', 3, '', 'bzdw_h', 'zxdw_p', 5, 'jldw_mg', 0.30, '0.30mg*5片/盒', '', 0.0000, '', 'ml', '', 1, 16.9900, 1.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-04-04 16:03:12', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3891, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000290', 'jqckl', '金钱草颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/袋', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3901, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000300', 'fnxap(blz)', '非那雄胺片(保列治)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3911, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000310', 'sysp', '肾炎舒片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3921, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000320', 'gqxkjn', '枸杞消渴胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3931, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000330', 'dgkcw', '当归苦参丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3941, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000340', 'ynbyckt（qqhyx）', '云南白药创可贴（轻巧护翼型）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3951, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000350', 'ffpzhrg', '复方片仔癀软膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3961, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rgj', 'ZDS90000360', 'srssg', '湿润烧伤膏', 'sccj_stsmbzyyxgs', '国药准字Z20000004', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 40.00, '40.00g*1支/支', '', 0.0000, '', 'ml', '', 1, 72.0000, 100.8000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 1, '2017-07-13 00:00:00', '2018-04-08 15:01:13', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3971, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000370', 'zgs', '足光散', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3981, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000380', 'lzrg', '龙珠软膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (3991, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000390', 'ystbnfpwj', '盐酸特比萘芬喷雾剂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4001, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000400', 'xsjkl', '夏桑菊颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/袋', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4011, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000410', 'hyd', '护腰带', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4021, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000420', 'ysbhrzp(fsl)', '盐酸苯环壬酯片(飞赛乐)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4031, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000430', 'bldjnjn(skl)', '胞磷胆碱钠胶囊(思考林)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4041, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000440', 'sgjyjn', '舒肝解郁胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4051, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000450', 'ltsmp（dx）', '铝碳酸镁片（达喜）', 'sccj_beyybjyxgsfz', 'H20013410', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_g', 0.50, '0.50g*20片/盒', 'jf', 0.5000, '', 'ml', 'mr3c', 1, 17.4300, 28.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-24 15:20:32', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4061, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000460', 'amlzcrjn（dnlk）', '奥美拉唑肠溶胶囊（迪诺洛克）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4071, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_klj', 'ZDS90000470', 'sjwtkl', '三九胃泰颗粒', 'sccj_hrsj', 'z44020705', 3, '', 'bzdw_h', 'zxdw_d', 6, 'jldw_g', 20.00, '20.00g*6袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 8.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-23 14:43:23', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4081, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000480', 'gysmsblfsp(xln)', '枸橼酸莫沙必利分散片(新络纳)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1.00g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-02-09 16:54:44', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4091, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000490', 'asamlzmcrp', '艾司奥美拉唑镁肠溶片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4101, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000500', 'asplcrp(baspl)', '阿司匹林肠溶片(拜阿司匹灵)', 'sccj_beyybjyxgsfz', 'J20171021', 3, '', 'bzdw_h', 'zxdw_p', 30, 'jldw_g', 0.10, '0.10g*30片/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 15.5100, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-22 17:14:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4111, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000510', 'trnhqxw', '同仁牛黄清心丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4121, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000520', 'ztw', '正天丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4131, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000530', 'xstjn（dw）', '缬沙坦胶囊（代文）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4141, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000540', 'ysfglqjn(xbl)', '盐酸氟桂利嗪胶囊(西比灵)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4151, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000550', 'dttfhwjn(lfn)', '多糖铁复合物胶囊(力蜚能)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4161, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dyj', 'ZDS90000560', 'axlwdyy', '阿昔洛韦滴眼液', 'sccj_whwjyyyxgs', 'h42021090', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 8.00, '8.00ml*1支/支', '', 0.0000, '', 'ml', '', 1, 3.2000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-24 09:07:44', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4171, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000570', 'gxlwdyy', '更昔洛韦滴眼液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4181, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000580', 'xdhqdyy', '熊胆黄芩滴眼液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4191, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000590', 'znxgjpfl', '自粘性硅胶片敷料', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4201, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000600', 'lhjhsp(bdx)', '氯化钾缓释片(补达秀)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4211, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000610', 'pttfj', '葡萄糖粉剂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/袋', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4221, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000620', 'cmkl', '参麦颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4231, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000630', 'ynkl', '夜宁颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4241, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000640', 'czsfp', '除脂生发片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4251, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000008', 'ycxdssyq', '一次性袋式输液器', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '7号针头', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4261, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000018', 'sl', '砂轮', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4271, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000028', 'ycxwjrjst', '一次性无菌乳胶手套', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '一箱400双', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4281, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000038', 'ycxysb', '一次性压舌板', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '100片每包', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4291, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000048', 'xdyyxljysz', '消毒液有效氯检验试纸', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4301, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000058', 'cnj：jhm', '促凝剂：桔红帽', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '100支每盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4311, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000068', 'yknkjbhm', '牙科内窥镜保护膜', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '100个每盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4321, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000078', 'zzjcslqsg', '种植机冲输冷却水管', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '20个/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4331, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000088', 'cxp', '成型片', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '20片/包', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4341, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000098', 'wp', '弯盘', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4351, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000108', 'byt（ydccy)', '避孕套（阴道彩超用)', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4361, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000009', 'dg', '当归', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4371, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000019', 'bs', '白芍', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4381, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000029', 'zych', '竹叶柴胡', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4391, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000039', 'zgc', '炙甘草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4401, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000049', 'cszr', '炒酸枣仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4411, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000059', 'ctr', '燀桃仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4421, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000069', 'dk', '豆蔻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4431, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000079', 'dz', '大枣', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4441, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000089', 'swt', '首乌藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4451, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000099', 'md', '麦冬', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4461, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000109', 'jxt', '鸡血藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4471, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000119', 'xc', '玄参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4481, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000129', 'wg', '蜈蚣', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4491, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000139', 'cyhs', '醋延胡索', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4501, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000149', 'gyxc', '干鱼腥草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4511, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000159', 'ml', '牡蛎', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4521, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000169', 'xy', '辛夷', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4531, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000179', 'zyz', '制远志', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4541, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000189', 'cszr', '炒酸枣仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4551, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000199', 'sr', '砂仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4561, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000209', 'hb', '黄柏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4571, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000219', 'sz', '山楂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4581, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000229', 'ay', '艾叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4591, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000239', 'es', '莪术', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4601, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000249', 'jxm', '酒仙茅', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4611, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000259', 'rdt', '忍冬藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4621, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000269', 'wy', '乌药', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4631, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000279', 'dg', '当归', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4641, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000289', 'yyh', '淫羊藿', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4651, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000299', 'fbx', '法半夏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4661, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000309', 'zsg', '紫苏梗', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4671, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000319', 'bx', '萆薢', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4681, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000329', 'jg', '桔梗', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4691, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000339', 'fccp', '麸炒陈皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4701, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000349', 'mhd', '木蝴蝶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4711, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000359', 'msbp', '蜜桑白皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4721, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000369', 'cmjz', '炒蔓荆子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4731, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000379', 'pl', '佩兰', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4741, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000389', 'wlx', '威灵仙', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4751, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000399', 'zz', '栀子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4761, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000409', 'zs', '赭石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4771, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000419', 'xd', '续断', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4781, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000429', 'bjc', '败酱草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4791, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000439', 'sjs', '桑寄生', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4801, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000449', 'mb', '马勃', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4811, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000459', 'llt', '路路通', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4821, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000469', 'gcp', '甘草片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4831, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000479', 'jqm', '金荞麦', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4841, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000489', 'yj', '郁金', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4851, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000499', 'cjc', '炒僵蚕', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4861, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000509', 'cnx', '川牛膝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4871, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000519', 'cjz', '炒芥子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4881, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000529', 'crx', '醋乳香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4891, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000539', 'dgp', '冬瓜皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4901, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000549', 'nmtg', '糯米藤根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4911, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000559', 'lz', '灵芝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4921, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000569', 'fwrdk', '麸煨肉豆蔻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4931, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000579', 'dz', '杜仲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4941, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000589', 'bx', '萹蓄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4951, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000599', 'fs', '茯神', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4961, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000609', 'dzs', '煅赭石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4971, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000619', 'cmt', '川木通', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4981, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000629', 'xx', '细辛', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (4991, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000639', 'sjm', '石决明', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5001, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000649', 'adc', '矮地茶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5011, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000659', 'fg', '粉葛', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5021, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000669', 'yyz', '盐益智', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5031, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000679', 'dzy', '淡竹叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5041, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000689', 'bh', '百合', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5051, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000699', 'xy', '香橼', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5061, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000709', 'hhh', '合欢花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5071, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000719', 'gsh', '干石斛', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5081, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000729', 'ccez', '炒苍耳子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5091, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000739', 'dy', '稻芽', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5101, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000749', 'yjcz', '盐韭菜子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5111, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000759', 'zbfz', '制白附子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5121, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000769', 'thf', '天花粉', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5131, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000779', 'jh', '菊花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5141, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000789', 'bmg', '白茅根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5151, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000799', 'jxm', '酒仙茅', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5161, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000809', 'zl', '泽兰', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5171, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000819', 'lzg', '芦竹根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5181, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000829', 'jdc', '酒丹参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5191, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000839', 'tgsb', '烫骨碎补', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5201, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000849', 'bh', '薄荷', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5211, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000859', 'cmc', '川明参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5221, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000869', 'mmh', '蜜麻黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5231, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000879', 'cjl', '炒蒺藜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5241, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000889', 'adc', '矮地茶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5251, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000899', 'lbmy', '罗布麻叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5261, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000909', 'bhssc', '白花蛇舌草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5271, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000919', 'hpx', '海螵蛸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5281, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000929', 'ccez', '炒苍耳子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5291, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000939', 'lz', '莲子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5301, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000949', 'lqc(tgx)', '连钱草(透骨消)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5311, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000959', 'jbx', '姜半夏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5321, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000969', 'bb', '荜茇', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5331, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000979', 'ysyz', '盐沙苑子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5341, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000989', 'gcp', '甘草片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5351, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000999', 'szr', '酸枣仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5361, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001009', 'ydtsz', '盐大菟丝子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5371, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001019', 'zmh', '炙麻黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5381, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001029', 'ztnx', '制天南星', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5391, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001039', 'bx', '萹蓄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5401, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001049', 'cdk', '草豆蔻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5411, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001059', '*td', '*天冬', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5421, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001069', 'rg', '肉桂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5431, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001079', 'fp', '浮萍', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5441, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001089', 'dx', '丁香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5451, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001099', 'slp', '石榴皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5461, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001109', 'dsjm', '煅石决明', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5471, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001119', 'dyqct', '大叶茜草炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5481, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001129', 'jhl', '酒黄连', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5491, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001139', 'zjc', '皂角刺', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5501, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001149', 'cwlz', '醋五灵脂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5511, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001159', 'dzrs', '煅钟乳石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5521, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001169', 'wm', '乌梅', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5531, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001179', 'xr', '香薷', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5541, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001189', 'hsw', '何首乌', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5551, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001199', 'hjt', '红景天', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5561, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001209', 'zhdd', '紫花地丁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5571, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001219', 'tsz', '烫水蛭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5581, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001229', 'jqc', '金钱草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5591, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001239', 'cay', '醋艾叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5601, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001249', 'cyyr', '炒薏苡仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5611, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001259', 'fbx', '法半夏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5621, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001269', 'fbx', '法半夏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5631, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001279', 'ec', '儿茶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5641, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001289', 'jst', '酒蛇蜕', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5651, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001299', 'zcw', '制川乌', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5661, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001309', 'bg（r）', '白果（仁）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5671, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001319', 'clfz', '炒莱菔子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5681, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001329', 'zzm', '珍珠母', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5691, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001339', 'xkc', '夏枯草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5701, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001349', 'qnj', '千年健', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5711, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001359', 'hdk', '红豆蔻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5721, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001369', 'ml', '牡蛎', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5731, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001379', 'dec', '地耳草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5741, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001389', 'sg', '石膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5751, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001399', 'xy', '香橼', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5761, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001409', 'bbl', '半边莲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5771, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001419', 'zm(r)', '知母(肉)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5781, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001429', 'yzm', '盐知母', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5791, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001439', 'mh', '麻黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5801, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001449', 'ckxr', '燀苦杏仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5811, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001459', 'yyh', '淫羊藿', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5821, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001469', 'sdg', '山豆根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5831, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001479', 'cxf', '醋香附', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5841, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001489', 'lz', '灵芝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5851, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001499', 'sjz', '使君子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5861, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001509', 'jbx', '姜半夏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5871, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001519', 'dxc', '灯心草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5881, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001529', 'kdc', '苦丁茶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5891, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001539', 'sy', '锁阳', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5901, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001549', 'cmx', '川木香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5911, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001559', 'zhq', '炙黄芪', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5921, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001569', 'ml', '牡蛎', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5931, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001579', 'sdg', '山豆根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5941, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001589', 'lxh', '凌霄花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5951, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001599', 'fl', '茯苓', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5961, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001609', 'yz', '玉竹', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5971, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001619', 'ydz', '盐杜仲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5981, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001629', 'bfp', '白附片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (5991, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001639', 'cp', '陈皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6001, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001649', 'bfp', '白附片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6011, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001659', 'ht', '淮通', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6021, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001669', 'fsm', '茯神木', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6031, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001679', 'nsc', '南沙参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6041, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001689', 'mhr', '麻黄绒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6051, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001699', 'hyz', '黄药子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6061, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001709', 'xyt', '血余炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6071, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001719', 'fccs', '麸炒苍术', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6081, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001729', 'jh', '菊花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6091, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001739', 'clfz', '炒莱菔子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6101, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001749', 'xxc', '豨莶草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6111, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001759', 'ytsz', '盐菟丝子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6121, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001769', 'bzhjs', '扁枝槲寄生', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6131, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001779', 'bp', '冰片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6141, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001789', 'lg', '芦根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6151, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001799', 'yqs', '阳起石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6161, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001809', 'ymz', '亚麻子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6171, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001819', 'dh(sd)', '地黄(生地)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6181, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001829', 'cxy', '炒辛夷', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6191, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001839', 'dsy', '煅石燕', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6201, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001849', 'jsz', '酒水蛭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6211, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001859', 'gc', '甘草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6221, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001869', 'dkg', '冬葵果', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6231, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001879', 'dyms', '煅云母石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6241, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001889', 'fz', '榧子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6251, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001899', 'cxl', '穿心莲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6261, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001909', 'cxf', '醋香附', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6271, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001919', 'ccp', '炒陈皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6281, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001929', 'jhp', '姜厚朴', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6291, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001939', 'cnbz', '炒牛蒡子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6301, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001949', 'qs', '芡实', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6311, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001959', 'ps', '硼砂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6321, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001969', 'dbsy', '煅白石英', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6331, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001979', 'cbt', '侧柏炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6341, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001989', 'jdc', '酒丹参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6351, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001999', 'ccs', '川赤芍', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6361, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002009', 'lft', '莱菔头', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6371, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002019', 'yspx', '盐桑螵蛸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6381, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002029', 'bfp', '白附片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6391, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002039', 'kf', '枯矾', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6401, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002049', 'jl', '橘络', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6411, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002059', 'kxr', '苦杏仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6421, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002069', 'thf', '天花粉', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6431, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002079', 'bgr', '白果仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6441, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002089', 'yyr', '薏苡仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6451, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002099', 'qbx', '清半夏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6461, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002109', 'bh', '百合', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6471, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002119', 'xwwz', '西五味子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6481, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002129', 'bbl', '半边莲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6491, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002139', 'bjc', '败酱草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6501, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002149', 'flp', '茯苓皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6511, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002159', 'bxq', '半夏曲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6521, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002169', 'ltj', '两头尖', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6531, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002179', 'jcnx', '酒川牛膝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6541, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002189', 'cwwz', '醋五味子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6551, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002199', 'rs', '人参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_1` VALUES (6561, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002209', 'hq', '黄芪', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
COMMIT;

-- ----------------------------
-- Table structure for drug_resource_2
-- ----------------------------
DROP TABLE IF EXISTS `drug_resource_2`;
CREATE TABLE `drug_resource_2` (
  `id` bigint unsigned NOT NULL DEFAULT '0' COMMENT '主键',
  `drug_res_type_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT ' 药品和物资类型ID(dw_drug_res_type.id)',
  `base_type` tinyint NOT NULL DEFAULT '0' COMMENT '物品类型：1-药品, 2-耗材, 3-办公用品',
  `status` int DEFAULT '1' COMMENT '药品状态: 0 - 停用, 1 - 使用',
  `type_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药品或者耗材类别的字典ID(dw_dictionary.id AND dw_dictionary.type_id=[yplb OR hclb])',
  `dict_dosage_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药品剂型的字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypjx)',
  `code` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '集团编码',
  `pym` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '拼音简码',
  `name` varchar(64) CHARACTER SET utf8 DEFAULT '' COMMENT '药品或者耗材的名称',
  `manufacturer_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '生产厂家的字典ID(dw_dictionary.id AND dw_dictionary.type_id=sccj)',
  `approval_no` varchar(100) CHARACTER SET utf8 DEFAULT NULL COMMENT '批准文号',
  `med_type` int DEFAULT '3' COMMENT '医保分类： 1 - 无自付, 2 - 部分自付, 3 - 全自付',
  `admin_code` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药监编码',
  `pack_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '包装单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypdw)',
  `min_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '最小单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypdw)',
  `pack_quantity` int DEFAULT '1' COMMENT '包装含量',
  `dosage_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '剂量单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=jldw)',
  `dosage_quantity` decimal(10,2) DEFAULT '0.00' COMMENT '剂量含量',
  `pack_spec` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '包装规格，生成规则：[剂量含量] [剂量单位] * [包装含量] [最小单位] / [包装单位]',
  `take_method_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '用法(默认用法)(dw_dictionary.id AND dw_dictionary.type_id=ypyf)',
  `take_quantity` decimal(36,4) DEFAULT '0.0000' COMMENT '用量(默认用量)',
  `take_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '用量单位字典ID - 暂留字典',
  `take_unit_name` varchar(36) CHARACTER SET utf8 DEFAULT 'ml' COMMENT '用量单位名称，默认ml',
  `take_frequency` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '频率(默认频率)(dw_dictionary.id AND dw_dictionary.type_id=yppl)',
  `common_unit_type` int DEFAULT '1' COMMENT '常规单位类型: 1 - 包装单位(packUnit), 2 - 最小单位(minUnit)',
  `purchase_price` decimal(8,4) DEFAULT '0.0000' COMMENT '进货价: 单位 元',
  `sale_price` decimal(8,4) DEFAULT '0.0000' COMMENT '基准价: 单位 元',
  `cost_category_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '费用类别字典ID(dw_dictionary.id AND dw_dicitionary.type_id=fylb)',
  `invoice_item_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '发票项目字典ID - 暂留',
  `expensive_flag` int DEFAULT '1' COMMENT '贵重物品标识： 0 - 非贵重物品， 1 - 贵重物品',
  `psy_flag_i` int DEFAULT '0' COMMENT ' 精神I类药品标识：0 - 非选中， 1 - 选中',
  `psy_flag_ii` int DEFAULT '0' COMMENT '精神II类药品标识：0 - 非选中，1 - 选中',
  `otc_flag` int DEFAULT '0' COMMENT 'OTC标识：0 - 非选中， 1 - 选中',
  `nar_flag` int DEFAULT '0' COMMENT '麻醉药品标识：0 - 非选中， 1 - 选中',
  `inventory_upper` int DEFAULT '0' COMMENT '库存上限',
  `inventory_lower` int DEFAULT '0' COMMENT '库存下限',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  `modify_time` datetime DEFAULT NULL COMMENT '修改时间',
  `del_flag` int DEFAULT '0' COMMENT '删除标志:  0 - 未删除, 1 - 已删除',
  `consumable_type` int NOT NULL DEFAULT '0' COMMENT '耗材类型:1-国产,2-进口',
  `tips` varchar(1024) CHARACTER SET utf8 DEFAULT NULL COMMENT '药品使用注意事项',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

-- ----------------------------
-- Records of drug_resource_2
-- ----------------------------
BEGIN;
INSERT INTO `drug_resource_2` VALUES (2, 'bgyplb_jgyplcl', 3, 1, 'bgyplb_jgyplcl', '', 'ZKM00001399', 'A4hywjj80y', 'A4活页文件夹80页', 'sccj_amzyc', '', 3, '', 'bzdw_h', 'zxdw_z_z', 1, '', 0.00, '1张/盒', '', 0.0000, '', 'ml', '', 2, 29.0000, 29.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-08-21 17:26:06', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (12, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000268', 'dzxyj', '电子血压计', 'sccj_omljkylzshs', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '包', '', 0.0000, '', 'ml', '', 1, 390.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-08-24 18:02:57', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (22, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001086', 'MP C2503Cxmf（hs）', 'MP C2503C型墨粉（红色）', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 580.0000, 580.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (32, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000377', 'slbd', '视力表灯', 'sccj_jsjggdkjyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '灯箱', '', 0.0000, '', 'ml', '', 1, 210.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (42, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001711', 'wlycg', '微量延长管', 'sccj_zjysylqxgfyxgs', '-', 3, '', 'jjdw_t', '', 1, '', 0.00, '套', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (52, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000787', 'cdk', '除丁克', 'sccj_llswyy（wh）yxgs', '(鄂)卫消证字(2009)第0029号', 3, '', 'jjdw_p', '', 1, '', 0.00, '10ML', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (62, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000735', 'xczj', '吸潮纸尖', 'sccj_tjjfylqxyxgs', '天津械备20160055号', 3, '', 'jjdw_h', '', 1, '', 0.00, '25#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 09:53:06', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (72, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000973', 'ycxsywhqmz', '一次性使用雾化器面罩', 'sccj_cdswsclc', '-', 3, '', 'jjdw_z_5693', '', 1, '', 0.00, '小号', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-28 09:54:04', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (82, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_wj', 'ZKM00000136', 'sxjxw', '速效救心丸', 'sccj_tjzxyyjtgfyxgsdlzyc', '国药准字Z12020025', 3, '', 'bzdw_h', 'zxdw_p_1', 2, 'jldw_l', 60.00, '60.00粒*2瓶/盒', '', 0.0000, '', '', '', 1, 28.8000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 13:35:31', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (92, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001100', 'jgscz', '金刚砂车针', 'sccj_lntczyyxgs', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'BR-45', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (102, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000292', 'sq', '舌钳', 'sccj_shylqx（jt）yxgsssqxc', '', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'H3461016.5直', '', 0.0000, '', 'ml', '', 1, 108.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-15 11:04:01', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (112, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000802', 'lst', '络石藤', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0840, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (122, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000688', 'flg', '伏龙肝', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0670, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (132, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000863', 'gzjyggqx（jyPz-28h）', '钢质机用根管器械（机用P钻-28混）', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '28mm1-6#6*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (142, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000235', 'ycxsywjzsz（zszt）', '一次性使用无菌注射针（注射针头）', 'sccj_zjkdlylqxgfyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '0.5#*20100支/盒', '', 0.0000, '', 'ml', '', 1, 0.1700, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (152, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001444', 'gmsjp', '高锰酸钾片', 'sccj_jnkfszyyxgs', '国药准字H37022233', 3, '', 'bzdw_h', 'zxdw_p', 24, 'jldw_g', 0.10, '0.10g*24片/盒', '', 0.0000, '', '', '', 1, 21.0600, 29.4800, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (162, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000462', 'wssB1zsy', '维生素B1注射液', 'sccj_sdfmyyjtgfyxgs', 'H37021057', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_ml', 2.00, '2.00ml*10支/盒', 'Iv', 2.0000, '', '', 'qd', 1, 3.9000, 5.4600, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 100, 10, NULL, '2018-04-19 11:55:16', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (172, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_klj', 'ZKM00001483', 'gmqrkl（wtx）', '感冒清热颗粒（无糖型）', 'sccj_hfrhslyyyxgs', '国药准字Z20055023', 3, '', 'bzdw_h', 'zxdw_d', 10, 'jldw_g', 6.00, '6.00g*10袋/盒', '', 0.0000, '', '', '', 1, 14.5000, 1.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-19 11:30:45', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (182, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001097', 'yhb', '盐黄柏', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.2020, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (192, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsy', 'ZKM00001478', 'ffljdhsy', '复方氯己定含漱液', 'sccj_sznyyyyxgs', 'H10920104', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 200.00, '200.00ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 11.6600, 15.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (202, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000620', 'xc', '缬草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0830, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (212, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000719', 'zszf', '制水蛭粉', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 3.1000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (222, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000227', 'ycxyyd', '一次性医用垫', 'sccj_xxsytylypyxgs', '', 3, '', 'jjdw_k_7001', '', 1, '', 0.00, '50*6010块/包', '', 0.0000, '', 'ml', '', 1, 0.5000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-24 10:03:51', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (232, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001102', 'fcqs', '麸炒芡实', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.2630, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (242, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000706', 'gshj', '干髓糊剂', 'sccj_llswyy（wh）yxgs', '--', 3, '', 'jjdw_h', '', 1, '', 0.00, '10ML', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (252, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000756', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '国械注进20152552079', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'F0-30F(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 1, 0, NULL, '2018-05-14 09:32:34', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (262, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001215', 'sm', '蛇莓', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0300, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (272, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000829', 'jst', '酒蛇蜕', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.4480, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-24 11:38:19', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (282, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00000458', 'mdlxtktcssjh（knf）TPPA', '梅毒螺旋体抗体测试试剂盒（抗凝法）TPPA', 'sccj_rb', '', 3, '', 'jjdw_f_9562', '', 1, '', 0.00, '100T', '', 0.0000, '', 'ml', '', 1, 6.6000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-10 23:11:39', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (292, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001491', 'pfskjdR1541', '皮肤伤口胶带R1541', 'sccj_3M', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (302, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000369', 'bxgtp', '不锈钢托盘', 'sccj_gdscaxctqsylqxc', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '26X20X3', '', 0.0000, '', 'ml', '', 1, 38.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (312, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000710', 'jzs', '结扎丝', 'sccj_hzxhswclyxgs', '--', 3, '', 'jjdw_q', '', 1, '', 0.00, '100G(0.25)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-04-08 12:59:52', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (322, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tj', 'ZKM00001626', 'jqhlrt', '经期护理热帖', 'sccj_tjhjzygs', '170814', 3, '', 'bzdw_h', 'zxdw_t', 2, 'jldw_t', 1.00, '1.00贴*2贴/盒', '', 0.0000, '', '', '', 1, 0.0000, 13.9000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (332, 'yplb_xy', 1, 1, 'yplb_zcy', 'ypjx_jnj', 'ZKM00001397', 'lhqwjn', '莲花清瘟胶囊', 'sccj_sjzylyygfyxgs', '国药准字z20040063', 3, '', 'bzdw_h', 'zxdw_l', 24, 'jldw_g', 0.35, '0.35g*24粒/盒', '', 0.0000, '', '', '', 1, 11.2000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 13:54:39', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (342, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001276', 'qs', '秋石', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0300, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (352, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000185', 'ycxsyyymq', '一次性使用医用棉签', 'sccj_bjdkwsypyxzrgs', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '4支/240小包/50中包', '', 0.0000, '', 'ml', '', 1, 21.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (362, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000358', 'ycxslsg', '一次性塑料试管', 'sccj_jskdylypyxgs', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '12x75mm，PE，500支', '', 0.0000, '', 'ml', '', 1, 20.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (372, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000763', 'qkwktp', '全口无孔托盘', 'sccj_rxckclyxgs', '沪食药监械生产许可20000061号', 3, '', 'jjdw_ge', '', 1, '', 0.00, '2#上', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-04-17 16:59:21', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (382, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000673', 'sfc', '鼠妇虫', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.6500, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (392, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000009', 'kxswkfx', '可吸收外科缝线', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '2-0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (402, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000577', 'mgt', '茅根炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0400, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:45:47', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (412, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001636', 'lltdp（TX）', '氯雷他定片（TX）', 'sccj_shypzyyxgs', 'SH00511', 3, '', 'bzdw_h', 'zxdw_p', 12, 'jldw_mg', 10.00, '10.00mg*12片/盒', '', 0.0000, '', '', '', 2, 0.0000, 3.9000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-05-17 17:26:48', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (422, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000757', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '国械注进20152552079', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'F0-25(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (432, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000834', 'yytz', '牙用探针', 'sccj_shkqylqxyxgs', '沪浦械备20170003', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'E5', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (442, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001709', 'tlbd（tlwm）20g//b', '弹力绷带（弹力网帽）20个//包', 'sccj_zzatlkswgcyxgs', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-07-04 13:08:40', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (452, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001212', 'mmh', '密蒙花', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0950, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (462, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rj', 'ZKM00001800', 'xjgyrj（bx）', '西甲硅油乳剂（柏西）', 'sccj_dgblgfhxyxgs', 'H20160184', 3, '', 'bzdw_p', 'zxdw_ml', 30, 'jldw_ml', 1.00, '1.00ml*30ml/瓶', 'kf', 2.0000, '', '', 'm8xsyc', 1, 0.0000, 46.3500, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (472, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000527', 'yyyqljg', '医用氧气链接管', 'sccj_yzst', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '1.5m', '', 0.0000, '', 'ml', '', 1, 4.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (482, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001045', 'dsd', '订书钉', 'sccj_amzyc', '', 3, '', 'bzdw_z_8915', 'zxdw_h', 10, '', 0.00, '10盒/组', '', 0.0000, '', 'ml', '', 2, 10.8000, 10.8000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (492, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001150', 'sjc', '伸筋草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0500, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (502, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001051', 'etbyq', '儿童拔牙钳', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '7#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (512, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000879', 'bj', '荜芨', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.3140, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 10:59:25', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (522, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_klj', 'ZKM00001584', 'ymckl', '益母草颗粒', 'sccj_gxcfyygfyxgs', '国药准字Z45021652', 3, '', 'bzdw_h', 'zxdw_d', 12, 'jldw_g', 15.00, '15.00g*12袋/盒', '', 0.0000, '', '', '', 1, 7.5000, 7.5000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (532, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000314', 'fln', '敷料镊', 'sccj_shylqx（jt）yxgsssqxc', '', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'J4205012.5CM无钩', '', 0.0000, '', 'ml', '', 1, 10.1600, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (542, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000976', '75%yyjj', '75%医用酒精', 'sccj_sclkyyflyxgs', '川（广安）卫消证字2014第0001号', 3, '', 'jjdw_p', '', 1, '', 0.00, '500ml', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-28 10:02:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (552, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000232', 'ycxsywg', '一次性使用胃管', 'sccj_yzysyykjyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, 'Fr18', '', 0.0000, '', 'ml', '', 1, 2.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (562, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000815', 'dtSuperlinezzt', '登腾Superline种植体', 'sccj_EA', '--', 3, '', 'jjdw_h', '', 1, '', 0.00, 'FX4512SW', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (572, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000592', 'jxz', '急性子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0400, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (582, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_pbj', 'ZKM00001481', 'zcypbj（cs）', '中成药喷鼻剂（测试）', 'sccj_sdslylqxyxgs', 'GB8888', 3, '', 'bzdw_h', 'zxdw_b_7638', 2, 'jldw_l', 10.00, '10.00粒*2板/盒', 'cqkf', 2.0000, '', '', 'm6xsyc', 1, 0.0000, 15.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-05-21 22:42:38', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (592, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000245', 'xtg', '吸痰管', 'sccj_hnsjqylqxyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, 'F122.67*500mm', '', 0.0000, '', 'ml', '', 1, 1.5000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (602, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000441', 'yywhq（mzs）', '医用雾化器（面罩式）', 'sccj_hzjlylqxyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, 'YZ.W02 10ml(L)', '', 0.0000, '', 'ml', '', 1, 14.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 30, 10, NULL, '2018-01-24 09:17:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (612, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000652', 'jyprotaper', '机用protaper', 'sccj_xnddsb', '国食药监械（进）字2014第2061388号', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm混', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 09:28:22', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (622, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsp', 'ZKM00000364', 'csxy（cs）', '测试西药（测试）', 'sccj_gzsl', 'GB20171231', 3, '9001-ddd', 'bzdw_p', 'zxdw_l', 20, 'jldw_mg', 10.00, '10.00mg*20粒/瓶', 'ad us.int', 20.0000, '', '', 'bid', 1, 30.0000, 10.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-05-17 23:17:11', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (632, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000067', 'jbxsj', '菌斑显示剂', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (642, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000791', 'hh', '红花', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.4260, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (652, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001448', 'ysybqzsy', '盐酸异丙嗪注射液', 'sccj_shhfzyyxgs', '国药准字H31021490', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 1.00, '1.00ml*1支/支', '', 0.0000, '', '', '', 1, 1.3000, 1.8200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (662, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tj', 'ZKM00001728', 'ssztg', '伤湿止痛膏', 'sccj_hswsclyyyxgs', 'Z42021954', 3, '', 'bzdw_h', 'zxdw_t', 5, 'jldw_t', 1.00, '1.00贴*5贴/盒', 'thc_1', 1.0000, '', '', 'mr1c', 1, 0.0000, 5.4000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (672, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001402', 'kqqxj', '空气清新剂', 'sccj_amzyc', '', 3, '', 'bzdw_p', 'zxdw_p_1', 1, '', 0.00, '1瓶/瓶', '', 0.0000, '', 'ml', '', 2, 19.0000, 19.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (682, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001058', '20yzlcA4', '20页资料册A4', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 7.5000, 7.5000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (692, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000658', 'jsq', '焦神曲', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0670, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (702, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000548', 'pttcdsjh（yhmf）', '葡萄糖测定试剂盒（氧化酶法）', 'sccj_glyltyldzyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '50ml*6校准品1ml', '', 0.0000, '', 'ml', '', 1, 152.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (712, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000136', 'ssj', '手术剪', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '12.6弯', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (722, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001015', 'jgscz', '金刚砂车针', 'sccj_w', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'TF-12EF', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (732, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000674', 'hc', '黄岑', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.2900, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (742, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000823', 'yhjt', '愈合基台', 'sccj_EA', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, 'HAB553050L', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (752, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00001389', 'sjppttsgkfy', '三精牌葡萄糖酸钙口服液', 'sccj_hyjtsjzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_ml', 10.00, '10.00ml*10支/盒', 'ad us.int', 10.0000, '', '', 'bid', 1, 15.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-03-20 20:46:58', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (762, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001370', 'nb', '尿杯', 'sccj_hmynt', '-', 3, '', 'jjdw_x', '', 1, '', 0.00, '40ml，带红盖，KG517-2，PP,800支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (772, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001470', 'zlxzp	', '脂类校准品	', 'sccj_szmr', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (782, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000258', 'ycxsygmj', '一次性使用肛门镜', 'sccj_jshfylkjyxgs', '', 3, '', 'jjdw_z_5693', '', 1, '', 0.00, '小号1只', '', 0.0000, '', 'ml', '', 1, 1.2000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 13:29:17', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (792, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001348', 'jqbhs', '金钱白花蛇', 'sccj_trt', '', 3, '', 'bzdw_t', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 1.0000, '', '', '', 1, 90.0000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (802, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000129', 'sgtbd', '石膏调绊刀', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '16cm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (812, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001780', 'tsgD3p（geq）', '碳酸钙D3片（钙尔奇）', 'sccj_hszyyxgs', 'H10950029', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_l', 30.00, '30.00粒*1瓶/瓶', 'kf', 1.0000, '', '', 'mr1c', 1, 0.0000, 28.6800, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (822, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00000531', 'wss B1zsy', '维生素 B1注射液', 'sccj_sdfmyyjtgfyxgs', 'H37021057', 3, '', 'bzdw_z', 'zxdw_ml', 2, 'jldw_g', 0.10, '0.10g*2ml/支', '', 0.0000, '', '', '', 1, 0.3900, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 100, 10, NULL, '2018-02-24 11:00:56', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (832, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001052', 'A4skwjj', 'A4三孔文件夹', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 9.0000, 9.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (842, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qwj', 'ZKM00000290', 'lssdacxrqwj(wtl）', '硫酸沙丁胺醇吸入气雾剂(万托林）', 'sccj_glsskzy（sz）yxgs', '国药准字j20160074', 3, '', 'bzdw_h', 'zxdw_q', 200, 'jldw_ug', 100.00, '100.00ug*200揿/盒', '', 0.0000, '', '', '', 1, 14.7000, 20.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-06-07 14:19:14', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (852, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001032', 'yt', '牙挺', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '空心六角柄SC3', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (862, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001396', 'zhzlp', '中号治疗盘', 'sccj_gdscaxczysylqxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '30*20*4.6', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (872, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001813', 'wssB1p', '维生素B1片', 'sccj_gdhnyyjtyxgs', 'H44023349', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 10.00, '10.00mg*100片/瓶', '', 0.0000, '', '', '', 1, 0.0000, 4.8000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (882, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001479', 'jxlsm（ALP）cdsjh	', '碱性磷酸酶（ALP）测定试剂盒	', 'sccj_szmr', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (892, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000276', 'lgxwwhjp', '冷光纤维弯喉镜片', 'sccj_TruphatekInternationalLtd', '', 3, '', 'jjdw_z', '', 1, '', 0.00, 'shucman2系列52433号弯', '', 0.0000, '', 'ml', '', 1, 900.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (902, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001532', 'sly', '石蜡油', 'sccj_sdaj', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (912, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_pj', 'ZKM00000177', 'mmsqp', '明目上清片', 'sccj_jlyrzygfyxgs', '国药准字Z22021188', 3, '', 'bzdw_h', 'zxdw_b_7638', 2, 'jldw_p', 12.00, '12.00片*2板/盒', '', 0.0000, '', '', '', 1, 4.1500, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:40:24', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (922, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001016', 'jgscz', '金刚砂车针', 'sccj_w', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'TF-13C', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (932, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001093', 'byq/crbyq', '拔牙钳/成人拔牙钳', 'sccj_w', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '23#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (942, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001874', 'xddhp（hsp）', '西地碘含片（华素片）', 'sccj_bjhszygfyxgs', 'H10910012', 3, '', 'bzdw_h', 'zxdw_p', 30, 'jldw_mg', 1.50, '1.5mg*30片/盒', '', 0.0000, '', '', '', 1, 0.0000, 12.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (952, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_cj_1', 'ZKM00000193', 'smlhly', '狮马龙活络油', 'sccj_yjlzycyxgs', 'zc20160011', 3, '', 'bzdw_h', 'zxdw_p_1', 1, 'jldw_ml', 20.00, '20.00ml*1瓶/盒', '', 0.0000, '', '', '', 1, 14.9000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-29 15:50:04', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (962, 'bgyplb_gdzc', 3, 1, 'bgyplb_gdzc', '', 'ZKM00001390', 'dyj', '打印机', 'sccj_amzyc', '', 3, '', 'bzdw_x', 'zxdw_g', 1, '', 0.00, '1个/箱', '', 0.0000, '', 'ml', '', 2, 2000.0000, 2000.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (972, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001262', 'yyljd	', '医用垃圾袋	', 'sccj_bjkylsmyxgs		', '-', 3, '', 'jjdw_k', '', 1, '', 0.00, '30L58*70*2.5S', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (982, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001326', 'qgcgds', '气管插管导丝', 'sccj_gzwl', '-', 3, '', 'jjdw_g', '', 1, '', 0.00, '维力,b型,10CH白色', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (992, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000291', 'dmp', '多酶片', 'sccj_scykzyyxgs', '国药准字H51020247', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_p', 100.00, '100.00片*1瓶/瓶', '', 0.0000, '', '', '', 1, 3.1500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:43:56', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1002, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001285', 'ycxPEst', '一次性PE手套', 'sccj_dgblgfhxyxgs', '-', 3, '', 'jjdw_b', '', 1, '', 0.00, '中号10包/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1012, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000726', 'Z350XTgghldsz', 'Z350XT光固化流动树脂', 'sccj_3MESPE DENTAL PRODUCT', '--', 3, '', 'jjdw_z', '', 1, '', 0.00, '7032/A33*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1022, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000812', 'dgw', '当归尾', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1680, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1032, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001385', 'yyssdp', '医用手术刀片', 'sccj_shpdjhylypgfyxgs		', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '10#无菌碳钢,100片/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1042, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000984', 'ycxsymbxybhdcgq', '一次性使用脉搏血氧饱和度传感器', 'sccj_llhtylcdsbjs（bj）yxgs', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, 'AMD-DS-AM0007-1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-30 14:36:59', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1052, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000403', 'tqjd（wfb）', '透气胶带（无纺布）', 'sccj_jzxzlmwsclyxgs', '', 3, '', 'jjdw_j', '', 1, '', 0.00, '1.25*91024卷/盒', '', 0.0000, '', 'ml', '', 1, 1.0400, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 15:37:15', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1062, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000569', 'wlc', '委陵菜', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0610, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:12:16', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1072, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000717', 'bsc', '北沙参', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2350, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1082, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000606', 'Hc', 'H锉', 'sccj_xnddsb', '国械备20170214号', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm-40（黑）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1092, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000254', 'B-Dsyb', 'B-D试验包', 'sccj_sdxhylqxgfyxgs', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '12cm*12cm40包/箱', '', 0.0000, '', 'ml', '', 1, 28.5000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 13:44:05', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1102, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_hsp', 'ZKM00000363', 'cszcyp', '测试中成药品', 'sccj_beyyyxgs', 'GB1573', 3, '9009-6990', 'bzdw_h', 'zxdw_b_7638', 2, 'jldw_l', 15.00, '15.00粒*2板/盒', 'ad us.int', 3.0000, '', '', 'bid', 1, 10.0000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-03-01 23:01:27', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1112, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000564', 'cpt', '陈皮炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0540, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1122, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001247', 'lc', '葎草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0680, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1132, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000554', 'jtdp', '胶头滴瓶', 'sccj_dd', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '30ml', '', 0.0000, '', 'ml', '', 1, 3.5000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1142, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001533', 'ycxzxd', '一次性止血带', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1152, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_njj', 'ZKM00000474', 'ffldkynj', '复方利多卡因凝胶', 'sccj_dd', '', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_g', 10.00, '10.00g*10支/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 2, 1, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1162, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001274', 'yyqxz	', '移液器吸嘴	', 'sccj_dlxcsyyq（bj）yxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '1000μl（100支/盒）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1172, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001621', 'zjztg 0.25*25', '针灸针套管 0.25*25', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1182, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000370', 'bxgdckzc', '不锈钢带尺叩诊锤', 'sccj_gdscaxctqsylqxc', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '不锈钢', '', 0.0000, '', 'ml', '', 1, 10.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1192, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_klj', 'ZKM00001700', 'gmlkl', '感冒灵颗粒', 'sccj_hrsj', 'Z44021940', 3, '', 'bzdw_h', 'zxdw_d', 9, 'jldw_g', 10.00, '10.00g*9袋/盒', 'kf', 10.0000, '', '', 'mr3c', 1, 0.0000, 10.6000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 10:52:24', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1202, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsp', 'ZKM00000027', 'ze1', '周二1', 'sccj_hrsj', '111', 3, '', 'bzdw_b', 'zxdw_wu_cldw', 1, 'jldw_w', 10.00, '10.00丸/包', '', 0.0000, '', '', '', 1, 0.0000, 12.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1212, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tptj', 'ZKM00000423', 'asamlzmcrp', '艾司澳美拉唑镁肠溶片', 'sccj_Abbott Biologicals B.V.', '', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_mg', 40.00, '40.00mg*7片/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1222, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000989', 'bxgnzt', '不锈钢镊子筒', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '小号', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1232, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000223', 'lzz', '留置针', 'sccj_szxdylqxyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '20G', '', 0.0000, '', 'ml', '', 1, 11.3600, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 17:12:26', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1242, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000033', 'bxsxybhdcly', '便携式血氧饱和度测量仪', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1252, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001049', 'etbyq', '儿童拔牙钳', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '3#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1262, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000198', '3Mtmbmft', '3M透明薄膜敷贴', 'sccj_3M Deutschlang GmbH', '', 3, '', 'jjdw_zhang', '', 1, '', 0.00, '100片/盒6*7cm', '', 0.0000, '', 'ml', '', 1, 3.4000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1272, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000481', 'ycxsywjzjz', '一次性使用无菌针灸针', 'sccj_bjkydylypc', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '0.25*75单支', '', 0.0000, '', 'ml', '', 1, 0.1000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1282, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000356', 'fbdblfhsjn', '芬必得布洛芬缓释胶囊', 'sccj_zmtjskzyyxgs', '国药准字h20013062', 3, '', 'bzdw_h', 'zxdw_l', 24, 'jldw_g', 0.40, '0.40g*24粒/盒', '', 0.0000, '', '', '', 1, 19.4400, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-08 08:44:48', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1292, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_qwj', 'ZKM00001425', 'khjpwj', '开喉剑喷雾剂', 'sccj_gzsl', '国药准字z20026493', 3, '', 'bzdw_h', 'zxdw_z', 1, 'jldw_ml', 20.00, '20.00ml*1支/盒', '', 0.0000, '', '', '', 1, 30.0800, 1.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:56:18', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1302, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001311', 'ycxng（sqdng）', '一次性尿管（双腔导尿管）', 'sccj_gzwst', '-', 3, '', 'jjdw_g', '', 1, '', 0.00, '双腔导尿管,乳胶,12根/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1312, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000288', 'mjswzsj', '灭菌生物指示剂', 'sccj_sdxhylqxgfyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '压力蒸汽50支/盒', '', 0.0000, '', 'ml', '', 1, 525.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1322, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001626', 'dzdyjj04（30#）', '大锥度牙胶尖04（30#）', 'sccj_dsbyk（tj）yxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1332, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000601', 'Hc', 'H锉', 'sccj_xnddsb', '国械备20170214号', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm-10（紫）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1342, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000928', 'ggkdz（kdz21h）', '根管扩大针（扩大针21混）', 'sccj_mnzshs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm15-40H6*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1352, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000334', 'ysybssxszsy', '盐酸异丙肾上腺素注射液', 'sccj_shhfzyyxgs', 'H31021344', 3, '', 'bzdw_h', 'zxdw_z', 2, 'jldw_ml', 2.00, '2.00ml*2支/盒', '', 0.0000, '', '', '', 2, 52.0600, 34.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-22 10:21:27', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1362, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000446', 'ycxsyyydd', '一次性使用医用垫单', 'sccj_hnydsyyxgs', '', 3, '', 'jjdw_t_7475', '', 1, '', 0.00, '60*50', '', 0.0000, '', 'ml', '', 1, 0.5600, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1372, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001766', 'slsxgenzsy', '三磷酸腺苷二钠注射液', 'sccj_rs', 'H20013207', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_ml', 2.00, '2.00ml*10支/盒', 'jrzs', 2.0000, '', '', 'mr1c', 2, 0.0000, 0.6500, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-30 10:03:03', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1382, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000814', 'dtSuperlinezzt', '登腾Superline种植体', 'sccj_EA', '--', 3, '', 'jjdw_h', '', 1, '', 0.00, 'FX4510SW', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1392, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001460', 'zjdhs（D-Bil）cdsjh	', '直接胆红素（D-Bil）测定试剂盒	', 'sccj_szmr', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1402, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_fsp', 'ZKM00001895', 'lhmsfsp', '罗红霉素分散片', 'sccj_zmtjskzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_p', 12, 'jldw_mg', 50.00, '50mg*12片/盒', '', 0.0000, '', '', '', 1, 0.0000, 14.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1412, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000568', 'jm', '椒目', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0950, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1422, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001625', 'dzdyjj04（25#）', '大锥度牙胶尖04（25#）', 'sccj_dsbyk（tj）yxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1432, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000263', 'lekpdfxdy（df）', '利尔康牌碘伏消毒液（碘伏）', 'sccj_sdlekxdkjgfyxgs', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '100ml', '', 0.0000, '', 'ml', '', 1, 1.5000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1442, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001527', 'xxycz', '心相印抽纸', 'sccj_amzyc', NULL, 3, '', 'bzdw_j_4203', 'zxdw_b', 48, '', 0.00, '48包/件', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1452, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001131', 'ycxsywjzsq', '一次性使用无菌注射器', 'sccj_yymkyyclyxgs', '国食药监械（准）字2014第3151344号', 3, '', 'jjdw_z', '', 1, '', 0.00, '5ml0.5*38', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-04 14:46:44', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1462, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00001443', 'pttzsy（sp）', '葡萄糖注射液（塑瓶）', 'sccj_dzzy', '国药准字H44020197', 3, '', 'bzdw_p', 'zxdw_ml', 250, 'jldw_g', 25.00, '25.00g*250ml/瓶', '', 0.0000, '', '', '', 1, 4.3500, 6.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1472, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000216', 'ycxsyqgcg', '一次性使用气管插管', 'sccj_zjsjylqxgfyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '6#', '', 0.0000, '', 'ml', '', 1, 4.5000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-12 16:15:38', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1482, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001082', 'dpz', '大盘纸', 'sccj_amzyc', '', 3, '', 'bzdw_x', 'zxdw_g', 12, '', 0.00, '12个/箱', '', 0.0000, '', 'ml', '', 2, 10.7500, 10.7500, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1492, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001277', 'wjft', '无菌敷贴', 'sccj_zjyd ', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '6*7cm,50片/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1502, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_wj', 'ZKM00001892', 'hwzcw', '和胃整肠丸', 'sccj_tglwsyc（dysb）lhgs', '', 3, '', 'bzdw_p', 'zxdw_l', 50, 'jldw_g', 0.20, '0.20g*50粒/瓶', '', 0.0000, '', '', '', 1, 0.0000, 20.5000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-07-03 17:27:44', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1512, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001111', 'zjc', '皂角刺', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.8960, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1522, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_klj', 'ZKM00000499', 'csxykl', '测试西药颗粒', 'sccj_gdyhylqxcyxgs', '123', 3, '321', 'bzdw_h', 'zxdw_b', 10, 'jldw_mg', 20.00, '20.00mg*10包/盒', 'ad us.int', 20.0000, '', '', 'bid', 1, 20.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-02-07 18:21:11', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1532, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001227', 'cxj', '拆线剪', 'sccj_shjz', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '16cm/把上海金钟', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-07 16:38:50', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1542, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001446', 'nkcmzsy', '尼可刹米注射液', 'sccj_shhfzyyxgs', '国药准字H31021527', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 1.50, '1.50ml*1支/支', '', 0.0000, '', '', '', 1, 6.8000, 9.5200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 3, NULL, '2018-04-08 16:11:05', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1552, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000582', 'tfl', '土茯苓', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0840, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:33:45', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1562, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000827', 'yyjyxfm', '医用胶原修复膜', 'sccj_EA', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '20*25mm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1572, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001226', 'zzjdw', '组织剪刀弯', 'sccj_shjz', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '16cm/把上海金钟', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1582, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000363', 'csx（bzx）dz', '蚕丝线（编织型）带针', 'sccj_hzhwylypyxgs', '20170418120170411', 3, '', 'jjdw_h', '', 1, '', 0.00, '5-070cm△1/24x10单针', '', 0.0000, '', 'ml', '', 1, 220.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-24 10:09:49', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1592, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000624', 'dzj', '大皂角', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0330, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1602, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000982', 'mmh', '蜜麻黄', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1120, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1612, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000916', 'sypqz（js）', '三用喷枪嘴（金属）', 'sccj_w', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '标准', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1622, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001573', 'mdpp（pds）', '米氮平片（派迪生）', 'sccj_hy（wx）zyyxgs', 'H20041656', 3, '', 'bzdw_h', 'zxdw_p', 10, 'jldw_mg', 30.00, '30.00mg*10片/盒', 'ad us.int', 0.0000, '', '', '', 1, 61.9000, 86.6600, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 3, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1632, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000653', 'xczj', '吸潮纸尖', 'sccj_tjjfylqxyxgs', '天津械备20160055号', 3, '', 'jjdw_h', '', 1, '', 0.00, '混', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 09:52:58', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1642, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000889', 'xwggzxfxt', '纤维根管桩修复系统', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '15根桩4个钻10个延长头', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1652, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dyj', 'ZKM00000302', 'dyylfp(lfpdyy)', '滴眼用利福平(利福平滴眼液)', 'sccj_whwjyyyxgs', 'j42020693', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 10.00, '10.00ml*1支/支', '', 0.0000, '', '', '', 1, 5.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 16:03:36', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1662, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dbj', 'ZKM00000419', 'ffbhndbj', '复方薄荷脑滴鼻剂', 'sccj_zgrmjfjzyydyfsyy（y304yy）yz', '', 3, '', 'bzdw_h', 'zxdw_ml', 8, 'jldw_ml', 1.00, '1.00ml*8ml/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 1, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1672, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001247', 'jjxdp	', '酒精消毒片	', 'sccj_xzwcwsclyxgs		', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '30*60mm/片50片/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1682, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_sj', 'ZKM00001751', 'txzs', '替硝唑栓', 'sccj_hbshzyyxgs', '国药准字h20010063', 3, '', 'bzdw_h', 'zxdw_l', 6, 'jldw_g', 0.20, '0.20g*6粒/盒', '', 0.0000, '', '', '', 1, 0.0000, 3.7000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1692, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000657', 'dfp', '地枫皮', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1570, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-03-07 14:00:58', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1702, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001037', 'jsq', '计算器', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 16.0000, 16.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1712, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001128', 'cqc', '车前草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0440, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1722, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tptj', 'ZKM00000439', 'mtss（smd）', '蒙脱石散（思密达）', 'sccj_bf-yps（tj）zyyxgs', 'H20000690', 3, '', 'bzdw_h', 'zxdw_d', 10, 'jldw_g', 3.00, '3.00g*10袋/盒', 'kf', 3.0000, '', '', 'mr3c', 1, 21.7800, 30.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 3, NULL, '2018-05-24 14:17:10', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1732, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001770', 'sdbg', '梳打饼干', 'sccj_amzyc', NULL, 3, '', 'bzdw_d', 'zxdw_d', 1, '', 0.00, '1袋/袋', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1742, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000050', 'dbyxsz', '大便隐血试纸', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1752, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000643', 'ckssj', '齿科酸蚀剂', 'sccj_dgHeraeus Kulzergmbh', '--', 3, '', 'jjdw_z', '', 1, '', 0.00, '2*12.5ml', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1762, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001596', 'hlsqp（bln）', '黄连上清片（百灵鸟）', 'sccj_gzjxyyyxgs', '20170935', 3, '', 'bzdw_h', 'zxdw_p', 48, 'jldw_g', 0.30, '0.30g*48片/盒', '', 0.0000, '', '', '', 1, 5.8000, 5.1000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-05-21 14:53:48', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1772, 'bgyplb_gdzc', 3, 1, 'bgyplb_gdzc', '', 'ZKM00001847', 'bjbdnE470', '笔记本电脑E470', 'sccj_amzyc', NULL, 3, '', 'bzdw_t_9258', 'zxdw_t_6854', 1, '', 0.00, '1台/台', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1782, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000088', 'bxgKc 25mm', '不锈钢K锉 25mm', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1792, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001730', 'byyz', '布艺椅子', 'sccj_amzyc', NULL, 3, '', 'bzdw_b_9933', 'zxdw_b_1129', 1, '', 0.00, '1把/把', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1802, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001007', 'sg', '射干', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.2910, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1812, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsp', 'ZKM00000368', 'tbklhsp（II）', '头孢克洛缓释片（II）', 'sccj_llszzyyxgs', '国药准字H20020571', 3, '', 'bzdw_h', 'zxdw_p', 4, 'jldw_g', 0.37, '0.37g*4片/盒', 'ad us.int', 0.3700, '', '', 'Q8h', 1, 27.6500, 38.7100, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 3, NULL, '2018-04-08 10:19:28', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1822, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000692', 'zbfz', '制白附子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.2390, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1832, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rgj', 'ZKM00000425', 'ksmmsrg', '糠酸莫米松乳膏', 'sccj_beyy（sh）yxgs', 'H19991918', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_mg', 10.00, '10.00mg*1支/支', '', 0.0000, '', '', '', 1, 19.7700, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 5, 1, NULL, '2018-05-18 10:35:58', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1842, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000665', 'wm', '乌梅', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1120, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 17:47:39', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1852, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000353', 'bxgdgfp', '不锈钢带盖方盘', 'sccj_gdscaxctqsylqxc', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '9寸无空304', '', 0.0000, '', 'ml', '', 1, 40.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1862, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001541', 'ycxsywjzsz 0.6*28.5mm', '一次性使用无菌注射针 0.6*28.5mm', 'sccj_jxhdylqxjtyxgs', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1872, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000551', 'α-qdstymcdsjh（c-tdsdwf）', 'α-羟丁酸脱氧酶测定试剂盒（c-酮丁酸底物法）', 'sccj_glyltyldzyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '40ml*5；10ml*5', '', 0.0000, '', 'ml', '', 1, 292.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1882, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001161', 'td', '天冬', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.3920, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1892, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001105', 'czq', '持针钳', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '细针直型140mm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1902, 'hclb_ryplcl', 2, 1, 'hclb_ryplcl', '', 'ZKW00000042', 'mt', '毛毯', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_zhang', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1912, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000546', 'nscdsjh（nmlxjcf）', '尿素测定试剂盒（脲酶连续检测法）', 'sccj_glyltyldzyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '50ml*6；校准品1ml', '', 0.0000, '', 'ml', '', 1, 253.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1922, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000898', 'bp', '冰片', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.3140, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1932, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000687', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'TR-62C(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1942, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001739', 'xgltejsgp（jnd）', '西格列汀二甲双胍片（捷诺达）', 'sccj_msdzyyxgs', 'H20140774', 3, '', 'bzdw_h', 'zxdw_p', 1, 'jldw_hk', 550.00, '550.00毫克*1片/盒', 'cskf', 1100.0000, '', '', 'm12xsyc', 1, 0.0000, 203.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 5, NULL, '2018-05-25 11:04:32', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1952, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hj', 'ZKM00001716', 'flkhj', '肺力咳合剂', 'sccj_gzjxyyyxgs', 'Z20025136', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 100.00, '100.00ml*1瓶/瓶', 'kf', 20.0000, '', '', 'mr3c', 1, 0.0000, 23.7000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 10:18:29', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1962, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001465', 'ptt（Glu-0）cdsjh	', '葡萄糖（Glu-0）测定试剂盒	', 'sccj_szmr', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1972, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000674', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'S0-21(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1982, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000876', 'djc', '地锦草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 0.0000, '', '', '', 1, 0.0500, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (1992, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001152', 'sm', '升麻', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1790, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2002, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000744', 'kllSE BONO（njj）', '可乐丽SE BONO（粘接剂）', 'sccj_rbkll', '--', 3, '', 'jjdw_t', '', 1, '', 0.00, '小套装(1025*1.5ml)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2012, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001481', 'UQnzky	', 'UQ尿质控液	', 'sccj_glyltyldzyxgs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2022, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000230', 'ycxsyxddj', '一次性使用心电电极', 'sccj_shltylqxyxgs', '', 3, '', 'jjdw_p_10962', '', 1, '', 0.00, 'LT-30150片/包', '', 0.0000, '', 'ml', '', 1, 0.6000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 14:54:11', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2032, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000564', 'ycxsyjmcxq', '一次性使用静脉采血器', 'sccj_bdylqx（sh）yxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '50支/包', '', 0.0000, '', 'ml', '', 1, 1.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2042, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_wy', 'ZKM00000442', '50%lsmry', '50%硫酸镁溶液', 'sccj_dd', '', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 100.00, '100.00ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 2, 1, NULL, '2018-01-15 09:17:20', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2052, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000964', 'sgy', '生谷芽', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 0.0000, '', '', '', 1, 0.0390, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2062, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000665', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'EX-21(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2072, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000763', 'sny', '石楠叶', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0300, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2082, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000419', 'ycxsywjzsqdz', '一次性使用无菌注射器带针', 'sccj_shkdlqyfzjtgfyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '5ml', '', 0.0000, '', 'ml', '', 1, 0.3100, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-23 15:23:12', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2092, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000284', 'wkqxrhj（qxx）', '外科器械润滑剂（强效型）', 'sccj_mnsdkyzzyyqc（sh）yxgs', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '70600+2瓶/箱5L', '', 0.0000, '', 'ml', '', 1, 976.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-15 10:57:20', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2102, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_fzj', 'ZKM00001555', 'zsyysklms', '注射用盐酸克林霉素', 'sccj_whnayyyxgs', 'H20051740', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 0.30, '0.30g*1支/支', '', 0.0000, '', '', '', 1, 6.7900, 2.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2112, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001040', 'crbyq', '成人拔牙钳', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '53L#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2122, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001785', 'xbdpksp（bxt）', '硝苯地平控释片（拜新同）', 'sccj_beyyyxgs', 'J20130115', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_mg', 30.00, '30.00mg*7片/盒', '', 0.0000, '', '', '', 1, 0.0000, 31.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2132, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000395', 'ysejsgp（ghz）', '盐酸二甲双胍片（格华止）', 'sccj_zmshsgbzyyxgs', 'H20023370', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_g', 0.50, '0.50g*20片/盒', 'PO', 0.5000, '', '', 'bid', 1, 24.8600, 2.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 2, NULL, '2018-05-03 16:35:48', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2142, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001806', 'zsyaqms', '注射用阿奇霉素', 'sccj_zjytyygfyxgs', 'H20063284', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 0.25, '0.25g*1支/支', '', 0.0000, '', '', '', 1, 0.0000, 1.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-06-15 10:03:12', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2152, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000883', 'cnx', '川牛膝', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.2180, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2162, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001323', 'gkczc', '骨科尺诊锤', 'sccj_jybl', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '金属中号', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2172, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001647', 'ckyggctcl 2g', '齿科用根管充填材料 2g', 'sccj_rb', '国械进注20173632065', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2182, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001185', 'rgtzh', '人工天竺黄', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.6650, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2192, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsjn', 'ZKM00000384', 'bpchsjn（ambl）', '别嘌醇缓释胶囊（奥迈必利）', 'sccj_hljdhsyyyxgs', 'H20041338', 3, '', 'bzdw_h', 'zxdw_p', 14, 'jldw_g', 0.25, '0.25g*14片/盒', 'ad us.int', 0.2500, '', '', 'qd', 1, 0.0000, 42.3000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 2, NULL, '2018-05-23 14:39:19', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2202, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001316', 'zzq', '组织钳', 'sccj_shjz', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '20cm,普通,头宽5cm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2212, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000857', 'tmj（glmtmj）', '脱敏剂（格鲁玛脱敏剂）', 'sccj_w', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '5ml/瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-22 17:59:03', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2222, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000100', 'gsszctq', '各式树脂充填器', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2232, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001437', 'ycxbyg（sb）', '一次性鼻氧管（双鼻）', 'sccj_yzyc', '-', 3, '', 'jjdw_g', '', 1, '', 0.00, '根', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2242, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000287', 'ffhajezp', '复方磺胺甲噁唑片', 'sccj_xnyygfyxgs', '', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_p', 100.00, '100片*1瓶/瓶', '', 0.0000, '', '', '', 1, 9.2000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 10:46:25', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2252, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001246', 'zbph	', '载玻片盒	', 'sccj_shjzylqxbzgfyxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '100片', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2262, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dyj', 'ZKM00000400', 'jyxcdyy（rz）', '聚乙烯醇滴眼液（瑞珠）', 'sccj_hbrzzyyxgs', 'H20046681', 3, '', 'bzdw_h', 'zxdw_h', 1, 'jldw_ml', 0.80, '0.80ml*1盒/盒', 'O.U．', 0.1000, '', '', 'Prn', 1, 17.5000, 21.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 5, 3, NULL, '2018-04-27 15:21:06', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2272, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000373', 'zsytbqs', '注射用头孢曲松', 'sccj_w', '', 3, '', 'bzdw_h', 'zxdw_p_1', 1, 'jldw_g', 1.00, '1.00g*1瓶/盒', 'Iv', 2.0000, '', '', 'qd', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 5, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2282, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001168', 'tlz', '葶苈子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0560, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2292, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000561', 'bhcz', '白花菜子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.1450, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2302, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001674', 'cnn250ml', '纯牛奶250ml', 'sccj_amzyc', NULL, 3, '', 'bzdw_x', 'zxdw_h', 24, '', 0.00, '1盒/盒', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-21 12:17:19', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2312, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001371', 'xg', '吸管', 'sccj_jskd', '-', 3, '', 'jjdw_b', '', 1, '', 0.00, '圆底160mm，500μl滴量PE，500支*10包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2322, 'yplb_cy', 1, 1, 'yplb_xy', 'ypjx_hxj', 'ZKM00000049', 'xrybdndhxy', '吸入用布地奈德混悬液', 'sccj_AstraZeneca Pty Ltd ', '', 3, '', 'bzdw_b', 'zxdw_z', 5, 'jldw_ml', 2.00, '2ml*5支/包', '', 0.0000, '', '', '', 1, 71.6000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-13 14:25:38', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2332, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001154', 'sy', '锁阳', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.1010, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2342, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001103', 'yjl', '盐蒺藜', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.1340, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2352, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000535', 'jxlsmcdsjh（NNPdw-AMPhcyf））', '碱性磷酸酶测定试剂盒（NNP底物-AMP缓冲液法））', 'sccj_glyltyldzyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '50ml*6', '', 0.0000, '', 'ml', '', 1, 253.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-28 14:55:20', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2362, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001317', 'ycxyqmz', '一次性氧气面罩', 'sccj_fsnh', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '可调带2色调节管L（成人）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2372, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001516', 'wgfp', '无盖方盘', 'sccj_caxdfzxyylqxc		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2382, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001313', 'zxq（z）', '止血钳（直）', 'sccj_shjz', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '18cm普通直全齿WD', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2392, 'bgyplb_yslcl', 3, 1, 'bgyplb_yslcl', '', 'ZKM00001418', 'xxf', '小信封', 'sccj_amzyc', NULL, 3, '', 'bzdw_b', 'zxdw_g', 1200, '', 0.00, '1200个/包', '', 0.0000, '', 'ml', '', 2, 0.3100, 0.3100, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2402, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001266', 'chm', '炒槐米', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0680, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2412, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000558', 'ybd', '样本袋', 'sccj_jsst', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '1000支/箱', '', 0.0000, '', 'ml', '', 1, 1.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2422, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001494', 'bxgmqg', '不锈钢棉签缸', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2432, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_wj', 'ZKM00000118', 'zbdhw', '知柏地黄丸', 'sccj_zjwxzygfyxgs', 'z410201904', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_w', 200.00, '200.00丸*1瓶/瓶', '', 0.0000, '', '', '', 1, 14.9000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:18:42', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2442, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000247', 'wksbfl', '外科纱布敷料', 'sccj_cxhlwsclyxgs', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '纱布块100片/包5*7cm8层', '', 0.0000, '', 'ml', '', 1, 15.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2452, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001426', 'smtctq', '水门汀充填器', 'sccj_shkqckyxc		', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '八角柄E2', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2462, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000210', '75%jjxdy', '75%酒精消毒液', 'sccj_sdajgkxdkjyxgs', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '500ml/瓶', '', 0.0000, '', 'ml', '', 1, 3.7400, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2472, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001542', 'ycxsykytqd 7cm', '一次性使用口咽通气道 7cm', 'sccj_gzwl', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2482, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000075', 'glbnp', '格列本脲片', 'sccj_gyjtstjszyyxgs', 'h44021065', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 2.50, '2.50mg*100片/瓶', '', 0.0000, '', '', '', 1, 18.6000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:21:38', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2492, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001169', 'xtsz', '血糖试纸', 'sccj_lszdcp（sh）yxgs', '国食药监械（准）字第2404286', 3, '', 'jjdw_T_9057', '', 1, '', 0.00, '50T卓越', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 13:17:26', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2502, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001197', 'bbm', '荜茇面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.2050, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2512, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000253', 'ajbszsy', '氨甲苯酸注射液', 'sccj_shpjlzzyyxgs(ylzyszyyxgs)', '', 3, '', 'bzdw_h', 'zxdw_z', 5, 'jldw_ml', 10.00, '10ml*5支/盒', '', 0.0000, '', '', '', 1, 1.9000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 15:00:50', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2522, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000612', 'jxc', '积雪草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.0380, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2532, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_pj', 'ZKM00000162', 'fkqjp', '妇科千金片', 'sccj_zzqjyygfyxgs', 'z43020027', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_p', 144.00, '144.00片*1瓶/瓶', '', 0.0000, '', '', '', 1, 33.5000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:22:04', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2542, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000999', 'qh', '前胡', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.4480, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2552, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000875', 'gxjq', '硅橡胶枪', 'sccj_w', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '1:2', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2562, 'bgyplb_gdzc', 3, 1, 'bgyplb_gdzc', '', 'ZKM00001679', 'gqspcjk', '高清视频采集卡', 'sccj_amzyc', NULL, 3, '', 'bzdw_t_9258', 'zxdw_t_6854', 1, '', 0.00, '1台/台', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2572, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001638', 'clt ey', '磁疗贴 耳用', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2582, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000616', 'yhz', '咬合纸', 'sccj_rxckclyxgs', '沪青械备20150043', 3, '', 'jjdw_h', '', 1, '', 0.00, '115mm*22mm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2592, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000658', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'TF-11(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2602, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000917', 'zm', '知母', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.1680, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2612, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001298', 'ohj', '耦合剂', 'sccj_tjxxys', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, 'TM-100型250ml/瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2622, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000566', 'hqt', '黄芩炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.2280, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-03-07 14:03:50', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2632, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00001545', 'dttfhwjn（hyd', '多糖铁复合物胶囊（红源达', 'sccj_shyyjtqdgfyy', 'H20030033', 3, '', 'bzdw_h', 'zxdw_p', 10, 'jldw_g', 0.15, '0.15g*10片/盒', 'kf', 0.1500, '', '', 'mr1c', 1, 27.8700, 2.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 14:10:14', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2642, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001536', 'jbA4', '夹板A4', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2652, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001252', 'yzc', '鸭跖草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.0180, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2662, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_kfy', 'ZKM00000498', 'pttsgxkfry', '葡萄糖酸钙锌口服溶液', 'sccj_anzy', 'h20013241', 3, '', 'bzdw_h', 'zxdw_z', 24, 'jldw_ml', 10.00, '10.00ml*24支/盒', '', 0.0000, '', '', '', 1, 38.1400, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:28:06', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2672, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000299', 'ycxzsqdz', '一次性注射器带针', 'sccj_shkdlqyfzjtgfyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '2.5ml', '', 0.0000, '', 'ml', '', 1, 0.3100, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2682, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000056', 'PEst', 'PE手套', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_d', '', 1, '', 0.00, '中小', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2692, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000588', 'jxt', '鸡血藤', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0450, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:34:38', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2702, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001642', 'ntysg ly18L', '镍钛圆丝弓 卵圆18L', 'sccj_shamdclljgfyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2712, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001178', 'ycxsyjmxycjrq（fwj）', '一次性使用静脉血样采集容器（非无菌）', 'sccj_hbxlylqxkjgfyxgs', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '分离胶/促凝剂8ml*100支/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-06 17:12:52', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2722, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001207', 'srm', '砂仁面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 1.7000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2732, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001119', 'zsg', '紫苏梗', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0390, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2742, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000869', 'bsz', '拔髓针', 'sccj_mnzshs', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, '00#12*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:41:28', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2752, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000704', 'jbs', '焦白术', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.2740, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2762, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001898', 'xgltejsgp（jnd）', '西格列汀二甲双胍片（捷诺达）', 'sccj_hzmsdzyyxgs', 'J20171012', 3, '', 'bzdw_h', 'zxdw_p', 28, 'jldw_hk', 900.00, '900毫克*28片/盒', '', 0.0000, '', '', '', 1, 0.0000, 186.0200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2772, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000148', 'sdq', '三德钳', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2782, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000933', 'xczj', '吸潮纸尖', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '160*130H', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2792, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000193', 'xhpmjbzcl', '新华牌灭菌包装材料', 'sccj_sdxhylqxgfyxgs', '', 3, '', 'jjdw_j', '', 1, '', 0.00, '200mm*100m', '', 0.0000, '', 'ml', '', 1, 420.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2802, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsy', 'ZKM00001311', 'ffljdhsy', '复方氯己定含漱液', 'sccj_jscpbdyyyxgs', '国药准字h20058018', 3, '', 'bzdw_h', 'zxdw_p_1', 1, 'jldw_ml', 250.00, '250.00ml*1瓶/盒', '', 0.0000, '', '', '', 1, 11.9200, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-29 15:48:28', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2812, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001003', 'jgscz', '金刚砂车针', 'sccj_w', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'BR-45', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2822, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001029', 'hsjhb', '黑色记号笔', 'sccj_amzyc', '', 3, '', 'bzdw_h', 'zxdw_z', 10, '', 0.00, '10支/盒', '', 0.0000, '', 'ml', '', 2, 1.2000, 1.2000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2832, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001677', 'twc', '头围尺', 'sccj_sdrhtyyyxgs', '-', 3, '', 'jjdw_b', '', 1, '', 0.00, '包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2842, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001493', 'kgyt（ls）', '快干印台（蓝色）', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 14.0000, 14.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2852, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000894', 'kdzclc', '扩大针测量尺', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, 'A0327', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2862, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001577', 'mqg', '棉签缸', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2872, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000765', 'qkwktp', '全口无孔托盘', 'sccj_rxckclyxgs', '沪食药监械生产许可20000061号', 3, '', 'jjdw_ge', '', 1, '', 0.00, '3#上', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2882, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000301', 'lswfb', '蓝色无纺布', 'sccj_mnsdkyzzyxgs', '', 3, '', 'jjdw_zhang', '', 1, '', 0.00, '60cm*60cm500张/箱', '', 0.0000, '', 'ml', '', 1, 1.9840, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 14:15:58', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2892, 'yplb_xy', 1, 1, 'yplb_zcy', 'ypjx_wj', 'ZKM00000519', 'ffdcdw', '复方丹参滴丸', 'sccj_tslzyjtgfyxgs', 'Z10950111', 3, '', 'bzdw_p', 'zxdw_p', 180, 'jldw_mg', 27.00, '27.00mg*180片/瓶', '', 0.0000, '', '', '', 1, 26.0800, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 6, 2, NULL, '2018-02-06 17:03:01', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2902, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000522', 'yym', '医用帽', 'sccj_jsk', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '20个/袋', '', 0.0000, '', 'ml', '', 1, 0.2000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2912, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001368', 'lstjp（ksy）', '氯沙坦钾片（科索亚）', 'sccj_hzmsdzyyxgs', 'J20130048', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_mg', 100.00, '100.00mg*7片/盒', 'ad us.int', 50.0000, '', '', 'qd', 1, 37.9400, 53.1200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, NULL, '2018-06-27 17:15:12', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2922, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000397', 'zjzxsp（yjl）', '左甲状腺素片（优甲乐）', 'sccj_MerckKGaA', 'H20140052', 3, '', 'bzdw_h', 'zxdw_p', 100, 'jldw_ug', 50.00, '50.00ug*100片/盒', 'ad us.int', 50.0000, '', '', 'qd', 1, 25.6500, 35.9100, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, NULL, '2018-04-19 11:50:57', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2932, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000387', 'PEtqyyjd', 'PE透气医用胶带', 'sccj_hnjzxzlmwsclyxgs', '', 3, '', 'jjdw_j', '', 1, '', 0.00, '1.25X910', '', 0.0000, '', 'ml', '', 1, 1.4000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-24 10:13:23', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2942, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000190', 'xhpB-Dsyb', '新华牌B-D试验包', 'sccj_sdxhylqxgfyxgs', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '12cm*12cm', '', 0.0000, '', 'ml', '', 1, 28.5000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 15:01:29', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2952, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001397', 'sbbd', '纱布绷带', 'sccj_fshsk		', '-', 3, '', 'jjdw_j', '', 1, '', 0.00, '5*45012粒/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2962, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_xrrj', 'ZKM00000450', 'xrylssdacry', '吸入用硫酸沙丁胺醇溶液', 'sccj_GlaxoWellcomeOperations', '', 3, '', 'bzdw_h', 'zxdw_z', 1, 'jldw_mg', 5.00, '5.00mg*1支/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 1, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2972, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001409', 'dzxty', '电子血糖仪', 'sccj_dgblgfhxyxgs', '-', 3, '', 'jjdw_t_148', '', 1, '', 0.00, '灵睿', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2982, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000782', 'ckpggwf', '齿科抛光膏无氟', 'sccj_yhjwwdtgs', '国械注进20162631068', 3, '', 'jjdw_z', '', 1, '', 0.00, '633063中颗粒55ml', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (2992, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_kfy', 'ZKM00001656', 'sdcby（wtx）', '蛇胆川贝液（无糖型）', 'sccj_ahakyl', 'Z34020907', 3, '', 'bzdw_h', 'zxdw_z', 12, 'jldw_ml', 10.00, '10.00ml*12支/盒', 'kf', 10.0000, '', '', 'mr2c', 1, 0.0000, 37.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-05-24 11:05:19', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3002, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000244', 'jzsfhcmxsxdy', '健之素复合醇免洗手消毒液', 'sccj_bjcjmyykjyxzrgs', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '大号500ml', '', 0.0000, '', 'ml', '', 1, 25.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3012, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001124', 'dyqs', '煅阳起石', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0340, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3022, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000158', 'ssmt', '砂石磨头', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3032, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000180', 'jzsxdptp', '健之素消毒泡腾片', 'sccj_bjcjmyykjyxzrgs', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '100片/瓶，1.5g*80片', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 25, 0, NULL, '2018-05-22 17:08:05', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3042, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000884', 'yhz（cb）', '咬合纸（超薄）', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '红色', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3052, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001692', 'dxpzsy（ad）', '地西泮注射液（安定）', 'sccj_tjjyyyyxgs', 'H12020957', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_ml', 2.00, '2.00ml*10支/盒', '', 0.0000, '', '', '', 2, 0.0000, 3.9000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 1, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3062, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001097', 'ykszctq', '牙科树脂充填器', 'sccj_w', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'KPFI-MI', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3072, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000799', '10ml zsq(TX)', '10ml 注射器(TX)', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '10ml*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-14 16:37:20', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3082, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001093', 'cwlz', '醋五灵脂', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2020, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-03-02 09:22:58', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3092, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000965', 'bzl', '半枝莲', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0500, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3102, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001261', 'jjst', '荆芥穗炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2390, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3112, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001059', 'jd', '剪刀', 'sccj_amzyc', '', 3, '', 'bzdw_b_9933', 'zxdw_b_1129', 1, '', 0.00, '1把/把', '', 0.0000, '', 'ml', '', 2, 28.0000, 28.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3122, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000585', 'Kc', 'K锉', 'sccj_xnddsb', '国械备20170214号', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm-10', '', 0.0000, '', 'ml', '', 1, 0.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3132, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_xry', 'ZKM00001476', 'klmsp（klx）', '克拉霉素片（克拉仙）', 'sccj_shypzyyxgs', 'H20033044', 3, '', 'bzdw_h', 'zxdw_p', 8, 'jldw_g', 0.25, '0.25g*8片/盒', 'kf', 0.2500, '', '', 'mr2c', 1, 56.0000, 60.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 1, NULL, '2018-05-24 14:21:50', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3142, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001344', 'yyzr', '盐益智仁', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.7840, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3152, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001475', 'nkd', '纽扣袋', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3162, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000896', 'lz', '莲子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1680, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3172, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_kfy', 'ZKM00001888', 'sds', '十滴水', 'sccj_gdngyyyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_ml', 5.00, '5.00ml*10支/盒', '', 0.0000, '', '', '', 1, 0.0000, 2.5000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-07-03 17:20:43', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3182, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000431', '（jz）zzj', '（金钟）组织剪', 'sccj_rbgdgyzshs_6795', '', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'J2204016CM弯', '', 0.0000, '', 'ml', '', 1, 65.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3192, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000755', 'ssbp', '生桑白皮', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1060, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3202, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000958', 'qx', '全蝎', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 5.5000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3212, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000078', 'glpqp（dt）', '格列吡嗪片（丹泰）', 'sccj_ryzyyxgs', '国药准字h20003554', 3, '', 'bzdw_h', 'zxdw_p', 30, 'jldw_mg', 5.00, '5.00mg*30片/盒', '', 0.0000, '', '', '', 1, 5.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 08:43:43', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3222, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00000533', 'ysssxszsy', '盐酸肾上腺素注射液', 'sccj_tjjyyyyxgs', 'H12020526', 3, '', 'bzdw_z', 'zxdw_ml', 1, 'jldw_mg', 1.00, '1.00mg*1ml/支', 'Ivgtt', 1.0000, '', '', 'Prn', 1, 4.8000, 6.7200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 20, 10, NULL, '2018-04-19 13:36:06', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3232, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000631', 'mhd', '木蝴蝶', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1250, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3242, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000523', 'ycxsygxq', '一次性使用灌洗器', 'sccj_qdhy', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '100ml', '', 0.0000, '', 'ml', '', 1, 4.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3252, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001226', 'hph', '厚朴花', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1900, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3262, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001198', 'xdp', '消毒片', 'sccj_hzlsyyxdjyxgs', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '100片/瓶杭州朗索', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3272, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tj', 'ZKM00001652', 'fjkqm（TX）', '蜂胶口腔膜（TX）', 'sccj_hrzzyyyxgs', '24171221', 3, '', 'bzdw_h', 'zxdw_h', 1, 'jldw_t', 30.00, '30.00贴*1盒/盒', '', 0.0000, '', '', '', 1, 0.0000, 26.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3282, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000487', 'jqlzsy', '甲强龙注射液', 'sccj_dd', '', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_mg', 40.00, '40.00mg*1支/支', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3292, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001270', 'ec', '儿茶', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1980, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3302, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_wj', 'ZKM00000182', 'hsxsw', '黄氏响声丸', 'sccj_wxjmkxshyygfyxgs', '', 3, '', 'bzdw_h', 'zxdw_b_7638', 3, 'jldw_g', 0.13, '0.13g*3板/盒', '', 0.0000, '', '', '', 1, 26.0000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 14:16:51', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3312, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000113', 'jyywssz', '机用药物输送针', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3322, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001570', 'zsymtfsxnm（bqt）', '注射用矛头蝮蛇血凝酶（巴曲亭）', 'sccj_plnkyyyxgs', 'H20041419', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_dw', 1.00, '1.00单位*1支/支', 'IM', 0.0000, '', '', '', 1, 36.2000, 50.6800, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3332, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000265', 'lhnzsy(0.9%)', '氯化钠注射液(0.9%)', 'sccj_zjgjyyyxgswtkmnjzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 250.00, '250.00ml*1瓶/瓶', 'Iv', 250.0000, '', '', 'qd', 1, 1.6500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 20, 0, NULL, '2018-03-02 14:23:29', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3342, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001268', 'sddtdktwlyyq	', '手动单通道可调微量移液器	', 'sccj_dlxcsyyq（bj）yxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '2-20μl', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3352, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000837', 'cmym', '醋没药面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.7290, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-03-27 14:52:19', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3362, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tptj', 'ZKM00000413', 'ysaxsp(aps）', '盐酸氨溴索片(安普索）', 'sccj_sds（zg）zyyxgs', '国药准字h19990228', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_mg', 30.00, '30.00mg*20片/盒', 'kf', 60.0000, '', '', 'mr3c', 1, 19.1310, 20.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 1, NULL, '2018-05-24 11:02:16', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3372, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000963', 'lqh', '利器盒', 'sccj_cdlekkjyxgs', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '4L', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 13:10:36', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3382, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001768', 'blzcbg', '焙朗早餐饼干', 'sccj_amzyc', NULL, 3, '', 'bzdw_h', 'zxdw_h', 1, '', 0.00, '1盒/盒', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-01 11:28:43', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3392, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001156', 'yyxdmp', '医用消毒棉片', 'sccj_qdhnswgcyxgs', '鲁青食药监械（准）字2013第164069', 3, '', 'jjdw_h', '', 1, '', 0.00, '6cm*3cm50片', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 11:27:35', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3402, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001423', 'lqh', '利器盒', 'sccj_dgblgfhxyxgs', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '1L圆形', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3412, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001587', 'tptp', '托盘天平', 'sccj_bx', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3422, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000622', 'ngz', '南瓜子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0540, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3432, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000801', 'ycxhyb（TX）', '一次性换药包（TX）', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '200只*箱', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3442, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000863', 'xcq', '徐长卿', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2630, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3452, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001176', 'clfz', '炒莱菔子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0560, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3462, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001297', 'yywjycxmq', '医用无菌一次性棉球', 'sccj_gzjwh', '-', 3, '', 'jjdw_b', '', 1, '', 0.00, '0.5*5粒/包100包/中包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3472, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000122', 'amxljn', '阿莫西林胶囊', 'sccj_cqdkcjzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_l', 20, 'jldw_g', 0.25, '0.25g*20粒/盒', '', 0.0000, '', '', '', 1, 1.4700, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-08 10:46:43', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3482, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001182', 'shfhdzzkp（sp1）', '生化复合定值质控品（水平1）', 'sccj_szmr', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '10*5ml105-007316-00', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3492, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000436', 'yhzwsdj', '雨花泽温湿度计', 'sccj_dd', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '圆形', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3502, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00001562', 'st djwf', '手套 定腈无粉', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3512, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_kfy', 'ZKM00001602', 'sdcby', '蛇胆川贝液', 'sccj_gzbystxzygfyxgs', 'T10007', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_ml', 10.00, '10.00ml*10支/盒', '', 0.0000, '', '', '', 1, 17.5000, 17.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3522, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001071', 'bcd', '白床单', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 33.0000, 33.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3532, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000672', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'S0-20(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3542, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00001624', 'skcmxdy（adf）', '伤口创面消毒液（安多福）', 'sccj_szdfyyyxgs', '17091020', 3, '', 'bzdw_z', 'zxdw_ml', 20, 'jldw_ml', 1.00, '1.00ml*20ml/支', '', 0.0000, '', '', '', 1, 0.0000, 26.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-05-11 17:05:11', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3552, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001204', 'bzm', '白芷面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0850, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3562, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000598', 'fsh', '佛手花', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.6070, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3572, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsp', 'ZKM00000352', 'dxsyslzhsp（snt）', '单硝酸异山梨酯缓释片（索尼特）', 'sccj_sdszyyxgs', '', 3, '', 'bzdw_h', 'zxdw_p', 10, 'jldw_mg', 60.00, '60.00mg*10片/盒', '', 0.0000, '', '', '', 1, 14.1400, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3582, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000836', 'tmwwysjbd（TX)）', '透明网纹易撕胶布带（TX)）', 'sccj_w', '-', 3, '', 'jjdw_j', '', 1, '', 0.00, '12卷*盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3592, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000117', 'gxj', '硅橡胶', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3602, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000001', 'xeafhnmkl', '小儿氨酚黄那敏颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1.00g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 1, 0, 0, 0, '2017-07-13 00:00:00', '2018-10-11 19:49:03', 0, 0, '44444');
INSERT INTO `drug_resource_2` VALUES (3612, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000011', 'bbjfs', '八宝惊风散', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3622, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dj', 'ZDS90000021', 'dyxajfhxdj(tnl)', '对乙酰氨基酚混悬滴剂(泰诺林)', 'sccj_shqszyyxgs', 'h19990007', 3, '', 'bzdw_h', 'zxdw_h', 1, 'jldw_ml', 15.00, '15.00ml*1盒/盒', '', 0.0000, '', 'ml', '', 1, 10.0500, 1.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-24 09:04:49', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3632, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000031', 'ffnhsdyy(xld)', '复方牛磺酸滴眼液(小乐敦)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3642, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_kfy', 'ZDS90000041', 'byskfy（wtx）', '鼻渊舒口服液（无糖型）', 'sccj_cdthjkkjjtgfyxgshszyc', 'Z51020208', 3, '', 'bzdw_h', 'zxdw_z', 6, 'jldw_ml', 10.00, '10.00ml*6支/盒', 'kf', 10.0000, '', 'ml', 'mr3c', 1, 16.3100, 1.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 2, '2017-07-13 00:00:00', '2018-05-24 11:04:22', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3652, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000051', 'tdp', '铁笛片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3662, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000061', 'bszgjn(pfl)', '白芍总苷胶囊(帕夫林)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3672, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000071', 'thjgw', '藤黄健骨丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3682, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000081', 'afghcrjn(gnz)', '阿法骨化醇软胶囊(盖诺真)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3692, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000091', 'jgttj', '金刚藤糖浆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3702, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000101', 'zqnytp（jyt）', '左炔诺孕酮片（金毓婷）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3712, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000111', 'zzrgrsα2bnj', '重组人干扰素α2b凝胶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3722, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000121', 'ngyzw', '暖宫孕子丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3732, 'yplb_xy', 1, 1, 'yplb_zcy', 'ypjx_pj', 'ZDS90000131', 'xyldp', '消炎利胆片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_zcy', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-09-11 13:49:27', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3742, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000141', 'ldxgw', '龙胆泻肝丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3752, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000151', 'sgztw', '舒肝止痛丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3762, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000161', 'xchkl', '小柴胡颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/袋', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3772, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000171', 'sjgmjn', '桑姜感冒胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3782, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000181', 'yxbgasp', '乙酰半胱氨酸片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3792, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_kfy', 'ZDS90000191', 'ysaxskfry', '盐酸氨溴索口服溶液', 'sccj_gyjtzjpszyyxgs', 'H20073744', 3, '', 'bzdw_h', 'zxdw_ml', 100, 'jldw_g', 0.30, '0.30g*100ml/盒', 'kf', 0.0300, '', 'ml', 'mr3c', 1, 9.5000, 13.3000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-24 11:12:56', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3802, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000201', 'yxbgaskl（fls）', '乙酰半胱氨酸颗粒（富露施）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3812, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000211', 'ydmxcj(wtl)', '吲哚美辛搽剂(万特力)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3822, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000221', 'qsxjp', '秋水仙碱片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3832, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000231', 'ytfnznj', '依托芬那酯凝胶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3842, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000241', 'ldhpdcrp', '柳氮磺吡啶肠溶片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3852, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000251', 'tbdnfsp(xfn)', '头孢地尼分散片(希福尼)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3862, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000261', 'tbkljn(xkl)', '头孢克洛胶囊(希刻劳)', 'sccj_llszzyyxgs', 'H10983030', 3, '', 'bzdw_h', 'zxdw_l', 6, 'jldw_g', 0.25, '0.25g*6粒/盒', '', 0.0000, '', 'ml', '', 1, 27.6700, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-24 09:06:58', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3872, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000271', 'gystmxfp', '枸橼酸他莫昔芬片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3882, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000281', 'yykxhj', '养阴口香合剂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3892, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000291', 'gysqjnkl', '枸橼酸氢钾钠颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3902, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000301', 'ffα-tsp(kt)', '复方α-酮酸片(开同)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3912, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000311', 'gysxdnfp（jg）', '枸橼酸西地那非片（金戈）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3922, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000321', 'qbhsgfsp', '羟苯磺酸钙分散片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3932, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000331', 'lrg', '硫软膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3942, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000341', 'ffznrg', '复方樟脑乳膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3952, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000351', 'jhxcw', '金花消痤丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3962, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000361', 'ynbyckt（qqtqx）', '云南白药创可贴（轻巧透气型）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3972, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000371', 'axlwrg', '阿昔洛韦乳膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3982, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tj', 'ZDS90000381', 'bzlat(bd)', '苯扎氯铵贴(邦迪)', 'sccj_shqsyxgs', 'H10920011', 3, '', 'bzdw_h', 'zxdw_p', 100, 'jldw_cm', 2.50, '2.50cm*100片/盒', 'ad us.ext', 2.5000, '', 'ml', 'Prn', 2, 0.1800, 0.2200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 500, 50, '2017-07-13 00:00:00', '2018-06-07 16:34:26', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (3992, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000391', 'hjtkfy', '红景天口服液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4002, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000401', 'cxlnzdw', '穿心莲内酯滴丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4012, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000411', 'asbny', '安神补脑液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4022, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZDS90000421', 'gwsp', '谷维素片', 'sccj_shyyjtqdgfyy', '20160506', 3, '', 'bzdw_h', 'zxdw_p', 100, 'jldw_mg', 10.00, '10.00mg*100片/盒', '', 0.0000, '', 'ml', '', 2, 8.5000, 0.0700, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 1, '2017-07-13 00:00:00', '2018-05-17 17:33:15', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4032, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000431', 'jwzxkl', '九味镇心颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4042, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000441', 'plxtp(nfk)', '吡拉西坦片(脑复康)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4052, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000451', 'abdzp(skccq)', '阿苯达唑片(史克肠虫清)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/片', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4062, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000461', 'kfzxp', '康腹止泻片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4072, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000471', 'wkljn', '胃康灵胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4082, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000481', 'jwxsp', '健胃消食片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4092, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000491', 'kcgjelhjkl', '枯草杆菌二联活菌颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4102, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000501', 'ttkfy', '通天口服液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4112, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000511', 'fmq10p(nql)', '辅酶q10片(能气朗)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4122, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000521', 'qlqxjn', '芪苈强心胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4132, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000531', 'nhjyw', '牛黄降压丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4142, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000541', 'nmjlp(lxl)', '尼麦角林片(乐喜林)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4152, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000551', 'rxbdb', '人血白蛋白', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4162, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000561', 'yxcdyy', '鱼腥草滴眼液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4172, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000571', 'xpladyy', '西吡氯铵滴眼液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4182, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000581', 'zzmmdyy', '珍珠明目滴眼液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4192, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000591', 'sbbd', '纱布绷带', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/袋', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4202, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000601', 'dwysp（sc）', '多维元素片（善存）', 'sccj_hszyyxgs', 'h10950025', 3, '', 'bzdw_h', 'zxdw_h', 1, 'jldw_p', 30.00, '30.00片*1盒/盒', '', 0.0000, '', 'ml', '', 1, 38.9800, 1.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-24 09:08:03', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4212, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000611', 'tfptp（smk）', '托伐普坦片（苏麦卡）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4222, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000621', 'jjhbw', '金鸡虎补丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4232, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000631', 'sbp', '肾宝片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4242, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000641', 'ffxjjn', '复方玄驹胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4252, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000009', 'ycxdssyq', '一次性袋式输液器', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '5.5号针头', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4262, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000019', 'ycxwjyymq', '一次性无菌医用棉签', 'sccj_bjdkwsypyxzrgs', '', 3, '', 'jjdw_b', 'jjdw_ge', 1, 'jldw_g', 1.00, '4支/小包', '', 0.0000, '', 'ml', '', 1, 0.0875, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-01-12 13:09:49', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4272, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000029', 'sys', '双氧水', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '100ml', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4282, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000039', 'ycxyywfbm', '一次性医用无纺布帽', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '一包20个', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4292, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000049', 'ohj', '耦合剂', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4302, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000059', 'nmsn9NC:lm', '柠檬酸钠9NC:蓝帽', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '100支每盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4312, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000069', 'ycxdkdlj', '一次性打孔垫脸巾', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '70cm×50cm（200张/包）', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4322, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000079', 'wjyymq', '无菌医用棉球', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '五颗独立包装', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4332, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000089', 'bsg', '白石膏', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4342, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000099', 'yqt（yq）', '氧气筒（氧气）', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4352, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000109', 'yyycxkyq', '医用一次性窥阴器', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4362, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000010', 'yyr', '薏苡仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4372, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000020', 'gz', '桂枝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4382, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000030', 'ccs', '川赤芍', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4392, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000040', 'fczk', '麸炒枳壳', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4402, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000050', 'sy', '山药', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4412, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000060', 'cp', '陈皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4422, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000070', 'mdp', '牡丹皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4432, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000080', 'jyh', '金银花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4442, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000090', 'ycqz', '盐车前子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4452, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000100', 'dc', '丹参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4462, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000110', 'gj', '干姜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4472, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000120', 'zsy', '紫苏叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4482, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000130', 'gc', '甘草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4492, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000140', 'mdp', '牡丹皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4502, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000150', 'wg', '蜈蚣', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4512, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000160', 'sz', '桑椹', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4522, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000170', 'ch', '柴胡', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4532, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000180', 'fcbs', '麸炒白术', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4542, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000190', 'nwdh', '牛尾独活', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4552, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000200', 'cbs', '炒白芍', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4562, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000210', 'zl', '猪苓', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4572, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000220', 'cclz', '炒川楝子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4582, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000230', 'yzx', '盐泽泻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4592, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000240', 'hq', '黄芪', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4602, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000250', 'wwz', '五味子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4612, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000260', 'zr', '竹茹', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4622, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000270', 'scp', '石菖蒲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4632, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000280', 'xqxtc', '绣球小通草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4642, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000290', 'fxm', '浮小麦', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4652, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000300', 'bhssc', '白花蛇舌草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4662, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000310', 'mglp', '蜜瓜蒌皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4672, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000320', 'sjc', '伸筋草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4682, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000330', 'sm', '升麻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4692, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000340', 'jhl', '酒黄连', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4702, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000350', 'td', '天冬', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4712, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000360', 'hjh', '化橘红', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4722, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000370', 'jzz', '焦栀子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4732, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000380', 'cjc', '炒僵蚕', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4742, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000390', 'jst', '鸡矢藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4752, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000400', 'hhp', '合欢皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4762, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000410', 'hz', '虎杖', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4772, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000420', 'jhp', '姜厚朴', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4782, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000430', 'sy', '山药', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4792, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000440', 'bl', '槟榔', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4802, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000450', 'cx', '川芎', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4812, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000460', 'qh', '青蒿', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4822, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000470', 'fqp', '麸青皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4832, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000480', 'lgc', '老鹳草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4842, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000490', 'hqp', '黄芩片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4852, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000500', 'fcyyr', '麸炒薏苡仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4862, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000510', 'cbbd', '炒白扁豆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4872, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000520', 'bgr', '白果仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4882, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000530', 'qs', '芡实', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4892, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000540', 'hb', '黄柏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4902, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000550', 'tbc', '土鳖虫', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4912, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000560', 'dl', '地龙', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4922, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000570', 'dc', '党参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4932, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000580', 'gj', '龟甲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4942, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000590', 'jwss', '酒乌梢蛇', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4952, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000600', 'cdk', '草豆蔻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4962, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000610', 'pht', '蒲黄炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4972, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000620', 'wlx', '威灵仙', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4982, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000630', 'cjyz(r)', '炒金樱子(肉)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (4992, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000640', 'my', '麦芽', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5002, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000650', 'cmx', '川木香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5012, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000660', 'clff', '炒露蜂房', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5022, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000670', 'gj', '蛤蚧', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5032, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000680', 'pl', '佩兰', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5042, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000690', 'mzw', '蜜紫菀', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5052, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000700', 'snj', '水牛角', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5062, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000710', 'hjt', '红景天', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5072, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000720', 'lfz', '莱菔子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5082, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000730', 'hh', '红花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5092, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000740', 'dy', '地榆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5102, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000750', 'xqc', '豨签草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5112, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000760', 'dyqc', '大叶茜草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5122, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000770', 'jmz', '决明子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5132, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000780', 'll', '漏芦', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5142, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000790', 'cxy', '炒辛夷', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5152, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000800', 'jjs', '荆芥穗', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5162, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000810', 'zych', '竹叶柴胡', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5172, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000820', 'jbx', '京半夏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5182, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000830', 'ybgz', '盐补骨脂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5192, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000840', 'glp', '瓜蒌皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5202, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000850', 'cbzr', '炒柏子仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5212, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000860', 'yyz', '盐益智', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5222, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000870', 'dx', '丁香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5232, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000880', 'kb', '昆布', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5242, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000890', 'jbx', '姜半夏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5252, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000900', 'zl', '泽兰', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5262, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000910', 'xy', '香橼', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5272, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000920', 'sl', '三棱', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5282, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000930', 'yj', '郁金', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5292, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000940', 'dwlz', '煅瓦楞子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5302, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000950', 'sdh', '熟大黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5312, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000960', 'jqc', '金钱草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5322, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000970', 'mzc', '猫爪草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5332, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000980', 'bxp', '白鲜皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5342, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000990', 'thf', '天花粉', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5352, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001000', 'sd', '柿蒂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5362, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001010', 'szy', '山茱萸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5372, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001020', 'qp', '秦皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5382, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001030', 'rdt', '忍冬藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5392, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001040', 'chmr', '炒火麻仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5402, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001050', 'gk', '蛤壳', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5412, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001060', 'whz', '煨诃子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5422, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001070', 'mhd', '木蝴蝶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5432, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001080', 'sph', '生蒲黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5442, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001090', 'cmy', '炒麦芽', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5452, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001100', 'jh', '菊花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5462, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001110', 'cjc', '炒僵蚕', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5472, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001120', 'bg(r)', '白果(仁)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5482, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001130', 'bgr', '白果仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5492, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001140', 'sn', '山柰', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5502, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001150', 'mx', '芒硝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5512, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001160', 'jb', '卷柏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5522, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001170', 'qh', '青蒿', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5532, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001180', 'zl', '重楼', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5542, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001190', 'ylr', '郁李仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5552, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001200', 'jj', '荆芥', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5562, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001210', 'dml', '煅牡蛎', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5572, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001220', 'fxy', '番泻叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5582, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001230', 'jjs', '荆芥穗', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5592, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001240', 'fl', '茯苓', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5602, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001250', 'gs', '甘松', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5612, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001260', 'dzsy', '煅紫石英', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5622, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001270', 'ybjt', '盐巴戟天', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5632, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001280', 'oj', '藕节', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5642, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001290', 'cwlz', '醋五灵脂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5652, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001300', 'yzm', '盐知母', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5662, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001310', 'xkqc', '夏枯全草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5672, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001320', 'jnzz', '酒女贞子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5682, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001330', 'yxhx', '盐小茴香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5692, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001340', 'fxm', '浮小麦', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5702, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001350', 'klp', '苦楝皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5712, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001360', 'dcs', '煅磁石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5722, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001370', 'bjc', '败酱草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5732, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001380', 'ccwz', '炒茺蔚子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5742, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001390', 'mzc', '猫爪草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5752, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001400', 'lh', '芦荟', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5762, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001410', 'slp', '石榴皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5772, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001420', 'cjmz', '炒决明子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5782, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001430', 'xlh', '雪莲花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5792, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001440', 'chmr', '炒火麻仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5802, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001450', 'ydz', '鸦胆子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5812, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001460', 'shhz', '水红花子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5822, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001470', 'hyz', '黄药子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5832, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001480', 'snt', '石南藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5842, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001490', 'nbz', '牛蒡子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5852, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001500', 'cjnj', '炒鸡内金', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5862, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001510', 'fz（bfp）', '附子（白附片）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5872, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001520', 'zcw', '制草乌', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5882, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001530', 'ff', '防风', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5892, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001540', 'dgz', '冬瓜子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5902, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001550', 'dgz', '冬瓜子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5912, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001560', 'dz', '大枣', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5922, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001570', 'fsm', '茯神木', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5932, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001580', 'hmy', '黑蚂蚁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5942, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001590', 'bh', '薄荷', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5952, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001600', 'hjt', '红景天', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5962, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001610', 'hh', '槐花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5972, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001620', 'tcwp', '烫刺猬皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5982, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001630', 'ljs', '鹿角霜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (5992, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001640', 'kb', '昆布', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6002, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001650', 'zjf', '肿节风', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6012, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001660', 'hhl', '胡黄连', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6022, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001670', 'jm', '椒目', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6032, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001680', 'gsq', '隔山撬', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6042, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001690', 'lgc', '老鹳草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6052, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001700', 'lk', '龙葵', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6062, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001710', 'mmh', '密蒙花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6072, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001720', 'hs', '滑石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6082, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001730', 'ctr', '燀桃仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6092, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001740', 'hy', '荷叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6102, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001750', 'ksl', '苦石莲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6112, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001760', 'jg', '桔梗', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6122, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001770', 'tbc', '土鳖虫', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6132, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001780', 'hj', '胡椒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6142, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001790', 'dz', '杜仲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6152, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001800', 'qp', '秦皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6162, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001810', 'csz', '赤石脂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6172, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001820', 'hd', '黑豆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6182, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001830', 'cgs', '醋甘遂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6192, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001840', 'hd', '黑豆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6202, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001850', 'bq', '白前', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6212, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001860', 'tzc', '太子参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6222, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001870', 'jh', '姜黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6232, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001880', 'bs', '白芍', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6242, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001890', 'zhsw', '制何首乌', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6252, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001900', 'xlc', '响铃草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6262, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001910', 'cmc', '川明参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6272, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001920', 'mdp', '牡丹皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6282, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001930', 'cg', '草果', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6292, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001940', 'cmt', '川木通', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6302, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001950', 'hq', '黄芩', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6312, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001960', 'rcrp', '肉苁蓉片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6322, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001970', 'mdp', '牡丹皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6332, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001980', 'ctr', '燀桃仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6342, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001990', 'jh', '菊花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6352, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002000', 'lxc', '鹿衔草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6362, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002010', 'll', '漏芦', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6372, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002020', 'wlz', '瓦楞子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6382, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002030', 'snj', '水牛角', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6392, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002040', 'wbz', '五倍子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6402, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002050', 'yyr', '薏苡仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6412, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002060', 'nwdh', '牛尾独活', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6422, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002070', 'jg', '桔梗', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6432, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002080', 'md', '麦冬', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6442, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002090', 'bp', '冰片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6452, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002100', 'fcjc', '麸炒僵蚕', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6462, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002110', 'tr', '桃仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6472, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002120', 'lst', '络石藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6482, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002130', 'mzw', '蜜紫菀', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6492, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002140', 'kdc', '苦丁茶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6502, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002150', 'bg', '白果', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6512, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002160', 'jsz', '焦山楂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6522, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002170', 'sy', '山药', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6532, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002180', 'zhsw', '制何首乌', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6542, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002190', 'wg', '蜈蚣', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6552, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002200', 'sz', '山楂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_2` VALUES (6562, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002210', 'jqbhs', '金钱白花蛇', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
COMMIT;

-- ----------------------------
-- Table structure for drug_resource_3
-- ----------------------------
DROP TABLE IF EXISTS `drug_resource_3`;
CREATE TABLE `drug_resource_3` (
  `id` bigint unsigned NOT NULL DEFAULT '0' COMMENT '主键',
  `drug_res_type_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT ' 药品和物资类型ID(dw_drug_res_type.id)',
  `base_type` tinyint NOT NULL DEFAULT '0' COMMENT '物品类型：1-药品, 2-耗材, 3-办公用品',
  `status` int DEFAULT '1' COMMENT '药品状态: 0 - 停用, 1 - 使用',
  `type_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药品或者耗材类别的字典ID(dw_dictionary.id AND dw_dictionary.type_id=[yplb OR hclb])',
  `dict_dosage_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药品剂型的字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypjx)',
  `code` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '集团编码',
  `pym` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '拼音简码',
  `name` varchar(64) CHARACTER SET utf8 DEFAULT '' COMMENT '药品或者耗材的名称',
  `manufacturer_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '生产厂家的字典ID(dw_dictionary.id AND dw_dictionary.type_id=sccj)',
  `approval_no` varchar(100) CHARACTER SET utf8 DEFAULT NULL COMMENT '批准文号',
  `med_type` int DEFAULT '3' COMMENT '医保分类： 1 - 无自付, 2 - 部分自付, 3 - 全自付',
  `admin_code` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药监编码',
  `pack_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '包装单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypdw)',
  `min_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '最小单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypdw)',
  `pack_quantity` int DEFAULT '1' COMMENT '包装含量',
  `dosage_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '剂量单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=jldw)',
  `dosage_quantity` decimal(10,2) DEFAULT '0.00' COMMENT '剂量含量',
  `pack_spec` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '包装规格，生成规则：[剂量含量] [剂量单位] * [包装含量] [最小单位] / [包装单位]',
  `take_method_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '用法(默认用法)(dw_dictionary.id AND dw_dictionary.type_id=ypyf)',
  `take_quantity` decimal(36,4) DEFAULT '0.0000' COMMENT '用量(默认用量)',
  `take_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '用量单位字典ID - 暂留字典',
  `take_unit_name` varchar(36) CHARACTER SET utf8 DEFAULT 'ml' COMMENT '用量单位名称，默认ml',
  `take_frequency` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '频率(默认频率)(dw_dictionary.id AND dw_dictionary.type_id=yppl)',
  `common_unit_type` int DEFAULT '1' COMMENT '常规单位类型: 1 - 包装单位(packUnit), 2 - 最小单位(minUnit)',
  `purchase_price` decimal(8,4) DEFAULT '0.0000' COMMENT '进货价: 单位 元',
  `sale_price` decimal(8,4) DEFAULT '0.0000' COMMENT '基准价: 单位 元',
  `cost_category_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '费用类别字典ID(dw_dictionary.id AND dw_dicitionary.type_id=fylb)',
  `invoice_item_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '发票项目字典ID - 暂留',
  `expensive_flag` int DEFAULT '1' COMMENT '贵重物品标识： 0 - 非贵重物品， 1 - 贵重物品',
  `psy_flag_i` int DEFAULT '0' COMMENT ' 精神I类药品标识：0 - 非选中， 1 - 选中',
  `psy_flag_ii` int DEFAULT '0' COMMENT '精神II类药品标识：0 - 非选中，1 - 选中',
  `otc_flag` int DEFAULT '0' COMMENT 'OTC标识：0 - 非选中， 1 - 选中',
  `nar_flag` int DEFAULT '0' COMMENT '麻醉药品标识：0 - 非选中， 1 - 选中',
  `inventory_upper` int DEFAULT '0' COMMENT '库存上限',
  `inventory_lower` int DEFAULT '0' COMMENT '库存下限',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  `modify_time` datetime DEFAULT NULL COMMENT '修改时间',
  `del_flag` int DEFAULT '0' COMMENT '删除标志:  0 - 未删除, 1 - 已删除',
  `consumable_type` int NOT NULL DEFAULT '0' COMMENT '耗材类型:1-国产,2-进口',
  `tips` varchar(1024) CHARACTER SET utf8 DEFAULT NULL COMMENT '药品使用注意事项',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

-- ----------------------------
-- Records of drug_resource_3
-- ----------------------------
BEGIN;
INSERT INTO `drug_resource_3` VALUES (3, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001695', 'qyjdf130/0.4lhnzsy', '羟乙基淀粉130/0.4氯化钠注射液', 'sccj_bjfsyskbyygs', 'H20103246', 3, '', 'bzdw_d', 'zxdw_ml', 500, 'jldw_％', 6.00, '6.00％*500ml/袋', '', 0.0000, '', '', '', 1, 0.0000, 102.1100, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (13, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000341', 'axzp', '奥硝唑片', 'sccj_scklyygfyxgs', '国药准字H20030148', 3, '', 'bzdw_h', 'zxdw_p', 12, 'jldw_g', 0.25, '0.25g*12片/盒', '', 0.0000, '', '', '', 1, 3.8000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 13:25:38', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (23, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001606', 'zjzth 0.3*13mm', '针灸针套盒 0.3*13mm', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (33, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001242', 'yyycxfhf	', '医用一次性防护服	', 'sccj_wjyl（cy）yxgs		', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '连身式1751件/袋', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (43, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001054', 'dad', '档案袋', 'sccj_amzyc', '', 3, '', 'bzdw_d', 'zxdw_g', 10, '', 0.00, '10个/袋', '', 0.0000, '', 'ml', '', 2, 0.9000, 0.9000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (53, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000392', 'lltdp（krt）', '氯雷他定片（开瑞坦）', 'sccj_beyyyxgswtbeyybjyxgsqdfgs', 'H10970410', 3, '', 'bzdw_h', 'zxdw_p', 6, 'jldw_mg', 10.00, '10.00mg*6片/盒', 'kf', 10.0000, '', '', 'mr1c', 1, 18.6200, 21.4000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 10, 2, NULL, '2018-05-24 14:15:42', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (63, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000205', '3Mznbd', '3M自粘绷带', 'sccj_3Mzg', '', 3, '', 'jjdw_j', '', 1, '', 0.00, '10cm*4.5m', '', 0.0000, '', 'ml', '', 1, 45.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (73, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001702', 'slsgj', '塑料试管架', 'sccj_jsckylypyxgs		', '-', 3, '', 'jjdw_t', '', 1, '', 0.00, '套', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (83, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_kfy', 'ZKM00000504', 'rgtkfry（dmk）', '乳果糖口服溶液（杜密克）', 'sccj_hl', 'H20120387', 3, '', 'bzdw_h', 'zxdw_d', 6, 'jldw_ml', 15.00, '15.00ml*6袋/盒', '', 0.0000, '', '', '', 1, 35.2000, 49.2800, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 2, NULL, '2018-04-19 10:41:05', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (93, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001246', 'fwc', '凤尾草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0550, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (103, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_klj', 'ZKM00001659', 'wskl（wtx）', '胃苏颗粒（无糖型）', 'sccj_yzjyyjtjszygfyxgs', 'Z10950007', 3, '', 'bzdw_h', 'zxdw_d', 9, 'jldw_g', 5.00, '5.00g*9袋/盒', 'kf', 5.0000, '', '', 'mr3c', 1, 0.0000, 22.2400, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-05-24 10:58:41', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (113, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000489', 'xsgyzsy', '硝酸甘油注射液', 'sccj_bjymyyyxgs', 'H11020289', 3, '', 'bzdw_z', 'zxdw_ml', 1, 'jldw_mg', 5.00, '5.00mg*1ml/支', 'Ivgtt', 5.0000, '', '', 'Prn', 1, 1.0700, 1.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 100, 10, NULL, '2018-04-19 13:35:15', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (123, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001421', 'xsgyp', '硝酸甘油片', 'sccj_bjymyyyxgs', '国药准字H11021022', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_hk', 0.50, '0.50毫克*100片/瓶', 'prad', 0.5000, '', '', 'Prn', 2, 0.1200, 0.1700, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 2, 1, NULL, '2018-04-08 17:02:31', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (133, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001236', 'hyw	', '换药碗	', 'sccj_caxdfzxyylqxc		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '14CM', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (143, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_wy', 'ZKM00000273', 'dgeqt', '丁桂儿脐贴', 'sccj_ybyyjtgfyxgs', '', 3, '', 'bzdw_h', 'zxdw_t', 2, 'jldw_g', 1.60, '1.6g*2贴/盒', '', 0.0000, '', '', '', 1, 12.8000, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 14:49:12', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (153, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000115', 'ssdb', '手术刀柄', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (163, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001238', 'ygg	', '油膏缸	', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '8cm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (173, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001335', 'ydszwxxdd', '移动式紫外线消毒灯', 'sccj_jyfy', '-', 3, '', 'jjdw_t_148', '', 1, '', 0.00, '江阴飞扬FY-30DC', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (183, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000424', 'ltsmp(dx)', '铝碳酸镁片(达喜)', 'sccj_beyybjyxgs', 'H20013410', 3, '', 'bzdw_h', 'zxdw_k', 20, 'jldw_p', 1.00, '1.00片*20捆/盒', 'ad us.int', 1.0000, '', '', 'TID', 1, 18.5200, 25.9300, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 3, NULL, '2018-06-12 16:01:01', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (193, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_kfy', 'ZKM00001604', 'sds', '十滴水', 'sccj_gxcfyygfyxgs', '170508', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_ml', 5.00, '5.00ml*10支/盒', '', 0.0000, '', '', '', 1, 0.0000, 1.9800, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-06-15 14:10:25', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (203, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_sj', 'ZKM00001579', 'kmzs', '克霉唑栓', 'sccj_hbdxyyyxgs', '国药准字H42021785', 3, '', 'bzdw_h', 'zxdw_l', 10, 'jldw_g', 0.15, '0.15g*10粒/盒', '', 0.0000, '', '', '', 1, 3.7000, 3.7000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (213, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_klj', 'ZKM00000134', 'lbwlkl', '利巴韦林颗粒', 'sccj_hnqjxjyygfyxgs', '国药准字H20044779', 3, '', 'bzdw_h', 'zxdw_d', 36, 'jldw_mg', 50.00, '50.00mg*36袋/盒', '', 0.0000, '', '', '', 1, 8.6000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 13:47:20', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (223, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_cj_1', 'ZKM00000226', 'bstpyyezcg', '百舒堂牌婴幼儿紫草膏', 'sccj_jxrlsyyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 1, 'jldw_g', 15.00, '15.00g*1支/盒', '', 0.0000, '', '', '', 1, 3.8000, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-10-17 14:10:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (233, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000347', 'afghcrjn1', '阿法骨化醇软胶囊1', 'sccj_kmbkndzyyxgs', '国药准字j20130162', 3, '', 'bzdw_h', 'zxdw_l', 20, 'jldw_ug', 0.25, '0.25ug*20粒/盒', '', 0.0000, '', '', '', 1, 43.9500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 13:49:23', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (243, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001096', 'sr', '砂仁', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 2.2400, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (253, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001306', 'dzs', '煅赭石', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0300, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (263, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000553', 'yj', '郁金', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.2110, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:30:37', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (273, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_w', 'ZKM00001587', 'wszyw', '乌蛇止痒丸', 'sccj_gzbysmxzyyxgs', 'X00013', 3, '', 'bzdw_h', 'zxdw_kg_g', 30, 'jldw_w', 1.00, '1.00丸*30g/盒', '', 0.0000, '', '', '', 1, 15.5000, 13.4300, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-14 15:23:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (283, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000105', 'yjj（dzd）', '牙胶尖（大锥度）', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (293, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000572', 'ggczK3', '根管锉针K3', 'sccj_Ormcocorporat Ion Also sa ', '国械注进2017555068', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm混', '', 0.0000, '', 'ml', '', 1, 0.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 08:51:27', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (303, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000707', 'fl', '茯苓', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.1680, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 17:35:22', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (313, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_cj', 'ZKM00000221', 'kfbyy', '口服补液盐', 'sccj_xaajyyyxgs', 'H20090205', 3, '', 'bzdw_h', 'zxdw_d', 6, 'jldw_g', 5.12, '5.12g*6袋/盒', '', 0.0000, '', '', '', 1, 32.4200, 45.3900, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-09 10:35:40', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (323, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000809', 'btw', '白头翁', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.2020, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (333, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000848', 'ycxsyjmlzz', '一次性使用静脉留置针', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '22G,50支/盒,Y型', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (343, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001014', 'jgscz', '金刚砂车针', 'sccj_w', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'TF-12', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (353, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000913', 'lyr', '龙眼肉', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.2910, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (363, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000682', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'F0-54C(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (373, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001240', 'bql', '白屈莱', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0540, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (383, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001868', 'ffhlsp', '复方黄连素片', 'sccj_scjyszy', 'Z51021798', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 30.00, '30mg*100片/瓶', '', 0.0000, '', '', '', 1, 0.0000, 11.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (393, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000961', 'ycxsyxtg', '一次性使用吸痰管', 'sccj_w', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '100支/包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (403, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001250', 'ycxsywjydkzq	', '一次性使用无菌阴道扩张器	', 'sccj_ncymyywcyxgs		', '-', 3, '', 'jjdw_z_5693', '', 1, '', 0.00, '中号A型转轴式400只/件', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (413, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000361', 'jssmtlep', '酒石酸美托洛尔片', 'sccj_aslkzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_mg', 50.00, '50.00mg*20片/盒', '', 0.0000, '', '', '', 1, 12.4000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (423, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000771', 'wztp', '网状托盘', 'sccj_rxckclyxgs', '沪食药监械', 3, '', 'jjdw_f_3720', '', 1, '', 0.00, '前口', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (433, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000839', 'smy', '生没药', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.5970, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-03-07 13:59:26', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (443, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000477', 'adtzsy', '胺碘酮注射液', 'sccj_dd', '', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_mg', 150.00, '150.00mg*1支/支', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (453, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001095', 'tzczq90°', '探针持针器90°', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, 'PiezonMaster700', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (463, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000757', 'jbs', '焦白芍', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0900, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (473, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001455', 'basajzym（ALT）cdsjh	', '丙氨酸氨基转移酶（ALT）测定试剂盒	', 'sccj_szmr', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (483, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000061', 'pgs', '抛光刷', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (493, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001839', 'yn', '印泥', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (503, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000833', 'll', '漏芦', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0840, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (513, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001133', 'dymydgwdzsjmgD', '第一磨牙单管网底直丝颊面管D', 'sccj_hzxyckclyxgs', '浙械注准20172631234', 3, '', 'jjdw_d', '', 1, '', 0.00, '62BK-20J-36(20*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-04 16:45:42', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (523, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000025', 'bxgfp', '不锈钢方盘', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (533, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001221', 'cmjz', '炒蔓荆子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0840, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (543, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_klj', 'ZKM00001708', 'xeafhnmkl（tcw）', '小儿氨酚黄那敏颗粒（甜橙味）', 'sccj_hrsj', 'H11022051', 3, '', 'bzdw_h', 'zxdw_d', 10, 'jldw_g', 6.00, '6.00g*10袋/盒', 'kf', 6.0000, '', '', 'mr3c', 1, 0.0000, 7.9000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 10:15:29', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (553, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00001683', 'xryybtxary（aql）', '吸入用异丙托溴铵溶液（爱全乐）', 'sccj_Alcon Laboratories, Inc（mg）', 'h20150158', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_ml', 2.00, '2.00ml*10支/盒', '', 0.0000, '', '', '', 2, 0.0000, 3.8200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (563, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001080', 'bllzsmt', '玻璃离子水门汀', 'sccj_w', '-', 3, '', 'jjdw_t', '', 1, '', 0.00, 'A2', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (573, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000506', 'wblxzet', '王不留行籽耳贴', 'sccj_dd', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '600粒/包', '', 0.0000, '', 'ml', '', 1, 14.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (583, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_cj', 'ZKM00000051', 'xqydsp', '熊去氧胆酸片', 'sccj_jsphksyyyxgs(yjsksyyyxgs)', 'h32023777', 3, '', 'bzdw_p', 'zxdw_p', 30, 'jldw_mg', 50.00, '50.00mg*30片/瓶', '', 0.0000, '', '', '', 1, 7.4000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:03:42', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (593, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dyj', 'ZKM00001865', 'swzcbpdyy（zsm）', '四味珍层冰硼滴眼液（珍视明）', 'sccj_gyjtgryy', 'Z10880003', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 8.00, '8.00ml*1支/支', '', 0.0000, '', '', '', 1, 0.0000, 12.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-06-28 11:17:06', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (603, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000483', 'jpajh', '极品艾灸盒', 'sccj_bjkydylypc', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '双孔', '', 0.0000, '', 'ml', '', 1, 30.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (613, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001240', 'xtcsz  lr	', '血糖测试纸  灵睿	', 'sccj_akswjs（hz）yxgs		', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '单人份25人份/盒配针', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (623, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ghxj', 'ZKM00001709', 'tbklghxj（xkl）', '头孢克洛干混悬剂（希刻劳）', 'sccj_llszzyyxgs', 'H0983028', 3, '', 'bzdw_h', 'zxdw_d', 6, 'jldw_mg', 125.00, '125.00mg*6袋/盒', 'kf', 125.0000, '', '', 'mr2c', 1, 0.0000, 22.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 6, 2, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (633, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tj', 'ZKM00001869', 'tqbt（tmx）', '通气鼻贴（透明型）', 'sccj_zmtjskzyyxgs', '2660004', 3, '', 'bzdw_h', 'zxdw_p', 10, 'jldw_t', 1.00, '1贴*10片/盒', '', 0.0000, '', '', '', 1, 0.0000, 13.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (643, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001332', 'ddxtq', '电动吸痰器', 'sccj_shyy', '-', 3, '', 'jjdw_t_148', '', 1, '', 0.00, '上海鱼跃7E-A', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (653, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001402', 'ycxfflnd', '一次性防返流尿袋', 'sccj_zjssd			', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '1000ml*20支/包带夹子', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (663, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pwj', 'ZKM00001440', 'bdndbpwj（lnkt）', '布地奈德鼻喷雾剂（雷诺考特）', 'sccj_aslkzyyxgs', '国药准字J20f140048', 3, '', 'bzdw_h', 'zxdw_p_2495', 120, 'jldw_μg', 64.00, '64.00μg*120喷/盒', '', 0.0000, '', '', '', 1, 64.9600, 90.9000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 1, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (673, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001074', 'knzst', '口内注射头', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '988-0172，黄', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (683, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001683', 'jgst（dm）F304L', '金刚砂条（单面）F304L', 'sccj_mghc', '', 3, '', 'jjdw_g', '', 1, '', 0.00, '根', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (693, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001010', 'ggc', '根管锉', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, 'MANIK-FILES10#-25mm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (703, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_w', 'ZKM00001385', 'sx', '麝香', 'sccj_trt', '', 3, '', 'bzdw_h', 'zxdw_kg_g', 3, 'jldw_g', 3.00, '3g/盒', '', 3.0000, '', '', '', 1, 1350.0000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-03-15 09:42:29', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (713, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000162', 'bxgfpdg，ylpxdqx', '不锈钢方盘带盖，用来泡消毒器械', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (723, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001741', 'ffbtmszsy（dbs）', '复方倍他米松注射液（得宝松）', 'sccj_hzmsdzyyxgs', 'J20140160', 3, '', 'bzdw_z', 'zxdw_ml', 1, 'jldw_mg', 5.00, '5.00mg*1ml/支', 'jrzs', 5.0000, '', '', 'mr1c', 1, 0.0000, 71.4000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 3, 1, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (733, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000968', 'bj', '白及', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 2.5200, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (743, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000208', 'ajsxdnj', '安捷手消毒凝胶', 'sccj_sdajgkxdkjyxgs', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '1L', '', 0.0000, '', 'ml', '', 1, 40.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (753, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001826', 'jxzp', '甲硝唑片', 'sccj_gdhnyyjtyxgs', 'H44020769', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_g', 0.20, '0.20g*100片/瓶', '', 0.0000, '', '', '', 2, 0.0000, 0.0600, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (763, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000496', 'yybd', '医用冰袋', 'sccj_an', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '200克', '', 0.0000, '', 'ml', '', 1, 14.4000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (773, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001332', 'fs', '佛手', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.3920, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (783, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000680', 'dlc', '煅龙齿', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.6750, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (793, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_klj', 'ZKM00000345', 'dshxp（typ）', '独圣活血片（糖衣片）', 'sccj_tjjtscmyzyyxgs', '国药准字z51020241', 3, '', 'bzdw_h', 'zxdw_p', 27, 'jldw_g', 0.40, '0.40g*27片/盒', '', 0.0000, '', '', '', 1, 25.0700, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-25 13:47:31', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (803, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001022', 'A5sfm', 'A5塑封膜', 'sccj_amzyc', '', 3, '', 'bzdw_b', 'zxdw_b', 1, '', 0.00, '1包/包', '', 0.0000, '', 'ml', '', 2, 29.0000, 29.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (813, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001640', 'tqbyp（TX）', '通窍鼻炎片（TX）', 'sccj_jlswtgkyyyxgs', '20171003', 3, '', 'bzdw_h', 'zxdw_p', 36, 'jldw_p', 1.00, '1.00片*36片/盒', '', 0.0000, '', '', '', 1, 0.0000, 17.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (823, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000796', 'ckt（TX）', '创口贴（TX）', 'sccj_w', '-', 3, '', 'jjdw_p_10962', '', 1, '', 0.00, '50*1盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-14 16:31:17', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (833, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001630', 'bxgfsly19*25x', '不锈钢方丝卵圆19*25下', 'sccj_shamdclljgfyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (843, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000713', 'jykkz', '机用扩孔钻', 'sccj_MANI', '国械注进20152551636', 3, '', 'jjdw_h', '', 1, '', 0.00, 'G28mm-1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 09:30:20', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (853, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000806', 'mhl', '墨旱莲', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0390, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (863, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_hxj', 'ZKM00000023', 'zy2', '中药2', 'sccj_hrsj', '', 3, '', 'bzdw_b', 'zxdw_kg_g', 1, 'jldw_g', 10.00, '10.00g*1g/包', '', 0.0000, '', '', '', 1, 0.0000, 12.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (873, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hxj', 'ZKM00000225', 'dplthxy', '多潘立酮混悬液', 'sccj_xayszyyxgs', '国药准字h10910084', 3, '', 'bzdw_h', 'zxdw_ml', 100, 'jldw_ml', 1.00, '1.00ml*100ml/盒', '', 0.0000, '', '', '', 1, 16.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:36:52', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (883, 'bgyplb_yyzflcl', 3, 1, 'bgyplb_yyzflcl', '', 'ZKM00001506', 'nysbdy（Lm）', '男医生白大衣（L码）', 'sccj_amzyc', NULL, 3, '', 'bzdw_j_4203', 'zxdw_j_2903', 1, '', 0.00, '1件/件', '', 0.0000, '', 'ml', '', 2, 130.0000, 130.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (893, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000388', 'fbsyqxrq', '浮标式氧气吸入器', 'sccj_hbhsbhxqtdylqxc', '', 3, '', 'jjdw_t', '', 1, '', 0.00, 'DY-C型15L', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (903, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000513', 'tmskfsflt', '透明伤口防水敷料贴', 'sccj_3M', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '10*12cm', '', 0.0000, '', 'ml', '', 1, 8.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (913, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000565', 'lq', '连翘', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2580, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:32:21', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (923, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000770', 'qj', '秦艽', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.8960, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (933, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000859', 'jcgxjymcl', '加成硅橡胶印模材料', 'sccj_w', '-', 3, '', 'jjdw_t', '', 1, '', 0.00, '4支*50ml', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (943, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_sj_1', 'ZKM00001789', 'dgy1%', '碘甘油1%', 'sccj_shyjhpzyyxgs', 'H31021302', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 20.00, '20.00ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 0.0000, 4.8100, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (953, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00001432', 'amxljn（amx）', '阿莫西林胶囊（阿莫仙）', 'sccj_zhlbzygfyxgszsfgs', '国药准字H44021351', 3, '', 'bzdw_h', 'zxdw_l', 24, 'jldw_g', 0.25, '0.25g*24粒/盒', 'kf', 0.5000, '', '', 'm8xsyc', 1, 11.8000, 16.5200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 14:32:43', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (963, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001035', 'qb（HB）', '铅笔（HB）', 'sccj_amzyc', '', 3, '', 'bzdw_h', 'zxdw_z', 12, '', 0.00, '12支/盒', '', 0.0000, '', 'ml', '', 2, 0.2300, 0.2300, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (973, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001254', 'sc', '水葱', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (983, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001184', 'ycxsyjmxycjrq（fwj）', '一次性使用静脉血样采集容器（非无菌）', 'sccj_hbxlylqxkjgfyxgs', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '柠檬酸钠4NC(3.8%)(黑）2ml*100支/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (993, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000533', 'basajzymcdsjh（basdwf）', '丙氨酸氨基转移酶测定试剂盒（丙氨酸底物法）', 'sccj_glyltyldzyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '40ml*320ml*3', '', 0.0000, '', 'ml', '', 1, 122.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1003, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_cj', 'ZKM00000151', 'xyldp（typ）', '消炎利胆片（糖衣片）', 'sccj_gdwnqzyyxgs', '国药准字Z44023159', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_p', 100.00, '100.00片*1瓶/瓶', '', 0.0000, '', '', '', 1, 7.8300, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:45:40', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1013, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000591', 'jhj', '酒黄精', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.3580, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:34:57', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1023, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_klj', 'ZKM00000160', 'pskl', '排石颗粒', 'sccj_jxncjszyc', 'z20044192', 3, '', 'bzdw_h', 'zxdw_d', 10, 'jldw_g', 5.00, '5.00g*10袋/盒', '', 0.0000, '', '', '', 1, 16.7100, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:46:40', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1033, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001793', 'bhsaldpp（lhx）', '苯磺酸氨氯地平片（络活喜）', 'sccj_hrzyyxgs', 'H10950224', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_mg', 5.00, '5.00mg*7片/盒', '', 0.0000, '', '', '', 1, 0.0000, 33.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1043, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000825', 'ff', '蜂房', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 1.3310, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1053, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001233', 'ghxg', '广藿香梗', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0730, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1063, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_kfy', 'ZKM00000215', 'pdlxykfy（yy））', '蒲地蓝消炎口服液（医院））', 'sccj_jczyyxgs', 'Z20030095', 3, '', 'bzdw_h', 'zxdw_z', 6, 'jldw_ml', 10.00, '10.00ml*6支/盒', '', 0.0000, '', '', '', 1, 24.3000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:47:19', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1073, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000261', 'pttzsy(5%)', '葡萄糖注射液(5%)', 'sccj_scklyygfyxgs', '', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 500.00, '500ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 1.3000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 15:03:24', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1083, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001372', 'ycxsyyyxjjcst', '一次性使用医用橡胶检查手套', 'sccj_amksmyyxgs		', '-', 3, '', 'jjdw_x', '', 1, '', 0.00, '中（6.2）100只每盒10盒每箱（无粉、麻面耐用型）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1093, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000266', 'glczsy(sp)', '甘露醇注射液(塑瓶)', 'sccj_sdqdyyyxgs', '', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 250.00, '250ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 2.1500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 15:04:40', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1103, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000058', '  lydsks', '  氯已定漱口水', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '200ML', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1113, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000707', 'yhjl（8*1）', '咬合记录（8*1）', 'sccj_dgDMGhxyyjtgs', '国食药监械（进）字2014第2631872', 3, '', 'jjdw_z', '', 1, '', 0.00, '909767', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 10:05:11', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1123, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000972', 'hsljtjt', '灰色垃圾桶脚踏', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '20L', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1133, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000890', 'yksg（wmcysg）', '牙科石膏（唯美超硬石膏）', 'sccj_w', '-', 3, '', 'jjdw_b', '', 1, '', 0.00, '紫色1kg/包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1143, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000993', 'zhc', '紫河车', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 4.8160, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1153, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000196', 'afghcrjn', '阿法骨化醇软胶囊', 'sccj_kmbkndzyyxgs', '国药准字j2013062', 3, '', 'bzdw_h', 'zxdw_l', 20, 'jldw_ug', 0.25, '0.25ug*20粒/盒', '', 0.0000, '', '', '', 1, 44.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:51:21', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1163, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001448', 'ycxsywlcxxg	', '一次性使用微量采血吸管	', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_t_5432', '', 1, '', 0.00, '桶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1173, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001619', 'cxp（2.0mm）', '成型片（2.0mm）', 'sccj_Ultradert product Inc', '', 3, '', 'jjdw_zhang', '', 1, '', 0.00, '张', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1183, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001121', 'cbs', '炒白芍', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.1570, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1193, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001554', 'gfzbd 3c', '高分子绷带 3寸', 'sccj_ssdt', '-', 3, '', 'jjdw_j', '', 1, '', 0.00, '卷', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1203, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001044', 'gzd', '盖章垫', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 17.0000, 17.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1213, 'bgyplb_ycxcl', 3, 1, 'bgyplb_ycxcl', '', 'ZKM00001494', 'kfjbb', '咖啡搅拌棒', 'sccj_amzyc', NULL, 3, '', 'bzdw_b', 'zxdw_z', 100, '', 0.00, '100支/包', '', 0.0000, '', 'ml', '', 2, 0.1200, 0.1200, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-08-27 15:23:01', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1223, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000109', 'yxgzq', '龈下刮治器', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1233, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000142', 'blzsq', '碧兰注射器', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1243, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001330', 'dkc', '倒扣草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0300, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1253, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001155', 'dx', '丁香', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.3080, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1263, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000036', 'mkp', '磨口瓶', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '透明', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1273, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000418', 'ycxsywjzsq dz', '一次性使用无菌注射器 带针', 'sccj_shkdlqyfzjtgfyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '1ml', '', 0.0000, '', 'ml', '', 1, 0.3000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 16:28:51', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1283, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000288', 'ffafwap', '复方氨酚烷胺片', 'sccj_jlswtgkyyyxgs', 'h22026193', 3, '', 'bzdw_h', 'zxdw_h', 1, 'jldw_p', 12.00, '12.00片*1盒/盒', '', 0.0000, '', '', '', 1, 12.6000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:55:56', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1293, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000639', 'dd', '刀豆', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0900, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1303, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000264', 'fflhnzsy', '复方氯化钠注射液', 'sccj_scklyygfyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_ml', 500.00, '500ml*1袋/袋', '', 0.0000, '', '', '', 1, 3.7400, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 15:04:13', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1313, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_wj', 'ZKM00000189', 'ddw', '跌打丸', 'sccj_bjtrtkjfzgfyxgs', 'z11020484', 3, '', 'bzdw_h', 'zxdw_w', 6, 'jldw_g', 3.00, '3.00g*6丸/盒', '', 0.0000, '', '', '', 1, 5.4000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:59:02', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1323, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001346', 'ytz', '芸薹子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0900, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1333, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_ryj', 'ZKM00000847', 'cjmz', '炒决明子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0270, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-24 16:46:01', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1343, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001021', 'twq', '剔挖器', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '八角柄整体型式E1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1353, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001257', 'fhdwq1712323	', '防护短围裙1712323	', 'sccj_szhkylqxyxgs		', '-', 3, '', 'jjdw_j_8137', '', 1, '', 0.00, '0.50铅当量', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1363, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001355', 'sddtdktwlyyq', '手动单通道可调微量移液器', 'sccj_dlxcsyyq（bj）yxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '0.5-10μl', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1373, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000531', 'yyycxbpd', '医用一次性备皮刀', 'sccj_yzst', '', 3, '', 'jjdw_z_5693', '', 1, '', 0.00, '均码', '', 0.0000, '', 'ml', '', 1, 2.1500, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 200, 10, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1383, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_rj', 'ZKM00001860', 'cpcs', '产品测试', 'sccj_hnqxzyyxgs', '', 3, '', 'bzdw_s', 'zxdw_kg_g', 50, 'jldw_g', 3.00, '3g/包', '', 0.0000, '', '', '', 1, 0.0000, 50.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1393, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000016', 'jmcxz', '静脉采血针', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_d', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1403, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001048', 'gtjb', '固体胶棒', 'sccj_amzyc', '', 3, '', 'bzdw_z_8915', 'zxdw_z', 12, '', 0.00, '12支/组', '', 0.0000, '', 'ml', '', 2, 1.2000, 1.2000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1413, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000414', 'bszdsdt', '笔式诊断手电筒', 'sccj_nbjygdyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, 'V7黑色白光', '', 0.0000, '', 'ml', '', 1, 10.0000, 0.0000, 'fylb_zcf', 'fpxm_zcf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1423, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001503', 'yhjkcybsb', '义获嘉烤瓷牙比色板', 'sccj_lz/wwdt', '-', 3, '', 'jjdw_k_7001', '', 1, '', 0.00, '块', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1433, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000550', 'fft', '防风炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.2100, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:46:54', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1443, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000442', 'ycxsyzlj', '一次性使用治疗巾', 'sccj_hnydsyyxgs', '', 3, '', 'jjdw_k_7001', '', 1, '', 0.00, 'I型60*40', '', 0.0000, '', 'ml', '', 1, 0.4600, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-10 22:57:34', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1453, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000590', 'smt', '升麻炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1750, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:45:02', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1463, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001711', 'txzp', '替硝唑片', 'sccj_sdlkyyjtstgs', 'H20033090', 3, '', 'bzdw_h', 'zxdw_p', 8, 'jldw_g', 0.50, '0.50g*8片/盒', 'kf', 2.0000, '', '', 'mr1c', 1, 0.0000, 3.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 10:21:24', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1473, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_xry', 'ZKM00001436', 'aqmsp(xsm)', '阿奇霉素片(希舒美)', 'sccj_hrzyyxgs', 'H10960167', 3, '', 'bzdw_h', 'zxdw_p', 4, 'jldw_g', 0.25, '0.25g*4片/盒', 'kf', 0.2500, '', '', 'mr1c', 1, 41.7300, 58.4200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 4, NULL, '2018-05-24 14:38:24', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1483, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000507', 'cxb', '采血笔', 'sccj_dd', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '-', '', 0.0000, '', 'ml', '', 1, 52.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1493, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_klj', 'ZKM00000079', 'blgkl', '板蓝根颗粒', 'sccj_scjyszyyxgs', '', 3, '', 'bzdw_b', 'zxdw_d', 20, 'jldw_g', 5.00, '5g*20袋/包', '', 0.0000, '', '', '', 1, 7.0000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 13:32:38', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1503, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dyj', 'ZKM00001635', 'sgsndyy（TX）', '色甘酸钠滴眼液（TX）', 'sccj_hbkl', '170601', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 0.80, '0.80ml*1支/支', '', 0.0000, '', '', '', 1, 0.0000, 2.4800, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1513, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001499', 'nn', '牛奶', 'sccj_amzyc', NULL, 3, '', 'bzdw_x', 'zxdw_h', 16, '', 0.00, '16盒/箱', '', 0.0000, '', 'ml', '', 2, 68.9000, 68.9000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1523, 'bgyplb_dzl', 3, 1, 'bgyplb_dzl', '', 'ZKM00001491', 'hyd', '会议垫', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 19.0000, 19.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1533, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000335', 'zzn', '组织镊', 'sccj_shylqx（jt）yxgsssqxc', '', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'J4105014CM1x2钩', '', 0.0000, '', 'ml', '', 1, 17.8400, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1543, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000308', 'qlsqp', '氢氯噻嗪片', 'sccj_sxypzyyxgs', '国药准字H14027096', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 25.00, '25.00mg*100片/瓶', '', 0.0000, '', '', '', 1, 1.3500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:12:33', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1553, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001517', 'qyxmhgzsy（xdl）', '去乙酰毛花苷注射液（西地兰）', 'sccj_shxdhpyyyxgs', 'H31021178', 3, '', 'bzdw_z', 'zxdw_ml', 2, 'jldw_mg', 0.40, '0.40mg*2ml/支', 'Iv', 0.4000, '', '', 'Q2h', 1, 68.0000, 95.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 5, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1563, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hxj', 'ZKM00000223', 'aqmsghxj', '阿奇霉素干混悬剂', 'sccj_hrzyyxgs', '国药准字H10960112', 3, '', 'bzdw_h', 'zxdw_d', 6, 'jldw_g', 0.10, '0.10g*6袋/盒', '', 0.0000, '', '', '', 1, 34.5800, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 16:01:52', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1573, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000738', 'dzy', '杜仲叶', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0400, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1583, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000819', 'fgls', '覆盖螺丝', 'sccj_EA', '--', 3, '', 'jjdw_d', '', 1, '', 0.00, 'CS38', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1593, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000696', 'hz', '虎杖', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0620, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1603, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_kfy', 'ZKM00000471', 'byskfy（wtx）', '鼻渊舒口服液（无糖型）', 'sccj_dd', '', 3, '', 'bzdw_h', 'zxdw_z', 6, 'jldw_ml', 10.00, '10.00ml*6支/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 2, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1613, 'bgyplb_gdzc', 3, 1, 'bgyplb_gdzc', '', 'ZKM00001754', 'csjyj', '超声洁牙机', 'sccj_amzyc', NULL, 3, '', 'bzdw_t_9258', 'zxdw_t_6854', 1, '', 0.00, '1台/台', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1623, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001536', 'slzsb', '视力指示笔', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_g', '', 1, '', 0.00, '根', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1633, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsp', 'ZKM00000028', 'ze2', '周二2', 'sccj_hrsj', '', 3, '', 'bzdw_b', 'zxdw_l', 10, 'jldw_g', 25.00, '25.00g*10粒/包', '', 0.0000, '', '', '', 1, 0.0000, 25.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1643, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000955', 'PEjcst', 'PE检查手套', 'sccj_cdswsclc', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, 'M号', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1653, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001659', 'xxbfxyyzkw（gz）-3ml', '血细胞分析仪用质控物（高值）-3ml', 'sccj_glyltyldzyxgs', '2400121', 3, '', 'jjdw_z', '', 1, '', 0.00, '支', '', 0.0000, '', 'ml', '', 1, 0.0000, 220.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1663, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000784', 'gc', '甘草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1340, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1673, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001289', 'wjst7h', '无菌手套7号', 'sccj_shkb', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '无粉,1副/包,50包/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1683, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000153', 'tzm', '脱脂棉', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_d', '', 1, '', 0.00, '500g', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1693, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000679', 'jxd', '酒续断', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1250, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1703, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000614', 'mjlm', '妙蒺藜面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0420, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1713, 'bgyplb_sbwxpjlcl', 3, 1, 'bgyplb_sbwxpjlcl', '', 'ZKM00001469', 'jp', '键盘', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1723, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000439', '3Mtxmrkjd', '3M弹性棉柔宽胶带', 'sccj_3M  Japan Limited Health', '', 3, '', 'jjdw_j', '', 1, '', 0.00, '5*5cm', '', 0.0000, '', 'ml', '', 1, 75.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1733, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_pj', 'ZKM00000180', 'bykp', '鼻炎康片', 'sccj_gyjtdz（fs）yyyxgs', '', 3, '', 'bzdw_p', 'zxdw_p', 72, 'jldw_g', 0.37, '0.37g*72片/瓶', '', 0.0000, '', '', '', 1, 17.2000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 14:16:36', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1743, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001686', 'jglxdkd', '技工蜡型雕刻刀', 'sccj_w', '17-11', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '把', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1753, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000063', 'ysp', '叶酸片', 'sccj_jslhyygfyxgs', 'h20044917', 3, '', 'bzdw_h', 'zxdw_p', 93, 'jldw_mg', 0.40, '0.40mg*93片/盒', '', 0.0000, '', '', '', 1, 9.8000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 16:06:21', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1763, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_sj_2', 'ZKM00001799', 'ffjyecdjzs（fjq）', '复方聚乙二醇电解质散（福静清）', 'sccj_fgBeaufour Ipsen Industrie', 'H20140560', 3, '', 'bzdw_h', 'zxdw_h', 1, 'jldw_b', 4.00, '4.00包*1盒/盒', 'kf', 4.0000, '', '', 'ljzx', 1, 0.0000, 163.8000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, NULL, '2018-06-12 15:06:16', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1773, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001302', 'sph', '生蒲黄', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.3360, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1783, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001493', 'scbjd', '丝绸布胶带', 'sccj_3M', '-', 3, '', 'jjdw_j', '', 1, '', 0.00, '卷', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1793, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000188', 'xmtdjn', '西咪替丁胶囊', 'sccj_cqkrzy(jt)yxgs', 'h50020247', 3, '', 'bzdw_h', 'zxdw_l', 60, 'jldw_g', 0.20, '0.20g*60粒/盒', '', 0.0000, '', '', '', 1, 12.8800, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 16:07:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1803, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000360', 'dtxyjcy', '动态血压监测仪', 'sccj_yghmgjyxgsbjdbc', '', 3, '', 'jjdw_t_148', '', 1, '', 0.00, 'ri-cardio(1760)', '', 0.0000, '', 'ml', '', 1, 9000.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1813, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000905', 'msbp', '蜜桑白皮', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1120, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1823, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001325', 'aedxdy', '安尔碘消毒液', 'sccj_shlk', '-', 3, '', 'jjdw_x', '', 1, '', 0.00, '上海利康环60ml（100瓶/箱）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1833, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_klj', 'ZKM00001720', 'jhkl', '橘红颗粒', 'sccj_htjtnnrszygs', 'Z45021543', 3, '', 'bzdw_h', 'zxdw_d', 15, 'jldw_g', 11.00, '11.00g*15袋/盒', 'kf', 11.0000, '', '', 'mr2c', 1, 0.0000, 8.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 10:52:49', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1843, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000696', 'ntysg', '镍钛圆丝弓', 'sccj_shamdclljgfyxgs', '沪械注准20162630198', 3, '', 'jjdw_d', '', 1, '', 0.00, '卵圆16U', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 09:36:43', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1853, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_kfy', 'ZKM00000304', 'pttsxkfry', '葡萄糖酸锌口服溶液', 'sccj_hbnlyyyxgs', '国药准字H20065564', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_ml', 10.00, '10.00ml*10支/盒', '', 0.0000, '', '', '', 1, 7.3000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-25 13:39:26', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1863, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_sj', 'ZKM00001812', 'ydmxs', '吲哚美辛栓', 'sccj_hbdxyygs', 'H42021462', 3, '', 'bzdw_h', 'zxdw_l', 10, 'jldw_g', 0.10, '0.10g*10粒/盒', '', 0.0000, '', '', '', 1, 0.0000, 2.9500, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1873, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000633', 'tbs', '土白芍', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1700, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1883, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000192', 'yyljd', '医用垃圾袋', 'sccj_bjjrkkjyxgs', '', 3, '', 'jjdw_k', '', 1, '', 0.00, '30L', '', 0.0000, '', 'ml', '', 1, 53.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-12 13:29:43', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1893, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000222', 'ycxsywjydszsq', '一次性使用无菌胰岛素注射器', 'sccj_mgBcctonDickinsonandComnanv', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '1ml0.33mm*12', '', 0.0000, '', 'ml', '', 1, 1.7000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1903, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000743', 'ggctq', '根管充填器', 'sccj_shkqylqxyxgs', '--', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '手用2型974-0059', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 14:16:21', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1913, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000826', 'wbz', '五倍子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1340, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1923, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000912', 'zbjt', '制巴戟天', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.5600, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1933, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001901', 'jfzp（hjq-G）', '吉法酯片（惠加强-G）', 'sccj_shryypzshs', 'H20160240', 3, '', 'bzdw_h', 'zxdw_p', 40, 'jldw_hk', 50.00, '50毫克*40片/盒', '', 0.0000, '', '', '', 1, 0.0000, 52.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1943, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000821', 'yhjt', '愈合基台', 'sccj_EA', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, 'HAB453050L', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1953, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001195', 'cjnjm', '醋鸡内金面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0410, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1963, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000133', 'cxpj', '成型片夹', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1973, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_njj', 'ZKM00001893', 'lkmsldkynj', '林可霉素利多卡因凝胶', 'sccj_shxyyymxyxgs', 'H31022635', 3, '', 'bzdw_p', 'zxdw_kg_g', 15, 'jldw_g', 0.00, '0.00g*15g/瓶', '', 0.0000, '', '', '', 1, 0.0000, 4.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-07-03 17:30:05', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1983, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tgj', 'ZKM00001417', '111', '111', 'sccj_lfskgzzpyxgs', '2222222222222222222', 3, '', 'bzdw_b_4606', 'zxdw_m_4363', 1, 'jldw_b_8396', 1.00, '1.00板*1米/板', 'ad us.int', 1.0000, '', '', 'Biw', 1, 10.0000, 1111.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (1993, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_zsj', 'ZKM00000539', 'ysadtzsj', '盐酸胺碘酮注射剂', 'sccj_snf（hz）zyyxgs', '7A018', 3, '', 'bzdw_z', 'zxdw_ml', 3, 'jldw_g', 0.15, '0.15g*3ml/支', '', 0.0000, '', '', '', 1, 155.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 1, 0, NULL, '2018-02-09 14:44:33', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2003, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_kfy', 'ZKM00000153', 'hjkfy', '化积口服液', 'sccj_ew(jx)zyyxgs(yjxdwyyyxgs)', 'z10890005', 3, '', 'bzdw_h', 'zxdw_z', 6, 'jldw_ml', 10.00, '10.00ml*6支/盒', '', 0.0000, '', '', '', 1, 7.1800, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 16:48:35', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2013, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000917', 'fstd', '富士调刀', 'sccj_w', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '蓝白', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2023, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000803', 'yysb10*10（TX）', '医用纱布10*10（TX）', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '8p*2片/袋', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-14 16:49:50', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2033, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001381', 'zzf', '珍珠粉', 'sccj_trt', '', 3, '', 'bzdw_hk', 'zxdw_kg_g', 3, 'jldw_g', 3.00, '3g/包', '', 3.0000, '', '', '', 1, 1.3500, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2043, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rg', 'ZKM00000115', 'nsrg', '尿素软膏', 'sccj_mylyyjtgfyxgs', '', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 10.00, '10g*1支/支', '', 0.0000, '', '', '', 1, 1.2500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 11:38:07', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2053, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000130', 'nfsxjn', '诺氟沙星胶囊', 'sccj_ybyyjtgfyxgs', '', 3, '', 'bzdw_h', 'zxdw_l', 24, 'jldw_g', 0.10, '0.1g*24粒/盒', '', 0.0000, '', '', '', 1, 1.7500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 10:46:50', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2063, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001649', 'sjqxrh350ml', '手机清洗润滑350ml', 'sccj_kdkjgygfyxgs', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2073, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000356', 'jhbxglb', '加厚不锈钢量杯', 'sccj_hnsjqylqxyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '1000ML', '', 0.0000, '', 'ml', '', 1, 140.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2083, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00001691', 'kfxy', '康复新液', 'sccj_hndnzy', 'Z43020995', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 120.00, '120.00ml*1瓶/瓶', 'kf', 10.0000, '', '', 'mr3c', 1, 0.0000, 37.4800, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 09:39:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2093, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000710', 'lg', '蝼蛄', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.8000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 17:30:18', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2103, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000934', 'yjj（jz-h）', '牙胶尖（简装-混）', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '15-40#100*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2113, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000781', 'ycxsykqqxh', '一次性使用口腔器械盒', 'sccj_jzshwylqxc', '翼石械备20170020', 3, '', 'jjdw_t', '', 1, '', 0.00, '8*1KQH-1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2123, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001194', 'wbzm', '五倍子面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0650, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2133, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001669', '60yB5bjb', '60页B5笔记本', 'sccj_amzyc', NULL, 3, '', 'bzdw_b_9413', 'zxdw_b_2375', 1, '', 0.00, '1本/本', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-18 13:39:36', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2143, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001110', 'ylr', '郁李仁', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.2240, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2153, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001203', 'ckt	', '创口贴	', 'sccj_ hsk', '-', 3, '', 'jjdw_p_10962', '', 1, '', 0.00, '50片/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2163, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001040', 'hmsmj', '海绵双面胶', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 1.5000, 1.5000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2173, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000853', 'ymcl（glz）', '研磨材料（矽离子）', 'sccj_tfyyjt', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '25*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2183, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001591', 'qxs', '器械刷', 'sccj_w', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '把', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2193, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000792', 'aedpfxdj（TX）', '安尔碘皮肤消毒剂（TX）', 'sccj_w', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '60ml*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2203, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000717', 'jykkz', '机用扩孔钻', 'sccj_MANI', '--', 3, '', 'jjdw_h', '', 1, '', 0.00, 'P28mm-1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2213, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000804', 'qct', '茜草炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.7280, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2223, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001211', 'ycxjmcxz', '一次性静脉采血针', 'sccj_jxhd		', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '100支/包（0.7）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2233, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001374', 'dmf', '玳瑁粉', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 3, 'jldw_g', 3.00, '3g/盒', '', 3.0000, '', '', '', 1, 21.6000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2243, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000727', 'Z250XTcgqdgmsz', 'Z250XT超高强度光敏树脂', 'sccj_3MESPE DENTAL PRODUCT', '--', 3, '', 'jjdw_z', '', 1, '', 0.00, '1470(A2)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2253, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001454', 'gbp	', '盖玻片	', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2263, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dyj', 'ZKM00001762', 'zsm（swzcbpdyy）', '珍视明（四味珍层冰硼滴眼液）', 'sccj_jxfeksyjtyxgs', '171002', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 13.00, '13.00ml*1支/支', '', 0.0000, '', '', '', 1, 0.0000, 12.7600, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2273, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000582', 'xtg', '吸唾管', 'sccj_ASA', '国械备20150684', 3, '', 'jjdw_d', '', 1, '', 0.00, '100*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2283, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001310', 'hzr', '诃子肉', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0780, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2293, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000358', 'zjssjqazsy', '重酒石酸间羟胺注射液', 'sccj_tjjyyyyxgs', 'H2020620', 3, '', 'bzdw_h', 'zxdw_z', 2, 'jldw_mg', 10.00, '10.00mg*2支/盒', '', 0.0000, '', '', '', 2, 49.0000, 60.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-22 10:15:55', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2303, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_dyj', 'ZKM00000035', 'tsdyy', '透视滴眼液', 'sccj_hrsj', 'PZWH027823', 3, '', 'bzdw_p', 'zxdw_kg_g', 20, 'jldw_ml', 20.00, '20.00g/瓶', '', 0.0000, '', '', '', 1, 0.0000, 20.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2313, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000090', 'kdz Rc 25mm', '扩大针 R锉 25mm', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2323, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001141', 'dymywdzsgtcC', '第一磨牙网底直丝弓托槽C', 'sccj_hzxyckclyxgs', '浙械注准20172631235', 3, '', 'jjdw_d', '', 1, '', 0.00, '8253-20B-46(20*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-04 17:02:43', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2333, 'bgyplb_sbwxpjlcl', 3, 1, 'bgyplb_sbwxpjlcl', '', 'ZKM00001468', 'sb', '鼠标', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2343, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001173', 'fbjyyclzz（cwq）', '粪便检验预处理装置（常卫清）', 'sccj_hznhjkkjyxgs', '浙杭械备20160367', 3, '', 'jjdw_h', '', 1, '', 0.00, '1人份/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2353, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001158', 'ycxsyzlj', '一次性使用治疗巾', 'sccj_bjgsyl', '-', 3, '', 'jjdw_zhang', '', 1, '', 0.00, '50cm*60cm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2363, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_kfy', 'ZKM00000314', 'yfwmkfry', '愈酚伪麻口服溶液', 'sccj_shqszyyxgs', 'H20050574', 3, '', 'bzdw_h', 'zxdw_p_1', 1, 'jldw_ml', 100.00, '100.00ml*1瓶/盒', '', 0.0000, '', '', '', 1, 20.7500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:16:31', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2373, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001316', 'gysmsblp', '枸橼酸莫沙必利片', 'sccj_lnbt', '国药准字H19990317', 3, '', 'bzdw_h', 'zxdw_p', 24, 'jldw_mg', 5.00, '5.00mg*24片/盒', '', 0.0000, '', '', '', 1, 19.0600, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:17:52', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2383, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001681', 'ttqjy（50ml*1）', '探头清洁液（50ml*1）', 'sccj_szmr', '2018061301', 3, '', 'jjdw_p', '', 1, '', 0.00, '瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2393, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000071', 'dscz', '低速车针', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2403, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001126', 'bllzsmt', '玻璃离子水门汀', 'sccj_3M Deutschlang GmbH', '国械进注20153632743', 3, '', 'jjdw_t', '', 1, '', 0.00, '56906', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2413, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001089', 'ypbjb（16k）', '硬皮笔记本（16k）', 'sccj_amzyc', '', 3, '', 'bzdw_b_9413', 'zxdw_b_2375', 1, '', 0.00, '1本/本', '', 0.0000, '', 'ml', '', 2, 25.9000, 25.9000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2423, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001239', 'qlg', '千里光', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0500, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2433, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001294', 'jj', '荆芥', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.0300, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2443, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000476', 'ssxszsy', '肾上腺素注射液', 'sccj_dd', '', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_mg', 1.00, '1.00mg*10支/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2453, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001305', 'lxg', '离心管', 'sccj_jskjylqxyxgs		', '-', 3, '', 'jjdw_b', '', 1, '', 0.00, '1.5ml抗凝，1000支/包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2463, 'yplb_zcy', 1, 0, 'yplb_zcy', 'ypjx_cj', 'ZKM00000043', '4', '4', 'sccj_adyy(bj)yxgs', ' 4', 3, '4', 'bzdw_h', 'zxdw_p_1', 1, 'jldw_ml', 500.00, '500.00ml*1瓶/盒', 'IH', 500.0000, '', '', 'bid', 1, 50.0000, 90.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 1, 0, 123, 12, NULL, '2017-12-28 23:15:07', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2473, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_jnj', 'ZKM00000138', 'ytnjn', '腰痛宁胶囊', 'sccj_jfkyyjtyxgs', '', 3, '', 'bzdw_h', 'zxdw_l', 20, 'jldw_g', 0.30, '0.3g*20粒/盒', '', 0.0000, '', '', '', 1, 19.9800, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 13:40:48', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2483, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001525', 'ssd', '手术单', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_k_7001', '', 1, '', 0.00, '块', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2493, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000798', 'mglz', '蜜瓜蒌子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.1900, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2503, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_wj', 'ZKM00000174', 'trwjbfw', '同仁乌鸡白凤丸', 'sccj_bjtrtgfyxgstrtzyc', '', 3, '', 'bzdw_h', 'zxdw_b', 1, 'jldw_g', 36.00, '36g*1包/盒', '', 0.0000, '', '', '', 1, 10.8000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 14:15:18', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2513, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001235', 'dqy', '大青盐', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.0220, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2523, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001548', 'gz  cr', '拐杖  成人', 'sccj_ssdt', '-', 3, '', 'jjdw_f_3720', '', 1, '', 0.00, '付', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2533, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001024', 'A4rrft', 'A4热熔封套', 'sccj_amzyc', '', 3, '', 'bzdw_b', 'zxdw_g', 10, '', 0.00, '10个/包', '', 0.0000, '', 'ml', '', 2, 1.6000, 1.6000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2543, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001637', 'ysxtlqp（TX）', '盐酸西替利嗪片（TX）', 'sccj_cdhrzyyxgs', '170808', 3, '', 'bzdw_h', 'zxdw_p', 16, 'jldw_mg', 10.00, '10.00mg*16片/盒', '', 0.0000, '', '', '', 1, 0.0000, 15.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2553, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_cj', 'ZKM00000280', 'ykxwssADdj(1sys)', '伊可新维生素AD滴剂(1岁以上)', 'sccj_sddyhyswzygfyxgs', 'h3702294', 3, '', 'bzdw_h', 'zxdw_h', 1, 'jldw_l', 20.00, '20.00粒*1盒/盒', '', 0.0000, '', '', '', 1, 14.0700, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:22:43', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2563, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000777', 'fy', '防已', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.5040, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2573, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000408', 'ycxsygcb', '一次性使用灌肠包', 'sccj_szwkylqxyxgs', '', 3, '', 'jjdw_z_5693', '', 1, '', 0.00, '1000ml/80', '', 0.0000, '', 'ml', '', 1, 5.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2583, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001075', 'A4fyz（ls）', 'A4复印纸（蓝色）', 'sccj_amzyc', '', 3, '', 'bzdw_b', 'zxdw_b', 1, '', 0.00, '1包/包', '', 0.0000, '', 'ml', '', 2, 14.9000, 14.9000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2593, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000992', 'jqm', '金荞麦', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.1010, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2603, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000585', 'bqg', '白茄根', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.1100, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2613, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001309', 'fpz', '覆盆子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 1.3440, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2623, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000228', 'ycxyyd', '一次性医用垫', 'sccj_xxsytylypyxgs', '', 3, '', 'jjdw_k_7001', '', 1, '', 0.00, '80*15010块/包', '', 0.0000, '', 'ml', '', 1, 1.7000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-24 10:05:03', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2633, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000592', 'Kc', 'K锉', 'sccj_xnddsb', '国械备20170214号', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm-10', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2643, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000924', 'cbj', '醋鳖甲', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.4910, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2653, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000029', 'lxj', '离心机', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, 'TD-400', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2663, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00001688', 'yslpdajn（ymt）', '盐酸洛哌丁胺胶囊（易蒙停）', 'sccj_xayszyyxgs', 'H10910085', 3, '', 'bzdw_h', 'zxdw_l', 6, 'jldw_mg', 2.00, '2.00mg*6粒/盒', 'kf', 4.0000, '', '', 'bys', 1, 0.0000, 4.7200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 10:03:43', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2673, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000902', 'mz', '木贼', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0450, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 11:20:02', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2683, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000243', 'ysldkyzsy(rjy)', '盐酸利多卡因注射液(溶剂用)', 'sccj_sdfmyyjtgfyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_ml', 2.00, '2ml*10支/盒', '', 0.0000, '', '', '', 1, 1.2700, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 14:57:03', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2693, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000311', 'smdmp', '双嘧达莫片', 'sccj_fryyjtyxgs', 'h20073360', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 0.25, '0.25mg*100片/瓶', '', 0.0000, '', '', '', 1, 8.2000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:28:46', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2703, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_hsp', 'ZKM00000026', 'ze2', '周二2', 'sccj_hrsj', '12', 3, '', 'bzdw_b', 'zxdw_kg_g', 20, 'jldw_g', 20.00, '20.00g/包', '', 0.0000, '', '', '', 1, 0.0000, 12.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-07-31 16:18:54', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2713, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_sj', 'ZKM00001721', 'dyxajfs', '对乙酰氨基酚栓', 'sccj_hbdxyygs', 'H42021460', 3, '', 'bzdw_h', 'zxdw_l', 6, 'jldw_g', 0.15, '0.15g*6粒/盒', '', 0.0000, '', '', '', 1, 0.0000, 1.2500, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2723, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001251', 'lhjczx	', '铝合金出诊箱	', 'sccj_jsshylqxyxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '16#38*21*23', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2733, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000530', '75%jjxdy', '75%酒精消毒液', 'sccj_yzst', '20171002', 3, '', 'jjdw_p', '', 1, '', 0.00, '500ML', '', 0.0000, '', 'ml', '', 1, 3.7400, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 100, 2, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2743, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001546', 'dp zs', '滴瓶 棕色', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2753, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000372', 'klmsfsp', '克拉霉素分散片', 'sccj_yzjyyjtjszygfyxgs', 'H19990376', 3, '', 'bzdw_h', 'zxdw_p', 6, 'jldw_g', 0.25, '0.25g*6片/盒', 'ad us.int', 0.5000, '', '', 'bid', 1, 10.5000, 14.0700, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 3, NULL, '2018-04-04 17:31:33', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2763, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001643', 'qz', '揿针', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2773, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000167', 'czxdh', '车针消毒盒', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '72孔', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2783, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001069', 'ldsz', '流动树脂', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '7032A2', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2793, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001245', 'ycxsyyydjjcst	', '一次性使用医用定睛检查手套	', 'sccj_jxaemylqxyxgs		', '-', 3, '', 'jjdw_s', '', 1, '', 0.00, '小号麻面无粉100只/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2803, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000737', 'xx', '细辛', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.5040, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2813, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001347', 'jqs', '酒蕲蛇', 'sccj_trt', '', 3, '', 'bzdw_t', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 1.0000, '', '', '', 1, 60.0000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2823, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000773', 'dc', '党参', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.6160, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2833, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000978', 'ycxsywjzjz', '一次性使用无菌针灸针', 'sccj_szylypcyxgs', '苏械注准201622700970', 3, '', 'jjdw_h', '', 1, '', 0.00, '0.3*40100支/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2843, 'bgyplb_ycxcl', 3, 1, 'bgyplb_ycxcl', '', 'ZKM00001844', 'bht', '薄荷糖', 'sccj_amzyc', NULL, 3, '', 'bzdw_d', 'zxdw_d', 1, '', 0.00, '1袋/袋', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2853, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001674', 'ldcwlb', '锂电池物料包', 'sccj_szmr', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2863, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000626', 'yymjd', '医用灭菌袋', 'sccj_cqql', '卫消字（2012）第0009号', 3, '', 'jjdw_j', '', 1, '', 0.00, '75*200', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2873, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000562', 'tljcyc', '听力检查音叉', 'sccj_Carent ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '128Hz', '', 0.0000, '', 'ml', '', 1, 58.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-03-14 10:40:45', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2883, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001116', 'dfxdy', '碘伏消毒液', 'sccj_sclkyyflyxgs', '川（广安）卫消证字2014第0001号', 3, '', 'jjdw_p', '', 1, '', 0.00, '60ml', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2893, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000017', 'dgdbb', '带盖大便杯', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2903, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000539', 'zdhscdsjh（dajbhszdyf）', '总胆红素测定试剂盒（对氨基苯磺酸重氮盐法）', 'sccj_glyltyldzyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '125ml*2；5ml*2', '', 0.0000, '', 'ml', '', 1, 129.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2913, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001422', 'dyxajfhsp（tnl）', '对乙酰氨基酚缓释片（泰诺林）', 'sccj_shqszyyxgs', '国药准字H20010394', 3, '', 'bzdw_h', 'zxdw_l', 6, 'jldw_g', 0.65, '0.65g*6粒/盒', 'kf', 0.6500, '', '', 'bys', 1, 5.9500, 6.8400, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 3, 1, NULL, '2018-05-24 11:17:59', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2923, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_wy', 'ZKM00001890', 'ddwhy', '跌打万花油', 'sccj_gzbysjxtyygfyxgs', '', 3, '', 'bzdw_p', 'zxdw_ml', 25, 'jldw_ml', 1.00, '1.00ml*25ml/瓶', '', 0.0000, '', '', '', 1, 0.0000, 7.8000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-07-03 17:28:49', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2933, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001827', 'csqandzsy', '醋酸曲氨奈德注射液', 'sccj_zjxjzygfyxgs', 'H33020762', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 5.00, '5.00ml*1支/支', '', 0.0000, '', '', '', 1, 0.0000, 5.6000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2943, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00001328', 'ysbndpp（kll）', '盐酸贝尼地平片（可力洛）', 'sccj_xhfjql（zg）zyyxgs', 'J20171015', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_mg', 8.00, '8.00mg*7片/盒', 'ad us.int', 4.0000, '', '', 'qd', 1, 59.4600, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2953, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001667', 'ykxftnjb', '牙科修复体粘结棒', 'sccj_yhjwwdtgs', '国械备20150102', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2963, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000078', 'gghqlhg', '光固化氢氯化钙', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2973, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001523', 'hxz', '回形针', 'sccj_amzyc', NULL, 3, '', 'bzdw_h', 'zxdw_h', 1, '', 0.00, '1盒/盒', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2983, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_wy', 'ZKM00001581', 'jwtdry', '聚维酮碘溶液', 'sccj_hldgdyyyxzrgs', '国药准字H21022101', 3, '', 'bzdw_p', 'zxdw_ml', 100, 'jldw_％', 5.00, '5.00％*100ml/瓶', '', 0.0000, '', '', '', 1, 4.7000, 4.7000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (2993, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001106', 'ymx', '玉米须', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0380, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3003, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rgj', 'ZKM00001822', 'ffblmsznrg（wjg）', '复方倍氯米松樟脑乳膏（无极膏）', 'sccj_shyayyyxgs', 'H42021866', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 20.00, '20.00g*1支/支', '', 0.0000, '', '', '', 1, 0.0000, 6.1000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3013, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000318', 'ajbszsy', '氨甲苯酸注射液', 'sccj_yzzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 5, 'jldw_ml', 10.00, '10.00ml*5支/盒', '', 0.0000, '', '', '', 1, 1.7200, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3023, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001668', 'zsgxmbj40%', '诊室高效美白剂40%', 'sccj_Ultradert product Inc', '', 3, '', 'jjdw_t', '', 1, '', 0.00, '套', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3033, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001615', 'aszlp', '艾司唑仑片', 'sccj_sdxyzyyxgs', 'H37023047', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_mg', 1.00, '1.00mg*20片/盒', 'kf', 1.0000, '', '', 'mr3c', 2, 5.7400, 0.3300, 'fylb_xyf', 'fpxm_xyf', 0, 0, 1, 0, 0, 5, 2, NULL, '2018-06-07 16:25:06', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3043, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001672', '40yzlc', '40页资料册', 'sccj_amzyc', NULL, 3, '', 'bzdw_b_9413', 'zxdw_b_2375', 1, '', 0.00, '1本/本', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3053, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tj', 'ZKM00001653', 'ngt（TX）', '暖宫贴（TX）', 'sccj_jstsldyyy', '18030694', 3, '', 'bzdw_h', 'zxdw_t', 2, 'jldw_cm', 13.00, '13.00cm*2贴/盒', '', 0.0000, '', '', '', 1, 0.0000, 24.6000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3063, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000641', 'sml', '生牡蛎', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0170, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 17:43:40', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3073, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000132', 'cxp', '成型片', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_d', '', 1, '', 0.00, '小中', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3083, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001363', 'fhz', '缝合针', 'sccj_hzhw		', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '圆头带针不可吸收缝合针1.040包/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3093, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00000525', 'gyhqry', '过氧化氢溶液', 'sccj_hbjnyyyxgs', 'H13022648', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 500.00, '500.00ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 10.8000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 2, 1, NULL, '2018-02-24 16:42:36', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3103, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000699', 'hsk', '滑石块', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0290, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3113, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001024', 'smtctq', '水门汀充填器', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '圆柄R2', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3123, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000170', 'ycxzsq', '一次性注射器', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3133, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000812', 'flpzzhcsbzdys', '飞利浦至臻护齿声波震动牙刷', 'sccj_w', '-', 3, '', 'jjdw_t_148', '', 1, '', 0.00, 'HX9141A/20', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3143, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00001693', 'mmwmry（hfn）', '美敏伪麻溶液（惠菲宁）', 'sccj_hszyyxgs', 'H20030051', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 100.00, '100.00ml*1瓶/瓶', 'kf', 6.0000, '', '', 'mr3c', 1, 0.0000, 12.6200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 09:38:11', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3153, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001862', 'qlsqp', '氢氯噻嗪片', 'sccj_sdrhtyyyxgs', 'H37020788', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_hk', 25.00, '25毫克*100片/瓶', '', 0.0000, '', '', '', 1, 0.0000, 2.5500, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3163, 'bgyplb_yslcl', 3, 1, 'bgyplb_yslcl', '', 'ZKM00001413', 'blt', '便利贴', 'sccj_amzyc', '', 3, '', 'bzdw_b', 'zxdw_b_2375', 120, '', 0.00, '120本/包', '', 0.0000, '', 'ml', '', 2, 2.6500, 2.6500, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3173, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001595', 'yyp（mysn）', '咽炎片（慢严舒柠）', 'sccj_scfczy', '170502', 3, '', 'bzdw_h', 'zxdw_p', 30, 'jldw_g', 0.25, '0.25g*30片/盒', '', 0.0000, '', '', '', 1, 22.0000, 19.2100, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-05-21 14:52:30', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3183, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000698', 'ntysg', '镍钛圆丝弓', 'sccj_shamdclljgfyxgs', '--', 3, '', 'jjdw_d', '', 1, '', 0.00, '卵圆18*22U', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3193, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000913', 'bxgytp（qk）', '不锈钢牙托盘（前口）', 'sccj_w', '-', 3, '', 'jjdw_f', '', 1, '', 0.00, '前口', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3203, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00001554', 'jjfhqry', '聚甲酚磺醛溶液', 'sccj_zjplkyzy', 'H20065487', 3, '', 'bzdw_p', 'zxdw_ml', 25, 'jldw_％', 36.00, '36.00％*25ml/瓶', '', 0.0000, '', '', '', 1, 35.8000, 2.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3213, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00000785', 'ygbdbmky、bmkt、eky、ekt、hxhtjcsjh（rjf）', '乙肝病毒表面抗原、表面抗体、e抗原、e抗体、核心核体检测试剂盒（乳胶法）', 'sccj_abswyy（hz）yxgs', '2017110015', 3, '20100288', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 80.0000, 91.2000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3223, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000941', 'wys', '望月砂', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0200, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3233, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001851', 'xzy', '修正液', 'sccj_amzyc', NULL, 3, '', 'bzdw_p', 'zxdw_p_1', 1, '', 0.00, '1瓶/瓶', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3243, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001260', 'jght', '鸡冠花炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0600, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3253, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000997', 'fhsz', '复合树脂', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '34365针管装A3', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3263, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001519', 'yysbbd', '医用纱布绷带', 'sccj_hnwc		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3273, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000102', 'tsqnp', '碳酸氢钠片', 'sccj_scchzyyxgs', '国药准字h51020795', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_g', 0.30, '0.30g*100片/瓶', '', 0.0000, '', '', '', 1, 3.7000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 08:57:54', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3283, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000954', 'txpdfxdy', '天信牌碘伏消毒液', 'sccj_w', '--', 3, '', 'jjdw_p', '', 1, '', 0.00, '500ml', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3293, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_cj', 'ZKM00000256', 'xsgyp', '硝酸甘油片', 'sccj_zhgjxcgfyxgs', '', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 0.50, '0.50mg*100片/瓶', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-06 15:33:53', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3303, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001487', 'kdxg2ml', '刻度吸管2ml', 'sccj_w', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3313, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000865', 'bl', '白蔹', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1260, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 10:54:21', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3323, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000943', 'kdc', '苦丁茶', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2240, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3333, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000629', 'ztnx', '制天南星', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1250, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3343, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00001601', 'jhtky', '橘红痰咳液', 'sccj_gdhjzyyxgs', '20170821', 3, '', 'bzdw_h', 'zxdw_z', 12, 'jldw_ml', 10.00, '10.00ml*12支/盒', '', 0.0000, '', '', '', 1, 35.0000, 35.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3353, 'bgyplb_csyplcl', 3, 1, 'bgyplb_csyplcl', '', 'ZKM00000366', 'mt', '毛毯', 'sccj_amzyc', '', 3, '', 'bzdw_t', 'zxdw_tiao', 1, '', 0.00, '1条/条', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3363, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000795', 'jyh', '金银花', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 0.0000, '', '', '', 1, 0.7840, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3373, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dyj', 'ZKM00001634', 'blsndyy（TX）', '玻璃酸钠滴眼液（TX）', 'sccj_sdbslfrdzyyxgs', '17070501', 3, '', 'bzdw_h', 'zxdw_z', 1, 'jldw_ml', 0.80, '0.80ml*1支/盒', '', 0.0000, '', '', '', 1, 0.0000, 5.1000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-14 10:03:39', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3383, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000327', 'gjxffsmnr（qs）', '高级心肺复苏模拟人（全身）', 'sccj_dd', '', 3, '', 'jjdw_t_148', '', 1, '', 0.00, 'GD/CPR2005', '', 0.0000, '', 'ml', '', 1, 4700.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3393, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000376', 'jjxyq', '紧急洗眼器', 'sccj_wzscswyyxgs', '', 3, '', 'jjdw_t_148', '', 1, '', 0.00, '移动单口喷', '', 0.0000, '', 'ml', '', 1, 168.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3403, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000005', 'wc1', '卫材1', 'sccj_bjsykyy', '12', 3, '', 'jjdw_b', '', 1, '', 0.00, '包', '', 0.0000, '', 'ml', '', 1, 0.0000, 10.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3413, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000933', 'dsjm', '煅石决明', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0480, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3423, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_wj', 'ZKM00000835', 'ffdcdw', '复方丹参滴丸', 'sccj_tslzyjtyxgs', 'Z10950111', 3, '', 'bzdw_h', 'zxdw_w', 180, 'jldw_mg', 27.00, '27.00mg*180丸/盒', '', 0.0000, '', '', '', 1, 26.0800, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 6, 0, NULL, '2018-02-24 11:40:37', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3433, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001507', 'lsgq', '临时冠枪', 'sccj_hb/kt', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '把', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3443, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dj_1', 'ZKM00001655', 'zljdd', '重楼解毒酊', 'sccj_gzsjtzyyxgs', 'Z20025808', 1, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 45.00, '45.00ml*1瓶/瓶', 'ad us.ext', 0.0000, '', '', '', 1, 0.0000, 56.9800, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-15 13:22:40', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3453, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000354', '0.9%lhnzsy（bl）', '0.9%氯化钠注射液（玻璃）', 'sccj_scklyygfyxgs', 'H51021158', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 500.00, '500.00ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 1.8900, 3.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-12 15:15:28', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3463, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000795', '95%jj(TX)', '95%酒精(TX)', 'sccj_w', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '500ml*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-14 16:17:40', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3473, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000604', 'cwwz', '醋五味子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.6720, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:40:03', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3483, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001521', 'sl', '砂轮', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3493, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001401', 'tphsdh', '托盘黑色大号', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 35.0000, 35.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3503, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000547', 'nscdsjh（nsm-gyhwmf）', '尿酸测定试剂盒（尿酸酶-过氧化物酶法）', 'sccj_glyltyldzyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '40ml*5；10ml*5；校准品1ml', '', 0.0000, '', 'ml', '', 1, 242.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3513, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000319', 'mlxkp', '美洛昔康片', 'sccj_qlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_p', 12, 'jldw_mg', 7.50, '7.50mg*12片/盒', '', 0.0000, '', '', '', 1, 3.2500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3523, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001018', 'A4fyz', 'A4复印纸', 'sccj_amzyc', '', 3, '', 'bzdw_h', 'zxdw_b', 5, '', 0.00, '5包/盒', '', 0.0000, '', 'ml', '', 2, 21.8000, 21.8000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-03-05 10:11:55', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3533, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000926', 'jh', '菊花', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2630, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3543, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00001628', 'tqtjjn(TX)', '田七痛经胶囊(TX)', 'sccj_gzjjtyyyxgs', '6441C02', 3, '', 'bzdw_h', 'zxdw_l', 24, 'jldw_g', 0.40, '0.40g*24粒/盒', '', 0.0000, '', '', '', 1, 0.0000, 18.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3553, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000767', 'wztp', '网状托盘', 'sccj_rxckclyxgs', '沪食药监械', 3, '', 'jjdw_f_3720', '', 1, '', 0.00, '大', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3563, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001500', 'hxSh', '护膝S号', 'sccj_3M', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3573, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000896', 'cjqkq（kjlg）', '唇颊牵开器（口角拉钩）', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '518-203侧方', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-28 14:53:06', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3583, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001305', 'oj', '藕节', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/支', '', 10.0000, '', '', '', 1, 0.0500, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3593, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000238', 'xtg', '吸痰管', 'sccj_hnsjqylqxyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, 'Fr84.0mm*500mm', '', 0.0000, '', 'ml', '', 1, 1.5000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3603, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000002', 'lqkfy', '蓝芩口服液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1.00g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 1, 0, 0, 0, '2017-07-13 00:00:00', '2018-08-13 18:02:27', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3613, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000012', 'jfzykl', '荆肤止痒颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3623, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000022', 'xeqxckl', '小儿七星茶颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3633, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000032', 'xefrkckl', '小儿肺热咳喘颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3643, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_qt', 'ZDS90000042', 'yfsxdey', '氧氟沙星滴耳液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-02-06 17:17:26', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3653, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000052', 'tlqtg', '通络祛痛膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3663, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000062', 'sjjyw', '舒筋健腰丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/大盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3673, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000072', 'trdhlw', '同仁大活络丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3683, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000082', '*gcxty', '*骨刺消痛液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3693, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000092', 'kbw', '坤宝丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3703, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000102', 'gzflw（nssw）', '桂枝茯苓丸（浓缩水丸）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3713, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000112', 'fkqjp', '妇科千金片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3723, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000122', 'sgjn', '舒更胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3733, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000132', 'hekl', '槐耳颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3743, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000142', 'cyctj', '垂阴茶糖浆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3753, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000152', 'sjgmp', '四季感冒片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3763, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000162', 'ffbhnrg（mxldbk）', '复方薄荷脑软膏（曼秀雷敦栢可）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3773, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000172', 'ypfkl', '玉屏风颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3783, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000182', 'qxsymsfkfry', '氢溴酸右美沙芬口服溶液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3793, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000192', 'qxsymsfkfry(lbklt)', '氢溴酸右美沙芬口服溶液(联邦克立停)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3803, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZDS90000202', 'gysptwlp', '枸橼酸喷托维林片', 'sccj_lfbzzyyxgs', '国药准字h14022502', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 25.00, '25.00mg*100片/瓶', '', 0.0000, '', 'ml', '', 1, 9.8000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-24 09:05:58', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3813, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000212', 'bxmlp(ljlx)', '苯溴马隆片(立加利仙)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3823, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000222', 'fflsrgsp', '复方硫酸软骨素片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3833, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000232', 'fkp(fbd)', '酚咖片(芬必得)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3843, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000242', 'nfsxjn', '诺氟沙星胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3853, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000252', 'aqmsghxj(xsm)', '阿奇霉素干混悬剂(希舒美)', 'sccj_hrzyyxgs', '国药准字H10960112', 3, '', 'bzdw_h', 'zxdw_d', 6, 'jldw_g', 0.10, '0.10g*6袋/盒', 'kf', 0.1000, '', 'ml', 'mr1c', 1, 38.0000, 53.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-24 14:43:37', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3863, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000262', 'aqmsp(xsm*)', '阿奇霉素片(希舒美*)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3873, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000272', 'pxjn', '平消胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3883, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000282', 'jxzkjp', '甲硝唑口颊片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3893, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000292', 'plap', '普乐安片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3903, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000302', 'swhzw', '十味诃子丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3913, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZDS90000312', 'zjzxsnp(yjl)', '左甲状腺素钠片(优甲乐)', 'sccj_dgMorok KGaA ', 'H20140052', 3, '', 'bzdw_h', 'zxdw_p', 100, 'jldw_μg', 50.00, '50.00μg*100片/盒', '', 0.0000, '', 'ml', '', 1, 25.6500, 28.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, '2017-07-13 00:00:00', '2018-06-08 14:14:47', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3923, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000322', '*@jdbswhcrydszsy（yh30r)(nhl）', '*@精蛋白生物合成人胰岛素注射液（预混30r)(诺和灵）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3933, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000332', 'gsnrg(hpl)', '肝素钠乳膏(海普林)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3943, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000342', 'qkrg（qb）', '氢醌乳膏（千白）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3953, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000352', 'fjxj', '肤疾洗剂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3963, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000362', 'lmsrg（an）', '卤米松乳膏（澳能）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3973, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000372', 'ysklmsnj', '盐酸克林霉素凝胶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3983, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000382', 'tkmsrg(ptb)', '他克莫司软膏(普特彼)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (3993, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000392', 'eswwmbw', '二十五味马宝丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4003, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000402', 'agnhw', '安宫牛黄丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4013, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000412', 'blfp(sf)', '巴氯芬片(枢芬)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4023, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000422', 'jgap(mkb)', '甲钴胺片(弥可保)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4033, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000432', 'ysbhrzp（fsl）', '盐酸苯环壬酯片（飞赛乐）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4043, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000442', 'prbljn（lrk）', '普瑞巴林胶囊（乐瑞卡）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4053, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000452', 'wfcp', '胃复春片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4063, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000462', 'sxzcs', '麝香痔疮栓', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4073, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000472', 'jtgjbjn', '胶体果胶铋胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4083, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZDS90000482', 'ltsmp（dx）', '铝碳酸镁片（达喜）', 'sccj_beyyyxgs', 'JS05587', 3, '', 'bzdw_h', 'zxdw_p', 30, 'jldw_g', 0.50, '0.50g*30片/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 39.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-11 16:16:22', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4093, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000492', 'mylsxzcg', '马应龙麝香痔疮膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4103, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000502', 'xbw', '心宝丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4113, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000512', 'ebstp(abw)', '厄贝沙坦片(安博维)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4123, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000522', 'wxkl', '稳心颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4133, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000532', '@xbdpksp(bxt)', '@硝苯地平控释片(拜新同)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4143, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000542', 'glqp', '桂利嗪片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4153, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000552', 'rxbdb', '人血白蛋白', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4163, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000562', 'ysbtledyy(bts)', '盐酸倍他洛尔滴眼液(贝特舒)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4173, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000572', 'zzmmdyy', '珍珠明目滴眼液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4183, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000582', 'blzadyy', '布林佐胺滴眼液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4193, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000592', 'yymq', '医用棉签', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/袋', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4203, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000602', 'wssb2p', '维生素b2片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4213, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000612', 'dwysp（29）(sc)', '多维元素片（29）(善存)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4223, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000622', 'ynkl', '夜宁颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4233, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000632', 'zbsfp', '滋补生发片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4243, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000642', 'jsccg', '健身长春膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4253, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000010', 'ycxzsq', '一次性注射器', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '2.5ml', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-01-12 16:23:19', 1, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4263, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000020', 'df', '碘伏', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '60ml', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4273, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000030', 'ycxqcfhb（wky）', '一次性清创缝合包（外科用）', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4283, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000040', 'ycxzjz', '一次性针灸针', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '100盒/箱（50根/盒）', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4293, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000050', 'rqh', '锐器盒', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '2L/个', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4303, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000060', 'gysn ：hm', '枸缘酸钠 ：黑帽', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '100支每盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4313, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000070', 'ykqxmjd（x)', '牙科器械灭菌袋（小)', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '5cm宽', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4323, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000080', 'ycxsyqt', '一次性三用枪头', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '250支/桶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4333, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000090', 'cysg', '超硬石膏', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4343, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000100', 'yqz', '氧气枕', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4353, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000001', 'hq', '红曲', 'sccj_bjhlzyyxgs', '1', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 2.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-07-31 13:46:01', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4363, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000011', 'fbx', '法半夏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4373, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000021', 'bs', '白术', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4383, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000031', 'ckxr', '燀苦杏仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4393, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000041', 'fl', '茯苓', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4403, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000051', 'jq', '建曲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4413, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000061', 'ff', '防风', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4423, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000071', 'zhq', '炙黄芪', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4433, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000081', 'dcd', '党参段', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4443, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000091', 'qh', '羌活', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4453, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000101', 'jhq', '酒黄芩', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4463, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000111', 'gc', '甘草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4473, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000121', 'jsz', '净山楂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4483, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000131', 'nsc', '南沙参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4493, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000141', 'dcs', '煅磁石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4503, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000151', 'gc', '甘草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4513, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000161', 'czsz', '炒紫苏子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4523, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000171', 'cwblx', '炒王不留行', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4533, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000181', 'clfz', '炒莱菔子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4543, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000191', 'cwzy', '炒吴茱萸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4553, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000201', 'jhl', '酒黄连', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4563, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000211', 'gt', '钩藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4573, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000221', 'cgj', '醋龟甲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4583, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000231', 'ytsz', '盐菟丝子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4593, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000241', 'qh', '前胡', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4603, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000251', 'jsz', '焦山楂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4613, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000261', 'cxd', '赤小豆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4623, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000271', 'pj', '炮姜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4633, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000281', 'ljs', '鹿角霜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4643, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000291', 'cxd', '赤小豆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4653, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000301', 'cjq', '炒建曲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4663, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000311', 'bxp', '白鲜皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4673, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000321', 'my', '麦芽', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4683, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000331', 'dzy', '淡竹叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4693, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000341', 'cccmt', '粗齿川木通', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4703, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000351', 'cbj', '醋鳖甲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4713, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000361', 'ybgz', '盐补骨脂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4723, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000371', 'tzc', '太子参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4733, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000381', 'tgsb', '烫骨碎补', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4743, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000391', 'wlx', '威灵仙', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4753, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000401', 'dnx', '胆南星', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4763, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000411', 'pj', '炮姜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4773, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000421', 'ylzh', '盐荔枝核', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4783, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000431', 'jdc', '酒丹参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4793, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000441', 'xc', '玄参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4803, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000451', 'zbm', '浙贝母', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4813, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000461', 'dxt', '大血藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4823, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000471', 'jxt', '鸡血藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4833, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000481', 'jh', '菊花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4843, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000491', 'nsc', '南沙参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4853, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000501', 'zl', '猪苓', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4863, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000511', 'llt', '路路通', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4873, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000521', 'hft', '海风藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4883, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000531', 'bbd', '白扁豆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4893, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000541', 'mbb', '蜜百部', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4903, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000551', 'lz', '莲子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4913, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000561', 'fxy', '番泻叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4923, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000571', 'fcqp', '麸炒青皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4933, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000581', 'bw', '白薇', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4943, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000591', 'ccwz', '炒茺蔚子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4953, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000601', 'lzx', '莲子心', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4963, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000611', 'tgj', '烫狗脊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4973, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000621', 'tgsb', '烫骨碎补', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4983, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000631', 'wy', '乌药', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (4993, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000641', 'xtc', '小通草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5003, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000651', 'lxc', '鹿衔草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5013, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000661', 'gt', '钩藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5023, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000671', 'cjz', '炒芥子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5033, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000681', 'ghx', '广藿香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5043, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000691', 'hp', '琥珀', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5053, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000701', 'dyqc', '大叶茜草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5063, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000711', 'fs', '浮石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5073, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000721', 'whz', '煨诃子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5083, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000731', 'cnx', '川牛膝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5093, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000741', 'ddc', '淡豆豉', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5103, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000751', 'msbp', '蜜桑白皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5113, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000761', 'bzl', '半枝莲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5123, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000771', 'sjc', '舒筋草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5133, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000781', 'dg', '当归', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5143, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000791', 'zhq', '炙黄芪', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5153, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000801', 'cglz', '炒瓜蒌子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5163, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000811', 'cxl', '穿心莲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5173, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000821', 'scg', '山慈菇', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5183, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000831', 'yfpz', '盐覆盆子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5193, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000841', 'sw', '石韦', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5203, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000851', 'gsq', '隔山撬', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5213, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000861', 'lxt', '灵仙藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5223, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000871', 'gqz', '枸杞子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5233, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000881', 'msm', '蜜升麻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5243, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000891', 'xjt', '小蓟炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5253, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000901', 'hmy', '黑蚂蚁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5263, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000911', 'yyh', '淫羊藿', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5273, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000921', 'gg', '葛根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5283, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000931', 'jgl', '绞股蓝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5293, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000941', 'mhd', '木蝴蝶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5303, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000951', 'lzx', '莲子心', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5313, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000961', 'zcw', '制草乌', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5323, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000971', 'jh', '菊花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5333, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000981', 'hlp', '黄连片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5343, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000991', 'sd', '柿蒂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5353, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001001', 'czsz', '炒紫苏子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5363, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001011', 'cmy', '炒麦芽', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5373, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001021', 'xgf', '寻骨风', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5383, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001031', 'dfz', '地肤子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5393, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001041', 'gs', '甘松', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5403, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001051', 'fp', '附片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5413, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001061', 'zl', '猪苓', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5423, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001071', 'glj', '高良姜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5433, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001081', 'lxj', '龙血竭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5443, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001091', 'zhj', '制黄精', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5453, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001101', 'cdgz', '炒冬瓜子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5463, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001111', 'llt', '路路通', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5473, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001121', 'ch', '柴胡', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5483, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001131', 'jwss', '酒乌梢蛇', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5493, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001141', 'sbp', '桑白皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5503, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001151', 'cp', '椿皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5513, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001161', 'gg', '官桂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5523, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001171', 'ymc', '益母草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5533, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001181', 'cclz', '炒川楝子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5543, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001191', 'sdh', '熟地黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5553, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001201', 'dsjm', '煅石决明', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5563, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001211', 'jh', '姜黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5573, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001221', 'gjy', '鬼箭羽', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5583, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001231', 'nx', '牛膝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5593, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001241', 'bp（hcln）', '冰片（合成龙脑）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5603, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001251', 'hp.', '琥珀.', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5613, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001261', 'ylzh', '盐荔枝核', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5623, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001271', 'sw', '石韦', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5633, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001281', 'ytsz', '盐菟丝子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5643, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001291', 'yyh', '淫羊藿', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5653, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001301', 'dzrt', '煅自然铜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5663, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001311', 'dcs', '煅磁石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5673, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001321', 'cs', '蚕沙', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5683, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001331', 'ybc', '岩白菜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5693, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001341', 'lxc', '鹿衔草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5703, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001351', 'dyqs', '煅阳起石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5713, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001361', 'fp', '附片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5723, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001371', 'zjc', '皂角刺', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5733, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001381', 'lxh', '凌霄花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5743, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001391', 'dg', '当归', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5753, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001401', 'rg', '肉桂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5763, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001411', 'cbs', '炒白芍', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5773, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001421', 'fp', '浮萍', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5783, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001431', 'czz', '炒栀子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5793, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001441', 'cx', '沉香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5803, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001451', 'wg', '蜈蚣', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5813, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001461', 'hsw', '何首乌', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5823, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001471', 'mppy', '蜜枇杷叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5833, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001481', 'cjnj', '炒鸡内金', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5843, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001491', 'jh', '姜黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5853, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001501', 'hsw', '何首乌', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5863, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001511', 'bbl', '半边莲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5873, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001521', 'gqz', '枸杞子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5883, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001531', 'dqy', '大青叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5893, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001541', 'whg', '无花果', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5903, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001551', 'kf', '枯矾', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5913, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001561', 'hjs', '海金沙', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5923, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001571', 'zbm', '浙贝母', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5933, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001581', 'qnj', '千年健', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5943, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001591', 'ebsc(elj)', '鹅不食草(二郎箭)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5953, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001601', 'sdh', '生地黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5963, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001611', 'ybgz', '盐补骨脂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5973, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001621', 'zlt', '棕榈炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5983, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001631', 'mb', '马勃', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (5993, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001641', 'xx', '细辛', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6003, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001651', 'sjc', '石见穿', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6013, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001661', 'gc', '甘草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6023, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001671', 'ct', '蝉蜕', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6033, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001681', 'yyh', '淫羊藿', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6043, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001691', 'fg', '粉葛', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6053, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001701', 'llt', '路路通', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6063, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001711', 'jl', '橘络', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6073, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001721', 'csz', '赤石脂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6083, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001731', 'cqh', '长前胡', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6093, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001741', 'btw', '白头翁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6103, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001751', 'fxy', '番泻叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6113, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001761', 'jbx', '京半夏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6123, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001771', 'pfp', '炮附片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6133, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001781', 'jdh', '酒大黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6143, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001791', 'qnj', '千年健', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6153, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001801', 'jx', '降香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6163, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001811', 'zsf（sf）', '朱砂粉（水飞）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6173, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001821', 'gz', '桂枝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6183, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001831', 'mbb', '蜜百部', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6193, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001841', 'cdgz', '炒冬瓜子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6203, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001851', 'wbz', '五倍子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6213, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001861', 'wwz', '五味子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6223, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001871', 'rr', '蕤仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6233, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001881', 'zbfz', '制白附子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6243, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001891', 'sz', '山楂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6253, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001901', 'dfz', '地肤子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6263, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001911', 'mppy', '蜜枇杷叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6273, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001921', 'sd', '柿蒂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6283, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001931', 'cgz', '炒贯众', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6293, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001941', 'zsg', '紫苏梗', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6303, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001951', 'ygm', '夜关门', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6313, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001961', 'cs', '脆蛇', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6323, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001971', 'mx', '芒硝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6333, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001981', 'ydz', '盐杜仲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6343, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001991', 'hzl', '红泽兰', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6353, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002001', 'jjcp', '九节菖蒲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6363, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002011', 'xks', '夏枯穗', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6373, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002021', 'zzm', '珍珠母', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6383, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002031', 'fbx', '法半夏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6393, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002041', 'sdg', '山豆根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6403, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002051', 'yj', '郁金', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6413, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002061', 'jqhy', '酒羌活鱼', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6423, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002071', 'nhs', '南鹤虱', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6433, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002081', 'sz', '山楂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6443, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002091', 'bcq', '荜澄茄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6453, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002101', 'jx', '降香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6463, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002111', 'md', '麦冬', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6473, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002121', 'sdt', '生地炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6483, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002131', 'qf', '青矾', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6493, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002141', 'gh', '葛花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6503, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002151', 'mg', '木瓜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6513, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002161', 'sz', '桑椹', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6523, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002171', 'cg(p)', '草果(皮)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6533, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002181', 'hlszwzy', '黄连水制吴茱萸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6543, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002191', 'cqnz', '炒牵牛子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_3` VALUES (6553, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002201', 'fczk', '麸炒枳壳', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
COMMIT;

-- ----------------------------
-- Table structure for drug_resource_4
-- ----------------------------
DROP TABLE IF EXISTS `drug_resource_4`;
CREATE TABLE `drug_resource_4` (
  `id` bigint unsigned NOT NULL DEFAULT '0' COMMENT '主键',
  `drug_res_type_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT ' 药品和物资类型ID(dw_drug_res_type.id)',
  `base_type` tinyint NOT NULL DEFAULT '0' COMMENT '物品类型：1-药品, 2-耗材, 3-办公用品',
  `status` int DEFAULT '1' COMMENT '药品状态: 0 - 停用, 1 - 使用',
  `type_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药品或者耗材类别的字典ID(dw_dictionary.id AND dw_dictionary.type_id=[yplb OR hclb])',
  `dict_dosage_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药品剂型的字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypjx)',
  `code` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '集团编码',
  `pym` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '拼音简码',
  `name` varchar(64) CHARACTER SET utf8 DEFAULT '' COMMENT '药品或者耗材的名称',
  `manufacturer_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '生产厂家的字典ID(dw_dictionary.id AND dw_dictionary.type_id=sccj)',
  `approval_no` varchar(100) CHARACTER SET utf8 DEFAULT NULL COMMENT '批准文号',
  `med_type` int DEFAULT '3' COMMENT '医保分类： 1 - 无自付, 2 - 部分自付, 3 - 全自付',
  `admin_code` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药监编码',
  `pack_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '包装单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypdw)',
  `min_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '最小单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypdw)',
  `pack_quantity` int DEFAULT '1' COMMENT '包装含量',
  `dosage_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '剂量单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=jldw)',
  `dosage_quantity` decimal(10,2) DEFAULT '0.00' COMMENT '剂量含量',
  `pack_spec` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '包装规格，生成规则：[剂量含量] [剂量单位] * [包装含量] [最小单位] / [包装单位]',
  `take_method_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '用法(默认用法)(dw_dictionary.id AND dw_dictionary.type_id=ypyf)',
  `take_quantity` decimal(36,4) DEFAULT '0.0000' COMMENT '用量(默认用量)',
  `take_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '用量单位字典ID - 暂留字典',
  `take_unit_name` varchar(36) CHARACTER SET utf8 DEFAULT 'ml' COMMENT '用量单位名称，默认ml',
  `take_frequency` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '频率(默认频率)(dw_dictionary.id AND dw_dictionary.type_id=yppl)',
  `common_unit_type` int DEFAULT '1' COMMENT '常规单位类型: 1 - 包装单位(packUnit), 2 - 最小单位(minUnit)',
  `purchase_price` decimal(8,4) DEFAULT '0.0000' COMMENT '进货价: 单位 元',
  `sale_price` decimal(8,4) DEFAULT '0.0000' COMMENT '基准价: 单位 元',
  `cost_category_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '费用类别字典ID(dw_dictionary.id AND dw_dicitionary.type_id=fylb)',
  `invoice_item_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '发票项目字典ID - 暂留',
  `expensive_flag` int DEFAULT '1' COMMENT '贵重物品标识： 0 - 非贵重物品， 1 - 贵重物品',
  `psy_flag_i` int DEFAULT '0' COMMENT ' 精神I类药品标识：0 - 非选中， 1 - 选中',
  `psy_flag_ii` int DEFAULT '0' COMMENT '精神II类药品标识：0 - 非选中，1 - 选中',
  `otc_flag` int DEFAULT '0' COMMENT 'OTC标识：0 - 非选中， 1 - 选中',
  `nar_flag` int DEFAULT '0' COMMENT '麻醉药品标识：0 - 非选中， 1 - 选中',
  `inventory_upper` int DEFAULT '0' COMMENT '库存上限',
  `inventory_lower` int DEFAULT '0' COMMENT '库存下限',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  `modify_time` datetime DEFAULT NULL COMMENT '修改时间',
  `del_flag` int DEFAULT '0' COMMENT '删除标志:  0 - 未删除, 1 - 已删除',
  `consumable_type` int NOT NULL DEFAULT '0' COMMENT '耗材类型:1-国产,2-进口',
  `tips` varchar(1024) CHARACTER SET utf8 DEFAULT NULL COMMENT '药品使用注意事项',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

-- ----------------------------
-- Records of drug_resource_4
-- ----------------------------
BEGIN;
INSERT INTO `drug_resource_4` VALUES (4, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000648', 'mbh', '蜜百合', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, NULL, '', 10.0000, '', '', '', 1, 0.0630, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (14, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001249', 'xpc', '香排草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1.00g*1g/克', '', 10.0000, '', '', '', 1, 0.0350, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (24, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000555', 'fxm', '浮小麦', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1.00g*1g/克', '', 10.0000, '', '', '', 1, 0.0290, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:30:57', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (34, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000689', 'zxdmqx', '中性多酶清洗', 'sccj_sdxhylqxgfyxgs', '--', 3, '', 'jjdw_t_5432', '', 1, '', 0.00, '1升', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (44, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000990', 'lxh', '凌霄花', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1.00g*1g/克', '', 10.0000, '', '', '', 1, 0.4140, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (54, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001353', 'wjcwq', '无菌持物钳', 'sccj_dgblgfhxyxgs', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '25cm，直10mmJ34071', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (64, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000094', 'cjrsc 25mm', '超级柔顺锉 25mm', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (74, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000669', 'mdp', '牡丹皮', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2350, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 17:48:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (84, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000502', 'cswwdj', '测水温温度计', 'sccj_fy', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '0-100℃', '', 0.0000, '', 'ml', '', 1, 9.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (94, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001564', 'gbp', '盖玻片', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (104, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000646', 'Kc', 'K锉', 'sccj_xnddsb', '--', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm-8', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (114, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001501', 'hxLh', '护膝L号', 'sccj_3M', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (124, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001224', 'slp	', '砂轮片	', 'sccj_shjzylqxbzgfyxgs		', '-', 3, '', 'jjdw_l', '', 1, '', 0.00, '10粒/包江西', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (134, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_klj', 'ZKM00000470', 'gmqrkl（wzt）', '感冒清热颗粒（无蔗糖）', 'sccj_dd', '', 3, '', 'bzdw_h', 'zxdw_d', 10, 'jldw_g', 12.00, '12.00g*10袋/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 2, NULL, '2018-03-01 16:08:50', 1, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (144, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001269', 'sddtdktwlyyq	', '手动单通道可调微量移液器	', 'sccj_dlxcsyyq（bj）yxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '20-200μl', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (154, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001838', 'tpj145mm', '铁票夹145mm', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (164, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00000490', 'nxmysj(PT)cdsjh（dgx）（ngf）', '凝血酶原时间(PT)测定试剂盒（冻干型）（凝固法）', 'sccj_shtyswjsyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '10*20ml1*21ml', '', 0.0000, '', 'ml', '', 1, 100.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-11 09:37:07', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (174, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000104', 'yjj', '牙胶尖', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (184, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001612', 'qfsnj531550（5mlf+30mlf）', '氢氟酸凝胶531550（5ml粉+30ml粉）', 'sccj_yhjwwdtgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (194, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000103', 'zj', '纸尖', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (204, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001159', 'tlg', '藤梨根', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0290, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (214, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001726', 'sjzdj', '塑胶装订夹', 'sccj_amzyc', NULL, 3, '', 'bzdw_h', 'zxdw_h', 1, '', 0.00, '1盒/盒', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (224, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000319', 'stxs', '三通旋塞', 'sccj_hzjlylqxyxgs', '', 3, '', 'jjdw_z_5693', '', 1, '', 0.00, 'ST01B蓝50只*12盒', '', 0.0000, '', 'ml', '', 1, 3.6000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (234, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001197', ' ycxzkcxgxcg ', ' 一次性真空采血管血沉管 ', 'sccj_jskjylqxyxgs', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, '100个/板江苏康捷', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (244, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000950', 'djms', '煅金礞石', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0230, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (254, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000785', 'tm', '天麻', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 1.2320, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (264, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000662', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'RS-21(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-04-08 10:43:49', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (274, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000618', 'slz', '石莲子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0980, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (284, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001614', 'zjzth 0.3*75mm', '针灸针套盒 0.3*75mm', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (294, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00001459', 'gysbjjn（lzdl）', '枸橼酸铋钾胶囊（丽珠得乐）', 'sccj_lzjtlzzyc', 'H10920098', 3, '', 'bzdw_h', 'zxdw_l', 40, 'jldw_g', 0.30, '0.30g*40粒/盒', 'kf', 0.3000, '', '', 'mr4c', 1, 28.8000, 33.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-05-24 15:21:26', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (304, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_cj', 'ZKM00000200', 'ysajpttjn', '盐酸氨基葡萄糖胶囊', 'sccj_adyy(bj)yxgs', '', 3, '', 'bzdw_h', 'zxdw_l', 40, 'jldw_g', 0.24, '0.24g*40粒/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (314, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001298', 'mbx', '绵萆薢', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.1060, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (324, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000529', 'ycxsywjzsqdz', '一次性使用无菌注射器带针', 'sccj_shkdlqyfzjtgfyxgs', 'k', 3, '', 'jjdw_z', '', 1, '', 0.00, '20ML', '', 0.0000, '', 'ml', '', 1, 0.5300, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 500, 20, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (334, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001360', 'yshyq', '匀速混匀器', 'sccj_dlxcsyyq（bj）yxgs		', '-', 3, '', 'jjdw_t_148', '', 1, '', 0.00, 'MX-S', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (344, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000852', 'ymcl（glz）', '研磨材料（矽离子）', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, 'PN017125*1配一支柄', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (354, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000351', 'wb', '围脖', 'sccj_szshkylqxyxgs', '', 3, '', 'jjdw_j_8137', '', 1, '', 0.00, '590*50', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (364, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001190', 'lqm', '连翘面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0820, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (374, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000269', 'tbkwjn', '头孢克肟胶囊', 'sccj_gzbysyyjtgfyxgsbyszyzc', 'H10930128', 3, '', 'bzdw_h', 'zxdw_l', 6, 'jldw_g', 0.10, '0.10g*6粒/盒', 'ad us.int', 0.1000, '', '', 'TID', 1, 31.7500, 44.4500, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 3, NULL, '2018-04-04 11:32:42', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (384, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000871', 'dlc', '冬凌草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0840, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 10:56:43', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (394, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_klj', 'ZKM00000094', 'kbdkl（wzt）', '抗病毒颗粒（无蔗糖）', 'sccj_scgdzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 12, 'jldw_g', 4.00, '4g*12袋/盒', '', 0.0000, '', '', '', 1, 17.0400, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 13:34:22', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (404, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000628', 'wmt', '乌梅炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0800, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (414, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000388', 'jsszptp', '酒石酸唑吡坦片', 'sccj_snf（hz）zy', 'J20140021', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_mg', 10.00, '10.00mg*20片/盒', 'ad us.int', 10.0000, '', '', 'qd', 1, 60.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 1, 0, 0, 5, 2, NULL, '2018-02-28 16:52:47', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (424, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001288', 'ycxdj', '一次性洞巾', 'sccj_jxym		', '-', 3, '', 'jjdw_b', '', 1, '', 0.00, '50X60CM,50张/包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (434, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000711', 'zjtxfj(fyq)', '正畸弹性附件(分牙圈)', 'sccj_szshswtc', '--', 3, '', 'jjdw_b', '', 1, '', 0.00, '1000*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (444, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001654', 'fbjyyclzz（cwm）', '粪便检验预处理装置（常卫明）', 'sccj_hznhjkkjyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-20 13:32:46', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (454, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000072', 'ssj', '酸蚀剂', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '2.5ML', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (464, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001252', 'fhqm1712335	', '防护铅帽1712335	', 'sccj_szhkylqxyxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '0.50铅当量', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (474, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001220', 'jjd', '酒精灯', 'sccj_gx', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '——', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (484, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001271', 'dgq', '煅干漆', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.5700, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (494, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_sj_2', 'ZKM00001642', 'slhfs（TX）', '双料喉风散（TX）', 'sccj_gdyhylqxyxgs', '20170501', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_g', 2.20, '2.20g*1瓶/瓶', '', 0.0000, '', '', '', 1, 0.0000, 8.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (504, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000746', 'mmgz', '绵马贯众', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0250, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (514, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001251', 'xgf', '寻骨风', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0160, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (524, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tptj', 'ZKM00000436', 'ysxbjp', '盐酸小檗碱片', 'sccj_bjzxyyyxgs', 'H11020962', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_g', 0.10, '0.10g*100片/瓶', 'ad us.int', 0.3000, '', '', 'TID', 1, 16.2000, 22.6800, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 10, 2, NULL, '2018-04-19 11:45:55', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (534, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000906', 'cbxq', '炒半夏曲', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0900, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (544, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_cj', 'ZKM00000194', 'rmsp', '乳酶生片', 'sccj_adyy(bj)yxgs', '', 3, '', 'bzdw_p', 'zxdw_p', 1000, 'jldw_g', 0.15, '0.15g*1000片/瓶', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (554, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000877', 'ycxxjst（wf）', '一次性橡胶手套（微粉）', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, 'XS100只/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (564, 'bgyplb_ycxcl', 3, 1, 'bgyplb_ycxcl', '', 'ZKM00001405', 'kz', '口罩', 'sccj_amzyc', '', 3, '', 'bzdw_x', 'zxdw_g', 30, '', 0.00, '30个/箱', '', 0.0000, '', 'ml', '', 2, 2.5000, 2.5000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (574, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001559', 'xpj', '橡皮筋', 'sccj_amzyc', NULL, 3, '', 'bzdw_d', 'zxdw_d', 1, '', 0.00, '1袋/袋', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (584, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000316', 'jzsfhcmxsxdy', '健之素复合醇免洗手消毒液', 'sccj_bjcjmyykjyxzrgsscjd', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '500ml', '', 0.0000, '', 'ml', '', 1, 25.0000, 0.0000, 'fylb_qt', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (594, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001201', 'ycxzkcxggzg 	', '一次性真空采血管干燥管 	', 'sccj_jskjylqxyxgs', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, '100个/板江苏康捷', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (604, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001200', 'mxsxy（nj）', '免洗手消液（凝胶）', 'sccj_sdlekylkjyxgs', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '246ml/瓶利尔康', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (614, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000574', 'Hc', 'H锉', 'sccj_xnddsb', '国器备20170214', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm-25', '', 0.0000, '', 'ml', '', 1, 0.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (624, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001321', 'ycxxtg', '一次性吸痰管', 'sccj_yzsgl', '-', 3, '', 'jjdw_b', '', 1, '', 0.00, '12#,50根/包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (634, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001382', 'lxgh', '离心管盒', 'sccj_kj', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '两用（50个一盒）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (644, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001183', 'rgnh', '人工牛黄', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.1000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (654, 'bgyplb_dzl', 3, 1, 'bgyplb_dzl', '', 'ZKM00001830', 'hm5Asj(yhf)', '红米5A手机(樱花粉)', 'sccj_amzyc', NULL, 3, '', 'bzdw_t_9258', 'zxdw_t_6854', 1, '', 0.00, '1台/台', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-19 09:55:09', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (664, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001782', 'cmxljyp（qtz-M）', '草木犀流浸液片（清脱止-M）', 'sccj_shryypzshs', 'H20160144', 3, '', 'bzdw_h', 'zxdw_p', 50, 'jldw_mg', 25.00, '25.00mg*50片/盒', 'cqkf', 75.0000, '', '', 'mr3c', 1, 0.0000, 40.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (674, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001121', 'C-fydbzk', 'C-反应蛋白质控', 'sccj_flOriongs', '国械注进20162400859', 3, '', 'jjdw_h', '', 1, '', 0.00, '1ml', '', 0.0000, '', 'ml', '', 1, 0.0000, 238.4000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-31 13:42:19', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (684, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000632', 'jfc', '金沸草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0240, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:53:23', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (694, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001710', 'txbd（tlwm）20g/b', '弹性绷带（弹力网帽）20个/包', 'sccj_zzatlkswgcyxgs', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (704, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001455', 'rglnp（nhl）', '瑞格列奈片（诺和龙）', 'sccj_dgHeraeus Kulzergmbh', 'H20130021', 3, '', 'bzdw_h', 'zxdw_p', 30, 'jldw_mg', 20.00, '20.00mg*30片/盒', '', 0.0000, '', '', '', 1, 70.4400, 98.6200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (714, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001219', 'hwxlldls	', '红外线理疗灯立式	', 'sccj_cqxh', '-', 3, '', 'jjdw_t_148', '', 1, '', 0.00, '台/单头、', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (724, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_cj', 'ZKM00000228', 'cszyxy', '除湿止痒洗液', 'sccj_adyy(bj)yxgs', '', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 150.00, '150.00ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (734, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000750', 'qyf', '铅衣服', 'sccj_sdslylqxyxgs', '鲁烟械备20160050', 3, '', 'jjdw_t_7475', '', 1, '', 0.00, 'M', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-04-17 16:09:10', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (744, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001593', 'zjz 0.25*13mm', '针灸针 0.25*13mm', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (754, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000128', 'pyx', '排龈线', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '000000', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (764, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000175', 'dgxp', '地高辛片', 'sccj_shsyxyycyxgs(yshxyycyxgs)', '国药准字H31020678', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 0.25, '0.25mg*100片/瓶', '', 0.0000, '', '', '', 1, 65.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:23:09', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (774, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000179', 'sxdnj', '手消毒凝胶', 'sccj_sdajgkxdkjyxgs', '', 1, '', 'jjdw_p', '', 1, '', 0.00, '1000ml', '', 0.0000, '', 'ml', '', 1, 40.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (784, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001023', 'smtctq', '水门汀充填器', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '八角柄E2', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (794, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000823', 'dgs', '黛蛤散', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0560, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (804, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_jnj', 'ZKM00000496', 'xstjn', '血塞通胶囊', 'sccj_ynwhyy', '国药准字Z53021143', 3, '', 'bzdw_h', 'zxdw_l', 24, 'jldw_mg', 50.00, '50.00mg*24粒/盒', '', 0.0000, '', '', '', 1, 19.8000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:26:04', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (814, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001620', 'ICONcmhcxl', 'ICON唇面皓齿系列', 'sccj_dgDMGhxyyjtgs', '', 3, '', 'jjdw_t', '', 1, '', 0.00, '套', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (824, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000615', 'szk', '生枳壳', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0340, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (834, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000733', 'hjgh', '红鸡冠花', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0500, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (844, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000916', 'jg', '桔梗', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.3360, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (854, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000160', 'nzt', '镊子筒', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '中号', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (864, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000447', 'psfrmyqdb', '破伤风人免疫球蛋白', 'sccj_scydsyyygfyxgs', 'S20043093', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_dw', 250.00, '250.00单位*1支/支', 'Ut dict', 0.0000, '', '', '', 1, 0.0000, 490.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 2, 1, NULL, '2018-05-14 09:55:58', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (874, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000251', 'yqmz（ktd2stjg）', '氧气面罩（可调带2色调节管）', 'sccj_hzjlylqxyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, 'HX.002L', '', 0.0000, '', 'ml', '', 1, 10.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (884, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001004', 'scby', '生侧柏叶', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0290, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (894, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000828', 'sdht', '生地黄炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1100, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (904, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001406', 'dzzly', '电子针疗仪', 'sccj_htp', '-', 3, '', 'jjdw_t_148', '', 1, '', 0.00, 'SDZ-2蓝色旋钮', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (914, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000594', 'jnzz', '酒女贞子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0450, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:38:25', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (924, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000571', 'yyslmq', '医用石蜡棉球', 'sccj_xxshxwcyxgs', '豫食药监械生产许20150037号', 3, '', 'jjdw_b', '', 1, '', 0.00, '中号', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (934, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001025', 'yyflq', '牙用分离器', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '扁柄型式F1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (944, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001078', 'ycxsywjykzsz', '一次性使用无菌牙科注射针', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '30G*21mm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-29 16:51:17', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (954, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000809', 'akmzstc', '奥科美自锁托槽', 'sccj_mg Ormco Corporation', '国械注进20162631328', 3, '', 'jjdw_f_3720', '', 1, '', 0.00, '标准Q740-1503', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (964, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000174', 'LEDwxgghj', 'LED无线光固化机', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (974, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000379', 'dtxdty', '动态心电图仪', 'sccj_ktyxxt（qhd）gfyxgs', '', 3, '', 'jjdw_t_148', '', 1, '', 0.00, 'TLC6000', '', 0.0000, '', 'ml', '', 1, 6000.0000, 0.0000, 'fylb_zcf', 'fpxm_zcf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 15:56:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (984, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000485', 'fsmzsy', '呋塞米注射液', 'sccj_tjjyyyyxgs', 'H12020527', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_mg', 20.00, '20.00mg*10支/盒', '', 0.0000, '', '', '', 2, 0.9000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 20, 5, NULL, '2018-02-24 11:08:24', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (994, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000425', 'ktjfyxyg', '可调节负压吸引管', 'sccj_hzjlylqxyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, 'Fr14SG.Y01', '', 0.0000, '', 'ml', '', 1, 1.4000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1004, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000387', 'dxpp', '地西泮片', 'sccj_bjymyyyxgs', 'H37023039', 3, '', 'bzdw_p_1730', 'zxdw_p', 1, 'jldw_mg', 2.50, '2.50mg*1片/片', 'ad us.int', 10.0000, '', '', 'Qid', 1, 0.2000, 0.3000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 1, 0, 0, 5, 2, NULL, '2018-05-04 16:35:10', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1014, 'bgyplb_yyzflcl', 3, 1, 'bgyplb_yyzflcl', '', 'ZKM00001520', 'hsx', '护士鞋', 'sccj_amzyc', NULL, 3, '', 'bzdw_s', 'zxdw_s', 1, '', 0.00, '1双/双', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1024, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001673', 'bxgwgfxp27*20', '不锈钢无盖方向盘27*20', 'sccj_cdswsclc', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1034, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000570', 'jcs', '焦苍术', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2560, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1044, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001209', 'cdy', '炒稻芽', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0450, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1054, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001042', '55mmnkdah', '55mm粘扣档案盒', 'sccj_amzyc', '', 3, '', 'bzdw_x', 'zxdw_g', 10, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 8.1600, 8.1600, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-03-01 09:41:15', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1064, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001605', 'zjz 0.3*25mm', '针灸针 0.3*25mm', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1074, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000790', 'ycxsyyywkkz（TX）', '一次性使用医用外科口罩（TX）', 'sccj_gzslhylqxsyyxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.2800, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-22 15:59:41', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1084, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001264', 'lf', '莲房', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0140, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1094, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001498', 'hzSh', '护肘S号', 'sccj_3M', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1104, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00001170', 'ldxdtjlz', '六导心电图记录纸', 'sccj_tjsfhzzpyxgs', '-', 3, '', 'jjdw_b_2336', '', 1, '', 0.00, '110*140-150CE800', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1114, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000321', 'bbzyx', '标本转运箱', 'sccj_dd', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1124, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000573', 'jhl', '酒黄连', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.4070, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1134, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001691', 'pfxdy100ml', '皮肤消毒液100ml', 'sccj_scjszyyxgs', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-07-04 11:31:02', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1144, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001273', 'yyqxz	', '移液器吸嘴	', 'sccj_dlxcsyyq（bj）yxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '200μl(96支/盒）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1154, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001472', 'rxj	', '溶血剂	', 'sccj_szmr', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1164, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001176', 'syyytkyjcsjh（jtjf）', '沙眼衣原体抗原检测试剂盒（胶体金法）', 'sccj_shkcswjsyxgs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '20人份/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1174, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000269', 'wksbfl（wjsbk）', '外科纱布敷料（无菌纱布块）', 'sccj_sdbzsyylqxyxgs', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '5片x7.5x7.5', '', 0.0000, '', 'ml', '', 1, 1.2000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1184, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000596', 'cyhs', '醋延胡索', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.3020, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:38:44', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1194, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000323', 'ysybqzsy', '盐酸异丙嗪注射液', 'sccj_shhfzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_mg', 25.00, '25.00mg*10支/盒', '', 0.0000, '', '', '', 1, 12.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1204, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000159', 'bxgygg', '不锈钢药膏缸', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '9cm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2017-09-13 09:16:04', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1214, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rgj', 'ZKM00001442', 'fxdsrg（al）', '夫西地酸乳膏（奥络）', 'sccj_amzyc', 'HC20150043', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 5.00, '5.00g*1支/支', '', 0.0000, '', '', '', 1, 9.7800, 13.6900, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1224, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000635', 'ggczTF', '根管锉针TF', 'sccj_Ormcocorporat Ion Also sa ', '国械注进20162062999', 3, '', 'jjdw_h', '', 1, '', 0.00, '27mm-混', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 08:52:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1234, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001010', 'snj', '水牛角', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.2670, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1244, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000731', 'dkp', '豆蔻皮', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.3750, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1254, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001708', 'tlbd 12j/h 5*450', '弹力绷带 12卷/盒 5*450', 'sccj_ hsk		', '-', 3, '', 'jjdw_j', '', 1, '', 0.00, '卷', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-07-04 11:07:37', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1264, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_rj', 'ZKM00001880', 'ynbyqwj', '云南白药气雾剂', 'sccj_ynbyjtgfyxgs', 'z53021107', 3, '', 'bzdw_h', 'zxdw_p_1', 1, 'jldw_g', 110.00, '110g*1瓶/盒', '', 0.0000, '', '', '', 1, 0.0000, 29.2600, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1274, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000505', 'zbp', '载玻片', 'sccj_ho', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '50/盒', '', 0.0000, '', 'ml', '', 1, 8.8000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-11 16:56:04', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1284, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000878', 'bh', '壁虎', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 2.1840, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 10:58:36', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1294, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000721', 'mh', '麻黄', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.1060, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1304, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000449', 'gyysxdyAy', '过氧乙酸消毒液A液', 'sccj_sdajgkxdkjyxgs', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '250ml', '', 0.0000, '', 'ml', '', 1, 6.5000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1314, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000949', 'dhrs', '煅花蕊石', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0200, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1324, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsp', 'ZKM00001359', 'hbsmtlehsp', '琥铂酸美托洛尔缓释片', 'sccj_aslkzyyxgs', 'J20150044', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_mg', 47.50, '47.50mg*7片/盒', 'ad us.int', 47.5000, '', '', 'qd', 1, 14.8200, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, NULL, '2018-03-12 09:34:48', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1334, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_kfy', 'ZKM00001518', 'axtlkfy（ytj）', '氨溴特罗口服液（易坦静）', 'sccj_bjhmypyxgs', 'H20040317', 3, '', 'bzdw_p', 'zxdw_ml', 60, 'jldw_ml', 60.00, '60.00ml*60ml/瓶', 'kf', 20.0000, '', '', 'mr2c', 1, 23.0000, 32.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 3, NULL, '2018-05-24 11:13:19', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1344, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000978', 'zl', '重楼', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 3.3600, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1354, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001468', 'dmdzdbdgc（LDL-C）cdsjh	', '低密度脂蛋白胆固醇（LDL-C）测定试剂盒	', 'sccj_szmr', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1364, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_rj', 'ZKM00001886', 'hxbhy', '和兴白花油', 'sccj_fjtpyzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_ml', 5, 'jldw_ml', 0.00, '0.00ml*5ml/瓶', '', 0.0000, '', '', '', 1, 0.0000, 3.5000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-07-03 17:24:09', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1374, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000343', '(jz）zxq', '(金钟）止血钳', 'sccj_shylqx（jt）yxgsssqxc', '', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'JC311216CM弯全齿WD', '', 0.0000, '', 'ml', '', 1, 60.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1384, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001005', 'jgscz', '金刚砂车针', 'sccj_w', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'EX-21', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1394, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000756', 'nch', '南柴胡', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.4250, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1404, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000891', 'ckzsyymcl（fc）', '齿科藻酸盐印模材料（翡翠）', 'sccj_w', '-', 3, '', 'jjdw_t_5432', '', 1, '', 0.00, '908g/桶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1414, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001089', 'jgscz', '金刚砂车针', 'sccj_w', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'CR-12EF', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1424, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001416', 'etfhwq1712322', '儿童防护围裙1712322', 'sccj_szhkylqxyxgs		', '-', 3, '', 'jjdw_j_8137', '', 1, '', 0.00, '0.50铅当量', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1434, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000246', 'ysplptzsy(g)', '盐酸普罗帕酮注射液(国)', 'sccj_gzbysmxzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 5, 'jldw_ml', 10.00, '10ml*5支/盒', '', 0.0000, '', '', '', 1, 4.7500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 14:58:47', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1444, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00001755', 'amxljn（aml）', '阿莫西林胶囊（阿莫灵）', 'sccj_amzy', 'hc20130014', 3, '', 'bzdw_h', 'zxdw_l', 24, 'jldw_g', 0.25, '0.25g*24粒/盒', '', 0.0000, '', '', '', 1, 0.0000, 14.0400, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1454, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000706', 'jyzr', '金樱子肉', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1680, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1464, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001566', 'cjz', '擦镜纸', 'sccj_w', '-', 3, '', 'jjdw_b_2336', '', 1, '', 0.00, '本', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1474, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000494', 'ksgxdmqxy', '快速高效多酶清洗液', 'sccj_wfja', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '1L', '', 0.0000, '', 'ml', '', 1, 250.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-11 09:55:12', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1484, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001514', 'ysaxsp（aps）', '盐酸氨溴索片（安普索）', 'sccj_sds（zg）zyyxgs', 'H19990228', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_mg', 30.00, '30.00mg*20片/盒', 'ad us.int', 30.0000, '', '', 'TID', 1, 11.0000, 15.4000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 3, NULL, '2018-04-26 16:43:26', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1494, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000460', 'lhjzsy', '氯化钾注射液', 'sccj_bjymyyyxgs', 'H11020320', 3, '', 'bzdw_z', 'zxdw_kg_g', 1, 'jldw_ml', 10.00, '10.00ml*1g/支', 'Iv', 10.0000, '', '', 'Prn', 2, 0.4200, 0.5900, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 5, NULL, '2018-04-19 13:37:55', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1504, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000612', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '国械注进20152552079', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'TC-21EF(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1514, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000331', 'ssd', '手术灯', 'sccj_shhfylqxyxgs', '', 3, '', 'jjdw_t_148', '', 1, '', 0.00, 'YD01-Ⅱ（L751）冷光单孔（可调光）', '', 0.0000, '', 'ml', '', 1, 860.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1524, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001231', 'sgbd	', '石膏绷带	', 'sccj_shxh', '-', 3, '', 'jjdw_j', '', 1, '', 0.00, '（11cm）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1534, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001379', 'ltjbzd', '立体卷包装袋', 'sccj_sdxhyl		', '-', 3, '', 'jjdw_x', '', 1, '', 0.00, '山东新华（100m*10cm*2cm,3卷/箱）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1544, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001078', 'jxb（3m）', '接线板（3m）', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 47.9000, 47.9000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1554, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001025', 'hsqzb', '黑色签字笔', 'sccj_amzyc', '', 3, '', 'bzdw_h', 'zxdw_z', 12, '', 0.00, '12支/盒', '', 0.0000, '', 'ml', '', 2, 1.8000, 1.8000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1564, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001651', 'ffafssp  kdl（TX）', '复方氨酚肾素片  科达琳（TX）', 'sccj_xfyg', '7CG3', 3, '', 'bzdw_h', 'zxdw_h', 1, 'jldw_p', 18.00, '18.00片*1盒/盒', '', 0.0000, '', '', '', 1, 0.0000, 22.5200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-06-28 17:35:23', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1574, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tptj', 'ZKM00000408', 'fsmp', '呋塞米片', 'sccj_tjlszygfyxgs', 'H12020163', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 20.00, '20.00mg*100片/瓶', 'ad us.int', 40.0000, '', '', 'qd', 1, 9.2000, 12.8800, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, NULL, '2018-04-19 11:48:50', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1584, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000820', 'lxc', '鹿衔草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1340, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1594, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000742', 'ggctq', '根管充填器', 'sccj_Ormcocorporat Ion Also sa ', '--', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '974-0060', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-04-08 16:39:30', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1604, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001075', 'ysglh', '药水管理盒', 'sccj_w', '-', 3, '', 'jjdw_t', '', 1, '', 0.00, '988-0280', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1614, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000492', 'dtydszsy（nhp）（bx）', '地特胰岛素注射液（诺和平）（笔芯）', 'sccj_nhnd（zg）zyyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '3ml：300U', '', 0.0000, '', 'ml', '', 1, 182.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-10 23:26:25', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1624, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000845', 'mdpt', '牡丹皮炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1900, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1634, 'hclb_gzyhp', 2, 1, 'hclb_gzyhp', '', 'ZKW00001522', '2.5mbzdsslbd', '2.5米标准对数视力表灯', 'sccj_gdyhylqxcyxgs', '-', 3, '', 'jjdw_t_148', '', 1, '', 0.00, '台', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1644, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000651', 'jyprotaper', '机用protaper', 'sccj_xnddsb', '国食药监械（进）字2014第2061388号', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm混', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 09:28:26', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1654, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000607', 'bmg', '白茅根', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0900, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1664, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000902', 'csjyjgzj（ggdxz）', '超声洁牙机工作尖（根管荡洗针）', 'sccj_w', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '25#红6*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1674, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000848', 'slg', '生龙骨', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1510, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 10:45:47', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1684, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000975', 'ssj', '手术剪', 'sccj_cdswsclc', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '14cm直圆', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1694, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000609', 'mbc', '马鞭草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0420, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1704, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000213', 'lzz', '留置针', 'sccj_szxdylqxyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '24G', '', 0.0000, '', 'ml', '', 1, 11.3600, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1714, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000054', 'jgp', '肌苷片', 'sccj_hnzycyxgs', 'h46020244', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_g', 0.20, '0.20g*100片/瓶', '', 0.0000, '', '', '', 1, 6.4000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 16:04:43', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1724, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000974', 'ycxsywjzsqdz', '一次性使用无菌注射器带针', 'sccj_cdsxjsfylqxyxgs', '国械注准20163150107', 3, '', 'jjdw_z', '', 1, '', 0.00, '1ml0.45*15', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-30 13:23:40', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1734, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001322', 'ycxqgqkb', '一次性气管切开包', 'sccj_jsry', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '江苏荣业,7.0#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1744, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001157', 'PEjcst', 'PE检查手套', 'sccj_bjgsyl', '陕宝械备20170001号', 3, '', 'jjdw_d', '', 1, '', 0.00, 'M号', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1754, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000225', 'ycxsywjzsz（zszt）', '一次性使用无菌注射针（注射针头）', 'sccj_zjkdlylqxgfyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '0.45*16', '', 0.0000, '', 'ml', '', 1, 0.1700, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 13:54:29', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1764, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000199', 'lsatpp', '硫酸阿托品片', 'sccj_xxsclzyyxzrgs', 'h41020202', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 0.30, '0.30mg*100片/瓶', '', 0.0000, '', '', '', 1, 6.9000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 16:06:39', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1774, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001017', 'A4dyz', 'A4打印纸', 'sccj_amzyc', '', 3, '', 'bzdw_h', 'zxdw_b', 5, '', 0.00, '5包/盒', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1784, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000739', 'ctmbytz', '瓷贴面备牙套装', 'sccj_shdb', '--', 3, '', 'jjdw_t', '', 1, '', 0.00, 'FG0807D', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1794, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000518', 'ycxkz wj yywkkz', '一次性口罩 无菌 医用外科口罩', 'sccj_zb', '', 3, '', 'jjdw_p_10962', '', 1, '', 0.00, '独立包装10片/包', '', 0.0000, '', 'ml', '', 1, 0.9000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-11 17:48:56', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1804, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_w', 'ZKM00000111', 'jsgjw（nsw）', '金锁固精丸（浓缩丸）', 'sccj_jztgfyxgs', 'z2002342', 3, '', 'bzdw_p', 'zxdw_w', 200, 'jldw_g', 0.20, '0.20g*200丸/瓶', '', 0.0000, '', '', '', 1, 5.7000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 16:07:28', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1814, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001357', 'sddtdktwlyyq', '手动单通道可调微量移液器', 'sccj_dlxcsyyq（bj）yxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '20-200μl', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1824, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000821', 'dk', '豆蔻', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.2910, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1834, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_kfy', 'ZKM00001887', 'sdcby', '蛇胆川贝液', 'sccj_hbdxyyyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 6, 'jldw_ml', 10.00, '10.00ml*6支/盒', '', 0.0000, '', '', '', 1, 0.0000, 6.5000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-07-03 17:21:34', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1844, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000278', 'allsnp', '阿仑膦酸钠片', 'sccj_cdttszyyxgs', '', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_mg', 10.00, '10.00mg*7片/盒', '', 0.0000, '', '', '', 1, 9.7000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-24 11:26:21', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1854, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000856', 'tgj', '烫狗脊', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0620, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 10:46:29', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1864, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001186', 'yys', '益元散', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0540, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1874, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000151', 'ygz', '牙骨凿', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1884, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001280', 'hsp（fz）', '黑顺片（附子）', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.6900, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1894, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000673', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'TC-26(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1904, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000137', 'czq', '持针器', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '14', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1914, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000552', 'rstymcdsjh（rsdwf）', '乳酸脱氧酶测定试剂盒（乳酸底物法）', 'sccj_glyltyldzyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '40ml*5；10ml*5', '', 0.0000, '', 'ml', '', 1, 308.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1924, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_klj', 'ZKM00000219', 'amxlklwsjkl', '阿莫西林克拉维酸钾颗粒', 'sccj_xsyyyxgs', 'H20163326', 3, '', 'bzdw_h', 'zxdw_b', 6, 'jldw_g', 0.15, '0.15g*6包/盒', '', 0.0000, '', '', '', 1, 8.3000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 16:46:59', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1934, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001189', 'hqm', '黄芩面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1360, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1944, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000718', 'fcbs', '麸炒白术', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.2020, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1954, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000401', 'dmcxq', '动脉采血器', 'sccj_bdylqx（sh）yxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '22G*1', '', 0.0000, '', 'ml', '', 1, 10.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1964, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000910', 'jgcxdkd', '技工醋型雕刻刀', 'sccj_shkqylqxyxgs', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '#E4610支/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 16:58:12', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1974, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000257', 'ysskqwhq', '压缩式空气雾化器', 'sccj_shyyylsbyxgs', '', 3, '', 'jjdw_t_148', '', 1, '', 0.00, '403C', '', 0.0000, '', 'ml', '', 1, 400.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-15 10:11:09', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1984, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000390', 'ysxtlqp（xtm）', '盐酸西替利嗪片（仙特明）', 'sccj_UCB PARCHIM SA rs bj', 'H20100740', 3, '', 'bzdw_h', 'zxdw_p', 5, 'jldw_mg', 10.00, '10.00mg*5片/盒', 'PO', 10.0000, '', '', 'qd', 1, 16.2900, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 10, 2, NULL, '2018-02-24 09:16:48', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (1994, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tgj', 'ZKM00000433', 'xttg', '消痛贴膏', 'sccj_xcqzcygfyxgs', '国药准字Z54020113', 3, '', 'bzdw_h', 'zxdw_d', 6, 'jldw_t', 1.00, '1.00贴*6袋/盒', '', 0.0000, '', '', '', 1, 82.0300, 114.8400, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 1, NULL, '2018-04-08 15:04:58', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2004, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_gj', 'ZKM00001614', 'mylsxzcg', '马应龙麝香痔疮膏', 'sccj_mylyyjtgfyxgs', '170909', 3, '', 'bzdw_h', 'zxdw_z', 6, 'jldw_g', 4.00, '4.00g*6支/盒', '', 0.0000, '', '', '', 1, 0.0000, 23.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2014, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001125', 'lsgnjj', '临时冠粘接剂', 'sccj_dgDMGhxyyjtgs', '国食药监械（进）字2014第3631866', 3, '', 'jjdw_t', '', 1, '', 0.00, '110137', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2024, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000255', 'tsqnzsy', '碳酸氢钠注射液', 'sccj_gyjtrszyyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 5, 'jldw_ml', 10.00, '10ml*5支/盒', '', 0.0000, '', '', '', 1, 4.2000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 15:01:20', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2034, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001475', 'xxbfxyrxj	', '血细胞分析用溶血剂	', 'sccj_szmr', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2044, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000114', 'ssdp', '手术刀片', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_d', '', 1, '', 0.00, '11/12', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2054, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsjn', 'ZKM00001599', 'ktljn', '咳特灵胶囊', 'sccj_hzslfszyyxgs', '171001', 3, '', 'bzdw_h', 'zxdw_b_7638', 2, 'jldw_p', 12.00, '12.00片*2板/盒', '', 0.0000, '', '', '', 1, 8.5000, 8.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2064, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000829', 'ssgjh', '手术工具盒', 'sccj_w', '-', 3, '', 'jjdw_t', '', 1, '', 0.00, 'UXIF', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2074, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001657', 'ysjpky/ssxszsy（skdn）', '盐酸甲哌卡因/肾上腺素注射液（斯康杜尼）', 'sccj_fglbfnzygs', 'H20171134', 3, '', 'bzdw_h', 'zxdw_z', 50, 'jldw_ml', 1.80, '1.80ml*50支/盒', '', 0.0000, '', '', '', 1, 0.0000, 8.3000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2084, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001382', 'hpf', '琥珀粉', 'sccj_trt', '', 3, '', 'bzdw_hk', 'zxdw_kg_g', 15, 'jldw_g', 15.00, '15g/包', '', 15.0000, '', '', '', 1, 2.0500, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2094, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000614', 'tmhj', '脱敏糊剂', 'sccj_sctfjxhgyxgs', '川械注准20162630195', 3, '', 'jjdw_z', '', 1, '', 0.00, '120g', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2104, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001220', 'qp', '秦皮', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0620, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2114, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000876', 'ycxglm（fwm）', '一次性隔离膜（防污膜）', 'sccj_w', '-', 3, '', 'jjdw_j', '', 1, '', 0.00, '1200片/卷', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2124, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000484', 'atpzsy', '阿托品注射液', 'sccj_dd', '', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_mg', 0.50, '0.50mg*10支/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-01-15 10:33:25', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2134, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000709', 'HXbzxwdzsgtc', 'HX标准型网底直丝弓托槽', 'sccj_hzxyckclyxgs', '--', 3, '', 'jjdw_d', '', 1, '', 0.00, '8416-20B(不带钩)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2144, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000201', 'dpltp', '多潘立酮片', 'sccj_hnqjxjyygfyxgs', 'h20093426', 3, '', 'bzdw_h', 'zxdw_p', 30, 'jldw_mg', 10.00, '10.00mg*30片/盒', '', 0.0000, '', '', '', 1, 10.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 17:02:07', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2154, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rj', 'ZKM00001881', 'dqytp（dft）', '地屈孕酮片（达芙通）', 'sccj_Abbott Biologicals B.V.', 'h20170221', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_mg', 10.00, '10mg*20片/盒', '', 0.0000, '', '', '', 1, 0.0000, 111.1300, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2164, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001020', 'yzdtz', '牙周袋探针', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '单头KPC2', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2174, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000597', 'Kc', 'K锉', 'sccj_xnddsb', '国械备20170214号', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm-6', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2184, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000694', 'hhh', '合欢花', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.3920, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2194, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000305', 'xsgyp', '硝酸甘油片', 'sccj_bjymyyyxgs', 'H11021022', 3, '', 'bzdw_p', 'zxdw_p', 50, 'jldw_mg', 0.50, '0.50mg*50片/瓶', 'ad us.int', 0.5000, '', '', '', 1, 6.2000, 8.6800, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, NULL, '2018-04-19 13:34:54', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2204, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000882', 'ygc（st）', '牙刮匙（双头）', 'sccj_w', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '#E2', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2214, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000957', 'fxy', '番泻叶', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0730, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2224, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000011', 'ytsl', '液体石蜡', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2234, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000333', 'dxpzsy(ad)', '地西泮注射液(安定)', 'sccj_tjjyyyyxgs', 'H12020957', 3, '', 'bzdw_z', 'zxdw_ml', 2, 'jldw_mg', 10.00, '10.00mg*2ml/支', '', 10.0000, '', '', 'Prn', 1, 3.9000, 5.4600, 'fylb_xyf', 'fpxm_xyf', 0, 0, 1, 0, 0, 10, 4, NULL, '2018-05-04 15:32:04', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2244, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001269', 'dxc', '灯心草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.6000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2254, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001009', 'scr', '山慈茹', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 1.7920, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2264, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001745', 'fflhnzsy(sp)', '复方氯化钠注射液(塑瓶)', 'sccj_sjzsyyxgs', 'H13023036', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 500.00, '500.00ml*1瓶/瓶', 'jmdz', 500.0000, '', '', 'bys', 2, 0.0000, 1.7200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2274, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000059', 'pgg', '抛光膏', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '浅绿', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2017-09-12 15:57:09', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2284, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_gj', 'ZKM00000330', 'ynbyckt', '云南白药创可贴', 'sccj_ynbyjtwxyyyxgswtjsnfwcyy', 'z20073016', 3, '', 'bzdw_p_1730', 'zxdw_p', 1, 'jldw_cm', 1.50, '1.50cm*1片/片', '', 0.0000, '', '', '', 1, 0.1340, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-19 11:54:43', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2294, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001375', 'cbf', '川贝粉', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 2, 'jldw_g', 2.00, '2g/盒', '', 2.0000, '', '', '', 1, 21.6000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2304, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000013', 'zzq', '组织钳', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_m', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2314, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000681', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'SI-S48(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2324, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000351', 'jgap', '甲钴胺片', 'sccj_hzkebzy', '', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_mg', 0.50, '0.50mg*20片/盒', '', 0.0000, '', '', '', 1, 8.4000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2334, 'yplb_zcy', 1, 0, 'yplb_zcy', 'ypjx_cj', 'ZKM00000045', '5', '5', 'sccj_adyy(bj)yxgs', '5', 3, '5', 'bzdw_h', 'zxdw_b_7638', 1, 'jldw_l', 12.00, '12粒*1板/盒', 'ad us.int', 3.0000, '', '', 'Am', 1, 10.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 1, 0, 0, 0, NULL, '2017-12-28 23:14:58', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2344, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000097', 'bsz', '拔髓针', 'sccj_mnzshs', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, '0# 12*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:40:47', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2354, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000046', 'xtsz', '血糖试纸', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2364, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001068', 'gghfhsz', '光固化复合树脂', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '7018A3B', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2374, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_zsj', 'ZKM00000342', 'wssD2zsy', '维生素D2注射液', 'sccj_jxnhxyyyxgs', '', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 5.00, '5.00ml*1支/支', '', 0.0000, '', '', '', 1, 18.3900, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-12-13 11:15:59', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2384, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001378', 'ylzqmjhxcsb', '压力蒸汽灭菌化学测试包', 'sccj_sdxhyl		', '-', 3, '', 'jjdw_x', '', 1, '', 0.00, '山东新华(30包/箱)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2394, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001007', 'jgscz', '金刚砂车针', 'sccj_llhtylcdsbjs（bj）yxgs', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'F0-25', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2404, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001293', 'wl 6cm/g Ax crx ', '维力 6cm/个 A型 成人型 ', 'sccj_yzyc', '-', 3, '', 'jjdw_g', '', 1, '', 0.00, '双鼻带架', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2414, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_cj', 'ZKM00000047', 'amxljn', '阿莫西林胶囊', 'sccj_adyy(bj)yxgs', '', 3, '', 'bzdw_h', 'zxdw_l', 24, 'jldw_g', 0.25, '0.25g*24粒/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2424, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000813', 'dtSuperlinezzt', '登腾Superline种植体', 'sccj_EA', '--', 3, '', 'jjdw_h', '', 1, '', 0.00, 'FX4508SW', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-21 09:40:51', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2434, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001118', 'ycxsymxz', '一次性使用埋线针', 'sccj_zjggylqxyxgs', '苏食药监械生产许2001-0244', 3, '2001-0244', 'jjdw_z', '', 1, '', 0.00, '0.9*62mm', '', 0.0000, '', 'ml', '', 1, 0.0000, 3.5000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-31 12:41:33', 1, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2444, 'bgyplb_jgyplcl', 3, 1, 'bgyplb_jgyplcl', '', 'ZKM00001363', 'bbj', '标本架', 'sccj_amzyc', '', 3, '', 'bzdw_t', 'zxdw_g', 1, '', 0.00, '1个/条', '', 0.0000, '', 'ml', '', 2, 26.0000, 26.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-08-27 15:22:52', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2454, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000885', 'cxp', '成形片', 'sccj_w', '-', 3, '', 'jjdw_b', '', 1, '', 0.00, '#2中20片/袋', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2464, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dj', 'ZKM00000281', 'ykxwssADdj(0-1s)', '伊可新维生素AD滴剂(0-1岁)', 'sccj_sddyhyswzygfyxgs', 'h37022973', 3, '', 'bzdw_h', 'zxdw_h', 1, 'jldw_l', 20.00, '20.00粒*1盒/盒', '', 0.0000, '', '', '', 1, 12.6200, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:20:42', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2474, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000031', 'fyxtq', '负压吸痰器', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2484, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000327', 'ytkxp', '依托考昔片', 'sccj_hzmsdzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_p', 5, 'jldw_mg', 120.00, '120.00mg*5片/盒', '', 0.0000, '', '', '', 1, 68.0200, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2494, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001590', 'tptp', '托盘天平', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2504, 'hclb_gzyhp', 2, 1, 'hclb_gzyhp', '', 'ZKW00001671', '1', '1', 'sccj_flp', '1', 3, '', 'jjdw_b_189', '', 1, '', 0.00, '板', '', 0.0000, '', 'ml', '', 1, 0.0000, 10.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2514, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000904', 'lk', '龙葵', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.0450, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2524, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dyj', 'ZKM00001765', 'blsndyy', '玻璃酸钠滴眼液', 'sccj_zhlbzygfyxgszsfgs', 'H20040352', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 5.00, '5.00ml*1支/支', 'dyy', 0.1000, '', '', 'bys', 1, 0.0000, 19.4000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-30 09:59:10', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2534, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000900', 'jcx', '酒川芎', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.1460, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2544, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000824', 'xqc', '豨签草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.0300, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2554, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000680', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'TC-11C(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2564, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_kfy', 'ZKM00000108', 'qlppl（wtx）', '强力枇杷露（无糖型）', 'sccj_hebsklyyyxzrgs', 'z23023220', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 150.00, '150.00ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 27.7500, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:23:08', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2574, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000478', 'ldkyzsy', '利多卡因注射液', 'sccj_dd', '', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_mg', 100.00, '100.00mg*1支/支', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2584, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000329', 'dsmslsnzsy（K）', '地塞米松磷酸钠注射液（K）', 'sccj_cxyygfyxgs', 'h37021969', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 1.00, '1.00ml*1支/支', '', 0.0000, '', '', '', 1, 0.1570, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:25:02', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2594, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000240', 'yytxbd', '医用弹性绷带', 'sccj_ajhjylqxyxgs', '', 3, '', 'jjdw_k_7001', '', 1, '', 0.00, '7.5*450CM', '', 0.0000, '', 'ml', '', 1, 2.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2604, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001312', 'sdt', '手电筒', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '白光聚光SF-411', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2614, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000587', 'Kc', 'K锉', 'sccj_xnddsb', '国械备20170214号', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm-20', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2624, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000703', 'sn', '山奈', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.2000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2634, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000289', 'fflxpabddp', '复方利血平氨苯蝶啶片', 'sccj_hrshyygfyxgs', '', 3, '', 'bzdw_h', 'zxdw_h', 1, 'jldw_p', 10.00, '10片*1盒/盒', '', 0.0000, '', '', '', 1, 13.0400, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 11:00:55', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2644, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001544', 'ycxsyrtjmxycjrq', '一次性使用人体静脉血样采集容器', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2654, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001689', 'ggp', '刮宫片', 'sccj_ncymyywcyxgs		', '', 3, '', 'jjdw_d', '', 1, '', 0.00, '袋', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2664, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001612', 'wssCzsy', '维生素C注射液', 'sccj_rs', 'H41023393', 3, '', 'bzdw_z', 'zxdw_ml', 2, 'jldw_g', 0.50, '0.50g*2ml/支', 'Ut dict', 0.0000, '', '', '', 1, 0.2600, 0.3600, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 20, 6, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2674, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000945', 'jdg', '酒当归', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.3140, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2684, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001610', 'zjz 0.3*50mm', '针灸针 0.3*50mm', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2694, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000571', 'xc', '玄参', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.1000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:33:01', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2704, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000952', 'sbhss', '生北寒水石', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0350, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2714, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000650', 'jyprotaper(cs）', '机用protaper(橙色）', 'sccj_xnddsb', '国食药监械（进）字2014第2061388号', 3, '', 'jjdw_h', '', 1, '', 0.00, '19mm-SX(橙色）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 09:28:31', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2724, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000259', 'bltwj', '玻璃体温计', 'sccj_deejahylqxyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '腋下（大）内标式', '', 0.0000, '', 'ml', '', 1, 5.0000, 0.0000, 'fylb_qt', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-15 10:26:10', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2734, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001292', 'dl', '地龙', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 1.2320, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2744, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000161', 'xsyslzp', '硝酸异山梨酯片', 'sccj_smtjzy(js)yxzrgs', 'h32024617', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 5.00, '5.00mg*100片/瓶', '', 0.0000, '', '', '', 1, 3.6000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:30:06', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2754, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000406', 'ycxsybgsyq  dz', '一次性使用避光输液器  带针', 'sccj_sdqpjtyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, 'QBA4-A0.7*23', '', 0.0000, '', 'ml', '', 1, 5.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2764, 'hclb_dzyhp', 2, 0, 'hclb_dzyhp', '', 'ZKW00000789', 'ysb（TX）', '压舌板（TX）', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '100*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-21 16:26:33', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2774, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001747', '0.9%lhnzsy（sp）', '0.9%氯化钠注射液（塑瓶）', 'sccj_sjzsyyxgs', 'H13023201', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 250.00, '250.00ml*1瓶/瓶', '', 0.0000, '', '', '', 2, 0.0000, 1.0300, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2784, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_pj', 'ZKM00000541', 'gysmsblp', '枸橼酸莫沙必利片', 'sccj_lnbtzyyxgs', 'H19990317', 3, '', 'bzdw_h', 'zxdw_p', 24, 'jldw_mg', 5.00, '5.00mg*24片/盒', '', 0.0000, '', '', '', 1, 18.4600, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 2, NULL, '2018-03-02 17:04:11', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2794, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000769', 'wztp', '网状托盘', 'sccj_rxckclyxgs', '沪食药监械', 3, '', 'jjdw_f_3720', '', 1, '', 0.00, '小', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2804, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001337', 'sdz', '生杜仲', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0670, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2814, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hjp', 'ZKM00001787', 'tbmsdyy（tbs）0.3%', '妥布霉素滴眼液（托百士）0.3%', 'sccj_s.a ALCON-COUVREUR  n v', 'H20140811', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 5.00, '5.00ml*1支/支', '', 0.0000, '', '', '', 1, 0.0000, 16.0900, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2824, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_wj', 'ZKM00000168', 'nsdgw', '浓缩当归丸', 'sccj_zjwxzygfyxgs', 'z41021821', 3, '', 'bzdw_h', 'zxdw_w', 1, 'jldw_w', 200.00, '200.00丸*1丸/盒', '', 0.0000, '', '', '', 1, 10.3000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:32:43', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2834, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001228', 'tlbd	', '弹力绷带	', 'sccj_ hsk', '-', 3, '', 'jjdw_j', '', 1, '', 0.00, '7.5*4.5*480', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2844, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000806', 'yyxjst', '医用橡胶手套', 'sccj_shkbyyrjqcyxgs', '沪械注准20152660114', 3, '', 'jjdw_s', '', 1, '', 0.00, '6.5', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2854, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000120', 'sgj', '石膏剪', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2864, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000334', 'yyycxkz', '医用一次性口罩', 'sccj_sdayylkjyxgs', '', 3, '', 'jjdw_d', '', 1, '', 0.00, '17.5x9cmx10个/袋', '', 0.0000, '', 'ml', '', 1, 3.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2874, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000910', 'ybgz', '盐补骨脂', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0950, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2884, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001343', 'jyhxq', '简易呼吸器', 'sccj_dgblgfhxyxgs', '-', 3, '', 'jjdw_t', '', 1, '', 0.00, 'MN001-A/PVC成人型', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2894, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dyj', 'ZKM00000058', 'yfsxdyy', '氧氟沙星滴眼液', 'sccj_cxfdyy(ws)yxgs(ycxyygfyxgs)', 'h10960124', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 5.00, '5.00ml*1支/支', '', 0.0000, '', '', '', 1, 1.3500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:55:41', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2904, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000723', 'Z350XTgghnmsz', 'Z350XT光固化纳米树脂', 'sccj_3MESPE DENTAL PRODUCT', '--', 3, '', 'jjdw_z', '', 1, '', 0.00, '7018(A3.5)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2914, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000861', 'qm', '瞿麦', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0290, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2924, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001345', 'nszt', '南山楂炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0560, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2934, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000938', 'swlz', '生瓦楞子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0190, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-03-20 15:42:09', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2944, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000357', 'zjsmbxyy', '指夹式脉搏血氧仪', 'sccj_jsyyylsbgfyxgs', '', 3, '', 'jjdw_t_148', '', 1, '', 0.00, 'YX304', '', 0.0000, '', 'ml', '', 1, 150.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 14:16:08', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2954, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000494', 'wDgjjp(dq）', '维D钙咀嚼片(迪巧）', 'sccj_aszyyxgs', '', 3, '', 'bzdw_h', 'zxdw_p_1', 1, 'jldw_p', 60.00, '60.00片*1瓶/盒', '', 0.0000, '', '', '', 1, 41.2300, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-01-18 11:30:28', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2964, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001637', 'jjd', '酒精灯', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2974, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000882', 'dfhs', '锻浮海石', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2240, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 11:02:25', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2984, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000675', 'hpk', '琥珀块', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0540, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (2994, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000621', 'sfj', '水飞蓟', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0390, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3004, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000849', 'ggkdz', '根管扩大针', 'sccj_mnzshs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm 06H 6*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-22 17:40:39', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3014, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000766', 'tcwp', '烫刺猬皮', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.4830, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3024, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000048', 'wkhyc', '外科换药车', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3034, 'bgyplb_jgyplcl', 3, 1, 'bgyplb_jgyplcl', '', 'ZKM00001400', 'A4hywjj100y', 'A4活页文件夹100页', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 30.0000, 30.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3044, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_fzj', 'ZKM00000445', 'zsyxnm', '注射用血凝酶', 'sccj_plnkyyyxgs', '', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_dw', 1.00, '1.00单位*1支/支', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3054, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001178', 'dzrt', '煅自然铜', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0400, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3064, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001798', 'jgap（ow）', '甲钴胺片（欧维）', 'sccj_syyhzyyxgs', 'H20050168', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_mg', 0.50, '0.50mg*20片/盒', '', 0.0000, '', '', '', 1, 0.0000, 20.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3074, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001675', 'cnn250ml', '纯牛奶250ml', 'sccj_amzyc', NULL, 3, '', 'bzdw_x', 'zxdw_h', 24, '', 0.00, '24盒/箱', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3084, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000152', 'fln', '敷料镊', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '14cm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3094, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_sj', 'ZKM00001546', 'jjfhqs', '聚甲酚磺醛栓', 'sccj_sdxsdyy', 'H20055730', 3, '', 'bzdw_h', 'zxdw_l', 6, 'jldw_mg', 90.00, '90.00mg*6粒/盒', '', 0.0000, '', '', '', 1, 20.0400, 2.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3104, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00001355', 'gysbjjn（lzdl）', '枸橼酸铋甲胶囊（丽珠得乐）', 'sccj_lzjtlzzyc', 'H10920098', 3, '', 'bzdw_h', 'zxdw_l', 20, 'jldw_g', 0.30, '0.30g*20粒/盒', 'ad us.int', 0.3000, '', '', 'Qid', 1, 11.6800, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 3, NULL, '2018-03-13 14:38:59', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3114, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000099', 'PROTAPER', 'PROTAPER', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3124, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000997', 'pl', '佩兰', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0390, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3134, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001180', 'yqs', '阴起石', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0110, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3144, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001228', 'spx', '桑螵蛸', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 2.9120, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3154, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000889', 'xr', '香薷', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0450, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 11:03:59', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3164, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000749', 'sej', '生阿胶', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 5.3960, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3174, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001061', 'jt', '胶条', 'sccj_amzyc', '', 3, '', 'bzdw_t_2442', 'zxdw_g', 36, '', 0.00, '8个/桶', '', 0.0000, '', 'ml', '', 2, 0.3700, 0.3700, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-03-01 14:48:41', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3184, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000012', 'xpq', '橡皮圈', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3194, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00000489', 'thxhdb（HbAlc）dlcdsjh（mf）', '糖化血红蛋白（HbAlc）定量测定试剂盒（酶法）', 'sccj_shkh', '', 3, '', 'jjdw_h', '', 1, '', 0.00, 'Rla：1*1.85ml/瓶Rlb：1*8ml/瓶R2:1*11.5ml', '', 0.0000, '', 'ml', '', 1, 2000.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3204, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000747', 'bxgyt', '不锈钢牙托', 'sccj_shkqylqxyxgs', 'B3124(2013)0654', 3, '', 'jjdw_ge', '', 1, '', 0.00, '2#下有孔', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3214, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001488', 'dlpmtksmpc90d', '得力皮面摊开式名片册90袋', 'sccj_amzyc', NULL, 3, '', 'bzdw_b_9413', 'zxdw_b_2375', 1, '', 0.00, '1本/本', '', 0.0000, '', 'ml', '', 2, 19.0000, 19.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3224, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001196', 'ycxzkcxgkng', '一次性真空采血管抗凝管', 'sccj_jskjylqxyxgs', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, '100个/板江苏康捷', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3234, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000039', 'xedzxyj', '小儿电子血压计', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3244, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000892', 'thf', '天花粉', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1230, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3254, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001234', 'lx', '莲须', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.3920, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3264, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001596', 'zjzth 0.25*25mm', '针灸针套盒 0.25*25mm', 'sccj_w', '-', 3, '', 'jjdw_t', '', 1, '', 0.00, '套', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3274, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000556', 'cbqnz', '炒白牵牛子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0300, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3284, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000324', 'wjssdp', '无菌手术刀片', 'sccj_shylqx（jt）yxgsssqxc', '', 3, '', 'jjdw_p_10962', '', 1, '', 0.00, 'K1-10', '', 0.0000, '', 'ml', '', 1, 0.4050, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3294, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001340', 'dzxyj', '电子血压计', 'sccj_oml dl', '-', 3, '', 'jjdw_t_148', '', 1, '', 0.00, '家用上臂式HEM-7112上臂式', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3304, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000149', 'txq', '梯形钳', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3314, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000325', 'wssB2zsy', '维生素B2注射液', 'sccj_shpjlzzyyxgs', 'h41023864', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 2.00, '2.00ml*1支/支', '', 0.0000, '', '', '', 1, 0.3100, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 09:00:32', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3324, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000755', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '国械注进20152552079', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'EX-12(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3334, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000921', 'ggtccl（AH Plus）', '根管填充材料（AH Plus）', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, 'A糊剂3ml/管+B糊剂3ml/管', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3344, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_qwj', 'ZKM00001758', 'jhjpwj', '金喉健喷雾剂', 'sccj_gzhyyyyxgs', '国药准字Z20025361', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 20.00, '20.00ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 0.0000, 21.5800, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3354, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000558', 'mmgzt', '绵马贯众炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0160, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:46:36', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3364, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001399', '20mlzsq', '20ml注射器', 'sccj_jxhd		', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '16#100支/盒800支/件', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3374, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001430', 'ycxtyms', '一次性涂药毛刷', 'sccj_hb/kt', '-', 3, '', 'jjdw_t_5432', '', 1, '', 0.00, '黄色中号100支/筒4筒/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3384, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000740', 'pgcz（jswk）', '破冠车针（金鲨外科）', 'sccj_SSW.WHITE BURS.IN', '--', 3, '', 'jjdw_z', '', 1, '', 0.00, 'GW-558LSL', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3394, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000619', 'ggctjA.H', '根管充填剂A.H', 'sccj_xnddsb', '国械注进20153630830', 3, '', 'jjdw_h', '', 1, '', 0.00, '3ml', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3404, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000977', 'mz', '脉枕', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '无', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3414, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000567', 'fs', '茯神', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2910, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:32:41', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3424, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000701', 'bxgfs', '不锈钢方丝', 'sccj_shamdclljgfyxgs', '沪食药监械（准）字2011第2630861', 3, '', 'jjdw_d', '', 1, '', 0.00, '卵圆18*22上', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 08:49:44', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3434, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001225', 'tx', '檀香', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 3.3160, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3444, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000528', 'wblxzet', '王不留行子耳贴', 'sccj_dd', '', 3, '', 'jjdw_l', '', 1, '', 0.00, '600粒', '', 0.0000, '', 'ml', '', 1, 0.0200, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3454, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001117', 'tgsb', '烫骨碎补', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1680, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3464, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001145', 'knpgb', '口内抛光杯', 'sccj_dgslgylqxyxgs', '沪虹械备20150219号', 3, '', 'jjdw_ge', '', 1, '', 0.00, '无', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3474, 'hclb_fskcl', 2, 1, 'hclb_fskcl', '', 'ZKW00000437', 'rmjp', '热敏胶片', 'sccj_hqylkj（sz）yxgs', '', 3, '', 'jjdw_zhang', '', 1, '', 0.00, '14x17 100张/盒 5盒/箱', '', 0.0000, '', 'ml', '', 1, 10.8000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-23 13:34:19', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3484, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tptj', 'ZKM00000414', 'axtlkfy', '氨溴特罗口服液', 'sccj_Abbott Biologicals B.V.', '', 3, '', 'bzdw_p', 'zxdw_ml', 60, 'jldw_ml', 60.00, '60.00ml*60ml/瓶', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3494, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001324', 'asamlzmcrp（nx）', '艾司奥美拉唑镁肠溶片（耐信）', 'sccj_aslkzy', '国药准字h20046379', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_mg', 20.00, '20.00mg*7片/盒', 'Ac', 20.0000, '', '', 'qd', 1, 72.5000, 101.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 5, NULL, '2018-04-27 15:37:40', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3504, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000483', 'dxpzsy', '地西泮注射液', 'sccj_dd', '', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_mg', 10.00, '10.00mg*1支/支', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3514, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001214', 'bljn', '北刘寄奴', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0670, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3524, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000398', 'slsgj', '塑料试管架', 'sccj_tzsfylqxyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '13MM*50孔', '', 0.0000, '', 'ml', '', 1, 15.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3534, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_cj', 'ZKM00000279', 'pttsxkfy', '葡萄糖酸锌口服液', 'sccj_hbnlyyyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_ml', 10.00, '10ml*10支/盒', '', 0.0000, '', '', '', 1, 7.3000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-08 15:12:20', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3544, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001564', 'qdq', '起钉器', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3554, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000144', 'ydmxjn', '吲哚美辛胶囊', 'sccj_sxfhzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_l', 100, 'jldw_mg', 25.00, '25mg*100粒/瓶', '', 0.0000, '', '', '', 1, 2.5000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 10:55:27', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3564, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001501', '7hdc', '7号电池', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_l', 1, '', 0.00, '1粒/个', '', 0.0000, '', 'ml', '', 2, 2.3250, 2.3250, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3574, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001729', 'bgjjst', '不干胶警示贴', 'sccj_amzyc', NULL, 3, '', 'bzdw_j', 'zxdw_j', 1, '', 0.00, '500张/卷', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-25 09:18:18', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3584, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000849', 'swt', '首乌藤', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/支', '', 10.0000, '', '', '', 1, 0.0500, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 10:46:07', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3594, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000447', 'aqksczq', '安全快速持针器', 'sccj_mgBcctonDickinsonandComnanv', '', 3, '', 'jjdw_g', '', 1, '', 0.00, 'Pronto快捷指针器', '', 0.0000, '', 'ml', '', 1, 10.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-10 11:51:30', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3604, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000003', 'zxs', '紫雪散', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3614, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000013', 'blfjjp', '布洛芬咀嚼片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1.00g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-10-11 19:14:07', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3624, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000023', 'xeybkl.', '小儿咽扁颗粒.', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3634, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000033', 'zcyerg', '紫草婴儿软膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3644, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000043', 'ffpzhhp', '复方片仔癀含片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3654, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000053', 'ynbyqwj', '云南白药气雾剂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3664, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000063', 'yat', '药艾条', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3674, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000073', 'zsmp', '祖师麻片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3684, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000083', 'kmshtp', '昆明山海棠片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3694, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000093', 'gxnjn', '宫血宁胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3704, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000103', 'rbcms', '壬苯醇醚栓', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3714, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000113', '@rpxp', '@乳癖消片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3724, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000123', '*zzrgrsα-2bnj（yja）', '*重组人干扰素α-2b凝胶（尤靖安）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3734, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000133', 'ldxgw', '龙胆泻肝丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3744, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000143', 'lmfdp(hpd)', '拉米夫定片(贺普丁)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3754, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000153', 'ffgmlkl', '复方感冒灵颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3764, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZDS90000163', 'ffafssp（kdl）', '复方氨酚肾素片（科达琳）', 'sccj_xfyg', '7CK5', 3, '', 'bzdw_h', 'zxdw_p', 12, 'jldw_p', 1.00, '1.00片*12片/盒', '', 0.0000, '', 'ml', '', 1, 25.8000, 22.5200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-21 14:28:04', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3774, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000173', 'sywrg', '湿痒王软膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3784, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000183', 'tkjdw', '痰咳净滴丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3794, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000193', 'bxtj', '半夏糖浆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3804, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000203', 'xyzkp', '消炎止咳片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3814, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000213', 'ffsysjzbhctj', '复方水杨酸甲酯薄荷醇贴剂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3824, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000223', 'akfs', '阿咖酚散', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3834, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000233', 'mlxkfsp（nb）', '美洛昔康分散片（奈邦）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3844, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000243', 'jtsxp', '加替沙星片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3854, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000253', 'ffhajezp', '复方磺胺甲噁唑片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/板', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3864, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000263', 'yszyfsxjn', '盐酸左氧氟沙星胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3874, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000273', 'hskfy', '回生口服液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3884, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000283', 'fjkqm', '蜂胶口腔膜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3894, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000293', 'ndqkl（wtx）', '尿毒清颗粒（无糖型）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3904, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000303', 'gysxdnfp(wak)', '枸橼酸西地那非片(万艾可)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3914, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000313', 'alstjn', '奥利司他胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3924, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000323', 'blymdp', '丙硫氧嘧啶片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3934, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000333', 'bdfjn', '白癜风胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3944, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000343', 'wltpry（xslxl）', '乌洛托品溶液（西施兰夏露）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3954, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000353', 'nswerg', '尿素维e乳膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3964, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000363', 'jtqbp', '景天祛斑片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3974, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000373', 'lrg', '硫软膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3984, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000383', 'jtqbjn', '景天祛斑胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (3994, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000393', 'ysnltsxp(fd)', '盐酸纳洛酮舌下片(风度)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4004, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000403', 'xmgjkl', '玄麦甘桔颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/袋', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4014, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000413', 'bwsnhsp(dbj)', '丙戊酸钠缓释片(德巴金)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4024, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000423', 'ambntj', '安眠补脑糖浆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4034, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000433', 'tmsp', '天麻素片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4044, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000443', 'bbbtdldjp（ydp）', '苯巴比妥东莨菪碱片（晕动片）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4054, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000453', 'nhqww', '牛黄清胃丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4064, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000463', 'ksl（hgy）', '开塞露（含甘油）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4074, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000473', 'cxhqp', '沉香化气片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4084, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000483', 'jbmzp(als)', '甲苯咪唑片(安乐士)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4094, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000493', 'dysbp', '地榆升白片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4104, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000503', 'wxkl（wtx）', '稳心颗粒（无糖型）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4114, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000513', 'yfnxp', '愈风宁心片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4124, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000523', 'jhsbtstp(msl)', '甲磺酸倍他司汀片(敏使朗)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1.00g*1袋/盒', 'ad us.int', 0.0000, '', 'ml', 'TID', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-03-02 16:51:23', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4134, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000533', 'lbmjyjn', '罗布麻降压胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4144, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000543', 'fflxpabddp（bjjy0h）(0h)', '复方利血平氨苯蝶啶片（北京降压0号）(0号)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4154, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000553', 'zzsxp', '再造生血片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4164, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000563', 'swzcbpdyy', '四味珍层冰硼滴眼液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4174, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000573', 'jssxmnddyy(afg)', '酒石酸溴莫尼定滴眼液(阿法根)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4184, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000583', 'lmsdyy(rs)', '氯霉素滴眼液(润舒)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4194, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000593', 'yysbp', '医用纱布片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/袋', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4204, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000603', 'gasp', '胱氨酸片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4214, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000613', 'slxhsbqpwq', '生理性海水鼻腔喷雾器', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4224, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000623', 'jsbjn', '金水宝胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4234, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000633', 'jksqw', '金匮肾气丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4244, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000001', 'dztwj', '电子体温计', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4254, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000011', 'ycxzsq', '一次性注射器', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '5ml', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-01-12 16:39:50', 1, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4264, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000021', '75%jj', '75%酒精', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '60ml', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4274, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000031', 'ycxhyb（wky)', '一次性换药包（外科用)', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4284, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000041', 'hg（bl）d', '火罐（玻璃）大', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '内径5.2', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4294, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000051', 'xtsz', '血糖试纸', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '50支/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 1, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4304, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000061', 'ycxzzysshlb', '一次性种植牙手术护理包', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4314, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000071', 'ykqxmjd(z）', '牙科器械灭菌袋(中）', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '10cm宽', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4324, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000081', 'kqyycxwj', '口腔用一次性围巾', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '500片/箱', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4334, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000091', 'flj', '分离剂', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4344, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000101', 'sbsdzxyj', '上臂式电子血压计', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '国际标准', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4354, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000002', 'wg', '蜈蚣', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4364, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000012', 'lhg', '罗汉果', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-08-20 15:00:14', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4374, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000022', 'jdc', '酒丹参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4384, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000032', 'dc', '党参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4394, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000042', 'pgy', '蒲公英', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4404, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000052', 'gg', '葛根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4414, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000062', 'cxf', '醋香附', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4424, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000072', 'fbx', '法半夏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4434, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000082', 'tzc', '太子参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4444, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000092', 'fcbs', '麸炒白术', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4454, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000102', 'ssg', '生石膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4464, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000112', 'mppy', '蜜枇杷叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4474, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000122', 'jyh', '金银花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4484, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000132', 'hx', '藿香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4494, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000142', 'cjq', '炒建曲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4504, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000152', 'ybjt', '盐巴戟天', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4514, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000162', 'fp（bfp）', '附片（白附片）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4524, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000172', 'zbm', '浙贝母', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4534, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000182', 'jxt', '鸡血藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4544, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000192', 'cnbz', '炒牛蒡子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4554, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000202', 'lg', '龙骨', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4564, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000212', 'ct', '蝉蜕', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4574, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000222', 'ccez', '炒苍耳子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4584, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000232', 'hp', '厚朴', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4594, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000242', 'bxp', '白鲜皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4604, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000252', 'fqp', '麸青皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4614, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000262', 'swt', '首乌藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4624, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000272', 'qj', '秦艽', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4634, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000282', 'cbbd', '炒白扁豆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4644, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000292', 'jzz', '焦栀子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4654, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000302', 'rcr', '肉苁蓉', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4664, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000312', 'scz', '蛇床子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4674, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000322', 'bl', '槟榔', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4684, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000332', 'dh', '大黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4694, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000342', 'jh', '姜黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4704, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000352', 'hqp', '黄芩片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4714, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000362', 'yjh', '野菊花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4724, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000372', 'dgp', '地骨皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4734, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000382', 'bmg', '白茅根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4744, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000392', 'zl', '泽兰', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4754, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000402', 'hjt', '红景天', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4764, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000412', 'jdc', '酒丹参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4774, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000422', 'cjyzr', '炒金樱子肉', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4784, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000432', 'dqy', '大青叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4794, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000442', 'kc', '苦参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4804, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000452', 'md', '麦冬', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4814, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000462', 'sz', '桑椹', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4824, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000472', 'jbx', '姜半夏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4834, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000482', 'qh', '青蒿', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4844, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000492', 'blg', '板蓝根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4854, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000502', 'dz', '杜仲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4864, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000512', 'gth', '葛藤花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4874, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000522', 'sdh', '熟地黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4884, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000532', 'cay', '醋艾叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4894, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000542', 'blg', '板蓝根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4904, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000552', 'wlx', '威灵仙', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4914, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000562', 'gj', '干姜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4924, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000572', 'jfc', '金沸草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4934, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000582', 'yzx', '盐泽泻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4944, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000592', 'jj', '荆芥', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4954, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000602', 'hb', '黄柏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4964, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000612', 'mhg', '麻黄根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4974, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000622', 'ycqz', '盐车前子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4984, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000632', 'cbbd', '炒白扁豆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (4994, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000642', 'hmwjp', '红毛五加皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5004, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000652', 'hsw', '何首乌', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5014, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000662', 'csl', '穿山龙', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5024, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000672', 'cmy', '醋没药', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5034, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000682', 'jfc', '金沸草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5044, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000692', 'thf', '天花粉', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5054, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000702', 'zr', '竹茹', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5064, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000712', 'hjs', '海金沙', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5074, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000722', 'mbb', '蜜百部', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5084, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000732', 'zz', '栀子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5094, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000742', 'cmc', '川明参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5104, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000752', 'bf', '白矾', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5114, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000762', 'cg', '草果', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5124, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000772', 'ph', '蒲黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5134, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000782', 'jzr', '姜竹茹', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5144, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000792', 'dnx（tz）', '胆南星（听装）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5154, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000802', 'jmz', '决明子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5164, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000812', 'cxr', '川香薷', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5174, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000822', 'lx', '莲须', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5184, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000832', 'kb', '昆布', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5194, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000842', 'tbc', '土鳖虫', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5204, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000852', 'gj', '蛤蚧', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5214, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000862', 'mybc', '毛岩白菜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5224, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000872', 'lxc', '鹿衔草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5234, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000882', 'ay', '艾叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5244, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000892', 'hjh(g)', '化橘红(光)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5254, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000902', 'flp', '茯苓皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5264, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000912', 'dlg', '煅龙骨', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5274, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000922', 'sjs', '桑寄生', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5284, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000932', 'cbt', '侧柏炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5294, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000942', 'fs', '浮石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5304, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000952', 'cccmt', '粗齿川木通', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5314, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000962', 'jdl', '锦灯笼', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5324, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000972', 'mmh', '蜜麻黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5334, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000982', 'xtc', '小通草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5344, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000992', 'ldc', '龙胆草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5354, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001002', 'tgj', '烫狗脊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5364, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001012', 'dhss', '煅寒水石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5374, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001022', 'dzsy', '煅紫石英', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5384, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001032', 'ddhj', '大豆黄卷', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5394, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001042', 'qnj', '千年健', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5404, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001052', 'btl', '白土苓', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5414, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001062', 'hx', '藿香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5424, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001072', 'sy', '锁阳', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5434, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001082', 'szr', '山枝仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5444, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001092', 'mbc', '马鞭草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5454, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001102', 'zj', '枳椇', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5464, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001112', 'qj', '秦艽', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5474, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001122', 'kxr', '苦杏仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5484, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001132', 'wy', '乌药', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5494, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001142', 'wlx', '威灵仙', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5504, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001152', 'ljs', '鹿角霜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5514, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001162', 'jqm', '金荞麦', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5524, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001172', 'cxf', '醋香附', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5534, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001182', 'cs', '赤芍', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5544, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001192', 'yc', '茵陈', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5554, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001202', 'es', '莪术', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5564, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001212', 'zyz', '制远志', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5574, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001222', 'flh', '法落海', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5584, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001232', 'pj', '炮姜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5594, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001242', 'jsz', '酒水蛭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5604, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001252', 'fczs', '麸炒枳实', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5614, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001262', 'sq', '三七', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5624, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001272', 'hz', '虎杖', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5634, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001282', 'jmz', '决明子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5644, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001292', 'cjmz', '炒决明子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5654, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001302', 'dzs', '煅赭石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5664, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001312', 'xj', '小蓟', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5674, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001322', 'cbt', '侧柏炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5684, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001332', 'bjc', '败酱草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5694, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001342', 'fsm', '茯神木', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5704, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001352', 'ljn', '刘寄奴', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5714, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001362', 'mgc', '蜜甘草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5724, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001372', 'zhsw', '制何首乌', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5734, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001382', 'zdf', '钻地风', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5744, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001392', 'bl', '白蔹', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5754, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001402', 'jhq', '酒黄芩', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5764, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001412', 'tsz', '烫水蛭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5774, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001422', 'jxd', '酒续断', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5784, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001432', 'jxm', '酒仙茅', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5794, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001442', 'dc', '丹参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5804, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001452', 'gj', '蛤蚧', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5814, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001462', 'jzr', '姜竹茹', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5824, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001472', 'sh(z)', '石斛(中)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5834, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001482', 'lg', '芦根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5844, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001492', 'jh', '姜黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5854, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001502', 'lst', '络石藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5864, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001512', 'jymc', '酒益母草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5874, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001522', 'gqz', '枸杞子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5884, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001532', 'qct', '茜草炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5894, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001542', 'zm', '知母', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5904, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001552', 'djc', '地锦草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5914, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001562', 'sqh', '三七花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5924, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001572', 'xqg', '西青果', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5934, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001582', 'hft', '海风藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5944, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001592', 'jg', '桔梗', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5954, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001602', 'btl', '白土苓', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5964, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001612', 'bf', '白矾', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5974, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001622', 'sm', '升麻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5984, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001632', 'hq', '黄芪', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (5994, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001642', 'cjyz', '炒金樱子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6004, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001652', 'gzt', '贯众炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6014, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001662', 'chm', '炒槐米', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6024, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001672', 'lg', '芦根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6034, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001682', 'bl', '槟榔', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6044, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001692', 'tkz', '天葵子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6054, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001702', 'pfp', '炮附片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6064, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001712', 'yz', '玉竹', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6074, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001722', 'dg', '当归', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6084, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001732', 'chj', '炒槐角', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6094, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001742', 'lzc', '荔枝草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6104, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001752', 'mhr', '麻黄绒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6114, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001762', 'dcs', '煅磁石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6124, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001772', 'jbx', '京半夏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6134, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001782', 'hl(w)', '黄连(味)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6144, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001792', 'qlg', '千里光', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6154, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001802', 'jh（gj）', '菊花（贡菊）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6164, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001812', 'wmt', '乌梅炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6174, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001822', 'kdc', '苦丁茶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6184, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001832', 'zyz', '制远志', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6194, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001842', 'hjz', '黄荆子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6204, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001852', 'szr', '酸枣仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6214, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001862', 'spc', '三匹草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6224, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001872', 'jgc', '鸡骨草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6234, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001882', 'jgt', '金刚藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6244, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001892', 'fpz', '覆盆子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6254, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001902', 'yjh', '盐橘核', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6264, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001912', 'zyz', '制远志', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6274, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001922', 'jxd', '酒续断', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6284, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001932', 'ylzh', '盐荔枝核', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6294, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001942', 'gk', '蛤壳', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6304, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001952', 'dyqs', '煅阴起石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6314, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001962', 'jyz', '金樱子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6324, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001972', 'kb', '昆布', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6334, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001982', 'cwwz', '醋五味子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6344, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001992', 'dk', '豆蔻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6354, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002002', 'ayt', '艾叶炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6364, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002012', 'jcgr', '姜草果仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6374, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002022', 'dc', '丹参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6384, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002032', 'qct', '茜草炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6394, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002042', 'jxt', '鸡血藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6404, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002052', 'bx', '萆薢', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6414, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002062', 'bsc', '北沙参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6424, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002072', 'xyt', '血余炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6434, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002082', 'bzr', '柏子仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6444, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002092', 'ybgz', '盐补骨脂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6454, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002102', 'ckxr', '燀苦杏仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6464, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002112', 'rdt', '忍冬藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6474, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002122', 'mmdl', '蜜马兜铃', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6484, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002132', 'csl', '穿山龙', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6494, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002142', 'tnx', '天南星', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6504, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002152', 'lxc', '鹿衔草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6514, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002162', 'dc', '党参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6524, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002172', 'sdh', '熟地黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6534, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002182', 'tdm', '烫玳瑁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6544, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002192', 'sdh', '熟地黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_4` VALUES (6554, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002202', 'ff', '防风', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
COMMIT;


SET FOREIGN_KEY_CHECKS = 1;
