/*
 Navicat Premium Data Transfer

 Source Server         : local
 Source Server Type    : MySQL
 Source Server Version : 80027
 Source Host           : localhost:3306
 Source Schema         : drug_1

 Target Server Type    : MySQL
 Target Server Version : 80027
 File Encoding         : 65001

 Date: 07/05/2022 23:50:25
*/


DROP DATABASE IF EXISTS drug;
CREATE DATABASE IF NOT EXISTS drug;
USE drug;

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for drug_resource_5
-- ----------------------------
DROP TABLE IF EXISTS `drug_resource_5`;
CREATE TABLE `drug_resource_5` (
  `id` bigint unsigned NOT NULL DEFAULT '0' COMMENT '主键',
  `drug_res_type_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT ' 药品和物资类型ID(dw_drug_res_type.id)',
  `base_type` tinyint NOT NULL DEFAULT '0' COMMENT '物品类型：1-药品, 2-耗材, 3-办公用品',
  `status` int DEFAULT '1' COMMENT '药品状态: 0 - 停用, 1 - 使用',
  `type_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药品或者耗材类别的字典ID(dw_dictionary.id AND dw_dictionary.type_id=[yplb OR hclb])',
  `dict_dosage_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药品剂型的字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypjx)',
  `code` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '集团编码',
  `pym` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '拼音简码',
  `name` varchar(64) CHARACTER SET utf8 DEFAULT '' COMMENT '药品或者耗材的名称',
  `manufacturer_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '生产厂家的字典ID(dw_dictionary.id AND dw_dictionary.type_id=sccj)',
  `approval_no` varchar(100) CHARACTER SET utf8 DEFAULT NULL COMMENT '批准文号',
  `med_type` int DEFAULT '3' COMMENT '医保分类： 1 - 无自付, 2 - 部分自付, 3 - 全自付',
  `admin_code` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药监编码',
  `pack_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '包装单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypdw)',
  `min_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '最小单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypdw)',
  `pack_quantity` int DEFAULT '1' COMMENT '包装含量',
  `dosage_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '剂量单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=jldw)',
  `dosage_quantity` decimal(10,2) DEFAULT '0.00' COMMENT '剂量含量',
  `pack_spec` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '包装规格，生成规则：[剂量含量] [剂量单位] * [包装含量] [最小单位] / [包装单位]',
  `take_method_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '用法(默认用法)(dw_dictionary.id AND dw_dictionary.type_id=ypyf)',
  `take_quantity` decimal(36,4) DEFAULT '0.0000' COMMENT '用量(默认用量)',
  `take_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '用量单位字典ID - 暂留字典',
  `take_unit_name` varchar(36) CHARACTER SET utf8 DEFAULT 'ml' COMMENT '用量单位名称，默认ml',
  `take_frequency` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '频率(默认频率)(dw_dictionary.id AND dw_dictionary.type_id=yppl)',
  `common_unit_type` int DEFAULT '1' COMMENT '常规单位类型: 1 - 包装单位(packUnit), 2 - 最小单位(minUnit)',
  `purchase_price` decimal(8,4) DEFAULT '0.0000' COMMENT '进货价: 单位 元',
  `sale_price` decimal(8,4) DEFAULT '0.0000' COMMENT '基准价: 单位 元',
  `cost_category_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '费用类别字典ID(dw_dictionary.id AND dw_dicitionary.type_id=fylb)',
  `invoice_item_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '发票项目字典ID - 暂留',
  `expensive_flag` int DEFAULT '1' COMMENT '贵重物品标识： 0 - 非贵重物品， 1 - 贵重物品',
  `psy_flag_i` int DEFAULT '0' COMMENT ' 精神I类药品标识：0 - 非选中， 1 - 选中',
  `psy_flag_ii` int DEFAULT '0' COMMENT '精神II类药品标识：0 - 非选中，1 - 选中',
  `otc_flag` int DEFAULT '0' COMMENT 'OTC标识：0 - 非选中， 1 - 选中',
  `nar_flag` int DEFAULT '0' COMMENT '麻醉药品标识：0 - 非选中， 1 - 选中',
  `inventory_upper` int DEFAULT '0' COMMENT '库存上限',
  `inventory_lower` int DEFAULT '0' COMMENT '库存下限',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  `modify_time` datetime DEFAULT NULL COMMENT '修改时间',
  `del_flag` int DEFAULT '0' COMMENT '删除标志:  0 - 未删除, 1 - 已删除',
  `consumable_type` int NOT NULL DEFAULT '0' COMMENT '耗材类型:1-国产,2-进口',
  `tips` varchar(1024) CHARACTER SET utf8 DEFAULT NULL COMMENT '药品使用注意事项',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

-- ----------------------------
-- Records of drug_resource_5
-- ----------------------------
BEGIN;
INSERT INTO `drug_resource_5` VALUES (5, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000510', 'dtydszsy（nhp）（bx）', '地特胰岛素注射液（诺和平）（笔芯）', 'sccj_nhnd（zg）zyyxgs', 'J20140106', 3, '', 'bzdw_z', 'zxdw_U', 300, 'jldw_ml', 3.00, '3.00ml*300U/支', '', 0.0000, '', '', '', 1, 182.0000, 254.8000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 0, NULL, '2018-04-10 13:29:50', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (15, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000666', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'SR-11(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 1, 0, NULL, '2018-05-14 09:27:44', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (25, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000044', 'ycxhyw', '一次性换药碗', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (35, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000206', 'blfhsjn（fbd）', '布洛芬缓释胶囊（芬必得）', 'sccj_zmtjskzyyxgs', '国药准字H20013062', 3, '', 'bzdw_h', 'zxdw_l', 24, 'jldw_g', 0.40, '0.40g*24粒/盒', 'kf', 0.4000, '', '', 'mr2c', 1, 18.2400, 29.8000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 3, NULL, '2018-05-24 11:12:11', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (45, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001347', 'sqz', '舌钳子', 'sccj_zjgsy', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '16.5cm,不锈钢', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (55, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000207', '3Mpfskjd', '3M皮肤伤口胶带', 'sccj_3Mzg', '', 3, '', 'jjdw_b', '', 1, '', 0.00, 'R1547', '', 0.0000, '', 'ml', '', 1, 16.5000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (65, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001172', 'byxjcsj（jtjf）-ppg', '便隐血检测试剂（胶体金法）-噗噗管', 'sccj_hznhjkkjyxgs', '浙械准注20182400230', 3, '', 'jjdw_h', '', 1, '', 0.00, '1人份/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (75, 'bgyplb_sbwxpjlcl', 3, 1, 'bgyplb_sbwxpjlcl', '', 'ZKM00001471', 'dndyx', '电脑电源线', 'sccj_amzyc', NULL, 3, '', 'bzdw_g_468', 'zxdw_g_5284', 1, '', 0.00, '1根/根', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (85, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001393', 'dh', '电话', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 55.9000, 55.9000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (95, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001413', 'gcsctg', '观察室床头柜', 'sccj_blm		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, 'CF-570', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (105, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001749', 'tbfxzp', '头孢呋辛酯片', 'sccj_zhlbzygfyxgszsfgs', 'H20010096', 3, '', 'bzdw_h', 'zxdw_p', 12, 'jldw_g', 0.25, '0.25g*12片/盒', 'kf', 0.2500, '', '', 'mr2c', 1, 0.0000, 19.7000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (115, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000517', 'cxTxdj', '抽血T型垫巾', 'sccj_cf', '', 3, '', 'jjdw_p_10962', '', 1, '', 0.00, '50片/包', '', 0.0000, '', 'ml', '', 1, 0.2400, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (125, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000960', 'bq', '白前', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.3920, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (135, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00001622', 'ddwhy', '跌打万花油', 'sccj_gzbyshjhpzyyxgs', 'J06031', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 25.00, '25.00ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 0.0000, 7.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (145, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001810', 'cspnsp', '醋酸泼尼松片', 'sccj_zjxjzygfyxgs', 'H33021207', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 5.00, '5.00mg*100片/瓶', '', 0.0000, '', '', '', 2, 0.0000, 0.0400, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-06-14 16:59:25', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (155, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001058', 'yyssj', '眼用手术剪', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '弯尖头10cm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (165, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_hsp', 'ZKM00000401', 'lstjp', '氯沙坦钾片', 'sccj_ctzyzshsndgc（rb）', '', 3, '', 'bzdw_h', 'zxdw_kg_g', 14, 'jldw_g', 10.00, '10g/盒', 'ad us.int', 100.0000, '', '', 'qd', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 0, 0, 0, 2, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (175, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000381', 'blfhsjn', '布洛芬缓释胶囊', 'sccj_w', '', 3, '', 'bzdw_h', 'zxdw_l', 24, 'jldw_g', 0.40, '0.40g*24粒/盒', 'ad us.int', 0.4000, '', '', 'Qid', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 3, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (185, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000888', 'gb', '藳本', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.5600, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 11:02:48', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (195, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001623', 'nkpgs', '内口抛光刷', 'sccj_dgslgylqxyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (205, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dyj', 'ZKM00000404', 'qtgdyy（xlr）', '羟糖苷滴眼液（新泪然）', 'sccj_Alcon Laboratories, Inc（mg）', 'H20140264', 3, '', 'bzdw_z', 'zxdw_ml', 5, 'jldw_ml', 1.00, '1.00ml*5ml/支', 'O.U．', 0.1000, '', '', 'Prn', 1, 27.0000, 37.8000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, NULL, '2018-04-19 11:52:53', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (215, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000667', 'bjm', '白及面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 2.7000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (225, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001204', '1mlzsq	', '1ml注射器	', 'sccj_jxhd		', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '100支/包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (235, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001177', 'xb', '薤白', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.1680, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (245, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dyj', 'ZKM00000402', 'zyfsxdyy', '左氧氟沙星滴眼液', 'sccj_ctzy（zg）yxgs', 'J20150106', 3, '', 'bzdw_z', 'zxdw_ml', 5, 'jldw_mg', 24.40, '24.40mg*5ml/支', 'pa', 0.1000, '', '', 'Q6h', 1, 29.2000, 29.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 1, NULL, '2018-07-05 15:57:23', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (255, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001660', 'ffgcp', '复方甘草片', 'sccj_ydyyyxgs', 'H42021787', 3, '', 'bzdw_p', 'zxdw_b_7638', 3, 'jldw_p', 10.00, '10.00片*3板/瓶', 'kf', 4.0000, '', '', 'mr3c', 1, 0.0000, 6.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 10:57:25', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (265, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000973', 'zsz', '制水蛭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 4.2560, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (275, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00000455', 'xwdby（FIB）cdsj（dgx）（ngf）', '纤维蛋白原（FIB）测定试剂（冻干型）（凝固法）', 'sccj_shtyswjsyxgs', '', 3, '', 'jjdw_f_9562', '', 1, '', 0.00, '5*2.5', '', 0.0000, '', 'ml', '', 1, 42.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-10 21:36:11', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (285, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001071', 'ycxsyslyt', '一次性使用塑料牙托', 'sccj_w', '-', 3, '', 'jjdw_f', '', 1, '', 0.00, '411/412大号', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-29 16:45:39', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (295, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001038', '5hdc', '5号电池', 'sccj_amzyc', '', 3, '', 'bzdw_h', 'zxdw_l', 10, '', 0.00, '10粒/盒', '', 0.0000, '', 'ml', '', 2, 1.3900, 1.3900, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (305, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00001313', 'tbmsdyy', '妥布霉素滴眼液', 'sccj_blsSA AIcon Couvreur NV', '', 3, '', 'bzdw_h', 'zxdw_ml', 5, 'jldw_mg', 20.00, '20.00mg*5ml/盒', '', 0.0000, '', '', '', 1, 30.2500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (315, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000554', 'jp', '姜皮', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0650, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (325, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000045', 'xty', '血糖仪', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '欧姆龙', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (335, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001083', 'ggc', '根管锉', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, 'MANIH-FILES10#-25mm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (345, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000838', 'crxm', '醋乳香面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.2000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (355, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001769', 'ksfmfdgny', '康师傅妙芙蛋糕奶油', 'sccj_amzyc', NULL, 3, '', 'bzdw_h', 'zxdw_h', 1, '', 0.00, '1盒/盒', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-01 11:26:23', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (365, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000656', 'SSWgscz', 'SSW高速车针', 'sccj_SSW.WHITE BURS.IN', '--', 3, '', 'jjdw_z', '', 1, '', 0.00, 'FG-34', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (375, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000748', 'ldt', '龙胆炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 0.0000, '', '', '', 1, 0.3000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (385, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001017', 'jgscz', '金刚砂车针', 'sccj_w', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'TF-SS31', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (395, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001186', 'slxg', '塑料吸管', 'sccj_xk', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '2ml', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (405, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000548', 'zmd', '朱麦冬', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.1560, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (415, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001221', 'sgbd', '石膏绷带', 'sccj_shxh', '-', 3, '', 'jjdw_j', '', 1, '', 0.00, '（11cm）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (425, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001632', 'zjz 0.3*13mm', '针灸针 0.3*13mm', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (435, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_hj', 'ZKM00000217', 'sjkbdhj（OTC）', '四季抗病毒合剂（OTC）', 'sccj_sxhtzyyxgs', '国药准字Z20027669', 3, '', 'bzdw_h', 'zxdw_p_1', 1, 'jldw_ml', 120.00, '120.00ml*1瓶/盒', '', 0.0000, '', '', '', 1, 30.5000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-29 15:03:44', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (445, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000963', 'dwlz', '煅瓦楞子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0290, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (455, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001684', 'ykwgcz', '牙科钨钢车针', 'sccj_gzbysghzygfyxgs', '151001', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (465, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000872', 'ytz（ghsz）', '牙探针（光滑髓针）', 'sccj_mnzshs', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, '000#12*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 12:46:54', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (475, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000367', 'amxljn', '阿莫西林胶囊', 'sccj_w', '', 3, '', 'bzdw_h', 'zxdw_l', 24, 'jldw_g', 0.50, '0.50g*24粒/盒', 'ad us.int', 1.0000, '', '', 'Q8h', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 3, NULL, '2018-01-12 10:10:52', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (485, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_sj_2', 'ZKM00001610', 'kfbyys（I）', '口服补液盐散（I）', 'sccj_fzhwfyzyyxgs', '1605305', 3, '', 'bzdw_h', 'zxdw_d', 20, 'jldw_g', 14.75, '14.75g*20袋/盒', '', 0.0000, '', '', '', 1, 0.0000, 18.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (495, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000967', 'ytsl', '液体石蜡', 'sccj_sdajgkxdkjyxgs', 'SH/T 0417-92', 3, '', 'jjdw_p', '', 1, '', 0.00, '450ml', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (505, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001180', 'cgshfhxzp', '常规生化复合校准品', 'sccj_szmr', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '10x30ml10500112200', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (515, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000668', 'zbm', '浙贝母', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.5600, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (525, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000996', 'fhsz', '复合树脂', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '34364针管装A2', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (535, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001378', 'xycjxf', '西洋参极细粉', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 3, 'jldw_g', 3.00, '3g/袋', '', 3.0000, '', '', '', 1, 13.5000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (545, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000841', 'ysj', '油松节', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0270, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (555, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_jnj', 'ZKM00000167', 'ttnjn', '头痛宁胶囊', 'sccj_sxbczyyxgs', 'Z20026851', 3, '', 'bzdw_h', 'zxdw_l', 36, 'jldw_g', 0.40, '0.40g*36粒/盒', '', 0.0000, '', '', '', 1, 27.3900, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:03:12', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (565, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000275', 'ycxjyx（PE）st', '一次性聚乙烯（PE）手套', 'sccj_hmsyzylqxyxgs', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '中号100只/包', '', 0.0000, '', 'ml', '', 1, 3.5000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-15 10:44:19', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (575, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000994', 'dxfhz（yysx）', '带线缝合针（医用丝线）', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '4-0针，0.4', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (585, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000035', 'tzmq', '脱脂棉球', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_d', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (595, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000407', 'ycxsygsm', '一次性使用肝素帽', 'sccj_whjryyzpyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '50支/盒', '', 0.0000, '', 'ml', '', 1, 0.8000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 15:40:16', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (605, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_zsj', 'ZKM00000479', 'lsmzsy', '硫酸镁注射液', 'sccj_dd', '', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 10.00, '10.00ml*1支/支', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-06 17:44:58', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (615, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000172', 'jssmtlep（btlk）', '酒石酸美托洛尔片（倍他乐克）', 'sccj_aslkzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_mg', 50.00, '50mg*20片/盒', '', 0.0000, '', '', '', 1, 11.6400, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 10:59:41', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (625, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000894', 'zc', '紫草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 1.0080, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (635, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000537', 'zdbcdsjh（ssnf）', '总蛋白测定试剂盒（双缩脲法）', 'sccj_glyltyldzyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '45ml*6', '', 0.0000, '', 'ml', '', 1, 78.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-27 11:24:14', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (645, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001447', 'lsatpzsy', '硫酸阿托品注射液', 'sccj_hnrhzygfyxgs', '国药准41020324', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 1.00, '1.00ml*1支/支', '', 0.0000, '', '', '', 1, 6.2000, 8.6800, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (655, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000411', 'ycxsyjmsyz', '一次性使用静脉输液针', 'sccj_jxhdylqxjtyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '0.7#', '', 0.0000, '', 'ml', '', 1, 0.2000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (665, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001484', 'allsnp（fsm）', '阿仑磷酸钠片（福善美）', 'sccj_hzmsdzyyxgs', '国药准字J20130085', 3, '', 'bzdw_h', 'zxdw_p', 1, 'jldw_mg', 70.00, '70.00mg*1片/盒', '', 0.0000, '', '', '', 1, 60.8600, 60.8600, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (675, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001149', 'mhg', '麻黄根', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0670, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (685, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000318', 'ycxsyqgcg', '一次性使用气管插管', 'sccj_hzjlylqxyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, 'QC-01带囊7.5mm10支/盒', '', 0.0000, '', 'ml', '', 1, 13.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 15:40:19', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (695, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000317', 'ssj', '手术剪', 'sccj_shylqx（jt）yxgsssqxc', '', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'JC211516CM', '', 0.0000, '', 'ml', '', 1, 57.9200, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-24 10:25:59', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (705, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001108', 'ycsywjzsqdz', '一次使用无菌注射器带针', 'sccj_cdsxjsfylqxyxgs', '国械注准20163150107', 3, '', 'jjdw_z', '', 1, '', 0.00, '5ml0.6*25TW.LB', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (715, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_pj', 'ZKM00000370', 'zyfsxp（klbt）', '左氧氟沙星片（可乐必妥）', 'sccj_dysgzy（bj）yxgs', 'H20000655', 3, '', 'bzdw_h', 'zxdw_p', 10, 'jldw_g', 0.10, '0.10g*10片/盒', 'ad us.int', 0.5000, '', '', 'bid', 1, 31.6300, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 3, NULL, '2018-03-02 17:43:36', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (725, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001128', 'ycxsywjzsz 1.2*32mm', '一次性使用无菌注射针 1.2*32mm', 'sccj_jxhdylqxjtyxgs', '国械注准20143152282 ', 3, '', 'jjdw_z', '', 1, '', 0.00, '支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-19 09:37:06', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (735, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000818', 'dtSuperlinezzt', '登腾Superline种植体', 'sccj_EA', '--', 3, '', 'jjdw_h', '', 1, '', 0.00, 'FX5012SW', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (745, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000450', 'gyysxdyBy', '过氧乙酸消毒液B液', 'sccj_sdajgkxdkjyxgs', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '250ml', '', 0.0000, '', 'ml', '', 1, 6.5000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (755, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000134', 'dbcxpjtz', '豆瓣成型片夹套装', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (765, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_kfy', 'ZKM00000497', 'hxzqkfy', '藿香正气口服液', 'sccj_tjjt', '国药准字Z50020409', 3, '', 'bzdw_h', 'zxdw_z', 6, 'jldw_ml', 10.00, '10.00ml*6支/盒', '', 0.0000, '', '', '', 1, 11.2200, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:24:25', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (775, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000310', 'jxzp', '甲硝唑片', 'sccj_sxfhzyyxgs', '国药准字h14021002', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_g', 0.20, '0.20g*20片/盒', '', 0.0000, '', '', '', 1, 2.5000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:25:33', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (785, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000394', 'kmxpp', '卡马西平片', 'sccj_bjnhzyyxgs', 'H11022279', 3, '', 'bzdw_h', 'zxdw_p', 30, 'jldw_g', 0.20, '0.20g*30片/盒', 'ad us.int', 0.1000, '', '', 'bid', 1, 25.6600, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, NULL, '2018-03-09 11:43:38', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (795, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_rg', 'ZKM00000021', 'zy1', '中药1', 'sccj_hrsj', '111', 3, '', 'bzdw_b', 'zxdw_kg_g', 10, 'jldw_g', 12.00, '12.00g*10g/包', '', 0.0000, '', '', '', 1, 0.0000, 10.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (805, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001056', 'ptzxq', '普通止血钳', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '弯型14cm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-29 16:38:59', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (815, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_w', 'ZKM00000113', 'gpw', '归脾丸', 'sccj_zjwxzygfyxgs', '国药准字Z41020007', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_w', 200.00, '200.00丸*1瓶/瓶', '', 0.0000, '', '', '', 1, 11.1000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:26:31', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (825, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001001', 'jgscz', '金刚砂车针', 'sccj_w', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'BR-31', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (835, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_hsp', 'ZKM00000029', 'ze1', '周二1', 'sccj_hrsj', '12', 3, '', 'bzdw_b', 'zxdw_d', 12, 'jldw_g', 100.00, '100.00g*12袋/包', '', 0.0000, '', '', '', 1, 0.0000, 12.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (845, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_kfy', 'ZKM00001598', 'lqkfy', '蓝芩口服液', 'sccj_yzjyyjtjszygfyxgs', '17092032', 3, '', 'bzdw_h', 'zxdw_z', 12, 'jldw_ml', 10.00, '10.00ml*12支/盒', '', 0.0000, '', '', '', 1, 39.6000, 39.6000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (855, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_gcj', 'ZKM00000427', 'ksl', '开塞露', 'sccj_shyjhpzyyxgs', 'H31021363', 3, '', 'bzdw_z', 'zxdw_ml', 20, 'jldw_ml', 20.00, '20.00ml*20ml/支', 'ad us.ext', 20.0000, '', '', 'Qod', 1, 1.3000, 1.5600, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 100, 10, NULL, '2018-04-19 13:53:05', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (865, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000952', 'yggsj（6%dzdyjj）', '牙根管塞尖（6%大锥度牙胶尖）', 'sccj_dsbyk（tj）yxgs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '06锥度25#红120*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (875, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000944', 'ckyggtccl（btpks）', '齿科用根管填充材料（比塔派克斯）', 'sccj_w', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '2g/只，VITAPEX', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (885, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000908', 'ss', '桑葚', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2240, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (895, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000798', '5ml zsq(TX)', '5ml 注射器(TX)', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '5ml*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-14 16:36:25', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (905, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsp', 'ZKM00000052', '123123', '123123', 'sccj_hzkebzy', '1231231233', 3, '', 'bzdw_g_cldw', 'zxdw_wu_cldw', 1, 'jldw_g', 1.00, '1.00g/g', '', 0.0000, '', '', '', 1, 0.0000, 12.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-10-11 19:50:18', 1, 0, 'ewrwerwer');
INSERT INTO `drug_resource_5` VALUES (915, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001702', 'lhmsfsp', '罗红霉素分散片', 'sccj_sygczygs', 'H20000206', 3, '', 'bzdw_h', 'zxdw_p', 8, 'jldw_g', 0.15, '0.15g*8片/盒', 'kfkf', 0.1500, '', '', 'mr2c', 1, 0.0000, 3.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 10:05:59', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (925, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000684', 'll', '雷龙', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.4320, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (935, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000260', 'pttzsy(10%)', '葡萄糖注射液(10%)', 'sccj_scklyygfyxgs', '', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 500.00, '500ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 1.3000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 15:02:58', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (945, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001458', 'zdb（TP）cdsjh	', '总蛋白（TP）测定试剂盒	', 'sccj_szmr', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (955, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001473', 'smwjg', '双门文件柜', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (965, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000884', 'ssg', '生石膏', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0220, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (975, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001153', 'dyt', '地榆炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0950, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (985, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001210', 'ycxjmcxz', '一次性静脉采血针', 'sccj_jxhd		', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '100支/包（0.55）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (995, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001464', 'jg（CREA）cdsjh	', '肌酐（CREA）测定试剂盒	', 'sccj_szmr', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1005, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001392', 'fzwxyj', '防紫外线眼镜', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 39.0000, 39.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1015, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tptj', 'ZKM00000432', 'ydmxt', '吲哚美辛贴', 'sccj_KowaCompanyLtd', '', 3, '', 'bzdw_h', 'zxdw_h', 1, 'jldw_p', 7.00, '7.00片*1盒/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 1, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1025, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00001427', 'fmQ10jn', '辅酶Q10胶囊', 'sccj_shsyxyycyxgs(yshxyycyxgs)', 'H19999132', 3, '', 'bzdw_p', 'zxdw_l', 60, 'jldw_mg', 10.00, '10.00mg*60粒/瓶', '', 0.0000, '', '', '', 1, 6.7000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1035, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000854', 'pyx（dqgd，clc）', '排龈线（带切割刀，测量尺）', 'sccj_w', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '#0不含药2.44米长', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-28 15:50:35', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1045, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000293', 'zzn', '组织镊', 'sccj_shylqx（jt）yxgsssqxc', '', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'J4108016CM1x2钩', '', 0.0000, '', 'ml', '', 1, 20.3200, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-15 11:03:43', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1055, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001556', 'gfzbd 5c', '高分子绷带 5寸', 'sccj_ssdt', '-', 3, '', 'jjdw_j', '', 1, '', 0.00, '卷', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1065, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rgj', 'ZKM00000296', 'ffcsdsmsrg', '复方醋酸地塞米松乳膏', 'sccj_hrsj', 'H44024170', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 20.00, '20.00g*1支/支', '', 0.0000, '', '', '', 1, 1.9600, 8.5600, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-06-14 17:12:25', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1075, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001343', 'bzr', '柏子仁', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.4480, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1085, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001308', 'fcdgz', '麸炒冬瓜子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.1340, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1095, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qwj', 'ZKM00000490', 'xsgyqwj', '硝酸甘油气雾剂', 'sccj_sdjwzyyxgs', 'H37021173', 3, '', 'bzdw_p', 'zxdw_p_2495', 200, 'jldw_mg', 0.50, '0.50mg*200喷/瓶', 'Ut dict', 0.5000, '', '', 'St', 1, 40.0900, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 2, 1, NULL, '2018-03-09 15:37:56', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1105, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000568', 'rjzt', '乳胶枕套', 'sccj_mbl', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '50x30', '', 0.0000, '', 'ml', '', 1, 39.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1115, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000921', 'csl', '穿山龙', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0950, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1125, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000631', 'dzdyjj', '大锥度牙胶尖', 'sccj_dsbyk（tj）yxgs', '国械注准20163631121', 3, '', 'jjdw_h', '', 1, '', 0.00, '06（混）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-04-03 15:42:23', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1135, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001804', 'wssCptp（lds）', '维生素C泡腾片（力度伸）', 'sccj_beyybjyxgswtsdxhzygfyxgs', 'H20056946', 3, '', 'bzdw_p', 'zxdw_l', 10, 'jldw_g', 1.00, '1.00g*10粒/瓶', '', 0.0000, '', '', '', 1, 0.0000, 20.5800, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1145, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001119', 'kxsxwkfx（jydb）', '可吸收性外科缝线（胶原蛋白）', 'sccj_sdbdylypyxgs', '鲁食药监械生产许20120021号', 3, '', 'jjdw_b', '', 1, '', 0.00, '2-0', '', 0.0000, '', 'ml', '', 1, 0.0000, 4.5000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-31 12:26:10', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1155, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001631', 'bxgfsly19*25s', '不锈钢方丝卵圆19*25上', 'sccj_shamdclljgfyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-19 16:33:45', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1165, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000304', 'ycxzsqdz', '一次性注射器带针', 'sccj_shkdlqyfzjtgfyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '20ml', '', 0.0000, '', 'ml', '', 1, 0.5300, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1175, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000865', 'gzjyggqx（ggssz）', '钢质机用根管器械（根管输送针）', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm25#4*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1185, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000793', 'hjt', '红景天', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.3140, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1195, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000903', 'ld', '龙胆', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.5040, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1205, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001005', 'zhq', '炙黄芪', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 0.0000, '', '', '', 1, 0.3640, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1215, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000979', 'jhp', '姜厚朴', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.1010, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 15:52:22', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1225, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001592', 'gjdwy', '根尖定位仪', 'sccj_w', '-', 3, '', 'jjdw_t_148', '', 1, '', 0.00, '台', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1235, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000728', 'sckksst（21mm）', '双侧开口输送头（21mm）', 'sccj_Ultradert product Inc', '--', 3, '', 'jjdw_z', '', 1, '', 0.00, '5122(黄色)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1245, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000092', 'txKc 25mm', '弹性K锉 25mm', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1255, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001129', 'hl', '黄连', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.6720, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1265, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001133', 'cbbdr', '炒白扁豆仁', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0900, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1275, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000998', 'ycxsyfhyj', '一次性使用防护眼镜', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, 'G006', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1285, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000956', 'hpx', '海螵蛸', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.1340, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1295, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001206', '5mlzsq	', '5ml注射器	', 'sccj_jxhd		', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '100支/包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1305, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000831', 'mjxjwkst1144C', '灭菌橡胶外科手套1144C', 'sccj_mdkylypmy（sh）yxgs', '国食药监械(进)字2013第2665558', 3, '', 'jjdw_s', '', 1, '', 0.00, '无粉6.5号1144C', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1315, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00001166', 'lqh', '利器盒', 'sccj_cdlekkjyxgs', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '8L', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1325, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001388', 'syh', '输液盒', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '350mm*125mm*85mm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1335, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000936', 'sgf', '生蛤粉', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0100, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1345, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000920', 'ggzlywxmd（rsmzSP）', '根管治疗用微型马达（瑞士迈装SP）', 'sccj_w', '-', 3, '', 'jjdw_t_148', '', 1, '', 0.00, 'X-SMARTSP', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1355, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000836', 'lh', '芦荟', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0810, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1365, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000834', 'hj（q）', '花椒（青）', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.2180, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1375, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000970', 'cwz', '茺蔚子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1900, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1385, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000603', 'jszr', '焦酸枣仁', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.5450, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1395, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000089', 'ysbhlmp', '盐酸苯海拉明片', 'sccj_lfbzzyyxgs', '国药准字H14021492', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 25.00, '25.00mg*100片/瓶', '', 0.0000, '', '', '', 1, 9.9000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:09:26', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1405, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000378', 'fmmmp（tn）', '酚麻美敏片（泰诺）', 'sccj_shqszyyxgs', 'H20010115', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_p', 1.00, '1.00片*20片/盒', 'kf', 1.0000, '', '', 'm6xsyc', 1, 20.1200, 28.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 10, 1, NULL, '2018-05-24 11:19:25', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1415, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000782', 'cx', '川芎', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1680, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1425, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001267', 'sddtdktwlyyq	', '手动单通道可调微量移液器	', 'sccj_dlxcsyyq（bj）yxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '0.5-10μl', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1435, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001012', 'A4z', 'A4纸', 'sccj_amzyc', '', 3, '', 'bzdw_b', 'zxdw_b', 1, '', 0.00, '500张/克', '', 0.0000, '', 'ml', '', 2, 20.0000, 20.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-28 10:09:02', 1, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1445, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001156', 'jh', '姜黄', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0950, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1455, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000718', 'jykkz', '机用扩孔钻', 'sccj_MANI', '--', 3, '', 'jjdw_h', '', 1, '', 0.00, 'P28mm-2', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1465, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001035', 'dzxyt', '丁字形牙挺', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1475, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000454', '0.9%lhnzsy', '0.9%氯化钠注射液', 'sccj_bjymyyyxgs', '', 3, '', 'bzdw_z', 'zxdw_ml', 10, 'jldw_g', 1.00, '1.00g*10ml/支', '', 0.0000, '', '', '', 1, 2.1000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 20, 8, NULL, '2018-02-07 11:21:12', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1485, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001138', 'demyPIMdgwdzsgjmg', '第二磨牙PIM单管网底直丝弓夹面管', 'sccj_hzxyckclyxgs', '浙食药监械（准）字2014第2630177号', 3, '', 'jjdw_d', '', 1, '', 0.00, '62BS-20J-27(20*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-04 16:54:44', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1495, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000869', 'yjh', '月季花', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.2180, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 10:56:01', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1505, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000716', 'jykkz', '机用扩孔钻', 'sccj_MANI', '国械注进20152551636', 3, '', 'jjdw_h', '', 1, '', 0.00, 'G28mm-4', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 09:30:31', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1515, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000777', 'ycxsymsxycjrq', '一次性使用末梢血样采集容器', 'sccj_bdylqx（sh）yxgs', '7352909', 3, '', 'jjdw_z', '', 1, '', 0.00, '50支/包', '', 0.0000, '', 'ml', '', 1, 2.8000, 2.8000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1525, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rg', 'ZKM00001588', 'ffblmsznrg', '复方倍氯米松樟脑乳膏', 'sccj_hbfryy', '20170351', 3, '', 'bzdw_z', 'zxdw_kg_g', 10, 'jldw_g', 1.00, '1.00g*10g/支', '', 0.0000, '', '', '', 1, 3.5000, 3.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 2, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1535, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000166', 'ysplptp', '盐酸普罗帕酮片', 'sccj_czzycyxgs', '国药准字h32023905', 3, '', 'bzdw_p', 'zxdw_p', 50, 'jldw_mg', 50.00, '50.00mg*50片/瓶', '', 0.0000, '', '', '', 1, 10.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:11:49', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1545, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001147', 'sjc', '石见穿', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0450, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1555, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00000462', 'byx（FOB）jcsj（jtjf）', '便隐血（FOB）检测试剂（胶体金法）', 'sccj_abswyy（hz）yxgs', '', 3, '', 'jjdw_f_9562', '', 1, '', 0.00, '25/人份', '', 0.0000, '', 'ml', '', 1, 2.8000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1565, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001281', 'ycxmq', '一次性棉签', 'sccj_sdkz		', '-', 3, '', 'jjdw_b', '', 1, '', 0.00, '12cm,6支/包,600支/中包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1575, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000429', 'pjq', '帕金钳', 'sccj_rbgdgyzshs_6795', '', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'JC350414cm普通', '', 0.0000, '', 'ml', '', 1, 77.1200, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1585, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000690', 'Z251XTcgqdgmsz', 'Z251XT超高强度光敏树脂', 'sccj_3MESPE DENTAL PRODUCT', '--', 3, '', 'jjdw_z', '', 1, '', 0.00, '1470(A2)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1595, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000354', 'nzt', '镊子桶', 'sccj_hnsjqylqxyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '中号80*198mm', '', 0.0000, '', 'ml', '', 1, 10.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1605, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000983', 'qft', '青风藤', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0290, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 16:41:54', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1615, 'yplb_xy', 1, 1, 'yplb_zcy', 'ypjx_pj', 'ZKM00000055', 'ffhlsp', '复方黄连素片', 'sccj_scjyszyyxgs', 'z51021954', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 30.00, '30.00mg*100片/瓶', '', 0.0000, '', '', '', 1, 7.0000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 16:02:39', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1625, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000878', 'yyc（C+c）', '牙用锉（C+锉）', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm8##6*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1635, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000788', 'df0.5%', '碘伏0.5%', 'sccj_hnkfylksfzyxgs', '20171111', 3, '', 'jjdw_p', '', 1, '', 0.00, '60ml*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 4.1000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1645, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000626', 'sdht', '熟地黄炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1655, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001701', 'tlbd（tlwm）20g/b', '弹力绷带（弹力网帽）20个/包', 'sccj_zzatlkswgcyxgs', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1665, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001046', 'qbz', '曲别针', 'sccj_amzyc', '', 3, '', 'bzdw_z_8915', 'zxdw_h', 10, '', 0.00, '10盒/组', '', 0.0000, '', 'ml', '', 2, 1.6000, 1.6000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1675, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000309', 'ycxsysyqdz', '一次性使用输液器带针', 'sccj_shkdlqyfzjtgfyxgs', '', 3, '', 'jjdw_t', '', 1, '', 0.00, '0.6#', '', 0.0000, '', 'ml', '', 1, 0.9400, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1685, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000143', 'dyxajfp', '对乙酰氨基酚片', 'sccj_gyjtstjszyyxgs', 'h44021051', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_g', 0.50, '0.50g*100片/瓶', '', 0.0000, '', '', '', 1, 3.2500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 16:04:21', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1695, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001087', 'MP C2503Cxmf（hs）', 'MP C2503C型墨粉（黑色）', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 580.0000, 580.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1705, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000871', 'ytz（ghsz）', '牙探针（光滑髓针）', 'sccj_mnzshs', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, '0#12*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1715, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001179', 'ycxsyjmxycjrq（fwj）', '一次性使用静脉血样采集容器（非无菌）', 'sccj_hbxlylqxkjgfyxgs', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, 'K2EDTA(紫）2ml*100支/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1725, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000164', 'ycxkqqxp', '一次性口腔器械盘', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1735, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000144', 'ygc', '牙刮匙', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1745, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000858', 'ojt', '藕节炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0560, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 10:53:40', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1755, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tptj', 'ZKM00000410', 'atfttgp', '阿托伐他汀钙片', 'sccj_hrzy', 'H20051408', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_mg', 20.00, '20.00mg*7片/盒', 'ad us.int', 20.0000, '', '', 'qd', 1, 62.6300, 87.6800, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 2, NULL, '2018-07-03 15:14:09', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1765, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001608', 'zjz 0.3*40mm', '针灸针 0.3*40mm', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1775, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000075', 'sz（3M）', '树脂（3M）', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_d', '', 1, '', 0.00, '固体，液体', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1785, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rgj', 'ZKM00001441', 'xsmkzrg（dkn）', '硝酸咪康唑乳膏（达克宁）', 'sccj_xayszyyxgs', '国药准字H61020001', 3, '', 'bzdw_z', 'zxdw_kg_g', 20, 'jldw_％', 2.00, '2.00％*20g/支', '', 0.0000, '', '', '', 1, 15.2600, 17.6000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-08 14:46:03', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1795, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001120', 'mcj', '马齿笕', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0560, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1805, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000321', 'wssB1 zsy', '维生素B1 注射液', 'sccj_hzyygfyxgs', '', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 2.00, '2.00ml*1支/支', '', 0.0000, '', '', '', 1, 0.3900, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1815, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001377', 'mjswzsj', '灭菌生物指示剂', 'sccj_sdxhyl		', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '山东新华（50支/盒）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1825, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001094', 'tzczq120°', '探针持针器120°', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, 'Mini-Piiezon/PiezonMaster700', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1835, 'bgyplb_sbwxpjlcl', 3, 1, 'bgyplb_sbwxpjlcl', '', 'ZKM00001463', 'qdccq', '气动吹尘枪', 'sccj_amzyc', NULL, 3, '', 'bzdw_b_9933', 'zxdw_b_1129', 1, '', 0.00, '1把/把', '', 0.0000, '', 'ml', '', 2, 43.2000, 43.2000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1845, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001594', 'zjztg 0.25*13mm', '针灸针套管 0.25*13mm', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1855, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000221', 'ycxsywjssb（hldj）', '一次性使用无菌手术包（华林洞巾）', 'sccj_xxshlylqxyxgs', '', 3, '', 'jjdw_k_7001', '', 1, '', 0.00, '50*60', '', 0.0000, '', 'ml', '', 1, 0.4500, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-15 11:15:42', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1865, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000565', 'fzwxyj', '防紫外线眼镜', 'sccj_3M', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '1个/包', '', 0.0000, '', 'ml', '', 1, 39.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1875, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000996', 'gj', '干姜', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1060, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1885, 'hclb_fskcl', 2, 1, 'hclb_fskcl', '', 'ZKW00000328', 'yycsohj', '医用超声耦合剂', 'sccj_tjsxyszzs', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '250ml', '', 0.0000, '', 'ml', '', 1, 1.3000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1895, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_cj', 'ZKM00000214', 'lltdp（yf））', '氯雷他定片（亿菲））', 'sccj_adyy(bj)yxgs', '', 3, '', 'bzdw_h', 'zxdw_p', 10, 'jldw_mg', 10.00, '10.00mg*10片/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1905, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001115', 'dzsy', '煅紫石英', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0380, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1915, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001829', 'A4rrft1mm', 'A4热熔封套1mm', 'sccj_amzyc', NULL, 3, '', 'bzdw_h', 'zxdw_h', 1, '', 0.00, '1盒/盒', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1925, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000282', 'ycxsymjxjwkst', '一次性使用灭菌橡胶外科手套', 'sccj_glrjc（glgb）', '', 3, '', 'jjdw_f', '', 1, '', 0.00, '7#无粉弯型麻面', '', 0.0000, '', 'ml', '', 1, 2.4500, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-15 10:54:18', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1935, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001446', 'Aqlzbdkyjcsjh', 'A群轮状病毒抗原检测试剂盒', 'sccj_zhsykyxgcgfyxgs		', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1945, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001079', 'ycxsywjykzsz', '一次性使用无菌牙科注射针', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '30G*25mm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1955, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000759', 'es', '鹅虱', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 0.0000, '', '', '', 1, 0.0400, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1965, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000549', 'jsjmcdsjh（lsjsdwf）', '肌酸激酶测定试剂盒（磷酸肌酸底物法）', 'sccj_glyltyldzyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '40ml*5；10ml*5', '', 0.0000, '', 'ml', '', 1, 730.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1975, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001063', 'yt', '印台', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 7.0000, 7.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1985, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001555', 'gfzbd 4c', '高分子绷带 4寸', 'sccj_ssdt', '-', 3, '', 'jjdw_j', '', 1, '', 0.00, '卷', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (1995, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001538', 'zyb', '遮眼版', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_g', '', 1, '', 0.00, '根', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2005, 'bgyplb_yslcl', 3, 1, 'bgyplb_yslcl', '', 'ZKM00001419', 'xz', '信纸', 'sccj_amzyc', NULL, 3, '', 'bzdw_b', 'zxdw_z_z', 2000, '', 0.00, '2000张/包', '', 0.0000, '', 'ml', '', 2, 0.1700, 0.1700, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2015, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001148', 'syz', '沙苑子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1680, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2025, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000959', 'ffpzbp', '风帆牌载玻片', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '1.2mm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2035, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_wj', 'ZKM00000133', 'xfzyw', '血府逐瘀丸', 'sccj_ydzyjtgfyxgs', 'z13021060', 3, '', 'bzdw_h', 'zxdw_w', 10, 'jldw_g', 9.00, '9.00g*10丸/盒', '', 0.0000, '', '', '', 1, 7.4000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 16:48:50', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2045, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001053', 'jgj', '金冠剪', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '直头11cm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2055, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000384', 'PEtqyyjb', 'PE透气医用胶布', 'sccj_hnjzxzlmwsclyxgs', '', 3, '', 'jjdw_j', '', 1, '', 0.00, '2.5X910', '', 0.0000, '', 'ml', '', 1, 2.7000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-24 10:13:16', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2065, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000233', 'ycxsyxtg（b）', '一次性使用吸痰管（包）', 'sccj_szsryxsjyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, 'F12', '', 0.0000, '', 'ml', '', 1, 1.2000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2075, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000459', 'qyxmhgzsy', '去乙酰毛花苷注射液', 'sccj_shxdpyyyxgs', '', 3, '', 'bzdw_z', 'zxdw_ml', 2, 'jldw_mg', 0.20, '0.20mg*2ml/支', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 5, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2085, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000740', 'zsh', '紫梢花', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.5000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2095, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000595', 'Kc', 'K锉', 'sccj_xnddsb', '国械备20170214号', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm-30', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2105, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00001722', 'blfhsjn（fbd）', '布洛芬缓释胶囊（芬必得）', 'sccj_zmtjskzyyxgs', 'H10900089', 3, '', 'bzdw_h', 'zxdw_l', 20, 'jldw_g', 0.30, '0.30g*20粒/盒', '', 0.0000, '', '', '', 1, 0.0000, 14.7000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2115, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000547', 'xdt', '续断炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0400, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:47:34', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2125, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001073', 'bgljt（30L）', '办公垃圾桶（30L）', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 80.0000, 80.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2135, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000748', 'bxgyt', '不锈钢牙托', 'sccj_shkqylqxyxgs', 'B3124(2013)0654', 3, '', 'jjdw_ge', '', 1, '', 0.00, '3#上有孔', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2145, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00001168', 'lszyxty', '罗氏卓越血糖仪', 'sccj_lszdcp（sh）yxgs', '-', 3, '', 'jjdw_t_148', '', 1, '', 0.00, '无', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2155, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001530', 'yysgmz', '医用石膏绵纸', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_b', '', 1, '', 0.00, '包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-19 09:56:41', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2165, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001640', 'clt ty', '磁疗贴 体用', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2175, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000627', 'yymjd', '医用灭菌袋', 'sccj_shjzylqxbzgfyxgs', '------------', 3, '', 'jjdw_j', '', 1, '', 0.00, '100*200', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2185, 'bgyplb_dzl', 3, 1, 'bgyplb_dzl', '', 'ZKM00001774', 'bgyp（cs）', '办公用品（测试）', 'sccj_amzyc', NULL, 3, '', 'bzdw_h', 'zxdw_t_6854', 1, '', 0.00, '1台/盒', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-28 19:03:02', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2195, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rj', 'ZKM00001857', '1', '1', 'sccj_NEOzygyzshs', '11', 3, '', 'bzdw_k_10382', 'zxdw_k_6141', 1, 'jldw_IU', 1.00, '1IU*1颗/颗', '', 0.0000, '', '', '', 1, 0.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2205, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tj_3708', 'ZKM00001712', 'lltdtj（krt）', '氯雷他定糖浆（开瑞坦）', 'sccj_blsSA AIcon Couvreur NV', 'H20120436', 3, '', 'bzdw_p', 'zxdw_hk', 60, 'jldw_ml', 60.00, '60.00ml*60毫克/瓶', 'kf', 0.0000, '', '', '', 1, 0.0000, 32.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 5, 2, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2215, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000359', 'wssD2zsy', '维生素D2注射液', 'sccj_jxnhxyyyxgs', 'h20054433', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_mg', 5.00, '5.00mg*1支/支', '', 0.0000, '', '', '', 1, 18.3900, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-19 12:40:52', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2225, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_sj_2', 'ZKM00000274', 'rsdbjms', '鞣酸蛋白酵母散', 'sccj_jhqy(jt)gfyxgsxajhzyc', 'h61022591', 3, '', 'bzdw_h', 'zxdw_h', 1, 'jldw_b', 9.00, '9.00包*1盒/盒', '', 0.0000, '', '', '', 1, 6.3000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 17:05:35', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2235, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000057', 'qlsqp（skp）', '氢氯噻嗪片（双克片）', 'sccj_sxypzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_p', 1000, 'jldw_mg', 25.00, '25mg*1000片/瓶', '', 0.0000, '', '', '', 1, 1.3500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 11:21:03', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2245, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001685', 'jgscz', '金刚砂车针', 'sccj_w', 'D18A188000', 3, '', 'jjdw_b_189', '', 1, '', 0.00, '板', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2255, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_kfy', 'ZKM00001479', 'ysaxskfry', '盐酸氨溴索口服溶液', 'sccj_amzyc', 'HC20150038', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_ml', 10.00, '10.00ml*1袋/袋', 'kf', 10.0000, '', '', 'mr3c', 2, 1.0000, 1.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-05-24 11:14:06', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2265, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001199', 'mxm', '木香面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0500, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2275, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000677', 'bhssc', '白花蛇舌草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.1230, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 17:48:46', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2285, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000915', 'llt', '路路通', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0450, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2295, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_fzj', 'ZKM00000249', 'zsyysnlt', '注射用盐酸纳洛酮', 'sccj_cxyygfyxgs', '', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_mg', 0.40, '0.4mg*1支/支', '', 0.0000, '', '', '', 1, 3.2400, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 14:59:38', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2305, 'yplb_zcy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000198', 'mlxkp', '美洛昔康片', 'sccj_qlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_p', 12, 'jldw_mg', 7.50, '7.5mg*12片/盒', '', 0.0000, '', '', '', 1, 3.2500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-21 11:07:50', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2315, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000092', 'wssB2p（p）', '维生素B2片（瓶）', 'sccj_cddyzyyxgs(ycddyyyyxgs)', '', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 5.00, '5mg*100片/瓶', '', 0.0000, '', '', '', 1, 3.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 11:30:12', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2325, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000901', 'cbm', '川贝母', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 11.2000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2335, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000768', 'wztp', '网状托盘', 'sccj_rxckclyxgs', '沪食药监械', 3, '', 'jjdw_f_3720', '', 1, '', 0.00, '中', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2345, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000063', 'yx', '牙线', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2355, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001364', 'njq', '奶精球', 'sccj_amzyc', '', 3, '', 'bzdw_d', 'zxdw_d', 1, '', 0.00, '1袋/袋', '', 0.0000, '', 'ml', '', 2, 25.8000, 25.8000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2365, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001808', 'fkzp', '氟康唑片', 'sccj_whdxyykjyxgs', 'H20084422', 3, '', 'bzdw_h', 'zxdw_l', 6, 'jldw_mg', 50.00, '50.00mg*6粒/盒', '', 0.0000, '', '', '', 1, 0.0000, 2.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2375, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000140', 'ysldkyzsy', '盐酸利多卡因注射液', 'sccj_syyhzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 5, 'jldw_g', 0.10, '0.1g*5支/盒', '', 0.0000, '', '', '', 1, 7.8000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 10:51:21', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2385, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001466', 'zdgc（TC）cdsjh	', '总胆固醇（TC）测定试剂盒	', 'sccj_szmr', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2395, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000126', 'hyhmsjn', '琥乙红霉素胶囊', 'sccj_xaljzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_l', 12, 'jldw_g', 0.25, '0.25g*12粒/盒', '', 0.0000, '', '', '', 1, 9.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 10:45:16', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2405, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001144', 'cnbz', '炒牛蒡子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.1500, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2415, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_pj', 'ZKM00000125', 'sqp', '三七片', 'sccj_scykzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_p', 40, 'jldw_g', 0.25, '0.25g*40片/瓶', '', 0.0000, '', '', '', 1, 3.1000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 13:39:34', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2425, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001778', 'akbtp（btp）', '阿卡波糖片（拜糖平）', 'sccj_beyyyxgs', 'H19990205', 3, '', 'bzdw_h', 'zxdw_p', 30, 'jldw_mg', 50.00, '50.00mg*30片/盒', '', 0.0000, '', '', '', 1, 0.0000, 62.2300, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2435, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001670', '40yA5bjb', '40页A5笔记本', 'sccj_amzyc', NULL, 3, '', 'bzdw_b_9413', 'zxdw_b_2375', 1, '', 0.00, '1本/本', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-18 13:41:22', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2445, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000373', '3Mhmj', '3M护目镜', 'sccj_mnsdkyzz（sh）gjmyyxgs', '', 3, '', 'jjdw_f', '', 1, '', 0.00, '1711AF', '', 0.0000, '', 'ml', '', 1, 34.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2455, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000505', 'rsfttgp', '瑞舒伐他汀钙片', 'sccj_aslkzyyxgs', 'J20170008', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_mg', 10.00, '10.00mg*7片/盒', 'ad us.int', 10.0000, '', '', 'qd', 1, 56.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-03-02 16:56:50', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2465, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000752', 'gghmxcl', '光固化模型材料', 'sccj_shhg', '--', 3, '', 'jjdw_h', '', 1, '', 0.00, '50*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2475, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000709', 'xce（d）', '雄蚕蛾（大）', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.3500, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2485, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001334', 'zx', '泽泻', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.1010, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2495, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000695', 'dgkf', '煅蛤壳粉', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 0.0000, '', '', '', 1, 0.0140, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2505, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000543', 'gmdzdbdgccdsjh（zjf-xzyzf）', '高密度脂蛋白胆固醇测定试剂盒（直接法-选择抑制法）', 'sccj_glyltyldzyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '45ml*3；15ml*3校准品1ml', '', 0.0000, '', 'ml', '', 1, 1006.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2515, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001044', 'crbyq', '成人拔牙钳', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '151#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2525, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000991', 'wjssdp（tg）', '无菌手术刀片（碳钢）', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '15#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2535, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000855', 'pyx（dqgd，clc', '排龈线（带切割刀，测量尺', 'sccj_w', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '#00不含药2.44米长', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-28 15:50:19', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2545, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001224', 'bl', '槟榔', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.0670, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2555, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000093', 'cjrsc 21mm', '超级柔顺锉 21mm', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2565, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001445', 'byx（FOB）jcsj', '便隐血（FOB）检测试剂', 'sccj_abswyy（hz）yxgs', '-', 3, '', 'jjdw_l', '', 1, '', 0.00, '粒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2575, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001370', 'tsxlh', '天山雪莲花', 'sccj_trt', '', 3, '', 'bzdw_d_695', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 1.0000, '', '', '', 1, 34.0000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2585, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00001816', 'hxzqrjn', '藿香正气软胶囊', 'sccj_swyyjt', 'Z13020797', 3, '', 'bzdw_h', 'zxdw_l', 24, 'jldw_g', 0.45, '0.45g*24粒/盒', '', 0.0000, '', '', '', 1, 0.0000, 11.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2595, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000842', 'kqzjyfgj', '口腔正畸用反光镜', 'sccj_w', '-', 3, '', 'jjdw_k_7001', '', 1, '', 0.00, '505-102侧面#2', '', 0.0000, '', 'ml', '', 1, 0.0000, 120.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2605, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000264', 'yyklwfhkz（3Mkz N95kz）', '医用颗粒物防护口罩（3M口罩 N95口罩）', 'sccj_3Mzg', '', 3, '', 'jjdw_z_5693', '', 1, '', 0.00, '9132', '', 0.0000, '', 'ml', '', 1, 5.5000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 15:38:01', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2615, 'bgyplb_yyzflcl', 3, 1, 'bgyplb_yyzflcl', '', 'ZKM00001504', 'nysbdy（Mm）', '女医生白大衣（M码）', 'sccj_amzyc', NULL, 3, '', 'bzdw_j_4203', 'zxdw_j_2903', 1, '', 0.00, '1件/件', '', 0.0000, '', 'ml', '', 2, 130.0000, 130.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2625, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00000846', 'C-fydbzk', 'C-反应蛋白质控', 'sccj_w', '国械注进20162400859', 3, '', 'jjdw_z', '', 1, '', 0.00, '1ml/支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-31 13:38:15', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2635, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001607', 'zjzth 0.3*40mm', '针灸针套盒 0.3*40mm', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2645, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000935', 'fhy', '凤凰衣', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.0860, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2655, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001485', 'kdxg1ml', '刻度吸管1ml', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2665, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001322', 'yklzspA6', '亚克力展示牌A6', 'sccj_amzyc', '', 3, '', 'bzdw_z_8915', 'zxdw_g', 4, '', 0.00, '4个/组', '', 0.0000, '', 'ml', '', 2, 9.7500, 9.7500, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2675, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000989', 'fcp', '麸椿皮', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0840, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2685, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000482', 'mdzlzsy（lyx）', '咪达唑仑注射液（力月西）', 'sccj_jsehyygfyxgs', 'H10980025', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 2.00, '2.00ml*1支/支', 'Ut dict', 2.0000, '', '', 'Prn', 1, 21.8300, 30.5600, 'fylb_xyf', 'fpxm_xyf', 0, 0, 1, 0, 0, 0, 2, NULL, '2018-05-04 15:28:42', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2695, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001539', 'crdjpwlb', '成人电极片物料包', 'sccj_szmr', '-', 3, '', 'jjdw_t', '', 1, '', 0.00, '套', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2705, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000344', 'ycxsybbb（dbb）', '一次性使用标本杯（大便杯）', 'sccj_jskdylypyxgs', '', 3, '', 'jjdw_z_5693', '', 1, '', 0.00, '60ml带小勺，PP', '', 0.0000, '', 'ml', '', 1, 0.2400, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2715, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000678', 'sqf', '三七粉', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 1.9040, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2725, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001318', 'tbkwfsp', '头孢克肟分散片', 'sccj_cdbtyy', '国药准字h20040588', 3, '', 'bzdw_h', 'zxdw_p', 12, 'jldw_mg', 100.00, '100.00mg*12片/盒', '', 0.0000, '', '', '', 1, 26.8700, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-08 08:51:21', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2735, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tj', 'ZKM00001408', 'ydmxtj（wtl）', '吲哚美辛贴剂（万特力）', 'sccj_qtypzshs', 'JX20120247', 3, '', 'bzdw_h', 'zxdw_t', 7, 'jldw_g', 3.50, '3.50g*7贴/盒', 'ad us.ext', 3.5000, '', '', 'bid', 1, 62.9000, 75.4800, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-04-03 10:38:47', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2745, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_hsp', 'ZKM00000047', 'kczy1', '库存中药1', 'sccj_hrsj', '1121121', 3, '', 'bzdw_b', 'zxdw_kg_g', 1, 'jldw_g', 10.00, '10.00g/包', '', 0.0000, '', '', '', 1, 0.0000, 10.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2755, 'bgyplb_jgyplcl', 3, 1, 'bgyplb_jgyplcl', '', 'ZKM00000044', 'cs123', '测试123', 'sccj_amzyc', NULL, 3, '', 'bzdw_p_1730', 'zxdw_z', 1, '', 0.00, '1揿/包', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-08-21 17:12:20', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2765, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000326', 'bxgstsmjq', '不锈钢手提式灭菌器', 'sccj_shsaylqxc', '', 3, '', 'jjdw_t_148', '', 1, '', 0.00, 'DSX-280B（自动）', '', 0.0000, '', 'ml', '', 1, 1650.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2775, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001262', 'lft', '莲房炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0350, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2785, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001582', 'wscecp', '戊酸雌二醇片', 'sccj_beyybjyxgsgzfgs', '国药准字J20171038', 3, '', 'bzdw_h', 'zxdw_p', 21, 'jldw_mg', 1.00, '1.00mg*21片/盒', '', 0.0000, '', '', '', 1, 31.0000, 31.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2795, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001906', 'lstjp', '氯沙坦钾片', 'sccj_hzmsdzyyxgs', 'J20130048', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_hk', 100.00, '100毫克*7片/盒', '', 0.0000, '', '', '', 1, 0.0000, 53.1200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2805, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000188', 'xhpB-Dsyb', '新华牌B-D试验包', 'sccj_sdxhylqxgfyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '12cm*12cm', '', 0.0000, '', 'ml', '', 1, 28.5000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2815, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000178', 'ycxsyyqwhq', '一次性使用氧气雾化器', 'sccj_gdhnyyjtyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2825, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000252', 'shpG-1xxdjndsz', '四环牌G-1型消毒剂浓度试纸', 'sccj_bjshwsyxcyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, 'G-1型20本/盒', '', 0.0000, '', 'ml', '', 1, 75.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2835, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dyj', 'ZKM00001791', 'tbmsdsmsdyy', '妥布霉素地塞米松滴眼液', 'sccj_cdqslkyyyxgs', 'H20073655', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 5.00, '5.00ml*1支/支', '', 0.0000, '', '', '', 1, 0.0000, 7.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2845, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001547', 'gz et', '拐杖 儿童', 'sccj_ssdt', '-', 3, '', 'jjdw_f_3720', '', 1, '', 0.00, '付', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2855, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001526', 'yygdd zh', '医用固定带 中号', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2865, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsp', 'ZKM00000382', 'dyxajfhsp', '对乙酰氨基酚缓释片', 'sccj_sdajgkxdkjyxgs', '', 3, '', 'bzdw_h', 'zxdw_p', 6, 'jldw_g', 0.65, '0.65g*6片/盒', 'ad us.int', 0.6500, '', '', 'Qid', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 3, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2875, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001788', 'csqandzsy', '醋酸曲安奈德注射液', 'sccj_zjxjzygfyxgs', 'H20033525', 3, '', 'bzdw_p', 'zxdw_ml', 1, 'jldw_mg', 40.00, '40.00mg*1ml/瓶', 'gjqzs', 5.0000, '', '', 'bys', 1, 0.0000, 4.6100, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2885, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000203', 'ryljd', '日用垃圾袋', 'sccj_bjjrkkjyxgs', '', 3, '', 'jjdw_k', '', 1, '', 0.00, '30L', '', 0.0000, '', 'ml', '', 1, 32.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2895, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000139', 'twq', '剔挖器', 'sccj_shkqylqxyxgs', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '#E6', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 14:13:18', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2905, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001307', 'fxm', '分心木', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1060, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2915, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000764', 'gp', '桂皮', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0400, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2925, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000365', 'csx（bzx）dz', '蚕丝线（编织型）带针', 'sccj_hzhwylypyxgs', '20170846820170820', 3, '', 'jjdw_h', '', 1, '', 0.00, '070cm△1/29x24单针', '', 0.0000, '', 'ml', '', 1, 220.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-24 10:10:14', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2935, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_qwj', 'ZKM00000190', 'ynbyqwj', '云南白药气雾剂', 'sccj_ynbyjtgfyxgs', '国药准字Z53021107', 3, '', 'bzdw_h', 'zxdw_kg_g', 60, 'jldw_g', 50.00, '50.00g*60g/盒', '', 0.0000, '', '', '', 1, 28.9000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-29 15:47:06', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2945, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000629', 'yyfhz', '医用缝合针', 'sccj_shxyyl', '沪食药监械准字2014第2011256', 3, '', 'jjdw_b', '', 1, '', 0.00, '1/25*14', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2955, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_pj', 'ZKM00000159', 'xsgyp', '硝酸甘油片', 'sccj_sdxyzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 0.50, '0.5mg*100片/瓶', '', 0.0000, '', '', '', 1, 4.8000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-06 15:33:43', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2965, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000600', 'ybbsz', '有柄拔髓针', 'sccj_xnddsb', '国食药监械进字2013第1555607', 3, '', 'jjdw_b_189', '', 1, '', 0.00, '10*1（混）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-04-03 10:40:43', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2975, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000599', 'myc', '绵茵陈', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0560, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:39:16', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2985, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000660', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'TF-13(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-04-08 10:44:08', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (2995, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001617', 'fbhjbcz1*7k', '氟保护剂补充装1*7克', 'sccj_yhjwwdtgs', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3005, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000526', 'bxgswkygg', '不锈钢砂无孔药膏罐', 'sccj_hryl', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '90*90mm', '', 0.0000, '', 'ml', '', 1, 45.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3015, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001112', 'dgeqt', '丁桂儿脐贴', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '1.6g*2贴', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3025, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001690', 'dfxdy100ml', '碘伏消毒液100ml', 'sccj_scjszyyxgs', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-07-04 11:30:27', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3035, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001353', 'tdqbcj ', '推钉器补充夹 ', 'sccj_amzyc', '', 3, '', 'bzdw_h', 'zxdw_h', 1, '', 0.00, '1盒/盒', '', 0.0000, '', 'ml', '', 2, 8.0000, 8.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3045, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000753', 'ltj', '两头尖', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2250, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3055, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000855', 'bz', '白芷', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1400, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3065, 'bgyplb_dzl', 3, 1, 'bgyplb_dzl', '', 'ZKM00001734', 'dzc', '电子秤', 'sccj_amzyc', NULL, 3, '', 'bzdw_t_9258', 'zxdw_t_6854', 1, '', 0.00, '1台/台', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3075, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000938', 'yggsj（6%dzdyjj-h）', '牙根管塞尖（6%大锥度牙胶尖-混）', 'sccj_dsbyk（tj）yxgs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '06锥度15-40#120*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-28 16:28:08', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3085, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000430', 'zzq（gjzs）', '组织钳（国际制式）', 'sccj_shylqx（jt）yxgsssqxc', '', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'TC703024(巴氏）', '', 0.0000, '', 'ml', '', 1, 104.4000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3095, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001871', 'jszhp（th）', '金嗓子喉片（铁盒）', 'sccj_gxjszyxgs', 'B20020993', 3, '', 'bzdw_h', 'zxdw_p', 16, 'jldw_g', 2.00, '2g*16片/盒', '', 0.0000, '', '', '', 1, 0.0000, 12.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3105, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000007', 'cs123', '测试123', 'sccj_bjsykyy', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-08-08 18:08:39', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3115, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000982', 'ycxsyzkcxg', '一次性使用真空采血管', 'sccj_jskjylypyxgs', '苏械注准20152411361', 3, '', 'jjdw_z', '', 1, '', 0.00, '血沉管黑色', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3125, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000628', 'fxsfhx（xt）', '非吸收缝合线（线团）', 'sccj_hzhwylypyxgs', '浙械注准20142650178', 3, '', 'jjdw_ge', '', 1, '', 0.00, '3-03m', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3135, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000376', 'lsastwjn(df)', '磷酸奥司他韦胶囊(达菲)', 'sccj_shlszyyxgs', 'J20140121', 3, '', 'bzdw_h', 'zxdw_l', 10, 'jldw_mg', 75.00, '75.00mg*10粒/盒', 'kf', 75.0000, '', '', 'bid', 1, 221.3500, 301.3200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 3, NULL, '2018-05-24 11:10:35', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3145, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000279', 'zxd', '止血带', 'sccj_dd', '', 3, '', 'jjdw_t_7475', '', 1, '', 0.00, '卡扣式', '', 0.0000, '', 'ml', '', 1, 4.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-15 10:46:39', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3155, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000919', 'zr', '竹茹', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0900, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3165, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001694', 'ajpxdp100p', '安捷牌消毒片100片', 'sccj_sdaj', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3175, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000682', 'cwj', '刺五加', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2180, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3185, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001272', 'yshyq	', '匀速混匀器	', 'sccj_dlxcsyyq（bj）yxgs		', '-', 3, '', 'jjdw_t_148', '', 1, '', 0.00, 'MX-S', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3195, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001018', 'jgscz', '金刚砂车针', 'sccj_w', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'TR-62C', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3205, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001565', 'zbp', '载玻片', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3215, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000922', 'yyc（protaper ntgk-sy21h）', '牙用锉（protaper 镍钛根扩-手用21混）', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mmSX-F36*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3225, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_wj', 'ZKM00001891', 'bjw', '保济丸', 'sccj_gyjtflx（fs）yyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 20, 'jldw_g', 3.70, '3.70g*20袋/盒', '', 0.0000, '', '', '', 1, 0.0000, 8.5000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-07-03 17:28:17', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3235, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001792', 'psfrmyqdb', '破伤风人免疫球蛋白', 'sccj_szwgswzpgfyxgs', 'S20053027', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_dw', 250.00, '250.00单位*1瓶/瓶', '', 0.0000, '', '', '', 1, 0.0000, 250.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-06-07 16:20:49', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3245, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000683', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'F0-54C', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3255, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001314', 'mlstnp', '孟鲁司特钠片', 'sccj_scdz', 'h20064370', 3, '', 'bzdw_h', 'zxdw_p', 5, 'jldw_mg', 10.00, '10.00mg*5片/盒', '', 0.0000, '', '', '', 1, 30.3500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:04:34', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3265, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000187', 'yyljt', '医用垃圾桶', 'sccj_bjjrkkjyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '100L', '', 0.0000, '', 'ml', '', 1, 180.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3275, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00000463', 'ymlxgjkyjcsj（rjf）', '幽门螺旋杆菌抗原检测试剂（乳胶法）', 'sccj_abswyy（hz）yxgs', '', 3, '', 'jjdw_f_9562', '', 1, '', 0.00, '25人份', '', 0.0000, '', 'ml', '', 1, 14.8000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3285, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000603', 'Hc', 'H锉', 'sccj_xnddsb', '国械备20170214号', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm-25（红）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3295, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000095', 'wssCp', '维生素C片', 'sccj_cddyzyyxgs(ycddyyyyxgs)', '国药准字h51022742', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_g', 0.10, '0.10g*100片/瓶', '', 0.0000, '', '', '', 1, 1.4000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 08:58:48', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3305, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001158', 'zhdd', '紫花地丁', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0730, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3315, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001233', 'zzjdw	', '组织剪刀弯	', 'sccj_shjz', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '16cm/把上海金钟', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3325, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_kfy', 'ZKM00000220', 'ysbktlkfry(mpq）', '盐酸丙卡特罗口服溶液(美普清）', 'sccj_scdzzyyxgs', '国药准字h20053903', 3, '', 'bzdw_h', 'zxdw_p_1', 1, 'jldw_ml', 30.00, '30.00ml*1瓶/盒', '', 0.0000, '', '', '', 1, 11.7100, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-25 13:37:58', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3335, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001699', '0.9％lhnzsy', '0.9％氯化钠注射液', 'sccj_rs', 'H20024024', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 10.00, '10.00ml*1支/支', '', 0.0000, '', '', '', 1, 0.0000, 2.3000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 20, 5, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3345, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_hj', 'ZKM00000540', 'pdlxykfy', '蒲地蓝消炎口服液', 'sccj_jcyyjtyxgs', 'Z20030095', 3, '', 'bzdw_h', 'zxdw_z', 12, 'jldw_ml', 10.00, '10.00ml*12支/盒', 'ad us.int', 20.0000, '', '', 'TID', 1, 44.5800, 1.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 10, 2, NULL, '2018-04-09 10:18:07', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3355, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000135', 'ssj', '手术剪', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '12.5直', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3365, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rg', 'ZKM00000112', 'kmzrg', '克霉唑乳膏', 'sccj_xxsclzyyxzrgs', '国药准字h41023824', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 10.00, '10.00g*1支/支', '', 0.0000, '', '', '', 1, 1.9500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 09:01:48', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3375, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001451', 'wssB12zsy', '维生素B12注射液', 'sccj_gzbystxzygfyxgs', 'H44022100', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 1.00, '1.00ml*1支/支', '', 0.0000, '', '', '', 1, 0.4320, 0.6100, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 3, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3385, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00001670', '1', '1', 'sccj_sccj（cs）', '1', 3, '', 'jjdw_b_189', '', 1, '', 0.00, '板', '', 0.0000, '', 'ml', '', 1, 0.0000, 10.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3395, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000138', 'czq', '持针器', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '16', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3405, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_cj_1', 'ZKM00001752', 'ysdkyjj', '盐酸丁卡因胶浆', 'sccj_xaljzyyxgs', '国药准字H61022993', 3, '', 'bzdw_h', 'zxdw_z', 1, 'jldw_g', 5.00, '5.00g*1支/盒', '', 0.0000, '', '', '', 1, 0.0000, 14.6300, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3415, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000559', 'jszy', '酒山茱萸', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2520, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:31:41', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3425, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001000', 'ycxsy（PE）bmst', '一次性使用（PE）薄膜手套', 'sccj_w', '-', 3, '', 'jjdw_x', '', 1, '', 0.00, '中号', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-29 17:06:37', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3435, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000455', '0.9%lhnzsy', '0.9%氯化钠注射液', 'sccj_sjzsyyxgs', 'H13023201', 3, '', 'bzdw_d', 'zxdw_ml', 250, 'jldw_g', 2.25, '2.25g*250ml/袋', 'Iv', 2.2500, '', '', 'qd', 2, 5.2000, 7.2800, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 20, 5, NULL, '2018-04-20 11:31:48', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3445, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000939', 'yggsj（6%dzdyjj）', '牙根管塞尖（6%大锥度牙胶尖）', 'sccj_dsbyk（tj）yxgs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '06锥度15#白120*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 16:23:11', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3455, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001703', 'yyj', '医用胶', 'sccj_zzatlkswgcyxgs', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3465, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000799', 'cmt', '川木通', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0670, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3475, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000118', 'gxj', '硅橡胶', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '二次氢体', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3485, 'bgyplb_sbwxpjlcl', 3, 1, 'bgyplb_sbwxpjlcl', '', 'ZKM00001738', 'VGAzjt', 'VGA转接头', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3495, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000186', 'ryljt', '日用垃圾桶', 'sccj_bjjrkkjyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '30L', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3505, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000243', 'yyzd（hlfmd）', '医用中单（华林腹膜单）', 'sccj_xxshlylqxyxgs', '', 3, '', 'jjdw_k_7001', '', 1, '', 0.00, '100*200林膜', '', 0.0000, '', 'ml', '', 1, 1.2000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3515, 'bgyplb_yslcl', 3, 1, 'bgyplb_yslcl', '', 'ZKM00001411', 'yxd', '影像袋', 'sccj_amzyc', '', 3, '', 'bzdw_b', 'zxdw_g', 100, '', 0.00, '100个/包', '', 0.0000, '', 'ml', '', 2, 1.8500, 1.8500, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3525, 'bgyplb_dzl', 3, 1, 'bgyplb_dzl', '', 'ZKM00001690', 'rmsyjz', '热敏收银机纸', 'sccj_amzyc', NULL, 3, '', 'bzdw_t_9258', 'zxdw_t_6854', 1, '', 0.00, '1台/台', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3535, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000006', 'ze1', '周二1', 'sccj_hrsj', '111', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 120.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-07-31 13:59:39', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3545, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001401', 'jmsyq', '静脉输液器', 'sccj_jxhd		', '-', 3, '', 'jjdw_f', '', 1, '', 0.00, '6#500副/件25副/包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3555, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001248', 'myc', '猫眼草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0840, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3565, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000569', 'ycxhzf', '一次性汗蒸服', 'sccj_dd', '', 3, '', 'jjdw_j_8137', '', 1, '', 0.00, '均码', '', 0.0000, '', 'ml', '', 1, 18.8000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3575, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001107', 'yz', '玉竹', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1900, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3585, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_kfy', 'ZKM00001548', 'axtlkfry（ytj）', '氨溴特罗口服溶液（易坦静）', 'sccj_bjhmypyxgs', 'H20040317', 3, '', 'bzdw_p', 'zxdw_ml', 60, 'jldw_ml', 1.00, '1.00ml*60ml/瓶', '', 0.0000, '', '', '', 1, 23.0000, 2.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3595, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000918', 'bb', '百部', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/支', '', 10.0000, '', '', '', 1, 0.1230, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3605, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000004', 'lsnj', '六神凝胶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3615, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000014', 'tzjkl', '太子金颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3625, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000024', 'pttsgkfry', '葡萄糖酸钙口服溶液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3635, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000034', 'dyxajfhxdj(tnl)', '对乙酰氨基酚混悬滴剂(泰诺林)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3645, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000044', 'tqbyp', '通窍鼻炎片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3655, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000054', 'dzzgjn', '杜仲壮骨胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3665, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tj', 'ZDS90000064', 'ydmxtp（wtl）', '吲哚美辛贴片（万特力）', 'sccj_qtypzshs', '国药准字J20160036', 3, '', 'bzdw_h', 'zxdw_t', 7, 'jldw_cm', 7.00, '7.00cm*7贴/盒', '', 0.0000, '', 'ml', '', 1, 50.5600, 58.1400, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-04-08 14:23:43', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3675, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000074', 'ytp', '腰痛片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3685, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qwj', 'ZDS90000084', 'ynbyqwj（tx）', '云南白药气雾剂（腾讯）', 'sccj_ynbyjtgf', 'ZEB1738', 3, '', 'bzdw_p', 'zxdw_kg_g', 115, 'jldw_g', 1.00, '1.00g*115g/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 29.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-11 16:55:46', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3695, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000094', 'kgyrjn', '抗宫炎软胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3705, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000104', 'cfakl', '产妇安颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3715, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000114', 'jeyxy', '洁尔阴洗液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3725, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000124', 'fkqjp', '妇科千金片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3735, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000134', 'gfkw', '肝复康丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3745, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000144', 'sgw', '舒肝丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3755, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_klj', 'ZDS90000154', 'xchkl', '小柴胡颗粒', 'sccj_gzbysmxzyyxgs', 'K70393', 3, '', 'bzdw_h', 'zxdw_d', 10, 'jldw_g', 10.00, '10.00g*10袋/盒', '', 0.0000, '', 'ml', '', 1, 12.5000, 10.9000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-21 14:31:15', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3765, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000164', 'gmljn', '感冒灵胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3775, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000174', 'xzl（sp）', '鲜竹沥（塑瓶）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3785, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000184', 'cbxltj', '川贝雪梨糖浆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3795, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000194', 'qfyhp', '清肺抑火片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3805, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZDS90000204', 'yszxtlqp（yz）', '盐酸左西替利嗪片（优泽）', 'sccj_UCB PARCHIM SA rs bj', 'H20150522', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_mg', 5.00, '5.00mg*7片/盒', 'kf', 5.0000, '', 'ml', 'mr1c', 1, 30.6100, 2.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-24 14:19:29', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3815, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000214', 'akfs', '阿咖酚散', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3825, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000224', 'ytkxp', '依托考昔片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3835, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000234', 'ysfxlwp(mzx)', '盐酸伐昔洛韦片(明竹欣)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3845, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZDS90000244', 'ysmnhsjn(mm)', '盐酸米诺环素胶囊(玫满)', 'sccj_hszyyxgs', 'H10960011', 3, '', 'bzdw_h', 'zxdw_l', 20, 'jldw_mg', 50.00, '50.00mg*20粒/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 48.8000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-06-08 14:20:23', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3855, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_qt', 'ZDS90000254', 'yszyfsxp', '盐酸左氧氟沙星片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-02-06 14:20:11', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3865, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000264', 'txzp', '替硝唑片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3875, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000274', 'lzplp', '硫唑嘌呤片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3885, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000284', 'dxytjn', '丁细牙痛胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3895, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000294', 'sykfp', '肾炎康复片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3905, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000304', 'ffsyp', '复方肾炎片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3915, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000314', 'ysejsgp(ghz)', '盐酸二甲双胍片(格华止)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3925, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000324', 'alstjn', '奥利司他胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3935, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000334', 'kbscrg', '卡泊三醇软膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3945, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000344', 'qyrg', '羌月乳膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3955, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000354', 'ysdjd', '盐酸氮芥酊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3965, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000364', 'fftkzfyxj', '复方酮康唑发用洗剂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3975, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000374', 'ffrsrg(gbm)', '复方乳酸乳膏(干彼美)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3985, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000384', 'fftkzfyxj', '复方酮康唑发用洗剂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/袋', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (3995, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000394', 'rqmj', '仁青芒觉', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4005, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_kfy', 'ZDS90000404', 'hxzqkfy', '藿香正气口服液', 'sccj_tjjt', '17070736', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_ml', 10.00, '10.00ml*10支/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 20.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-11 09:48:54', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4015, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000414', 'ahblp(sla)', '氨磺必利片(索里昂)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4025, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZDS90000424', 'ysyplsp(mn)', '盐酸乙哌立松片(妙纳)', 'sccj_wc（zg）yyyxgs', 'H20133175', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_mg', 50.00, '50.00mg*20片/盒', 'kf', 50.0000, '', 'ml', 'mr3c', 1, 1.0000, 26.0100, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-06-07 11:15:19', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4035, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000434', 'jgap(ysb)', '甲钴胺片(怡神保)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4045, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000444', 'sqasw', '顺气安神丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4055, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000454', 'cxlblp', '陈香露白露片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4065, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000464', 'cynjn', '肠炎宁胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4075, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000474', 'kyljn', '溃疡灵胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4085, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000484', 'zzdx', '坐珠达西', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4095, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000494', 'bhsaldpp(lhx)', '苯磺酸氨氯地平片(络活喜)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4105, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000504', 'sxp', '舒胸片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4115, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000514', 'lkjp', '利可君片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4125, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000524', 'yxyp(dnk)', '银杏叶片(达纳康)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4135, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000534', 'fmsbslep(kx)', '富马酸比索洛尔片(康忻)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4145, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000544', 'atfttgp(lpt)', '阿托伐他汀钙片(立普妥)', 'sccj_hrzyyxgs', 'h20051407', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_mg', 10.00, '10mg*7片/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 43.4000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-07-03 15:15:12', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4155, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000554', 'rxbdb(bl)', '人血白蛋白(贝林)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4165, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000564', 'ffxstjn', '复方血栓通胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4175, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000574', 'llzlhdp(wlt)', '卵磷脂络合碘片(沃丽汀)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4185, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000584', 'bdlasdyy(spas)', '苄达赖氨酸滴眼液(莎普爱思)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4195, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000594', 'tqjd', '透气胶带', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/袋', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4205, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000604', 'tsgwd3ysp（4）', '碳酸钙维d3元素片（4）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4215, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000614', 'ktfsckt', '卡通防水创可贴', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4225, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000624', 'qbmrw', '七宝美髯丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4235, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000634', 'nxyzkfy(zzjny)', '宁心益智口服液(枕中健脑液)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4245, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000002', 'twj（sy）', '体温计（水银）', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '10支每盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4255, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000012', 'ycxzsq', '一次性注射器', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '20ml', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-01-12 16:40:01', 1, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4265, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000022', 'yy84xdy', '医用84消毒液', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '500ml', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4275, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000032', 'ycxwjyyfs', '一次性无菌医用方纱', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '8*10cm 两片一包', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4285, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000042', 'hg（bl）z', '火罐（玻璃）中', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '内径4.6', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4295, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000052', 'ycxcysmsxtcxz（zxl）', '一次性触压式末梢血糖采血针（中血量）', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '50个/包', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4305, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000062', 'ycxkqhlb', '一次性口腔护理包', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4315, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000072', 'ykqxmjd（d）', '牙科器械灭菌袋（大）', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '15cm宽', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4325, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000082', 'mjhm', '明胶海绵', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '20片/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4335, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000092', 'ycxslymtp', '一次性塑料牙模托盘', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '1号', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4345, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000102', 'wyd', '无影灯', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4355, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000003', 'wg.', '蜈蚣.', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4365, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000013', 'gj', '蛤蚧', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4375, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000023', 'jg', '桔梗', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4385, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000033', 'hq', '黄芪', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4395, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000043', 'md', '麦冬', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4405, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000053', 'fccs', '麸炒苍术', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4415, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000063', 'cp', '陈皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4425, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000073', 'jqc', '金钱草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4435, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000083', 'dy', '稻芽', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4445, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000093', 'sg', '石膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4455, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000103', 'mzw', '蜜紫菀', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4465, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000113', 'jhj', '酒黄精', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4475, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000123', 'yc', '茵陈', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4485, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000133', 'zgc', '炙甘草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4495, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000143', 'rg', '肉桂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4505, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000153', 'btl', '白土苓', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4515, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000163', 'yfpz', '盐覆盆子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4525, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000173', 'dk', '豆蔻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4535, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000183', 'bzr', '柏子仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4545, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000193', 'sm', '升麻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4555, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000203', 'fxm', '浮小麦', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4565, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000213', 'gz', '桂枝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4575, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000223', 'ay', '艾叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4585, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000233', 'scp', '石菖蒲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4595, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000243', 'rcrp', '肉苁蓉片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4605, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000253', 'sr', '砂仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4615, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000263', 'hs', '滑石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4625, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000273', 'xx', '细辛', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4635, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000283', 'yj', '郁金', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4645, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000293', 'nx', '牛膝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4655, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000303', 'cs', '赤芍', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4665, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000313', 'cjl', '炒蒺藜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4675, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000323', 'bzl', '半枝莲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4685, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000333', 'pj', '炮姜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4695, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000343', 'qs', '芡实', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4705, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000353', 'cwlz', '醋五灵脂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4715, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000363', 'gsq', '隔山撬', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4725, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000373', 'wm', '乌梅', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4735, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000383', 'ydtsz', '盐大菟丝子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4745, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000393', 'clff', '炒露蜂房', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4755, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000403', 'dwlz', '煅瓦楞子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4765, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000413', 'zjc', '皂角刺', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4775, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000423', 'xkqc', '夏枯全草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4785, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000433', 'dfp', '大腹皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4795, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000443', 'ddhj', '大豆黄卷', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4805, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000453', 'jl', '橘络', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4815, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000463', 'cbs', '炒白芍', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4825, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000473', 'pl', '佩兰', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4835, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000483', 'cjq', '炒建曲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4845, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000493', 'hjs', '海金沙', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4855, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000503', 'yhb', '盐黄柏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4865, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000513', 'qc', '茜草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4875, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000523', 'scg', '山慈菇', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4885, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000533', 'hz', '海藻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4895, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000543', 'glj', '高良姜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4905, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000553', 'whg', '无花果', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4915, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000563', 'qx', '全蝎', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4925, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000573', 'cdy', '炒稻芽', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4935, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000583', 'xcq', '徐长卿', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4945, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000593', 'fxy', '番泻叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4955, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000603', 'fj', '防己', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4965, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000613', 'hp', '厚朴', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4975, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000623', 'kc', '苦参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4985, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000633', 'bgr', '白果仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (4995, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000643', 'jh', '菊花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5005, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000653', 'cmy', '醋没药', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5015, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000663', 'csz', '炒山楂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5025, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000673', 'cdgz', '炒冬瓜子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5035, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000683', 'dzzm', '煅珍珠母', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5045, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000693', 'cqnz', '炒牵牛子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5055, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000703', 'dz', '杜仲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5065, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000713', 'gjc', '谷精草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5075, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000723', 'tgj', '烫狗脊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5085, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000733', 'bh', '百合', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5095, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000743', 'dfjc', '大肺筋草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5105, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000753', 'sr', '砂仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5115, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000763', 'xy', '香橼', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5125, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000773', 'yhlb', '盐葫芦巴', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5135, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000783', 'jx', '降香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5145, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000793', 'cxy', '炒辛夷', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5155, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000803', 'btw', '白头翁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5165, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000813', 'dzy', '淡竹叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5175, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000823', 'sy', '锁阳', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5185, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000833', 'cby', '侧柏叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5195, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000843', 'mhl', '墨旱莲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5205, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000853', 'tkz', '天葵子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5215, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000863', 'bzr', '柏子仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5225, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000873', 'ghx', '广藿香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5235, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000883', 'btl', '白土苓', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5245, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000893', 'hjs', '槲寄生', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5255, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000903', 'gz', '桂枝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5265, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000913', 'tzc', '太子参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5275, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000923', 'ebsc', '鹅不食草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5285, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000933', 'cyh', '川银花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5295, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000943', 'bh', '薄荷', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5305, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000953', 'cwblx', '炒王不留行', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5315, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000963', 'lqc', '连钱草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5325, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000973', 'jh', '菊花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5335, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000983', 'qh', '青蒿', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5345, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000993', 'flp', '茯苓皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5355, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001003', 'dqy', '大青叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5365, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001013', 'mbc', '马鞭草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5375, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001023', 'ddc', '淡豆豉', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5385, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001033', 'xcq', '徐长卿', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5395, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001043', 'bljn', '北刘寄奴', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5405, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001053', 'cbbd', '炒白扁豆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5415, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001063', 'yjh', '月季花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5425, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001073', 'cmjz', '炒蔓荆子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5435, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001083', 'mmdl', '蜜马兜铃', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5445, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001093', 'fcbs', '麸炒白术', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5455, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001103', 'chj', '炒槐角', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5465, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001113', 'qs', '芡实', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5475, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001123', 'yxc', '鱼腥草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5485, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001133', 'bb', '百部', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5495, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001143', 'pl', '佩兰', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5505, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001153', 'xjt', '小蓟炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5515, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001163', 'llt', '路路通', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5525, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001173', 'tr', '桃仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5535, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001183', 'yzz', '预知子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5545, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001193', 'zlt', '棕榈炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5555, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001203', 'cjxz', '炒急性子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5565, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001213', 'bcq', '荜澄茄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5575, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001223', 'gg', '官桂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5585, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001233', 'dgz', '冬瓜子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5595, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001243', 'hh', '槐花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5605, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001253', 'bfp', '白附片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5615, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001263', 'sz', '桑椹', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5625, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001273', 'zbm', '浙贝母', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5635, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001283', 'bf', '白矾', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5645, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001293', 'mhq', '蜜黄芪', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5655, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001303', 'lq', '连翘', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5665, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001313', 'dh(sd)', '地黄(生地)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5675, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001323', 'by', '白英', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5685, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001333', 'bq', '白前', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5695, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001343', 'qx', '全蝎', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5705, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001353', 'hph', '厚朴花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5715, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001363', 'yz', '玉竹', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5725, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001373', 'cyhs', '醋延胡索', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5735, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001383', 'tnx', '天南星', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5745, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001393', 'fl', '茯苓', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5755, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001403', 'ljs', '鹿角霜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5765, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001413', 'mlc', '马兰草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5775, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001423', 'wbz', '五倍子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5785, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001433', 'kf', '枯矾', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5795, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001443', 'jh（gj）', '菊花（贡菊）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5805, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001453', 'bx', '萹蓄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5815, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001463', 'tzc', '太子参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5825, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001473', 'bjhx', '八角茴香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5835, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001483', 'gb', '藁本', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5845, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001493', 'jxt', '鸡血藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5855, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001503', 'ff', '防风', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5865, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001513', 'yjh', '盐橘核', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5875, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001523', 'lsq', '六神曲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5885, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001533', 'fxm', '浮小麦', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5895, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001543', 'cdk', '草豆蔻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5905, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001553', 'lyh', '六月寒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5915, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001563', 'zsf', '朱砂粉', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5925, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001573', 'mhg', '麻黄根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5935, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001583', 'bs', '白术', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5945, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001593', 'zyz', '猪牙皂', 'sccj_bjtrtgfyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 10.0000, '', 'ml', '', 2, 0.1180, 1.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-02-23 16:51:18', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5955, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001603', 'xc', '玄参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5965, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001613', 'cs', '脆蛇', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5975, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001623', 'fg', '粉葛', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5985, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001633', 'bb', '百部', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (5995, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001643', 'cwblx', '炒王不留行', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6005, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001653', 'ghrcrp', '管花肉苁蓉片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6015, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001663', 'cxf', '醋香附', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6025, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001673', 'ctr', '燀桃仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6035, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001683', 'bj', '鳖甲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6045, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001693', 'jbx', '京半夏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6055, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001703', 'hh', '红花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6065, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001713', 'xtc', '小通草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6075, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001723', 'degs', '煅鹅管石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6085, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001733', 'jjs', '荆芥穗', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6095, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001743', 'bw', '白薇', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6105, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001753', 'xqxtc', '绣球小通草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6115, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001763', 'hjs', '海金沙', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6125, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001773', 'mlc', '马兰草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6135, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001783', 'ddhj', '大豆黄卷', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6145, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001793', 'btw', '白头翁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6155, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001803', 'djms', '煅金礞石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6165, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001813', 'lq', '连翘', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6175, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001823', 'jqs', '酒蕲蛇', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6185, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001833', 'dfz', '大风子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6195, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001843', 'cby', '侧柏叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6205, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001853', 'ydy', '一朵云', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6215, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001863', 'xkc', '夏枯草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6225, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001873', 'cp', '陈皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6235, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001883', 'zjz', '枳椇子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6245, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001893', 'qh', '前胡', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6255, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001903', 'yjh', '盐橘核', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6265, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001913', 'ddh', '代代花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6275, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001923', 'xc', '玄参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6285, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001933', 'bj', '白及', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6295, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001943', 'sl', '松萝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6305, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001953', 'xjt', '小蓟炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6315, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001963', 'yzj', '一支箭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6325, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001973', 'lxj', '龙血竭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6335, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001983', 'cbzr', '炒柏子仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6345, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001993', 'pgy', '蒲公英', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6355, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002003', 'js', '寄生', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6365, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002013', 'kxr', '苦杏仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6375, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002023', 'nsz', '南山楂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6385, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002033', 'dg', '当归', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6395, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002043', 'zjp.', '紫荆皮.', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6405, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002053', 'jjcp', '九节菖蒲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6415, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002063', 'zjf', '肿节风', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6425, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002073', 'jxz', '急性子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6435, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002083', 'jbx', '姜半夏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6445, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002093', 'dg', '当归', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6455, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002103', 'xyz', '小玉竹', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6465, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002113', 'bsc', '北沙参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6475, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002123', 'jzr', '姜竹茹', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6485, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002133', 'mg', '木瓜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6495, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002143', 'dzsy', '煅紫石英', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6505, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002153', 'dz', '大枣', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6515, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002163', 'dh', '独活', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6525, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002173', 'tgc', '透骨草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6535, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002183', 'wmy', '无名异', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6545, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002193', 'gg', '葛根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_5` VALUES (6555, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002203', 'cbs', '炒白芍', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
COMMIT;

-- ----------------------------
-- Table structure for drug_resource_6
-- ----------------------------
DROP TABLE IF EXISTS `drug_resource_6`;
CREATE TABLE `drug_resource_6` (
  `id` bigint unsigned NOT NULL DEFAULT '0' COMMENT '主键',
  `drug_res_type_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT ' 药品和物资类型ID(dw_drug_res_type.id)',
  `base_type` tinyint NOT NULL DEFAULT '0' COMMENT '物品类型：1-药品, 2-耗材, 3-办公用品',
  `status` int DEFAULT '1' COMMENT '药品状态: 0 - 停用, 1 - 使用',
  `type_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药品或者耗材类别的字典ID(dw_dictionary.id AND dw_dictionary.type_id=[yplb OR hclb])',
  `dict_dosage_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药品剂型的字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypjx)',
  `code` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '集团编码',
  `pym` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '拼音简码',
  `name` varchar(64) CHARACTER SET utf8 DEFAULT '' COMMENT '药品或者耗材的名称',
  `manufacturer_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '生产厂家的字典ID(dw_dictionary.id AND dw_dictionary.type_id=sccj)',
  `approval_no` varchar(100) CHARACTER SET utf8 DEFAULT NULL COMMENT '批准文号',
  `med_type` int DEFAULT '3' COMMENT '医保分类： 1 - 无自付, 2 - 部分自付, 3 - 全自付',
  `admin_code` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药监编码',
  `pack_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '包装单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypdw)',
  `min_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '最小单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypdw)',
  `pack_quantity` int DEFAULT '1' COMMENT '包装含量',
  `dosage_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '剂量单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=jldw)',
  `dosage_quantity` decimal(10,2) DEFAULT '0.00' COMMENT '剂量含量',
  `pack_spec` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '包装规格，生成规则：[剂量含量] [剂量单位] * [包装含量] [最小单位] / [包装单位]',
  `take_method_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '用法(默认用法)(dw_dictionary.id AND dw_dictionary.type_id=ypyf)',
  `take_quantity` decimal(36,4) DEFAULT '0.0000' COMMENT '用量(默认用量)',
  `take_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '用量单位字典ID - 暂留字典',
  `take_unit_name` varchar(36) CHARACTER SET utf8 DEFAULT 'ml' COMMENT '用量单位名称，默认ml',
  `take_frequency` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '频率(默认频率)(dw_dictionary.id AND dw_dictionary.type_id=yppl)',
  `common_unit_type` int DEFAULT '1' COMMENT '常规单位类型: 1 - 包装单位(packUnit), 2 - 最小单位(minUnit)',
  `purchase_price` decimal(8,4) DEFAULT '0.0000' COMMENT '进货价: 单位 元',
  `sale_price` decimal(8,4) DEFAULT '0.0000' COMMENT '基准价: 单位 元',
  `cost_category_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '费用类别字典ID(dw_dictionary.id AND dw_dicitionary.type_id=fylb)',
  `invoice_item_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '发票项目字典ID - 暂留',
  `expensive_flag` int DEFAULT '1' COMMENT '贵重物品标识： 0 - 非贵重物品， 1 - 贵重物品',
  `psy_flag_i` int DEFAULT '0' COMMENT ' 精神I类药品标识：0 - 非选中， 1 - 选中',
  `psy_flag_ii` int DEFAULT '0' COMMENT '精神II类药品标识：0 - 非选中，1 - 选中',
  `otc_flag` int DEFAULT '0' COMMENT 'OTC标识：0 - 非选中， 1 - 选中',
  `nar_flag` int DEFAULT '0' COMMENT '麻醉药品标识：0 - 非选中， 1 - 选中',
  `inventory_upper` int DEFAULT '0' COMMENT '库存上限',
  `inventory_lower` int DEFAULT '0' COMMENT '库存下限',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  `modify_time` datetime DEFAULT NULL COMMENT '修改时间',
  `del_flag` int DEFAULT '0' COMMENT '删除标志:  0 - 未删除, 1 - 已删除',
  `consumable_type` int NOT NULL DEFAULT '0' COMMENT '耗材类型:1-国产,2-进口',
  `tips` varchar(1024) CHARACTER SET utf8 DEFAULT NULL COMMENT '药品使用注意事项',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

-- ----------------------------
-- Records of drug_resource_6
-- ----------------------------
BEGIN;
INSERT INTO `drug_resource_6` VALUES (6, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001182', 'jjsq', '焦建神曲', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1.00g*1g/克', '', 10.0000, '', '', '', 1, 0.0370, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (16, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000662', 'xd', '续断', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1.00g*1g/克', '', 10.0000, '', '', '', 1, 0.1230, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (26, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000300', 'ycxzsqdz', '一次性注射器带针', 'sccj_shkdlqyfzjtgfyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '5ml', '', 0.0000, '', 'ml', '', 1, 0.3100, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (36, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_wy', 'ZKM00000437', 'sys', '双氧水', 'sccj_hbjn', 'H3022648', 3, '', 'bzdw_p', 'zxdw_ml', 500, 'jldw_ml', 1.00, '1.00ml*500ml/瓶', 'ad us.ext', 5.0000, '', '', 'Prn', 1, 10.0800, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 2, 1, NULL, '2018-03-02 17:33:35', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (46, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001905', 'cgjsq', '晨光计算器', 'sccj_amzyc', NULL, 3, '', 'bzdw_t_9258', 'zxdw_t_6854', 1, '', 0.00, '1台/台', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (56, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001848', 'xgHP2612', '硒鼓HP2612', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (66, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000172', 'pyq', '排龈器', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (76, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000165', 'ycxyyt', '一次性牙椅套', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_d', '', 1, '', 0.00, '袋', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (86, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000377', 'ffdyxajfpⅡ（slt）', '复方对乙酰氨基酚片Ⅱ（散利痛）', 'sccj_beyybjyxgs', 'H20056948', 3, '', 'bzdw_h', 'zxdw_p', 10, 'jldw_p', 1.00, '1.00片*10片/盒', 'kf', 1.0000, '', '', 'mr3c', 1, 6.7000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 10, 3, NULL, '2018-05-24 11:14:41', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (96, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001115', 'ycxsyyymq（fk）', '一次性使用医用棉签（妇科）', 'sccj_bjsdeylqxzzyxzrgs', '陕宝食药监械（准）字2014第1640046号', 3, '', 'jjdw_b', '', 1, '', 0.00, '15支*20袋', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (106, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000932', 'dgk', '煅蛤壳', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0130, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (116, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001700', '3Mscbjd 12j/h', '3M丝绸布胶带 12卷/盒', 'sccj_mnsdkyzzyyqc', '-', 3, '', 'jjdw_j', '', 1, '', 0.00, '卷', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (126, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001580', 'ycxsyyydjjcst jxh', '一次性使用医用丁睛检查手套 加小号', 'sccj_jxhssyyxgs		', '-', 3, '', 'jjdw_s', '', 1, '', 0.00, '双', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (136, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_wj', 'ZKM00000077', 'hlsqw', '黄连上清丸', 'sccj_cddajttfyygfyxgs', '国药准字Z51020358', 3, '', 'bzdw_h', 'zxdw_d', 9, 'jldw_g', 6.00, '6.00g*9袋/盒', '', 0.0000, '', '', '', 1, 4.4000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 13:37:26', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (146, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000731', 'yjjyz', '牙胶尖压针', 'sccj_xnddsb', '国食药监械（进）字2013第1551335', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm混', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 10:03:28', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (156, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000111', 'vitapex', 'vitapex', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (166, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001218', 'xce', '雄蚕蛾', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.3360, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (176, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000557', 'cxf', '醋香附', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0780, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:31:23', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (186, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000642', 'cyhsm', '醋延胡索面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.2400, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (196, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001342', 'hz', '海藻', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.1230, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (206, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001329', 'qgcg', '气管插管', 'sccj_gzwl', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '维力带囊7.0mm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (216, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_tjj', 'ZKM00000286', 'zkpctj', '止咳平喘糖浆', 'sccj_scstyzyyxgs', 'z20063043', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 100.00, '100.00ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 19.0300, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-19 11:59:23', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (226, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000879', 'yyc（C+c）', '牙用锉（C+锉）', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm10##6*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (236, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000708', 'chl', '抽葫芦', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0700, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (246, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000646', 'mbq', '蜜白前', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.3000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (256, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001540', 'rmdyz', '热敏打印纸', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_j', '', 1, '', 0.00, '卷', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (266, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001756', 'wssB2p', '维生素B2片', 'sccj_hzyygfyxgs', '国药准字h42020612', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 5.00, '5.00mg*100片/瓶', '', 0.0000, '', '', '', 1, 0.0000, 3.3000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (276, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00001175', 'syyytkyjcsjh（jtjf）', '沙眼衣原体抗原检测试剂盒（胶体金法）', 'sccj_hzab', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '20人份/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (286, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rgj', 'ZKM00001557', 'dndrg', '地奈德乳膏', 'sccj_cqhbzyyxgs', 'H20060725', 3, '', 'bzdw_z', 'zxdw_kg_g', 20, 'jldw_％', 0.05, '0.05％*20g/支', '', 0.0000, '', '', '', 1, 28.0000, 2.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (296, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001048', 'etbyq', '儿童拔牙钳', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '2#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (306, 'bgyplb_jgyplcl', 3, 1, 'bgyplb_jgyplcl', '', 'ZKM00000045', 'cs123', '测试123', 'sccj_amzyc', NULL, 3, '', 'bzdw_b', 'zxdw_kg_g', 123, '', 0.00, '123g/包', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-08-21 17:27:37', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (316, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001833', 'zdmg', '装订铆管', 'sccj_amzyc', NULL, 3, '', 'bzdw_h', 'zxdw_h', 1, '', 0.00, '1盒/盒', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (326, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001351', 'csz', '楮实子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.1120, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (336, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000122', 'ptsg', '普通石膏', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_d', '', 1, '', 0.00, '袋', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (346, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001200', 'rgm', '肉桂面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.6100, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (356, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_njj', 'ZKM00000224', 'lslnj', '磷酸铝凝胶', 'sccj_Boryung Pharmaceutical ', 'h20130422', 3, '', 'bzdw_h', 'zxdw_d', 4, 'jldw_g', 20.00, '20.00g*4袋/盒', '', 0.0000, '', '', '', 1, 19.5000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-25 13:40:43', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (366, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001627', 'dzdyjj06（25#）', '大锥度牙胶尖06（25#）', 'sccj_dsbyk（tj）yxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (376, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001009', 'ggc', '根管锉', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, 'MANIK-FILES6#-25mm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (386, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000102', 'sys', '双氧水', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '500ML', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (396, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000929', 'ggkdz（kdz）', '根管扩大针（扩大针）', 'sccj_mnzshs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm06#6*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (406, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000791', 'yksg', '牙科石膏', 'sccj_hlsgsckyxgs', '国械备20152133号', 3, '', 'jjdw_d', '', 1, '', 0.00, '1.5KG', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (416, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001480', 'C-fydbcdsjh	', 'C-反应蛋白测定试剂盒	', 'sccj_flOrlongs		', '-', 3, '', 'jjdw_f_9562', '', 1, '', 0.00, '份', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (426, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000560', 'xxk', '血型卡', 'sccj_dd', '', 3, '', 'jjdw_zhang', '', 1, '', 0.00, '-', '', 0.0000, '', 'ml', '', 1, 5.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (436, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001469', 'cgshfhxzp	', '常规生化复合校准品	', 'sccj_szmr', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (446, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000484', 'wyaz', '无烟艾柱', 'sccj_nylyacswzpyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '14mm*100mm', '', 0.0000, '', 'ml', '', 1, 8.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (456, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000386', 'bxsyygyq', '便携式医用供氧器', 'sccj_hbhsbhxqtdylqxc', '', 3, '', 'jjdw_t', '', 1, '', 0.00, '4L', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (466, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001081', 'csz', '擦手纸', 'sccj_amzyc', '', 3, '', 'bzdw_x', 'zxdw_b', 20, '', 0.00, '20包/箱', '', 0.0000, '', 'ml', '', 2, 5.9500, 5.9500, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (476, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001096', 'jgscz', '金刚砂车针', 'sccj_w', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'EX-11', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (486, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000616', 'flm', '茯苓面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.1000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (496, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001054', 'jgj', '金冠剪', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '弯头11cm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (506, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000864', 'dcs', '煅磁石', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0300, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (516, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001068', 'blm', '玻璃膜', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 49.0000, 49.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (526, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001270', 'sddtdktwlyyq	', '手动单通道可调微量移液器	', 'sccj_dlxcsyyq（bj）yxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '200-1000μl', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (536, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000306', 'byg', '鼻氧管', 'sccj_hzjlylqxyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, 'BY-11M200支/箱', '', 0.0000, '', 'ml', '', 1, 2.7000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (546, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rgj', 'ZKM00001649', 'ffcsdsmsrg（TX）', '复方醋酸地塞米松乳膏（TX）', 'sccj_hzszbqtyxgs', '1709008H', 3, '', 'bzdw_z', 'zxdw_kg_g', 30, 'jldw_mg', 22.50, '22.50mg*30g/支', '', 0.0000, '', '', '', 1, 0.0000, 12.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (556, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001194', 'ycxzkcxgcgg 	', '一次性真空采血管常规管 	', 'sccj_jskjylqxyxgs', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, '100个/板江苏康捷', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (566, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_gj', 'ZKM00001600', 'mlcbppg', '蜜炼川贝枇杷膏', 'sccj_bjgybkdyfbjzd', 'G21706027', 3, '', 'bzdw_p', 'zxdw_ml', 150, 'jldw_ml', 1.00, '1.00ml*150ml/瓶', '', 0.0000, '', '', '', 1, 28.6000, 28.6000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (576, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001284', 'szz', '生栀子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.1000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (586, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000222', 'mlstnp', '孟鲁司特钠片', 'sccj_scdzzyyxgs', 'h20064370', 3, '', 'bzdw_h', 'zxdw_p', 5, 'jldw_mg', 10.00, '10.00mg*5片/盒', 'ad us.int', 10.0000, '', '', 'qd', 1, 28.9200, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 3, NULL, '2018-05-23 14:04:22', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (596, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000249', '121℃ylzqmjhxzsk', '121℃压力蒸汽灭菌化学指示卡', 'sccj_bjshwsyxcyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '121摄氏度', '', 0.0000, '', 'ml', '', 1, 15.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (606, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001414', 'fhqm1712335', '防护铅帽1712335', 'sccj_szhkylqxyxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '0.50铅当量', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (616, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000700', 'hq', '黄芩', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.2900, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 17:48:23', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (626, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000316', 'csqand zsy', '醋酸曲安奈德 注射液', 'sccj_zjxjzygfyxgs', '国药准字H33020762', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 5.00, '5.00ml*1支/支', '', 0.0000, '', '', '', 1, 5.3000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:06:58', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (636, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001019', 'A5fyz', 'A5复印纸', 'sccj_amzyc', '', 3, '', 'bzdw_h', 'zxdw_b', 10, '', 0.00, '10包/盒', '', 0.0000, '', 'ml', '', 2, 11.4000, 11.4000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (646, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000208', 'etwDgjjp', '儿童维D钙咀嚼片', 'sccj_aszy(zs)yxgs', 'h20150324', 3, '', 'bzdw_h', 'zxdw_b', 1, 'jldw_p', 30.00, '30.00片*1包/盒', '', 0.0000, '', '', '', 1, 38.4700, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-08 08:48:13', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (656, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001230', 'gysmsblp（kl）', '枸橼酸莫沙必利片（快力）', 'sccj_lnbtzyyxgs', 'H19990317', 3, '', 'bzdw_h', 'zxdw_p', 24, 'jldw_mg', 5.00, '5.00mg*24片/盒', 'kfkf', 5.0000, '', '', 'mr3c', 1, 18.4600, 20.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 3, NULL, '2018-05-24 15:19:22', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (666, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000897', 'lz', '灵芝', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.2240, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (676, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000925', 'ymc', '益母草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0280, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (686, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_wj', 'ZKM00001583', 'jgtw', '金刚藤丸', 'sccj_hhzhzyyxgs', '国药准字Z20090650', 3, '', 'bzdw_h', 'zxdw_d', 12, 'jldw_g', 4.00, '4.00g*12袋/盒', '', 0.0000, '', '', '', 1, 46.5200, 46.5200, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (696, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001653', 'cwn', '常卫宁', 'sccj_hznhjkkjyxgs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (706, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000708', 'ljtz', '蓝胶套装', 'sccj_hzxhswclyxgs', '--', 3, '', 'jjdw_h', '', 1, '', 0.00, '--', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (716, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000552', 'yhl', '萸黄连', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.5400, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (726, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000641', 'SSWdscz', 'SSW低速车针', 'sccj_SSW.WHITE BURS.IN', '--', 3, '', 'jjdw_z', '', 1, '', 0.00, 'RA-34', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (736, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001334', 'cswhxrq', '超声雾化吸入器', 'sccj_gdyh', '-', 3, '', 'jjdw_t_148', '', 1, '', 0.00, '超声压缩式雾化器CN-100', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (746, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001237', 'cx', '沉香', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 21.8400, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (756, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000022', 'ltg', '蓝头管', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (766, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00000844', 'zkgz', '质控高值', 'sccj_w', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '3ml*6瓶/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (776, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dyj', 'ZKM00001580', 'tbmsdyy', '妥布霉素滴眼液', 'sccj_S.A.ALCON-COUVREUR N.V', 'H20140811', 3, '', 'bzdw_h', 'zxdw_z', 1, 'jldw_ml', 5.00, '5.00ml*1支/盒', '', 0.0000, '', '', '', 1, 15.6800, 15.6800, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (786, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001139', 'demyPIMdgwdzsgjmg', '第二磨牙PIM单管网底直丝弓夹面管', 'sccj_hzxyckclyxgs', '浙食药监械（准）字2014第2630177号', 3, '', 'jjdw_d', '', 1, '', 0.00, '62BS-20J-37(20*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-04 16:55:04', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (796, 'hclb_gzyhp', 2, 1, 'hclb_gzyhp', '', 'ZKW00001436', 'sgzdq', '石膏振荡器', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (806, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00000776', 'hszkcxg', '黄色真空采血管', 'sccj_bdylqx（sh）yxgs', '7247526', 3, '', 'jjdw_z', '', 1, '', 0.00, '5.0ml13*100mm', '', 0.0000, '', 'ml', '', 1, 1.2000, 1.2000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (816, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000079', 'shj', '失活剂', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '快', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2017-09-12 16:32:41', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (826, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000090', 'lltdp（yf）', '氯雷他定片（亿菲）', 'sccj_cdhrzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_p', 10, 'jldw_mg', 10.00, '10mg*10片/盒', '', 0.0000, '', '', '', 1, 4.8000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-13 14:49:10', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (836, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000049', 'dzy', '电针仪', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (846, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000563', 'fccs', '麸炒苍术', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.4200, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:32:03', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (856, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00001549', 'yqkzjn（sprn）', '伊曲康唑胶囊（斯皮仁诺）', 'sccj_xayszyyxgs', 'H20020367', 3, '', 'bzdw_h', 'zxdw_l', 14, 'jldw_g', 0.10, '0.10g*14粒/盒', 'kf', 0.2000, '', '', 'mr1c', 1, 129.4200, 2.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 14:23:56', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (866, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001361', 'yyqxz', '移液器吸嘴', 'sccj_dlxcsyyq（bj）yxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '200μl(96支/盒）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (876, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_cj', 'ZKM00000098', 'gwssp', '谷维生素片', 'sccj_adyy(bj)yxgs', '', 3, '', 'bzdw_h', 'zxdw_l', 60, 'jldw_mg', 100.00, '100.00mg*60粒/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (886, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_fsp', 'ZKM00001897', 'lhmsfsp', '罗红霉素分散片', 'sccj_lzjtlzzyc', '', 3, '', 'bzdw_h', 'zxdw_p', 12, 'jldw_mg', 50.00, '50mg*12片/盒', '', 0.0000, '', '', '', 1, 0.0000, 14.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (896, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00001677', 'pttzsy50%', '葡萄糖注射液50%', 'sccj_gyjtrszyyxgs', 'H41020039', 3, '', 'bzdw_h', 'zxdw_z', 5, 'jldw_ml', 20.00, '20.00ml*5支/盒', '', 0.0000, '', '', '', 2, 0.0000, 0.4200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-22 10:51:32', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (906, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000563', 'ycxkeq', '一次性窥耳器', 'sccj_wlylsb（sz）yxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '52432-U', '', 0.0000, '', 'ml', '', 1, 1.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-03-15 09:27:33', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (916, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000992', 'ygjt', '牙根尖挺', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '六角空心柄装配式HS1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (926, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00000845', 'xcgxzp', '血常规校准品', 'sccj_w', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '3ml/2支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (936, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00000457', 'nxmfdzzkp（yc）', '凝血酶非定值质控品（异常）', 'sccj_shtyswjsyxgs', '', 3, '', 'jjdw_f_9562', '', 1, '', 0.00, '10*10ml', '', 0.0000, '', 'ml', '', 1, 39.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-10 23:10:44', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (946, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000751', 'qwb', '铅围脖', 'sccj_sdslylqxyxgs', '鲁烟械备20160050', 3, '', 'jjdw_t_7475', '', 1, '', 0.00, 'M', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (956, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001169', 'tc', '通草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 1.0080, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (966, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001706', 'glmnp（yml）', '格列美脲片（亚莫利）', 'sccj_snf（bj）zyyxgs', 'H20057672', 3, '', 'bzdw_h', 'zxdw_p', 15, 'jldw_mg', 2.00, '2.00mg*15片/盒', 'kf', 0.0000, '', '', '', 1, 0.0000, 66.8000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 6, 2, NULL, '2018-05-23 14:46:30', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (976, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_klj', 'ZKM00000146', 'sjwtkl', '三九胃泰颗粒', 'sccj_hrsjyygfyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 10, 'jldw_g', 20.00, '20.00g*10袋/盒', '', 0.0000, '', '', '', 1, 17.5000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-03-22 14:17:30', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (986, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001036', 'crbyq', '成人拔牙钳', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '1#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (996, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000555', 'ycxtx', '一次性拖鞋', 'sccj_jc', '', 3, '', 'jjdw_s', '', 1, '', 0.00, '10双/包', '', 0.0000, '', 'ml', '', 1, 2.9900, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-03-08 17:33:35', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1006, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000948', 'wzzstjq（jszsq）', '无针注射推进器（金属注射器）', 'sccj_shkqylqxyxgs', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '钩头', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1016, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001287', 'bg', '白果', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0670, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1026, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000163', 'ycxwj', '一次性围巾', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1036, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001671', 'cscjkg', '超声采集开关', 'sccj_amzyc', NULL, 3, '', 'bzdw_t_9258', 'zxdw_t_6854', 1, '', 0.00, '1台/台', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1046, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001352', 'dzjsq', '电子计时器', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 15.8000, 15.8000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1056, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001155', 'ycxsyqchyb', '一次性使用清创换药包', 'sccj_yzsyaylqxyxgs', '苏械注准20152640568', 3, '', 'jjdw_b', '', 1, '', 0.00, '袋', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1066, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001181', 'rs-jmsrsy', '瑞氏-姬姆萨染色液', 'sccj_zhbsswjsyxgs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, 'BA-40174*250ml', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1076, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000754', 'ljj', '鹿角胶', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 21.0000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1086, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001253', 'fhwb1712603	', '防护围脖1712603	', 'sccj_szhkylqxyxgs		', '-', 3, '', 'jjdw_t_7475', '', 1, '', 0.00, '0.50铅当量', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1096, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000887', 'jqc', '金钱草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0560, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1106, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsjn', 'ZKM00001664', 'kfbyy（I）', '口服补液盐（I）', 'sccj_fzhwfyzyyxgs', '1605350', 3, '', 'bzdw_h', 'zxdw_d', 20, 'jldw_g', 14.75, '14.75g*20袋/盒', '', 0.0000, '', '', '', 2, 0.0000, 0.7900, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1116, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000521', 'ycxyycd', '一次性医用床单', 'sccj_cf', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '100*200cm', '', 0.0000, '', 'ml', '', 1, 15.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1126, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001558', 'ysb', '压舌板', 'sccj_ssdt', '-', 3, '', 'jjdw_g', '', 1, '', 0.00, '根', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1136, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_klj', 'ZKM00000123', 'wxkl', '稳心颗粒', 'sccj_sdbczygfyxgs', '国药准字z10950026', 3, '', 'bzdw_h', 'zxdw_d', 9, 'jldw_g', 9.00, '9.00g*9袋/盒', '', 0.0000, '', '', '', 1, 24.0200, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:50:24', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1146, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000643', 'ff', '防风', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 1.1200, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1156, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000152', 'ysbhsp', '盐酸苯海索片', 'sccj_hnznzyyxzrgs', '国药准字', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 2.00, '2.00mg*100片/瓶', '', 0.0000, '', '', '', 1, 28.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:09:11', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1166, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000919', 'sgtd', '石膏调刀', 'sccj_shkqylqxyxgs', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '#1R', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1176, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001324', 'hlxdjndcsz', '含氯消毒剂浓度测试纸', 'sccj_bjsh', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '20本/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1186, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001499', 'hxMh', '护膝M号', 'sccj_3M', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1196, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000619', 'sd', '柿蒂', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.2250, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-03-07 14:06:27', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1206, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001266', 'bbzyx	', '标本转运箱	', 'sccj_cdtk		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '46L带温显', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1216, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001644', 'ohjwj', '耦合剂无菌', 'sccj_w', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1226, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001207', '10mlzsq	', '10ml注射器	', 'sccj_jxhd		', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '100支/包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1236, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001212', 'ycxwjmscxz	', '一次性无菌末梢采血针	', 'sccj_ak', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '25支/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1246, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001538', 'zdjt', '装订夹条', 'sccj_amzyc', NULL, 3, '', 'bzdw_h', 'zxdw_h', 1, '', 0.00, '1盒/盒', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1256, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001045', 'crbyq', '成人拔牙钳', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '222#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1266, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000166', 'ykj', '眼科剪', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '直/弯', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1276, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000610', 'hdy', '黑豆衣', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0600, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1286, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001427', 'byq/crbyq', '拔牙钳/成人拔牙钳', 'sccj_shkqckyxc		', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '222#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1296, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001006', 'bh', '百合', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.2240, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1306, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000204', 'xstfsp', '缬沙坦分散片', 'sccj_hnhlzygfyxgs', '', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_mg', 80.00, '80mg*7片/盒', '', 0.0000, '', '', '', 1, 12.6700, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 11:00:15', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1316, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000903', 'csjyjgzj（ggdxz）', '超声洁牙机工作尖（根管荡洗针）', 'sccj_w', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '30#蓝6*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1326, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000735', 'cs', '蚕沙', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0290, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1336, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_kfy', 'ZKM00000210', 'pttsgxkfry', '葡萄糖酸钙锌口服溶液', 'sccj_hbwsyygfyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 18, 'jldw_ml', 10.00, '10ml*18支/盒', '', 0.0000, '', '', '', 1, 33.3000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 14:31:02', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1346, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001333', 'ymz', '亚麻子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0560, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1356, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000827', 'ddh', '代代花', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.6720, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1366, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001263', 'zlt', '棕榈炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0570, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1376, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000810', 'amkQtcksgj', '奥美科Q托槽开锁工具', 'sccj_mg Ormco Corporation', '国械备20160817号', 3, '', 'jjdw_f_3720', '', 1, '', 0.00, '866-4014', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1386, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000480', 'yswlpmzsy', '盐酸维拉帕米注射液', 'sccj_shhfzyyxgs', 'H31021343', 3, '', 'bzdw_z', 'zxdw_ml', 2, 'jldw_mg', 5.00, '5.00mg*2ml/支', 'Iv', 0.0000, '', '', '', 1, 9.8000, 13.7200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, NULL, '2018-05-04 16:43:52', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1396, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001377', 'cbmf', '川贝母粉', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 2, 'jldw_g', 2.00, '2g/包', '', 2.0000, '', '', '', 1, 28.0000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1406, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_rg', 'ZKM00000158', 'srssg', '湿润烧伤膏', 'sccj_stsmbzyyxgs', '', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 20.00, '20.00g*1支/支', '', 0.0000, '', '', '', 1, 36.8000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-18 16:19:14', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1416, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000038', 'crdzxyj', '成人电子血压计', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1426, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_gj', 'ZKM00000443', 'hmsyg', '红霉素眼膏', 'sccj_bjsjzyyxgs', 'H11021270', 3, '', 'bzdw_h', 'zxdw_h', 1, 'jldw_g', 2.50, '2.50g*1盒/盒', 'ad us.ext', 0.0000, '', '', 'Qn', 1, 3.6500, 5.1100, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, NULL, '2018-04-19 11:54:12', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1436, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000164', 'xbdpp', '硝苯地平片', 'sccj_hzyygfyxgs', '国药准字h42020385', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 10.00, '10.00mg*100片/瓶', '', 0.0000, '', '', '', 1, 0.9000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:10:33', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1446, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001531', 'dyzA4', '打印纸A4', 'sccj_amzyc', NULL, 3, '', 'bzdw_b', 'zxdw_p', 8, '', 0.00, '8片/包', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-08-27 15:24:55', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1456, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001284', 'ycxyywfbkz', '一次性医用无纺布口罩', 'sccj_jxym		', '-', 3, '', 'jjdw_b', '', 1, '', 0.00, '三层带鼻架100个/包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1466, 'bgyplb_yyzflcl', 3, 1, 'bgyplb_yyzflcl', '', 'ZKM00001503', 'nysbdy（Lm）', '女医生白大衣（L码）', 'sccj_amzyc', NULL, 3, '', 'bzdw_j_4203', 'zxdw_j_2903', 1, '', 0.00, '1件/件', '', 0.0000, '', 'ml', '', 2, 130.0000, 130.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1476, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001352', 'wjcwq', '无菌持物钳', 'sccj_shjz', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '25cm，直10mmJ34080', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1486, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001205', 'hqm', '黄芪面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1750, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1496, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00001559', 'zjrtmx bs nm', '针灸人体模型 白色 男模', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1506, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rgj', 'ZKM00001617', 'yszrg', '鱼石脂软膏', 'sccj_gdhjzyyxgs', '170909', 3, '', 'bzdw_h', 'zxdw_kg_g', 20, 'jldw_％', 10.00, '10.00％*20g/盒', '', 0.0000, '', '', '', 1, 0.0000, 8.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1516, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000870', 'hzm', '黑芝麻', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0840, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 10:56:21', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1526, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000995', 'ycxsyyktyb', '一次性使用牙科涂药棒', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, 'M6500F', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1536, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000761', 'tbz', '土鳖子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0310, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1546, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001398', '50%pttzsy（slzz）', '50%葡萄糖注射液（塑料支装）', 'sccj_hbkl', 'z42021188', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 20.00, '20.00ml*1支/支', '', 0.0000, '', '', '', 1, 1.1400, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 16:00:29', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1556, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001070', 'ldsz', '流动树脂', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '7032A3', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1566, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000407', 'bztjnycrjn', '标准桃金娘油肠溶胶囊', 'sccj_dgbsjdyc', '', 3, '', 'bzdw_h', 'zxdw_l', 10, 'jldw_g', 0.30, '0.30g*10粒/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 1, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1576, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000186', 'amlzcrjn', '奥美拉唑肠溶胶囊', 'sccj_jsfbyyyxgs', '', 3, '', 'bzdw_p', 'zxdw_l', 28, 'jldw_mg', 20.00, '20mg*28粒/瓶', '', 0.0000, '', '', '', 1, 4.5000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 11:07:31', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1586, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000559', 'kD10mlxxdxsj', '抗D10ml血型定型试剂', 'sccj_gMillipo', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '10ml', '', 0.0000, '', 'ml', '', 1, 260.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1596, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001688', 'jgscz', '金刚砂车针', 'sccj_gzbysghzygfyxgs', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, '板', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1606, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001229', 'yxz', '叶下珠', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0600, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1616, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000602', 'sjs', '桑寄生', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0450, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:39:45', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1626, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_wj', 'ZKM00000103', 'txlfw', '通宣理肺丸', 'sccj_tjjtcqzyecyxgs', 'z50020598', 3, '', 'bzdw_h', 'zxdw_b_7638', 2, 'jldw_w', 32.00, '32.00丸*2板/盒', '', 0.0000, '', '', '', 1, 4.8200, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 16:02:55', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1636, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000800', 'gjc', '谷精草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.4370, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1646, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001471', 'shfhdzzkp	', '生化复合定值质控品	', 'sccj_szmr', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1656, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_klj', 'ZKM00001685', 'ysklmszlszkl（kes）', '盐酸克林霉素棕榈酸酯颗粒（可尔生）', 'sccj_bjbdyyyxgs', 'H9990265', 3, '', 'bzdw_h', 'zxdw_d', 12, 'jldw_g', 2.00, '2.00g*12袋/盒', 'kf', 3.0000, '', '', 'mr3c', 1, 0.0000, 24.7200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 10:10:51', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1666, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000683', 'shq', '生黄芪', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.2630, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 17:50:13', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1676, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000127', 'bsb', '比色板', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '29色', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1686, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001457', 'rgaxzym（r-GT）cdsjh	', 'r谷氨酰转移酶（r-GT）测定试剂盒	', 'sccj_szmr', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1696, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001032', 'hsstjhb', '黑色双头记号笔', 'sccj_amzyc', '', 3, '', 'bzdw_h', 'zxdw_z', 12, '', 0.00, '12支/盒', '', 0.0000, '', 'ml', '', 2, 1.2500, 1.2500, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-03-01 09:26:13', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1706, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_wy', 'ZKM00001590', 'hxbhy', '和兴白花油', 'sccj_shyyjtqdgfyy', 'PGEBH010', 3, '', 'bzdw_p', 'zxdw_ml', 10, 'jldw_dw', 1.00, '1.00单位*10ml/瓶', '', 0.0000, '', '', '', 1, 19.8000, 19.8000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1716, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_wj', 'ZKM00000100', 'xsyww（nsx）', '香砂养胃丸（浓缩型）', 'sccj_zjwxzygfyxgs', 'z41021829', 3, '', 'bzdw_h', 'zxdw_l', 1, 'jldw_w', 200.00, '200.00丸*1粒/盒', '', 0.0000, '', '', '', 1, 14.9000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 16:05:11', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1726, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000389', 'aedpfxdj（shaed））', '安尔碘皮肤消毒剂（上海安尔碘））', 'sccj_shlkxdgkjyxgs', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '60ML100瓶/箱', '', 0.0000, '', 'ml', '', 1, 4.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 13:35:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1736, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000347', 'lxg', '离心管', 'sccj_jskdylypyxgs', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '0.5ml1000只/包', '', 0.0000, '', 'ml', '', 1, 20.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1746, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000620', 'ssdp', '手术刀片', 'sccj_shlhylypyxgs', '沪食药监械准字2014第2011126', 3, '', 'jjdw_b', '', 1, '', 0.00, '12#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1756, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001549', 'zlp wg', '治疗盘 无盖', 'sccj_gdhx ', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1766, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001264', 'lqh	', '利器盒	', 'sccj_bjkylsmyxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '1L圆形', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1776, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000070', 'wssK1zsy', '维生素K1注射液', 'sccj_scyygfyxgs(ytjyyjtxzgfyxgs)', '', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_mg', 10.00, '10mg*10支/盒', '', 0.0000, '', '', '', 1, 40.5000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 11:24:15', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1786, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001441', 'tbdcbzly', '特宝电磁波治疗仪', 'sccj_cqxh', '-', 3, '', 'jjdw_b', '', 1, '', 0.00, '包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1796, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001567', 'sb', '烧杯', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1806, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001790', 'bxmlp（ets）', '苯溴马隆平（尔同舒）', 'sccj_ycdygcjyygfyxgs', 'H20040348', 3, '', 'bzdw_h', 'zxdw_p', 10, 'jldw_mg', 50.00, '50.00mg*10片/盒', 'kf', 50.0000, '', '', 'mr1c', 1, 0.0000, 20.3600, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1816, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000693', 'ntysg', '镍钛圆丝弓', 'sccj_shamdclljgfyxgs', '沪械注准20162630198', 3, '', 'jjdw_d', '', 1, '', 0.00, '卵圆18U', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 09:36:36', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1826, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001661', 'nszt11G', '尿试纸条11G', 'sccj_glyltyldzyxgs', '2400111', 3, '', 'jjdw_t_5432', '', 1, '', 0.00, '桶', '', 0.0000, '', 'ml', '', 1, 0.0000, 220.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1836, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00000529', 'gmsjwyp', '高锰酸钾外用片', 'sccj_jnkfszyyxgs_2176', 'H37022233', 3, '', 'bzdw_h', 'zxdw_p', 48, 'jldw_g', 0.10, '0.10g*48片/盒', 'ad us.ext', 0.1000, '', '', 'Once', 1, 34.6000, 41.5200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 5, 2, NULL, '2018-05-04 10:06:24', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1846, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001515', 'rtjlxwgt', '人体经络穴位挂图', 'sccj_shxxswsb		', '-', 3, '', 'jjdw_zhang', '', 1, '', 0.00, '张', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1856, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_tjj', 'ZKM00000270', 'jztj', '急支糖浆', 'sccj_tjjtzjdfzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 200.00, '200ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 15.4000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-18 15:34:42', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1866, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001282', 'fbx', '粉萆薢', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0360, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1876, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001381', 'fhxhmj', '防化学护目镜', 'sccj_3M', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '3M', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1886, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001437', 'mlstnjjp（sen）', '孟鲁司特钠咀嚼片（顺尔宁）', 'sccj_hzmsdzyyxgs', '国药准字J20130054', 3, '', 'bzdw_h', 'zxdw_p', 5, 'jldw_mg', 5.00, '5.00mg*5片/盒', 'kf', 5.0000, '', '', 'mr1c', 1, 34.2400, 47.9000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 11:11:05', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1896, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000415', 'ycxqgcgb', '一次性气管插管包', 'sccj_hnsjqylqxyxgs', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '普通', '', 0.0000, '', 'ml', '', 1, 50.4000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 15:12:54', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1906, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000018', 'dgxbb', '带盖小便杯', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1916, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001410', 'gsm', '肝素帽', 'sccj_whjr', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '50个/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1926, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001695', 'yyj 10cmwj', '眼用剪 10cm弯尖', 'sccj_shjz', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '把', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1936, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000359', 'csx（bzx）dz', '蚕丝线（编织型）带针', 'sccj_hzhwylypyxgs', '20161011520161000', 3, '', 'jjdw_b', '', 1, '', 0.00, '5-070cm。1/24x10单针', '', 0.0000, '', 'ml', '', 1, 4.4000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-15 14:40:47', 1, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1946, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000895', 'jl', '橘络', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 1.0800, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 11:11:23', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1956, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000520', 'slhyxhmpw', '施乐辉隐形护膜喷雾', 'sccj_sl', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '500ml/瓶', '', 0.0000, '', 'ml', '', 1, 43.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1966, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001376', 'wkqxrhj(qxx)', '外科器械润滑剂(强效型)', 'sccj_mnsdkyzzyyqc', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '70600+(5L/瓶,2瓶/箱)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1976, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001104', 'jgscz', '金刚砂车针', 'sccj_w', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'F0-25', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-29 17:30:13', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1986, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001714', 'lssdacp', '硫酸沙丁胺醇片', 'sccj_jsybapsyy', 'H32024535', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 2.00, '2.00mg*100片/瓶', 'kf', 4.0000, '', '', 'mr3c', 1, 0.0000, 8.3000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 10:17:29', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (1996, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_cj', 'ZKM00000292', 'ksl', '开塞露', 'sccj_zhgjxcgfyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_ml', 20.00, '20.00ml*10支/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2006, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001086', 'ggc', '根管锉', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, 'MANIK-FILES10#-21mm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2016, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000672', 'tdh', '土大黄', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0340, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2026, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000030', 'ycxxtg', '一次性吸痰管', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2036, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001692', 'tlbd7.5cm*450cm', '弹力绷带7.5cm*450cm', 'sccj_qdjk', '', 3, '', 'jjdw_j', '', 1, '', 0.00, '卷', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2046, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000936', 'yjj（jz）', '牙胶尖（简装）', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '20#100*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2056, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001060', 'xp', '橡皮', 'sccj_amzyc', '', 3, '', 'bzdw_h', 'zxdw_k_8177', 30, '', 0.00, '30块/盒', '', 0.0000, '', 'ml', '', 2, 0.5000, 0.5000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2066, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000380', 'ffyswmhjhsjn（xktk）', '复方盐酸伪麻黄碱缓释胶囊（新康泰克）', 'sccj_zmtjskzyyxgs', 'H20010430', 3, '', 'bzdw_h', 'zxdw_l', 8, 'jldw_l', 1.00, '1.00粒*8粒/盒', 'kf', 1.0000, '', '', 'm12xsyc', 1, 7.7800, 10.8900, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 3, NULL, '2018-05-24 11:20:06', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2076, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001392', 'ygxfp', '有盖小方盘', 'sccj_gdscaxczysylqxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '200*11*45', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2086, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001553', 'ycxfyylq', '一次性负压引流器', 'sccj_ssdt', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2096, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001114', 'dfz', '地肤子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1060, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2106, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001065', 'snx', '收纳箱', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 53.0000, 53.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2116, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001008', 'bbjc', '北败酱草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0500, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2126, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000948', 'dbhss', '煅北寒水石', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0480, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2136, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000557', 'kAkBxxdxsj（dklkt）', '抗A抗B血型定型试剂（单克隆抗体）', 'sccj_shxyswyyyxzrgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '2*10ml', '', 0.0000, '', 'ml', '', 1, 99.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2146, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_klj', 'ZKM00000141', 'wskl', '胃苏颗粒', 'sccj_yzjyyjtjszygfyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 9, 'jldw_g', 5.00, '5g*9袋/盒', '', 0.0000, '', '', '', 1, 22.1000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 13:44:06', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2156, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001523', 'ycxsyyydjjcst', '一次性使用医用丁腈检查手套', 'sccj_jxhssyyxgs		', '-', 3, '', 'jjdw_s', '', 1, '', 0.00, '双', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2166, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000890', 'bxp', '白鲜皮', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.7280, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2176, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_wj', 'ZKM00000119', 'jksqw（smw）', '金匮肾气丸（水蜜丸）', 'sccj_ydzyjtgfyxgs', 'z13020712', 3, '', 'bzdw_h', 'zxdw_d', 10, 'jldw_g', 5.00, '5.00g*10袋/盒', '', 0.0000, '', '', '', 1, 6.9800, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 17:03:18', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2186, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hjp', 'ZKM00001772', 'xy（cs）', '西药（测试）', 'sccj_sccj（cs）', 'GB0002', 3, 'YJ002', 'bzdw_x', 'zxdw_h', 10, 'jldw_b', 2.00, '2.00包*10盒/箱', 'cqkf', 1.0000, '', '', 'ljzx', 1, 0.0000, 55.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-06-28 19:00:03', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2196, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001572', 'wsxcjz', '魏氏血沉架子', 'sccj_w', '-', 3, '', 'jjdw_t_148', '', 1, '', 0.00, '台', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2206, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rj', 'ZKM00001873', 'fxlwp（hzwk）', '泛昔洛韦片（海正伟克）', 'sccj_zhztzyyxgs', 'H199991379', 3, '', 'bzdw_h', 'zxdw_p', 6, 'jldw_g', 0.13, '0.125g*6片/盒', '', 0.0000, '', '', '', 1, 0.0000, 7.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2216, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000599', 'Kc', 'K锉', 'sccj_xnddsb', '国食药监械进字2013第1062073', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm-15-40混', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2226, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000524', 'ybxyj', '圆表血压计', 'sccj_yy', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '-', '', 0.0000, '', 'ml', '', 1, 50.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2236, 'bgyplb_ycxcl', 3, 1, 'bgyplb_ycxcl', '', 'ZKM00001495', 'kfb（240ml）', '咖啡杯（240ml）', 'sccj_amzyc', NULL, 3, '', 'bzdw_b', 'zxdw_g', 100, '', 0.00, '100个/提', '', 0.0000, '', 'ml', '', 2, 0.5400, 0.5400, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-04-23 13:56:43', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2246, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000911', 'pjh', '片姜黄', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0950, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2256, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_jnj', 'ZKM00000044', 'amxl', '阿莫西林', 'sccj_adyy(bj)yxgs', '', 3, '', 'bzdw_h', 'zxdw_l', 24, 'jldw_g', 0.25, '0.25g*24粒/盒', 'PO', 0.0000, '', '', 'pc', 1, 15.0000, 20.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 200, 20, NULL, '2017-09-05 09:13:03', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2266, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000424', 'ewj', '耳温计', 'sccj_ksrygdyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, 'TH839S', '', 0.0000, '', 'ml', '', 1, 225.0000, 0.0000, 'fylb_tjf', 'fpxm_tjf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2276, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsp', 'ZKM00000039', 'xmde', '西模单二', 'sccj_hrsj', '', 3, '', 'bzdw_b', 'zxdw_z', 10, 'jldw_g', 15.00, '15.00g*10支/包', '', 0.0000, '', '', '', 1, 0.0000, 10.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2286, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000335', 'wssB12zsy', '维生素B12注射液', 'sccj_tjjyjthbtyyygfyxgs', 'H12020387', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 1.00, '1.00ml*1支/支', 'IM', 1.0000, '', '', 'qd', 1, 1.9000, 2.6600, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 100, 10, NULL, '2018-04-19 13:14:08', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2296, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001832', 'slzdfm', '塑料装订封面', 'sccj_amzyc', NULL, 3, '', 'bzdw_h', 'zxdw_h', 1, '', 0.00, '1盒/盒', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2306, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001102', 'jgscz', '金刚砂车针', 'sccj_w', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'TR-13EF', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2316, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001039', 'smj', '双面胶', 'sccj_amzyc', '', 3, '', 'bzdw_t_2442', 'zxdw_g', 32, '', 0.00, '32个/桶', '', 0.0000, '', 'ml', '', 2, 0.6800, 0.6800, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2326, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001505', 'cs', '车石', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2336, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00000537', 'lssshjp（my）', '络酸羧酸活菌片（米雅）', 'sccj_rbmyszyzshs', 'S20140080', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_p', 1.00, '1.00片*20片/盒', '', 0.0000, '', '', '', 1, 65.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 1, 0, 10, 4, NULL, '2018-02-11 14:42:18', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2346, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000642', 'SSWdscz', 'SSW低速车针', 'sccj_SSW.WHITE BURS.IN', '--', 3, '', 'jjdw_z', '', 1, '', 0.00, 'RA-701', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2356, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000712', 'amk qyxpq', '奥美科 牵引橡皮圈', 'sccj_mg Ormco Corporation', '--', 3, '', 'jjdw_d', '', 1, '', 0.00, '1/4 3.5 0Z', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-04-08 13:03:22', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2366, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000098', 'EDTA', 'EDTA', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '7*2', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2376, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001195', 'ycxzkcxggzg ', '一次性真空采血管干燥管 ', 'sccj_jskjylqxyxgs', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, '100个/板江苏康捷', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2386, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000780', 'csl', '醋三棱', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.1340, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2396, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001727', 'ysmxsxp（bfl）', '盐酸莫西沙星片（拜复乐）', 'sccj_beyyyxgs', 'J20150015', 3, '', 'bzdw_h', 'zxdw_p', 3, 'jldw_g', 0.40, '0.40g*3片/盒', 'kf', 0.4000, '', '', 'mr1c', 1, 0.0000, 86.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 14:53:55', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2406, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001162', 'bx', '萹蓄', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0300, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2416, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hj', 'ZKM00000469', 'pdlxykfy', '蒲地蓝消炎口服液', 'sccj_jcyyjtyxgs', 'Z20030095', 3, '', 'bzdw_h', 'zxdw_z', 12, 'jldw_ml', 10.00, '10.00ml*12支/盒', 'kf', 10.0000, '', '', 'mr3c', 1, 44.5800, 2.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 2, NULL, '2018-05-24 11:05:53', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2426, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000440', 'kflssshjp', '口服酪酸梭酸活菌片', 'sccj_rbmyszyzshs', 'S20140080', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_p', 1.00, '1.00片*20片/盒', 'ad us.int', 2.0000, '', '', 'TID', 1, 65.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 10, 3, NULL, '2018-03-01 13:45:22', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2436, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001148', 'nthjygs', '镍钛合金牙弓丝', 'sccj_shamdclljgfyxgs', '沪械注准20162630198', 3, '', 'jjdw_d', '', 1, '', 0.00, '卵圆12U', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2446, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00001578', 'zzrgrsa2bydptjn', '重组人干扰素a2b阴道泡腾胶囊', 'sccj_shhxswgjsyxgs', '国药准字s20050075', 3, '', 'bzdw_h', 'zxdw_l', 4, 'jldw_wdw', 80.00, '80.00万单位*4粒/盒', '', 0.0000, '', '', '', 1, 60.0000, 60.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2456, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000971', 'ahjmxsxdy', '爱护佳免洗手消毒液', 'sccj_3M', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '500ml/瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2466, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000021', 'ltg（gsl）', '绿头管（肝素锂）', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2476, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001067', 'fhmd', '防滑门垫', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 168.0000, 168.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2486, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001422', 'ryljd', '日用垃圾袋', 'sccj_bjkylsmyxgs		', '-', 3, '', 'jjdw_k', '', 1, '', 0.00, '30L60*80*1.5S', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2496, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_klj', 'ZKM00000360', 'sjgmlkl', '三九感冒灵颗粒', 'sccj_hrsj', '国药准字Z44021940', 3, '', 'bzdw_h', 'zxdw_d', 9, 'jldw_g', 10.00, '10.00g*9袋/盒', '', 0.0000, '', '', '', 1, 10.3000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-19 11:37:13', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2506, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000930', 'ggkdz（kdz）', '根管扩大针（扩大针）', 'sccj_mnzshs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm08#6*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 16:15:07', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2516, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001074', 'ycxCPRpzxdmm', '一次性CPR屏障消毒面膜', 'sccj_amzyc', '', 3, '', 'bzdw_h', 'zxdw_h', 1, '', 0.00, '1盒/盒', '', 0.0000, '', 'ml', '', 2, 70.0000, 70.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2526, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000542', 'lssjhjp', '酪酸梭菌活菌片', 'sccj_rbmylszyzshs_491', 'S20140080', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_CFU', 0.35, '0.35CFU*20片/盒', '', 0.0000, '', '', '', 1, 65.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 10, 2, NULL, '2018-02-24 09:15:16', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2536, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tj', 'ZKM00001591', 'lxyct', '乐行晕车贴', 'sccj_hnekxyzyyxgs', '20170821', 3, '', 'bzdw_h', 'zxdw_t', 6, 'jldw_t', 1.00, '1.00贴*6贴/盒', '', 0.0000, '', '', '', 1, 22.5000, 22.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2546, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001438', 'asamlzmcrp（nx）', '艾司奥美拉唑镁肠溶片（耐信）', 'sccj_aslkzyyxgs', '国药准字H20046380', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_mg', 40.00, '40.00mg*7片/盒', 'kf', 40.0000, '', '', 'mr1c', 1, 105.0000, 147.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 15:30:06', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2556, 'bgyplb_ycxcl', 3, 1, 'bgyplb_ycxcl', '', 'ZKM00001841', 'bst tb', '白砂糖 糖包', 'sccj_amzyc', NULL, 3, '', 'bzdw_d', 'zxdw_d', 1, '', 0.00, '1袋/袋', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-19 10:26:48', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2566, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_njj', 'ZKM00001807', 'adplnj', '阿达帕林凝胶', 'sccj_hnqxzyyxgs', 'H20066621', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 15.00, '15.00g*1支/支', '', 0.0000, '', '', '', 1, 0.0000, 13.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2576, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000685', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'WR-13C(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2586, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000209', '3Mtxmrkjd', '3M弹性棉柔宽胶带', 'sccj_3Mzg', '', 3, '', 'jjdw_j', '', 1, '', 0.00, '2.5cm*5m', '', 0.0000, '', 'ml', '', 1, 36.5000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2596, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001795', 'yszyfsxp', '盐酸左氧氟沙星片', 'sccj_gdbdyyyxgs', 'H199900053', 3, '', 'bzdw_h', 'zxdw_p', 6, 'jldw_g', 0.10, '0.10g*6片/盒', '', 0.0000, '', '', '', 1, 0.0000, 1.3000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2606, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001261', 'yyzzx	', '医用周转箱	', 'sccj_bjkylsmyxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '60L黄色', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2616, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000107', 'gchj AH', '根充糊剂 AH', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2626, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000649', 'Kc', 'K锉', 'sccj_xnddsb', '国械备20150214', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm-35', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 09:26:40', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2636, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000250', '132℃ylzqmjhxzsk', '132℃压力蒸汽灭菌化学指示卡', 'sccj_bjshwsyxcyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '132摄氏度200片/盒', '', 0.0000, '', 'ml', '', 1, 40.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2646, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001238', 'sqh', '三七花', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 1.8370, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2656, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00001757', 'ysajpttjn', '盐酸氨基葡萄糖胶囊', 'sccj_amzy', 'hc20140008', 3, '', 'bzdw_h', 'zxdw_l', 30, 'jldw_g', 0.75, '0.75g*30粒/盒', '', 0.0000, '', '', '', 1, 0.0000, 54.4000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2666, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001000', 'glp', '瓜蒌皮', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0870, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2676, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000864', 'gzjyggqx（jyPz-32h）', '钢质机用根管器械（机用P钻-32混）', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '32mm1-6#6*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2686, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00001763', 'ffxhmjn（dj）', '复方消化酶胶囊（达吉）', 'sccj_hgSKhgzshs', 'H20160065', 3, '', 'bzdw_h', 'zxdw_b_7638', 2, 'jldw_l', 10.00, '10.00粒*2板/盒', 'kf', 2.0000, '', '', 'mr3c', 1, 0.0000, 35.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-30 09:52:03', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2696, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000856', 'pyx（dqgd，clc', '排龈线（带切割刀，测量尺', 'sccj_w', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '#000不含药2.44米长', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-28 15:50:26', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2706, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001866', 'ffcshhp', '复方草珊瑚含片', 'sccj_jzyygfyxgs', 'Z36021461', 3, '', 'bzdw_h', 'zxdw_p', 24, 'jldw_g', 1.00, '1g*24片/盒', '', 0.0000, '', '', '', 1, 0.0000, 6.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2716, 'bgyplb_sbwxpjlcl', 3, 1, 'bgyplb_sbwxpjlcl', '', 'ZKM00001472', 'VGAljx', 'VGA连接线', 'sccj_amzyc', NULL, 3, '', 'bzdw_g_468', 'zxdw_g_5284', 1, '', 0.00, '1根/根', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2726, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001263', 'ryljd	', '日用垃圾袋	', 'sccj_bjkylsmyxgs		', '-', 3, '', 'jjdw_k', '', 1, '', 0.00, '30L60*80*1.5S', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2736, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000621', 'ssdp', '手术刀片', 'sccj_shlhylypyxgs', '沪浦械备20150030', 3, '', 'jjdw_b', '', 1, '', 0.00, '11#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2746, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001283', 'ycxysb', '一次性压舌板', 'sccj_nchy', '-', 3, '', 'jjdw_b', '', 1, '', 0.00, '100s/包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2756, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001519', 'rmbqz', '热敏标签纸', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2766, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rg', 'ZKM00000105', 'hmsrg', '红霉素软膏', 'sccj_gdhjzyyxgs', 'H44023920', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 10.00, '10.00g*1支/支', '', 0.0000, '', '', '', 1, 1.4000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-06-14 17:09:52', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2776, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00001185', 'yyxjxeq', '医用橡胶洗耳球', 'sccj_bjfs', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '小#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2786, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001380', 'lyjf', '羚羊角粉', 'sccj_trt', '', 3, '', 'bzdw_hk', 'zxdw_kg_g', 3, 'jldw_g', 3.00, '3g/袋', '', 3.0000, '', '', '', 1, 10.0000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2796, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001744', 'xsgyzsy', '硝酸甘油注射液', 'sccj_hnrhzygfyxgs', 'H20057216', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_ml', 1.00, '1.00ml*10支/盒', 'jmtz', 1.0000, '', '', 'bys', 2, 0.0000, 2.1900, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2806, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001404', 'bzhggxh', '标准火罐各型号', 'sccj_jsxz', '-', 3, '', 'jjdw_t', '', 1, '', 0.00, '24个罐+6个硅胶罐', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2816, 'bgyplb_yslcl', 3, 1, 'bgyplb_yslcl', '', 'ZKM00001509', 'bt', '臂贴', 'sccj_amzyc', NULL, 3, '', 'bzdw_t_2138', 'zxdw_t', 1, '', 0.00, '1贴/贴', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2826, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000423', 'ycxsywjzsqdz', '一次性使用无菌注射器带针', 'sccj_shkdlqyfzjtgfyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '50ml', '', 0.0000, '', 'ml', '', 1, 1.1000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 17:19:38', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2836, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001834', 'zmzsj', '桌面展示架', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2846, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001571', '80ulwlcxxg', '80ul微量采血吸管', 'sccj_w', '-', 3, '', 'jjdw_t_5432', '', 1, '', 0.00, '桶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2856, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001137', 'demyPIMdgwdzsgjmg', '第二磨牙PIM单管网底直丝弓夹面管', 'sccj_hzxyckclyxgs', '浙食药监械（准）字2014第2630177号', 3, '', 'jjdw_d', '', 1, '', 0.00, '62BS-20J-47(20*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-04 16:53:20', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2866, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001109', 'ycxsywjzsqdz', '一次性使用无菌注射器带针', 'sccj_cdsxjsfylqxyxgs', '国械注准20163150107', 3, '', 'jjdw_z', '', 1, '', 0.00, '5ml06*25', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-30 14:19:11', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2876, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000400', 'crhld', '成人护理垫', 'sccj_（bdb）tjsyfwsypyxgs', '', 3, '', 'jjdw_b', '', 1, '', 0.00, 'M410860cm*60cm8片*12包/箱48包/4箱', '', 0.0000, '', 'ml', '', 1, 12.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2886, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001803', 'zsylapl', '注射用赖氨匹林', 'sccj_gyjtgryy', 'H20054763', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 0.90, '0.90g*1支/支', '', 0.0000, '', '', '', 1, 0.0000, 3.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2896, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000934', 'ccgr', '炒草果仁', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.8400, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2906, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_rj', 'ZKM00001820', 'xzcy（cs）', '新中成药（测试）', 'sccj_dgblgfhxyxgs', 'GB777', 3, '', 'bzdw_h', 'zxdw_z', 6, 'jldw_wdw', 20.00, '20.00万单位*6支/盒', '', 0.0000, '', '', '', 2, 0.0000, 16.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-06-14 18:43:45', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2916, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001583', 'cxp(0.9mm)', '成型片(0.9mm)', 'sccj_Ultradert product Inc', '', 3, '', 'jjdw_zhang', '', 1, '', 0.00, '张', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2926, 'hclb_gzyhp', 2, 1, 'hclb_gzyhp', '', 'ZKW00001545', 'yqp', '氧气瓶', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_t', '', 1, '', 0.00, '套', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2936, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000825', 'tzytgxfcl', '同种异体骨修复材料', 'sccj_EA', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '1ml', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2946, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000804', 'ycxyqbdg（TX）', '一次性氧气鼻导管（TX）', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '1*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-14 17:08:31', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2956, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000171', 'qgq', '去冠器', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2966, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001254', 'ztfhwl1712605	', '直条防护围领1712605	', 'sccj_dgblgfhxyxgs', '-', 3, '', 'jjdw_t_7475', '', 1, '', 0.00, '0.50铅当量', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2976, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000793', '75%jj', '75%酒精', 'sccj_hnkfylksfzyxgs', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '500ml*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2986, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001641', 'ntysg ly14L', '镍钛圆丝弓 卵圆14L', 'sccj_shamdclljgfyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (2996, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001380', 'lswfb', '蓝色无纺布', 'sccj_mnsdkyzzyyqc		', '-', 3, '', 'jjdw_x', '', 1, '', 0.00, '3M900mm*90cm120张/箱', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3006, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001291', 'dh', '大黄', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1570, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3016, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000433', 'zzq（gjzs）', '组织钳（国际制式）', 'sccj_rbgdgyzshs_6795', '', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'TC703024cm(巴士）', '', 0.0000, '', 'ml', '', 1, 104.4000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3026, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rgj', 'ZKM00000524', 'ksmmsrg（als）', '糠酸莫米松乳膏（艾洛松）', 'sccj_beyy（sh）yxgs', 'H19991418', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 5.00, '5.00g*1支/支', 'ad us.ext', 0.0000, '', '', 'qd', 1, 19.7700, 23.7200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 5, 2, NULL, '2018-05-18 10:36:07', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3036, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000512', 'ysnltzsy', '盐酸纳洛酮注射液', 'sccj_bjhszygfyxgs', 'H20023762', 3, '', 'bzdw_z', 'zxdw_ml', 2, 'jldw_mg', 2.00, '2.00mg*2ml/支', 'Ivgtt', 2.0000, '', '', 'St', 1, 52.4000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 4, 1, NULL, '2018-03-02 14:27:21', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3046, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001331', 'ydsyj', '移动输液架', 'sccj_gdhx ', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '不锈钢带轮', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3056, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000059', 'lnzp（atstp）', '螺内酯片（安体舒通片）', 'sccj_hzmsyyyxgs', 'H33020070', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 20.00, '20.00mg*100片/瓶', 'ad us.int', 40.0000, '', '', 'bid', 1, 13.5000, 18.9000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, NULL, '2018-04-19 13:42:45', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3066, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001672', 'yytzsbd6*6*8', '医用脱脂纱布垫6*6*8', 'sccj_cdswsclc', '', 3, '', 'jjdw_d', '', 1, '', 0.00, '袋', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3076, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001407', 'bxgmqg（zj10cm）', '不锈钢棉签缸（直径10cm）', 'sccj_gdhx ', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '10CM', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3086, 'hclb_gzyhp', 2, 1, 'hclb_gzyhp', '', 'ZKW00000378', 'dtxyjcy', '动态血压检测仪', 'sccj_yghmgjyxgsbjdbc', '', 3, '', 'jjdw_t_148', '', 1, '', 0.00, 'ri-cardio(1760)', '', 0.0000, '', 'ml', '', 1, 9000.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3096, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000096', 'syyjjcyz 25mm', '手用牙胶尖侧压针 25mm', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3106, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000844', 'hbm', '黄柏面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0550, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3116, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001099', 'glj', '高良姜', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0670, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3126, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001165', 'ycxdnb', '一次性导尿包', 'sccj_jshtylqxyxgs', '-', 3, '', 'jjdw_z_5693', '', 1, '', 0.00, '16#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3136, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001456', 'tmdasajzym（AST）cdsjh	', '天门冬氨酸氨基转移酶（AST）测定试剂盒	', 'sccj_szmr', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3146, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000983', 'ajpxdp', '安捷牌消毒片', 'sccj_sdajgkxdkjyxgs', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '100片', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3156, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsp', 'ZKM00000031', 'cs123', '测试123', 'sccj_bjsykyy', '', 3, '', 'bzdw_p_1730', 'zxdw_h', 1, 'jldw_g', 2.00, '2.00g*1盒/片', '', 0.0000, '', '', '', 1, 0.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-08-07 14:29:35', 1, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3166, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rj', 'ZKM00001856', 'xy（xcs）', '西药（新测试）', 'sccj_sccj（cs）', 'GB1111', 3, '', 'bzdw_h', 'zxdw_b_7638', 2, 'jldw_p', 10.00, '10片*2板/盒', '', 0.0000, '', '', '', 1, 0.0000, 55.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3176, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000800', '20ml zsq(TX)', '20ml 注射器(TX)', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '20ml*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3186, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dyj', 'ZKM00001870', 'sgsndyy', '色甘酸钠滴眼液', 'sccj_hbtyyygfyxgs', 'H200565124', 3, '', 'bzdw_z', 'zxdw_ml', 8, 'jldw_g', 0.16, '0.16g*8ml/支', '', 0.0000, '', '', '', 1, 0.0000, 8.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3196, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000525', 'znsskfl', '自粘式伤口辅料', 'sccj_hn', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '70*45mm', '', 0.0000, '', 'ml', '', 1, 8.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-11 18:18:41', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3206, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000270', 'ycxyyxjjcst（wf）', '一次性医用橡胶检查手套（无粉）', 'sccj_dd', '', 3, '', 'jjdw_h', '', 1, '', 0.00, 'TLFCMD42100无粉小号（5,.5）乳白色100只/盒，10盒/箱', '', 0.0000, '', 'ml', '', 1, 36.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 15:38:53', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3216, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001296', 'zl', '泽兰', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0390, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3226, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000668', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'TF-S20(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3236, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001248', 'yysbp（mjj）	', '医用纱布片（灭菌级）	', 'sccj_wjyl（hg）yxgs		', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '10*10cm-8P*2片/袋50袋/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3246, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000873', 'ycjtszⅠⅠ（znzyf）', '义齿基托树脂ⅠⅠ（自凝造牙粉）', 'sccj_w', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '2#100g/瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3256, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001511', 'jgsdmt', '金刚砂打磨头', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3266, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001482', 'klmsfsp', '克拉霉素分散片', 'sccj_cdhrzyyxgs', '国药准字H20093945', 3, '', 'bzdw_h', 'zxdw_p', 12, 'jldw_g', 0.12, '0.12g*12片/盒', '', 0.0000, '', '', '', 1, 12.1000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3276, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001275', 'jyyr', '焦薏苡仁', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0950, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3286, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001084', 'mtdz', '马桶垫纸', 'sccj_amzyc', '', 3, '', 'bzdw_h', 'zxdw_h', 1, '', 0.00, '1盒/盒', '', 0.0000, '', 'ml', '', 2, 33.0000, 33.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3296, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001532', 'tmj（d）', '透明胶（大）', 'sccj_amzyc', NULL, 3, '', 'bzdw_j', 'zxdw_j', 1, '', 0.00, '1卷/卷', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3306, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00001750', 'gyhqry（sys）', '过氧化氢溶液（双氧水）', 'sccj_gdhjzyyxgs', 'H44023919', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 100.00, '100.00ml*1瓶/瓶', 'hs', 10.0000, '', '', 'bys', 1, 0.0000, 3.0500, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-29 10:45:13', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3316, 'bgyplb_sbwxpjlcl', 3, 1, 'bgyplb_sbwxpjlcl', '', 'ZKM00001470', 'dyjljx', '打印机连接线', 'sccj_amzyc', NULL, 3, '', 'bzdw_g_468', 'zxdw_g_5284', 1, '', 0.00, '1片/根', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-04-11 10:48:26', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3326, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001134', 'dymydgwdzsjmgC', '第一磨牙单管网底直丝颊面管C', 'sccj_hzxyckclyxgs', '浙械注准20172631234', 3, '', 'jjdw_d', '', 1, '', 0.00, '62BK-20J-46(20*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-04 16:47:51', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3336, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tptj', 'ZKM00000415', 'fflsdykfy', '复方磷酸待因口服液', 'sccj_Abbott Biologicals B.V.', '', 3, '', 'bzdw_h', 'zxdw_d', 30, 'jldw_ml', 10.00, '10.00ml*30袋/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3346, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000688', 'weq', '戊二醛', 'sccj_schtkjsyyxgs', '--', 3, '', 'jjdw_t_5432', '', 1, '', 0.00, '2000ml', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3356, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001506', 'jsz', '夹石针', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3366, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_w', 'ZKM00001611', 'hwzcw', '和胃整肠丸', 'sccj_tgdxyzyc', 'CAA6262', 3, '', 'bzdw_p', 'zxdw_l', 300, 'jldw_mg', 200.00, '200.00mg*300粒/瓶', '', 0.0000, '', '', '', 1, 0.0000, 88.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3376, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001259', 'yyljt	', '医用垃圾桶	', 'sccj_bjkylsmyxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '30L脚踏式', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3386, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001001', 'sgl', '丝瓜络', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1900, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3396, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001522', '5hdc', '5号电池', 'sccj_amzyc', NULL, 3, '', 'bzdw_b_4606', 'zxdw_l', 4, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-02 13:33:19', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3406, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000287', 'ycxsymjxjwkst', '一次性使用灭菌橡胶外科手套', 'sccj_glrjc（glgb）', '', 3, '', 'jjdw_f', '', 1, '', 0.00, '6.5#无粉弯型麻面', '', 0.0000, '', 'ml', '', 1, 2.4500, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3416, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000909', 'jx', '降香', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 1.6800, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3426, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001743', 'tsqnzsy', '碳酸氢钠注射液', 'sccj_yzsyaylqxyxgs', 'H41023047', 3, '', 'bzdw_h', 'zxdw_z', 5, 'jldw_ml', 10.00, '10.00ml*5支/盒', 'jmdz', 10.0000, '', '', 'bys', 2, 0.0000, 1.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3436, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001433', 'zyfsxp（klbt）', '左氧氟沙星片（可乐必妥）', 'sccj_dysgzy（bj）yxgs', '国药准字H20040091', 3, '', 'bzdw_h', 'zxdw_p', 4, 'jldw_g', 0.50, '0.50g*4片/盒', 'kf', 0.5000, '', '', 'mr1c', 1, 47.6400, 66.7000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 14:45:09', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3446, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001424', 'lqh', '利器盒', 'sccj_bjkylsmyxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '5L方形', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3456, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000736', 'sgj', '生龟甲', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.7200, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3466, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001634', 'zjz 0.25*60', '针灸针 0.25*60', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3476, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000580', 'fczk', '麸炒枳壳', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2240, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:33:29', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3486, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001391', 'jxb（5m）', '接线板（5m）', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 58.1000, 58.1000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-03-22 11:17:29', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3496, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001574', 'dzewq', '电子耳温枪', 'sccj_w', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3506, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001088', 'yt', '牙挺', 'sccj_w', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '空心六角柄SC5', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3516, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000266', 'tzq', '听诊器', 'sccj_3MCompany3MHealthCare', '', 3, '', 'jjdw_t_148', '', 1, '', 0.00, '3MTMlittmann2298', '', 0.0000, '', 'ml', '', 1, 480.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3526, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000043', 'ycxfhb', '一次性缝合包', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3536, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000866', 'yyc（protaper ntgk-jy21h）', '牙用锉（protaper 镍钛根扩-机用21混）', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mmSX-F36*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3546, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rgj', 'ZKM00001776', 'wAsrg   0.025%', '维A酸乳膏   0.025%', 'sccj_cqhbzyyxgs', 'H50021817', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 15.00, '15.00g*1支/支', '', 0.0000, '', '', '', 1, 0.0000, 8.9200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3556, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001452', 'gjcjz	', '高级擦镜纸	', 'sccj_hztpgyzxqcc		', '-', 3, '', 'jjdw_b_2336', '', 1, '', 0.00, '本', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3566, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000540', 'zjdhscdsjh（dajbhszdyf）', '直接胆红素测定试剂盒（对氨基苯磺酸重氮盐法）', 'sccj_glyltyldzyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '125ml*2；5ml*2', '', 0.0000, '', 'ml', '', 1, 129.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3576, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001387', 'hm', '海马', 'sccj_trt', '', 3, '', 'bzdw_z', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/支', '', 5.0000, '', '', '', 1, 19.0000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3586, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000227', 'dqp', '颠茄片', 'sccj_tjlszyyxgs', 'Z12020425', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 10.00, '10.00mg*100片/瓶', 'ad us.int', 10.0000, '', '', 'Prn', 1, 5.0000, 7.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 20, 3, NULL, '2018-04-27 15:47:28', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3596, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000499', 'dpw', '吊瓶网', 'sccj_zd', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '250ml', '', 0.0000, '', 'ml', '', 1, 0.4500, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3606, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000005', 'blfhxy(ml)', '布洛芬混悬液(美林)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1.00g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 1, 0, 0, 0, '2017-07-13 00:00:00', '2018-08-16 14:29:06', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3616, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000015', 'ffnhsdyy(xld)', '复方牛磺酸滴眼液(小乐敦)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3626, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000025', 'wssaddj（ykx0-1s）', '维生素ad滴剂（伊可新0-1岁）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3636, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000035', 'xeqxckl', '小儿七星茶颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3646, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_qt', 'ZDS90000045', 'yfsxdey（tlbt)', '氧氟沙星滴耳液（泰利必妥)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-02-06 17:16:39', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3656, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000055', 'ssztg', '伤湿止痛膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3666, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000065', 'xzztg', '消肿镇痛膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3676, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000075', 'ynbyg', '云南白药膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3686, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000085', 'yat', '药艾条', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3696, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000095', 'fkqjjn', '妇科千金胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3706, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000105', 'wscecp/cechbytpfhbz（klm）', '戊酸雌二醇片/雌二醇环丙孕酮片复合包装（克龄蒙）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3716, 'yplb_xy', 1, 1, 'yplb_zcy', 'ypjx_wj', 'ZDS90000115', 'xyw', '逍遥丸', 'sccj_zjwxzygfyxgs', 'z41021831', 3, '', 'bzdw_h', 'zxdw_h', 1, 'jldw_w', 200.00, '200.00丸*1盒/盒', '', 0.0000, '', 'ml', '', 1, 13.4000, 1.0000, 'fylb_zcy', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-24 09:05:27', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3726, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000125', 'xjw', '小金丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3736, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000135', 'etkwp(bld)', '恩替卡韦片(博路定)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3746, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000145', 'jgp', '肌苷片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3756, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000155', 'ffbhnrg（mxldbk）', '复方薄荷脑软膏（曼秀雷敦栢可）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3766, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000165', 'bjkfy', '保济口服液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3776, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000175', 'jdncamlcbppg', '京都念慈菴蜜炼川贝枇杷膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3786, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000185', 'jdncamlcbppg', '京都念慈菴蜜炼川贝枇杷膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3796, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000195', 'mlcbppg', '蜜炼川贝枇杷膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3806, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000205', 'csdsmsp', '醋酸地塞米松片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3816, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000215', 'slxbjn(xlb)', '塞来昔布胶囊(西乐葆)', 'sccj_hrzy', 'J20140072', 3, '', 'bzdw_h', 'zxdw_l', 6, 'jldw_g', 0.20, '0.20g*6粒/盒', 'ad us.int', 0.2000, '', 'ml', 'bid', 1, 32.6200, 1.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 2, '2017-07-13 00:00:00', '2018-02-28 16:28:03', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3826, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZDS90000225', 'ffdyxajfp（II）（slt）', '复方对乙酰氨基酚片（II）（散利痛）', 'sccj_beyyyxgs', '1611040', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_p', 1.00, '1.00片*20片/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 16.3000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-11 10:54:23', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3836, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000235', 'yyjp', '异烟肼片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3846, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000245', 'fntycrp', '呋喃妥因肠溶片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3856, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000255', 'fnztp', '呋喃唑酮片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3866, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000265', 'zmsp（zmjsp）', '制霉素片（制霉菌素片）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3876, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000275', 'cnyyfj（tp）（as）', '肠内营养粉剂（tp）（安素）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/听', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3886, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000285', 'fflyddsmsm', '复方氯已定地塞米松膜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3896, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000295', 'gysxdnfp(wak)', '枸橼酸西地那非片(万艾可)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3906, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000305', 'jssttldp(snt)', '酒石酸托特罗定片(舍尼亭)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3916, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000315', 'yqw', '玉泉丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3926, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000325', 'akbtp(btp*)', '阿卡波糖片(拜唐苹*)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3936, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000335', 'mlxcg', '玫芦消痤膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3946, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000345', 'fyj', '风油精', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3956, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000355', 'ffbslbtsrg', '复方丙酸氯倍他索软膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3966, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000365', 'pfkxy', '皮肤康洗液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3976, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000375', 'bdfw', '白癜风丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3986, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000385', 'csdsmsp', '醋酸地塞米松片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (3996, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000395', 'jyhl', '金银花露', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4006, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000405', 'ffblgkl', '复方板蓝根颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/袋', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4016, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000415', 'ysdnpqp（als）', '盐酸多奈哌齐片（安理申）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4026, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000425', 'lmsqp(lbt)', '拉莫三嗪片(利必通)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4036, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000435', 'nxskfy', '脑心舒口服液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4046, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000445', 'ambntj', '安眠补脑糖浆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4056, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000455', 'atxap(sbm)', '奥替溴铵片(斯巴敏)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4066, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000465', 'dpltp(mdl)', '多潘立酮片(吗丁啉)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4076, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000475', 'asamlzmcrp', '艾司奥美拉唑镁肠溶片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4086, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000485', 'xspww', '香砂平胃丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4096, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000495', 'bhsaldpp', '苯磺酸氨氯地平片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4106, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000505', 'tmw', '天麻丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4116, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000515', 'bhszxaldpp(shd)', '苯磺酸左旋氨氯地平片(施慧达)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4126, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000525', 'lscxqp', '磷酸川芎嗪片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4136, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000535', 'ffdcdw', '复方丹参滴丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 1, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4146, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000545', 'xfzykfy', '血府逐瘀口服液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4156, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000555', 'sxxbjn', '升血小板胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4166, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000565', 'ysjmsyg', '盐酸金霉素眼膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4176, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000575', 'hmsyg', '红霉素眼膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4186, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000585', 'zzmmdyy', '珍珠明目滴眼液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4196, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000595', 'bltwj', '玻璃体温计', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4206, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000605', 'pttzsy', '葡萄糖注射液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4216, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000615', 'jrt', '灸热帖', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4226, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000625', 'wzyzw', '五子衍宗丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4236, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000635', 'lwdhw', '六味地黄丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4246, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000003', 'ycxxyg', '一次性吸氧管', 'sccj_scsyjsylkjyxgs', '12324', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '个', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-08-01 16:19:35', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4256, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000013', 'ycxzxd（ymd）', '一次性止血带（压脉带）', 'sccj_w', '-', 3, '', 'jjdw_h', 'jjdw_ge', 1, 'jldw_g', 1.00, '50条/每盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-22 17:22:10', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4266, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000023', 'xdptp', '消毒泡腾片', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '100片/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4276, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000033', 'ycxyyfslsb', '一次性医用凡士林纱布', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '5*5cm 50片每盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4286, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000043', 'hg（bl）x', '火罐（玻璃）小', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '内径3.4', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4296, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000053', 'ycxjmcxz', '一次性静脉采血针', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '100支每袋', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4306, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000063', 'ycxkqqxh', '一次性口腔器械盒', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '200个每箱', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4316, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000073', 'yhz', '咬合纸', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '300片每盒 55*18mm', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4326, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000083', 'zsyymc', '藻酸盐印膜材', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4336, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000093', 'ycxslymtp', '一次性塑料牙模托盘', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '2号', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4346, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000103', 'jyhxqn', '简易呼吸气囊', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4356, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000004', 'mgh', '玫瑰花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-08-14 16:40:15', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4366, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000014', 'bs', '白术', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4376, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000024', 'sdh', '熟地黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4386, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000034', 'bs', '白芍', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4396, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000044', 'gymc', '干益母草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4406, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000054', 'jcx', '酒川芎', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4416, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000064', 'zych', '竹叶柴胡', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4426, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000074', 'fczs', '麸炒枳实', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4436, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000084', 'jhp', '姜厚朴', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4446, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000094', 'jhq', '酒黄芩', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4456, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000104', 'gj', '干姜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4466, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000114', 'ydz', '盐杜仲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4476, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000124', 'dz', '大枣', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4486, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000134', 'swt', '首乌藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4496, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000144', 'jg', '桔梗', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4506, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000154', 'bsc', '北沙参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4516, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000164', 'dl', '地龙', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4526, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000174', 'cjc', '炒僵蚕', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4536, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000184', 'mhl', '墨旱莲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4546, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000194', 'jsz', '焦山楂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4556, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000204', 'sl', '三棱', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4566, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000214', 'xc', '玄参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4576, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000224', 'sbp', '桑白皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4586, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000234', 'thf', '天花粉', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4596, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000244', 'rcr', '肉苁蓉', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4606, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000254', 'qs', '芡实', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4616, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000264', 'btl', '白土苓', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4626, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000274', 'mbb', '蜜百部', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4636, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000284', 'yxhx', '盐小茴香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4646, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000294', 'jhp', '姜厚朴', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4656, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000304', 'lyr', '龙眼肉', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4666, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000314', 'dml', '煅牡蛎', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4676, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000324', 'dgz', '冬瓜子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4686, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000334', 'gc', '甘草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4696, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000344', 'zm', '知母', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4706, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000354', 'sz', '桑枝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4716, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000364', 'jhq', '酒黄芩', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4726, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000374', 'cyhs', '醋延胡索', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4736, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000384', 'zz', '栀子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4746, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000394', 'csg', '川射干', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4756, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000404', 'xhc', '仙鹤草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4766, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000414', 'fj', '防己', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4776, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000424', 'sy', '锁阳', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4786, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000434', 'td', '天冬', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4796, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000444', 'pj', '炮姜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4806, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000454', 'ch', '柴胡', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4816, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000464', 'jqbhs', '金钱白花蛇', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4826, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000474', 'jbx', '京半夏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4836, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000484', 'cqc', '车前草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4846, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000494', 'lq', '连翘', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4856, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000504', 'yxhx', '盐小茴香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4866, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000514', 'dfjc', '大肺筋草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4876, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000524', 'dyt', '地榆炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4886, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000534', 'xkc', '夏枯草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4896, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000544', 'zc', '紫草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4906, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000554', 'sjc', '伸筋草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4916, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000564', 'yspx', '盐桑螵蛸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4926, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000574', 'jnzz', '酒女贞子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4936, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000584', 'bljn', '北刘寄奴', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4946, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000594', 'yc', '茵陈', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4956, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000604', 'fczk', '麸炒枳壳', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4966, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000614', 'qh', '羌活', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4976, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000624', 'dgt', '当归头', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4986, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000634', 'cnbz', '炒牛蒡子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (4996, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000644', 'dlc', '煅龙齿', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5006, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000654', 'wwz', '五味子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5016, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000664', 'hjt', '红景天', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5026, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000674', 'my', '麦芽', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5036, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000684', 'zmhr', '炙麻黄绒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5046, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000694', 'sy', '山药', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5056, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000704', 'jjt', '荆芥炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5066, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000714', 'lxh', '凌霄花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5076, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000724', 'ctlz', '炒葶苈子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5086, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000734', 'zcw', '制川乌', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5096, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000744', 'cmt', '川木通', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5106, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000754', 'lsq', '六神曲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5116, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000764', 'jst', '鸡矢藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5126, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000774', 'jcgr', '姜草果仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5136, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000784', 'csz', '赤石脂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5146, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000794', 'jh(h)', '菊花(杭)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5156, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000804', 'ztnx', '制天南星', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5166, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000814', 'dzzm', '煅珍珠母', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5176, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000824', 'cwwz', '醋五味子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5186, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000834', 'xlc', '响铃草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5196, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000844', 'cqp', '炒青皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5206, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000854', 'dgp', '冬瓜皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5216, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000864', 'hjs', '海金沙', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5226, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000874', 'cx', '川芎', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5236, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000884', 'cs', '蚕沙', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5246, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000894', 'ebsc', '鹅不食草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5256, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000904', 'fcsy', '麸炒山药', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5266, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000914', 'mbb', '蜜百部', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5276, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000924', 'jwss', '酒乌梢蛇', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5286, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000934', 'tbc', '土鳖虫', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5296, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000944', 'nmtg', '糯米藤根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5306, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000954', 'mmh', '密蒙花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5316, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000964', 'scz', '蛇床子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5326, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000974', 'sy', '桑叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5336, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000984', 'qj', '秦艽', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5346, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000994', 'qh', '羌活', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5356, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001004', 'htp', '海桐皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5366, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001014', 'ctlz', '炒葶苈子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5376, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001024', 'qmz', '苘麻子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5386, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001034', 'cx', '沉香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5396, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001044', 'dml', '煅牡蛎', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5406, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001054', 'cgj', '醋龟甲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5416, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001064', 'zhsw', '制何首乌', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5426, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001074', 'yjh', '野菊花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5436, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001084', 'ddc', '淡豆豉', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5446, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001094', 'gj', '龟甲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5456, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001104', 'pht', '蒲黄炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5466, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001114', 'scp', '石菖蒲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5476, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001124', 'yzm(r)', '盐知母(肉)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5486, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001134', 'xx', '细辛', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5496, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001144', 'hhh', '合欢花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5506, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001154', 'scg', '山慈菇', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5516, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001164', 'mppy', '蜜枇杷叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5526, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001174', 'gjc', '谷精草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5536, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001184', 'mjp', '木槿皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5546, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001194', 'lmh', '蜡梅花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5556, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001204', 'dfz', '地肤子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5566, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001214', 'dl', '地龙', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5576, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001224', 'ych', '银柴胡', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5586, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001234', 'hjs', '海金沙', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5596, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001244', 'sgl', '丝瓜络', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5606, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001254', 'slp', '石榴皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5616, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001264', 'jcx', '酒川芎', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5626, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001274', 'mdq', '毛冬青', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5636, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001284', 'lst', '络石藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5646, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001294', 'mg', '木瓜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5656, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001304', 'sdg', '山豆根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5666, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001314', 'zcw', '制川乌', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5676, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001324', 'sbp', '桑白皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5686, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001334', 'bzr', '柏子仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5696, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001344', 'tef', '兔耳风', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5706, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001354', 'jgc', '鸡骨草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5716, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001364', 'glj', '高良姜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5726, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001374', 'czz', '炒栀子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5736, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001384', 'mgh', '玫瑰花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5746, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001394', 'ec', '儿茶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5756, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001404', 'dywg', '独一味根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5766, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001414', 'dlg', '煅龙骨', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5776, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001424', 'jmz', '决明子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5786, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001434', 'dyqc', '大叶茜草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5796, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001444', 'yyr', '薏苡仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5806, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001454', 'jbx', '京半夏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5816, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001464', 'lj', '鹿角', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5826, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001474', 'mbc', '马鞭草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5836, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001484', 'mmh.', '蜜麻黄.', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5846, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001494', 'jm', '椒目', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5856, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001504', 'dsjm', '煅石决明', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5866, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001514', 'fczs', '麸炒枳实', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5876, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001524', 'zsy', '紫苏叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5886, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001534', 'sgjc', '赛谷精草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5896, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001544', 'zl', '泽兰', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5906, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001554', 'nhs', '南鹤虱', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5916, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001564', 'ccs', '川赤芍', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5926, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001574', 'sm', '升麻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5936, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001584', 'xx', '细辛', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5946, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001594', 'jh', '姜黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5956, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001604', 'ojt', '藕节炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5966, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001614', 'cbbd', '炒白扁豆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5976, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001624', 'sph', '生蒲黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5986, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001634', 'rgtzh', '人工天竺黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (5996, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001644', 'jmz', '决明子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6006, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001654', 'jz', '芥子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6016, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001664', 'jb', '卷柏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6026, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001674', 'cs', '赤芍', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6036, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001684', 'lxc', '鹿衔草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6046, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001694', 'csz', '炒山楂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6056, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001704', 'byz', '白药子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6066, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001714', 'bz', '白芷', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6076, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001724', 'bs', '白术', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6086, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001734', 'dqy', '大青盐', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6096, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001744', 'jdl(hgn)', '锦灯笼(红姑娘)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6106, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001754', 'glp', '瓜蒌皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6116, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001764', 'jjcp', '九节菖蒲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6126, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001774', 'xcq', '徐长卿', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6136, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001784', 'qs', '芡实', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6146, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001794', 'ec', '儿茶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6156, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001804', 'ghx', '广藿香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6166, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001814', 'yzx', '盐泽泻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6176, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001824', 'hp', '琥珀', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6186, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001834', 'cdgz', '炒冬瓜子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6196, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001844', 'zz', '栀子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6206, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001854', 'jcx', '酒川芎', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6216, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001864', 'pht', '蒲黄炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6226, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001874', 'sdt', '蛇倒退', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6236, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001884', 'mx', '木香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6246, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001894', 'bs', '白芍', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6256, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001904', 'csl', '穿山龙', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6266, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001914', 'bj', '白及', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6276, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001924', 'hq.', '黄芪.', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6286, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001934', 'dec', '地耳草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6296, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001944', 'dk', '豆蔻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6306, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001954', 'xsz', '相思子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6316, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001964', 'hyz', '黄药子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6326, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001974', 'fcsy', '麸炒山药', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6336, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001984', 'dg', '当归', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6346, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001994', 'cwh', '醋莞花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6356, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002004', 'zmt', '走马胎', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6366, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002014', 'ctr', '燀桃仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6376, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002024', 'thf', '天花粉', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6386, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002034', 'chx', '川藿香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6396, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002044', 'cwlz', '醋五灵脂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6406, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002054', 'ml', '牡蛎', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6416, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002064', 'sgjc', '赛谷精草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6426, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002074', 'crx', '炒乳香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6436, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002084', 'cp', '陈皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6446, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002094', 'dml', '煅牡蛎', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6456, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002104', 'swt', '首乌藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6466, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002114', 'xnsc', '西南手参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6476, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002124', 'cxl', '穿心莲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6486, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002134', 'fccs', '麸炒苍术', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6496, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002144', 'cxq', '沉香曲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6506, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002154', 'zbm', '浙贝母', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6516, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002164', 'gjz', '谷精珠', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6526, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002174', 'cjc', '炒僵蚕', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6536, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002184', 'csy', '炒山药', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6546, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002194', 'lh', '芦荟', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_6` VALUES (6556, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002204', 'dz', '大枣', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
COMMIT;

-- ----------------------------
-- Table structure for drug_resource_7
-- ----------------------------
DROP TABLE IF EXISTS `drug_resource_7`;
CREATE TABLE `drug_resource_7` (
  `id` bigint unsigned NOT NULL DEFAULT '0' COMMENT '主键',
  `drug_res_type_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT ' 药品和物资类型ID(dw_drug_res_type.id)',
  `base_type` tinyint NOT NULL DEFAULT '0' COMMENT '物品类型：1-药品, 2-耗材, 3-办公用品',
  `status` int DEFAULT '1' COMMENT '药品状态: 0 - 停用, 1 - 使用',
  `type_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药品或者耗材类别的字典ID(dw_dictionary.id AND dw_dictionary.type_id=[yplb OR hclb])',
  `dict_dosage_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药品剂型的字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypjx)',
  `code` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '集团编码',
  `pym` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '拼音简码',
  `name` varchar(64) CHARACTER SET utf8 DEFAULT '' COMMENT '药品或者耗材的名称',
  `manufacturer_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '生产厂家的字典ID(dw_dictionary.id AND dw_dictionary.type_id=sccj)',
  `approval_no` varchar(100) CHARACTER SET utf8 DEFAULT NULL COMMENT '批准文号',
  `med_type` int DEFAULT '3' COMMENT '医保分类： 1 - 无自付, 2 - 部分自付, 3 - 全自付',
  `admin_code` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药监编码',
  `pack_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '包装单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypdw)',
  `min_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '最小单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypdw)',
  `pack_quantity` int DEFAULT '1' COMMENT '包装含量',
  `dosage_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '剂量单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=jldw)',
  `dosage_quantity` decimal(10,2) DEFAULT '0.00' COMMENT '剂量含量',
  `pack_spec` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '包装规格，生成规则：[剂量含量] [剂量单位] * [包装含量] [最小单位] / [包装单位]',
  `take_method_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '用法(默认用法)(dw_dictionary.id AND dw_dictionary.type_id=ypyf)',
  `take_quantity` decimal(36,4) DEFAULT '0.0000' COMMENT '用量(默认用量)',
  `take_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '用量单位字典ID - 暂留字典',
  `take_unit_name` varchar(36) CHARACTER SET utf8 DEFAULT 'ml' COMMENT '用量单位名称，默认ml',
  `take_frequency` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '频率(默认频率)(dw_dictionary.id AND dw_dictionary.type_id=yppl)',
  `common_unit_type` int DEFAULT '1' COMMENT '常规单位类型: 1 - 包装单位(packUnit), 2 - 最小单位(minUnit)',
  `purchase_price` decimal(8,4) DEFAULT '0.0000' COMMENT '进货价: 单位 元',
  `sale_price` decimal(8,4) DEFAULT '0.0000' COMMENT '基准价: 单位 元',
  `cost_category_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '费用类别字典ID(dw_dictionary.id AND dw_dicitionary.type_id=fylb)',
  `invoice_item_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '发票项目字典ID - 暂留',
  `expensive_flag` int DEFAULT '1' COMMENT '贵重物品标识： 0 - 非贵重物品， 1 - 贵重物品',
  `psy_flag_i` int DEFAULT '0' COMMENT ' 精神I类药品标识：0 - 非选中， 1 - 选中',
  `psy_flag_ii` int DEFAULT '0' COMMENT '精神II类药品标识：0 - 非选中，1 - 选中',
  `otc_flag` int DEFAULT '0' COMMENT 'OTC标识：0 - 非选中， 1 - 选中',
  `nar_flag` int DEFAULT '0' COMMENT '麻醉药品标识：0 - 非选中， 1 - 选中',
  `inventory_upper` int DEFAULT '0' COMMENT '库存上限',
  `inventory_lower` int DEFAULT '0' COMMENT '库存下限',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  `modify_time` datetime DEFAULT NULL COMMENT '修改时间',
  `del_flag` int DEFAULT '0' COMMENT '删除标志:  0 - 未删除, 1 - 已删除',
  `consumable_type` int NOT NULL DEFAULT '0' COMMENT '耗材类型:1-国产,2-进口',
  `tips` varchar(1024) CHARACTER SET utf8 DEFAULT NULL COMMENT '药品使用注意事项',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

-- ----------------------------
-- Records of drug_resource_7
-- ----------------------------
BEGIN;
INSERT INTO `drug_resource_7` VALUES (7, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001429', 'ckpgg（Proxytcs-cpg）', '齿科抛光膏（Proxyt粗砂-粗抛光）', 'sccj_lz/wwdt', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, 'Coarse/83粗颗粒度/蓝色/55m', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (17, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000622', 'sb', '纱布', 'sccj_cdswsclc', '川械注准20172640036', 3, '', 'jjdw_j', '', 1, '', 0.00, 'A8M', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (27, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000260', 'hxtkz', '活性炭口罩', 'sccj_gzghlbhxtypyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '活性炭50个/盒', '', 0.0000, '', 'ml', '', 1, 15.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-24 10:07:06', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (37, 'yplb_xy', 1, 1, 'yplb_zcy', 'ypjx_jnj', 'ZKM00000343', 'ybtjn', '腰痹通胶囊', 'sccj_jskyyyyxgs', '国药准字z20010045', 3, '', 'bzdw_h', 'zxdw_l', 50, 'jldw_g', 0.42, '0.42g*50粒/盒', '', 0.0000, '', '', '', 1, 38.2900, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-25 13:43:45', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (47, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000778', 'yzyjrg', '牙周抑菌软膏', 'sccj_llswyy（wh）yxgs', '(鄂)卫消证字(2009)第0029号', 3, '', 'jjdw_z', '', 1, '', 0.00, '0.5G', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-04-24 10:45:26', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (57, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000580', 'qtbytz', '嵌体备牙套装', 'sccj_shdb', '无', 3, '', 'jjdw_m', '', 1, '', 0.00, '枚', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-08-08 18:15:08', 0, 1, NULL);
INSERT INTO `drug_resource_7` VALUES (67, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001616', 'zjz 0.3*75mm', '针灸针 0.3*75mm', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (77, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000504', 'yyycxzd', '医用一次性中单', 'sccj_cf', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '100*200cm', '', 0.0000, '', 'ml', '', 1, 15.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (87, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001764', 'jwxsp', '健胃消食片', 'sccj_jzyygfyxgs', 'Z20013220', 3, '', 'bzdw_h', 'zxdw_b_7638', 4, 'jldw_l', 8.00, '8.00粒*4板/盒', 'kf', 3.0000, '', '', 'mr3c', 1, 0.0000, 7.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-30 10:09:44', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (97, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001215', 'ycxzjz', '一次性针灸针', 'sccj_szhq', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '0.25*50mm*10支/10片/盒华佗牌', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (107, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsjn', 'ZKM00001608', 'mtss（xcw）', '蒙脱石散（香草味）', 'sccj_bf-yps（tj）zyyxgs', 'M11668', 3, '', 'bzdw_h', 'zxdw_d', 10, 'jldw_g', 3.00, '3.00g*10袋/盒', '', 0.0000, '', '', '', 1, 0.0000, 23.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (117, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000786', 'gqz', '枸杞子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2910, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (127, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001417', 'fhdwq1712323', '防护短围裙1712323', 'sccj_szhkylqxyxgs		', '-', 3, '', 'jjdw_j_8137', '', 1, '', 0.00, '0.50铅当量', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (137, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001062', 'ckssj（glmssj）', '齿科酸蚀剂（格鲁玛酸蚀剂）', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '2.5ml/支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (147, 'yplb_cy', 1, 0, 'yplb_xy', 'ypjx_qwj', 'ZKM00000048', 'lssdacwhxrry', '硫酸沙丁胺醇雾化吸入溶液', 'sccj_shxyjzyyyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 4, 'jldw_ml', 2.50, '2.5ml*4支/盒', '', 0.0000, '', '', '', 1, 51.2800, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-11-16 10:52:58', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (157, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001388', 'xyt', '血余炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/支', '', 10.0000, '', '', '', 1, 0.1500, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (167, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_sj_1', 'ZKM00000074', 'hxzqs', '藿香正气水', 'sccj_jxsfrtyygfyxgs', '国药准字Z36020816', 3, '', 'bzdw_h', 'zxdw_z', 6, 'jldw_ml', 10.00, '10.00ml*6支/盒', '', 0.0000, '', '', '', 1, 4.9000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-05-23 13:37:57', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (177, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_hjp', 'ZKM00001773', 'zcy（cs）', '中成药（测试）', 'sccj_hbsxyyrjzpyxgs', 'GB0003', 3, 'YJ003', 'bzdw_h', 'zxdw_b_7638', 2, 'jldw_l', 10.00, '10.00粒*2板/盒', 'cqkf', 2.0000, '', '', 'm12xsyc', 1, 0.0000, 32.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-06-19 22:24:36', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (187, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000141', 'fhx', '缝合线', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '3-0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (197, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000512', 'wksbfl', '外科纱布辅料', 'sccj_hl_8653', '', 3, '', 'jjdw_p_10962', '', 1, '', 0.00, '7*8cm100片/包', '', 0.0000, '', 'ml', '', 1, 0.1200, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-11 17:33:03', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (207, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001366', 'fhz', '缝合针', 'sccj_hzhw		', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '角头带针不可吸收缝合针1.040包/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (217, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000328', 'lhnzsy（0.9%）', '氯化钠注射液（0.9%）', 'sccj_sdklyyyxgswtscklyyyxgs', '', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 500.00, '500.00ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 1.4000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (227, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_klj', 'ZKM00000344', 'xmgjkl', '玄麦甘桔颗粒', 'sccj_scfczyyxgs', '国药准字Z51020113', 3, '', 'bzdw_b', 'zxdw_d', 20, 'jldw_g', 10.00, '10.00g*20袋/包', '', 0.0000, '', '', '', 1, 5.6000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 13:48:37', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (237, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000220', 'ycxsywjdng', '一次性使用无菌导尿管', 'sccj_zjssdsyyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '双腔14#', '', 0.0000, '', 'ml', '', 1, 3.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (247, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000594', 'Kc', 'K锉', 'sccj_xnddsb', '国械备20170214号', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm-25', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (257, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001372', 'zhcf', '紫河车粉', 'sccj_trt', '', 3, '', 'bzdw_d', 'zxdw_kg_g', 3, 'jldw_g', 3.00, '3g/袋', '', 3.0000, '', '', '', 1, 11.8000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (267, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tptj', 'ZKM00000448', 'rgtkfy', '乳果糖口服液', 'sccj_Abbott Biologicals B.V.', 'H20120387', 3, '', 'bzdw_h', 'zxdw_d', 6, 'jldw_ml', 15.00, '15.00ml*6袋/盒', 'ad us.int', 15.0000, '', '', 'qd', 1, 35.2000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 3, NULL, '2018-03-01 13:53:55', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (277, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000630', 'rg', '肉桂', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.4900, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 17:42:49', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (287, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000651', 'cmy', '炒麦芽', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0390, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (297, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000101', 'lhjp', '氯化钾片', 'sccj_tjlszygfyxgs', '国药准字H12020167', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 10.00, '10.00mg*100片/瓶', '', 0.0000, '', '', '', 1, 3.3000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 13:51:38', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (307, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001072', 'ycxsyslyt', '一次性使用塑料牙托', 'sccj_w', '-', 3, '', 'jjdw_f', '', 1, '', 0.00, '413/414中号', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (317, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_njj', 'ZKM00000336', 'ysldkyzsy', '盐酸利多卡因注射液', 'sccj_tjjyjthbtyyygfyxgs', '国药准字h20133209', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 5.00, '5.00ml*1支/支', '', 0.0000, '', '', '', 1, 1.4600, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 13:54:01', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (327, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001383', 'xjf', '血竭粉', 'sccj_trt', '', 3, '', 'bzdw_hk', 'zxdw_kg_g', 15, 'jldw_g', 15.00, '15g/袋', '', 15.0000, '', '', '', 1, 22.0000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (337, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_qwj', 'ZKM00000306', 'ynbyqwj', '云南白药气雾剂', 'sccj_ynbyjtgfyxgs', '', 3, '', 'bzdw_h', 'zxdw_h', 1, 'jldw_g', 110.00, '110.00g*1盒/盒', '', 0.0000, '', '', '', 1, 28.9000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (347, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000939', 'szbc', '生紫贝齿', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0950, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (357, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001341', 'gt', '钩藤', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.3920, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (367, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001903', 'wdjz', '维达卷纸', 'sccj_amzyc', NULL, 3, '', 'bzdw_t_6064', 'zxdw_t_6703', 1, '', 0.00, '1提/提', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (377, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001013', 'A4', 'A4', 'sccj_amzyc', '', 3, '', 'bzdw_b', 'zxdw_z_z', 500, '', 0.00, '500张/包', '', 0.0000, '', 'ml', '', 2, 10.0000, 10.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (387, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00001434', 'xhc（cs）', '新耗材（测试）', 'sccj_hnqxzyyxgs', 'GB6666', 3, '', 'jjdw_j_8137', '', 1, '', 0.00, '件', '', 0.0000, '', 'ml', '', 1, 0.0000, 22.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-26 02:23:27', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (397, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000840', 'ytz（ghsz）', '牙探针（光滑髓针）', 'sccj_mnzshs', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, '00#12*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 19.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (407, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001027', 'yyflq', '牙用分离器', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '杆类型式170', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (417, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001394', 'LEDyjd', 'LED应急灯', 'sccj_amzyc', '', 3, '', 'bzdw_z', 'zxdw_g', 1, '', 0.00, '1个/支', '', 0.0000, '', 'ml', '', 2, 89.0000, 89.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (427, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000797', 'xmf', '玄明粉', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0300, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (437, 'hclb_ptcl', 2, 0, 'hclb_ptcl', '', 'ZKW00000003', 'jj', '酒精', 'sccj_adyy(bj)yxgs', '123', 3, '123', 'jjdw_p', '', 1, '', 0.00, '500ml/瓶', '', 0.0000, '', 'ml', '', 1, 10.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 1, 0, 0, 0, NULL, '2017-08-25 09:21:44', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (447, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001562', 'dsj', '订书机', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (457, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001213', 'lys', '六一散', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0870, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (467, 'bgyplb_ycxcl', 3, 1, 'bgyplb_ycxcl', '', 'ZKM00001737', 'ylljd100L', '医疗垃圾袋100L', 'sccj_amzyc', NULL, 3, '', 'bzdw_b_9933', 'zxdw_b_1129', 1, '', 0.00, '1把/把', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (477, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000679', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'WR-13(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (487, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000020', 'htg', '红头管', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '真空', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (497, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000638', 'xkc', '夏枯草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0950, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:55:45', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (507, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_wy', 'ZKM00000435', 'bdckt', '邦迪创可贴', 'sccj_shqsyxgs', '', 3, '', 'bzdw_h', 'zxdw_p', 100, 'jldw_mg', 0.50, '0.50mg*100片/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 1, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (517, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000998', 'zyyh', '炙淫羊藿', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.8400, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (527, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000872', 'hg', '荷梗', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0500, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 10:57:05', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (537, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_w', 'ZKM00001723', 'ffdcdw', '复方丹参滴丸', 'sccj_tslzyjtgfyxgs', 'Z10950111', 3, '', 'bzdw_h', 'zxdw_w', 180, 'jldw_mg', 27.00, '27.00mg*180丸/盒', '', 0.0000, '', '', '', 1, 0.0000, 26.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (547, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_wy', 'ZKM00000170', 'jeyxy', '洁尔阴洗液', 'sccj_scewzyyxgs', 'Z10930008', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 180.00, '180.00ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 14.4600, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:02:49', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (557, 'bgyplb_yslcl', 3, 1, 'bgyplb_yslcl', '', 'ZKM00001415', 'wfbyd', '无纺布药袋', 'sccj_amzyc', '', 3, '', 'bzdw_k', 'zxdw_g', 50, '', 0.00, '50个/捆', '', 0.0000, '', 'ml', '', 2, 1.1800, 1.1800, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (567, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001584', 'jzbm10010411', '聚酯薄膜10010411', 'sccj_bx', '国械备20161280号', 3, '', 'jjdw_zhang', '', 1, '', 0.00, '张', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (577, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001673', 'zdz1000*600*750', '折叠桌1000*600*750', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-18 14:10:47', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (587, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_klj', 'ZKM00000207', 'gcxkl', '甘草锌颗粒', 'sccj_sddyhyswzygfyxgs', '国药准好h19993277', 3, '', 'bzdw_h', 'zxdw_d', 10, 'jldw_g', 1.50, '1.50g*10袋/盒', '', 0.0000, '', '', '', 1, 11.7000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:05:41', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (597, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001466', 'cscwj3#（32mm）', '彩色长尾夹3#（32mm）', 'sccj_amzyc', NULL, 3, '', 'bzdw_h', 'zxdw_h', 1, '', 0.00, '1盒/盒', '', 0.0000, '', 'ml', '', 2, 12.0000, 12.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-04-11 10:21:27', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (607, 'bgyplb_yslcl', 3, 1, 'bgyplb_yslcl', '', 'ZKM00001409', 'dxf', '大信封', 'sccj_amzyc', '', 3, '', 'bzdw_b', 'zxdw_g', 300, '', 0.00, '300个/包', '', 0.0000, '', 'ml', '', 2, 0.7000, 0.7000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (617, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsp', 'ZKM00000393', 'jgap', '甲钴胺片', 'sccj_wc（zg）yyyxgs', 'H20143107', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_mg', 0.50, '0.50mg*20片/盒', 'ad us.int', 1.0000, '', '', 'TID', 1, 32.5000, 45.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, NULL, '2018-04-19 13:43:38', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (627, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000252', 'wssCzsy', '维生素C注射液', 'sccj_shxdhs(sq)yyyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 5, 'jldw_ml', 5.00, '5ml*5支/盒', '', 0.0000, '', '', '', 1, 1.7900, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 15:00:27', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (637, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001272', 'gg', '官桂', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0300, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (647, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000364', 'dtxdty', '动态心电图仪', 'sccj_ktyxxt（qhd）gfyxgs', '', 3, '', 'jjdw_t_148', '', 1, '', 0.00, 'TLC6000', '', 0.0000, '', 'ml', '', 1, 8000.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (657, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000805', '3Mtqjbt（TX）', '3M透气胶布贴（TX）', 'sccj_w', '-', 3, '', 'jjdw_j', '', 1, '', 0.00, '12卷*盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-21 17:05:44', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (667, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001299', '75%jj', '75%酒精', 'sccj_sdaj', '-', 3, '', 'jjdw_x', '', 1, '', 0.00, '500ml*30瓶/箱', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (677, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000280', 'fssb', '防水手柄', 'sccj_TruphatekInternationalLtd', '', 3, '', 'jjdw_z', '', 1, '', 0.00, 'shucman5571', '', 0.0000, '', 'ml', '', 1, 900.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (687, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000261', 'ycxsyhyb', '一次性使用换药包', 'sccj_yzysyykjyxgs', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '常规不加碘200包/箱', '', 0.0000, '', 'ml', '', 1, 3.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 15:37:03', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (697, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001189', 'M-5Dxsy（zw/20LX1）', 'M-5D稀释液（中文/20LX1）', 'sccj_szmr', '-', 3, '', 'jjdw_x', '', 1, '', 0.00, '20L', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (707, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000886', 'bh', '薄荷', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0450, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (717, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000467', 'ysjylpazsy', '盐酸甲氧氯普胺注射液', 'sccj_scyy', '国药准字Z20090650', 3, '', 'bzdw_z', 'zxdw_ml', 1, 'jldw_mg', 10.00, '10.00mg*1ml/支', '', 0.0000, '', '', '', 1, 0.4860, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 2, NULL, '2018-05-23 14:07:36', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (727, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000750', 'qh', '青蒿', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0300, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (737, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000746', 'bxgyt', '不锈钢牙托', 'sccj_shkqylqxyxgs', 'B3124(2013)0654', 3, '', 'jjdw_ge', '', 1, '', 0.00, '2#上有孔', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (747, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rj', 'ZKM00001879', 'kfbyy', '口服补液盐', 'sccj_xaajyyyxgs', '国药准H20090205', 3, '', 'bzdw_h', 'zxdw_xd', 6, 'jldw_g', 5.13, '5.125g*6小袋/盒', '', 0.0000, '', '', '', 1, 0.0000, 32.9900, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (757, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001561', 'gmyy', '光敏印油', 'sccj_amzyc', NULL, 3, '', 'bzdw_p', 'zxdw_p_1', 1, '', 0.00, '1瓶/瓶', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (767, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001031', 'hdstjhb', '红的双头记号笔', 'sccj_amzyc', '', 3, '', 'bzdw_h', 'zxdw_z', 12, '', 0.00, '12支/盒', '', 0.0000, '', 'ml', '', 2, 1.1500, 1.1500, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-03-01 09:25:56', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (777, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000847', 'ycxsyjmlzz', '一次性使用静脉留置针', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '20G,50支/盒，Y型', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-22 17:11:53', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (787, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rj', 'ZKM00001883', 'ysxtlqdj', '盐酸西替利嗪滴剂', 'sccj_amzyc', 'hc20150029', 3, '', 'bzdw_h', 'zxdw_p_1', 1, 'jldw_ml', 30.00, '30ml*1瓶/盒', '', 0.0000, '', '', '', 1, 0.0000, 32.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (797, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsp', 'ZKM00001317', 'hpsmtlehsp', '琥珀酸美托洛尔缓释片', 'sccj_aslkzy', 'J20150044', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_mg', 47.50, '47.50mg*7片/盒', 'ad us.int', 47.5000, '', '', 'qd', 1, 14.8200, 1.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, NULL, '2018-04-04 16:49:54', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (807, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001256', 'fhdwq1712323	', '防护短围裙1712323	', 'sccj_szhkylqxyxgs		', '-', 3, '', 'jjdw_j_8137', '', 1, '', 0.00, '防护短围裙1712323', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (817, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rg', 'ZKM00000434', 'mplxrg', '莫匹罗星软膏', 'sccj_zmtjskzyyxgs', 'H10930064', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 5.00, '5.00g*1支/支', 'ad us.ext', 0.0000, '', '', 'TID', 1, 11.8500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 1, NULL, '2018-05-18 10:29:18', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (827, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_sj_2', 'ZKM00001458', 'sqgjslhjs（pfk）', '双歧杆菌三联活菌散（培菲康）', 'sccj_shsyxyycyxgs(yshxyycyxgs)', 'S10970104', 3, '', 'bzdw_h', 'zxdw_b', 6, 'jldw_g', 2.00, '2.00g*6包/盒', 'kf', 2.0000, '', '', 'mr3c', 1, 37.6500, 52.8000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 14:13:50', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (837, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_xry', 'ZKM00001638', 'xrylssdacry（wtl）', '吸入用硫酸沙丁胺醇溶液（万托林）', 'sccj_adlyGlaxoSmithKliae', 'H20160660', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_hk', 5.00, '5.00毫克*1瓶/瓶', 'Ut dict', 0.0000, '', '', '', 1, 0.0000, 6.7200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, NULL, '2018-05-15 13:12:27', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (847, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000362', 'csx（bzx）dz', '蚕丝线（编织型）带针', 'sccj_hzhwylypyxgs', '20170628420170614', 3, '', 'jjdw_h', '', 1, '', 0.00, '4-070cm。1/2,5x12单针', '', 0.0000, '', 'ml', '', 1, 220.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-24 10:08:42', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (857, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_fzj', 'ZKM00001689', 'zsyyswlde(lh)', '注射用盐酸乌拉地尔(罗浩)', 'sccj_sdlxyyjtgfyxgs', 'H20051889', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_mg', 25.00, '25.00mg*1支/支', '', 0.0000, '', '', '', 1, 0.0000, 20.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (867, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000137', 'jxzp', '甲硝唑片', 'sccj_hzyygfyxgs', 'H42020388', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_g', 0.20, '0.20g*100片/瓶', 'kf', 0.6000, '', '', 'mr3c', 1, 6.3400, 3.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 1, NULL, '2018-06-15 11:27:25', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (877, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000867', 'yyc（protaper ntgk-jy25h）', '牙用锉（protaper 镍钛根扩-机用25混）', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mmSX-F36*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (887, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_rg', 'ZKM00000155', 'mylsxzcg', '马应龙麝香痔疮膏', 'sccj_mylyyjtgfyxgs', '国药准字z42021920', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 10.00, '10.00g*1支/支', '', 0.0000, '', '', '', 1, 8.7000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:37:32', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (897, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001304', 'shyypb', '生化仪样品杯', 'sccj_jskjylqxyxgs		', '-', 3, '', 'jjdw_b', '', 1, '', 0.00, '500个/包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (907, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001454', 'ysjylpazsy', '盐酸甲氧氯普胺注射液', 'sccj_shhfzyyxgs', 'H31021522', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 1.00, '1.00ml*1支/支', '', 0.0000, '', '', '', 2, 0.1000, 0.1400, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 3, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (917, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tptj', 'ZKM00000441', 'mbwcjn', '美宝胃肠胶囊', 'sccj_Abbott Biologicals B.V.', '', 3, '', 'bzdw_p', 'zxdw_l', 50, 'jldw_g', 0.50, '0.50g*50粒/瓶', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (927, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000885', 'jrcr', '酒肉苁蓉', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.9520, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (937, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001657', 'cgshdxfhzkp-sp2（5ml*6）', '常规生化多项复合质控品-水平2（5ml*6）', 'sccj_glyltyldzyxgs', '20162400050', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 689.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (947, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000413', 'yytlw（semtlw）', '医用弹力袜（舒尔美弹力袜）', 'sccj_rbgdgyzshs_6795', '', 3, '', 'jjdw_s', '', 1, '', 0.00, '束小腿', '', 0.0000, '', 'ml', '', 1, 90.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (957, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000452', '0.9%lhnzsy', '0.9%氯化钠注射液', 'sccj_dzzy', '国药准字H44020184', 3, '', 'bzdw_p', 'zxdw_ml', 100, 'jldw_g', 0.90, '0.90g*100ml/瓶', 'Iv', 100.0000, '', '', 'St', 1, 3.5100, 4.9000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 20, 3, NULL, '2018-05-07 10:12:18', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (967, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00000527', 'lsmzsy', '硫酸镁注射液', 'sccj_tjjyyyyxgs', 'H12020994', 3, '', 'bzdw_z', 'zxdw_ml', 10, 'jldw_g', 2.50, '2.50g*10ml/支', 'Iv', 2.5000, '', '', 'qd', 2, 9.8000, 13.7200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, NULL, '2018-04-19 10:38:03', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (977, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001242', 'cwj（32mm）', '长尾夹（32mm）', 'sccj_amzyc', '', 3, '', 'bzdw_h', 'zxdw_h', 1, '', 0.00, '1盒/盒', '', 0.0000, '', 'ml', '', 2, 12.0000, 12.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (987, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000271', 'lgxwwhjp', '冷光纤维弯喉镜片', 'sccj_TruphatekInternationalLtd', '', 3, '', 'jjdw_z', '', 1, '', 0.00, 'shucman2系列52411号弯', '', 0.0000, '', 'ml', '', 1, 900.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (997, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001418', 'yyljt', '医用垃圾桶', 'sccj_bjkylsmyxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '30L脚踏式', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1007, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001599', 'zjzth 0.25*50mm', '针灸针套盒 0.25*50mm', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1017, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000738', 'qtbytz', '嵌体备牙套装', 'sccj_shdb', '--', 3, '', 'jjdw_t', '', 1, '', 0.00, 'FG0908D', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1027, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001184', 'ssq', '生神曲', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0100, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1037, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001135', 'by', '白英', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0560, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1047, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001172', 'xm', '仙茅', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.5600, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1057, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000458', 'zsys', '注射用水', 'sccj_dzzy', '', 3, '', 'bzdw_z', 'zxdw_ml', 10, 'jldw_ml', 1.00, '1.00ml*10ml/支', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 20, 10, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1067, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000625', 'yymjd', '医用灭菌袋', 'sccj_shjzylqxbzgfyxgs', '------', 3, '', 'jjdw_j', '', 1, '', 0.00, '55*200', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1077, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001073', 'ycxsyslyt', '一次性使用塑料牙托', 'sccj_w', '-', 3, '', 'jjdw_f', '', 1, '', 0.00, '415/416小号', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1087, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001019', 'jgscz', '金刚砂车针', 'sccj_w', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'WR-13C', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1097, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001303', 'ycxgmj', '一次性肛门镜', 'sccj_yzsyn', '-', 3, '', 'jjdw_x', '', 1, '', 0.00, '20个/包,400支/箱，B型', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1107, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001101', 'jgscz', '金刚砂车针', 'sccj_lntczyyxgs', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'BR-46', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1117, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001041', 'crbyq', '成人拔牙钳', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '53R#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-29 18:18:11', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1127, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001449', 'ysdbazsy', '盐酸多巴胺注射液', 'sccj_shhfzyyxgs', 'H31021174', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 2.00, '2.00ml*1支/支', '', 0.0000, '', '', '', 1, 3.5480, 4.9700, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 3, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1137, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000605', 'Hc', 'H锉', 'sccj_xnddsb', '国械备20170214号', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm-35（绿）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1147, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001666', 'EDTAnj6g', 'EDTA凝胶6g', 'sccj_llswyy（wh）yxgs', '鄂械注准20162632242', 3, '', 'jjdw_z', '', 1, '', 0.00, '支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1157, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001411', 'qpq', '启瓶器', 'sccj_dgblgfhxyxgs', '-', 3, '', 'jjdw_t', '', 1, '', 0.00, '小开启青霉素钠', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1167, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00000459', 'rrmmcxxjs（HCG）jcszt', '人绒毛膜促性腺激素（HCG）检测试纸条', 'sccj_lszswyy（bj）yxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '20A-3.0mm', '', 0.0000, '', 'ml', '', 1, 2.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1177, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000742', 'jlh', '金莲花', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0700, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1187, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000950', 'ggctq（czjyq-st）', '根管充填器（垂直加压器-双头）', 'sccj_shkqylqxyxgs', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'KRCP#9/11', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1197, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000675', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'TR-15(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1207, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001535', 'jjmp', '酒精棉片', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1217, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001725', 'blrych', '玻璃如意茶壶', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1227, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000623', 'yymjd', '医用灭菌袋', 'sccj_cqql', '卫消字（2012）第0009号', 3, '', 'jjdw_j', '', 1, '', 0.00, '200*200', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1237, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000307', 'zzn', '组织镊', 'sccj_shylqx（jt）yxgsssqxc', '', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'J4111020CM1X2钩', '', 0.0000, '', 'ml', '', 1, 21.6800, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1247, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000868', 'yhxdxysmt', '氧化锌丁香油水门汀', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '2瓶*10g粉，1瓶*6ml', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1257, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000947', 'NTIkcpgl', 'NTI烤瓷抛光轮', 'sccj_w', '-', 3, '', 'jjdw_z_5693', '', 1, '', 0.00, '银灰色', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1267, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001635', 'mxsxy', '免洗手消液', 'sccj_sdxhyl		', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1277, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000283', 'ptxyj', '普通血压计', 'sccj_shyyylsbyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, 'TH839S', '', 0.0000, '', 'ml', '', 1, 90.0000, 0.0000, 'fylb_tjf', 'fpxm_tjf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 16:50:18', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1287, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001151', 'ycxyyt', '一次性牙椅套', 'sccj_hnsyylqxyxgs', '豫长食药监械（准）字2012', 3, '', 'jjdw_t', '', 1, '', 0.00, '3*500/件', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 10:17:53', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1297, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001467', 'xxyjz', '心相印卷纸', 'sccj_amzyc', NULL, 3, '', 'bzdw_t_6064', 'zxdw_j', 10, '', 0.00, '10泡/提', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-02 13:52:53', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1307, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_rj', 'ZKM00001818', 'xcy（cs）', '新草药（测试）', 'sccj_gxnnbhyy', 'GB9999', 3, '', 'bzdw_b', 'zxdw_kg_g', 10, 'jldw_g', 20.00, '20g/包', '', 0.0000, '', '', '', 1, 0.0000, 55.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1317, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001569', 'jsq bs', '计时器 白色', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1327, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_hsp', 'ZKM00000048', 'kczy2', '库存中药2', 'sccj_bjsykyy', '214124', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', '', '', 1, 0.0000, 10.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1337, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001431', 'ycxtyms', '一次性涂药毛刷', 'sccj_hb/kt', '-', 3, '', 'jjdw_t_5432', '', 1, '', 0.00, '白色小号100支/筒4筒/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1347, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001668', 'lgltp（an）', '罗格列酮片（爱能）', 'sccj_cdhrzyyxgs', '国药准字H20030569', 3, '', 'bzdw_h', 'zxdw_p', 14, 'jldw_mg', 4.00, '4.00mg*14片/盒', '', 0.0000, '', '', '', 1, 0.0000, 33.0500, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1357, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_hj', 'ZKM00000284', 'flkhj', '肺力咳合剂', 'sccj_gzjxyyyxgs', 'z20025136', 3, '', 'bzdw_h', 'zxdw_p_1', 1, 'jldw_ml', 100.00, '100.00ml*1瓶/盒', '', 0.0000, '', '', '', 1, 18.6100, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-19 12:42:01', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1367, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001060', 'czq', '持针器', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '粗针直型140mm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1377, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000711', 'dg', '当归', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.5040, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 17:37:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1387, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001253', 'ws', '瓦松', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0450, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1397, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000781', 'zyz', '制远志', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.7840, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1407, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001450', 'zzn	', '组织镊	', 'sccj_shjz', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '把', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1417, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000762', 'qkwktp', '全口无孔托盘', 'sccj_rxckclyxgs', '沪食药监械生产许可20000061号', 3, '', 'jjdw_ge', '', 1, '', 0.00, '1#下', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1427, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001662', 'knpgs', '口内抛光刷', 'sccj_dgslgylqxyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1437, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000720', 'ggczTF', '根管锉针TF', 'sccj_Ormcocorporat Ion Also sa ', '国械注进20162062999', 3, '', 'jjdw_h', '', 1, '', 0.00, '23mm-混/04.06.08', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 08:52:04', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1447, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001069', 'xgj', '巡更机', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 368.0000, 368.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1457, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001661', 'ffntjgzzsy', '复方脑肽节苷脂注射液', 'sccj_jlbczyyxgs', 'H22026472', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 2.00, '2.00ml*1支/支', 'Iv', 2.0000, '', '', 'qd', 1, 0.0000, 167.7000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 600, 100, NULL, '2018-05-28 15:42:24', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1467, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001124', 'xjxydbksjcsjh（tysmf）', '细菌性阴道病快速检测试剂盒（唾液酸酶法）', 'sccj_zhdeswgcyxgs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '50T/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1477, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001065', 'tynjxt', '通用粘接系统', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '41282补充装', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1487, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000516', 'ysp', '油纱片', 'sccj_sxfke', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '10*10cm', '', 0.0000, '', 'ml', '', 1, 30.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1497, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000281', 'hjzyh', '喉镜专用盒', 'sccj_TruphatekInternationalLtd', '', 3, '', 'jjdw_z', '', 1, '', 0.00, 'shucman5570', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1507, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000054', 'xtg', '吸唾管', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_d', '', 1, '', 0.00, '袋', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1517, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000396', 'lek84xdyⅠx（84xdy）', '利尔康84消毒液Ⅰ型（84消毒液）', 'sccj_sdlekxdkjgfyxgs', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '500g', '', 0.0000, '', 'ml', '', 1, 1.5000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1527, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000453', '0.5%lhnzsy', '0.5%氯化钠注射液', 'sccj_dzzy', '', 3, '', 'bzdw_d', 'zxdw_ml', 500, 'jldw_ml', 1.00, '1.00ml*500ml/袋', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 5, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1537, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001713', 'xxbfxyqy20L', '血细胞分析用鞘液20L', 'sccj_glyltyldzyxgs', '', 3, '', 'jjdw_j_8137', '', 1, '', 0.00, '件', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1547, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000369', 'tbkwfsp', '头孢克肟分散片', 'sccj_w', '', 3, '', 'bzdw_h', 'zxdw_p', 10, 'jldw_g', 0.10, '0.10g*10片/盒', 'ad us.int', 0.1000, '', '', 'bid', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 3, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1557, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsy', 'ZKM00000421', 'ffljdhsy', '复方氯己定含漱液', 'sccj_hebltyyyxgs', 'H20064451', 3, '', 'bzdw_p', 'zxdw_ml', 300, 'jldw_ml', 1.00, '1.00ml*300ml/瓶', '', 0.0000, '', '', '', 1, 12.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 1, NULL, '2018-02-10 22:20:47', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1567, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_kfy', 'ZKM00001477', 'rgtkfy', '乳果糖口服液', 'sccj_bjhmypyxgs', 'H20065730', 3, '', 'bzdw_h', 'zxdw_p_1', 1, 'jldw_ml', 100.00, '100.00ml*1瓶/盒', 'kf', 30.0000, '', '', 'mr1c', 1, 30.6000, 35.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 14:16:34', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1577, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001478', 'xxbfxyyzkw（wfl）	', '血细胞分析仪用质控物（五分类）	', 'sccj_szmr', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1587, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001164', 'ycxmscxq', '一次性末梢采血器', 'sccj_szslylqxyxgs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '26G*1.8mm50支/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 13:05:49', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1597, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000734', 'zn', '樟脑', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 0.0000, '', '', '', 1, 0.1000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1607, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000925', 'ggc（Kc-25h）', '根管锉（K锉-25混）', 'sccj_mnzshs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm15-40#6*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1617, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000739', 'sqs', '生芡实', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.2350, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1627, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000953', 'wmy', '无名异', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1200, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1637, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000576', 'dfz', '大风子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 0.0000, '', '', '', 1, 0.0720, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1647, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001165', 'dlg', '煅龙骨', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.2630, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1657, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001415', 'ztfhwl1712605', '直条防护围领1712605', 'sccj_szhkylqxyxgs		', '-', 3, '', 'jjdw_t_7475', '', 1, '', 0.00, '0.50铅当量', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1667, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001452', 'wssB6zsy', '维生素B6注射液', 'sccj_fzhwfyzyyxgs', 'H35020493', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 1.00, '1.00ml*1支/支', '', 0.0000, '', '', '', 1, 0.3500, 0.4900, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 3, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1677, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000797', 'mq（TX）', '棉签（TX）', 'sccj_w', '-', 3, '', 'jjdw_b', '', 1, '', 0.00, '6*1包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-14 16:23:59', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1687, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001606', 'xddhp', '西地碘含片', 'sccj_bjhszygfyxgs', '1709291', 3, '', 'bzdw_h', 'zxdw_p', 45, 'jldw_mg', 1.50, '1.50mg*45片/盒', '', 0.0000, '', '', '', 1, 0.0000, 26.8000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1697, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000729', 'stxrzzt', '手调型软质重体', 'sccj_dgDMGhxyyjtgs', '国械注进20172630622', 3, '', 'jjdw_t', '', 1, '', 0.00, '909019', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-14 13:18:07', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1707, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001291', 'ycxwhxrmz', '一次性雾化吸入面罩', 'sccj_gzwl', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '维力8cm/个B型儿童型', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1717, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001375', 'bxgsbg', '不锈钢纱布罐', 'sccj_njhrylsbyxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '141*130mm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1727, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001393', 'ygxfp', '有盖小方盘', 'sccj_gdscaxczysylqxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '230*150*50', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1737, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001420', 'lfdyp（kpf）', '洛芬待因片（可普芬）', 'sccj_gyjtgyyxgs', 'H20020514', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_hk', 12.50, '12.50毫克*20片/盒', 'ad us.int', 12.5000, '', '', 'Q6h', 1, 28.4400, 39.8200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1747, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001271', 'yyqj	', '移液器架	', 'sccj_dlxcsyyq（bj）yxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '旋转型', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1757, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001563', 'A4fyz', 'A4复印纸', 'sccj_amzyc', NULL, 3, '', 'bzdw_j_4203', 'zxdw_b', 8, '', 0.00, '8包/件', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1767, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000371', 'aqmsp', '阿奇霉素片', 'sccj_w', '', 3, '', 'bzdw_h', 'zxdw_p', 4, 'jldw_g', 0.25, '0.25g*4片/盒', 'ad us.int', 0.5000, '', '', 'qd', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 5, NULL, '2018-03-09 14:35:34', 1, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1777, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001301', 'jgc', '鸡骨草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0900, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1787, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000421', 'ycxsywjzsqdz', '一次性使用无菌注射器带针', 'sccj_shkdlqyfzjtgfyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '2.5ml', '', 0.0000, '', 'ml', '', 1, 0.3100, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-24 10:14:36', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1797, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001057', 'yyssj', '眼用手术剪', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '直尖头10cm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1807, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001338', 'gyqq', '高压气枪', 'sccj_tzhyyl', '-', 3, '', 'jjdw_t_148', '', 1, '', 0.00, '枪身+单头+管', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1817, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000412', 'ycxsyjmsyz', '一次性使用静脉输液针', 'sccj_jxhdylqxjtyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '0.6#', '', 0.0000, '', 'ml', '', 1, 0.2000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1827, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00001586', 'fkzjn', '氟康唑胶囊', 'sccj_hrzyyxgs', '国药准字H10960164', 3, '', 'bzdw_h', 'zxdw_l', 1, 'jldw_g', 0.15, '0.15g*1粒/盒', '', 0.0000, '', '', '', 1, 41.0700, 41.0700, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1837, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000277', 'ycxyyxjjcst（wf）', '一次性医用橡胶检查手套（无粉）', 'sccj_dd', '', 3, '', 'jjdw_h', '', 1, '', 0.00, 'TLFCMD46100无粉大号（6.0）乳白色100只/盒，10盒/箱', '', 0.0000, '', 'ml', '', 1, 36.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 15:38:42', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1847, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tptj', 'ZKM00000429', 'plxkt', '吡罗昔康贴', 'sccj_hgSKhgzshs', '', 3, '', 'bzdw_h', 'zxdw_t', 3, 'jldw_t', 1.00, '1.00贴*3贴/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1857, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rj', 'ZKM00001884', 'cs', '测试', 'sccj_pflzer italla srl', '', 3, '', 'bzdw_k_10382', 'zxdw_k_6141', 12, 'jldw_IU', 3.00, '3IU*12颗/颗', '', 0.0000, '', '', '', 1, 0.0000, 23.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1867, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000808', 'qc', '拳参', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1340, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1877, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000444', 'gmsjp', '高锰酸钾片', 'sccj_jnkfszyyxgs', '', 3, '', 'bzdw_h', 'zxdw_b_7638', 2, 'jldw_p', 24.00, '24.00片*2板/盒', 'ad us.ext', 1.0000, '', '', 'qd', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, NULL, '2018-03-01 16:43:06', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1887, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_crp', 'ZKM00001568', 'asplcrp（baspl）', '阿司匹林肠溶片（拜阿司匹灵）', 'sccj_beyybjyxgs', 'J20171021', 3, '', 'bzdw_h', 'zxdw_p', 30, 'jldw_hk', 100.00, '100.00毫克*30片/盒', 'ad us.int', 100.0000, '', '', 'qd', 1, 15.4000, 21.5600, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1897, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rgj', 'ZKM00001705', 'dsqhkdsrg（yze）', '丁酸氢化可的松乳膏（尤卓尔）', 'sccj_tjjyyyyxgs', 'H10940095', 3, '', 'bzdw_z', 'zxdw_kg_g', 10, 'jldw_%', 0.10, '0.10%*10g/支', 'thc_2', 0.1000, '', '', 'mr2c', 1, 0.0000, 13.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 10:42:20', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1907, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_pj', 'ZKM00000083', 'shp', '三黄片', 'sccj_hbryyygfyxgs(yhbryyyyxgs)', '国药准字z42020649', 3, '', 'bzdw_h', 'zxdw_p', 54, 'jldw_g', 0.26, '0.26g*54片/盒', '', 0.0000, '', '', '', 1, 2.1600, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:50:48', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1917, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000491', 'fngzsy', '非那根注射液', 'sccj_dd', '', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_mg', 25.00, '25.00mg*10支/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1927, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001327', 'blsnzsy', '玻璃酸钠注射液', 'sccj_shjfzy', 'h2000643', 3, '', 'bzdw_h', 'zxdw_z', 1, 'jldw_mg', 25.00, '25.00mg*1支/盒', '', 0.0000, '', '', '', 1, 112.5500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 16:47:26', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1937, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_tgj', 'ZKM00000503', 'xttg', '消痛贴膏', 'sccj_xcqz', 'z54020113', 3, '', 'bzdw_h', 'zxdw_t', 5, 'jldw_ml', 2.50, '2.50ml*5贴/盒', '', 0.0000, '', '', '', 1, 64.7500, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-08 08:43:43', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1947, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001286', 'ycxPEst', '一次性PE手套', 'sccj_nceh', '-', 3, '', 'jjdw_b', '', 1, '', 0.00, '中号10包/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1957, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000074', '3Mnjj', '3M粘结剂', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '五代', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1967, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001047', 'etbyq', '儿童拔牙钳', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '1#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1977, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000723', 'hd', '黑豆', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0340, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1987, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_pj', 'ZKM00000176', 'gnap', '更年安片', 'sccj_jxtskzygfyxgs', '', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_g', 0.30, '0.3g*100片/瓶', '', 0.0000, '', '', '', 1, 7.8000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 14:15:34', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (1997, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001495', 'hw', '护腕', 'sccj_3M', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2007, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001845', 'jyzxhtz', '家用针线盒套装', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2017, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000818', 'cbt', '侧柏炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0430, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2027, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001483', 'shfhdzzkp（sp2）', '生化复合定值质控品（水平2）', 'sccj_szmr', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-15 15:27:26', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2037, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000310', 'fln', '辅料镊', 'sccj_shylqx（jt）yxgsssqxc', '', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'J4203016CM无钩', '', 0.0000, '', 'ml', '', 1, 12.8000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2047, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001217', 'cbl', '炒槟榔', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0670, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2057, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001038', 'crbyq', '成人拔牙钳', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '17#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2067, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000751', 'jgl', '金果榄', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.6000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2077, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000633', 'pgg', '抛光膏', 'sccj_Ultradert product Inc', '--', 3, '', 'jjdw_ge', '', 1, '', 0.00, '8313（草莓味）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-04-04 13:45:23', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2087, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000308', 'zzn', '组织镊', 'sccj_shylqx（jt）yxgsssqxc', '', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'J4101012.5CM1x2钩', '', 0.0000, '', 'ml', '', 1, 16.5600, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2097, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001693', 'yyj 10cmzj', '眼用剪 10cm直尖', 'sccj_shjz', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '把', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2107, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001336', 'jxc', '九香虫', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 3.9200, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2117, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_hsp', 'ZKM00000399', 'hpsmtlehsp', '琥珀酸美托洛尔缓释片', 'sccj_hlasN.V.Organon', '', 3, '', 'bzdw_h', 'zxdw_kg_g', 7, 'jldw_g', 47.50, '48g/盒', 'ad us.int', 95.0000, '', '', 'qd', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 0, 0, 0, 2, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2127, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000645', 'Z250XTcgqdgmsz', 'Z250XT超高强度光敏树脂', 'sccj_3MESPE DENTAL PRODUCT', '国械注进20153630485', 3, '', 'jjdw_z', '', 1, '', 0.00, '1470(A3)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-04-08 11:33:36', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2137, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001300', '95%jj', '95%酒精', 'sccj_sdaj', '-', 3, '', 'jjdw_x', '', 1, '', 0.00, '500ml*30瓶/箱', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2147, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000905', 'fhmztz', '防护面罩套装', 'sccj_w', '-', 3, '', 'jjdw_t', '', 1, '', 0.00, '1架/10张膜片', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2157, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000345', 'bxgwwc', '不锈钢污物车', 'sccj_njhrylsbzzyxgs', '', 3, '', 'jjdw_t_148', '', 1, '', 0.00, 'B442756*530*1075折叠式', '', 0.0000, '', 'ml', '', 1, 1200.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2167, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dj', 'ZKM00001694', 'xewmmfdj（ac）', '小儿伪麻美芬滴剂（艾畅）', 'sccj_shqsyxgs', 'H20010605', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 15.00, '15.00ml*1瓶/瓶', 'kf', 0.8000, '', '', 'm6xsyc', 1, 0.0000, 15.2200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 09:40:59', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2177, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000796', 'xqg', '西青果', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0900, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2187, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001166', 'cmy', '醋没药', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.5600, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2197, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001302', 'jmlzz', '静脉留置针', 'sccj_qdjk', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '18G/支,50支/包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2207, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_jnj', 'ZKM00001319', 'ynbyjn', '云南白药胶囊', 'sccj_ynbyjtgf', 'z53020799', 3, '', 'bzdw_h', 'zxdw_l', 32, 'jldw_g', 0.25, '0.25g*32粒/盒', '', 0.0000, '', '', '', 1, 34.1000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 17:05:12', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2217, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000737', 'SSWgscz', 'SSW高速车针', 'sccj_SSW.WHITE BURS.IN', '--', 3, '', 'jjdw_z', '', 1, '', 0.00, 'FG-701L', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2227, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001243', '2hdc', '2号电池', 'sccj_amzyc', '', 3, '', 'bzdw_h', 'zxdw_l', 2, '', 0.00, '2粒/盒', '', 0.0000, '', 'ml', '', 2, 6.9500, 6.9500, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2237, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_sj_2', 'ZKM00000493', 'ryjhs', '如意金黄散', 'sccj_jsq0qtrzyyxgs', '国药准字z32020732', 3, '', 'bzdw_h', 'zxdw_d', 10, 'jldw_g', 12.00, '12.00g*10袋/盒', '', 0.0000, '', '', '', 1, 12.0700, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-29 15:44:44', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2247, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rg', 'ZKM00001802', 'ysmnhsrg（pla）', '盐酸米诺环素软膏（派丽奥）', 'sccj_rb', 'H20150106', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 0.50, '0.50g*1支/支', '', 0.0000, '', '', '', 1, 0.0000, 45.9500, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2257, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000840', 'srx', '生乳香', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0800, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2267, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001663', 'ysxbjp（hls）', '盐酸小檗碱片（黄连素）', 'sccj_njhrylsbzzyxgs', '170502', 3, '', 'bzdw_h', 'zxdw_p', 48, 'jldw_g', 0.10, '0.10g*48片/盒', '', 0.0000, '', '', '', 2, 0.0000, 0.1200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2277, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001149', 'nthjygs', '镍钛合金牙弓丝', 'sccj_shamdclljgfyxgs', '沪械注准20162630198', 3, '', 'jjdw_d', '', 1, '', 0.00, '卵圆12L', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 09:34:35', 1, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2287, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000192', 'gysbjjn', '枸橼酸铋钾胶囊', 'sccj_fryyjtyxgs', 'h20033441', 3, '', 'bzdw_h', 'zxdw_l', 20, 'jldw_g', 0.30, '0.30g*20粒/盒', 'ad us.int', 0.3000, '', '', 'Qid', 1, 11.6800, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 10, 3, NULL, '2018-05-23 15:13:56', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2297, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000955', 'wlx', '威灵仙', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.2520, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2307, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000792', 'ch', '柴胡', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.7280, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2317, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000851', 'ggkdz', '根管扩大针', 'sccj_mnzshs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm10H6*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2327, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsp', 'ZKM00001515', 'dyxajfhsp（tnl）', '对乙酰氨基酚缓释片（泰诺林）', 'sccj_shqszyyxgs', 'H20010394', 3, '', 'bzdw_h', 'zxdw_p', 6, 'jldw_g', 0.65, '0.65g*6片/盒', 'ad us.int', 0.6500, '', '', 'Q8h', 1, 5.8500, 7.0200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 10, 5, NULL, '2018-05-24 11:15:36', 1, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2337, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001529', 'xtszjz', '血糖试纸机子', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2347, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_xrrj', 'ZKM00000449', 'xryyxbgasry', '吸入用乙酰半胱氨酸溶液', 'sccj_ZambonS.P.A', 'H20150548', 3, '', 'bzdw_h', 'zxdw_ml', 3, 'jldw_g', 0.30, '0.30g*3ml/盒', 'Ut dict', 0.0000, '', '', '', 2, 13.4100, 18.7700, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 1, NULL, '2018-05-02 11:31:05', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2357, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001327', 'ycxkytqd', '一次性口咽通气道', 'sccj_gzwl', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '1#70mm，白色', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2367, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001589', 'jsq', '计时器', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2377, 'bgyplb_ycxcl', 3, 1, 'bgyplb_ycxcl', '', 'ZKM00001876', 'mhtzN85', '墨盒套装N85', 'sccj_amzyc', NULL, 3, '', 'bzdw_t_2940', 'zxdw_t_9446', 1, '', 0.00, '1套/套', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2387, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000077', 'tmj', '脱敏剂', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '120g', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2397, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001188', 'nyszt', '尿液试纸条', 'sccj_glylt', '-', 3, '', 'jjdw_t_5432', '', 1, '', 0.00, '100T/筒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2407, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000374', 'sxp304', '肾形盘304', 'sccj_gdscaxctqsylqxc', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '小号304', '', 0.0000, '', 'ml', '', 1, 10.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2417, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000350', 'fhl', '防护帘', 'sccj_szshkylqxyxgs', '', 3, '', 'jjdw_j_8137', '', 1, '', 0.00, '400*470', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2427, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001569', 'lhnzsy', '氯化钠注射液', 'sccj_hbtyyygfyxgs', 'H42021838', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 10.00, '10.00ml*1支/支', '', 0.0000, '', '', '', 1, 0.2800, 2.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2437, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001276', 'sbp	', '纱布片	', 'sccj_ncxh		', '-', 3, '', 'jjdw_b', '', 1, '', 0.00, '6*8*8cm,300片/包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2447, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_pj', 'ZKM00000187', 'xgsrhp', '西瓜霜润喉片', 'sccj_glsjyygfyxgs', 'Z45021646', 3, '', 'bzdw_h', 'zxdw_p', 24, 'jldw_g', 0.60, '0.60g*24片/盒', '', 0.0000, '', '', '', 1, 4.1600, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-19 11:35:58', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2457, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000664', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'SR-12(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2467, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001003', 'hhp', '合欢皮', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.0560, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2477, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001063', 'gzq/yyjgq', '刮治器/牙用洁刮器', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, 'SG5/69Gracey刮治器-5/6', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2487, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000181', 'kytqd', '口咽通气道', 'sccj_kdyckjyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '70mm白色', '', 0.0000, '', 'ml', '', 1, 4.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2497, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001227', 'xhd', '雄黑豆', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.0390, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2507, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000214', '3M ylzqmjzsbq', '3M 压力蒸汽灭菌指示标签', 'sccj_3Mzg', '', 3, '', 'jjdw_zhang', '', 1, '', 0.00, '1322L', '', 0.0000, '', 'ml', '', 1, 3.6000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2517, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000498', 'dpw', '吊瓶网', 'sccj_zd', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '100ml', '', 0.0000, '', 'ml', '', 1, 0.3800, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2527, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000772', 'pgy', '蒲公英', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.0560, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2537, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_kfy', 'ZKM00001662', 'kbdkf', '抗病毒口服', 'sccj_gzdzzyyxgs', '201708012', 3, '', 'bzdw_h', 'zxdw_z', 18, 'jldw_ml', 10.00, '10.00ml*18支/盒', '', 0.0000, '', '', '', 2, 0.0000, 30.5600, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-06-28 17:39:40', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2547, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rj', 'ZKM00001819', 'xxy（cs）', '新西药（测试）', 'sccj_sccj（cs）', 'GB8888', 3, '', 'bzdw_h', 'zxdw_p_1', 10, 'jldw_ml', 20.00, '20.00ml*10瓶/盒', '', 0.0000, '', '', '', 1, 0.0000, 36.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-06-26 02:20:17', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2557, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000545', 'cs', '常山', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.0200, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 15:36:49', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2567, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001232', 'bbl', '半边莲', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.1900, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2577, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_jnj', 'ZKM00000350', 'xscrjn', '消栓肠溶胶囊', 'sccj_smxsnwzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_h', 24, 'jldw_g', 0.20, '0.20g*24盒/盒', '', 0.0000, '', '', '', 1, 44.5000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2587, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001034', 'yt', '牙挺', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '空心六角柄SS21/2', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2597, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001170', 'cclz', '炒川楝子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.0450, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2607, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001150', 'yjj', '牙胶尖', 'sccj_tjjfylqxyxgs', '国食药监械（准）字2014第3630623', 3, '', 'jjdw_h', '', 1, '', 0.00, '15-40', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2617, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dj', 'ZKM00000282', 'blfhxdj(ml）', '布洛芬混悬滴剂(美林）', 'sccj_shqszyyxgs', 'h19991012', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 15.00, '15.00ml*1瓶/瓶', 'kf', 1.2500, '', '', 'bys', 1, 9.5500, 12.9900, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 10:08:17', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2627, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000593', 'Kc', 'K锉', 'sccj_xnddsb', '国械备20170214号', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm-20', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2637, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001543', 'yyfslfl', '医用凡士林敷料', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_p_10962', '', 1, '', 0.00, '片', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2647, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000807', 'ddc', '淡豆豉', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.0670, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2657, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001142', 'ycqz', '盐车前子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.1120, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2667, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000516', 'tsgD3p（geqD）', '碳酸钙D3片（钙尔奇D）', 'sccj_hszyyxgs', 'H10950029', 3, '', 'bzdw_p', 'zxdw_p', 60, 'jldw_g', 0.60, '0.60g*60片/瓶', 'ad us.int', 0.6000, '', '', 'qd', 1, 50.5000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 2, 1, NULL, '2018-03-01 17:09:04', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2677, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000438', 'jjb', '急救包', 'sccj_w', '-', 3, '', 'jjdw_t', '', 1, '', 0.00, '1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_qt', 'fpxm_tjf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-21 18:29:29', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2687, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000993', 'ycxsyjbq/hht', '一次性使用搅拌器/混合头', 'sccj_w', '-', 3, '', 'jjdw_b', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2697, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001567', '9Vdc', '9V电池', 'sccj_amzyc', NULL, 3, '', 'bzdw_b_4606', 'zxdw_l', 1, '', 0.00, '1粒/板', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2707, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001492', 'pfskjdR1547', '皮肤伤口胶带R1547', 'sccj_3M', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2717, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000155', 'mq', '棉球', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_d', '', 1, '', 0.00, '袋', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2727, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000303', 'lswfb', '蓝色无纺布', 'sccj_mnsdkyzzyxgs', '', 3, '', 'jjdw_zhang', '', 1, '', 0.00, '90cm*90cm120张/箱', '', 0.0000, '', 'ml', '', 1, 4.5840, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 14:17:50', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2737, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00001129', 'ycxkeq', '一次性窥耳器', 'sccj_wlylsb（sz）yxgs', '美国进口', 3, '', 'jjdw_b', '', 1, '', 0.00, '850个/包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-01 17:56:48', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2747, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001287', 'ycxmz', '一次性帽子', 'sccj_jxym		', '-', 3, '', 'jjdw_b', '', 1, '', 0.00, '100个/包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2757, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000541', 'gyszcdsjh（mf）', '甘油三酯测定试剂盒（酶法）', 'sccj_glyltyldzyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '50ml*6校准品1ml', '', 0.0000, '', 'ml', '', 1, 564.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2767, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_pj', 'ZKM00000056', 'fsmp', '呋塞米片', 'sccj_shchyyyxgs', '', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 20.00, '20mg*100片/瓶', '', 0.0000, '', '', '', 1, 9.2000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-06 15:38:09', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2777, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00001190', 'lqjkyjcsjh（rjf）', '淋球菌抗原检测试剂盒（乳胶法）', 'sccj_hzab', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '20T', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2787, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000508', 'ycxrjzxd', '一次性乳胶止血带', 'sccj_kw', '', 3, '', 'jjdw_t_7475', '', 1, '', 0.00, '单条装', '', 0.0000, '', 'ml', '', 1, 1.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2797, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001036', 'xqbj', '削铅笔机', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 15.0000, 15.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2807, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dyj', 'ZKM00000398', 'tbmsdsmsdyy（dbs）', '妥布霉素地塞米松滴眼液（典必殊）', 'sccj_ALCON-COUVREUR n.v.（bls）', 'H20150119', 3, '', 'bzdw_p', 'zxdw_ml', 5, 'jldw_mg', 20.00, '20.00mg*5ml/瓶', 'O.U．', 0.1000, '', '', 'Q4h', 1, 30.2500, 38.8000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 1, NULL, '2018-06-07 16:14:52', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2817, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00000464', 'lzbd、xbdkyjcsjh（rjf）', '轮状病毒、腺病毒抗原检测试剂盒（乳胶法）', 'sccj_abswyy（hz）yxgs', '', 3, '', 'jjdw_f_9562', '', 1, '', 0.00, '25人份', '', 0.0000, '', 'ml', '', 1, 10.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2827, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000091', 'txKc 21mm', '弹性K锉 21mm', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2837, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001624', 'dbdtynjxt', '第八代通用粘结系统', 'sccj_3M ESPE Dental Products		', '国械注进20143636221', 3, '', 'jjdw_p', '', 1, '', 0.00, '瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2847, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001855', 'klmsfsp', '克拉霉素分散片', 'sccj_cdhrzyyxgs', 'H20093945', 3, '', 'bzdw_h', 'zxdw_p', 12, 'jldw_mg', 125.00, '125.00mg*12片/盒', '', 0.0000, '', '', '', 1, 0.0000, 12.1000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2857, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000667', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'SI-47(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-04-08 10:47:16', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2867, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_cj', 'ZKM00000179', 'xftdp/sjz', '辛伐他丁片/舒降之', 'sccj_hzmsdzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_mg', 20.00, '20mg*7片/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-08 12:46:48', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2877, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000686', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'TR-13C(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2887, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001699', '3Mtqjt 24j/h', '3M透气胶贴 24卷/盒', 'sccj_mnsdkyzzyyqc', '-', 3, '', 'jjdw_j', '', 1, '', 0.00, '卷', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2897, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000353', 'tsgD3p（geqD）', '碳酸钙D3片（钙尔奇D）', 'sccj_hs/zyyxgs', 'H10950029', 3, '', 'bzdw_p', 'zxdw_p', 30, 'jldw_mg', 600.00, '600.00mg*30片/瓶', '', 0.0000, '', '', '', 1, 29.9000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-05-23 15:56:34', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2907, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001675', 'ycxmscxq', '一次性末梢采血器', 'sccj_szslylqxyxgs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2917, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000901', 'csjyjgzj（ggdxz）', '超声洁牙机工作尖（根管荡洗针）', 'sccj_w', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '20#黄6*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2927, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000701', 'zcr', '紫草茸', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0530, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2937, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001037', 'crbyq', '成人拔牙钳', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '8#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2947, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000725', 'Z350XTgghldsz', 'Z350XT光固化流动树脂', 'sccj_3MESPE DENTAL PRODUCT', '--', 3, '', 'jjdw_z', '', 1, '', 0.00, '7032/A22*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2957, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000774', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '国械注进20152552079', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'F0-40EF(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2967, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001852', '2cyklzsj', '2层亚克力展示架', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2977, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00000465', 'jx/yxlgbdkyjcsjh（jtjf）', '甲型/乙型流感病毒抗原检测试剂盒（胶体金法）', 'sccj_abswyy（hz）yxgs', '', 3, '', 'jjdw_f_9562', '', 1, '', 0.00, '20人份', '', 0.0000, '', 'ml', '', 1, 20.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2987, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rgj', 'ZKM00001718', 'xmsfqsrg', '新霉素氟轻松乳膏', 'sccj_gdhjzyyxgs', 'H44024191', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 20.00, '20.00g*1支/支', 'thc_2', 0.1000, '', '', 'mr2c', 1, 0.0000, 3.3000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 10:42:50', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (2997, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000966', 'ycxsymjxjwkst', '一次性使用灭菌橡胶外科手套', 'sccj_cdwjlkylypyxgs', '-', 3, '', 'jjdw_z_5693', '', 1, '', 0.00, '7.5', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3007, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000095', 'syyjjcyz 21mm', '手用牙胶尖侧压针 21mm', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3017, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000047', 'xwj', '显微镜', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '奥林巴斯CX23', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3027, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001576', 'wxgxsbM218', '无线光学鼠标M218', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3037, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001724', 'scdsslwjg', '十层带锁塑料文件柜', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3047, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000909', 'ycmbjtz（10%ysz）', '牙齿美白胶套装（10%医生装）', 'sccj_w', '-', 3, '', 'jjdw_t', '', 1, '', 0.00, 'PF10%8支*1.2ml', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3057, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000088', 'mlslbnmp', '马来酸氯苯那敏片', 'sccj_lfbzzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 4.00, '4mg*100片/瓶', '', 0.0000, '', '', '', 1, 9.9000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 11:28:50', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3067, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001486', '0.9％lhnzsy', '0.9％氯化钠注射液', 'sccj_sjzsyyxgs', 'H13023201', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_ml', 250.00, '250.00ml*1袋/袋', 'Iv', 250.0000, '', '', 'Prn', 1, 5.2000, 7.2800, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 20, 5, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3077, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_jnj', 'ZKM00000085', 'lhqwjn', '连花清瘟胶囊', 'sccj_sjzylyygfyxgs', '国药准字z20040063', 3, '', 'bzdw_h', 'zxdw_l', 24, 'jldw_g', 0.35, '0.35g*24粒/盒', '', 0.0000, '', '', '', 1, 10.8000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 13:54:44', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3087, 'hclb_gzyhp', 2, 1, 'hclb_gzyhp', '', 'ZKW00001524', 'xybhdjhy', '血氧饱和度监护仪', 'sccj_szmr', '-', 3, '', 'jjdw_t_148', '', 1, '', 0.00, '台', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3097, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001123', 'cjz', '炒芥子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1010, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3107, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000906', 'cjqkq（kjlg）', '唇颊牵开器（口角拉钩）', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '518-201 成人', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 16:49:18', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3117, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000573', 'Hc', 'H锉', 'sccj_xnddsb', '国器械20170214', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm-20', '', 0.0000, '', 'ml', '', 1, 0.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3127, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001442', 'sgbd', '石膏绷带', 'sccj_shxh', '-', 3, '', 'jjdw_j', '', 1, '', 0.00, '卷', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3137, 'bgyplb_yslcl', 3, 1, 'bgyplb_yslcl', '', 'ZKM00001508', 'std', '手提袋', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 3.3500, 3.3500, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3147, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001697', 'xjxydbjckBV 20T/h', '细菌性阴道病检测卡BV 20T/盒', 'sccj_zzatlkswgcyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3157, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001896', 'ysadtzsy（kdl）', '盐酸胺碘酮注射液（可达龙）', 'sccj_snf（hz）zyyxgs', '', 3, '', 'bzdw_z', 'zxdw_ml', 3, 'jldw_g', 0.15, '0.15g*3ml/支', '', 0.0000, '', '', '', 1, 0.0000, 195.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3167, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001837', 'dlgdj', '得力固定胶', 'sccj_amzyc', NULL, 3, '', 'bzdw_z', 'zxdw_z', 1, '', 0.00, '1支/支', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3177, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000908', 'zstccl', '暂时填充材料', 'sccj_w', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '白色30g/瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3187, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000627', 'dgm', '当归面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3197, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000866', 'slp', '石榴皮', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0450, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 10:54:46', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3207, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000195', 'yyljd', '医用垃圾袋', 'sccj_bjjrkkjyxgs', '', 3, '', 'jjdw_k', '', 1, '', 0.00, '100L', '', 0.0000, '', 'ml', '', 1, 95.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3217, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001597', 'jjcxlp', '加劲穿心莲片', 'sccj_gxcztzyyxgs', '1705163', 3, '', 'bzdw_h', 'zxdw_p', 60, 'jldw_p', 1.00, '1.00片*60片/盒', '', 0.0000, '', '', '', 1, 26.0000, 26.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3227, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001482', 'byx（FOB）jcsj	', '便隐血（FOB）检测试剂	', 'sccj_abswyy（hz）yxgs', '-', 3, '', 'jjdw_f_9562', '', 1, '', 0.00, '份', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3237, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000367', 'bxgdgfp', '不锈钢带盖放盘', 'sccj_gdscaxctqsylqxc', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '11.5寸无孔304', '', 0.0000, '', 'ml', '', 1, 44.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3247, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001836', 'cshcsz', '彩生活檫手纸', 'sccj_amzyc', NULL, 3, '', 'bzdw_j_4203', 'zxdw_b', 20, '', 0.00, '20包/件', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3257, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tptj', 'ZKM00000411', 'rsfttgp', '瑞舒伐他汀钙片', 'sccj_Abbott Biologicals B.V.', '', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_mg', 10.00, '10.00mg*7片/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3267, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00000528', 'xttg', '消痛贴膏', 'sccj_xcqzcygfyxgswtgsqzcyyxgs', 'Z54020113', 3, '', 'bzdw_h', 'zxdw_xd', 5, 'jldw_g', 1.20, '1.20g*5小袋/盒', 'ad us.ext', 1.2000, '', '', 'Prn', 1, 62.5000, 87.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 1, NULL, '2018-05-11 08:50:26', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3277, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00001356', 'zsytbqsn（lsf）', '注射用头孢曲松钠（罗氏芬）', 'sccj_shlszyyxgs', 'H10983036', 3, '', 'bzdw_h', 'zxdw_z', 1, 'jldw_g', 1.00, '1.00g*1支/盒', 'Iv', 2.0000, '', '', 'qd', 1, 46.7800, 72.7700, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 2, NULL, '2018-04-08 10:26:53', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3287, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000681', 'bhj', '白胡椒', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2730, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3297, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001502', 'qbdd', '前臂吊带', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3307, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000245', 'dxsyslzzsy', '单硝酸异山梨酯注射液', 'sccj_sdfmyyjtgfyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 5, 'jldw_ml', 5.00, '5ml*5支/盒', '', 0.0000, '', '', '', 1, 9.4000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 14:58:34', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3317, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000572', 'cz', '葱子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0600, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3327, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001358', 'jsq', '加湿器', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 199.0000, 199.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3337, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000715', 'jykkz', '机用扩孔钻', 'sccj_MANI', '国械注进20152551636', 3, '', 'jjdw_h', '', 1, '', 0.00, 'G28mm-3', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 09:30:38', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3347, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001222', '75%jj	', '75%酒精	', 'sccj_sdlekxdkjgfyxgs', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '100ml/瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3357, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001082', 'ggc', '根管锉', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, 'MANIH-FILES10#-21mm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3367, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001490', 'cwj（19mm）', '长尾夹（19mm）', 'sccj_amzyc', NULL, 3, '', 'bzdw_h', 'zxdw_h', 1, '', 0.00, '1盒/盒', '', 0.0000, '', 'ml', '', 2, 8.0000, 8.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3377, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000899', 'shf', '松花粉', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.5040, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3387, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001550', 'xdtz', '心电图纸', 'sccj_ssdt', '-', 3, '', 'jjdw_b_2336', '', 1, '', 0.00, '本', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3397, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000839', 'ggtcq(cyz-S25h)', '根管填充器(侧压针-S25混)', 'sccj_mnzshs', 'R171122800', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm15-40#6*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 35.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3407, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001835', 'tsl9263', '铁书立9263', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3417, 'bgyplb_dzl', 3, 1, 'bgyplb_dzl', '', 'ZKM00001733', 'Up', 'U盘', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3427, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000295', 'fhwssBp', '复合维生素B片', 'sccj_cddyzyyxgs(ycddyyyyxgs)', '', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_p', 100.00, '100片*1瓶/瓶', '', 0.0000, '', '', '', 1, 10.8000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 11:31:23', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3437, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000810', 'qnj', '千年健', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0500, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3447, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001509', 'ycxkqqxh（ycxwj）', '一次性口腔器械盒（一次性围巾）', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_t_7475', '', 1, '', 0.00, '条', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3457, 'hclb_gzyhp', 2, 1, 'hclb_gzyhp', '', 'ZKW00001117', 'jnnkj', '胶囊内窥镜', 'sccj_gzhglbyyyxgs', '国械注进20173220628', 3, '', 'jjdw_l', '', 1, '', 0.00, '粒', '', 0.0000, '', 'ml', '', 1, 0.0000, 2000.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3467, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00001623', 'gyhqry', '过氧化氢溶液', 'sccj_gdhjzyyxgs', '170902', 3, '', 'bzdw_p', 'zxdw_ml', 100, 'jldw_％', 3.00, '3.00％*100ml/瓶', '', 0.0000, '', '', '', 1, 0.0000, 3.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3477, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001160', 'ycxsycyyg', '一次性使用肠营养管', 'sccj_shsykgyyqxyxgs', '沪食药监械（准）字2013第2661468号', 3, '', 'jjdw_b', '', 1, '', 0.00, 'II型（16F）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 11:38:35', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3487, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000841', 'ykmp', '牙科膜片', 'sccj_w', '-', 3, '', 'jjdw_p_10962', '', 1, '', 0.00, '厚1.5mm透明10片/包', '', 0.0000, '', 'ml', '', 1, 0.0000, 15.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3497, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000960', 'ycxfhb', '一次性缝合包', 'sccj_yzsyaylqxyxgs', '-', 3, '', 'jjdw_z_5693', '', 1, '', 0.00, '清创缝合型', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-28 09:09:32', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3507, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001439', 'xtcsz  lr', '血糖测试纸  灵睿', 'sccj_akswjs（hz）yxgs		', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3517, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000065', 'xlz', '夕粒子', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '25*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3527, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000211', '3M 1322zqmjzsjd', '3M 1322蒸汽灭菌指示胶带', 'sccj_3Mzg', '', 3, '', 'jjdw_j', '', 1, '', 0.00, '24mmX55M', '', 0.0000, '', 'ml', '', 1, 60.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3537, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000081', 'zfcl', '暂封材料', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '白/粉', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3547, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001489', 'xcg', '血沉管', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3557, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001321', 'cz', '抽纸', 'sccj_amzyc', '', 3, '', 'bzdw_x', 'zxdw_b', 24, '', 0.00, '24包/箱', '', 0.0000, '', 'ml', '', 2, 3.3300, 3.3300, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3567, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001070', 'gyslt', '感应水龙头', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 298.0000, 298.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3577, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000050', 'ftp', '酚酞片', 'sccj_lfbzzyyxgs', 'h14022492', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 100.00, '100.00mg*100片/瓶', '', 0.0000, '', '', '', 1, 6.1000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 09:04:17', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3587, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_crp', 'ZKM00000488', 'asplcrp', '阿司匹林肠溶片', 'sccj_dd', '', 3, '', 'bzdw_h', 'zxdw_p', 30, 'jldw_g', 0.10, '0.10g*30片/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3597, 'bgyplb_yslcl', 3, 1, 'bgyplb_yslcl', '', 'ZKM00001410', 'blt', '病例套', 'sccj_amzyc', '', 3, '', 'bzdw_b', 'zxdw_g', 250, '', 0.00, '250个/包', '', 0.0000, '', 'ml', '', 2, 2.8200, 2.8200, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3607, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000006', 'bektj', '宝儿康糖浆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1.00g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 1, 0, 0, 0, '2017-07-13 00:00:00', '2018-08-16 14:28:49', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3617, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000016', 'jyhl', '金银花露', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3627, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000026', 'lsnj', '六神凝胶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3637, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000036', 'xeybkl.', '小儿咽扁颗粒.', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3647, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000046', 'tdp', '铁笛片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3657, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000056', 'sxzgg', '麝香壮骨膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/袋', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3667, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000066', 'ssztg', '伤湿止痛膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/袋', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3677, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000076', 'qyzgg', '强腰壮骨膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3687, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000086', 'rbcms', '壬苯醇醚栓', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3697, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000096', 'sybtw', '嗣育保胎丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3707, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000106', 'hkxy', '黄苦洗液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3717, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000116', 'zqnytp(bst)', '左炔诺孕酮片(保仕婷)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3727, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000126', 'bfknj', '保妇康凝胶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3737, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000136', 'hhqgssww', '红花清肝十三味丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3747, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000146', 'dsp', '胆石片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3757, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000156', 'lhqwjn', '连花清瘟胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3767, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000166', 'ypfkl', '玉屏风颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3777, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000176', 'cbzktj', '川贝止咳糖浆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3787, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000186', 'bxzktj', '半夏止咳糖浆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3797, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000196', 'sdcpy', '蛇胆陈皮液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3807, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000206', 'lltdkqbjp', '氯雷他定口腔崩解片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3817, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000216', 'ffdyxajfp(ii)', '复方对乙酰氨基酚片(ii)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3827, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000226', 'blfhsjn(fbd)', '布洛芬缓释胶囊(芬必得)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3837, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000236', 'sldap', '沙利度胺片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3847, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000246', 'axzjn（abl）', '奥硝唑胶囊（奥博林）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3857, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000256', '@jxzp', '@甲硝唑片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3867, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000266', 'cyjn', '参一胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3877, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000276', 'xjp', '小金片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3887, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000286', 'rgnhjxzjn', '人工牛黄甲硝唑胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3897, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000296', 'lnzp', '螺内酯片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3907, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000306', 'tljn', '通淋胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3917, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000316', 'lgltnp(tl)', '罗格列酮纳片(太罗)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3927, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000326', '@xkw', '@消渴丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3937, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000336', '*dndrg(lyz)', '*地奈德乳膏(力言卓)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3947, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rg', 'ZDS90000346', 'hmsrg', '红霉素软膏', 'sccj_mylyyjtgfyxgs', '171017', 3, '', 'bzdw_z', 'zxdw_kg_g', 10, 'jldw_%', 1.00, '1.00%*10g/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 2.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-11 16:34:55', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3957, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000356', 'gy', '甘油', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3967, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_wy', 'ZDS90000366', 'fyj', '风油精', 'sccj_gdhjzyyxgs', '170803', 3, '', 'bzdw_p', 'zxdw_ml', 5, 'jldw_dw', 1.00, '1.00单位*5ml/瓶', '', 0.0000, '', 'ml', '', 1, 5.0000, 5.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 1, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-10 14:47:35', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3977, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000376', 'plwxqwj(sjk)', '吡硫翁锌气雾剂(适今可)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3987, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000386', 'syqwj', '湿疡气雾剂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (3997, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000396', 'agnhw', '安宫牛黄丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4007, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000406', 'pdlxyp', '蒲地蓝消炎片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 1, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4017, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000416', 'dbsjp(mdb)', '多巴丝肼片(美多芭)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4027, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000426', 'lptp(wst)', '利培酮片(维思通)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4037, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000436', 'zylxtp(kpl)', '左乙拉西坦片(开浦兰)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4047, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000446', 'ksl', '开塞露', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4057, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZDS90000456', 'gysbjp/txzp/klmspzh（lzwsl）', '枸橼酸铋钾片/替硝唑片/克拉霉素片组合（丽珠维三联）', 'sccj_lzjtlzzyc', '国药准字H10900084', 3, '', 'bzdw_h', 'zxdw_p', 8, 'jldw_g', 0.00, '0.00g*8片/盒', 'kf', 0.6000, '', 'ml', 'mr2c', 1, 20.8300, 29.1600, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 3, '2017-07-13 00:00:00', '2018-05-24 15:23:57', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4067, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZDS90000466', 'jwxsp', '健胃消食片', 'sccj_jxgnhxyygfyxgs', '17061005', 3, '', 'bzdw_h', 'zxdw_p', 72, 'jldw_g', 0.50, '0.50g*72片/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 20.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-11 16:13:40', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4077, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000476', 'sqgjrgjslhjp（jsq）', '双歧杆菌乳杆菌三联活菌片（金双歧）', 'sccj_nmgsqyygfyxgs', 's19980004', 3, '', 'bzdw_h', 'zxdw_h', 1, 'jldw_p', 36.00, '36.00片*1盒/盒', '', 0.0000, '', 'ml', '', 1, 29.7000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-24 09:07:22', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4087, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000486', 'wklkl', '胃康灵颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4097, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000496', '@hpsmtlehsp(btlk)', '@琥珀酸美托洛尔缓释片(倍他乐克)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1.00g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-03-09 14:31:54', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4107, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000506', 'yxytqwp(jnd)', '银杏叶提取物片(金纳多)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4117, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000516', 'xbdphsp(ii)', '硝苯地平缓释片(ii)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4127, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000526', 'ebstqlsqp(abn)', '厄贝沙坦氢氯噻嗪片(安博诺)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4137, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000536', 'sqtsjn', '三七通舒胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4147, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000546', 'gtelsnkfry(raj)', '果糖二磷酸钠口服溶液(瑞安吉)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4157, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000556', 'ffhybxkfy', '复方红衣补血口服液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4167, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000566', 'qyydhsgdyy(stl)', '七叶洋地黄双苷滴眼液(施图伦)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4177, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000576', 'bzqydyy', '冰珍去翳滴眼液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4187, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000586', 'jcxcmft', '接触性创面敷贴', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/袋', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4197, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000596', 'dwtkfry', '多维铁口服溶液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4207, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_cj', 'ZDS90000606', '@kfbyys（i）', '@口服补液盐散（i）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/袋', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-09-11 14:46:29', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4217, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000616', 'jjmq', '酒精棉球', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4227, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000626', 'lwdhw', '六味地黄丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4237, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000636', '@smy（dcf）', '@生脉饮（党参方）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4247, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000004', '3Myyxdxsy', '3M医用消毒洗手液', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '500ml', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4257, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000014', 'jmsylzz', '静脉输液留置针', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '24号（儿童）', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4267, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000024', 'ycxcd', '一次性床单', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '120cm*220cm(10个/包）', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4277, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000034', 'ycxjjb', '一次性急救包', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4287, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000044', '95%jj', '95%酒精', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '500ml', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4297, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000054', 'wkn：hm', '无抗凝：红帽', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '100支每盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4307, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000064', 'ycxkqzxmb', '一次性口腔止血棉棒', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '50个每捆', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4317, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000074', 'jzcxp', '聚酯成型片', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '100片每盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4327, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000084', 'gxjymc', '硅橡胶印膜材', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4337, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000094', 'ycxslymtp', '一次性塑料牙模托盘', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '3号', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4347, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000104', 'xty', '血糖仪', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4357, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000005', 'hqm', '红曲米', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4367, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000015', 'sdh', '熟地黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4377, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000025', 'dcd', '党参段', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4387, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000035', 'ydz', '盐杜仲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4397, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000045', 'lq', '连翘', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4407, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000055', 'yc', '茵陈', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4417, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000065', 'bs', '白术', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4427, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000075', 'bzhjs', '扁枝槲寄生', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4437, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000085', 'yhb', '盐黄柏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4447, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000095', 'bh', '薄荷', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4457, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000105', 'dg', '当归', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4467, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000115', 'bs', '白术', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4477, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000125', 'bh', '百合', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4487, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000135', 'dgz', '冬瓜子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4497, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000145', 'fg', '粉葛', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4507, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000155', 'csg', '川射干', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4517, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000165', 'ytsz', '盐菟丝子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4527, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000175', 'glp', '瓜蒌皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4537, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000185', 'pgy', '蒲公英', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4547, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000195', 'ybgz', '盐补骨脂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4557, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000205', 'blg', '板蓝根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4567, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000215', 'bsc', '北沙参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4577, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000225', 'mg', '木瓜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4587, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000235', 'hy', '荷叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4597, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000245', 'chmr', '炒火麻仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4607, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000255', 'bhssc', '白花蛇舌草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4617, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000265', 'xkqc', '夏枯全草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4627, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000275', 'fczk', '麸炒枳壳', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4637, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000285', 'ctlz', '炒葶苈子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4647, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000295', 'cmy', '炒麦芽', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4657, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000305', 'lzg', '芦竹根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4667, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000315', 'kc', '苦参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4677, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000325', 'xb', '薤白', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4687, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000335', 'mkdh', '蜜款冬花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4697, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000345', 'cglz', '炒瓜蒌子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4707, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000355', 'ct', '蝉蜕', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4717, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000365', 'mmhr', '蜜麻黄绒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4727, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000375', 'fcyyr', '麸炒薏苡仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4737, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000385', 'sjm', '石决明', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4747, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000395', 'hsf（yyhsf）', '滑石粉（药用滑石粉）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4757, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000405', 'mxfh', '蜜旋覆花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4767, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000415', 'jwss', '酒乌梢蛇', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4777, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000425', 'tsz', '烫水蛭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4787, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000435', 'zc', '紫草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4797, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000445', 'gk', '蛤壳', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4807, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000455', 'tgj', '烫狗脊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4817, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000465', 'mbb', '蜜百部', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4827, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000475', 'cjl', '炒蒺藜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4837, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000485', 'zzm', '珍珠母', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4847, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000495', 'ysj', '油松节', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4857, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000505', 'cjq', '炒建曲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4867, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000515', 'clfz', '炒莱菔子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4877, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000525', 'szr', '酸枣仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4887, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000535', 'cmy', '醋没药', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4897, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000545', 'mdp', '牡丹皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4907, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000555', 'sph', '生蒲黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4917, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000565', 'flp', '茯苓皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4927, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000575', 'dyt', '地榆炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4937, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000585', 'cnbz', '炒牛蒡子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4947, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000595', 'cmjz', '炒蔓荆子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4957, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000605', 'bxq', '半夏曲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4967, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000615', 'mx', '木香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4977, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000625', 'sy', '山药', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4987, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000635', 'dxt', '大血藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (4997, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000645', 'yhb', '盐黄柏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5007, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000655', 'xxc', '豨莶草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5017, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000665', 'xd', '续断', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5027, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000675', 'jcnx', '酒川牛膝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5037, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000685', 'xy', '辛夷', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5047, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000695', 'xqg', '西青果', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5057, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000705', 'zl', '泽兰', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5067, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000715', 'ych', '银柴胡', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5077, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000725', 'cbj', '醋鳖甲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5087, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000735', 'jqbhs', '金钱白花蛇', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5097, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000745', 'jcnx', '酒川牛膝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5107, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000755', 'lyr', '龙眼肉', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5117, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000765', 'zzm', '珍珠母', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5127, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000775', 'rdt', '忍冬藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5137, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000785', 'crx', '醋乳香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5147, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000795', 'cwzy', '炒吴茱萸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5157, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000805', 'jzr', '姜竹茹', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5167, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000815', 'hy', '荷叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5177, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000825', 'sh', '石斛', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5187, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000835', 'yjcz', '盐韭菜子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5197, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000845', 'nsz', '南山楂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5207, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000855', 'bj', '白及', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5217, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000865', 'mxfh', '蜜旋覆花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5227, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000875', 'hhl', '胡黄连', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5237, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000885', 'hj', '花椒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5247, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000895', 'yhb', '盐黄柏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5257, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000905', 'kb', '昆布', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5267, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000915', 'qct', '茜草炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5277, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000925', 'zc', '紫草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5287, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000935', 'rg', '肉桂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5297, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000945', 'gj', '干姜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5307, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000955', 'jm', '椒目', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5317, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000965', 'hhp', '合欢皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5327, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000975', 'dzzm', '煅珍珠母', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5337, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000985', 'dg', '当归', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5347, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000995', 'zych', '竹叶柴胡', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5357, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001005', 'bl', '槟榔', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5367, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001015', 'mh.', '麻黄.', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5377, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001025', 'jst', '鸡矢藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5387, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001035', 'cmx', '川木香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5397, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001045', 'mkdh', '蜜款冬花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5407, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001055', 'mh', '麻黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5417, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001065', 'dyqs', '煅阳起石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5427, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001075', 'jsz', '焦山楂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5437, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001085', 'ydz', '盐杜仲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5447, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001095', 'mmh(r)', '蜜麻黄(绒)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5457, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001105', 'xlc', '响铃草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5467, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001115', 'dc.', '丹参.', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5477, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001125', 'hjs', '槲寄生', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5487, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001135', 'mz', '木贼', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5497, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001145', 'bzr', '柏子仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5507, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001155', 'md', '麦冬', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5517, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001165', 'es', '莪术', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5527, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001175', 'nx', '牛膝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5537, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001185', 'sr', '砂仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5547, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001195', 'zs', '赭石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5557, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001205', 'dh', '独活', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5567, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001215', 'czk', '炒枳壳', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5577, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001225', 'dqy', '大青盐', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5587, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001235', 'yspx', '盐桑螵蛸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5597, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001245', 'fcbs', '麸炒白术', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5607, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001255', 'sjc', '石见穿', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5617, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001265', 'fp', '浮萍', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5627, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001275', 'gs', '甘松', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5637, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001285', 'wy', '乌药', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5647, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001295', 'cx', '沉香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5657, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001305', 'xf', '香附', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5667, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001315', 'hx', '藿香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5677, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001325', 'jst', '酒蛇蜕', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5687, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001335', 'hph', '厚朴花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5697, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001345', 'sr', '砂仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5707, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001355', 'cszr', '炒山枝仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5717, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001365', 'dj', '大蓟', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5727, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001375', 'yjh', '盐橘核', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5737, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001385', 'ml', '牡蛎', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5747, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001395', 'hq.', '黄芪.', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5757, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001405', 'ccp', '炒陈皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5767, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001415', 'whg', '无花果', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5777, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001425', 'gqz', '枸杞子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5787, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001435', 'zl', '重楼', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5797, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001445', 'mh', '麻黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5807, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001455', 'bhssc', '白花蛇舌草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5817, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001465', 'mg', '木瓜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5827, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001475', 'mzc', '猫爪草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5837, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001485', 'cjmz', '炒决明子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5847, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001495', 'cjnj', '炒鸡内金', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5857, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001505', 'yzz', '预知子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5867, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001515', 'hhh', '合欢花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5877, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001525', 'cnbz', '炒牛蒡子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5887, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001535', 'zs', '针砂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5897, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001545', 'blg', '板蓝根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5907, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001555', 'wwz', '五味子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5917, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001565', 'xtc', '小通草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5927, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001575', 'ay', '艾叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5937, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001585', 'ssg', '生石膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5947, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001595', 'bj', '鳖甲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5957, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001605', 'sy', '桑叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5967, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001615', 'lx', '莲须', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5977, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001625', 'mc', '虻虫', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5987, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001635', 'fbx', '法半夏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (5997, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001645', 'yxc', '鱼腥草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6007, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001655', 'hft', '海风藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6017, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001665', 'btw', '白头翁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6027, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001675', 'czs', '炒枳实', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6037, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001685', 'ddc', '地丁草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6047, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001695', 'xqc', '豨签草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6057, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001705', 'pht', '蒲黄炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6067, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001715', 'fg', '粉葛', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6077, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001725', 'hft', '海风藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6087, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001735', 'cjxc', '炒九香虫', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6097, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001745', 'mzc', '猫爪草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6107, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001755', 'yzj', '一支箭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6117, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001765', 'dqy', '大青叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6127, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001775', 'zlt', '棕榈炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6137, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001785', 'mxfh', '蜜旋覆花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6147, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001795', 'wm', '乌梅', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6157, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001805', 'fczs', '麸炒枳实', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6167, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001815', 'szr', '酸枣仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6177, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001825', 'cgs', '醋甘遂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6187, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001835', 'bfp', '白附片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6197, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001845', 'xr', '香薷', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6207, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001855', 'zs', '朱砂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6217, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001865', 'yzz', '预知子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6227, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001875', 'ccp', '炒陈皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6237, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001885', 'fl', '茯苓', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6247, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001895', 'ybjt', '盐巴戟天', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6257, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001905', 'gs', '狗肾', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6267, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001915', 'dhrs', '煅花蕊石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6277, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001925', 'mppy', '蜜枇杷叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6287, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001935', 'gbp', '藁本片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6297, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001945', 'mc', '虻虫', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6307, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001955', 'txr', '甜杏仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6317, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001965', 'cyhs', '醋延胡索', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6327, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001975', 'csj', '醋山甲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6337, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001985', 'gg', '葛根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6347, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001995', 'crx', '醋乳香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6357, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002005', 'btl', '白土苓', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6367, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002015', 'wy', '乌药', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6377, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002025', 'lyh', '六月寒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6387, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002035', 'axx', '安息香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6397, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002045', 'ylzh', '盐荔枝核', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6407, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002055', 'qc', '茜草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6417, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002065', 'dg', '当归', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6427, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002075', 'lxh', '凌霄花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6437, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002085', 'jh', '菊花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6447, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002095', 'cby', '侧柏叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6457, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002105', 'ej', '阿胶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6467, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002115', 'cs', '辰砂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6477, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002125', 'csl', '醋三棱', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6487, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002135', 'ymz', '亚麻子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6497, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002145', 'wys', '望月沙', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6507, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002155', 'clff', '炒露蜂房', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6517, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002165', 'gz', '桂枝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6527, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZMK90002175', 'dfs', '煅浮石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 10.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-02-26 11:01:48', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6537, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002185', 'bfp', '白附片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6547, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002195', 'cmy', '醋没药', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_7` VALUES (6557, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002205', 'bjhx', '八角茴香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
COMMIT;

-- ----------------------------
-- Table structure for drug_resource_8
-- ----------------------------
DROP TABLE IF EXISTS `drug_resource_8`;
CREATE TABLE `drug_resource_8` (
  `id` bigint unsigned NOT NULL DEFAULT '0' COMMENT '主键',
  `drug_res_type_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT ' 药品和物资类型ID(dw_drug_res_type.id)',
  `base_type` tinyint NOT NULL DEFAULT '0' COMMENT '物品类型：1-药品, 2-耗材, 3-办公用品',
  `status` int DEFAULT '1' COMMENT '药品状态: 0 - 停用, 1 - 使用',
  `type_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药品或者耗材类别的字典ID(dw_dictionary.id AND dw_dictionary.type_id=[yplb OR hclb])',
  `dict_dosage_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药品剂型的字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypjx)',
  `code` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '集团编码',
  `pym` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '拼音简码',
  `name` varchar(64) CHARACTER SET utf8 DEFAULT '' COMMENT '药品或者耗材的名称',
  `manufacturer_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '生产厂家的字典ID(dw_dictionary.id AND dw_dictionary.type_id=sccj)',
  `approval_no` varchar(100) CHARACTER SET utf8 DEFAULT NULL COMMENT '批准文号',
  `med_type` int DEFAULT '3' COMMENT '医保分类： 1 - 无自付, 2 - 部分自付, 3 - 全自付',
  `admin_code` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药监编码',
  `pack_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '包装单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypdw)',
  `min_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '最小单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypdw)',
  `pack_quantity` int DEFAULT '1' COMMENT '包装含量',
  `dosage_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '剂量单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=jldw)',
  `dosage_quantity` decimal(10,2) DEFAULT '0.00' COMMENT '剂量含量',
  `pack_spec` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '包装规格，生成规则：[剂量含量] [剂量单位] * [包装含量] [最小单位] / [包装单位]',
  `take_method_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '用法(默认用法)(dw_dictionary.id AND dw_dictionary.type_id=ypyf)',
  `take_quantity` decimal(36,4) DEFAULT '0.0000' COMMENT '用量(默认用量)',
  `take_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '用量单位字典ID - 暂留字典',
  `take_unit_name` varchar(36) CHARACTER SET utf8 DEFAULT 'ml' COMMENT '用量单位名称，默认ml',
  `take_frequency` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '频率(默认频率)(dw_dictionary.id AND dw_dictionary.type_id=yppl)',
  `common_unit_type` int DEFAULT '1' COMMENT '常规单位类型: 1 - 包装单位(packUnit), 2 - 最小单位(minUnit)',
  `purchase_price` decimal(8,4) DEFAULT '0.0000' COMMENT '进货价: 单位 元',
  `sale_price` decimal(8,4) DEFAULT '0.0000' COMMENT '基准价: 单位 元',
  `cost_category_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '费用类别字典ID(dw_dictionary.id AND dw_dicitionary.type_id=fylb)',
  `invoice_item_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '发票项目字典ID - 暂留',
  `expensive_flag` int DEFAULT '1' COMMENT '贵重物品标识： 0 - 非贵重物品， 1 - 贵重物品',
  `psy_flag_i` int DEFAULT '0' COMMENT ' 精神I类药品标识：0 - 非选中， 1 - 选中',
  `psy_flag_ii` int DEFAULT '0' COMMENT '精神II类药品标识：0 - 非选中，1 - 选中',
  `otc_flag` int DEFAULT '0' COMMENT 'OTC标识：0 - 非选中， 1 - 选中',
  `nar_flag` int DEFAULT '0' COMMENT '麻醉药品标识：0 - 非选中， 1 - 选中',
  `inventory_upper` int DEFAULT '0' COMMENT '库存上限',
  `inventory_lower` int DEFAULT '0' COMMENT '库存下限',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  `modify_time` datetime DEFAULT NULL COMMENT '修改时间',
  `del_flag` int DEFAULT '0' COMMENT '删除标志:  0 - 未删除, 1 - 已删除',
  `consumable_type` int NOT NULL DEFAULT '0' COMMENT '耗材类型:1-国产,2-进口',
  `tips` varchar(1024) CHARACTER SET utf8 DEFAULT NULL COMMENT '药品使用注意事项',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

-- ----------------------------
-- Records of drug_resource_8
-- ----------------------------
BEGIN;
INSERT INTO `drug_resource_8` VALUES (8, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rgj', 'ZKM00001630', 'hmsyg（TX）', '红霉素眼膏（TX）', 'sccj_njhjyyyxgs', '170605', 3, '', 'bzdw_z', 'zxdw_kg_g', 2, 'jldw_％', 0.50, '0.50％*2g/支', '', 0.0000, '', '', '', 1, 0.0000, 6.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (18, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001365', 'fhz', '缝合针', 'sccj_hzhw		', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '圆头带针不可吸收缝合针5.040包/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (28, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000578', 'Hc', 'H锉', 'sccj_xnddsb', '国器备20170214', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm-40', '', 0.0000, '', 'ml', '', 1, 0.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (38, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000967', 'qh', '羌活', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1.00g*1g/克', '', 10.0000, '', '', '', 1, 1.0640, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (48, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00000491', 'hhbfnxhmsj（APTT）cdsjh（rhs）（ngf）', '活化部分凝血活酶时间（APTT）测定试剂盒（鞣花酸）（凝固法）', 'sccj_shtyswjsyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '10*1.5ml0.025mol/1cac121*25', '', 0.0000, '', 'ml', '', 1, 100.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (58, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001229', 'sbbd	', '纱布绷带	', 'sccj_ hsk', '-', 3, '', 'jjdw_j', '', 1, '', 0.00, '卷（5列）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (68, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001349', 'lb', '鹿鞭', 'sccj_trt', '', 3, '', 'bzdw_t', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 1.0000, '', '', '', 1, 500.0000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (78, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000787', 'dqy', '大青叶', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0440, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (88, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000985', 'jzz', '焦栀子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1230, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (98, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001043', 'A4tmsxb', 'A4透明书写板', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 12.0000, 12.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (108, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_wy', 'ZKM00000346', 'yjsp75%xdjj', '伊洁士牌75%消毒酒精', 'sccj_scsyjsylkjyxgs', '', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 100.00, '100.00ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 1.7400, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (118, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001746', '5%pttzsy（sp）', '5%葡萄糖注射液（塑瓶）', 'sccj_sjzsyyxgs', 'H13022474', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 250.00, '250.00ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 0.0000, 1.0300, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (128, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_xrj', 'ZKM00000451', 'xrybdndhxy', '吸入用布地奈德混悬液', 'sccj_AstraZenecaPtyLtd', 'H20140475', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 2.00, '2.00ml*1支/支', 'Inhal', 0.0000, '', '', '', 1, 14.3200, 20.0500, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, NULL, '2018-05-15 11:32:59', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (138, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000958', 'dgnb（lg）', '带盖尿杯（蓝盖）', 'sccj_cdswsclc', '-', 3, '', 'jjdw_z_5693', '', 1, '', 0.00, '40ml', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (148, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001283', 'dhm', '大黄面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/支', '', 10.0000, '', '', '', 1, 0.1000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (158, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tj', 'ZKM00001625', 'bzlat（bd）', '苯扎氯铵贴（邦迪）', 'sccj_shqsyxgs', '160725M', 3, '', 'bzdw_h', 'zxdw_p', 100, 'jldw_mm', 25.00, '25.00mm*100片/盒', '', 0.0000, '', '', '', 2, 0.0000, 0.2900, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-05-17 17:25:18', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (168, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_wj', 'ZKM00000116', 'lwdhw', '六味地黄丸', 'sccj_zjwxzygfyxgs', '国药准字Z41022186', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_w', 200.00, '200.00丸*1瓶/瓶', '', 0.0000, '', '', '', 1, 14.9000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 13:46:38', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (178, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_klj', 'ZKM00000213', 'xecgtrkl', '小儿柴桂退热颗粒', 'sccj_khyyjt', 'Z20050716', 3, '', 'bzdw_h', 'zxdw_d', 12, 'jldw_g', 5.00, '5.00g*12袋/盒', '', 0.0000, '', '', '', 1, 23.2100, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-19 11:50:44', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (188, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000644', 'Z350 XTnms', 'Z350 XT纳米树', 'sccj_3MESPE DENTAL PRODUCT', '国械注进20153630485', 3, '', 'jjdw_z', '', 1, '', 0.00, '7018（A3）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (198, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001646', 'wssCp（TX）', '维生素C片（TX）', 'sccj_gdhjzyyxgs', '170816', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 100.00, '100.00mg*100片/瓶', '', 0.0000, '', '', '', 1, 0.0000, 3.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (208, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001206', 'hpxm', '海螵蛸面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.1100, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (218, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000053', 'nxsj', '凝血试剂', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (228, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001175', 'xfh', '旋覆花', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0900, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (238, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001108', 'bq', '菝葜', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0760, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (248, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001669', 'gxmbj40%', '高效美白剂40%', 'sccj_Ultradert product Inc', '', 3, '', 'jjdw_t', '', 1, '', 0.00, '套', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (258, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000657', 'Honigumgxjqt', 'Honigum硅橡胶轻体', 'sccj_dgDMGhxyyjtgs', '--', 3, '', 'jjdw_t', '', 1, '', 0.00, '909892', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (268, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_pj', 'ZKM00000081', 'cxlp（bmy）', '穿心莲片（薄膜衣）', 'sccj_gzbyshjhpzyyxgs', '国药准字Z44021764', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_p', 80.00, '80.00片*1瓶/瓶', '', 0.0000, '', '', '', 1, 7.5000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 13:51:01', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (278, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000832', 'cph', '炒蒲黄', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.3640, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (288, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001141', 'cjc', '炒僵蚕', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.9520, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (298, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001280', 'syt', '输液贴', 'sccj_jxak		', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '70*35*100s/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (308, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_pj', 'ZKM00000091', 'sjgmp', '桑菊感冒片', 'sccj_lytsyyyxzrgs', '国药准字z41020434', 3, '', 'bzdw_h', 'zxdw_p', 1, 'jldw_p', 48.00, '48.00片*1片/盒', '', 0.0000, '', '', '', 1, 3.3000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 13:52:26', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (318, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000721', 'djst', '丁腈手套', 'sccj_mdkylypmy（sh）yxgs', '国械备20150109', 3, '', 'jjdw_h', '', 1, '', 0.00, '无粉小号', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-01 14:06:59', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (328, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000349', 'lxg', '离心管', 'sccj_jskdylypyxgs', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '1.5ml500只/包', '', 0.0000, '', 'ml', '', 1, 15.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (338, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001050', 'etbyq', '儿童拔牙钳', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '5#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (348, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000380', 'bxgfgwjxydsyj', '不锈钢方管五脚型移动输液架', 'sccj_njhrylsbzzyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, 'C053φ450*1350-1900', '', 0.0000, '', 'ml', '', 1, 465.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (358, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001450', 'wssB1zsy', '维生素B1注射液', 'sccj_hzmsyyyxgs', 'H33020079', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 2.00, '2.00ml*1支/支', '', 0.0000, '', '', '', 1, 0.4800, 0.6700, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 3, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (368, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000760', 'yyctq', '牙用充填器', 'sccj_Hu-FriecMfg.CO.,LLC', '--', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'PFIDDCASS', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (378, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000575', 'H c', 'H 锉', 'sccj_xnddsb', '国器备20170214', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm-30', '', 0.0000, '', 'ml', '', 1, 0.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (388, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000813', 'wy', '乌药', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.1230, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (398, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000212', 'yyycxbpd', '医用一次性备皮刀', 'sccj_jscfylsyyxgs', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '100支/包', '', 0.0000, '', 'ml', '', 1, 2.1500, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-24 10:04:39', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (408, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001136', 'dymydgwdzsjmgB', '第一磨牙单管网底直丝颊面管B', 'sccj_hzxyckclyxgs', '浙食药监械（准）字2014第2630177号', 3, '', 'jjdw_d', '', 1, '', 0.00, '62BK-20J-26(20*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-04 16:49:35', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (418, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000131', 'yszyfsxjn', '盐酸左氧氟沙星胶囊', 'sccj_cdhrzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_l', 20, 'jldw_g', 0.10, '0.1g*20粒/盒', '', 0.0000, '', '', '', 1, 4.8000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-08-14 16:28:34', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (428, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000586', 'mhj', '蜜槐角', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0680, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (438, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001373', 'ycxsyyyxjjcst', '一次性使用医用橡胶检查手套', 'sccj_amksmyyxgs		', '-', 3, '', 'jjdw_x', '', 1, '', 0.00, '大（6.6）100只每盒10盒每箱（无粉、麻面耐用型）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (448, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000830', 'kjb', '口镜柄', 'sccj_shylqx（jt）yxgsssqxc', '沪虹械备20150210号', 3, '', 'jjdw_z', '', 1, '', 0.00, '柄', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (458, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_cj_1', 'ZKM00000195', 'gcxty', '骨刺消痛液', 'sccj_bjtrtkjfzgfyxgs', '', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 300.00, '300ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 14.8000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 14:22:15', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (468, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001137', 'yxc', '鱼腥草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0450, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (478, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000445', 'zszkcxg', '紫色真空采血管', 'sccj_jskjylqxyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '13*75mm/2ml', '', 0.0000, '', 'ml', '', 1, 0.5000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (488, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000666', 'skz', '三颗针', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 0.0000, '', '', '', 1, 0.0430, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (498, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_pj', 'ZKM00000331', 'aszlp', '艾司唑仑片', 'sccj_sdxyzyyxgs', 'H37023047', 3, '', 'bzdw_p_1730', 'zxdw_p', 1, 'jldw_mg', 1.00, '1.00mg*1片/片', '', 0.0000, '', '', '', 1, 0.2160, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 1, 0, 0, 0, 0, NULL, '2018-06-07 16:26:08', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (508, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001064', 'kgy', '快干油', 'sccj_amzyc', '', 3, '', 'bzdw_p', 'zxdw_p_1', 1, '', 0.00, '1瓶/瓶', '', 0.0000, '', 'ml', '', 2, 8.8000, 8.8000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (518, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001496', 'hzLh', '护肘L号', 'sccj_3M', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (528, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001310', 'ycxzxd', '一次性止血带', 'sccj_czkr', '-', 3, '', 'jjdw_b', '', 1, '', 0.00, '40M/包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (538, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_ryj', 'ZKM00000544', 'fl', '茯苓', 'sccj_bjbdwxswkjyxgs', '', 3, '', 'bzdw_f', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (548, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001225', 'jd(xj)	', '剪刀(线剪)	', 'sccj_shjz', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '16cm/把', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (558, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001087', 'yksztcq/szctq', '牙科树脂填充器/树脂充填器', 'sccj_w', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'E1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (568, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000265', 'qgcgyds（qgcgds）', '气管插管引导丝（气管插管导丝）', 'sccj_xxstrylqxyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, 'Fr12', '', 0.0000, '', 'ml', '', 1, 4.5000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-15 10:33:20', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (578, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000487', 'ycxsywjzjz', '一次性使用无菌针灸针', 'sccj_bjkydylypc', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '0.25*25支', '', 0.0000, '', 'ml', '', 1, 0.1000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (588, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001340', 'csz', '炒山楂', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0500, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (598, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001544', 'ysxxsldjp', '盐酸消旋山莨菪碱片', 'sccj_hzmsyyyxgs', 'H33021706', 3, '', 'bzdw_p', 'zxdw_p', 1, 'jldw_mg', 5.00, '5.00mg*1片/瓶', 'kf', 5.0000, '', '', 'mr3c', 2, 1.3800, 2.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 11:24:39', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (608, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001543', 'qltqccp（ysm）', '屈螺酮炔雌醇片（优思明）', 'sccj_beyyyxgs', 'J20130120', 3, '', 'bzdw_h', 'zxdw_p', 21, 'jldw_hk', 3.00, '3.00毫克*21片/盒', 'kf', 3.0000, '', '', 'mr1c', 1, 110.5000, 2.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 1, NULL, '2018-05-24 14:10:55', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (618, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001140', 'sdh', '熟大黄', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.1680, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (628, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001574', 'dxpp（ad）', '地西泮片（安定）', 'sccj_bjymyyyxgs', 'H11020898', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_mg', 2.50, '2.50mg*20片/盒', 'Ut dict', 0.0000, '', '', '', 1, 4.8600, 6.8000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (638, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000154', 'yysb', '医用纱布', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_d', '', 1, '', 0.00, '袋', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (648, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dj', 'ZKM00000268', 'ysxtlqdj', '盐酸西替利嗪滴剂', 'sccj_amzyc', 'hc20150029', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 20.00, '20.00ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 23.6400, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-19 11:51:43', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (658, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000300', 'xfttp/sjz', '辛伐他汀片/舒降之', 'sccj_hzmsdzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_mg', 20.00, '20mg*7片/盒', '', 0.0000, '', '', '', 1, 20.6300, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 11:05:02', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (668, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001011', 'jgscz', '金刚砂车针', 'sccj_w', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'SF-12', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (678, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000824', 'tzytgxfcl', '同种异体骨修复材料', 'sccj_EA', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '0.5ml', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (688, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000591', 'Kc', 'K锉', 'sccj_xnddsb', '国械备20170214号', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm-8', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (698, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001576', 'gkp', '广口瓶', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (708, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000893', 'yhz', '咬合纸', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '20片/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (718, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_kfy', 'ZKM00000508', 'byskfy', '鼻渊舒口服液', 'sccj_cdthjkkjjt', 'z51020208', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_ml', 10.00, '10.00ml*10支/盒', 'ad us.int', 10.0000, '', '', 'TID', 1, 21.1300, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 1, 0, 10, 3, NULL, '2018-04-19 11:52:53', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (728, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_hj', 'ZKM00000520', 'byskfy（wt）', '鼻渊舒口服液（无糖）', 'sccj_cdthjkkjjtgfyxgshszyc', 'Z51020208', 3, '', 'bzdw_h', 'zxdw_z', 6, 'jldw_ml', 10.00, '10.00ml*6支/盒', 'ad us.int', 10.0000, '', '', 'TID', 1, 16.2000, 22.6800, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 10, 2, NULL, '2018-04-19 13:54:34', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (738, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001731', 'yd', '圆凳', 'sccj_amzyc', NULL, 3, '', 'bzdw_b_9933', 'zxdw_b_1129', 1, '', 0.00, '1把/把', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (748, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001346', 'zxq（w）', '止血钳（弯）', 'sccj_shjz', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '18cm普通弯全齿WD', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (758, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001801', 'lxxpp', '氯硝西泮片', 'sccj_jsehyygfyxgs', 'H10930004', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_hk', 2.00, '2.00毫克*20片/盒', 'kf', 2.0000, '', '', 'm8xsyc', 1, 0.0000, 8.8900, 'fylb_xyf', 'fpxm_xyf', 0, 0, 1, 0, 0, 5, 2, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (768, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001127', 'mbj', '美白剂', 'sccj_Ultradert product Inc', '国食药监械（进）字2014第3633407号', 3, '', 'jjdw_z', '', 1, '', 0.00, '5393甜瓜味', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (778, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000027', 'whmz', '雾化面罩', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (788, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tj', 'ZKM00001553', 'bzlat（bd）', '苯扎氯铵贴（邦迪）', 'sccj_shqsyxgs', 'H10920011', 3, '', 'bzdw_h', 'zxdw_p', 100, 'jldw_hk', 0.50, '0.50毫克*100片/盒', '', 0.0000, '', '', '', 1, 18.0700, 2.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 1, NULL, '2018-05-04 15:38:25', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (798, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000146', 'yt', '牙挺', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '各型', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (808, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000694', 'ntysg', '镍钛圆丝弓', 'sccj_shamdclljgfyxgs', '沪械注准20162630198', 3, '', 'jjdw_d', '', 1, '', 0.00, '卵圆12U', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 09:36:33', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (818, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000639', 'ggywsszjy', '根管药物输送针机用', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, '25mm混', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (828, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000231', 'ycxqgcbg', '一次性气管插包管', 'sccj_hnsjqylqxyxgs', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '普通', '', 0.0000, '', 'ml', '', 1, 50.4000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (838, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001463', 'ns（UREA）cdsjh	', '尿素（UREA）测定试剂盒	', 'sccj_szmr', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (848, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_dj', 'ZKM00000062', 'yfsxdey', '氧氟沙星滴耳液', 'sccj_whnayyyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 1, 'jldw_ml', 8.00, '8ml*1支/盒', '', 0.0000, '', '', '', 1, 2.7000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-06 17:16:56', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (858, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001140', 'dymywdzsgtcD', '第一磨牙网底直丝弓托槽D', 'sccj_hzxyckclyxgs', '浙械注准20172631235', 3, '', 'jjdw_d', '', 1, '', 0.00, '8253-20B-36(20*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-04 17:01:29', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (868, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000943', 'ryycg（tmcgtz）', '乳牙预成冠（透明齿冠套装）', 'sccj_w', '-', 3, '', 'jjdw_t', '', 1, '', 0.00, '120*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (878, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rg', 'ZKM00001618', 'mplxrg', '莫匹罗星软膏', 'sccj_zmshsgbzyyxgs', '17070250', 3, '', 'bzdw_z', 'zxdw_kg_g', 10, 'jldw_％', 2.00, '2.00％*10g/支', '', 0.0000, '', '', '', 1, 0.0000, 28.6000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (888, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000700', 'ntfsg', '镍钛方丝弓', 'sccj_shamdclljgfyxgs', '沪械注准20162630198', 3, '', 'jjdw_d', '', 1, '', 0.00, '卵圆18*22U', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 09:36:27', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (898, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001400', 'jmsyq', '静脉输液器', 'sccj_jxhd		', '-', 3, '', 'jjdw_f', '', 1, '', 0.00, '5.5#500副/件25副/包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (908, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000532', 'dlgbyt', '第六感避孕套', 'sccj_jd', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '24支/盒', '', 0.0000, '', 'ml', '', 1, 14.9700, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (918, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000428', 'fln', '敷料镊', 'sccj_shylqx（jt）yxgsssqxc', '', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'J4203016CM', '', 0.0000, '', 'ml', '', 1, 12.8000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (928, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001403', 'tmdyj', '条码打印机', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 960.0000, 960.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (938, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000317', 'lhnzsy', '氯化钠注射液', 'sccj_hbtyyygfyxgs', '国药准字h20084468', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_mg', 90.00, '90.00mg*1支/支', '', 0.0000, '', '', '', 1, 0.2700, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:41:21', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (948, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rg', 'ZKM00000109', 'xsmkzrg', '硝酸咪康唑乳膏', 'sccj_hnwztyyyxzrgs', 'h43021530', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 20.00, '20.00g*1支/支', '', 0.0000, '', '', '', 1, 1.8000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:42:42', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (958, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000949', 'GCtbb', 'GC调拌本', 'sccj_w', '-', 3, '', 'jjdw_b_2336', '', 1, '', 0.00, '-', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (968, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000874', ' ycjtszⅠⅠ（znzyts）', ' 义齿基托树脂ⅠⅠ（自凝造牙脱水）', 'sccj_w', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '100ml/瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 12:48:26', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (978, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000607', 'Hc', 'H锉', 'sccj_xnddsb', '国械备20170214号', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm-8', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (988, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000124', 'znzyf', '自凝造牙粉', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '100*3', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (998, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000962', 'lqh', '利器盒', 'sccj_cdlekkjyxgs', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '1L', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 13:10:46', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1008, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000761', 'qkwktp', '全口无孔托盘', 'sccj_rxckclyxgs', '沪食药监械生产许可20000061号', 3, '', 'jjdw_ge', '', 1, '', 0.00, '1#上', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1018, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001022', 'ngftd', '粘固粉调刀', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '八角柄整体型式1#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1028, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000320', 'qyxmhgzsy', '去乙酰毛花苷注射液', 'sccj_shxdhpyyyxgs', 'H31021178', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 2.00, '2.00ml*1支/支', 'Iv', 2.0000, '', '', 'Q2h', 2, 68.0000, 95.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 3, NULL, '2018-04-27 15:28:41', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1038, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001192', 'jyhm', '金银花面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.5830, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1048, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001577', 'jqmzp', '甲巯咪唑片', 'sccj_mkzy（js）yxgs', 'J20160064', 3, '', 'bzdw_h', 'zxdw_p', 50, 'jldw_mg', 10.00, '10.00mg*50片/盒', 'Ut dict', 10.0000, '', '', 'qd', 1, 33.1000, 46.3400, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1058, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000422', 'tzq', '听诊器', 'sccj_3MCompany3MHealthCare', '', 3, '', 'jjdw_t_148', '', 1, '', 0.00, '3MTMLittmann', '', 0.0000, '', 'ml', '', 1, 480.0000, 0.0000, 'fylb_qt', 'fpxm_tjf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1068, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000713', 'qxz', '青箱子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0630, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1078, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000762', 'zjz', '枳椇子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0880, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 17:55:31', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1088, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001859', 'yxytqwp（jnd）', '银杏叶提取物片（金纳多）', 'sccj_dgwmspbsyc', 'H20140768', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_hk', 40.00, '40毫克*20片/盒', '', 0.0000, '', '', '', 1, 0.0000, 52.5800, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1098, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000842', 'txt', '天仙藤', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0360, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1108, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001004', 'jgscz', '金刚砂车针', 'sccj_w', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'BR-49', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1118, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001687', 'smttcq', '水门汀填充器', 'sccj_w', '17-09', 3, '', 'jjdw_d', '', 1, '', 0.00, '袋', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1128, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000157', 'jgsmt', '金刚砂磨头', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1138, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_pj', 'ZKM00001894', 'hlsqp', '黄连上清片', 'sccj_hbxlyyyxzrgs', '', 3, '', 'bzdw_h', 'zxdw_p', 36, 'jldw_p', 0.00, '0.00片*36片/盒', '', 0.0000, '', '', '', 1, 0.0000, 3.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-07-03 17:29:23', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1148, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001216', 'ycxzjz', '一次性针灸针', 'sccj_szhq', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '0.25*70mm*10支/10片/盒华佗牌', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1158, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001104', 'yjh', '盐橘核', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.2240, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1168, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_kfy', 'ZKM00000502', 'fflskdykfry', '复方磷酸可待因口服溶液', 'sccj_amzy', '', 3, '', 'bzdw_h', 'zxdw_p_1', 1, 'jldw_ml', 150.00, '150.00ml*1瓶/盒', '', 0.0000, '', '', '', 1, 17.8200, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 1, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1178, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001609', 'zjzth 0.3*50mm', '针灸针套盒 0.3*50mm', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1188, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001486', 'kdxg5ml', '刻度吸管5ml', 'sccj_w', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '支', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1198, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000259', 'asplcrp', '阿司匹林肠溶片', 'sccj_bjzxyygfyxgs(ybjzxzyc)', '', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 25.00, '25mg*100片/瓶', '', 0.0000, '', '', '', 1, 1.1000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 15:02:42', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1208, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000324', 'pttzsy（bp50%）', '葡萄糖注射液（玻瓶50%）', 'sccj_hnklyyyxgs', '国药准字H41023311', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 20.00, '20.00ml*1支/支', '', 0.0000, '', '', '', 1, 0.2480, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:55:06', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1218, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000383', 'ycxsywjxyg', '一次性使用无菌吸氧管', 'sccj_bjjxxylqxc', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '成人2M', '', 0.0000, '', 'ml', '', 1, 2.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1228, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000550', 'jsjmMBtgmcdsjh（myyzf）', '肌酸激酶MB同工酶测定试剂盒（免疫抑制法）', 'sccj_glyltyldzyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '40ml*5;10ml*5', '', 0.0000, '', 'ml', '', 1, 2680.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1238, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000669', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'TF-21EF(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1248, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001279', 'qbx', '清半夏', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.8730, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1258, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001651', 'ppg', '噗噗管', 'sccj_w', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1268, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000135', 'txzp', '替硝唑片', 'sccj_sdlkyyjtstyxzrgs', '', 3, '', 'bzdw_h', 'zxdw_p', 8, 'jldw_g', 0.50, '0.5g*8片/盒', '', 0.0000, '', '', '', 1, 2.6000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 10:49:03', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1278, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000968', 'ycxyyzd', '一次性医用中单', 'sccj_hnytylypyxgs', '豫械注准20152640571', 3, '', 'jjdw_zhang', '', 1, '', 0.00, '400*500mm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-28 09:44:40', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1288, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000124', 'aqmsjn（rt）', '阿奇霉素胶囊（蓉通）', 'sccj_scykzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_l', 6, 'jldw_g', 0.25, '0.25g*6粒/盒', '', 0.0000, '', '', '', 1, 2.4000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 10:44:56', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1298, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000375', 'sxp304', '肾形盘304', 'sccj_gdscaxctqsylqxc', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '中号304', '', 0.0000, '', 'ml', '', 1, 12.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 16:26:40', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1308, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001043', 'crbyq', '成人拔牙钳', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '150#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1318, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001173', 'sh', '石斛', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.2910, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1328, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000623', 'tkz', '天葵子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0950, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1338, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000183', 'kytqd', '口咽通气道', 'sccj_kdyckjyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '110mm蓝色', '', 0.0000, '', 'ml', '', 1, 4.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1348, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_sj', 'ZKM00001556', 'szts', '双唑泰栓', 'sccj_hebotyy', 'H10983208', 3, '', 'bzdw_h', 'zxdw_l', 7, 'jldw_b_8396', 1.00, '1.00板*7粒/盒', '', 0.0000, '', '', '', 1, 4.7000, 2.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1358, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001575', 'dgp', '滴管瓶', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1368, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rg', 'ZKM00000060', 'hmsyg', '红霉素眼膏', 'sccj_cxfdyy(ws)yxgs(ycxyygfyxgs)', '国药准字h37022025', 3, '', 'bzdw_h', 'zxdw_kg_g', 2, 'jldw_%', 0.50, '0.50%*2g/盒', '', 0.0000, '', '', '', 1, 3.5000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-05-23 14:59:56', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1378, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001055', 'wszxq', '蚊式止血钳', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '弯型12.5cm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1388, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001002', 'hb', '黄柏', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1900, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1398, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001609', 'dsmslsnzsy', '地塞米松磷酸钠注射液', 'sccj_rs', 'H41020036', 3, '', 'bzdw_z', 'zxdw_ml', 1, 'jldw_mg', 5.00, '5.00mg*1ml/支', 'Ut dict', 0.0000, '', '', '', 1, 0.4200, 0.5900, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 4, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1408, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000775', 'cp', '陈皮', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0340, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1418, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_xrrj', 'ZKM00000348', 'lssdacwhxrry', '硫酸沙丁胺醇雾化吸入溶液', 'sccj_shxyjzyyyxgs', '国药准字H19990233', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 2.50, '2.50ml*1支/支', '', 0.0000, '', '', '', 1, 12.8200, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:10:03', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1428, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000076', 'pgtz', '抛光套装', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1438, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001027', 'hsqzb', '红色签字笔', 'sccj_amzyc', '', 3, '', 'bzdw_h', 'zxdw_z', 12, '', 0.00, '12支/盒', '', 0.0000, '', 'ml', '', 2, 1.8000, 1.8000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1448, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000783', 'bltcpgtz', '玻璃陶瓷抛光套装', 'sccj_shdb', '沪食药监械生产许2011908号', 3, '', 'jjdw_t', '', 1, '', 0.00, 'RA1212D', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1458, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001213', 'ycxzjz	', '一次性针灸针	', 'sccj_szhq', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '0.25*25mm*10支/10片/盒华佗牌', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1468, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000647', 'cs', '赤芍', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.4200, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 17:44:02', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1478, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000567', 'zyamf', '中医按摩服', 'sccj_dd', '', 3, '', 'jjdw_t', '', 1, '', 0.00, '-', '', 0.0000, '', 'ml', '', 1, 73.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1488, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000853', 'dqms', '锻青礞石', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0300, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1498, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001531', 'efgj', '额反光镜', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1508, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001540', 'ygb', '荧光笔', 'sccj_amzyc', NULL, 3, '', 'bzdw_z', 'zxdw_z', 1, '', 0.00, '1支/支', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-07 10:00:46', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1518, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000143', 'blzt', '碧兰针头', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '27g30g', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1528, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000942', 'jtl（hlp）', '基托蜡（红蜡片）', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '240g,20片/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1538, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000173', 'xhzqy', '小孩子铅衣', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1548, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001275', 'ddxyq	', '电动吸引器	', 'sccj_yzan		', '-', 3, '', 'jjdw_x', '', 1, '', 0.00, '200只/箱', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1558, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001759', 'jpnlp', '甲泼尼龙片', 'sccj_pflzer italla srl', 'h20150245', 3, '', 'bzdw_h', 'zxdw_p', 30, 'jldw_mg', 4.00, '4.00mg*30片/盒', '', 0.0000, '', '', '', 1, 0.0000, 29.1800, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1568, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001095', 'xhc', '仙鹤草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0280, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1578, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000636', 'cjrsc', '超级柔顺锉', 'sccj_cdhgylqxyxgs', '--', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm-15-40', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-04-04 15:50:52', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1588, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00000534', 'gysmsblp', '枸橼酸莫沙比利片', 'sccj_lnbtzyyxgs', 'H19990317', 3, '', 'bzdw_h', 'zxdw_p', 24, 'jldw_mg', 5.00, '5.00mg*24片/盒', '', 0.0000, '', '', '', 1, 15.7780, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 0, 0, 10, 2, NULL, '2018-02-07 16:13:16', 1, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1598, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000578', 'tmz', '茼麻子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0710, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-03-27 14:54:15', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1608, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000201', 'lqh', '利器盒', 'sccj_bjjrkkjyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '5L', '', 0.0000, '', 'ml', '', 1, 7.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1618, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000125', 'znytf', '自凝牙托粉', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1628, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001456', 'fmsttfp', '富马酸酮替芬片', 'sccj_jstsldyyy', 'H32023660', 3, '', 'bzdw_p', 'zxdw_p', 60, 'jldw_hk', 1.00, '1.00毫克*60片/瓶', 'kf', 1.0000, '', '', 'mr2c', 2, 0.1400, 0.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 11:20:39', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1638, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001461', 'bbbtnzsy', '苯巴比妥钠注射液', 'sccj_gdbmzycyxgs', 'H44021888', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 1.00, '1.00ml*1支/支', '', 0.0000, '', '', '', 1, 1.9900, 2.8000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 1, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1648, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000575', 'mwl', '马尾连', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0350, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1658, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000289', 'ycxsytmtm（lzzt）', '一次性使用透明贴膜（留置针贴）', 'sccj_sdwgjtyygfzzpgfyxgs', '', 3, '', 'jjdw_p_10962', '', 1, '', 0.00, '6x7II型', '', 0.0000, '', 'ml', '', 1, 0.9000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-15 10:58:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1668, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001408', 'ly	', '轮椅	', 'sccj_jsyy', '-', 3, '', 'jjdw_t_148', '', 1, '', 0.00, '鱼跃轮椅H007', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1678, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000326', 'nkcmzsy', '尼可刹米注射液', 'sccj_gyjtrszyyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_ml', 1.50, '1.50ml*10支/盒', '', 0.0000, '', '', '', 1, 15.1200, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1688, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001100', 'cjnj', '醋鸡内金', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0620, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1698, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001046', 'crbyq', '成人拔牙钳', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '210#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1708, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tj', 'ZKM00001678', 'tqbt（etx）', '通气鼻贴（儿童型）', 'sccj_zmtjskzyyxgs', 'H356230', 3, '', 'bzdw_h', 'zxdw_p', 8, 'jldw_p', 1.00, '1.00片*8片/盒', '', 0.0000, '', '', '', 1, 0.0000, 14.2500, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1718, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000355', 'bxgdgfp', '不锈钢带盖方盘', 'sccj_gdscaxctqsylqxc', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '8寸无孔', '', 0.0000, '', 'ml', '', 1, 36.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1728, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00001560', 'rtjlxwgt', '人体经络穴位挂图', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1738, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_wj', 'ZKM00000303', 'nhjdw', '牛黄解毒丸', 'sccj_ydzyjtgfyxgs', '', 3, '', 'bzdw_h', 'zxdw_w', 10, 'jldw_g', 3.00, '3.00g*10丸/盒', '', 0.0000, '', '', '', 1, 4.5000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1748, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001526', 'A4bjb', 'A4笔记本', 'sccj_amzyc', NULL, 3, '', 'bzdw_b_9413', 'zxdw_b_2375', 1, '', 0.00, '1本/本', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1758, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_crp', 'ZKM00000523', 'yfsxdey', '氧氟沙星滴耳液', 'sccj_shchyyyxgs', 'J20140141', 3, '', 'bzdw_z', 'zxdw_ml', 5, 'jldw_mg', 15.00, '15.00mg*5ml/支', 'ad us.ext', 1.2000, '', '', 'TID', 1, 25.6000, 35.8400, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, NULL, '2018-04-19 10:42:04', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1768, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000965', 'yyhlkz', '医用护理口罩', 'sccj_cdwjlkylypyxgs', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '100个/袋', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-28 09:31:06', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1778, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000671', 'sx', '松香', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0560, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1788, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000055', 'mz', '面罩', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '套', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1798, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000057', 'ycxrjst', '一次性乳胶手套', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_d', '', 1, '', 0.00, '中小特小', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1808, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000129', 'ysklmsjn', '盐酸克林霉素胶囊', 'sccj_ycrfyyyxzrgs', '', 3, '', 'bzdw_h', 'zxdw_l', 10, 'jldw_g', 0.15, '0.15g*10粒/盒', '', 0.0000, '', '', '', 1, 2.6000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 10:46:02', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1818, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000927', 'ggc（Hc-25h)', '根管锉（H锉-25混)', 'sccj_mnzshs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm15-40#6*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1828, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001682', 'jgst（sm）4mmbxg', '金刚砂条（双面）4mm不锈钢', 'sccj_jk（dg）', '', 3, '', 'jjdw_g', '', 1, '', 0.00, '根', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1838, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000405', 'tzmsb（sbj）', '脱脂棉纱布（纱布卷）', 'sccj_cxlhwsclyxgs', '', 3, '', 'jjdw_j', '', 1, '', 0.00, '80CM*15M/卷', '', 0.0000, '', 'ml', '', 1, 35.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-23 16:19:32', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1848, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001013', 'jgscz', '金刚砂车针', 'sccj_w', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'TF-11', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1858, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000944', 'yns', '鱼脑石', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.3200, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1868, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_wy', 'ZKM00000205', 'ksl（hgy）', '开塞露（含甘油）', 'sccj_myykzyyxgs(yscmyykzyyxgs)', 'h51021642', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 20.00, '20.00ml*1支/支', '', 0.0000, '', '', '', 1, 0.6400, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 16:44:39', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1878, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000315', 'ycxsyqgcg', '一次性使用气管插管', 'sccj_hzjlylqxyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, 'QC-01带囊7.0mm10支/盒', '', 0.0000, '', 'ml', '', 1, 13.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 15:40:34', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1888, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001551', 'mz', '脉诊', 'sccj_hbll', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1898, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000338', 'xxtcrp', '胸腺肽肠溶片', 'sccj_hljdlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_p', 10, 'jldw_mg', 10.00, '10.00mg*10片/盒', '', 0.0000, '', '', '', 1, 14.8800, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1908, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001103', 'yksztcq', '牙科树脂填充器', 'sccj_w', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'KPFI-MI', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1918, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tptj', 'ZKM00000428', 'gysmsblp', '枸橼酸莫沙必利片', 'sccj_Abbott Biologicals B.V.', '', 3, '', 'bzdw_h', 'zxdw_p', 24, 'jldw_mg', 5.00, '5.00mg*24片/盒', '', 0.0000, '', '', '', 1, 15.7780, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-07 16:05:22', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1928, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001295', 'cch', '醋柴胡', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.7840, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1938, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000101', 'clsnry', '次氯酸钠溶液', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '0.3/0.1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1948, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001489', 'cwj（50mm）', '长尾夹（50mm）', 'sccj_amzyc', NULL, 3, '', 'bzdw_h', 'zxdw_h', 1, '', 0.00, '1盒/盒', '', 0.0000, '', 'ml', '', 2, 15.0000, 15.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1958, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000397', 'ssfyb', '三色服药杯', 'sccj_rbgdgyzshs_6795', '', 3, '', 'jjdw_t', '', 1, '', 0.00, '三色', '', 0.0000, '', 'ml', '', 1, 0.9000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1968, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_wj', 'ZKM00000121', 'asbxw', '安神补心丸', 'sccj_shhhyyyxgs', 'z31020410', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_w', 300.00, '300.00丸*1瓶/瓶', '', 0.0000, '', '', '', 1, 8.5000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 16:47:55', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1978, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001076', 'A4fyz（hs）', 'A4复印纸（黄色）', 'sccj_amzyc', '', 3, '', 'bzdw_b', 'zxdw_b', 1, '', 0.00, '1包/包', '', 0.0000, '', 'ml', '', 2, 14.9000, 14.9000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1988, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000914', 'ycxkqqxh（ycxdj）', '一次性口腔器械盒（一次性垫巾）', 'sccj_w', '-', 3, '', 'jjdw_t_7475', '', 1, '', 0.00, '20条/包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 17:03:49', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (1998, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001053', '11kwjd', '11孔文件袋', 'sccj_amzyc', '', 3, '', 'bzdw_b', 'zxdw_b', 1, '', 0.00, '1包/包', '', 0.0000, '', 'ml', '', 2, 27.0000, 27.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2008, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001139', 'ljs', '鹿角霜', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 1.0080, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2018, 'bgyplb_gdzc', 3, 1, 'bgyplb_gdzc', '', 'ZKM00001748', 'ggzlywxmd（rsmzSP）', '根管治疗用微型马达（瑞士迈装SP）', 'sccj_amzyc', NULL, 3, '', 'bzdw_t_9258', 'zxdw_t_6854', 1, '', 0.00, '1台/台', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2028, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001208', 'qxm', '全蝎面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 5.2500, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2038, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000918', 'ssdb', '手术刀柄', 'sccj_shkqylqxyxgs', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '#310把/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2048, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001704', 'tlbd 12j/h 7.5*450', '弹力绷带 12卷/盒 7.5*450', 'sccj_fshsk		', '-', 3, '', 'jjdw_j', '', 1, '', 0.00, '卷', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-07-04 11:07:59', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2058, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001656', 'cgshdxfhzkp-sp1（5ml*6）', '常规生化多项复合质控品-水平1（5ml*6）', 'sccj_glyltyldzyxgs', '20162400050', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 689.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2068, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000295', 'yyccg', '医用除颤膏', 'sccj_rbgdgyzshs_6795', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '100g', '', 0.0000, '', 'ml', '', 1, 100.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2078, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000714', 'dc', '丹参', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1400, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2088, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000432', 'zzq（gjzs）', '组织钳（国际制式）', 'sccj_shylqx（jt）yxgsssqxc', '', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'TC703024cm(巴士)', '', 0.0000, '', 'ml', '', 1, 104.4000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2098, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000514', 'pttzsy5%（rd）（sgsf）', '葡萄糖注射液5%（软袋）（双管双阀）', 'sccj_sdqdyyyxgs', 'H37020773', 3, '', 'bzdw_d', 'zxdw_ml', 250, 'jldw_g', 12.50, '12.50g*250ml/袋', '', 0.0000, '', '', '', 1, 5.1000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 20, 5, NULL, '2018-02-24 11:22:08', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2108, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000655', 'SSWgscz', 'SSW高速车针', 'sccj_SSW.WHITE BURS.IN', '--', 3, '', 'jjdw_z', '', 1, '', 0.00, 'FG-701', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2118, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001105', 'yxhx', '盐小茴香', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0670, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2128, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001364', 'fhz', '缝合针', 'sccj_hzhw		', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '圆头带针不可吸收缝合针4.040包/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2138, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000752', 'sm', '苏木', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0560, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2148, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000150', 'ysjgwap', '盐酸金刚烷胺片', 'sccj_jspyyyyxgs', 'h32023575', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_g', 0.10, '0.10g*100片/瓶', '', 0.0000, '', '', '', 1, 5.9000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 17:02:23', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2158, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001331', 'fcsy', '麸炒山药', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.2600, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2168, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000647', 'Kc', 'K锉', 'sccj_xnddsb', '--', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm-35', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2178, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000409', 'ycxsyjmglsyq', '一次性使用精密过滤输液器', 'sccj_tjhnhycyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, 'SYQ-512-06APD0.7*20(双翼）', '', 0.0000, '', 'ml', '', 1, 4.5000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2188, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001210', 'tbc', '土鳖虫', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.2350, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2198, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001081', 'bllzsmt', '玻璃离子水门汀', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '浅黄色', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2208, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001011', 'hy', '荷叶', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 0.0000, '', '', '', 1, 0.0670, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2218, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000759', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '国械注进20152552079', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'F0-22EF(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2228, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001201', 'mhm', '麻黄面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0160, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2238, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001513', 'rtxwmx（zj）', '人体穴位模型（针灸）', 'sccj_shyhmxyxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2248, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000893', 'czsz', '炒紫苏子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0900, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2258, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001257', 'bjgh', '白鸡冠花', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0400, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2268, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000923', 'sq', '三七', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 2.2400, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2278, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001076', 'tbw', '调拌碗', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '蓝色', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2288, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001061', 'ssdb', '手术刀柄', 'sccj_w', '无', 3, '', 'jjdw_d', '', 1, '', 0.00, '3', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2298, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000655', 'nx', '牛膝', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.1340, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2308, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001439', 'ysxbjp', '盐酸小檗碱片', 'sccj_gdhnyyjtyxgs', '国药准字H44020757', 3, '', 'bzdw_h', 'zxdw_p', 100, 'jldw_g', 0.10, '0.10g*100片/盒', 'kf', 0.3000, '', '', 'mr3c', 1, 16.0000, 18.4000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-05-24 14:17:37', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2318, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_wy', 'ZKM00000297', 'lgsxj', '炉甘石洗剂', 'sccj_hnekxyzyyxgs', 'H20153294', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 100.00, '100.00ml*1瓶/瓶', 'ad us.ext', 2.0000, '', '', 'alth', 1, 8.0000, 8.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 1, NULL, '2018-05-10 14:35:21', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2328, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001742', 'pttsgzsy', '葡萄糖酸钙注射液', 'sccj_shyyjtqdgfyy', 'H41023479', 3, '', 'bzdw_h', 'zxdw_z', 5, 'jldw_ml', 10.00, '10.00ml*5支/盒', 'jmdz', 10.0000, '', '', 'bys', 2, 0.0000, 4.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2338, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000773', 'jzs', '结扎丝', 'sccj_hzxhswclyxgs', '浙械注准20172630457', 3, '', 'jjdw_h', '', 1, '', 0.00, '100g(0.2)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2348, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rg', 'ZKM00000231', 'dndrg', '地奈德乳膏', 'sccj_cqhbzyyxgs', 'H20060725', 3, '', 'bzdw_z', 'zxdw_kg_g', 15, 'jldw_%', 0.05, '0.05%*15g/支', '', 0.0000, '', '', '', 1, 25.5000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:16:10', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2358, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001138', 'dxt', '大血藤', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0450, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2368, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001460', 'jsszptp（sns）', '酒石酸唑吡坦片（思诺思）', 'sccj_snf（hz）zyyxgs', 'J20140021', 3, '', 'bzdw_p_1730', 'zxdw_p', 1, 'jldw_mg', 10.00, '10.00mg*1片/片', '', 0.0000, '', '', '', 1, 2.9000, 4.1000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 1, 0, 0, 0, 0, NULL, '2018-04-09 14:47:41', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2378, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000085', 'TF ntc 23mm', 'TF 镍钛锉 23mm', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2388, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000339', 'ysxxsldjzsy', '盐酸消旋山莨菪碱注射液', 'sccj_hzmsyyyxgs', 'H33021707', 3, '', 'bzdw_z', 'zxdw_ml', 1, 'jldw_mg', 10.00, '10.00mg*1ml/支', 'IM', 0.0000, '', '', '', 1, 2.3800, 3.3300, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 100, 10, NULL, '2018-04-19 13:34:03', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2398, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000749', 'bxgyt', '不锈钢牙托', 'sccj_shkqylqxyxgs', 'B3124(2013)0654', 3, '', 'jjdw_ge', '', 1, '', 0.00, '3#下有孔', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2408, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000695', 'ntysg', '镍钛圆丝弓', 'sccj_shamdclljgfyxgs', '沪械注准20162630198', 3, '', 'jjdw_d', '', 1, '', 0.00, '卵圆12L', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 09:36:47', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2418, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001825', 'pttlhnzsy（sp）', '葡萄糖氯化钠注射液（塑瓶）', 'sccj_sccj（cs）', 'H41023364', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 500.00, '500.00ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 0.0000, 1.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2428, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000817', 'dtSuperlinezzt', '登腾Superline种植体', 'sccj_EA', '--', 3, '', 'jjdw_h', '', 1, '', 0.00, 'FX5010SW', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2438, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000888', 'lsgqszcl（protemp 4jt）', '临时冠桥树脂材料（protemp 4机调）', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, 'A2,67g', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2448, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001655', 'cgshdxfhxzp', '常规生化多项复合校准品', 'sccj_glyltyldzyxgs', '201652400051', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 845.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2458, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001309', 'xdtz', '心电图纸', 'sccj_rbgd', '-', 3, '', 'jjdw_b_2336', '', 1, '', 0.00, '六导110mm*140mm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2468, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_pj', 'ZKM00000097', 'hgp', '护肝片', 'sccj_thlmyyyxzrgs(ythshyygfyxgs)', 'z22023890', 3, '', 'bzdw_h', 'zxdw_p', 100, 'jldw_g', 0.35, '0.35g*100片/盒', '', 0.0000, '', '', '', 1, 7.2000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:21:13', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2478, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000250', 'pttsgzsy', '葡萄糖酸钙注射液', 'sccj_scmdkhkyyyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 5, 'jldw_ml', 10.00, '10ml*5支/盒', '', 0.0000, '', '', '', 1, 14.4000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 15:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2488, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000705', 'fbhj', '氟保护剂', 'sccj_3MESPE DENTAL PRODUCT', '--', 3, '', 'jjdw_h', '', 1, '', 0.00, '50*112247', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2498, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001113', 'szs', '生赭石', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.0290, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2508, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001151', 'jbl', '焦槟榔', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.0840, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2518, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000779', 'dfp', '大腹皮', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.0450, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2528, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001365', 'bcd', '白床单', 'sccj_amzyc', '', 3, '', 'bzdw_b', 'zxdw_z_z', 10, '', 0.00, '10张/包', '', 0.0000, '', 'ml', '', 2, 26.0000, 26.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2538, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001241', 'cxl', '穿心莲', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.0400, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2548, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_pj', 'ZKM00000145', 'yhztp', '元胡止痛片', 'sccj_scdqyyyxgs', 'z51021484', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_p', 100.00, '100.00片*1瓶/瓶', '', 0.0000, '', '', '', 1, 4.0000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:22:24', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2558, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001603', 'zjz 0.25*75mm', '针灸针 0.25*75mm', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2568, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000684', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'SF-12C(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2578, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000480', 'ycxsywjzjz', '一次性使用无菌针灸针', 'sccj_bjkydylypc', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '0.25*50单支', '', 0.0000, '', 'ml', '', 1, 0.1000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-10 21:52:25', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2588, 'bgyplb_ycxcl', 3, 1, 'bgyplb_ycxcl', '', 'ZKM00001877', 'tf', '碳粉', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2598, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000301', 'ysaxsp', '盐酸氨溴索片', 'sccj_sdyxyyyxgs（ysdlxyygfyxgs）', 'h19990228', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_mg', 30.00, '30.00mg*20片/盒', '', 0.0000, '', '', '', 1, 2.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:25:39', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2608, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000589', 'tzsm', '烫枳失面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2618, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000931', 'dcsz', '锻赤石脂', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2628, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000664', 'czz', '炒栀子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.1400, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2638, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00001551', 'jgtjn', '金刚藤胶囊', 'sccj_hbfryy', 'Z19991031', 3, '', 'bzdw_h', 'zxdw_l', 42, 'jldw_g', 0.50, '0.50g*42粒/盒', 'kf', 2.0000, '', '', 'mr3c', 1, 16.8800, 2.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 14:07:29', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2648, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000914', 'slc', '生龙齿', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.9520, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2658, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000296', 'ylzqmjhxcsb', '压力蒸汽灭菌化学测试宝', 'sccj_sdxhylqxgfyxgs', '', 3, '', 'jjdw_b', '', 1, '', 0.00, '30包/箱', '', 0.0000, '', 'ml', '', 1, 20.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 14:07:39', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2668, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000597', 'jdy', '焦稻芽', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0120, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2678, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001164', 'txtgc', '铁线透骨草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0390, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2688, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000606', 'ssb', '石上柏', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0450, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2698, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001083', 'xsy（5kg）', '洗手液（5kg）', 'sccj_amzyc', '', 3, '', 'bzdw_t_2442', 'zxdw_t_4836', 1, '', 0.00, '1桶/桶', '', 0.0000, '', 'ml', '', 2, 68.4000, 68.4000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2708, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_jnj', 'ZKM00000173', 'xzkjn', '血脂康胶囊', 'sccj_bjbdyyyxgs', '', 3, '', 'bzdw_h', 'zxdw_l', 24, 'jldw_g', 0.30, '0.3g*24粒/盒', '', 0.0000, '', '', '', 1, 30.0000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 13:48:19', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2718, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000624', 'yymjd', '医用灭菌袋', 'sccj_cqql', '卫消字（2012）第0009号', 3, '', 'jjdw_j', '', 1, '', 0.00, '150*200', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2728, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001517', 'wgfp 31*24*3.1', '无盖方盘 31*24*3.1', 'sccj_caxdfzxyylqxc		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2738, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001145', 'gl', '瓜蒌', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.1120, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2748, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000932', 'ggkdz（kdz25h）', '根管扩大针（扩大针25混）', 'sccj_mnzshs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm15-40#6*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2758, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000150', 'ygc', '牙骨锤', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '二头紫铜', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2768, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00001547', 'httjn（ymx）', '黄体酮胶囊（益玛欣）', 'sccj_zjxjzygfyxgs', 'H20041902', 3, '', 'bzdw_h', 'zxdw_l', 20, 'jldw_mg', 50.00, '50.00mg*20粒/盒', 'kf', 100.0000, '', '', 'mr2c', 1, 28.3600, 2.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 14:09:29', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2778, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001023', 'A4sfm', 'A4塑封膜', 'sccj_amzyc', '', 3, '', 'bzdw_b', 'zxdw_b', 1, '', 0.00, '1包/包', '', 0.0000, '', 'ml', '', 2, 49.0000, 49.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2788, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000037', 'mkp', '磨口瓶', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '棕色', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2798, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000602', 'Hc', 'H锉', 'sccj_xnddsb', '国械备20170214号', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm-15（白）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2808, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001209', 'tpz', '头皮针', 'sccj_jxhd		', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '100支/包（0.55）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2818, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dyj', 'ZKM00001631', 'zzmmdyy(TX)', '珍珠明目滴眼液(TX)', 'sccj_wlylsb（sz）yxgs', '20170914', 3, '', 'bzdw_h', 'zxdw_ml', 10, 'jldw_ml', 1.00, '1.00ml*10ml/盒', '', 0.0000, '', '', '', 1, 0.0000, 19.8000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2828, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000743', 'qc', '茜草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2350, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2838, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001132', 'sck', '舌侧扣', 'sccj_hzxyckclyxgs', '浙械注准20172631222', 3, '', 'jjdw_d', '', 1, '', 0.00, '9131-203（纽扣超薄粘结型凹底）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2848, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000611', 'qyhgxdhj', '氢氧化钙消毒糊剂', 'sccj_yhjwwdtgs', '国械注字进20153632564', 3, '', 'jjdw_h', '', 1, '', 0.00, '595915AN', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2858, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000132', 'axlwp', '阿昔洛韦片', 'sccj_scklyygfyxgs', 'h20057410', 3, '', 'bzdw_h', 'zxdw_p', 24, 'jldw_g', 0.20, '0.20g*24片/盒', '', 0.0000, '', '', '', 1, 2.1000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:54:59', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2868, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001660', 'shfxyyjxqxyURIT-DC1', '生化分析仪用碱性清洗液URIT-DC1', 'sccj_glyltyldzyxgs', '20140004', 3, '', 'jjdw_p', '', 1, '', 0.00, '瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 182.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2878, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000333', 'ddxtq', '电动吸痰器', 'sccj_shqxylqxc', '', 3, '', 'jjdw_t_148', '', 1, '', 0.00, 'DXT-1无油润滑真空泵，成人', '', 0.0000, '', 'ml', '', 1, 820.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2888, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dyj', 'ZKM00001632', 'nmwdyy（TX）', '萘敏维滴眼液（TX）', 'sccj_jxrlsyyxgs', '170907', 3, '', 'bzdw_z', 'zxdw_ml', 10, 'jldw_ml', 1.00, '1.00ml*10ml/支', '', 0.0000, '', '', '', 1, 0.0000, 22.8000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2898, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_pj', 'ZKM00001396', 'lstjp（ksy）', '氯沙坦钾片（科素亚）', 'sccj_hzmsdzyyxgs', 'J20130048', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_mg', 50.00, '50.00mg*7片/盒', '', 0.0000, '', '', '', 1, 37.4600, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-07-06 10:23:04', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2908, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001290', 'stxs', '三通旋塞', 'sccj_zjch		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '1*50', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2918, 'bgyplb_dzl', 3, 1, 'bgyplb_dzl', '', 'ZKM00001858', '1', '1', 'sccj_amzyc', NULL, 3, '', 'bzdw_k_10382', 'zxdw_k_6141', 1, '', 0.00, '1颗/颗', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2928, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hxy', 'ZKM00001710', 'blfhxy（ml）', '布洛芬混悬液（美林）', 'sccj_shqszyyxgs', 'H19991011', 3, '', 'bzdw_p', 'zxdw_kg_g', 2, 'jldw_ml', 100.00, '100.00ml*2g/瓶', 'kf', 0.0000, '', '', '', 1, 0.0000, 18.8000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 5, 2, NULL, '2018-05-23 15:03:45', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2938, 'bgyplb_ycxcl', 3, 1, 'bgyplb_ycxcl', '', 'ZKM00001904', 'zb', '纸杯', 'sccj_amzyc', NULL, 3, '', 'bzdw_d', 'zxdw_d', 1, '', 0.00, '1袋/袋', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2948, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000191', 'xhpmjbzcl', '新华牌灭菌包装材料', 'sccj_sdxhylqxgfyxgs', '', 3, '', 'jjdw_j', '', 1, '', 0.00, '300mm*100m', '', 0.0000, '', 'ml', '', 1, 255.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-12 13:25:40', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2958, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000699', 'ntfsg', '镍钛方丝弓', 'sccj_shamdclljgfyxgs', '沪械注准20162630198', 3, '', 'jjdw_d', '', 1, '', 0.00, '卵圆18*22L', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 09:36:30', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2968, 'bgyplb_yslcl', 3, 1, 'bgyplb_yslcl', '', 'ZKM00001414', 'xcc', '宣传册', 'sccj_amzyc', '', 3, '', 'bzdw_b', 'zxdw_b_2375', 50, '', 0.00, '50本/包', '', 0.0000, '', 'ml', '', 2, 10.5000, 10.5000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2978, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_hj', 'ZKM00000522', 'smtkfy', '四磨汤口服液', 'sccj_hnhszygfyxgs', 'Z20025044', 3, '', 'bzdw_h', 'zxdw_z', 8, 'jldw_ml', 10.00, '10.00ml*8支/盒', 'ad us.int', 20.0000, '', '', 'TID', 1, 18.3000, 25.6200, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 10, 2, NULL, '2018-04-19 15:27:04', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2988, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rgj', 'ZKM00001552', 'kmzrg', '克霉唑乳膏', 'sccj_fyyygfgs', 'H34022473', 3, '', 'bzdw_z', 'zxdw_kg_g', 10, 'jldw_g', 1.00, '1.00g*10g/支', '', 0.0000, '', '', '', 1, 2.9000, 2.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (2998, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pbj', 'ZKM00001480', 'xypbj（cs）', '西药喷鼻剂（测试）', 'sccj_Hu-FriecMfg.CO.,LLC', 'GB9999', 3, 'ABC111', 'bzdw_x', 'zxdw_p_1', 10, 'jldw_hk', 50.00, '50.00毫克*10瓶/箱', 'chkf', 10.0000, '', '', 'm12xsyc', 2, 0.0000, 90.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-06-01 22:22:28', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3008, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000819', 'yzm', '盐知母', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1900, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3018, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00000461', 'yxgybdbmky、eky、ekt、hxktjcsjh（rjf）', '乙型肝炎病毒表面抗原、e抗原、e抗体、核心抗体检测试剂盒（乳胶法）', 'sccj_abswyy（hz）yxgs', '', 3, '', 'jjdw_f_9562', '', 1, '', 0.00, '25T', '', 0.0000, '', 'ml', '', 1, 3.2000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-10 21:35:17', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3028, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001360', 'qxhm', '清洗海绵', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3038, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000640', 'xtw', '夏天无', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2750, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3048, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000645', 'lyx', '六月雪', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0440, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3058, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000991', 'ckxr', '炒苦杏仁', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1120, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3068, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000892', 'clsn（3%）', '次氯酸钠（3%）', 'sccj_w', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '200ml3%', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3078, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001132', 'zzm', '珍珠母', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0220, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3088, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001513', 'dhsl', '大号书立', 'sccj_amzyc', NULL, 3, '', 'bzdw_d_d', 'zxdw_d_d', 1, '', 0.00, '1对/对', '', 0.0000, '', 'ml', '', 2, 21.3500, 21.3500, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3098, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001337', 'gysq', '高压水枪', 'sccj_tzhyyl', '-', 3, '', 'jjdw_t', '', 1, '', 0.00, '2m/个八个头', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3108, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001118', 'scs', '生磁石', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0290, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3118, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000383', 'slxbjn（xlb）', '塞来昔布胶囊（西乐葆）', 'sccj_hrzyyxgs', 'J20140072', 3, '', 'bzdw_h', 'zxdw_l', 6, 'jldw_g', 0.20, '0.20g*6粒/盒', 'kf', 0.2000, '', '', 'bid', 1, 0.0000, 36.3200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 3, NULL, '2018-06-07 10:41:41', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3128, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001464', 'cscwj3#（32mm）', '彩色长尾夹3#（32mm）', 'sccj_amzyc', NULL, 3, '', 'bzdw_h', 'zxdw_h', 1, '', 0.00, '24个/盒', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-04-11 10:19:11', 1, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3138, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001171', 'ymjd', '压敏胶带', 'sccj_shsf', '沪嘉械备20140058号', 3, '', 'jjdw_h', '', 1, '', 0.00, '910*1.25cm24卷', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3148, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00001091', 'csxycj', '测试西药冲剂', 'sccj_3M', 'T0001', 3, 'T1111', 'bzdw_h', 'zxdw_b', 10, 'jldw_g', 10.00, '10.00g*10包/盒', 'ad us.int', 10.0000, '', '', 'bid', 1, 20.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3158, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_klj', 'ZKM00000191', 'jfkkl', '颈复康颗粒', 'sccj_jfkyyjtyxgs', '国药准字Z13022204', 3, '', 'bzdw_h', 'zxdw_d', 12, 'jldw_g', 5.00, '5.00g*12袋/盒', '', 0.0000, '', '', '', 1, 27.2000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 08:42:51', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3168, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000969', 'ycxyyzd', '一次性医用中单', 'sccj_hnytylypyxgs', '豫械注准20152640571', 3, '', 'jjdw_zhang', '', 1, '', 0.00, '1000*2000mm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3178, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000485', 'wzdzzhzly', '温针电针综合治疗仪', 'sccj_czhpdzyxgs', '', 3, '', 'jjdw_t_148', '', 1, '', 0.00, 'HT-2', '', 0.0000, '', 'ml', '', 1, 1600.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3188, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000945', 'pgb', '抛光杯', 'sccj_dgslgylqxyxgs', '-', 3, '', 'jjdw_z_5693', '', 1, '', 0.00, 'P-C505小', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3198, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000999', 'ycxsyxtg', '一次性使用吸唾管', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '手术弯管型', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3208, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001304', 'mgh', '玫瑰花', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.3920, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3218, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000234', 'ysdbazsy', '盐酸多巴胺注射液', 'sccj_ybyygfyxgs', 'H32023366', 3, '', 'bzdw_z', 'zxdw_ml', 2, 'jldw_mg', 20.00, '20.00mg*2ml/支', 'Iv', 40.0000, '', '', 'St', 2, 3.9800, 5.5700, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 4, NULL, '2018-04-19 16:56:43', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3228, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001072', 'zt', '枕头', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 139.0000, 139.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3238, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000691', 'Z350 XTnmsz', 'Z350 XT纳米树脂', 'sccj_3MESPE DENTAL PRODUCT', '--', 3, '', 'jjdw_z', '', 1, '', 0.00, 'Z018(A3)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3248, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dyj', 'ZKM00001633', 'ffmdwgdyy（TX）', '复方门冬维甘滴眼液（TX）', 'sccj_jxrlsyyxgs', '170809', 3, '', 'bzdw_z', 'zxdw_ml', 10, 'jldw_ml', 1.00, '1.00ml*10ml/支', '', 0.0000, '', '', '', 1, 0.0000, 22.8000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3258, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dj', 'ZKM00001312', 'qtgdyy', '羟糖甘滴眼液', 'sccj_AL/ALCONLABORTORIES,INC', 'h20140264', 3, '', 'bzdw_h', 'zxdw_z', 1, 'jldw_ml', 5.00, '5.00ml*1支/盒', '', 0.0000, '', '', '', 1, 24.5600, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-08 08:44:01', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3268, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rj', 'ZKM00001875', '1', '1', 'sccj_sdrhtyyyxgs', '1', 3, '', 'bzdw_k_10382', 'zxdw_k_6141', 1, 'jldw_IU', 1.00, '1IU*1颗/颗', '', 0.0000, '', '', '', 1, 0.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3278, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000595', 'hz', '猴枣', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 76.0000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:24:49', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3288, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000341', '（jz）zxq', '（金钟）止血钳', 'sccj_shylqx（jt）yxgsssqxc', '', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'JC311116CM直全齿WD', '', 0.0000, '', 'ml', '', 1, 60.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3298, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000987', 'gh', '葛花', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0840, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3308, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000481', 'dbazsy', '多巴胺注射液', 'sccj_dd', '', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_mg', 20.00, '20.00mg*10支/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3318, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001016', 'yszyfsxp', '盐酸左氧氟沙星片', 'sccj_dysgzy（bj）yxgs', 'H20000655', 3, '', 'bzdw_k_9250', 'zxdw_h', 10, 'jldw_g', 0.10, '0.10g*10盒/克', 'ad us.int', 0.2000, '', '', 'bid', 1, 31.6300, 44.2800, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 2, NULL, '2018-04-19 10:50:41', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3328, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000741', 'jj', '菊苣', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0500, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3338, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000468', 'yssldjzsy', '盐酸山莨菪碱注射液', 'sccj_hzmsyyyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_mg', 10.00, '10.00mg*10支/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3348, 'bgyplb_yslcl', 3, 1, 'bgyplb_yslcl', '', 'ZKM00001412', 'zb', '纸杯', 'sccj_amzyc', '', 3, '', 'bzdw_x', 'zxdw_b', 40, '', 0.00, '40包/箱', '', 0.0000, '', 'ml', '', 2, 21.0000, 21.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3358, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000772', 'hlsxpfymc', '贺利氏新配方印膜材', 'sccj_hlsgsckyxgs', '京食药监械（准）字2014第2630452', 3, '', 'jjdw_t_5432', '', 1, '', 0.00, '1000g', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3368, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000348', 'yygysq', '医用高压水枪', 'sccj_tzslhsysbyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, 'LH-Q108', '', 0.0000, '', 'ml', '', 1, 850.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-15 14:04:21', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3378, 'bgyplb_gdzc', 3, 1, 'bgyplb_gdzc', '', 'ZKM00001575', 'ThinkPad E470bjbdn', 'ThinkPad E470笔记本电脑', 'sccj_amzyc', NULL, 3, '', 'bzdw_t_9258', 'zxdw_t_6854', 1, '', 0.00, '1台/台', '', 0.0000, '', 'ml', '', 2, 3799.0000, 3799.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3388, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00000535', 'fflsdhsy', '复方氯巳定含漱液', 'sccj_hebkhyyyxgs', 'H20064451', 3, '', 'bzdw_p', 'zxdw_ml', 200, 'jldw_ml', 200.00, '200.00ml*200ml/瓶', 'pa', 15.0000, '', '', 'bid', 1, 12.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 5, 2, NULL, '2018-03-02 17:17:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3398, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001236', 'bf', '白矾', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0290, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3408, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_njj', 'ZKM00000051', 'bjzycsy', '北京专用测试药', 'sccj_bjsykyy', '1234567', 3, '', 'bzdw_h', 'zxdw_l', 8, 'jldw_mg', 5.00, '5.00mg*8粒/盒', '', 0.0000, '', '', '', 1, 0.0000, 10.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3418, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000545', 'jgcdsjh（kwsf）', '肌酐测定试剂盒（苦味酸法）', 'sccj_glyltyldzyxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '50ml*3；校准品1ml', '', 0.0000, '', 'ml', '', 1, 89.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-27 10:12:43', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3428, 'hclb_ptcl', 2, 0, 'hclb_ptcl', '', 'ZKW00000004', 'jd', '剪刀', 'sccj_adyy(bj)yxgs', '1234', 3, '1234', 'jjdw_ge', '', 1, '', 0.00, '1把/把', '', 0.0000, '', 'ml', '', 1, 10.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2017-08-25 09:21:48', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3438, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000897', 'xczj-h', '吸潮纸尖-混', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '160*115-40#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3448, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000779', 'pttlydry', '葡萄糖氯已定溶液', 'sccj_llswyy（wh）yxgs', '(鄂)卫消证字（2009）第0029号', 3, '', 'jjdw_p', '', 1, '', 0.00, '250ml', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3458, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000007', 'zjz', '针灸针', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '100mm*0.3', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3468, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001667', 'glktp（tsp）', '格列喹酮片（糖适平）', 'sccj_bjwhshyyyxzrgs', '国药准字H10940258', 3, '', 'bzdw_p', 'zxdw_p', 60, 'jldw_mg', 30.00, '30.00mg*60片/瓶', '', 0.0000, '', '', '', 1, 0.0000, 65.0400, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3478, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001648', 'crbyq 10#', '成人拔牙钳 10#', 'sccj_shkqckyxc		', '', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '把', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3488, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001012', 'jgscz', '金刚砂车针', 'sccj_w', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'TC-21', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3498, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000511', 'daqsjtyx', '带安全锁家庭药箱', 'sccj_jssh', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '小号', '', 0.0000, '', 'ml', '', 1, 60.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3508, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000690', 'stnx（d）', '生天南星（毒）', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3518, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000127', 'lhmsjn', '罗红霉素胶囊', 'sccj_hnqjxjyygfyxgs', '', 3, '', 'bzdw_h', 'zxdw_l', 12, 'jldw_mg', 150.00, '150mg*12粒/盒', '', 0.0000, '', '', '', 1, 6.1000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 10:45:35', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3528, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_pj', 'ZKM00000073', 'ysejsgp（ghz）', '盐酸二甲双胍片（格华止）', 'sccj_zmshsgbzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 20, 'jldw_g', 0.50, '0.5g*20支/盒', '', 0.0000, '', '', '', 1, 24.2000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-01-12 14:03:18', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3538, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001366', 'cpz ', '餐盘纸 ', 'sccj_amzyc', '', 3, '', 'bzdw_b', 'zxdw_b', 1, '', 0.00, '1包/包', '', 0.0000, '', 'ml', '', 2, 58.0000, 58.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3548, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001114', 'ycxsywjydkzq', '一次性使用无菌阴道扩张器', 'sccj_czhpdzyxgs', '苏械注准20163400540', 3, '', 'jjdw_z', '', 1, '', 0.00, '中号', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3558, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000342', 'bxgzsc', '不锈钢注射车', 'sccj_njhrylsbzzyxgs', '', 3, '', 'jjdw_t_148', '', 1, '', 0.00, 'B331640*439*915有两个小抽屉', '', 0.0000, '', 'ml', '', 1, 1750.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-15 13:53:36', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3568, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000931', 'ggkdz（kdz）', '根管扩大针（扩大针）', 'sccj_mnzshs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm10#6*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3578, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001602', 'zjzth 0.25*60mm', '针灸针套盒 0.25*60mm', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3588, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001707', 'mq12cm 100xb/zb', '棉签12cm 100小包/中包', 'sccj_sdkz		', '-', 3, '', 'jjdw_b', '', 1, '', 0.00, '包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3598, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000355', 'ysssxszsy', '盐酸肾上腺素注射液', 'sccj_cqdkcjzy', '', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_mg', 1.00, '1.00mg*10支/盒', '', 0.0000, '', '', '', 1, 25.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3608, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000007', 'xeybkl', '小儿咽扁颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3618, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000017', 'xegmkl', '小儿感冒颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3628, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000027', 'blfhxy(ml)', '布洛芬混悬液(美林)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3638, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000037', 'wssaddj（ykx0-1s）', '维生素ad滴剂（伊可新0-1岁）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3648, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000047', 'byw', '鼻渊丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3658, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000057', 'jfkkl', '颈复康颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3668, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000067', 'sxqtcj', '麝香祛痛搽剂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3678, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000077', 'ssztg', '伤湿止痛膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3688, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000087', 'cfakl', '产妇安颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3698, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000097', 'xzw', '消癥丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3708, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000107', 'dhzcw', '大黄蛰虫丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3718, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000117', 'dbjn', '丹鳖胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3728, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000127', 'klw', '坤灵丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3738, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000137', 'sgw', '舒肝丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3748, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000147', 'swhbpw', '十味黑冰片丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3758, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_klj', 'ZDS90000157', '999gmlkl', '999感冒灵颗粒', 'sccj_hrsj', '1708002H', 3, '', 'bzdw_h', 'zxdw_d', 9, 'jldw_g', 10.00, '10.00g*9袋/盒', '', 0.0000, '', 'ml', '', 1, 10.5000, 10.6000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-23 14:24:34', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3768, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000167', 'sftjn', '伤风停胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3778, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000177', 'jztj', '急支糖浆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3788, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000187', 'cbpptj', '川贝枇杷糖浆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3798, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tjj', 'ZDS90000197', 'jztj', '急支糖浆', 'sccj_cqdkcjzy', '17030065', 3, '', 'bzdw_p', 'zxdw_ml', 300, 'jldw_ml', 1.00, '1.00ml*300ml/瓶', '', 0.0000, '', 'ml', '', 1, 37.0000, 37.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-11 09:41:52', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3808, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000207', 'cspnsp', '醋酸泼尼松片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3818, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000217', 'afqktp(tln)', '氨酚羟考酮片(泰勒宁)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3828, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rg', 'ZDS90000227', 'slfseyarjj(ftl)', '双氯芬酸二乙胺乳胶剂(扶他林)', 'sccj_bjnhzyyxgs', '国药准字H19990291', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 20.00, '20.00g*1支/支', 'ad us.ext', 0.0000, '', 'ml', '', 1, 17.2100, 20.6500, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, '2017-07-13 00:00:00', '2018-05-04 16:24:07', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3838, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000237', 'amxljn(sy）', '阿莫西林胶囊(试用）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 24, 'jldw_g', 0.25, '0.25g*24袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-09-12 15:51:51', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3848, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000247', 'yqkzjn(sprn)', '伊曲康唑胶囊(斯皮仁诺)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3858, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZDS90000257', 'fkzjn(dfk)', '氟康唑胶囊(大扶康)', 'sccj_hrzyyxgs', 'H10960164', 3, '', 'bzdw_h', 'zxdw_l', 1, 'jldw_g', 0.15, '0.15g*1粒/盒', 'kf', 0.1500, '', 'ml', 'mz1c', 1, 44.0000, 40.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-24 14:28:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3868, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000267', 'xhw', '西黄丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3878, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000277', 'xhw', '西黄丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3888, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000287', 'zsw', '滋肾丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3898, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000297', 'bqydf', '包醛氧淀粉', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3908, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000307', 'sltkl', '石淋通颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/袋', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3918, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000317', '@jqmzp(sz)', '@甲巯咪唑片(赛治)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3928, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000327', '*@gjydszsy(lds)', '*@甘精胰岛素注射液(来得时)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3938, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000337', 'sysbftg', '水杨酸苯酚贴膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3948, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000347', 'fczykl', '防参止痒颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3958, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000357', 'ksmmsnj', '糠酸莫米松凝胶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3968, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rgj', 'ZDS90000367', 'mplxrg（bdb）', '莫匹罗星软膏（百多邦）', 'sccj_zmtjskzyyxgs', '国药准字H10930064', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 5.00, '5.00g*1支/支', '', 0.0000, '', 'ml', '', 1, 13.9400, 19.5200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-04-08 15:25:26', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3978, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000377', 'ffcsdsmsrg', '复方醋酸地塞米松乳膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3988, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000387', 'fyj', '风油精', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (3998, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000397', 'shp', '三黄片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4008, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000407', 'agnhw', '安宫牛黄丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4018, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000417', 'ysplxtp(slt)', '盐酸帕罗西汀片(赛乐特)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4028, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000427', 'ysdnpqp(sbh)', '盐酸多奈哌齐片(思博海)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4038, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000437', 'alpzp(alf)', '阿立哌唑片(安律凡)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4048, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000447', 'cynp', '肠炎宁片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4058, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000457', 'htjtqwkl', '猴头菌提取物颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4068, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZDS90000467', 'wudqlmpII', '维u颠茄铝镁片II', 'sccj_gxnnbhyy', 'H5021329', 3, '', 'bzdw_h', 'zxdw_h', 1, 'jldw_p', 50.00, '50.00片*1盒/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 8.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, '2017-07-13 00:00:00', '2018-06-14 17:15:48', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4078, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000477', 'mylsxzcg', '马应龙麝香痔疮膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4088, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000487', 'gysbjjn（lzdl）', '枸橼酸铋钾胶囊（丽珠得乐）', 'sccj_lzjtlzzyc', 'H10920098', 3, '', 'bzdw_h', 'zxdw_l', 20, 'jldw_g', 0.30, '0.30g*20粒/盒', 'ad us.int', 0.3000, '', 'ml', 'Qid', 1, 11.6800, 1.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 10, 3, '2017-07-13 00:00:00', '2018-03-13 15:01:28', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4098, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000497', 'mzlp', '迈之灵片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4108, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000507', 'qkldp', '曲克芦丁片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4118, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000517', 'jssmtlep(btlk)', '酒石酸美托洛尔片(倍他乐克)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4128, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000527', 'rsfttgp(kd)', '瑞舒伐他汀钙片(可定)', 'sccj_bjhlzyyxgs', '国药准字J20170008', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_mg', 10.00, '10.00mg*7片/盒', '', 0.0000, '', 'ml', '', 1, 49.2500, 68.9500, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-04-08 13:43:38', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4138, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000537', 'lsqlpglp（blw）', '硫酸氢氯吡格雷片（波立维）', 'sccj_snf（hz）zyyxgs', '国药准字J20130083', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_mg', 75.00, '75.00mg*7片/盒', '', 0.0000, '', 'ml', '', 1, 101.9500, 142.7000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-04-08 11:24:57', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4148, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000547', 'lstjp(ksy*)', '氯沙坦钾片(科素亚*)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 1, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4158, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000557', 'bdlasdyy(spas)', '苄达赖氨酸滴眼液(莎普爱思)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4168, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000567', 'shygw', '石斛夜光丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4178, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000577', 'blsndyy(al)', '玻璃酸钠滴眼液(爱丽)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4188, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000587', 'trt', '退热贴', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4198, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000597', 'ffajsjn（8-11）（ha）', '复方氨基酸胶囊（8-11）（和安）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4208, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000607', 'scyp', '善存银片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4218, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000617', 'fjkcxq', '妇洁康冲洗器', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4228, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000627', 'bsysjn', '补肾益寿胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4238, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000637', 'lzjn', '灵芝胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4248, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000005', '3Myymxsxdy', '3M医用免洗手消毒液', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '300ml', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4258, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000015', 'jmsylzz', '静脉输液留置针', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '22号（成人）', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4268, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000025', 'ycxzlj', '一次性治疗巾', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '50*40（50张一包）', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4278, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000035', 'ycxbd', '一次性绷带', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '10个/袋', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4288, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000045', 'azt', '艾炙条', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4298, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000055', 'K2EDTA(K2E)：zm', 'K2EDTA(K2E)：紫帽', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '100支每盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4308, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000065', 'ycxykxg', '一次性牙科吸管', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '100支每袋', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4318, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000075', 'ykycxtyb', '牙科一次性涂药棒', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '100根每瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4328, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000085', 'ykhlp', '牙科红蜡片', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '18片/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4338, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000095', 'ycxslymtp', '一次性塑料牙模托盘', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '4号', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4348, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000105', 'sq', '舌钳', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4358, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000006', 'fl', '茯苓', 'sccj_trt', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-02-23 13:27:25', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4368, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000016', 'yyr', '薏苡仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4378, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000026', 'lg', '芦根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4388, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000036', 'sdh', '生地黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4398, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000046', 'cmy', '炒麦芽', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4408, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000056', 'bz', '白芷', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4418, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000066', 'ytsz', '盐菟丝子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4428, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000076', 'yzx', '盐泽泻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4438, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000086', 'ckxr', '燀苦杏仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4448, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000096', 'hh', '红花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4458, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000106', 'jcx', '酒川芎', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4468, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000116', 'yj', '郁金', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4478, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000126', 'cxf', '醋香附', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4488, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000136', 'jnzz', '酒女贞子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4498, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000146', 'zbm', '浙贝母', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4508, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000156', 'cp', '陈皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4518, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000166', 'cszr', '炒酸枣仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4528, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000176', 'zhdd', '紫花地丁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4538, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000186', 'dfz', '地肤子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4548, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000196', 'gsh', '干石斛', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4558, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000206', 'dy', '稻芽', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4568, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000216', 'ay', '艾叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4578, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000226', 'gyxc', '干鱼腥草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4588, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000236', 'jj', '荆芥', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4598, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000246', 'ysyz', '盐沙苑子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4608, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000256', 'ghx', '广藿香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4618, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000266', 'fs', '茯神', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4628, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000276', 'yyz', '盐益智', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4638, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000286', 'cjl', '炒蒺藜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4648, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000296', 'mx', '芒硝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4658, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000306', 'fs', '佛手', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4668, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000316', 'dcd', '党参段', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4678, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000326', 'mh', '麻黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4688, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000336', 'mh', '麻黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4698, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000346', 'jyh', '金银花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4708, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000356', 'xhc', '仙鹤草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4718, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000366', 'cht', '草红藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4728, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000376', 'lg', '芦根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4738, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000386', 'cwwz', '醋五味子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4748, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000396', 'mkdh', '蜜款冬花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4758, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000406', 'gb', '藁本', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4768, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000416', 'bj', '白及', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4778, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000426', 'cjxc', '炒九香虫', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4788, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000436', 'es', '莪术', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4798, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000446', 'jhl', '酒黄连', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4808, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000456', 'bch', '北柴胡', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4818, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000466', 'cqc', '车前草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4828, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000476', 'tm', '天麻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4838, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000486', 'gt', '钩藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4848, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000496', 'lj', '鹿角', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4858, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000506', 'yz', '玉竹', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4868, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000516', 'sjc', '舒筋草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4878, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000526', 'scp', '石菖蒲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4888, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000536', 'ztnx', '制天南星', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4898, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000546', 'ml', '牡蛎', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4908, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000556', 'zjp', '紫荆皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4918, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000566', 'ylr', '郁李仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4928, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000576', 'qd', '青黛', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4938, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000586', 'yxhx', '盐小茴香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4948, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000596', 'xyt', '血余炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4958, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000606', 'mcx', '马齿苋', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4968, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000616', 'lz', '灵芝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4978, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000626', 'dgp', '冬瓜皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4988, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000636', 'dfp', '大腹皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (4998, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000646', 'chh', '炒槐花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5008, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000656', 'jgl', '绞股蓝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5018, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000666', 'bj', '鳖甲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5028, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000676', 'mcx', '马齿苋', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5038, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000686', 'myz', '蜜远志', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5048, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000696', 'kc', '苦参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5058, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000706', 'cbmf', '川贝母粉', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5068, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000716', 'ccsz', '炒楮实子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5078, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000726', 'gzt', '贯众炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5088, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000736', 'xqg', '西青果', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5098, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000746', 'qxz', '青葙子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5108, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000756', 'zsy', '紫苏叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5118, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000766', 'cxd', '赤小豆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5128, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000776', 'ycqz', '盐车前子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5138, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000786', 'dfp', '大腹皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5148, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000796', 'fcsy', '麸炒山药', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5158, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000806', 'oj', '藕节', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5168, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000816', 'cp', '椿皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5178, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000826', 'tx', '檀香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5188, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000836', 'cdk', '草豆蔻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5198, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000846', 'hss', '寒水石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5208, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000856', 'pj', '炮姜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5218, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000866', 'cjmz', '炒决明子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5228, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000876', 'lmh', '腊梅花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5238, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000886', 'mkdh', '蜜款冬花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5248, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000896', 'ldc', '龙胆草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5258, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000906', 'sgl', '丝瓜络', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5268, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000916', 'chj', '炒槐角', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5278, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000926', 'sm', '升麻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5288, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000936', 'hmwjp', '红毛五加皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5298, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000946', 'lzc', '荔枝草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5308, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000956', 'mbq', '蜜白前', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5318, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000966', 'yj', '郁金', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5328, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000976', 'qft', '青风藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5338, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000986', 'pdh', '胖大海', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5348, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000996', 'dh', '大黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5358, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001006', 'fs', '佛手', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5368, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001016', 'sw', '石韦', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5378, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001026', 'mglp', '蜜瓜蒌皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5388, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001036', 'qnj', '千年健', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5398, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001046', 'yspx', '盐桑螵蛸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5408, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001056', 'tm', '天麻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5418, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001066', 'bw', '白薇', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5428, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001076', 'dlc', '煅龙齿', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5438, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001086', 'jx', '降香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5448, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001096', 'lc', '龙齿', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5458, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001106', 'nsc', '南沙参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5468, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001116', 'cqnz', '炒牵牛子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5478, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001126', 'mhg', '麻黄根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5488, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001136', 'ldc', '龙胆草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5498, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001146', 'cbj', '醋鳖甲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5508, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001156', 'lst', '络石藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5518, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001166', 'glj', '高良姜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5528, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001176', 'qxz', '青葙子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5538, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001186', 'dc', '丹参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5548, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001196', 'mzw', '蜜紫菀', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5558, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001206', 'tm', '天麻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5568, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001216', 'bjhx', '八角茴香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5578, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001226', 'tr', '桃仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5588, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001236', 'dfz', '地肤子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5598, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001246', 'bz', '白芷', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5608, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001256', 'sl', '三棱', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5618, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001266', 'cxl', '穿心莲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5628, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001276', 'cxf', '醋香附', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5638, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001286', 'dxc', '灯心草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5648, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001296', 'jgl', '绞股蓝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5658, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001306', 'cyhs', '醋延胡索', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5668, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001316', 'wwz', '五味子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5678, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001326', 'tc', '通草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5688, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001336', 'tx', '檀香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5698, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001346', 'hb', '黄柏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5708, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001356', 'jhl(w)', '酒黄连(味)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5718, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001366', 'czs', '炒枳实', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5728, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001376', 'cby', '侧柏叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5738, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001386', 'tef', '兔耳风', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5748, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001396', 'bx', '萹蓄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5758, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001406', 'ccsz', '炒楮实子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5768, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001416', 'yxhx', '盐小茴香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5778, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001426', 'xjp', '香加皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5788, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001436', 'tm', '天麻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5798, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001446', 'mbl', '马槟榔', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5808, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001456', 'rcr', '肉苁蓉', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5818, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001466', 'gjy', '鬼箭羽', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5828, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001476', 'hdk', '红豆蔻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5838, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001486', 'mdx', '母丁香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5848, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001496', 'jst', '鸡矢藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5858, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001506', 'cs', '蚕沙', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5868, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001516', 'yms', '夜明沙', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5878, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001526', 'ql', '蜣螂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5888, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001536', 'yzx', '盐泽泻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5898, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001546', 'csl(gsl)', '穿山龙(过山龙)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5908, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001556', 'ylzh', '盐荔枝核', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5918, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001566', 'zmhr', '炙麻黄绒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5928, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001576', 'dfz', '大风子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5938, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001586', 'fccs', '麸炒苍术', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5948, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001596', 'qh', '羌活', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5958, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001606', 'wrdk', '煨肉豆蔻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5968, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001616', 'sm', '苏木', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5978, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001626', 'dl', '地龙', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5988, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001636', 'dzy', '淡竹叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (5998, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001646', 'my', '麦芽', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6008, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001656', 'by', '白英', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6018, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001666', 'fg', '粉葛', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6028, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001676', 'fbx', '法半夏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6038, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001686', 'hlp', '黄连片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6048, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001696', 'ld', '龙胆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6058, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001706', 'mts', '密陀僧', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6068, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001716', 'jgc', '鸡骨草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6078, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001726', 'wy', '乌药', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6088, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001736', 'xmf', '玄明粉', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6098, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001746', 'bh', '百合', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6108, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001756', 'mcx', '马齿苋', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6118, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001766', 'fxy', '番泻叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6128, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001776', 'mmh', '蜜麻黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6138, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001786', 'gg', '葛根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6148, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001796', 'gc', '甘草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6158, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001806', 'dh', '独活', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6168, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001816', 'jj', '荆芥', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6178, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001826', 'bfp', '白附片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6188, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001836', 'lgs', '炉甘石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6198, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001846', 'fj', '防己', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6208, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001856', 'csg', '川射干', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6218, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001866', 'tef', '兔耳风', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6228, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001876', 'cwwz', '醋五味子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6238, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001886', 'jjs', '金精石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6248, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001896', 'hjh', '化橘红', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6258, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001906', 'jgl', '金果榄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6268, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001916', 'klp', '苦楝皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6278, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001926', 'sz', '桑椹', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6288, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001936', 'cxr', '川香薷', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6298, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001946', 'jhp', '姜厚朴', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6308, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001956', 'hl', '黄连', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6318, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001966', 'jhl', '酒黄连', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6328, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001976', 'zm', '知母', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6338, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001986', 'ybjt', '盐巴戟天', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6348, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001996', 'lw', '雷丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6358, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002006', 'qd', '青黛', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6368, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002016', 'llt', '路路通', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6378, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002026', 'wpc', '五匹草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6388, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002036', 'hq', '黄芪', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6398, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002046', 'zcw', '制草乌', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6408, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002056', 'cjc', '炒僵蚕', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6418, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002066', 'lxc', '灵香草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6428, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002076', 'ydtsz', '盐大菟丝子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6438, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002086', 'fczk', '麸炒枳壳', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6448, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002096', 'yxhx', '盐小茴香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6458, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002106', 'cy', '参叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6468, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002116', 'jms', '金礞石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6478, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002126', 'ydz', '盐杜仲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6488, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002136', 'sn', '山柰', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6498, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002146', 'zsl', '朱砂莲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6508, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002156', 'nx', '牛膝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6518, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002166', 'lxt', '灵仙藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6528, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002176', 'hb', '黄柏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6538, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002186', 'sjs', '桑寄生', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6548, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002196', 'pfp', '炮附片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_8` VALUES (6558, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002206', 'ff', '防风', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
COMMIT;

-- ----------------------------
-- Table structure for drug_resource_9
-- ----------------------------
DROP TABLE IF EXISTS `drug_resource_9`;
CREATE TABLE `drug_resource_9` (
  `id` bigint unsigned NOT NULL DEFAULT '0' COMMENT '主键',
  `drug_res_type_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT ' 药品和物资类型ID(dw_drug_res_type.id)',
  `base_type` tinyint NOT NULL DEFAULT '0' COMMENT '物品类型：1-药品, 2-耗材, 3-办公用品',
  `status` int DEFAULT '1' COMMENT '药品状态: 0 - 停用, 1 - 使用',
  `type_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药品或者耗材类别的字典ID(dw_dictionary.id AND dw_dictionary.type_id=[yplb OR hclb])',
  `dict_dosage_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药品剂型的字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypjx)',
  `code` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '集团编码',
  `pym` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '拼音简码',
  `name` varchar(64) CHARACTER SET utf8 DEFAULT '' COMMENT '药品或者耗材的名称',
  `manufacturer_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '生产厂家的字典ID(dw_dictionary.id AND dw_dictionary.type_id=sccj)',
  `approval_no` varchar(100) CHARACTER SET utf8 DEFAULT NULL COMMENT '批准文号',
  `med_type` int DEFAULT '3' COMMENT '医保分类： 1 - 无自付, 2 - 部分自付, 3 - 全自付',
  `admin_code` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '药监编码',
  `pack_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '包装单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypdw)',
  `min_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '最小单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=ypdw)',
  `pack_quantity` int DEFAULT '1' COMMENT '包装含量',
  `dosage_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '剂量单位字典ID(dw_dictionary.id AND dw_dictionary.type_id=jldw)',
  `dosage_quantity` decimal(10,2) DEFAULT '0.00' COMMENT '剂量含量',
  `pack_spec` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '包装规格，生成规则：[剂量含量] [剂量单位] * [包装含量] [最小单位] / [包装单位]',
  `take_method_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '用法(默认用法)(dw_dictionary.id AND dw_dictionary.type_id=ypyf)',
  `take_quantity` decimal(36,4) DEFAULT '0.0000' COMMENT '用量(默认用量)',
  `take_unit_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '用量单位字典ID - 暂留字典',
  `take_unit_name` varchar(36) CHARACTER SET utf8 DEFAULT 'ml' COMMENT '用量单位名称，默认ml',
  `take_frequency` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '频率(默认频率)(dw_dictionary.id AND dw_dictionary.type_id=yppl)',
  `common_unit_type` int DEFAULT '1' COMMENT '常规单位类型: 1 - 包装单位(packUnit), 2 - 最小单位(minUnit)',
  `purchase_price` decimal(8,4) DEFAULT '0.0000' COMMENT '进货价: 单位 元',
  `sale_price` decimal(8,4) DEFAULT '0.0000' COMMENT '基准价: 单位 元',
  `cost_category_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '费用类别字典ID(dw_dictionary.id AND dw_dicitionary.type_id=fylb)',
  `invoice_item_id` varchar(36) CHARACTER SET utf8 DEFAULT '' COMMENT '发票项目字典ID - 暂留',
  `expensive_flag` int DEFAULT '1' COMMENT '贵重物品标识： 0 - 非贵重物品， 1 - 贵重物品',
  `psy_flag_i` int DEFAULT '0' COMMENT ' 精神I类药品标识：0 - 非选中， 1 - 选中',
  `psy_flag_ii` int DEFAULT '0' COMMENT '精神II类药品标识：0 - 非选中，1 - 选中',
  `otc_flag` int DEFAULT '0' COMMENT 'OTC标识：0 - 非选中， 1 - 选中',
  `nar_flag` int DEFAULT '0' COMMENT '麻醉药品标识：0 - 非选中， 1 - 选中',
  `inventory_upper` int DEFAULT '0' COMMENT '库存上限',
  `inventory_lower` int DEFAULT '0' COMMENT '库存下限',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  `modify_time` datetime DEFAULT NULL COMMENT '修改时间',
  `del_flag` int DEFAULT '0' COMMENT '删除标志:  0 - 未删除, 1 - 已删除',
  `consumable_type` int NOT NULL DEFAULT '0' COMMENT '耗材类型:1-国产,2-进口',
  `tips` varchar(1024) CHARACTER SET utf8 DEFAULT NULL COMMENT '药品使用注意事项',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;

-- ----------------------------
-- Records of drug_resource_9
-- ----------------------------
BEGIN;
INSERT INTO `drug_resource_9` VALUES (9, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001031', 'yt', '牙挺', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '空心六角柄SS4', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (19, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000255', 'kfyxyg', '可负压吸引管', 'sccj_hzjlylqxyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, 'SG.Y01Fr14', '', 0.0000, '', 'ml', '', 1, 1.4000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (29, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000730', 'mrsbmwtxdb', '麦瑞斯表面物体消毒布', 'sccj_kwsb（sh）ykylqxyxgs', '--', 3, '', 'jjdw_t_5432', '', 1, '', 0.00, '160抽/桶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (39, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001323', 'yklzspA4', '亚克力展示牌A4', 'sccj_amzyc', '', 3, '', 'bzdw_z_8915', 'zxdw_g', 4, '', 0.00, '4个/组', '', 0.0000, '', 'ml', '', 2, 15.5000, 15.5000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (49, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000218', 'ycxsysyq dz（hdsyq）', '一次性使用输液器 带针（洪达输液器）', 'sccj_jxhdylqxjtyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '0.7#B3-1', '', 0.0000, '', 'ml', '', 1, 0.7000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (59, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_sj_2', 'ZKM00000446', 'kfbyyⅢ', '口服补液盐Ⅲ', 'sccj_xaajyyyxgs', 'H20090205', 3, '', 'bzdw_h', 'zxdw_d', 6, 'jldw_g', 5.12, '5.12g*6袋/盒', 'kf', 5.1200, '', '', 'bys', 1, 31.3400, 43.8800, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 4, NULL, '2018-05-24 14:18:29', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (69, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000215', 'lzz', '留置针', 'sccj_szxdylqxyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '22G', '', 0.0000, '', 'ml', '', 1, 11.3600, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (79, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000974', 'kdh', '款冬花', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.7280, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (89, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001840', 'gmyy10mlh ', '光敏印油10ml红 ', 'sccj_amzyc', NULL, 3, '', 'bzdw_p', 'zxdw_p_1', 1, '', 0.00, '1瓶/瓶', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (99, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001028', 'hsqzbx', '红色签字笔芯', 'sccj_amzyc', '', 3, '', 'bzdw_h', 'zxdw_z', 20, '', 0.00, '20支/盒', '', 0.0000, '', 'ml', '', 2, 0.6000, 0.6000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (109, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000258', 'ktplp', '卡托普利片', 'sccj_cqkrzy(jt)yxgs', '国药准字H50020362', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 25.00, '25.00mg*100片/瓶', '', 0.0000, '', '', '', 1, 3.9500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 13:36:04', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (119, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_kfy', 'ZKM00000104', 'sdcby', '蛇胆川贝液', 'sccj_scstyzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 6, 'jldw_ml', 10.00, '10ml*6支/盒', '', 0.0000, '', '', '', 1, 3.6000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 13:35:45', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (129, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001384', 'hl', '海龙', 'sccj_trt', '', 3, '', 'bzdw_z', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/支', '', 1.0000, '', '', '', 1, 38.0000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (139, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000106', 'lsxsmt', '磷酸锌水门汀', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '单粉单液', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (149, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000760', 'hqzp', '黄芪纵片', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/支', '', 10.0000, '', '', '', 1, 0.0620, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (159, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000549', 'dgt', '当归炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/支', '', 10.0000, '', '', '', 1, 0.2000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:47:11', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (169, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001664', 'etsbys', '儿童声波牙刷', 'sccj_ULKNN', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (179, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000714', 'jykkz', '机用扩孔钻', 'sccj_MANI', '国械注进20152551636', 3, '', 'jjdw_h', '', 1, '', 0.00, 'G28mm-2', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 09:30:24', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (189, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000881', 'zmg', '苎麻根', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0500, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 11:00:13', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (199, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000352', 'mz', '帽子', 'sccj_szshkylqxyxgs', '', 3, '', 'jjdw_j_8137', '', 1, '', 0.00, '120*170', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (209, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000234', 'ycxsyxtg（b）', '一次性使用吸痰管（包）', 'sccj_szsryxsjyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, 'F1450支/包', '', 0.0000, '', 'ml', '', 1, 1.2000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (219, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001490', 'ggctq', '根管充填器', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (229, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000175', 'ykmjd ggxhdyyj', '牙科灭菌袋 各个型号都要一卷', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (239, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000066', 'bllz', '玻璃离子', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '16*9', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (249, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_klj', 'ZKM00001707', 'xehfhnmkl（tcw）', '小儿黄酚黄那敏颗粒（甜橙味）', 'sccj_hrsj', 'H11022051', 3, '', 'bzdw_h', 'zxdw_d', 10, 'jldw_g', 6.00, '6.00g*10袋/盒', '', 0.0000, '', '', '', 1, 0.0000, 7.9000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (259, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000801', 'tbm', '土贝母', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.3360, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (269, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000980', 'jdh', '酒大黄', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.1680, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (279, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qwj', 'ZKM00001824', 'ynbyqwj', '云南白药气雾剂', 'sccj_ynbyjtgf', 'Z53021107', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_g', 110.00, '110.00g*1瓶/瓶', '', 0.0000, '', '', '', 1, 0.0000, 37.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-07-03 14:48:27', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (289, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001359', 'yyqj', '移液器架', 'sccj_dlxcsyyq（bj）yxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '旋转型', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (299, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001645', 'xddj', '心电电极', 'sccj_shltylqxyxgs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (309, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001712', 'xxbfxyrxj1L', '血细胞分析用溶血剂1L', 'sccj_glyltyldzyxgs', '-', 3, '', 'jjdw_j_8137', '', 1, '', 0.00, '件', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (319, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_xry', 'ZKM00001521', 'xryyxbgasry（fls）', '吸入用乙酰半胱氨酸溶液（富露施）', 'sccj_ydl ZAMBON S.P.A', 'H20150548', 3, '', 'bzdw_z', 'zxdw_ml', 3, 'jldw_g', 0.30, '0.30g*3ml/支', 'Inhal', 0.3000, '', '', 'qd', 1, 13.4100, 18.7700, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (329, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001047', 'bt', '笔筒', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 5.5000, 5.5000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (339, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000337', 'wssErjn', '维生素E软胶囊', 'sccj_njhjyyyxgs', '国药准字h32025074', 3, '', 'bzdw_h', 'zxdw_l', 60, 'jldw_mg', 100.00, '100.00mg*60粒/盒', '', 0.0000, '', '', '', 1, 41.8000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 13:55:28', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (349, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001296', 'yyycxbpd', '医用一次性备皮刀', 'sccj_ncsy', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '单只包装', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (359, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000381', 'gjjjhxqn', '硅胶急救呼吸气囊', 'sccj_twydyxgs', '', 3, '', 'jjdw_t', '', 1, '', 0.00, 'ENT-1024儿童', '', 0.0000, '', 'ml', '', 1, 540.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 16:10:27', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (369, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001219', 'cdk', '草豆蔻', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.1830, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (379, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001066', 'gghfhsz', '光固化复合树脂', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '7018A2B', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (389, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001339', 'xyj(syts)', '血压计(水银台式)', 'sccj_jsyy', '-', 3, '', 'jjdw_t_148', '', 1, '', 0.00, '水银台式血压仪', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (399, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000767', 'bcq', '荜澄茄', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0670, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (409, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_w', 'ZKM00001629', 'xyw(TX)', '逍遥丸(TX)', 'sccj_zjwxzygfyxgs', '170615', 3, '', 'bzdw_h', 'zxdw_w', 200, 'jldw_w', 1.00, '1.00丸*200丸/盒', '', 0.0000, '', '', '', 1, 0.0000, 18.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (419, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000510', 'omlewqem', '欧姆龙耳温枪耳帽', 'sccj_oml', '', 3, '', 'jjdw_h', '', 1, '', 0.00, 'TH839S', '', 0.0000, '', 'ml', '', 1, 70.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (429, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_pj', 'ZKM00000128', 'ffdcp（bmy）', '复方丹参片（薄膜衣）', 'sccj_gzbyshjhpzyyxgs', '国药准字z44023372', 3, '', 'bzdw_p', 'zxdw_p', 60, 'jldw_g', 0.32, '0.32g*60片/瓶', '', 0.0000, '', '', '', 1, 9.3000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 13:58:32', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (439, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000323', '3Mfhxhmj', '3M防化学护目镜', 'sccj_3Mzg', '', 3, '', 'jjdw_f_3720', '', 1, '', 0.00, '1621', '', 0.0000, '', 'ml', '', 1, 28.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-15 13:32:31', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (449, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000697', 'hsry', '花生仁衣', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0560, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (459, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001369', 'xhh', '西红花', 'sccj_trt', '', 3, '', 'bzdw_d', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 1.0000, '', '', '', 1, 67.2000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (469, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000634', 'ggczK3', '根管锉针K3', 'sccj_Ormcocorporat Ion Also sa ', '国械注进2017555068', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm混', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 08:51:37', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (479, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000613', 'xczj', '吸潮纸尖', 'sccj_tjjfylqxyxgs', '津械备2016005号', 3, '', 'jjdw_h', '', 1, '', 0.00, '40#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 09:52:08', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (489, 'bgyplb_yyzflcl', 3, 1, 'bgyplb_yyzflcl', '', 'ZKM00001496', 'hsmy', '护士毛衣', 'sccj_amzyc', NULL, 3, '', 'bzdw_j_4203', 'zxdw_j_2903', 1, '', 0.00, '1件/件', '', 0.0000, '', 'ml', '', 2, 169.0000, 169.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (499, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000877', 'plz', '婆罗子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.3080, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 10:58:14', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (509, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000560', 'hhl', '胡黄连', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.2200, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (519, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001465', 'cscwj4#（25mm）', '彩色长尾夹4#（25mm）', 'sccj_amzyc', NULL, 3, '', 'bzdw_h', 'zxdw_h', 1, '', 0.00, '1盒/盒', '', 0.0000, '', 'ml', '', 2, 19.0000, 19.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-04-11 10:21:35', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (529, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001389', 'yh', '药盒', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '30*16*9.5cm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (539, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001265', 'lqh	', '利器盒	', 'sccj_bjkylsmyxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '5L方形', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (549, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001187', 'zfl', '朱茯苓', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0580, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (559, 'bgyplb_yyzflcl', 3, 1, 'bgyplb_yyzflcl', '', 'ZKM00001502', 'hsf', '护士服', 'sccj_amzyc', NULL, 3, '', 'bzdw_j_4203', 'zxdw_j_2903', 1, '', 0.00, '1件/件', '', 0.0000, '', 'ml', '', 2, 160.0000, 160.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (569, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000189', 'zzx', '周转箱', 'sccj_bjjrkkjyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 65.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-07-31 13:59:44', 0, 1, NULL);
INSERT INTO `drug_resource_9` VALUES (579, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001122', 'zw', '紫菀', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.1570, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (589, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000240', 'acjzsy', '氨茶碱注射液', 'sccj_tjjyyyyxgs', 'H12020884', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 2.00, '2.00ml*1支/支', '', 0.0000, '', '', '', 1, 0.8500, 1.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 3, NULL, '2018-04-08 17:28:21', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (599, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000203', 'jylpap', '甲氧氯普胺片', 'sccj_sxypzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 5.00, '5mg*100片/瓶', '', 0.0000, '', '', '', 1, 3.3500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 11:10:02', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (609, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000015', 'slrsg', '塑料软试管', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_d', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (619, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00001162', 'fjcsdztwj', '非接触式电子体温计', 'sccj_bek', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, 'JXB-183', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 11:43:03', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (629, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000625', 'yyrm', '薏苡仁面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0750, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (639, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001849', 'sdj', '色带架', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (649, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000086', 'TF ntc 27mm', 'TF 镍钛锉 27mm', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (659, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rg', 'ZKM00001650', 'qandykzrg（TX）', '曲安奈德益康唑乳膏（TX）', 'sccj_xayszyyxgs', '170531922', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 15.00, '15.00g*1支/支', 'thc_2', 0.0100, '', '', 'mr2c', 1, 0.0000, 16.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 10:41:23', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (669, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000915', 'ggqxhj（10%EDTAzz）', '根管清洗糊剂（10%EDTA支装）', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '2支*7ml', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (679, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000239', 'xsgyzsy', '硝酸甘油注射液', 'sccj_hnrhzygfyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_ml', 1.00, '1ml*10支/盒', '', 0.0000, '', '', '', 1, 8.1000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 14:55:17', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (689, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000064', 'dgy', '碘甘油', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '20ML', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (699, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000837', 'ggc（Hc-25h）', '根管锉（H锉-25混）', 'sccj_mnzshs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm 15-40# 6*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 24.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-22 15:49:51', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (709, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_hsp', 'ZKM00000396', 'mdpp', '米氮平片', 'sccj_bjnhzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_kg_g', 10, 'jldw_g', 30.00, '30g/盒', 'ad us.int', 45.0000, '', '', 'bid', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 0, 0, 0, 2, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (719, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000464', 'wssB6zsy', '维生素B6注射液', 'sccj_tjjyjthbtyyygfyxgs', 'H42020023', 3, '', 'bzdw_z', 'zxdw_ml', 2, 'jldw_g', 0.10, '0.10g*2ml/支', '', 0.0000, '', '', '', 1, 1.5000, 2.1000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 2, NULL, '2018-05-11 16:36:33', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (729, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000320', 'pjq', '帕巾钳', 'sccj_shylqx（jt）yxgsssqxc', '', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'JCA46016CM直细针0.3（圆鳃）', '', 0.0000, '', 'ml', '', 1, 77.1200, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (739, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000957', 'dbb（lxg）', '大便杯（螺旋盖）', 'sccj_w', '-', 3, '', 'jjdw_z_5693', '', 1, '', 0.00, '40ml', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (749, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001354', 'bstb', '白砂糖包', 'sccj_amzyc', '', 3, '', 'bzdw_h', 'zxdw_h', 1, '', 0.00, '1盒/盒', '', 0.0000, '', 'ml', '', 2, 22.8000, 22.8000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (759, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000052', 'xcgzkp', '血常规质控品', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (769, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001297', 'hsf', '滑石粉', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0290, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (779, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001256', 'dj', '大蓟', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0800, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (789, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000390', 'bxgdgfp', '不锈钢带盖方盘', 'sccj_gdscaxctqsylqxc', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '11.5寸无孔', '', 0.0000, '', 'ml', '', 1, 28.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (799, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000659', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'TF-21(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (809, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00001676', 'lsmzsy', '硫酸镁注射液', 'sccj_hzmsyyyxgs', 'H33021961', 3, '', 'bzdw_h', 'zxdw_z', 5, 'jldw_ml', 10.00, '10.00ml*5支/盒', '', 0.0000, '', '', '', 2, 0.0000, 4.4000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (819, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001188', 'cjmzm', '炒决明子面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0200, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (829, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000169', 'jgj', '金冠剪', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '直/弯', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (839, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00001161', 'yyyqd', '医用氧气袋', 'sccj_lkskhylqxyxgs', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '72*45', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 11:41:06', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (849, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000654', 'bmst', '薄膜手套', 'sccj_hnsabwcyxgs', '--', 3, '', 'jjdw_d', '', 1, '', 0.00, '中号', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (859, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tptj', 'ZKM00000416', 'ymp', '愈美片', 'sccj_hszyyxgs', 'H20030712', 3, '', 'bzdw_h', 'zxdw_p', 12, 'jldw_p', 1.00, '1.00片*12片/盒', '', 0.0000, '', '', '', 1, 9.3000, 11.1600, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 10, 3, NULL, '2018-05-04 16:44:41', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (869, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001861', 'lstjp（ksy）', '氯沙坦钾片（科素亚）', 'sccj_msdzyyxgs', 'J20130148', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_hk', 50.00, '50毫克*7片/盒', '', 0.0000, '', '', '', 1, 0.0000, 59.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (879, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000814', 'zgc', '制干蟾', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2910, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (889, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000741', 'yzhjcz（gmcz）', '硬质合金车针（固美车针）', 'sccj_dgHeraeus Kulzergmbh', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'H379.314.01', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (899, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_wy', 'ZKM00000272', 'bbtrt', '兵兵退热贴', 'sccj_zhgjxcgfyxgs', '', 3, '', 'bzdw_d', 'zxdw_t', 2, 'jldw_mm', 125.00, '125mm*2贴/袋', '', 0.0000, '', '', '', 1, 5.2000, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 15:06:42', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (909, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_jnj', 'ZKM00000163', 'slxmkjn', '松龄血脉康胶囊', 'sccj_cdkhzyyxgs', '国药准字z10960023', 3, '', 'bzdw_p', 'zxdw_l', 30, 'jldw_g', 0.50, '0.50g*30粒/瓶', '', 0.0000, '', '', '', 1, 22.1600, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:38:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (919, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000747', 'hyz', '黄药子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0450, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (929, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001153', 'sbbd', '纱布绷带', 'sccj_bjgsyl', '陕食械备2015002号', 3, '', 'jjdw_j', '', 1, '', 0.00, '600cm*6cm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 11:20:55', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (939, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000670', 'lg', '芦根', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0950, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (949, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001174', 'xy', '辛夷', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1680, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (959, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000765', ' mbb', ' 蜜百步', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1560, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (969, 'hclb_sjlcl', 2, 0, 'hclb_sjlcl', '', 'ZKW00000460', 'nszt', '尿试纸条', 'sccj_glyltyldzyxgs', '', 3, '', 'jjdw_t_7475', '', 1, '', 0.00, '11G/100条', '', 0.0000, '', 'ml', '', 1, 2.2000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-20 17:28:31', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (979, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001438', 'yywjycxhyb', '医用无菌一次性换药包', 'sccj_yzyc', '-', 3, '', 'jjdw_x', '', 1, '', 0.00, '箱', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (989, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000815', 'shhz', '水红花子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1120, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (999, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000988', 'sfhs', '生浮海石', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2020, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1009, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001244', 'kkszxd	', '卡扣式止血带	', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '-', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1019, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000366', 'csx（bzx）dz', '蚕丝线（编织型）带针', 'sccj_hzhwylypyxgs', '20170870320170830', 3, '', 'jjdw_b', '', 1, '', 0.00, '4-070cm△1/25x12单针', '', 0.0000, '', 'ml', '', 1, 4.4000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1029, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_xry', 'ZKM00001423', 'ysp', '叶酸片', 'sccj_lnglswyy', '国药准字H21021044', 3, '', 'bzdw_h', 'zxdw_p', 31, 'jldw_hk', 0.40, '0.40毫克*31片/盒', 'kf', 0.4000, '', '', 'mr1c', 1, 5.3200, 6.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 3, 1, NULL, '2018-05-24 14:08:10', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1039, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000659', 'ggy', '枸骨叶', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 0.0000, '', '', '', 1, 0.0560, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1049, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001216', 'cat', '醋艾炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0440, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1059, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_pj', 'ZKM00000507', 'lstjp（ksy）', '氯沙坦钾片（科素亚）', 'sccj_msdzyyxgs', 'J20130048', 3, '', 'bzdw_h', 'zxdw_p', 7, 'jldw_mg', 50.00, '50.00mg*7片/盒', 'ad us.int', 50.0000, '', '', 'qd', 1, 37.9400, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 2, NULL, '2018-07-06 10:23:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1069, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000860', 'wz', '乌枣', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0840, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1079, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000942', 'yms', '夜明砂', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0540, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-03-07 14:01:38', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1089, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_wj', 'ZKM00000148', 'dhjsw', '独活寄生丸', 'sccj_sxhkyygfyxgs', '国药准字z2004369', 3, '', 'bzdw_h', 'zxdw_d', 6, 'jldw_g', 6.00, '6.00g*6袋/盒', '', 0.0000, '', '', '', 1, 4.7000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:49:47', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1099, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000811', 'qd', '青黛', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.2240, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1109, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001628', 'dzdyjj06（30#）', '大锥度牙胶尖06（30#）', 'sccj_dsbyk（tj）yxgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1119, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001514', 'zjexmx', '针灸耳穴模型', 'sccj_shff		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1129, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001218', 'sgj', '试管架', 'sccj_jsjy', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '江苏1.6*50孔', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1139, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000242', 'yysbbd', '医用纱布绷带', 'sccj_cxlhwsclyxgs', '', 3, '', 'jjdw_k_7001', '', 1, '', 0.00, '3列6米21*21', '', 0.0000, '', 'ml', '', 1, 4.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1149, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000678', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'BR-S45(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1159, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000006', 'zjz', '针灸针', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '30mm*0.25', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1169, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000337', 'zzn（gjzs））', '组织镊（国际制式））', 'sccj_shylqx（jt）yxgsssqxc', '', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'TC703024CM(巴氏）', '', 0.0000, '', 'ml', '', 1, 104.4000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1179, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_pj', 'ZKM00000275', 'sjgmp', '桑菊感冒片', 'sccj_zhgjxcgfyxgs', '', 3, '', 'bzdw_h', 'zxdw_h', 1, 'jldw_p', 48.00, '48.00片*1盒/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1189, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001512', 'znbfry（CPkqyjj）', '樟脑苯酚溶液（CP口腔抑菌剂）', 'sccj_sccj（cs）', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1199, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000297', 'xhpmjbzcl', '新华牌灭菌包装材料', 'sccj_sdxhylqxgfyxgs', '', 3, '', 'jjdw_j', '', 1, '', 0.00, '100cm*10cm*2cm3卷/箱', '', 0.0000, '', 'ml', '', 1, 300.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 14:10:29', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1209, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001202', 'lswfb	', '蓝色无纺布	', 'sccj_mnsdkyzzyyqc		', '-', 3, '', 'jjdw_x', '', 1, '', 0.00, '3M600mm*60cm500张/箱', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1219, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000753', 'gghsb', '光固化设备', 'sccj_shhg', '--', 3, '', 'jjdw_t_148', '', 1, '', 0.00, 'D4', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1229, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_klj', 'ZKM00000212', 'xebnzwB1kl', '小儿贝诺酯维B1颗粒', 'sccj_dajtcdyygfyxgs', '国药准字H51023694', 3, '', 'bzdw_h', 'zxdw_d', 12, 'jldw_g', 0.30, '0.30g*12袋/盒', '', 0.0000, '', '', '', 1, 13.6800, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 14:55:29', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1239, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000586', 'Kc', 'K锉', 'sccj_xnddsb', '国械备20170214号', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm-15', '', 0.0000, '', 'ml', '', 1, 0.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1249, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000736', 'xczj', '吸潮纸尖', 'sccj_tjjfylqxyxgs', '天津械备20160055号', 3, '', 'jjdw_h', '', 1, '', 0.00, '30#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 09:53:02', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1259, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001510', 'blzcb', '焙朗早餐饼', 'sccj_amzyc', NULL, 3, '', 'bzdw_h', 'zxdw_h', 1, '', 0.00, '1盒/盒', '', 0.0000, '', 'ml', '', 2, 10.9000, 10.9000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1269, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001706', 'wlbycg ', '微量泵延长管 ', 'sccj_zjysylqxgfyxgs', '-', 3, '', 'jjdw_t', '', 1, '', 0.00, '套', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1279, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000729', 'pj', '炮姜', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.1340, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1289, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001295', 'ycxdnb', '一次性导尿包', 'sccj_zjsd', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '14Fr(5ml-10ml)III型', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1299, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000584', 'sgj', '石膏剪', 'sccj_shkqylqxyxgs', 'Q31/0115000708000', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '16cm', '', 0.0000, '', 'ml', '', 1, 0.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1309, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000832', 'yyn', '牙用镊', 'sccj_shkqylqxyxgs', '沪浦械备20160110', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '双弯无定位', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 08:44:32', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1319, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_crp', 'ZKM00000511', 'ffdyxajf（Ⅱ）', '复方对乙酰氨基酚（Ⅱ）', 'sccj_beyybjyxgswtsdxhzygfyxgs', 'H20056948', 3, '', 'bzdw_h', 'zxdw_p', 10, 'jldw_p', 1.00, '1.00片*10片/盒', '', 0.0000, '', '', '', 1, 6.7000, 9.3800, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 10, 3, NULL, '2018-04-19 11:47:20', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1329, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001157', 'jcz', '韭菜子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1120, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1339, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001572', 'lhjzsy', '氯化钾注射液', 'sccj_zgdzzyyxgs', 'H20053710', 3, '', 'bzdw_z', 'zxdw_ml', 10, 'jldw_g', 1.00, '1.00g*10ml/支', '', 0.0000, '', '', '', 1, 1.2900, 2.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1349, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000443', 'ycxsyyydd', '一次性使用医用垫单', 'sccj_hnydsyyxgs', '', 3, '', 'jjdw_k_7001', '', 1, '', 0.00, '150*90cm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1359, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000922', 'smy', '生麦芽', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0340, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1369, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001006', 'jgscz', '金刚砂车针', 'sccj_w', '-', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'EX-21EF', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1379, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001077', 'A4fyz（fs）', 'A4复印纸（粉色）', 'sccj_amzyc', '', 3, '', 'bzdw_b', 'zxdw_b', 1, '', 0.00, '1包/包', '', 0.0000, '', 'ml', '', 2, 14.9000, 14.9000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1389, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_hj', 'ZKM00000521', 'shlkfy', '双黄连口服液', 'sccj_hyjtsjzyyxgs', 'Z10920053', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_ml', 10.00, '10.00ml*10支/盒', 'ad us.int', 20.0000, '', '', 'TID', 1, 14.5000, 17.4000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 1, 0, 10, 2, NULL, '2018-04-19 15:27:26', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1399, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000509', 'mlstnjjp', '孟鲁司特钠咀嚼片', 'sccj_msdzyyxgs', '国药准字j20130053', 3, '', 'bzdw_h', 'zxdw_p', 5, 'jldw_mg', 4.00, '4.00mg*5片/盒', '', 0.0000, '', '', '', 1, 28.8600, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-25 13:30:42', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1409, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000969', 'xy', '香橼', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1680, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1419, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000608', 'sdy', '生稻芽', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0100, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1429, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000886', 'ggtcq（czjyq-st）', '根管填充器（垂直加压器-双头）', 'sccj_w', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'KRCP#9/11', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1439, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000715', 'jgl', '绞股蓝', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0500, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1449, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tj', 'ZKM00001643', 'fjkqm', '蜂胶口腔膜', 'sccj_hrzzyyyxgs', '24170912', 3, '', 'bzdw_h', 'zxdw_p', 30, 'jldw_cm', 1.00, '1.00cm*30片/盒', '', 0.0000, '', '', '', 1, 0.0000, 19.8000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1459, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000826', 'yyjyxfm', '医用胶原修复膜', 'sccj_EA', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '15*20mm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1469, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000080', 'shj', '失活剂', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '慢', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1479, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001573', 'hjq', '呼叫器', 'sccj_w', '-', 3, '', 'jjdw_t_148', '', 1, '', 0.00, '台', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1489, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000461', 'zsys', '注射用水', 'sccj_dzzy', '', 3, '', 'bzdw_p', 'zxdw_ml', 500, 'jldw_ml', 1.00, '1.00ml*500ml/瓶', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 5, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1499, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000008', 'mxz', '埋线针', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '9号', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1509, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001341', 'sytwj', '水银体温计', 'sccj_ahfd', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '内标式腋下无汞10支/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1519, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001214', 'ycxzjz	', '一次性针灸针	', 'sccj_szhq', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '0.25*40mm*10支/10片/盒华佗牌', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1529, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000937', 'gs', '甘松', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.2690, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1539, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001412', 'yygsjp（swzp）', '医用干式胶片（实为赠品）', 'sccj_hqylkj（sz）yxgs		', '-', 3, '', 'jjdw_zhang', '', 1, '', 0.00, '10*12', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1549, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001467', 'gmdzdbdgc（HDL-C）cdsjh	', '高密度脂蛋白胆固醇（HDL-C）测定试剂盒	', 'sccj_szmr', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1559, 'bgyplb_yslcl', 3, 1, 'bgyplb_yslcl', '', 'ZKM00001416', 'xxf', '小信封', 'sccj_amzyc', '', 3, '', 'bzdw_b', 'zxdw_g', 1000, '', 0.00, '1000个/包', '', 0.0000, '', 'ml', '', 2, 0.3100, 0.3100, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1569, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000332', 'ysldkyzsy', '盐酸利多卡因注射液', 'sccj_tjjyyyyxgs', 'H2021000', 3, '', 'bzdw_h', 'zxdw_z', 5, 'jldw_ml', 5.00, '5.00ml*5支/盒', '', 0.0000, '', '', '', 2, 1.5600, 2.4000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-22 10:19:57', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1579, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_klj', 'ZKM00000283', 'xeafhnmkl(xesxgmkl)', '小儿氨酚黄那敏颗粒(小儿速效感冒颗粒)', 'sccj_scykzyyxgs', 'h51023460', 3, '', 'bzdw_h', 'zxdw_d', 9, 'jldw_g', 6.00, '6.00g*9袋/盒', '', 0.0000, '', '', '', 1, 1.8800, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 16:02:19', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1589, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000758', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '国械注进20152552079', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'F0-32(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1599, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000391', 'jhsptstp', '甲磺酸培他司汀片', 'sccj_wc（zg）yyyxgs', 'H20040130', 3, '', 'bzdw_h', 'zxdw_p', 30, 'jldw_mg', 6.00, '6.00mg*30片/盒', 'ad us.int', 12.0000, '', '', 'TID', 1, 12.0000, 16.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 3, NULL, '2018-04-08 11:14:01', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1609, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_zsj', 'ZKM00000237', 'ysybqzsy', '盐酸异丙嗪注射液', 'sccj_shhfzyyxgs', '国药准字H31021490', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_ml', 1.00, '1.00ml*10支/盒', '', 0.0000, '', '', '', 1, 1.3000, 1.8200, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 3, NULL, '2018-04-08 16:19:20', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1619, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000689', 'zhswm', '制何首乌面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0950, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-03-14 11:04:45', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1629, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000593', 'shsw', '生何首乌', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0900, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1639, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001294', 'ycxssy', '一次性手术衣', 'sccj_jxym', '-', 3, '', 'jjdw_j_8137', '', 1, '', 0.00, '双袖XL', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1649, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000277', 'ystzndp', '盐酸替扎尼定片', 'sccj_sckrdzygfyxgs(ysckrdzyyxgs)', 'h20060645', 3, '', 'bzdw_h', 'zxdw_p', 24, 'jldw_mg', 2.00, '2.00mg*24片/盒', '', 0.0000, '', '', '', 1, 56.1500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-19 12:43:02', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1659, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001099', 'gzq', '刮治器', 'sccj_w', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, 'SG13/149E2', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1669, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000416', 'bxgqpq', '不锈钢启瓶器', 'sccj_（bjwxcf）caqsylqxc', '', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '普通', '', 0.0000, '', 'ml', '', 1, 8.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1679, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001374', 'ktfyxyg', '可调负压吸引管', 'sccj_hzjlylqxyxgs		', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, 'Fr14', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1689, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000929', 'tzc', '太子参', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 1.3440, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1699, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000994', 'blg', '板蓝根', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.1230, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1709, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000883', 'tgq', '剔刮器', 'sccj_w', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '#E510支/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1719, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001740', 'lxxp', '氯硝西泮', 'sccj_jsehyygfyxgs', 'H10930004', 3, '', 'bzdw_h', 'zxdw_p', 20, 'jldw_hk', 2.00, '2.00毫克*20片/盒', 'chkf', 2.0000, '', '', 'm8xsyc', 1, 0.0000, 11.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 1, 0, 0, 3, 1, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1729, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rg', 'ZKM00000248', 'fxdsrg', '夫西地酸乳膏', 'sccj_amzyc', 'hc20150043', 3, '', 'bzdw_h', 'zxdw_z', 1, 'jldw_g', 10.00, '10.00g*1支/盒', '', 0.0000, '', '', '', 1, 15.8500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 16:05:52', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1739, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_tj', 'ZKM00001719', 'sszt（tlwk）', '伤湿止痛（弹力微孔）', 'sccj_hswsclyyyxgs', 'Z42021954', 3, '', 'bzdw_h', 'zxdw_t', 5, 'jldw_cm', 6.80, '6.80cm*5贴/盒', 'thc_1', 6.8000, '', '', 'mr1c', 1, 0.0000, 5.4000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 16:25:55', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1749, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000807', 'mq', '棉球', 'sccj_hnsabwcyxgs', '川食药监械（准）字2013第2640139号', 3, '', 'jjdw_b', '', 1, '', 0.00, 'M', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1759, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_wj', 'ZKM00000307', 'lsw', '六神丸', 'sccj_lysyyjtyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 12, 'jldw_l', 10.00, '10.00粒*12支/盒', '', 0.0000, '', '', '', 1, 29.0000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1769, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000660', 'gcm', '甘草面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0900, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1779, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000285', 'ldxdtz', '六导心电图纸', 'sccj_dd', '', 3, '', 'jjdw_b_2336', '', 1, '', 0.00, '110mmX140mm', '', 0.0000, '', 'ml', '', 1, 12.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1789, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001615', 'fyh532505AN2.5g', '防氧化532505AN2.5g', 'sccj_yhjwwdtgs', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1799, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000570', 'mq', '棉签', 'sccj_schys', 'MQ233', 3, '', 'jjdw_b', '', 1, '', 0.00, '5-6cm', '', 0.0000, '', 'ml', '', 1, 0.0000, 2.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1809, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000935', 'yjj（jz）', '牙胶尖（简装）', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '15#100*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1819, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001391', 'kwt', '口温套', 'sccj_mgWelch Allyyn.Incgs', '国食药监械（进）2014第2203175号', 3, '', 'jjdw_ge', '', 1, '', 0.00, '20个/盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1829, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000654', 'mqh', '蜜前胡', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0780, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1839, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pwj', 'ZKM00000418', 'ysqjzlpwj', '盐酸羟甲唑啉喷雾剂', 'sccj_szdfyygfyxgs', 'H10980317', 3, '', 'bzdw_z', 'zxdw_ml', 10, 'jldw_%', 0.05, '0.05%*10ml/支', 'ad us.ext', 0.0000, '', '', 'Q12h', 1, 17.5000, 21.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 5, 2, NULL, '2018-04-19 13:51:11', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1849, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_crp', 'ZKM00000526', 'ysadtzsy', '盐酸胺碘酮注射液', 'sccj_snf（hz）zyyxgs', 'J20130036', 3, '', 'bzdw_z', 'zxdw_ml', 3, 'jldw_g', 0.15, '0.15g*3ml/支', 'Iv', 0.1500, '', '', 'St', 1, 25.8300, 36.1700, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 6, 2, NULL, '2018-04-19 16:55:22', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1859, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001062', 'czd', '裁纸刀', 'sccj_amzyc', '', 3, '', 'bzdw_b_9933', 'zxdw_b_1129', 1, '', 0.00, '1把/把', '', 0.0000, '', 'ml', '', 2, 3.5000, 3.5000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1869, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001085', 'ggc', '根管锉', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, 'MANIK-FILES8#-21mm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1879, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_klj', 'ZKM00001315', 'tbkwkl（ek）', '头孢克肟颗粒（儿科）', 'sccj_gzhjzy', 'h20051928', 3, '', 'bzdw_h', 'zxdw_d', 12, 'jldw_mg', 50.00, '50.00mg*12袋/盒', '', 0.0000, '', '', '', 1, 26.4000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 16:45:13', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1889, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000784', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '国械注进20152552079', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'TR-11(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1899, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000263', 'yxtg40pttzsy(kld)', '右旋糖酐40葡萄糖注射液(可立袋)', 'sccj_scklyygfyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_ml', 500.00, '500ml*1袋/袋', '', 0.0000, '', '', '', 1, 5.9400, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 15:03:57', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1909, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000147', 'bpcp', '别嘌醇片', 'sccj_hfjlzyyxgs', 'h34021248', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_g', 0.10, '0.10g*100片/瓶', '', 0.0000, '', '', '', 1, 38.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 16:46:17', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1919, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000698', 'yb', '鱼鳔', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.3870, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1929, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001250', 'xjt', '小蓟炭', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0160, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1939, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000032', 'slys', '生理盐水', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '10ml', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1949, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001329', 'tjp', '土荆皮', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0780, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1959, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001237', 'zxglsfklkz	', '自吸过滤式防颗粒口罩	', 'sccj_3M', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, 'N95耳挂式白色', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1969, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001111', 'bbyytrt', '兵兵医用退热贴', 'sccj_zhgjxcgfyxgs', '粤珠食药监械生产备20140003号', 3, '', 'jjdw_h', '', 1, '', 0.00, '112.5*mm*40mm1贴*2袋', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-30 14:42:14', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1979, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000577', 'Hc', 'H锉', 'sccj_xnddsb', '国器备20170214', 3, '', 'jjdw_h', '', 1, '', 0.00, '25mm-30', '', 0.0000, '', 'ml', '', 1, 0.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1989, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001051', 'A4klwjj', 'A4快劳文件架', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 2.0400, 2.0400, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (1999, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000874', 'hjs', '海金沙', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.7840, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 10:57:49', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2009, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000644', 'jjmz', '焦决明子', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0100, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2019, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001383', 'ssj', '手术剪', 'sccj_shylqx', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '16cm，直圆无镀层', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2029, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_hsp', 'ZKM00000022', 'zcy1', '中成药1', 'sccj_bjsykyy', '11', 3, '', 'bzdw_h', 'zxdw_p_1', 14, 'jldw_g', 214.00, '214.00g*14瓶/盒', '', 0.0000, '', '', '', 1, 0.0000, 12.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2039, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00000543', '0.9%lhnzsy', '0.9%氯化钠注射液', 'sccj_rs', 'H20044024', 3, '', 'bzdw_z', 'zxdw_ml', 10, 'jldw_mg', 90.00, '90.00mg*10ml/支', 'Iv', 90.0000, '', '', 'qd', 2, 0.4600, 0.6400, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-19 10:39:52', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2049, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001091', 'byq/crbyq', '拔牙钳/成人拔牙钳', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '65#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2059, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001406', 'ffgcsgp（mn）', '复方甘草酸苷片（美能）', 'sccj_qspjzshs', 'H20130148', 3, '', 'bzdw_h', 'zxdw_p', 100, 'jldw_mg', 25.00, '25.00mg*100片/盒', 'Pc', 25.0000, '', '', 'TID', 1, 133.0000, 186.2000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-04-02 18:08:06', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2069, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001273', 'jhb', '酒黄柏', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/包', '', 10.0000, '', '', '', 1, 0.0960, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2079, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000086', 'jzxp', '甲状腺片', 'sccj_sdshnyyyxgsysdslyswhxzyc', 'h37020075', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 40.00, '40.00mg*100片/瓶', '', 0.0000, '', '', '', 1, 13.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 17:01:21', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2089, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000130', 'xpw', '橡皮碗', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2099, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000514', 'jzsmxsxdy', '健之素免洗手消毒液', 'sccj_jzs', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '500ml', '', 0.0000, '', 'ml', '', 1, 25.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2109, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000068', '3Mfbhq', '3M氟保护漆', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2119, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001565', 'zst', '指示贴', 'sccj_amzyc', NULL, 3, '', 'bzdw_b_9413', 'zxdw_b_2375', 1, '', 0.00, '1本/本', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2129, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000904', 'csjyjgzj（ggdxz）', '超声洁牙机工作尖（根管荡洗针）', 'sccj_w', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '35#绿6*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2139, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001278', 'fbx', '法半夏', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.8730, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2149, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000087', 'bxgKc 21mm', '不锈钢K锉 21mm', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2159, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000600', 'jgy', '焦谷芽', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0160, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2169, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000121', 'lsgcl', '临时冠材料', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2179, 'hclb_gzyhp', 2, 1, 'hclb_gzyhp', '', 'ZKW00001578', 'sysbbzyx', '实验室标本转运箱', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2189, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001473', 'M 53Pttqjy（wfl）	', 'M 53P探头清洁液（五分类）	', 'sccj_szmr', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2199, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000181', 'cjhsp', '茶碱缓释片', 'sccj_gzmtxhzycyxgs', 'h44023791', 3, '', 'bzdw_h', 'zxdw_p', 24, 'jldw_g', 0.10, '0.10g*24片/盒', '', 0.0000, '', '', '', 1, 3.2500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 17:04:44', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2209, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001462', 'xp', '胸牌', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 7.0000, 7.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2219, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_tptj', 'ZKM00000412', 'fnbtjn', '非诺贝特胶囊', 'sccj_Abbott Biologicals B.V.', '', 3, '', 'bzdw_h', 'zxdw_l', 10, 'jldw_g', 0.20, '0.20g*10粒/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2229, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000861', 'gzjyggqx（jyGz-28h）', '钢质机用根管器械（机用G钻-28混）', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '28mm1-6#6*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2239, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000640', 'SSWdscz', 'SSW低速车针', 'sccj_SSW.WHITE BURS.IN', '--', 3, '', 'jjdw_z', '', 1, '', 0.00, 'RA-4', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2249, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_dyj', 'ZKM00000299', 'yszyfsxdyy', '盐酸左氧氟沙星滴眼液', 'sccj_cxfdyy(ws)yxgs(ycxyygfyxgs)', 'h20103569', 3, '', 'bzdw_h', 'zxdw_z', 1, 'jldw_ml', 5.00, '5.00ml*1支/盒', '', 0.0000, '', '', '', 1, 1.9500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 17:06:01', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2259, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001199', 'mxsxy（nj）	', '免洗手消液（凝胶）	', 'sccj_sdlekylkjyxgs', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '246ml/瓶利尔康', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2269, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_wj', 'ZKM00000114', 'jpw（nsx）', '健脾丸（浓缩型）', 'sccj_hnsjysjsyyyxgs', 'z41020007', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_w', 240.00, '240.00丸*1瓶/瓶', '', 0.0000, '', '', '', 1, 6.5000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 17:06:35', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2279, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000937', 'yjj（jz）', '牙胶尖（简装）', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '25#100*1', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2289, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_rgj', 'ZKM00001761', 'axlwrg', '阿昔洛韦乳膏', 'sccj_hbfryy', 'H19999049', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_g', 10.00, '10.00g*1支/支', 'tpfhc_2', 0.1000, '', '', 'bys', 1, 0.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2299, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000670', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'TF-13C(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2309, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_klj', 'ZKM00000110', 'qklkl', '清开灵颗粒', 'sccj_gzbysmxzyyxgs', '国药准字Z10950088', 3, '', 'bzdw_h', 'zxdw_xd', 9, 'jldw_g', 3.00, '3.00g*9小袋/盒', '', 0.0000, '', '', '', 1, 12.3800, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:14:33', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2319, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001680', 'twc', '头围尺', 'sccj_sdrhtyyyxgs', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2329, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000391', 'dzkkq', '丁字开口器', 'sccj_zjgsjfjldjc', '', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '13CM', '', 0.0000, '', 'ml', '', 1, 3.5000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 13:40:59', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2339, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_cj', 'ZKM00000209', 'ykxwssADdj（0-1s）', '伊可新维生素AD滴剂（0-1岁）', 'sccj_adyy(bj)yxgs', '', 3, '', 'bzdw_h', 'zxdw_b', 1, 'jldw_l', 20.00, '20.00粒*1包/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2349, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001198', 'gljm', '高良姜面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.0450, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2359, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000770', 'wztp', '网状托盘', 'sccj_rxckclyxgs', '沪食药监械', 3, '', 'jjdw_f_3720', '', 1, '', 0.00, '边口', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2369, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001403', 'ycxcd', '一次性床单', 'sccj_jxym		', '-', 3, '', 'jjdw_zhang', '', 1, '', 0.00, '100*200单包400张/件2张/包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2379, 'bgyplb_dzl', 3, 1, 'bgyplb_dzl', '', 'ZKM00001539', 'jp', '键盘', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2389, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001618', 'ympy2.0', '压模片硬2.0', 'sccj_Ultradert product Inc', '', 3, '', 'jjdw_zhang', '', 1, '', 0.00, '张', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2399, 'bgyplb_dzl', 3, 1, 'bgyplb_dzl', '', 'ZKM00001842', 'TP-LINK5kbzjhjTL-SF1005+', 'TP-LINK5口百兆交换机TL-SF1005+', 'sccj_amzyc', NULL, 3, '', 'bzdw_t_9258', 'zxdw_t_6854', 1, '', 0.00, '1台/台', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2409, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000513', 'lhnzsy（rd）（0.9%）', '氯化钠注射液（软袋）（0.9%）', 'sccj_zgdzzyyxgs', 'H12020024', 3, '', 'bzdw_d', 'zxdw_ml', 100, 'jldw_g', 0.90, '0.90g*100ml/袋', '', 0.0000, '', '', '', 1, 5.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 20, 5, NULL, '2018-03-07 16:51:12', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2419, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000745', 'tzs', '烫枳实', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/盒', '', 10.0000, '', '', '', 1, 0.4920, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2429, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000899', 'xcz', '吸潮纸', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '20#', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2439, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000650', 'cwwzm', '醋五味子面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.1970, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2449, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001192', 'tc', '铜秤', 'sccj_w', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '-', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2459, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000247', 'zjssqjssxszsy', '重酒石酸去甲肾上腺素注射液', 'sccj_ydyyyxgs', '国药准字H42021301', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 1.00, '1.00ml*1支/支', '', 0.0000, '', '', '', 1, 10.7000, 14.9800, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 2, NULL, '2018-04-08 16:26:10', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2469, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_ryj', 'ZKM00001620', 'zgs', '正骨水', 'sccj_hbdxyyyxgs', '1705194', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 30.00, '30.00ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 0.0000, 17.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2479, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000456', '5%pttzsy', '5%葡萄糖注射液', 'sccj_dzzy', '', 3, '', 'bzdw_d', 'zxdw_ml', 250, 'jldw_ml', 1.00, '1.00ml*250ml/袋', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 20, 8, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2489, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001714', 'wflxxbfxyxsy20L', '五分类血细胞分析用稀释液20L', 'sccj_glyltyldzyxgs', '', 3, '', 'jjdw_j_8137', '', 1, '', 0.00, '件', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-07-04 14:03:23', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2499, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000219', 'ycxsywjdng', '一次性使用无菌导尿管', 'sccj_zjssdsyyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '双腔16#', '', 0.0000, '', 'ml', '', 1, 3.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2509, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000702', 'sjnj', '生鸡内金', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.0560, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2519, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001143', 'jjnj', '焦鸡内金', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.0730, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2529, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001230', 'ycxjmcxz	', '一次性静脉采血针	', 'sccj_jxhd		', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '100支/包（0.55）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2539, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_fzj', 'ZKM00000241', 'zsyjhsftlm(g)', '注射用甲磺酸酚妥拉明(国)', 'sccj_shfdfhyyyxgs', '', 3, '', 'bzdw_h', 'zxdw_z', 5, 'jldw_mg', 10.00, '10mg*5支/盒', '', 0.0000, '', '', '', 1, 24.8000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 14:56:28', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2549, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000820', 'yhjt', '愈合基台', 'sccj_EA', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, 'HAB452035L', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2559, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000131', 'ngftd', '粘固粉调刀', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2569, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000822', 'yhjt', '愈合基台', 'sccj_EA', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, 'HAB552035L', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2579, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_cj', 'ZKM00000202', 'ztxyrg', '止痛消炎软膏', 'sccj_gdhjzyyxgs', 'z44023482', 3, '', 'bzdw_h', 'zxdw_h', 1, 'jldw_g', 450.00, '450.00g*1盒/盒', '', 0.0000, '', '', '', 1, 7.8000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:23:49', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2589, 'bgyplb_gdzc', 3, 1, 'bgyplb_gdzc', '', 'ZKM00000365', 'pf', '屏风', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2599, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000068', 'smdmp', '双嘧达莫片', 'sccj_fryyjtyxgs', '', 3, '', 'bzdw_h', 'zxdw_p', 1000, 'jldw_mg', 25.00, '25mg*1000片/盒', '', 0.0000, '', '', '', 1, 8.2000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 11:23:56', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2609, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000588', 'Kc', 'K锉', 'sccj_xnddsb', '国械备20170214号', 3, '', 'jjdw_h', '', 1, '', 0.00, '21mm-25', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2619, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001652', 'cwq', '常卫清', 'sccj_hznhjkkjyxgs', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2629, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_klj', 'ZKM00000065', 'jwqhkl', '九味羌活颗粒', 'sccj_jzgtryyjtyxzrgs', '', 3, '', 'bzdw_d', 'zxdw_d', 20, 'jldw_g', 15.00, '15g*20袋/袋', '', 0.0000, '', '', '', 1, 10.2000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 11:49:52', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2639, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000420', 'ycxsywjzsqdz', '一次性使用无菌注射器带针', 'sccj_shkdlqyfzjtgfyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '10ml', '', 0.0000, '', 'ml', '', 1, 0.3900, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-02-24 10:14:05', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2649, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000519', 'sllb（jhctdbs）', '塑料量杯（加厚超透带把手）', 'sccj_hysl', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '1000ml', '', 0.0000, '', 'ml', '', 1, 5.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2659, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000854', 'dh', '独活', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/对', '', 10.0000, '', '', '', 1, 0.1680, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2669, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_kfy', 'ZKM00001823', 'sds', '十滴水', 'sccj_gdghyyyxgs', 'Z44022331', 3, '', 'bzdw_h', 'zxdw_z', 10, 'jldw_ml', 5.00, '5.00ml*10支/盒', '', 0.0000, '', '', '', 1, 0.0000, 1.9800, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2679, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000392', 'bxghyw', '不锈钢换药碗', 'sccj_czscaqctxxqylqxc', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '16CM', '', 0.0000, '', 'ml', '', 1, 5.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2689, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001568', 'bph', '玻片盒', 'sccj_w', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2699, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000953', '95%ffjjxdy', '95%复方酒精消毒液', 'sccj_w', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '500ml', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2709, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001504', 'jybsb', '基牙比色板', 'sccj_lz/wwdt', '-', 3, '', 'jjdw_k_7001', '', 1, '', 0.00, '块', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2719, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001120', 'c-fydbcdsjh（ghxwlmyzdf）CRP', 'c-反应蛋白测定试剂盒（干化学微粒免疫浊度法）CRP', 'sccj_flOriongs', '国械注进20172400736', 3, '', 'jjdw_h', '', 1, '', 0.00, '50T', '', 0.0000, '', 'ml', '', 1, 0.0000, 650.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-31 13:37:39', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2729, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_jnj', 'ZKM00000171', 'plajn', '普乐安胶囊', 'sccj_zjkebzygfyxgs', 'z33020479', 3, '', 'bzdw_h', 'zxdw_l', 60, 'jldw_g', 0.37, '0.37g*60粒/盒', '', 0.0000, '', '', '', 1, 18.9600, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:29:05', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2739, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hxj', 'ZKM00001687', 'dyxajfhxdj（tnl）', '对乙酰氨基酚混悬滴剂（泰诺林）', 'sccj_shqsyxgs', 'H19990007', 3, '', 'bzdw_p', 'zxdw_ml', 20, 'jldw_g', 1.50, '1.50g*20ml/瓶', 'kf', 0.2000, '', '', 'bys', 1, 0.0000, 17.6300, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 09:42:47', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2749, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001136', 'cgy', '炒谷芽', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0450, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2759, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000501', 'dpw', '吊瓶网', 'sccj_zd', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '500ml', '', 0.0000, '', 'ml', '', 1, 0.5500, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2769, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000486', 'ycxsywjmscxz', '一次性使用无菌末梢采血针', 'sccj_tjypylqxyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '50支', '', 0.0000, '', 'ml', '', 1, 0.1600, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2779, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001647', 'wssB6p（TX）', '维生素B6片（TX）', 'sccj_fzhwfyzyyxgs', '1709262', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_mg', 10.00, '10.00mg*100片/瓶', '', 0.0000, '', '', '', 1, 0.0000, 3.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2789, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001202', 'ymcm', '益母草面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/袋', '', 10.0000, '', '', '', 1, 0.0100, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2799, 'hclb_ryplcl', 2, 1, 'hclb_ryplcl', '', 'ZKW00000041', 'pf', '屏风', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2809, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000120', 'qmsVjp', '青霉素V钾片', 'sccj_cqkrzy（jt）yxgs', 'h20063718', 3, '', 'bzdw_h', 'zxdw_p', 12, 'jldw_g', 0.23, '0.23g*12片/盒', '', 0.0000, '', '', '', 1, 1.5500, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-23 15:32:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2819, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000457', 'pttlhnzsy', '葡萄糖氯化钠注射液', 'sccj_dzzy', '', 3, '', 'bzdw_d', 'zxdw_ml', 500, 'jldw_ml', 1.00, '1.00ml*500ml/袋', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 10, 5, NULL, '2018-03-02 15:26:17', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2829, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000697', 'ntysg', '镍钛圆丝弓', 'sccj_shamdclljgfyxgs', '沪械注准20162630198', 3, '', 'jjdw_d', '', 1, '', 0.00, '卵圆16L', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-05 09:36:50', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2839, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000562', 'hlm', '黄连面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.4180, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2849, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001461', 'zdhs（T-bil-V）cdsjh	', '总胆红素（T-bil-V）测定试剂盒	', 'sccj_szmr', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2859, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001330', 'yqp', '氧气瓶', 'sccj_jnym', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '10L/个带表推车', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2869, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000332', 'zzn', '组织镊', 'sccj_shylqx（jt）yxgsssqxc', '', 3, '', 'jjdw_b_346', '', 1, '', 0.00, 'J4105014CM1x2钩', '', 0.0000, '', 'ml', '', 1, 17.8400, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2879, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000618', 'mslb', '毛刷连棒', 'sccj_dgslgylqxyxgs', '------', 3, '', 'jjdw_ge', '', 1, '', 0.00, '大（橙色+绿色）', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2889, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00001445', 'ysssxszsy', '盐酸肾上腺素注射液', 'sccj_ydyyyxgs', '国药准字H42021700', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 1.00, '1.00ml*1支/支', '', 0.0000, '', '', '', 1, 4.8000, 2.6000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-06-15 14:24:53', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2899, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00001424', 'mdpp（rml）', '米氮平片（瑞美隆）', 'sccj_hzmsdzyyxgs', '国药准字J20150132', 3, '', 'bzdw_h', 'zxdw_p', 10, 'jldw_hk', 30.00, '30.00毫克*10片/盒', '', 0.0000, '', '', '', 1, 110.2500, 154.4000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 5, 1, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2909, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001440', 'tbdcbzly', '特宝电磁波治疗仪', 'sccj_cqxh', '-', 3, '', 'jjdw_t_148', '', 1, '', 0.00, '台', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2919, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000686', 'xj', '小蓟', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1120, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2929, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001183', 'zlxzp', '脂类校准品', 'sccj_szmr', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '5*1ml', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2939, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001243', 'wxhjjszj	', '无线呼叫接收主机	', 'sccj_w', '-', 3, '', 'jjdw_t_148', '', 1, '', 0.00, '-', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2949, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZKM00000183', 'yslntdjn', '盐酸雷尼替丁胶囊', 'sccj_fzhwfyzyyxgs', '1707250', 3, '', 'bzdw_p', 'zxdw_l', 30, 'jldw_g', 0.15, '0.15g*30粒/瓶', '', 0.0000, '', '', '', 1, 6.9000, 8.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-05-11 16:09:22', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2959, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001196', 'fsm', '佛手面', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.5300, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2969, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000857', 'mzc', '猫抓草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.4760, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 10:46:53', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2979, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_klj', 'ZKM00001885', 'tqbyp', '通窍鼻炎片', 'sccj_jlltzygfyxgs', '', 3, '', 'bzdw_h', 'zxdw_p', 36, 'jldw_p', 1.00, '1.00片*36片/盒', '', 0.0000, '', '', '', 1, 0.0000, 3.5000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-07-03 17:25:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2989, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_jnj', 'ZKM00000165', 'tmjn', '天麻胶囊', 'sccj_hbwsyyyxgs', '', 3, '', 'bzdw_h', 'zxdw_l', 36, 'jldw_g', 0.25, '0.25g*36粒/盒', '', 0.0000, '', '', '', 1, 3.9000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 13:45:58', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (2999, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001142', 'dymywdzsgtcB', '第一磨牙网底直丝弓托槽B', 'sccj_hzxyckclyxgs', '浙械注准20172631235', 3, '', 'jjdw_d', '', 1, '', 0.00, '8253-20B-26(20*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-04 17:02:53', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3009, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001665', 'EDTAggrhy25ml', 'EDTA根管润滑液25ml', 'sccj_llswyy（wh）yxgs', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3019, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_gcj', 'ZKM00000438', 'sly', '石蜡油', 'sccj_dd', '', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 500.00, '500.00ml*1瓶/瓶', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 2, 1, NULL, '2018-01-15 09:14:49', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3029, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000064', 'lsytp', '硫酸亚铁片', 'sccj_jnynzygfyxgs', '国药准字h37020689', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_g', 0.30, '0.30g*100片/瓶', '', 0.0000, '', '', '', 1, 10.1000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 08:35:37', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3039, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_klj', 'ZKM00000285', 'aenkl', '安儿宁颗粒', 'sccj_jhcygfyxgs', '国药准字z20025878', 3, '', 'bzdw_h', 'zxdw_d', 9, 'jldw_g', 3.00, '3.00g*9袋/盒', '', 0.0000, '', '', '', 1, 20.7400, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 08:36:20', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3049, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000705', 'gk', '蛤壳', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0130, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3059, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000262', 'jzspxdptp（xdp）', '健之素牌消毒泡腾片（消毒片）', 'sccj_bjcjmyykjyxzrgs', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '0.75x100片', '', 0.0000, '', 'ml', '', 1, 10.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-15 10:25:20', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3069, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000764', 'qkwktp', '全口无孔托盘', 'sccj_rxckclyxgs', '沪食药监械生产许可20000061号', 3, '', 'jjdw_ge', '', 1, '', 0.00, '2#下', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3079, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000776', 'sy', '山药', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2240, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3089, 'hclb_xdjjrjlcl', 2, 1, 'hclb_xdjjrjlcl', '', 'ZKW00000024', '84xdy', '84消毒液', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_p', '', 1, '', 0.00, '0', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3099, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001015', 'ad', '按钉', 'sccj_amzyc', '', 3, '', 'bzdw_h', 'zxdw_h', 1, '', 0.00, '1盒/盒', '', 0.0000, '', 'ml', '', 2, 10.0000, 10.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3109, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_sj_2', 'ZKM00000211', 'mtss', '蒙脱石散', 'sccj_bf—yps(tj)zyyxgs', 'H20000690', 3, '', 'bzdw_h', 'zxdw_d', 10, 'jldw_g', 3.00, '3.00g*10袋/盒', '', 0.0000, '', '', '', 1, 17.8800, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 08:37:47', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3119, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000636', 'gg', '葛根', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0730, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 17:43:06', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3129, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000976', 'cxq', '沉香曲', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0730, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3139, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001518', 'ssj 16cm/w', '手术剪 16cm/弯', 'sccj_shjz', '-', 3, '', 'jjdw_b_346', '', 1, '', 0.00, '把', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3149, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001335', 'gz', '桂枝', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0450, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3159, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001537', 'ljd15L', '垃圾袋15L', 'sccj_amzyc', NULL, 3, '', 'bzdw_b_9933', 'zxdw_b_1129', 1, '', 0.00, '1把/把', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3169, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001367', 'bgzdb', '办公桌挡板', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 86.2500, 86.2500, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3179, 'hclb_dzyhp', 2, 1, 'hclb_dzyhp', '', 'ZKW00000802', 'yysb7.5*7.5（TX）', '医用纱布7.5*7.5（TX）', 'sccj_w', '-', 3, '', 'jjdw_d', '', 1, '', 0.00, '8p*2片/袋', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3189, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_zsj', 'ZKM00000322', 'pttzsy', '葡萄糖注射液', 'sccj_hnskhyygfyxgs', '', 3, '', 'bzdw_z', 'zxdw_z', 1, 'jldw_ml', 20.00, '20.00ml*1支/支', '', 0.0000, '', '', '', 1, 0.3400, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3199, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001698', '3Mtqjt 12j/h', '3M透气胶贴 12卷/盒', 'sccj_mnsdkyzzyyqc', '-', 3, '', 'jjdw_j', '', 1, '', 0.00, '卷', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3209, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000778', 'lzx', '莲子心', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.5040, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3219, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001160', 'cpc', '垂盆草', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0950, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3229, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000880', 'dzbc', '锻紫贝齿', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0870, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 10:59:46', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3239, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001085', 'MP C2503Cxmf（hs）', 'MP C2503C型墨粉（黄色）', 'sccj_amzyc', '', 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 580.0000, 580.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3249, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000583', 'say', '生艾叶', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0440, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-23 16:34:01', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3259, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000692', 'P60tzhygmsz', 'P60特种后牙光敏树脂', 'sccj_3MESPE DENTAL PRODUCT', '--', 3, '', 'jjdw_z', '', 1, '', 0.00, '8100(A3)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3269, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001171', 'wg', '蜈蚣', 'sccj_trt', '', 3, '', 'bzdw_t', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 1.0000, '', '', '', 1, 11.0000, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3279, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001828', 'yhgx', '医护工鞋', 'sccj_amzyc', NULL, 3, '', 'bzdw_s', 'zxdw_s', 1, '', 0.00, '1件/双', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-06-19 10:03:41', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3289, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000200', '3Mtmbmft', '3M透明薄膜敷贴', 'sccj_3M Health Care', '', 3, '', 'jjdw_zhang', '', 1, '', 0.00, '50片/盒10*12cm', '', 0.0000, '', 'ml', '', 1, 6.8000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3299, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001092', 'ctr', '燀桃仁', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.3360, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-03-02 09:23:11', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3309, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_hsp', 'ZKM00000405', 'asplcrp', '阿司匹林肠溶片', 'sccj_Alcon Laboratories, Inc（mg）', '', 3, '', 'bzdw_h', 'zxdw_p', 30, 'jldw_mg', 100.00, '100.00mg*30片/盒', '', 0.0000, '', '', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 0, 0, 0, 2, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3319, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001678', 'ttqjy', '探头清洁液', 'sccj_szmr', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '瓶', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3329, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001658', 'xxbfxyyzkw-3ml', '血细胞分析仪用质控物-3ml', 'sccj_glyltyldzyxgs', '2400121', 3, '', 'jjdw_z', '', 1, '', 0.00, '支', '', 0.0000, '', 'ml', '', 1, 0.0000, 220.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3339, 'bgyplb_dzl', 3, 1, 'bgyplb_dzl', '', 'ZKM00001529', 'dyzA4', '打印纸A4', 'sccj_amzyc', NULL, 3, '', 'bzdw_j_4203', 'zxdw_b', 8, '', 0.00, '8包/件', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 1, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3349, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001090', 'ggc/ggkdq', '根管锉/根管扩大器', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, 'MANIK-FILES6#-21mm', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-05-29 16:54:53', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3359, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001394', 'bxgwp', '不锈钢弯盘', 'sccj_gdscaxczysylqxgs		', '-', 3, '', 'jjdw_ge', '', 1, '', 0.00, '中号', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3369, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000720', 'mx', '木香', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0990, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3379, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_jnj', 'ZKM00000106', 'ktljn', '咳特灵胶囊', 'sccj_gzbysyyjtgfyxgsbyszyzc', '', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_l', 30.00, '30粒*1瓶/瓶', '', 0.0000, '', '', '', 1, 7.6000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 0, 0, 0, 0, NULL, '2017-09-11 13:36:04', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3389, 'hclb_qtlcl', 2, 1, 'hclb_qtlcl', '', 'ZKW00000372', 'sxp304', '肾形盘304', 'sccj_gdscaxctqsylqxc', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '大号304', '', 0.0000, '', 'ml', '', 1, 14.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, '2018-01-16 16:25:09', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3399, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001497', 'fw', '发网', 'sccj_amzyc', NULL, 3, '', 'bzdw_g', 'zxdw_g', 1, '', 0.00, '1个/个', '', 0.0000, '', 'ml', '', 2, 13.2000, 13.2000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3409, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001222', 'chh', '炒槐花', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.1120, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3419, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000110', 'xpztz', '橡皮障套装', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3429, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000851', 'scp', '石菖蒲', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.2020, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-02-26 08:49:03', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3439, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001301', 'jmlzz', '静脉留置针', 'sccj_qdjk', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, '24G/支,50支/包', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3449, 'yplb_zcy', 1, 1, 'yplb_zcy', 'ypjx_pj', 'ZKM00000157', 'jwxsp', '健胃消食片', 'sccj_jmjtyktgy（sz）', 'z2003114', 3, '', 'bzdw_h', 'zxdw_b_7638', 32, 'jldw_g', 0.80, '0.80g*32板/盒', '', 0.0000, '', '', '', 1, 4.9000, 0.0000, 'fylb_zcy', 'fpxm_zcy_1', 0, 0, 0, 1, 0, 0, 0, NULL, '2018-05-24 09:02:32', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3459, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001029', 'ygc', '牙骨锤', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '牛角型', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3469, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00000451', 'lszkcxg', '蓝色真空采血管', 'sccj_jskjylqxyxgs', '', 3, '', 'jjdw_z', '', 1, '', 0.00, '13*75mm2ml', '', 0.0000, '', 'ml', '', 1, 0.5000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3479, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZKM00000154', 'kmxpp', '卡马西平片', 'sccj_shfdfhyyyxgs', 'h31021366', 3, '', 'bzdw_p', 'zxdw_p', 100, 'jldw_g', 0.10, '0.10g*100片/瓶', '', 0.0000, '', '', '', 1, 8.3000, 0.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-05-24 09:03:47', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3489, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001595', 'zjz 0.25*25mm', '针灸针 0.25*25mm', 'sccj_w', '-', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3499, 'bgyplb_qtlcl', 3, 1, 'bgyplb_qtlcl', '', 'ZKM00001541', 'sfrmjd', '三防热敏胶带', 'sccj_amzyc', NULL, 3, '', 'bzdw_j', 'zxdw_j', 1, '', 0.00, '1卷/卷', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3509, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000745', 'jgscz', '金刚砂车针', 'sccj_mnzshs', '--', 3, '', 'jjdw_b_189', '', 1, '', 0.00, 'BR-S46(5*1)', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3519, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00000112', 'mslb', '毛刷连棒', 'sccj_Boryung Pharmaceutical ', '', 3, '', 'jjdw_h', '', 1, '', 0.00, '盒', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3529, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00001094', 'sy', '桑叶', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/条', '', 10.0000, '', '', '', 1, 0.0380, 0.0000, 'fylb_zcy', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, '2018-03-02 09:22:43', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3539, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', '', 'ZKW00001428', 'ckpgg（Proxytzcsd）', '齿科抛光膏（Proxyt中粗砂度）', 'sccj_lz/wwdt', '-', 3, '', 'jjdw_z', '', 1, '', 0.00, 'Medium/36中颗粒度/绿色/55m', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3549, 'hclb_kqkcl', 2, 1, 'hclb_kqkcl', '', 'ZKW00001639', 'ntysg ly14U', '镍钛圆丝弓 卵圆14U', 'sccj_shamdclljgfyxgs', '', 3, '', 'jjdw_ge', '', 1, '', 0.00, '个', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3559, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00001187', 'shfxyyqxyCD80(gn6pz', '生化分析仪用清洗液CD80(国内6瓶装', 'sccj_szmr', '-', 3, '', 'jjdw_p', '', 1, '', 0.00, '2L', '', 0.0000, '', 'ml', '', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3569, 'hclb_sjlcl', 2, 1, 'hclb_sjlcl', '', 'ZKW00000775', 'zszkcxg', '紫色真空采血管', 'sccj_bdylqx（sh）yxgs', '7214597', 3, '', 'jjdw_z', '', 1, '', 0.00, '2.0ml', '', 0.0000, '', 'ml', '', 1, 1.2000, 1.2000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3579, 'bgyplb_gdzc', 3, 1, 'bgyplb_gdzc', '', 'ZKM00001680', 'USBjtkg', 'USB脚踏开关', 'sccj_amzyc', NULL, 3, '', 'bzdw_t_9258', 'zxdw_t_6854', 1, '', 0.00, '1台/台', '', 0.0000, '', 'ml', '', 2, 0.0000, 0.0000, '', '', 1, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3589, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_sj_2', 'ZKM00000975', 'ejz', '阿胶珠', 'sccj_trt', '', 3, '', 'bzdw_k_9250', 'zxdw_kg_g', 1, 'jldw_g', 1.00, '1g/支', '', 10.0000, '', '', '', 1, 2.5200, 0.0000, 'fylb_zcy_1', 'fpxm_zcy', 0, 0, 0, 0, 0, 0, 0, NULL, NULL, 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3599, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_hsp', 'ZKM00000403', 'xsgyp', '硝酸甘油片', 'sccj_Alcon Laboratories, Inc（mg）', '', 3, '', 'bzdw_h', 'zxdw_p', 50, 'jldw_mg', 0.50, '0.50mg*50片/盒', 'ad us.int', 1.5000, '', '', 'o10min', 1, 0.0000, 0.0000, 'fylb_clf', 'fpxm_clf', 0, 0, 0, 0, 0, 0, 2, NULL, '2018-02-06 15:34:17', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3609, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000008', 'pttsgxkfry', '葡萄糖酸钙锌口服溶液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1.00g*1袋/盒', 'ad us.int', 0.0000, '', 'ml', 'qd', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-02-26 09:14:53', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3619, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000018', 'xefrkckl', '小儿肺热咳喘颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3629, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000028', 'bektj', '宝儿康糖浆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3639, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000038', 'byw', '鼻渊丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3649, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000048', 'ffpzhhp', '复方片仔癀含片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3659, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZDS90000058', 'ysajpttjn', '盐酸氨基葡萄糖胶囊', 'sccj_zjcyyygfyxgswtsxtdyyyxgs', 'h20060748', 3, '', 'bzdw_h', 'zxdw_l', 40, 'jldw_g', 0.24, '0.24g*40粒/盒', '', 0.0000, '', 'ml', '', 1, 17.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-24 09:05:08', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3669, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000068', 'gtpjn', '根痛平胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3679, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000078', 'xyztg', '消炎镇痛膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3689, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000088', 'qcchbytp(dy-35)', '炔雌醇环丙孕酮片(达英-35)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3699, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000098', 'jhsxytp(bmt)', '甲磺酸溴隐亭片(佰莫亭)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3709, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000108', 'jjjn', '金鸡胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3719, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000118', 'rbcmnj（llm）', '壬苯醇醚凝胶（乐乐迷）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3729, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000128', 'zqnytcrp', '左炔诺孕酮肠溶片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3739, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_jnj', 'ZDS90000138', 'ymcrjn', '胰酶肠溶胶囊', 'sccj_cqalswzyyxgs', 'H20093822', 3, '', 'bzdw_h', 'zxdw_l', 36, 'jldw_g', 0.15, '0.15g*36粒/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 18.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-06-07 16:49:42', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3749, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000148', 'eswwssw', '二十五味松石丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3759, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000158', 'bjw', '保济丸', 'sccj_gyjtdz(fs)yyyxgs', '170069', 3, '', 'bzdw_h', 'zxdw_d', 20, 'jldw_g', 3.70, '3.70g*20袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 9.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-11 11:20:55', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3769, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000168', 'ysgmhj', '云实感冒合剂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3779, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000178', 'cbqftj', '川贝清肺糖浆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3789, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000188', 'cbqftj', '川贝清肺糖浆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3799, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000198', 'qlrfg', '秋梨润肺膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3809, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000208', 'lltdp', '氯雷他定片', 'sccj_beyybjyxgs', 'h10970410', 3, '', 'bzdw_h', 'zxdw_p', 6, 'jldw_mg', 10.00, '10.00mg*6片/盒', '', 0.0000, '', 'ml', '', 1, 18.3900, 1.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-24 09:06:23', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3819, 'yplb_xy', 1, 0, 'yplb_xy', 'ypjx_pj', 'ZDS90000218', 'mlxkp', '美洛昔康片', 'sccj_qlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 3.2500, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-09-21 11:04:29', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3829, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000228', 'fbstp', '非布司他片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3839, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000238', 'tbkwjn（oj）', '头孢克肟胶囊（欧健）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3849, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000248', 'axlwp', '阿昔洛韦片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3859, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000258', 'ysfxlwp(lzw*)', '盐酸伐昔洛韦片(丽珠威*)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3869, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000268', 'jpnlp(mzl)', '甲泼尼龙片(美卓乐)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3879, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000278', 'mtmkfzjn(xx)', '吗替麦考酚酯胶囊(骁悉)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3889, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000288', 'bqydfjn(xq)', '包醛氧淀粉胶囊(析清)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3899, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000298', 'sjp（bmyp）', '三金片（薄膜衣片）', 'sccj_glsjyygfyxgs', '', 3, '', 'bzdw_h', 'zxdw_p', 72, 'jldw_g', 0.29, '0.29g*72片/盒', '', 0.0000, '', 'ml', '', 1, 30.2000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-09-08 14:30:52', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3909, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000308', 'ystslxhsjn(hl)', '盐酸坦索罗辛缓释胶囊(哈乐)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3919, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000318', 'alstp', '奥利司他片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3929, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000328', 'jgajn', '甲钴胺胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3939, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000338', 'lgsxj', '炉甘石洗剂', 'sccj_hnekxyzyyxgs', '国药准字h20153294', 3, '', 'bzdw_p', 'zxdw_p_1', 1, 'jldw_ml', 100.00, '100.00ml*1瓶/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 7.9000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-29 14:38:32', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3949, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000348', 'wykys', '外用溃疡散', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3959, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000358', 'dhsndtrg(xlt)', '多磺酸粘多糖乳膏(喜疗妥)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3969, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000368', 'xfzykl', '消风止痒颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3979, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000378', 'ffgsnnnsnj（krb）', '复方肝素钠尿囊素凝胶（康瑞保）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3989, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000388', '@hmsrg', '@红霉素软膏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (3999, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000398', 'emw', '二妙丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4009, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000408', 'xsjkl', '夏桑菊颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/袋', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4019, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000418', 'bldjnp(xkl)', '胞磷胆碱钠片(欣可来)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4029, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000428', '@ysbhsp', '@盐酸苯海索片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4039, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000438', 'ysmjgp(ybs)', '盐酸美金刚片(易倍申)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4049, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZDS90000448', 'dpltp（mdl）', '多潘立酮片（吗丁啉）', 'sccj_xayszyyxgs', '170917523', 3, '', 'bzdw_h', 'zxdw_p', 30, 'jldw_mg', 10.00, '10.00mg*30片/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 14.5000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-11 16:00:27', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4059, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_pj', 'ZDS90000458', 'rsjsp', '乳酸菌素片', 'sccj_jscpbdyyyxgs', '17061011', 3, '', 'bzdw_h', 'zxdw_p', 64, 'jldw_g', 0.40, '0.40g*64片/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 35.0000, 'fylb_xyf', 'fpxm_xyf', 0, 0, 0, 1, 0, 0, 0, '2017-07-13 00:00:00', '2018-05-11 16:06:54', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4069, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000468', 'abdzp(skccq)', '阿苯达唑片(史克肠虫清)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4079, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000478', 'bskdcrp', '比沙可啶肠溶片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4089, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000488', 'dmp', '多酶片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4099, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000498', 'ffdcp（bmy）', '复方丹参片（薄膜衣）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4109, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000508', 'xstqlsqp（fdw）', '缬沙坦氢氯噻嗪片（复代文）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4119, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_wj', 'ZDS90000518', 'ffdcdw', '复方丹参滴丸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1.00g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2018-02-24 11:32:34', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4129, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000528', 'mgfkp', '脉管复康片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4139, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000538', 'ffyjkl', '复方羊角颗粒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4149, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000548', 'zjjyp', '珍菊降压片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4159, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000558', 'jyxcdyy（rz）', '聚乙烯醇滴眼液（瑞珠）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4169, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000568', 'lhndyy', '氯化钠滴眼液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4179, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000578', 'nmwdyy(hrj)', '萘敏维滴眼液(红润洁)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/支', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4189, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000588', 'yytzm', '医用脱脂棉', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/包', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4199, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000598', 'pttsgxkfry', '葡萄糖酸钙锌口服溶液', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4209, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000608', 'wsscp', '维生素c片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_p', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/瓶', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4219, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000618', 'jzqyq', '颈椎牵引器', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_d', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/台', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4229, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000628', 'bjxzjn', '鳖甲消痔胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4239, 'yplb_xy', 1, 1, 'yplb_xy', 'ypjx_qt', 'ZDS90000638', 'jyljn', '健延龄胶囊', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_h', 'zxdw_d', 1, 'jldw_g', 1.00, '1g*1袋/盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_xyf', 'fpxm_xyf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4249, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000006', 'ycswhzz（cr）', '一次生雾化装置（成人）', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '单个装', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4259, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000016', 'lzzft（tm）', '留置针敷贴（透明）', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4269, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000026', 'ycxbmst', '一次性薄膜手套', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '50包一箱', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4279, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000036', 'ycxyytt', '一次性医用头套', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '50个/袋', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4289, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000046', 'jjd', '酒精灯', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4299, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000056', 'gsn：lm', '肝素钠：绿帽', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '100支每盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4309, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000066', 'kqyycxslbhlm', '口腔用一次性塑料保护蓝膜', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '10*15cm', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4319, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000076', 'ycxdp', '一次性刀片', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '100片每盒', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4329, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000086', 'pyx', '排龈线', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4339, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000096', 'wsyldzjcy', '污水余氯电子检测仪', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4349, 'hclb_ycxcl', 2, 1, 'hclb_ycxcl', 'hclb_ycxcl', 'ZKK90000106', 'kkq', '开口器', 'sccj_bjhlzyyxgs', '', 3, '', 'jjdw_ge', 'jjdw_ge', 1, 'jldw_g', 1.00, '无', '', 0.0000, '', 'ml', '', 1, 1.0000, 1.0000, 'fylb_clf', 'fpxm_clf', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4359, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000007', 'hq', '黄芪', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4369, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000017', 'gqz', '枸杞子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4379, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000027', 'syr', '山萸肉', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4389, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000037', 'yyh', '淫羊藿', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4399, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000047', 'sy', '山药', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4409, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000057', 'fcbs', '麸炒白术', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4419, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000067', 'fp（bfp）', '附片（白附片）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4429, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000077', 'dg', '当归', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4439, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000087', 'jcx', '酒川芎', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4449, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000097', 'jxd', '酒续断', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4459, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000107', 'nx', '牛膝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4469, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000117', 'lg', '龙骨', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4479, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000127', 'fccs', '麸炒苍术', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4489, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000137', 'mx', '木香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4499, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000147', 'fsm', '茯神木', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4509, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000157', 'wwz', '五味子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4519, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000167', 'jcnx', '酒川牛膝', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4529, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000177', 'ybjt', '盐巴戟天', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4539, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000187', 'wm', '乌梅', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4549, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000197', 'cjmz', '炒决明子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4559, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000207', 'hpx', '海螵蛸', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4569, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000217', 'jh', '菊花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4579, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000227', 'sz', '山楂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4589, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000237', 'yz', '玉竹', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4599, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000247', 'sy', '桑叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4609, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000257', 'zz', '栀子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4619, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000267', 'wy', '乌药', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4629, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000277', 'ldc', '龙胆草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4639, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000287', 'rg', '肉桂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4649, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000297', 'zsy', '紫苏叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4659, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000307', 'syr', '山萸肉', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4669, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000317', 'ytsz', '盐菟丝子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4679, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000327', 'zhsw', '制何首乌', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4689, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000337', 'dlg', '煅龙骨', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4699, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000347', 'ccp', '炒陈皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4709, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000357', 'bz', '白芷', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4719, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000367', 'jhl', '酒黄连', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4729, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000377', 'sy', '桑叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4739, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000387', 'hhp', '合欢皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4749, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000397', 'rg', '肉桂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4759, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000407', 'zm', '知母', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4769, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000417', 'mgh', '玫瑰花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4779, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000427', 'zl', '重楼', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4789, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000437', 'xkc', '夏枯草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4799, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000447', 'sdh', '熟大黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4809, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000457', 'hp', '琥珀', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4819, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000467', 'qm', '瞿麦', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4829, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000477', 'cht', '草红藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4839, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000487', 'yjcz', '盐韭菜子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4849, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000497', 'bzr', '柏子仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4859, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000507', 'yjh', '野菊花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4869, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000517', 'tgsb', '烫骨碎补', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4879, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000527', 'cs', '蚕沙', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4889, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000537', 'pdh', '胖大海', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4899, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000547', 'hjt', '红景天', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4909, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000557', 'ff', '防风', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4919, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000567', 'czych', '醋竹叶柴胡', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4929, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000577', 'sq（f）', '三七（粉）', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4939, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000587', 'zsg', '紫苏梗', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4949, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000597', 'cyhs', '醋延胡索', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4959, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000607', 'zr', '竹茹', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4969, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000617', 'bdg', '北豆根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4979, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000627', 'crx', '醋乳香', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4989, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000637', 'rg', '肉桂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (4999, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000647', 'sw', '石韦', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5009, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000657', 'zsg', '紫苏梗', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5019, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000667', 'hz', '海藻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5029, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000677', 'yhb', '盐黄柏', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5039, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000687', 'cbj', '醋鳖甲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5049, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000697', 'cyhs', '醋延胡索', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5059, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000707', 'qj', '秦艽', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5069, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000717', 'dgp', '地骨皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5079, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000727', 'qx', '全蝎', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5089, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000737', 'cbt', '侧柏炭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5099, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000747', 'zgc', '炙甘草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5109, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000757', 'chh', '炒槐花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5119, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000767', 'bzl', '半枝莲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5129, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000777', 'wbz', '五倍子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5139, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000787', 'swt', '首乌藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5149, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000797', 'btw', '白头翁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5159, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000807', 'ccwz', '炒茺蔚子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5169, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000817', 'cay', '醋艾叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5179, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000827', 'hs', '滑石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5189, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000837', 'dfp', '大腹皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5199, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000847', 'ymz', '亚麻子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5209, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000857', 'hz', '海藻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5219, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000867', 'xhc', '仙鹤草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5229, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000877', 'jjs', '荆芥穗', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5239, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000887', 'csg', '川射干', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5249, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000897', 'cmy', '炒麦芽', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5259, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000907', 'jq', '建曲', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5269, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000917', 'gsq', '隔山撬', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5279, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000927', 'fp', '附片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5289, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000937', 'gsh', '干石斛', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5299, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000947', 'qlg', '千里光', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5309, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000957', 'cszr', '炒山枝仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5319, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000967', 'cccmt', '粗齿川木通', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5329, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000977', 'qm', '瞿麦', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5339, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000987', 'hjs', '槲寄生', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5349, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90000997', 'bbd', '白扁豆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5359, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001007', 'hz', '虎杖', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5369, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001017', 'gh', '葛花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5379, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001027', 'bl', '白蔹', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5389, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001037', 'cff', '炒蜂房', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5399, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001047', 'mmh', '密蒙花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5409, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001057', 'mglp', '蜜瓜蒌皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5419, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001067', 'mdp', '牡丹皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5429, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001077', 'dk', '豆蔻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5439, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001087', 'ybjt', '盐巴戟天', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5449, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001097', 'xcq', '徐长卿', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5459, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001107', 'zl', '重楼', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5469, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001117', 'ckxr', '燀苦杏仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5479, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001127', 'sj', '松节', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5489, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001137', 'nwdh', '牛尾独活', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5499, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001147', 'bjc', '败酱草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5509, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001157', 'jqhy', '酒羌活鱼', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5519, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001167', 'sjc', '舒筋草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5529, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001177', 'hq', '黄芩', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5539, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001187', 'mh(r)', '麻黄(绒)', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5549, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001197', 'hh', '红花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5559, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001207', 'sgl', '丝瓜络', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5569, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001217', 'gs', '甘松', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5579, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001227', 'bsc', '北沙参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5589, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001237', 'sw', '石韦', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5599, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001247', 'dc', '党参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5609, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001257', 'bsc', '北沙参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5619, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001267', 'cwblx', '炒王不留行', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5629, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001277', 'jjs', '荆芥穗', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5639, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001287', 'snt', '石南藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5649, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001297', 'jl', '橘络', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5659, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001307', 'fczk', '麸炒枳壳', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5669, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001317', 'gsh', '干石斛', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5679, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001327', 'cszr', '炒酸枣仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5689, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001337', 'czych', '醋竹叶柴胡', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5699, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001347', 'mbb', '蜜百部', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5709, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001357', 'gc', '甘草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5719, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001367', 'sz', '山楂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5729, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001377', 'czsz', '炒紫苏子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5739, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001387', 'mmh', '蜜麻黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5749, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001397', 'slp', '石榴皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5759, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001407', 'ddc', '淡豆豉', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5769, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001417', 'jxt', '鸡血藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5779, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001427', 'btw', '白头翁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5789, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001437', 'blg', '板蓝根', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5799, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001447', 'mmh', '蜜麻黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5809, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001457', 'qft', '青风藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5819, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001467', 'jnzz', '酒女贞子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5829, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001477', 'jyh', '金银花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5839, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001487', 'jqhy', '酒羌活鱼', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5849, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001497', 'hyz', '黄药子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5859, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001507', 'jgl', '金果榄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5869, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001517', 'jhj', '酒黄精', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5879, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001527', 'jz', '芥子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5889, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001537', 'qmz', '苘麻子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5899, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001547', 'jsz', '酒水蛭', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5909, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001557', 'cs', '赤芍', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5919, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001567', 'lqc', '连钱草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5929, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001577', 'wbz', '五倍子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5939, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001587', 'glj', '高良姜', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5949, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001597', 'wbz', '五倍子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5959, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001607', 'qh', '青蒿', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5969, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001617', 'ytsz', '盐菟丝子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5979, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001627', 'lc', '龙齿', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5989, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001637', 'xc', '玄参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (5999, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001647', 'szr', '山枝仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6009, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001657', 'bb', '百部', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6019, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001667', 'jxt', '鸡血藤', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6029, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001677', 'gh', '葛花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6039, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001687', 'adc', '矮地茶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6049, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001697', 'glp', '瓜蒌皮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6059, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001707', 'hq', '黄芪', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6069, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001717', 'zbm', '浙贝母', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6079, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001727', 'xx', '细辛', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6089, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001737', 'bcq', '荜澄茄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6099, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001747', 'cjyzr', '炒金樱子肉', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6109, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001757', 'gbp', '藁本片', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6119, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001767', 'xxc', '豨莶草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6129, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001777', 'sh', '蛇含', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6139, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001787', 'hjs', '海金沙', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6149, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001797', 'bl', '白蔹', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6159, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001807', 'qc', '茜草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6169, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001817', 'yzx', '盐泽泻', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6179, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001827', 'fcyyr', '麸炒薏苡仁', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6189, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001837', 'zm', '知母', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6199, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001847', 'mh', '麻黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6209, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001857', 'dl', '地龙', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6219, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001867', 'mdq', '毛冬青', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6229, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001877', 'yns', '鱼脑石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6239, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001887', 'yc', '茵陈', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6249, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001897', 'xr', '香薷', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6259, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001907', 'yns', '鱼脑石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6269, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001917', 'ch', '蝉花', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6279, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001927', 'rgnh', '人工牛黄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6289, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001937', 'jhq', '酒黄芩', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6299, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001947', 'zhq', '炙黄芪', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6309, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001957', 'hj', '花椒', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6319, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001967', 'zhsw', '制何首乌', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6329, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001977', 'fp.', '浮萍.', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6339, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001987', 'rgz', '肉桂子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6349, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90001997', 'jnzz', '酒女贞子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6359, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002007', 'dyyl', '煅禹余粮', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6369, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002017', 'csl', '醋商陆', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6379, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002027', 'sfd', '石凤丹', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6389, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002037', 'dzzm', '煅珍珠母', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6399, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002047', 'jdc', '酒丹参', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6409, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002057', 'xjs', '玄精石', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6419, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002067', 'lk', '龙葵', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6429, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002077', 'cgs', '醋甘遂', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6439, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002087', 'bs', '白术', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6449, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002097', 'hyz', '黄药子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6459, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002107', 'chm', '炒槐米', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6469, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002117', 'qwc', '青蛙草', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6479, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002127', 'cxr', '川香薷', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6489, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002137', 'ggy', '枸骨叶', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6499, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002147', 'snjnsf', '水牛角浓缩粉', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6509, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002157', 'bcq', '荜澄茄', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6519, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002167', 'czz', '炒栀子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6529, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002177', 'fczs', '麸炒枳实', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6539, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002187', 'yfpz', '盐覆盆子', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6549, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002197', 'jhl', '酒黄连', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
INSERT INTO `drug_resource_9` VALUES (6559, 'yplb_cy', 1, 1, 'yplb_cy', 'ypjx_qt', 'ZMK90002207', 'hq', '黄芪', 'sccj_bjhlzyyxgs', '', 3, '', 'bzdw_g_cldw', 'zxdw_kg_g', 1, 'jldw_g', 1.00, 'g', '', 0.0000, '', 'ml', '', 2, 1.0000, 1.0000, 'fylb_zcy_1', 'fpxm_zcy_1', 1, 0, 0, 0, 0, 0, 0, '2017-07-13 00:00:00', '2017-07-13 00:00:00', 0, 0, NULL);
COMMIT;


SET FOREIGN_KEY_CHECKS = 1;
